# -*- coding: utf-8 -*-

import wx, re, fixRef, zlib, utility
import sqlite3 as sqlite
import stemming.lovins

from time import time
        

masterVerseString = []
masterVerseIdx = []

'''
vsIndex = [
1, 1534, 2747, 3606, 4894, 5853, 6511, 7129, 7214, 8024,
8719, 9535, 10254, 11196, 12018, 12298, 12704, 12871, 13941, 16402, 
17317, 17539, 17656, 18948, 20312, 20466, 21739, 22096, 22293, 22366,
22512, 22533, 22581, 22686, 22733, 22789, 22842, 22880, 23094, 23146,
24217, 24895, 26046, 26925, 27932, 28365, 28803, 29059, 29208, 29363,
29467, 29562, 29651, 29698, 29811, 29894, 29940, 29965, 30268, 30376, 
30481, 30542, 30647, 30660, 30674, 30699, 31103]
'''


class primSearch:
    def __init__(self, parent):
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.proxMatch = []
        self.phrase = 0
        self.string = 0
    
    
    def InsertTag(self, mo):
        return self.tagList.pop(0)

   
    
    def AddLine(self, line, full, case):
        count = 0 
        
        caseFlag = re.I|re.U
        if case:
            caseFlag = re.U
        
        if self.showRed == True:
            line = line.replace('<r>', '<font color="Red">')
            line = line.replace('</r>', '</font>')
        else:
            line = line.replace('<r>', '')
            line = line.replace('</r>', '')
        
        ref = re.match(r'(.+?)\t', line).group(1)
        tabIdx = line.find('\t')
        bk = line[:3]
        line = line[:3] + '_' + line[4:]
        
        abbr = 'AV'
        if not self.fromSchLnk:
            tab = self.mainApp.bibNB.GetSelection()
            if tab == len(self.mainApp.bibFileList):
                tab = self.mainApp.bAbbrList.index(self.mainApp.parallelBibClick)
            abbr = self.mainApp.bAbbrList[tab]
        
        
        if self.regEx:
            ref, txt = line.split('\t')
            

            self.word = self.word.replace(r'\2', r'\3')

            self.word = self.word.replace(r'\1', r'\2')


            c = re.compile(r'(%s)' % self.word, caseFlag)
                
            txt, vcnt = c.subn(r'<font color="#990000"><b>\1</b></font>', txt)
            count += vcnt
            for num in range(count):
                self.bookHits.append(bk)
            line = u'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<a name="%s"><u>%s</u>, </font>%s' % (bk, ref, txt)           
            
            # Put tags back in
            if '<t>' in line:
                line = re.sub(r'<t>', self.InsertTag, line)

            # Database Embedded Footnotes
            if '<fn>' in line:
                line = re.sub(r'<fn>(\d+?)</fn>', r'<a href="bibleFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, ref), line)
            #print line

            # Link Embedded Footnotes
            elif 'embNote' in line:
                line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
                line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)

            if abbr == 'NET':
                if not 'NET' in self.mainApp.cAbbrList:
                    abbr = 'NET-'
            # Commentary footnotes (NET)
            if '<fnc>' in line:
                line = re.sub(r'<fnc>(\d+?)</fnc>', r'<a href="commFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, ref), line)

            return line, count

        #line = '<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<a name="%s"></a><u>%s</u>, </font>%s'  % (bk, line[:tabIdx], line[tabIdx:])    
        
        elif self.string:
            #print 'string'

            formatWord = re.compile(r'((<.+?>)?%s(?!>)(<.+?>)?)' % self.wdMod, re.I|re.U)
            line, vcnt = formatWord.subn(r'<font color="#990000"><b>\1</b></font>', line)

            count += vcnt
            #print line
        
        elif self.phrase:
            #print 'phrase'
            if self.greekSch or self.comboSch or self.strongsSch or self.strongsNumSch:
                if self.strongsNumSch:
                    self.wdMod = self.wdMod.replace('[\(\),.?;:!-]?', '')

                if full:
                    formatWord = re.compile(r'(\b%s)' % self.wdMod, caseFlag)
                else:
                    formatWord = re.compile(r'(%s)' % self.wdMod, caseFlag)
            
            else:
                
                if full:
                    formatWord = re.compile(r'(\b%s\b)' % self.wdMod, caseFlag)
                else:
                    formatWord = re.compile(r'(\b%s)' % self.wdMod, caseFlag)
            
            if self.strongsNumSch:
                line, vcnt = formatWord.subn(r'<font color="#990000" size="+1"><b>\1</b></font>', line)
            else:
                line, vcnt = formatWord.subn(r'<font color="#990000"><b>\1</b></font>', line)
                
            count += vcnt
            #print line
        
        else:
            #print 'else'
            if self.multiWord:

                tmpList = self.wList[:-1]

            else:

                tmpList = self.wList[:]


            for wd in tmpList:
                if re.search(r'\w\|\w', wd):
                    #print wd, 'in Add Line |'
                    grp = wd.split('|')
                    vcnt = 0
                    for g in grp:
                        g = re.sub(r'[()]', '', g)
                        g = re.sub(r' ', r' ?(?:<[^>]+>)* ?', g)
                        if g.isdigit(): # People ID
                            line, cnt = re.subn(r'//(%s)">(.+?)</a>' % g, r'//\1"><font color="#990000"><b>\2</b></font></a>', line)
                        else:
                            if full:
                                formatWord = re.compile(r'(\b%s(?!>)\b)'% g, caseFlag)
                            else:
                                formatWord = re.compile(r'(\b%s(?!>))'% g, caseFlag)
                            line, cnt = formatWord.subn(r'<font color="#990000"><b>\1</b></font>', line)
                        vcnt += cnt
                
                elif wd.isdigit(): # People ID
                    #print 'in Add Line ID'
                    line, vcnt = re.subn(r'//(%s)">(.+?)</a>' % wd, r'//\1"><font color="#990000"><b>\2</b></font></a>', line)
                
                else:
                    #print 'Add Line else'
                    if full:
                        formatWord = re.compile(r'(\b%s(?!>)\b)'% wd, caseFlag)
                    else:
                        formatWord = re.compile(r'(\b%s(?!>))'% wd, caseFlag)
                    line, vcnt = formatWord.subn(r'<font color="#990000"><b>\1</b></font>', line)
                count += vcnt


        # Put tags back in
        if '<t>' in line:
            line = re.sub(r'<t>', self.InsertTag, line)
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
            
            #print line.encode('utf-8'), 'insert'
        
        if not self.mainApp.showStrongs:
            line = re.sub(r'\[[GH].+?\]', r'', line)
            line = re.sub(r' ?\[\([GH].+?\)\]', r'', line)
        
        if self.greekSch or self.strongsSch or self.comboSch:
            line = re.sub(r'\[([GH].+?)\]', r'<sup><font color="#000066">\1</font></sup>', line)
            line = re.sub(r'\[\(([GH].+?)\)\]', r'<sup><font color="#990000">\1</font></sup>', line)
            
            line = re.sub(r'{(.+?)}', r'<sup><font color="#777777" size="+1"> (\1)</font></sup>', line)
       
        if self.hebSch:
            line = re.sub(r', </font>', ', </font><font face="Times New Roman" size="+1">', line)
            line = line + '</font>'

        # Footnotes
            
        # Database Embedded Footnotes
        if '<fn>' in line:
            line = re.sub(r'<fn>(\w+?)</fn>', r'<a href="bibleFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, ref), line)

        # Link Embedded Footnotes
        elif 'embNote' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)

        if abbr == 'NET':
            if not 'NET' in self.mainApp.cAbbrList:
                abbr = 'NET-'
        # Commentary footnotes (NET)
        if '<fnc>' in line:
            line = re.sub(r'<fnc>(\d+?)</fnc>', r'<a href="commFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, ref), line)


        # For hit chart

        for num in range(count):

            self.bookHits.append(bk)
            
        line = u'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<a name="%s"></a><u>%s</u>, </font>%s'  % (bk, line[:tabIdx], line[tabIdx:])    
        
        #print line.encode('utf-8')
        
        #print count, 'c2'
        
        #print line
        return line, count
    
    
    def SubTags(self, row):
        if '<a href="embNote' in row[2] or '<f' in row[2]:
            self.tagList = re.findall(r'<a href="embNote.+?</a>|<fnc?>\d+</fnc?>', row[2])
            noTag = re.sub(r'<a href.+?</a>|<fnc?>\d+</fnc?>', r'<t>', row[2])
            return (row[0], row[1], noTag)
        return row
    


    def BuildTempList(self, hitRows, full, caseFlag, redSearch):
        self.tempList = hitRows[:]
        
        for row in hitRows:
            origRow = row
            #row = self.SubTags(row)                    
            vs = row[2]
            for wd in self.wList: 
                wd = re.sub(r' ', r' ?(?:<[^>]+>)* ?', wd)
                if redSearch:
                    if '<r>' in vs:
                        rRange = re.findall(r'<r>.+?</r>', row[2])
                        vs = ''.join(rRange)
                    else:
                        self.tempList.remove(origRow)
                        break

                if full:
                    find = re.search(r'\b%s(?!>)\b' % wd, vs, caseFlag)
                else:
                    find = re.search(r'\b%s(?!>)\w*' % wd, vs, caseFlag)

                if not find:
                    self.tempList.remove(origRow)
                    break
        


    def MultiSearch(self, word, fName, abbr, full, opt, case, fface, showRed, redSearch, idxList, exclude, rangeStr, refOnly, resWdList, doRoot, fixedRef, relatedRefOnly):

        resList = []

        self.multiTitleList = []

        self.multiTitleHitList = []

        hitFinal = []

        txtHits = []
        totalCnt = 0
        vsCnt = 0
        
        bibMultiFnList = []
        
        bibMultiListCopy = self.mainApp.bibMultiList[:]
        
        for abbr in bibMultiListCopy:
            if abbr in self.mainApp.bAbbrList:
                idx = self.mainApp.bAbbrList.index(abbr)
                fn = self.mainApp.bibFileList[idx]
                bibMultiFnList.append(fn)
            else:
                print 'removing', abbr
                self.mainApp.bibMultiList.remove(abbr)

        
        
        dlg = wx.ProgressDialog('Searching Bibles for %s' % word, 'This is just to make the dialog bigger bigger', maximum = len(bibMultiFnList), \
        style = wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_REMAINING_TIME)
        

        for idx, txt in enumerate(bibMultiFnList):
            abbr = self.mainApp.bibMultiList[idx]
            dlg.Update(idx, u'Searching %s Bible' % abbr)
            

            result, refList, title, count, findStr, totalHits, exclude, rngRefList,\
            schType, rangeStr, rLabel, caseStr, orig = \
            self.StdSearch(word, txt, abbr, full, opt, case, 

            fface, showRed, redSearch, idxList, exclude, rangeStr, refOnly, resWdList, doRoot, fixedRef,

            relatedRefOnly, 1)

            
            if result:
                resList.append(', '.join(result))

            if self.totalHits != 0:

                self.multiTitleHitList.append(self.totalHits)

                for n in range(self.totalHits):

                    txtHits.append(abbr)
            totalCnt += self.totalHits
            vsCnt += len(self.refTemp)

        
        dlg.Destroy()

        masterVerseIdx.append([])
        masterVerseString.append([])

        for idx, t in enumerate(self.multiTitleList):

            try:
                hitFinal.append('%s, %s' % (t, self.multiTitleHitList[idx]))

            except:
                print 'multiSearch list error'
                continue

        
        txtData = self.HitChart(txtHits, 0)
        
        final = u'%s<hr>%s' % (''.join(txtData), '<br><br>'.join(resList))


        answer = u'''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s"><b>%s<font color="#990000">%s, &nbsp;</font></b> <b>%s</b> (%s Texts) (%s)%s%s,<br>
        <b>%s</b> hits in <b>%s</b> verses</font></td></tr></table><br><br><font face="%s"><hr>%s</font>'''\
        % (self.mainApp.resColor, self.mainApp.resHeadColor, fface, schType, orig, 'Multiple Bible', len(bibMultiFnList), rangeStr, rLabel, caseStr, totalCnt, vsCnt, fface, final)


        return answer, refList, title, count, findStr, totalHits, exclude, rngRefList








    
    ## Word or phrase Search
    def StdSearch(self, word, fName, abbr, full, opt, case, fface, showRed, redSearch,\

    idxList, exclude, rangeStr, refOnly, resWdList, doRoot, fixedRef, relatedRefOnly, multiSearch = 0, popup = 0, fromSchLnk = 0):

        
        #print opt, 'opt'
        
        display = self.mainApp.resNB.GetCurrentPage()
        dispWidth = display.GetClientSize()
        
        if self.mainApp.getMaximized():
            maxDisplay = self.mainApp.getMaximized().window
            dispWidth = maxDisplay.GetClientSize()
        
        self.final = []
        self.showRed = showRed

        self.dispWidth = dispWidth[0]

        
        self.fName = fName
        self.abbr = abbr
        
        self.bookHits = []
        self.vsTemp = []
        self.refList = []
        self.refIdx = []
        
        self.refBk = ''
        self.refTemp = []

        

        self.multiTitle = ''

        
        self.rngRefList = []
        self.tagList = []
        
        if exclude:

            exclude = exclude.replace('?', '\w')

            exclude = exclude.replace('*', '\w*') 

            excludeTmp = exclude.split()
            
            excludeList = []
            for wd in excludeTmp:
                excludeList.append(re.sub(r' ?([GH]\d+)$', r'\[\1\]', wd))
            
            #print exclude, 'ex'
            #print excludeList, 'exlist'
                           

            
        self.cycMulti = 1

        self.multiWord = 0

        self.greekSch = 0

        self.strongsSch = 0
        self.strongsNumSch = 0
        self.hebSch = 0
        self.comboSch = 0
        self.regEx = 0
        self.fromSchLnk = fromSchLnk

        self.count = 0
        self.pageCount = 0
        self.over100 = 0
        
        self.totalHits = 0
        
        caseFlag = re.I|re.U
        if case:
            caseFlag = re.U
        
        
        
        def regEx(expr, line):
            if not line:
                return
            if case:
                r = re.compile(r'%s' % expr, re.U)
            else:
                r = re.compile(r'%s' % expr, re.I|re.U)
            
            if redSearch:
                if '<r>' in line:
                    rRange = re.findall(r'<r>.+?</r>', line)                                
                    for rng in rRange:
                        if case:
                            find = re.findall('%s(?!>)' % word, rng, re.U)
                        else:
                            find = re.findall('%s(?!>)' % word, rng, re.I|re.U)                        
                        if find:
                            self.totalHits += len(find)
                            return True
            else:
                find = r.findall(line)
                if find:

                    self.totalHits += len(find)
                    return True    
            
            return False
        
        
        
        def AddRef(row):
            if resWdList or relatedRefOnly:

                self.refTemp.append(row[1])
            else:

                txtStr = ''

                if multiSearch and abbr != self.multiTitle:
                    
                    link = u'<a href="search://[%s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s; %s]">Show Verses</a>'\
                    % (word, fName, abbr, full, opt, case, fface, showRed, redSearch, idxList, exclude, rangeStr, refOnly, resWdList, doRoot, fixedRef)
                    
                    txtStr = u'<table cellpadding="0", cellspacing="0", border="0"><tbody><tr><td bgcolor="%s" width="%s">\
                    <a name="%s"><center><b>%s</b> - <font size="-1">%s</font></center></td></tr></tbody></table>' % ('#dfdfdf', self.dispWidth -40, abbr, abbr, link)

                    self.multiTitle = abbr

                    self.multiTitleList.append(abbr)

                    
                ref = u'<u>%s</u>' % row[1]
                ref = ref.replace(' ', '_')
                if row[1][:3] != self.refBk:
                    self.refBk = row[1][:3]
                    fullBk = fixRef.fullTitle(row[1][:3])
                    self.refTemp.append('<br><br>%s<font color="#990000"><b>%s</b></font><br>%s' % (txtStr, fullBk, ref))
                else:
                    self.refTemp.append(ref)
        
        
        def processLine(row): 
            rngRef = row[1][:self.mainApp.multiRngLen]
            if not rngRef in self.rngRefList:
                self.rngRefList.append(row[1][:self.mainApp.multiRngLen])
            if self.count == 0:

                self.ref1 = row[1]
                self.refIdx.append(row[0])
            if self.count == (100*self.cycMulti):
                self.ref1 = row[1]
                self.refIdx.append(row[0])
                self.over100 = 1
                self.cycMulti += 1
            if self.count == (100*self.cycMulti)-1:
                self.refList.append('%s - %s' % (self.ref1, row[1]))
            if self.count < 100:
                line = u'%s\t%s' % (row[1], row[2])
                line, vsCount = self.AddLine(line, full, case)
                self.final.append(line)
                self.pageCount += vsCount               
            self.count += 1
        

        
        def doExclude(line):
            # if combo word
            if re.search(r'\[HG]\d+', excludeList[0]):
                exString = r'\b%s' % excludeList[0]
                if len(excludeList) > 1:
                    for wd in excludeList[1:]:
                        exString = exString + r'|\b%s' % wd              
            else:
                print 'else'

                if full:

                    exString = r'\b%s(?!>)\b' % re.sub(r'\[.+?\]', r'', excludeList[0])

                else:

                    exString = r'\b%s(?!>)\w*' % re.sub(r'\[.+?\]', r'', excludeList[0])

                if len(excludeList) > 1:

                    for wd in excludeList[1:]:
                        wd = re.sub(r'\[.+?\]', r'', wd)
                        exString += r'|\b%s(?!>)\b' % wd
            
            print excludeList, exString, 'str'
            
            if case:

                ex = re.search(exString, line, re.U)

            else:

                ex = re.search(exString, line, re.I|re.U)
                
            return ex

            
        
        if redSearch:
            beginIdx = 23146 
            endIdx = 31103

        findStr = ''
        
        if opt != 5:  # Non RegEx
            #word = word.encode('utf-8')
            
            orig = word

            origList = word.split()
            
            if doRoot:
                print 'doRoot'
                full = 0
                wdTmp = word.split()
                wdLst = [stemming.porter.stem(w) for w in wdTmp]
                word = ' '.join(wdLst)
                

            if opt == 1 or opt == 2 or opt == 3:
                #print word, 'word'
                word = re.sub(r'[ ,]+', ' ', word)
                word = word.replace('?', '\w')
                word = word.replace('*', '\w*') 
                if opt == 3:
                    word = re.sub(r'\[.+?\]', r'', word)
                
                if '|' in word:
                    alt = re.findall(r'\((.+?)\)', word)
                    word = re.sub(r'\(.+?\)', '', word)
                    self.wList = word.split()
                    self.origWList = word.split()
                    #print alt, 'alt'
                    for item in alt:
                        item = re.sub(r'"', '', item)
                        item = re.sub(r'\s*\|\s*', '|', item)
                        self.origWList.insert(0, item)
                        self.wList.insert(0, '(%s)' % item)
                
                elif '"' in word:
                    phrase = re.findall(r'"(.+?)"', word)
                    word = re.sub(r'".+?"', '', word)
                    self.wList = word.split()
                    #dbWdList = [wd for wd in phrase]
                    self.origWList = word.split()
                    for item in phrase:
                        self.origWList.insert(0, item)
                        item = item.replace(' ', r'(?:<[^>]+>|\[\(?[GH]\d\w*\)?\]|[\s.,;:?!-]*|{.+?})*')
                        self.wList.insert(0, item)
                            
                else:
                    self.wList = word.split()
                    self.origWList = word.split()
                
                #print self.wList
                #print self.origWList
                
                origList = self.origWList
                
                dbWdList = []
                for wd in self.origWList:
                    if not wd.isdigit():
                        if opt == 3:
                            wd = re.sub(r'(\d+)', r'//\1_>', wd)
                        wd = wd.replace('\w*', '%')
                        wd = wd.replace('\w', '_')
                        wd = wd.replace(' ', '%')
                        dbWdList.append(wd)

                encryptWdList = []
                for w in self.origWList:
                    #wl = wd.split()
                    #for w in wl:
                    if opt == 3:
                        w = re.sub(r'(\d+)', r'//\1">', w)
                    w = w.replace('\w*', '')
                    w = w.replace('\w', '')
                    encryptWdList.append(w)

                #print word
                #print self.origWList, 'orig'
                #print self.wList, 'wl'
                #print dbWdList, 'db'
                #print encryptWdList, 'encrypt wl'
            

            elif opt == 4:
                self.wdMod = re.sub(r'([.,;:"\'])', r'(?:<[^>]+>)?\1', word) 
                self.wdMod = self.wdMod.replace(' ', r' ?(?:<[^>]+>)? ?') 


            elif opt == 0:
                word = re.sub(r'[ ,]+', ' ', word)
                #print opt, 'in word'
                
                dbWord = word.replace('*', '%')
                dbWord = dbWord.replace('?', '_')
                dbWord = dbWord.replace(' ', '%')
                
                word = word.replace('?', '\w')
                word = word.replace('*', '\w*') 
                
                if re.search(r'\w(?:\\w\*|\\w)?[GH]', word, re.U): # or exclude and re.search('\w[GH]', exclude, re.U):
                    #print word.encode('utf-8'), 'combo'
                    self.wdMod = re.sub(r' ?([GH].*)$', r'\[\1\]', word)
                    dbWord = re.sub(r'([GH].*)$', r'[\1]', dbWord)
                    
                    self.comboSch = 1
                    orig = re.sub(r'([GH].*)$', r'<font color="#000066"><sup>\1</sup></font>', word)
                
                #elif word[0].upper() == 'H' and word[-1].isdigit() or word[0].upper() == 'G' and word[-1].isdigit():
                elif re.search(r'[*?]?[GH][\d*?]+[*?]?', orig, re.I|re.U):
                    #print word.encode('utf-8'), 'Strongs number'

                    self.wdMod = re.sub(r'((\\w\*|\\w)?\w\d+(\\w\*|\\w)?)$', r'[,.?;:!-]?\[\(?\1\)?\]', word, re.I)
                    
                    dbWord = re.sub(r'([GH]\d+)$', r'\1', dbWord)
                    self.strongsNumSch = 1
                
                else:
                    dbWord = '%' + dbWord + '%'
                    #print 'reg sch'
                    self.wdMod = word.replace('"', '')
                    self.wdMod = re.sub(r'(\w+)\b', r'\1(?!>)', self.wdMod)
                    self.wdMod = self.wdMod.replace(' ', r'(?:<[^>]+>|\[\(?[GH]\d\w*\)?\]|[\s.,;:?!-]*|{.+?})*') 
                    
                dbWord = '%' + dbWord + '%'
                dbWord = re.sub(r'%+', '%', dbWord)
                #dbWord = dbWord.replace("'", "''")
                
                encryptWdList = word.split()


        else:  # Regex
            #print word, 'regex'
            orig = word
            if word[0] == '^':
                word = "^(<.+?>)?" + word[1:]
            self.word = word
            
        
        #print self.wList
        #print self.wdMod
        #print dbWdList
        #print word
        #print dbWord

        

        
        if self.comboSch:
            titleStr = word
        else:
            titleStr = orig


        #print self.wdMod, 'self.wdMod'
        
        if fName in self.mainApp.strongsList:# and '[' in word:
            #print fName, 'SS'

            self.strongsSch = 1

        

        if case:
            caseStr = u' (Case Sensitive)'
        else:
            caseStr = u''
        
                    
        con = sqlite.connect(fName)
        #con.text_factory = str
        cur = con.cursor() 
        
        encrypt = utility.CheckEncrypt(cur)


        ## Regular Expression Search
        if opt == 5:
            self.regEx = 1
            
            con.create_function("regexp", 2, regEx)

                       
            selectStr = "SELECT * FROM bible WHERE id BETWEEN %d AND %d AND verse regexp \"%s\"" % (idxList[0][0], idxList[0][1], word)
            if len(idxList) == 1:
                endIdx = idxList[0][1]
            else:
                for rng in idxList[1:]:
                    selectStr += " OR id BETWEEN %d AND %d AND verse regexp '%s'" % (rng[0], rng[1], word)
                endIdx = rng[1]
            
            #print selectStr.encode('utf-8'), 'regex'
            
            if encrypt == 1:
                rows = utility.UnEncryptRows(cur, [], idxList)
                hitRows = []
                for ln in rows:
                    if regEx(word, ln[2]):
                        hitRows.append(ln)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()

            for row in hitRows:
                row = self.SubTags(row)

                if refOnly or multiSearch:
                    AddRef(row)
                else:
                    processLine(row)
                    lastHit = row[1]
                
                    if row == hitRows[-1]:
                        try: self.refList.append('%s - %s' % (self.ref1, lastHit))
                        except: pass
            
            self.refIdx.append(endIdx)
                                   
            schType = u'RegEx: '
            title = u'RegEx: %s (%s hits in %s verses)'  % (word, self.totalHits, self.count)



        ## Character string search
        if opt == 4:          
            selectStr = 'SELECT * FROM bible WHERE (id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            endIdx = idxList[0][1]
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
                    endIdx = rng[1]
            selectStr += ')'
            
            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, None, idxList)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
            
            full = 0
            case = 0
            self.string = 1
            
            for row in hitRows:
                row = self.SubTags(row)
                line = row[2]
                
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(ur'<r>.+?</r>', line)
                        line = ''.join(rRange)
                    else:
                        continue
                
                find = re.findall(r'%s' % self.wdMod, line, re.I|re.U)

                if find:

                    if exclude != None:

                        ex = doExclude(line)

                        if not ex:

                            if refOnly or multiSearch:

                                AddRef(row)

                            else:

                                processLine(row)

                                lastHit = row[1]

                    else:

                        if refOnly or multiSearch:

                            AddRef(row)

                        else:

                            processLine(row)

                            lastHit = row[1]

                

                    self.totalHits += len(find)

                        
                if row == hitRows[-1]:
                    try: self.refList.append('%s - %s' % (self.ref1, lastHit))
                    except: pass
            

            if exclude != None:

                orig = orig + ' -' + ' -'.join(excludeList)

            
            self.refIdx.append(endIdx)
            
            schType = u'Character String: '
            title = u'Character String: %s (%s hits in %s verses)'  % (titleStr, self.totalHits, self.count)



        ## Individual search
        if opt == 3:
            titleOrig = ''
            
            titleOrig = ' or '.join(origList)
            orig = ' </b></font>and<font color="#990000"><b> '.join(origList)
                                       
            if exclude != None:
                titleOrig = titleOrig + ' -' + ' -'.join(excludeList)
                orig = orig + ' -' + ' -'.join(excludeList)            

            selectStr = 'SELECT * FROM bible WHERE (id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            endIdx = idxList[0][1]
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
                    endIdx = rng[1]
            selectStr += ')'
            
            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    selectStr += ')'
                    continue
                
                selectStr += ' AND verse LIKE "%%%s%%"' % wd

            #print selectStr

            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, idxList)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
            
            self.BuildTempList(hitRows, full, caseFlag, redSearch)
            
            for row in self.tempList:
                row = self.SubTags(row)
                
                # For hit chart
                for wd in self.wList:
                    seek = re.compile(r'\b%s(?!>)\b' % wd, re.I|re.U)
                    find, hits = seek.subn('@', row[2])
                    if hits > 0:
                        self.totalHits += hits
                
                if exclude != None:
                    ex = doExclude(row[2])
                    if not ex:
                        if refOnly or multiSearch:
                            AddRef(row)
                        else:
                            processLine(row)
                            lastHit = row[1] 
                else:
                    if refOnly or multiSearch:
                        AddRef(row)
                    else:
                        processLine(row)
                        lastHit = row[1] 
                    
            try: 
                self.refList.append('%s - %s' % (self.ref1, lastHit))
            except:
                pass
            
            self.refIdx.append(endIdx)

            schType = u'Individual: '
            title = u'Individual: %s (%s hits in %s verses)'  % (titleOrig, self.totalHits, self.count)



        ## Any words search
        if opt == 2:
            titleOrig = ''
            
            titleOrig = ' or '.join(origList)

            orig = ' </b></font>or<font color="#990000"><b> '.join(origList)
            
            if exclude != None:

                titleOrig = titleOrig + ' -' + ' -'.join(excludeList)

                orig = orig + ' -' + ' -'.join(excludeList)

                
            if full:
                findStr = r'\b%s(?!>)\b' % self.wList[0]
            else:
                findStr = r'\b%s(?!>)\w*' % self.wList[0]
                
            for wd in self.wList[1:]:
                if full:
                    findStr = findStr + r'|\b%s(?!>)\b' % wd
                else:
                    findStr = findStr + r'|\b%s(?!>)\w*' % wd
            
            if case:
                seek = re.compile(r'(%s(?!>))' % findStr, re.U)
            else:
                seek = re.compile(r'(%s(?!>))' % findStr, re.I|re.U)
                
                
            selectStr = 'SELECT * FROM bible WHERE (id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            endIdx = idxList[0][1]
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
                    endIdx = rng[1]
            selectStr += ')'
            
            #print dbWdList, 'dbWdList1'
            
            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    #selectStr += ')'
                    continue
                
                if wd == dbWdList[0]:
                    selectStr += ' AND (verse LIKE "%%%s%%"' % wd
                else:
                    selectStr += ' OR verse LIKE "%%%s%%"' % wd
            
            #if not selectStr.endswith(')'):
            selectStr += ')'
                
            #print selectStr, 'Any first'
                        
            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, idxList, True)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()

            #print len(hitRows)
            for row in hitRows:       
                row = self.SubTags(row)       
                line = row[2]
                
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(ur'<r>.+?</r>', line)
                        line = ''.join(rRange)
                    else:
                        continue
                
                find = seek.findall(line)

                if find:

                    if exclude != None:

                        ex = doExclude(line)

                        if not ex:

                            if refOnly or multiSearch:

                                AddRef(row)                                

                            else:

                                processLine(row)

                                lastHit = row[1]

                    else:

                        if refOnly or multiSearch:

                            AddRef(row)
                        else:

                            processLine(row)

                            lastHit = row[1]

                

                    self.totalHits += len(find)

                        
                if row == hitRows[-1]:
                    try: self.refList.append('%s - %s' % (self.ref1, lastHit))
                    except: pass
                
            self.refIdx.append(endIdx)

            schType = u'Any Word: '
            title = u'Any Word: %s (%s hits in %s verses)'  % (titleOrig, self.totalHits, self.count)



        ## Every word search
        if opt == 1:
                       
            titleOrig = ' and '.join(origList)
            orig = ' </b></font>and<font color="#990000"><b> '.join(origList)
                        

            if exclude != None:

                titleOrig = titleOrig + ' -' + ' -'.join(excludeList)

                orig = orig + ' -' + ' -'.join(excludeList)            


            selectStr = 'SELECT * FROM bible WHERE (id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            endIdx = idxList[0][1]
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
                    endIdx = rng[1]
            selectStr += ')'
            
            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    selectStr += ')'
                    continue
                
                selectStr += ' AND verse LIKE "%%%s%%"' % wd

            #print selectStr

            if encrypt == 1:
                #print dbWdList
                hitRows = utility.UnEncryptRows(cur, encryptWdList, idxList)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
                
            
            #Multiples of same word.

            if self.wList[-1].isdigit():

                self.multiWord = 1

                for row in hitRows:
                    row = self.SubTags(row)    
                    line = row[2]
                    
                    if redSearch:
                        if '<r>' in line:
                            rRange = re.findall(r'<r>.+?</r>', line)
                            line = ''.join(rRange)
                        else:
                            continue
                    
                    if full:

                        find = re.findall(r'\b%s(?!>)\b' % self.wList[0], line, caseFlag)
                    else:    

                        find = re.findall(r'\b%s(?!>)' % self.wList[0], line, caseFlag)

                    

                    if find and len(find) >= int(self.wList[-1]):

                        if exclude != None:

                            ex = doExclude(line)

                            if not ex:

                                if refOnly or multiSearch:

                                    AddRef(row)

                                else:

                                    processLine(row)

                                    lastHit = row[1] 

                        else:

                            if refOnly or multiSearch:

                                AddRef(row)

                            else:

                                processLine(row)

                                lastHit = row[1] 

                            

                        self.totalHits += len(find)

                                        

                try: self.refList.append('%s - %s' % (self.ref1, lastHit))

                except: pass

                self.refIdx.append(endIdx)

                

                titleOrig = ' x '.join(self.wList)

                orig = ' </b></font>x<font color="#990000"><b> '.join(self.wList)

                schType = u'Multiple Word: '

                title = u'Multiple Word: %s (Found in %s verses)'  % (titleOrig, self.count)

            

            #Normal "every word"

            else:
                self.BuildTempList(hitRows, full, caseFlag, redSearch)
                
                for row in self.tempList:
                    row = self.SubTags(row)
                    
                    # For hit chart

                    for wd in self.wList:
                        seek = re.compile(r'\b%s(?!>)\b' % wd, re.I|re.U)

                        find, hits = seek.subn('@', row[2])

                        if hits > 0:

                            self.totalHits += hits
                    

                    if exclude != None:

                        ex = doExclude(row[2])

                        if not ex:

                            if refOnly or multiSearch:

                                AddRef(row)

                            else:

                                processLine(row)
                                lastHit = row[1] 

                    else:
                        if refOnly or multiSearch:

                            AddRef(row)

                        else:
                            processLine(row)

                            lastHit = row[1] 
                    



                try: self.refList.append('%s - %s' % (self.ref1, lastHit))
                except: pass
                self.refIdx.append(endIdx)
                
                schType = u'Every Word: '
                title = u'Every Word: %s (%s hits in %s verses)'  % (titleOrig, self.totalHits, self.count)
            
        
        ## Word or Phrase Search
        if opt == 0:
            #print self.wdMod.encode('utf-8')
            #print dbWord
            
            dbWord = dbWord.replace('"', '')


            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d AND verse LIKE "%%%s%%"' % (idxList[0][0], idxList[0][1], dbWord)
            if len(idxList) == 1:

                endIdx = idxList[0][1]
            else:
                for rng in idxList[1:]:

                    selectStr += ' OR id BETWEEN %d AND %d AND verse LIKE "%%%s%%"' % (rng[0], rng[1], dbWord) 
                endIdx = rng[1]
                           
            if encrypt == 1:
                wdList = dbWord.split('%')
                hitRows = utility.UnEncryptRows(cur, encryptWdList, idxList)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
                        

            if self.comboSch or self.strongsSch:
                if full:
                    seek = re.compile(r'\b%s' % self.wdMod, caseFlag)
                else:
                    seek = re.compile(r'%s' % self.wdMod, caseFlag)
            
            elif self.greekSch:
                seek = re.compile(r' %s' % self.wdMod, re.I|re.U)

            
            else:
                if full:

                    seek = re.compile(r'\b%s(?!>)\b' % self.wdMod, caseFlag)
                else:
                    seek = re.compile(r'\b%s(?!>)\w*' % self.wdMod, caseFlag)
            
            self.phrase = 1
            
            if exclude != None:

                orig = orig + ' -' + ' -'.join(excludeList)

            
            #print hitRows
            #print self.wdMod
            
            for row in hitRows:
                row = self.SubTags(row)
                line = u' %s' % row[2]       
                
                #print line.encode('utf-8')
                               
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(ur'<r>.+?</r>', row[2])
                        line = ''.join(rRange)
                    else:
                        continue
                    
                find = seek.findall(line)
                if find:
                    if exclude != None:

                        ex = doExclude(line)                            

                        if not ex:
                            if refOnly or multiSearch:
                                AddRef(row)
                            else:    
                                processLine(row)
                                lastHit = row[1]                       
                    else:

                        if refOnly or multiSearch:

                            AddRef(row)
                        else:
                            processLine(row)

                            lastHit = row[1]

                    
                    self.totalHits += len(find)

                
                if row == hitRows[-1]:
                    try: 
                        ref = '%s - %s' % (self.ref1, lastHit)
                        if not ref in self.refList:
                            self.refList.append(ref)
                    except: 
                        pass
            

            self.refIdx.append(endIdx)
                        
            schType = u'Every Instance: '
            title = u'Every Instance: %s (%s hits in %s verses)'  % (titleStr, self.totalHits, self.count)


        if not resWdList and not multiSearch and not popup:

            masterVerseIdx.append(self.refIdx)
            masterVerseString.append(self.refList)
        
        #print masterVerseIdx
        #print masterVerseString
        
        self.phrase = 0
        self.string = 0            
            
        rLabel = ''
        if redSearch:
            rLabel = u' (Red Letter)'
        
        if self.count < 100:
            rng = self.count
        else:
            rng = '100'
        

        orig = orig.replace('\w+', '*')            
        orig = orig.replace('\w', '?')    
        orig = re.sub(r'([GH][\d?*]+)', r'<font color="#000066"><sup>\1</sup></font>', orig)
        orig = re.sub(r'[\\\[\]]', r'', orig)
        
        if refOnly:
            if resWdList or relatedRefOnly:
                return self.refTemp
            
            else:
                result = ', '.join(self.refTemp)
                result = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', result)
                
                answer = '''<body bgcolor="%s" link="#336666"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
                <tr><td bgcolor="%s"><font face="%s"><b>%s<font color="#990000">%s, &nbsp;</font></b> <b>%s</b> (%s)%s%s,<br>
                <b>%s</b> hits in <b>%s</b> verses</font></td></tr></table><br><br><font face="%s">%s<br></font>'''\
                % (self.mainApp.resColor, self.mainApp.resHeadColor, fface, schType, orig, self.abbr, rangeStr, rLabel, caseStr,\
                self.totalHits, len(self.refTemp), fface, result),\
                self.refList, title, self.count, findStr, self.totalHits, exclude, self.rngRefList 
        

        elif multiSearch:

            return self.refTemp, self.refList, title, self.count, findStr, self.totalHits, exclude, self.rngRefList, schType, rangeStr, rLabel, caseStr, orig 

            


        else:
            result = '<br><br>'.join(self.final)
            
            if not self.mainApp.noPopRefLnk:
                result = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', result)
                self.mainApp.noPopRefLnk = 0
            
            if '<gu>' in result:
                result = re.sub(r'<gu>(.*?)</gu>', r'<font face="GU Greek">\1</font>', result)
            
            origFace = fface
            
            result, fface = utility.CheckOldFont(fName, result, fface)
            

            try:
                orig = unicode(orig, "utf-8")
            except:
                pass
            

            self.bkData = self.HitChart(self.bookHits, 1)
            #print self.bkData
        
            answer = '''<body bgcolor="%s" link="#336666"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
            <tr><td bgcolor="%s"><font face="%s"><b>%s<font color="#990000">%s, &nbsp;</font></b> <b>%s</b> (%s)%s%s,<br>\
            Verses <b>1</b> through <b>%s</b> of <b>%s,</b><br>\
            <b>%s</b> hits shown of <b>%s</b></font></td></tr></table><br><br><font face="%s">%s</font><hr><a name="results"></a><font face="%s">%s<br></font>'''\
            % (self.mainApp.resColor, self.mainApp.resHeadColor, origFace, schType, orig, self.abbr, rangeStr, rLabel, caseStr,\
            rng, self.count, self.pageCount, self.totalHits, origFace, ''.join(self.bkData), fface, result),\
            self.refList, title, self.count, findStr, self.totalHits, exclude, self.rngRefList
        
        return answer 
 
    

    
    def HitChart(self, hits, cap):

        bkList = []

        cntList = []

        bkCount = {}

        data = []


        for bk in hits:
            cnt = hits.count(bk)

            cntList.append(cnt)

            

        try:
            most = max(cntList)
        except:
            most = 0



        for bk in hits:

            cnt = hits.count(bk)

            if cnt != 0:

                if cnt == most:

                    color = self.mainApp.chartColor1

                else:            

                    color = self.mainApp.chartColor2

                

                width = float(cnt) / float(most) * float(self.dispWidth-155)

                fullName = bk

                if cap:

                    fullName = fixRef.fullTitle(bk)
                    fullName = fullName.replace('Thessalonians', 'Thess.')

                

                result = u'<table><tbody><tr><td width="120"><i><a href="#%s">%s</a></i></td><td bgcolor="%s" width="%d">%s</td></tr></tbody></table>'\
                % (bk, fullName, color, width, cnt)

                

                if result not in data:

                    data.append(result)

        return data



    

    ## Word or phrase next/prev search
    def PrevNextSearch(self, word, fName, abbr, full, opt, case, showRed, redSearch, count, findStr, totalHits, exclude, rangeStr, rngRefList, tab, sel):
        
        def regEx(expr, line):
            if case:

                r = re.compile(r'%s' % expr, re.U)

            else:

                r = re.compile(r'%s' % expr, re.I|re.U)

            if redSearch:
                if '<r>' in line:
                    rRange = re.findall(r'<r>.+?</r>', line)                                
                    for rng in rRange:
                        find = re.findall('%s(?!>)' % word, rng, re.I|re.U)
                        if find:
                            return 1
            else:
                find = r.findall(line)
                if find:
                    return 1
            
        
        if exclude:
            exclude = exclude.replace('?', '\w')
            exclude = exclude.replace('*', '\w*') 
            excludeTmp = exclude.split()
            
            excludeList = []
            for wd in excludeTmp:
                excludeList.append(re.sub(r' ?([GH].*)$', r'\[\1\]', wd))
        

            #print excludeList, 'exclude'

        def doExclude(line):
            # if combo word
            if re.search(r'\[HG]\d+', excludeList[0]):
                exString = r'\b%s' % excludeList[0]
                if len(excludeList) > 1:
                    for wd in excludeList[1:]:
                        exString = exString + r'|\b%s' % wd              
            else:
                if full:
                    exString = r'\b%s(?!>)\b' % re.sub(r'\[.+?\]', r'', excludeList[0])
                else:
                    exString = r'\b%s(?!>)\w*' % re.sub(r'\[.+?\]', r'', excludeList[0])
                if len(excludeList) > 1:
                    for wd in excludeList[1:]:
                        wd = re.sub(r'\[.+?\]', r'', wd)
                        exString += r'|\b%s(?!>)\b' % wd
            if case:
                ex = re.search(exString, line, re.U)
            else:
                ex = re.search(exString, line, re.I|re.U)
                
            return ex

        self.tagList = []
        
        self.bookHits = []

        self.final = []
        
        self.showRed = showRed
        self.fName = fName
        fface = self.mainApp.font

        
        tab = self.mainApp.resNB.GetSelection() -1
        disp = self.mainApp.resDisplay[tab]
        self.dispWidth = disp.GetClientSize()[0]

        
        pageCount = 0
        vsCount = 0
        self.multiWord = 0

        self.greekSch = 0

        self.strongsSch = 0
        self.strongsNumSch = 0
        self.hebSch = 0
        self.comboSch = 0
        self.regEx = 0
        self.fromSchLnk = 0
        
        caseFlag = re.I|re.U
        if case:
            caseFlag = re.U

        
        rngRefLen = len(rngRefList[0])
        
        orig = word

        if exclude != None:

            orig = orig + ' -' + ' -'.join(excludeList)

        
        if opt != 5:  # Non RegEx

            #word = word.encode('utf-8')

            word = re.sub(r'[ ,]+', ' ', word)

            orig = word            

            origList = word.split()

            

            if opt == 1 or opt == 2 or opt == 3:
                #print word, 'word'
                word = re.sub(r'[ ,]+', ' ', word)
                word = word.replace('?', '\w')
                word = word.replace('*', '\w*') 
                if opt == 3:
                    word = re.sub(r'\[.+?\]', r'', word)
                
                if '|' in word:
                    alt = re.findall(r'\((.+?)\)', word)
                    word = re.sub(r'\(.+?\)', '', word)
                    self.wList = word.split()
                    self.origWList = word.split()
                    #print alt, 'alt'
                    for item in alt:
                        item = re.sub(r'"', '', item)
                        item = re.sub(r'\s*\|\s*', '|', item)
                        self.origWList.insert(0, item)
                        self.wList.insert(0, '(%s)' % item)
                
                elif '"' in word:
                    phrase = re.findall(r'"(.+?)"', word)
                    word = re.sub(r'".+?"', '', word)
                    self.wList = word.split()
                    #dbWdList = [wd for wd in phrase]
                    self.origWList = word.split()
                    for item in phrase:
                        self.origWList.insert(0, item)
                        item = item.replace(' ', r'(?:<[^>]+>|\[\(?[GH]\d\w*\)?\]|[\s.,;:?!-]*|{.+?})*')
                        self.wList.insert(0, item)
                            
                else:
                    self.wList = word.split()
                    self.origWList = word.split()
                
                #print self.wList
                #print self.origWList
                
                origList = self.origWList
                
                dbWdList = []
                for wd in self.origWList:
                    if not wd.isdigit():
                        if opt == 3:
                            wd = re.sub(r'(\d+)', r'//\1_>', wd)
                        wd = wd.replace('\w*', '%')
                        wd = wd.replace('\w', '_')
                        wd = wd.replace(' ', '%')
                        dbWdList.append(wd)

                encryptWdList = []
                for w in self.origWList:
                    #wl = wd.split()
                    #for w in wl:
                    if opt == 3:
                        w = re.sub(r'(\d+)', r'//\1">', w)
                    w = w.replace('\w*', '')
                    w = w.replace('\w', '')
                    encryptWdList.append(w)

                #print word
                #print self.origWList, 'orig'
                #print self.wList, 'wl'
                #print dbWdList, 'db'
                #print encryptWdList, 'encrypt wl'
                    

            
            elif opt == 4:
                self.wdMod = re.sub(r'([.,;:"\'])', r'(?:<[^>]+>)?\1', word) 
                self.wdMod = self.wdMod.replace(' ', r' ?(?:<[^>]+>)? ?') 

            elif opt == 0:
                dbWord = word.replace('*', '%')
                dbWord = dbWord.replace('?', '_')
                dbWord = dbWord.replace(' ', '%')
                
                word = word.replace('?', '\w')
                word = word.replace('*', '\w*') 
                
                if re.search(r'\w(?:\\w\*|\\w)?[GH]', word, re.U): # or exclude and re.search('\w[GH]', exclude, re.U):
                    #print word.encode('utf-8'), 'combo'
                    self.wdMod = re.sub(r' ?([GH].*)$', r'\[\1\]', word)
                    dbWord = re.sub(r'([GH].*)$', r'[\1]', dbWord)
                    
                    self.comboSch = 1
                    orig = re.sub(r'([GH].*)$', r'<font color="#000066"><sup>\1</sup></font>', word)
                
                #elif word[0].upper() == 'H' and word[-1].isdigit() or word[0].upper() == 'G' and word[-1].isdigit():
                elif re.search(r'[*?]?[GH][\d*?]+[*?]?', orig, re.I|re.U):
                    #print word.encode('utf-8'), 'Strongs number'

                    self.wdMod = re.sub(r'((\\w\*|\\w)?\w\d+(\\w\*|\\w)?)$', r'[,.?;:!-]?\[\(?\1\)?\]', word, re.I)
                    
                    dbWord = re.sub(r'([GH]\d+)$', r'\1', dbWord)
                    self.strongsNumSch = 1
                
                else:
                    dbWord = '%' + dbWord + '%'
                    #print 'reg sch'
                    self.wdMod = word.replace('"', '')
                    self.wdMod = re.sub(r'(\w+)\b', r'\1(?!>)', self.wdMod)
                    self.wdMod = self.wdMod.replace(' ', r'(?:<[^>]+>|\[\(?[GH]\d\w*\)?\]|[\s.,;:?!-]*|{.+?})*') # % (pLst, pLst))
                
                dbWord = '%' + dbWord + '%'
                dbWord = re.sub(r'%+', '%', dbWord)
                #dbWord = dbWord.replace("'", "''")
                
                encryptWdList = [word]


        else:  

            orig = word            

            self.word = word

        
        if fName in self.mainApp.strongsList:

            self.strongsSch = 1

        
        beginIdx = masterVerseIdx[tab -1][sel]       
        endIdx = masterVerseIdx[tab -1][sel+1]-1  
            
        con = sqlite.connect(fName)
        #con.text_factory = str
        cur = con.cursor()
        
        encrypt = utility.CheckEncrypt(cur)


        ## Regular Expression Search
        if opt == 5:

            self.regEx = 1
            #print beginIdx, endIdx, word, 'reg'             
            con.create_function("regexp", 2, regEx)
            
            selectStr = "SELECT * FROM bible WHERE id BETWEEN %d AND %d AND verse regexp '%s'" % (beginIdx, endIdx, word)
            
            if encrypt == 1:
                rows = utility.UnEncryptRows(cur, [], idxList)
                hitRows = []
                for ln in rows:
                    #print ln
                    #print word
                    if regEx(word, ln[2]):
                        hitRows.append(ln)
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()

            for row in hitRows:
                 if row[1][:rngRefLen] in rngRefList:

                    #print row[0]
                    line = '%s\t%s' % (row[1], row[2])
                    line, vsCount = self.AddLine(line, full, case)
                    self.final.append(line)
                    pageCount += vsCount
            
            schType = 'RegEx: '
        
        
        if opt == 4:
            cur.execute('SELECT * FROM bible WHERE id BETWEEN ? AND ? AND verse LIKE ?', (beginIdx, endIdx, dbWord,))
            #rows = cur.fetchall()
            self.string = 1

            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, None, [[beginIdx, endIdx]])
            else:
                hitRows = cur.fetchall()

            for row in hitRows:
                row = self.SubTags(row)
                line = row[2]
                
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(r'<r>.+?</r>', line)
                        line = ''.join(rRange)
                    else:
                        continue
                
                find = re.findall('%s(?!>)' % self.wdMod, line, re.I|re.U)

                if find and row[1][:rngRefLen] in rngRefList:

                    if exclude != None:

                        ex = doExclude(line)

                        if not ex:
                            line = u'%s\t%s' % (row[1], row[2])
                            line, vsCount = self.AddLine(line, full, case)
                            self.final.append(line)
                            pageCount += vsCount

                    else:

                        line = u'%s\t%s' % (row[1], row[2])

                        line, vsCount = self.AddLine(line, full, case)

                        self.final.append(line)

                        pageCount += vsCount



                schType = u'Character String: '



        ## Individual search
        if opt == 3:
            orig = ' </b></font>and<font color="#990000"><b> '.join(origList)
                        
            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (beginIdx, endIdx)

            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    selectStr += ')'
                    continue
                
                selectStr += ' AND verse LIKE "%%%s%%"' % wd

            #print selectStr
            
            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, [[beginIdx, endIdx]])
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
            
            self.BuildTempList(hitRows, full, caseFlag, redSearch)            
            for line in self.tempList:
                if line[1][:rngRefLen] in rngRefList:
                    if exclude != None:
                        ex = doExclude(row[2])
                        if not ex:
                            line = u'%s\t%s' % (line[1], line[2])
                            line, vsCount = self.AddLine(line, full, case)
                            self.final.append(line)
                            pageCount += vsCount
                    else:
                        line = u'%s\t%s' % (line[1], line[2])
                        line, vsCount = self.AddLine(line, full, case)
                        self.final.append(line)
                        pageCount += vsCount
                                    
            schType = u'Individual: '



        if opt == 2:
            orig = ' </b></font>or<font color="#990000"><b> '.join(origList)               

            if case:
                seek = re.compile(r'(%s)' % findStr, re.U)
            else:
                seek = re.compile(r'(%s)' % findStr, re.I|re.U)

            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (beginIdx, endIdx)
            
            #print dbWdList, 'dbWdList1'
            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    #selectStr += ')'
                    continue
                
                if wd == dbWdList[0]:
                    selectStr += ' AND (verse LIKE "%%%s%%"' % wd
                else:
                    selectStr += ' OR verse LIKE "%%%s%%"' % wd
            
            #if not selectStr.endswith(')'):
            selectStr += ')'
          

            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, [[beginIdx, endIdx]], True)
            else:
                print selectStr, 'Any'
                cur.execute(selectStr)
                hitRows = cur.fetchall()
                        
            print len(hitRows)
            for row in hitRows:

                row = self.SubTags(row)
                line = row[2]
                
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(r'<r>.+?</r>', line)
                        line = ''.join(rRange)
                    else:
                        continue
                
                find = seek.findall(line)

                if find and row[1][:rngRefLen] in rngRefList:

                    if exclude != None:

                        ex = doExclude(line)

                        if not ex:

                            line = u'%s\t%s' % (row[1], row[2])

                            line, vsCount = self.AddLine(line, full, case)

                            self.final.append(line)

                            pageCount += vsCount

                    else:

                        line = u'%s\t%s' % (row[1], row[2])

                        line, vsCount = self.AddLine(line, full, case)

                        self.final.append(line)

                        pageCount += vsCount

            
            schType = u'Any Word: '

        
        if opt == 1:         
            altSearch = 0
                    

            if len(self.wList) > 1:

                orig = ' </b></font>and<font color="#990000"><b> '.join(origList)

            
            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d ' % (beginIdx, endIdx)
            
            for wd in dbWdList:
                if '|' in wd:
                    grp = wd.split('|')
                    for gWd in grp:
                        if gWd == grp[0]:
                            selectStr += ' AND (verse LIKE "%%%s%%"' % gWd
                        else:
                            selectStr += ' OR verse LIKE "%%%s%%"' % gWd
                    selectStr += ')'
                    continue
                
                selectStr += ' AND verse LIKE "%%%s%%"' % wd
                        
            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, [[beginIdx, endIdx]])
            else:
                print selectStr, 'Every'
                cur.execute(selectStr)
                hitRows = cur.fetchall()
            
            tempList = hitRows[:]
            
            #Multiples of same word.
            if self.wList[-1].isdigit():                

                self.multiWord = 1
                for row in hitRows:
                    row = self.SubTags(row)
                    line = row[2]
                    
                    if redSearch:
                        if '<r>' in line:
                            rRange = re.findall(r'<r>.+?</r>', line)
                            line = ''.join(rRange)
                        else:
                            continue
                    
                    find = re.findall(r'\b%s(?!>)\b' % self.wList[0], line, caseFlag)
                    if find and len(find) >= int(self.wList[-1]):
                        if exclude != None:
                            ex = doExclude(line)
                            if not ex:
                                line = '%s\t%s' % (row[1], row[2])
                                line, vsCount = self.AddLine(line, full, case)
                                self.final.append(line)
                                pageCount += vsCount
                        else:
                            line = '%s\t%s' % (row[1], row[2])
                            line, vsCount = self.AddLine(line, full, case)
                            self.final.append(line)
                            pageCount += vsCount
                    
                schType = u'Multiple Word: '

                orig = ' </b></font>x<font color="#990000"><b> '.join(self.wList)
            
            else:
                self.BuildTempList(hitRows, full, caseFlag, redSearch)            
                for line in self.tempList:
                    if line[1][:rngRefLen] in rngRefList:
                        if exclude != None:

                            ex = doExclude(row[2])

                            if not ex:
                                line = u'%s\t%s' % (line[1], line[2])
                                line, vsCount = self.AddLine(line, full, case)
                                self.final.append(line)
                                pageCount += vsCount
                        else:

                            line = u'%s\t%s' % (line[1], line[2])

                            line, vsCount = self.AddLine(line, full, case)
                            self.final.append(line)

                            pageCount += vsCount

                        

                schType = u'Every Word: '
        

        
        if opt == 0:
            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d AND verse LIKE "%%%s%%"' % (beginIdx, endIdx, dbWord)
            
            if encrypt == 1:
                hitRows = utility.UnEncryptRows(cur, encryptWdList, [[beginIdx, endIdx]])
            else:
                cur.execute(selectStr)
                hitRows = cur.fetchall()
            
            if self.comboSch or self.strongsSch:
                if full:
                    seek = re.compile(r'\b%s' % self.wdMod, re.I|re.U)
                else:
                    seek = re.compile(r'%s' % self.wdMod, re.I|re.U)
            
            elif self.greekSch:

                seek = re.compile(r' %s' % self.wdMod, re.I|re.U)

            
            else:

                if full:
                    seek = re.compile(r'\b%s(?!>)\b' % self.wdMod, caseFlag)
                else:
                    seek = re.compile(r'\b%s(?!>)\w*' % self.wdMod, caseFlag)
            
            self.phrase = 1
            
            for row in hitRows:

                row = self.SubTags(row)              
                line = u' ' + row[2]
                
                if redSearch:
                    if '<r>' in line:
                        rRange = re.findall(ur'<r>.+?</r>', row[2])
                        line = ''.join(rRange)
                    else:
                        continue


                find = seek.findall(line)
                if find and row[1][:rngRefLen] in rngRefList:

                    if exclude != None:

                        ex = doExclude(line)

                        if not ex:

                            line = u'%s\t%s' % (row[1], row[2])

                            line, vsCount = self.AddLine(line, full, case)

                            self.final.append(line)

                            pageCount += vsCount

                    else:

                        line = u'%s\t%s' % (row[1], row[2])

                        line, vsCount = self.AddLine(line, full, case)

                        self.final.append(line)

                        pageCount += vsCount



            schType = u'Every Instance: '
        
        self.phrase = 0
        self.string = 0
        
        orig = orig.replace('\w+', '*')            
        orig = orig.replace('\w', '?')
              
        range1 = sel*100 + 1
        if range1 + 100 > count:
            range2 = count
        else:
            range2 = range1 + 100 - 1
        
        rLabel = ''
        if redSearch:
            rLabel = ' (Red Letter)'
        
        caseStr = ''
        if case:
            caseStr = ' (Case Sensitive)'
        
        self.bkData = self.HitChart(self.bookHits, 1)
        
        final = '<br><br>'.join(self.final)#.decode('utf-8')

        final = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', final)
        
        if '<gu>' in final:
            final = re.sub(r'<gu>(.*?)</gu>', r'<font face="GU Greek">\1</font>', final)


        origFace = fface
        final, fface = utility.CheckOldFont(fName, final, fface)

        answer = '''<body bgcolor="%s" link="#336666"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s"><b>%s<font color="#990000">%s, &nbsp;</font></b> <b>%s</b> (%s)%s%s,<br>\
        Verses <b>%s</b> through <b>%s</b> of <b>%s,</b><br>\
        <b>%s</b> hits shown of <b>%s</b></font></td></tr></table><br><br><font face="%s">%s</font><hr><a name="results"></a><font face="%s">%s<br></font>'''\
        % (self.mainApp.resColor, self.mainApp.resHeadColor, origFace, schType, orig, abbr, rangeStr, rLabel, caseStr,\
        range1, range2, count, pageCount, totalHits, origFace, ''.join(self.bkData), fface, final)
        
        return answer 



    ## Proximity Search
    def Proximity(self, primWord, secWL, fName, abbr, span, full, fface, showRed, redSearch, idxList, rangeStr):
        
        def getSpan(index, encrypt):
            cur.execute('SELECT * FROM bible WHERE id = ?', (index,))
            row = cur.fetchone()
            
            if row:
                if encrypt:
                    row = utility.CheckEncryptByHeader(row)
            else:
                return
                
            try:
                return '%s\t%s' % (row[1], row[2])
            except: 
                #print row
                return u'<i>Beyond text range</i>'
        
        self.proxMatch = []
        
        #if redSearch:
        #    beginIdx = 23146 
        #    endIdx = 31102
        #else:    
        #    beginIdx = vsIndex[bkBegIdx]
        #    endIdx = vsIndex[bkEndIdx+1] 
            
        
        #primWord = primWord.replace('?', '\w')
        #primWord = primWord.replace('*', '\w*') 

        dbWord = '%' + primWord + '%'
        
        con = sqlite.connect(fName)
        con.text_factory = str
        cur = con.cursor()  
        
        encrypt = 0
        cur.execute("SELECT name FROM sqlite_master WHERE name='option'")
        if cur.fetchone():
            cur.execute('SELECT * FROM option')
            row = cur.fetchone()
            if len(row) > 2 and row[2]:
                encrypt = 1

        
        selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d AND verse LIKE "%%%s%%"' % (idxList[0][0], idxList[0][1], dbWord)
        if len(idxList) == 1:
            endIdx = idxList[0][1]
        else:
            for rng in idxList[1:]:
                selectStr += ' OR id BETWEEN %d AND %d AND verse LIKE "%%%s%%"' % (rng[0], rng[1], dbWord)
            endIdx = rng[1]
                
        if encrypt == 1:
            hitRows = utility.UnEncryptRows(cur, [primWord], idxList)
            #print hitRows
        else:
            cur.execute(selectStr)
            hitRows = cur.fetchall()
        
        #Search for all verses with primary word and put their verse index in primList
        primList = []
        
        if full:
            seek = re.compile(r'\b%s\b' % primWord, re.I)
        else:
            seek = re.compile(r'\b%s\w*' % primWord, re.I)
        
        for row in hitRows:
            noTag = re.sub(r'<.+?>', r'', row[2])
            
            find = seek.search(noTag)
            if find:
                lineIndex = row[0]
                primList.append(lineIndex)

        #Get preceding and following verses according to span range. Put in vRange.
        vRange = []
        for index in primList:
            tempList = []

            index = index - span
            for num in range(span * 2 + 1):
                line = getSpan(index + num, encrypt)
                if not line:
                    break
                                
                if showRed == True:
                    line = line.replace('<r>', '<font color="Red">')
                    line = line.replace('</r>', '</font>')
                else:
                    line = line.replace('<r>', '')
                    line = line.replace('</r>', '')
                 
                tabIdx = line.find('\t')
                line = line[:3] + '_' + line[4:]
                line = '&nbsp;&nbsp;&nbsp;&nbsp;<font color="#336666"><u>%s</u>, </font>%s'  % (line[:tabIdx], line[tabIdx:])
                line = '<tr><td>%s</tr></td>' % line 
                
                tempList.append(line)
            vRange.append(tempList)

        #Search for secondary word in each verse group. Place group match in "temp" list.
        temp = []
        for set in range(len(vRange)):

            hitList = []
            for wd in secWL:

                for line in vRange[set]:
                    origLine = line
                    
                    # Save tags/notes in list to put back
                    if '<a href' in row[2]:
                        self.tagList = re.findall(r'<a href.+?>|</a>', line)
                        line = re.sub(r'<a href.+?>|</a>', r'<t>', line)
                    
                    if full:
                        findSec = re.search(r'\b%s(?!>)\b' % wd, line, re.I)
                    else:
                        findSec = re.search(r'\b%s(?!>)\w*' % wd, line, re.I)
                    
                    indexSec = vRange[set].index(origLine)
                                        
                    if findSec:
                        if full:
                            sw = re.compile(r'(\b%s(?!>)\b)(.)' % wd, re.I)
                        else:
                            sw = re.compile(r'\b(%s(?!>))(\w*)' % wd, re.I)
                        
                        line = sw.sub(r'<font color="#990000"><b>\1</b></font>\2', line)
                        line = line.replace('<td>', '<td bgcolor="#CCEEFF">')
                        
                        # Put tags back in
                        if '<t>' in line:
                            line = re.sub(r'<t>', self.InsertTag, line)

                        vRange[set][indexSec] = line
                        if wd not in hitList:

                            hitList.append(wd)

                        

                        if len(hitList) == len(secWL) and vRange[set] not in temp:
                            temp.append(vRange[set])
                        

        #Search for primary word in each matched group. Place group in "match" list.
        for set in range(len(temp)):
            cycle = 1
            for line in temp[set]:
                
                origLine = line

                # Save tags/notes in list to put back
                if '<a h' in line or '<f' in line:
                    self.tagList = re.findall(r'<a href.+?>|</a>|<fnc?>\d+</fnc?>', line)
                    line = re.sub(r'<a href.+?>|</a>|<fnc?>\d+</fnc?>', r'<t>', line)

                if full:
                    findPri = re.search(r'\b%s(?!>)\b' % primWord, line, re.I)
                else:
                    findPri = re.search(r'\b%s(?!>)\w*' % primWord, line, re.I)
                
                indexPri = temp[set].index(origLine)
                
                if cycle == span +1:
                    line = line.replace('<td bgcolor="#FFFFCC">', '<td>')
                    line = line.replace('<td>', '<td bgcolor="#FFCCCC">')
                cycle += 1
                
                if findPri:
                    if full:
                        pw = re.compile(r'(\b%s(?!>)\b)(.)' % primWord, re.I)
                    else:
                        pw = re.compile(r'\b(%s(?!>))(\w*)' % primWord, re.I)
                                       
                    line = pw.sub(r'<font color="#990000"><b>\1</b></font>\2', line)
                    
                    # Put tags back in
                    if '<t>' in line:
                        line = re.sub(r'<t>', self.InsertTag, line)
                        
                    temp[set][indexPri] = line
                    
                    #grp = temp[set][:]
                    #for vs in grp:
                    #    if not 'bgcolor=' in vs:
                    #        temp[set].remove(vs)
                    
                    if temp[set] not in self.proxMatch:
                        self.proxMatch.append(temp[set])
                    
        
        matches = len(self.proxMatch)

        if matches == 0:
            return u'''<font face="%s" color="#000066"><center><b>No matches found.</b><br><br>Check spelling, increase range,
            or choose a different word.</center><br></font>''' % fface, 'None', '0', 'Not Found'
        
        next, distance, ref = self.proxNext(0, primWord, secWL, span, fface, abbr, rangeStr, fName)
        
        return next, matches, distance, ref


    def	proxNext(self, next, primWord, secWL, span, fface, abbr, rangeStr, fName = 0):
        #Find distance between keywords
        words = []
        wordsIdx = []
        distList = []
        primIdx = 0
        
        #print len(self.proxMatch), 'pm len'
                
        lineNum = 1
        lineIdx = 0
        for line in self.proxMatch[next]:

            line = line.replace('_', ' ')

            line = line.replace('\t', ' ')

            
            if lineNum == len(self.proxMatch[next]) /2 +1:
                ref = re.search(r'.\w\w \d+:\d+', line).group(0)

            
            line = re.sub(r'.\w\w \d+:\d+|&nbsp;|[().,:;?!"-\']|<.*?>', '', line)



            line = line.lower()
            lineList = line.split()
            
            if lineNum == len(self.proxMatch[next]) /2 +1:
                for wd in lineList:
                    if wd.startswith(primWord.lower()):
                        primIdx = lineList.index(wd) + lineIdx
            
            lineIdx += len(lineList)
            
            for word in lineList:
                words.append(word)
            
            lineNum += 1
        

        for wd in secWL:
            for word in words:
                if wd.lower() in word:
                    wordsIdx.append(words.index(word))
        
        for idx in wordsIdx:
            if int(primIdx) > int(idx):
                distList.append(int(primIdx) - int(idx))
            else:
                distList.append(int(idx) - int(primIdx))
                
                
        grp = self.proxMatch[next][:]
        for vs in grp:
            if not 'bgcolor=' in vs:
                self.proxMatch[next].remove(vs)
                
                
        result = '<tr><td></td></tr>'.join(self.proxMatch[next])
        #print result.encode('utf-8')
 
        result = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', result)

        if 'embNote' in result:
            result = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', result)
            result = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', result)
            
        if '<fn>' in result:
            result = re.sub(r'<fn>\d+?</fn>', r'', result)
            
        #print result


        #print result.encode('utf-8')

        origFace = fface
        result, fface = utility.CheckOldFont(fName, result, fface)
        
        #print result.encode('utf-8')

        answer = '''<body bgcolor="%s" link="#336666"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s"><b>Near Proximity Search,</b> &nbsp;<b>%s</b> (%s)<br>Between <font color="#990000">
        <b>%s</b></font> and <font color="#990000"><b>%s,</b></font><br>Range of <font color="#990000"><b>%d</b></font> 
        verses</font></td></tr></table><br><br><table cellpadding="5" cellspacing="0"><tbody><font face="%s">%s</font></tbody></table>'''\
        % (self.mainApp.resColor, self.mainApp.resHeadColor, origFace, abbr, rangeStr, primWord,\
        ', '.join(secWL), span, fface, result), distList, ref

        return answer 

