import wx, os, re, cPickle



refmatches = {
    "Ge":"Gen",  "Ex":"Exo",  "Le":"Lev",  "Nu":"Num",  "De":"Deu",  "Jos":"Jos",
    "Judg":"Jdg",  "Ru":"Rth",  "1 ?Sa":"1Sa",  "2 ?Sa":"2Sa",  "1 ?Ki":"1Ki",  "2 ?Ki":"2Ki",
    "1 ?Ch":"1Ch",  "2 ?Ch":"2Ch",  "Ezr":"Ezr",  "Ne":"Neh",  "Es":"Est",  "Job":"Job",
    "Ps":"Psa",  "Pr":"Pro",  "Ec":"Ecc",  "So":"Son",  "Is":"Isa",  "Je":"Jer",
    "La":"Lam", "Eze":"Eze", "Da":"Dan",  "Ho":"Hos", "Joe":"Joe",  "Am":"Amo",
    "Ob":"Oba",  "Jon":"Jon", "Mi":"Mic",  "Na":"Nah",  "Hab":"Hab",  "Zep":"Zep",
    "Hag":"Hag",  "Zec":"Zec",  "Mal":"Mal", "Jgs":"Jdg", "(?<!1\s])Jn": "Joh", 
    "Mat":"Mat",  "Mar":"Mar",  "Lu":"Luk",  "(?<!1\s])Joh": "Joh",  "Ac":"Act",  "Ro":"Rom",
    "1 ?Co":"1Co",  "2 ?Co":"2Co",  "Ga":"Gal",  "Ep":"Eph",  "Phi":"Phi", "Col":"Col",
    "1 ?Th":"1Th",  "2 ?Th":"2Th",  "1 ?Ti": "1Ti",  "2 ?Ti": "2Ti",  "Tit": "Tit", "He": "Heb",
    "Ja": "Jam", "1 ?Pe":"1Pe", "2\s?Pe":"2Pe", "1 ?Jo":"1Jo", "2\s?Jo": "2Jo",  "3\s?Jo":"3Jo",
    "Jud": "Jud","Re": "Rev", "Mt":"Mat", "Mk":"Mar", "Lk":"Luk", "(?<!1\s])Jn":"Joh",  "Jas":"Jam",
    "1 ?Kgs":"1Ki",  "2 ?Kgs":"2Ki", "1 ?Jn":"1Jo",  "2 ?Jn":"2Jo", "3 ?Jn":"3Jo",
    "Phm":"Phm", "Phile":"Phm", "Jdg":"Jdg", "1S":"1Sa", "2S":"2Sa", "1K":"1Ki", "2K":"2Ki",
    "1P":"1Pe", "2P":"2Pe", "1J":"1Jo", "2J":"2Jo", "3J":"3Jo"
    }





f = 'D:\\Scripts\Audio-KJV\\'

pathsTmp = []
audioPaths = {}
    
def parseAudioFolder():
    for root, dirs, files in os.walk(f):
        for fn in files:
            if fn.endswith('.mp3'):
                pathsTmp.append('%s\%s' % (root, fn))
                    
def sortAudioPaths():  
    for pth in pathsTmp:
        for book in refmatches:
            hit = re.search(book + '\w*[ -](\d+)', pth)
            if hit:
                digits = hit.group(1)
                
                while digits[0] == '0':
                    digits = digits[1:]
                
                ref = '%s %s' % (refmatches[book], digits)
                audioPaths[ref] = pth
                    

parseAudioFolder()
sortAudioPaths()


pFile = file('audioPaths.dat', 'wb')
cPickle.dump(audioPaths, pFile)
pFile.close()




