import os, re, wx, controlMini
import wx.media
from time import sleep

#import  wx.lib.filebrowsebutton as fbrowse



class HymnPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.mainApp = wx.GetApp().GetTopWindow()

        self.hymnPath = self.mainApp.allUsersDir + r'/modules/audio/'


        #self.audioFileList = [] #self.mainApp.audioList
        #self.audioTitleList = [] #self.mainApp.audioTitleList
        
        self.title = 'None'
                
        #try:
        #    if 'XP' in wx.GetOsDescription():
         #       self.mc = wx.media.MediaCtrl(self, style=wx.SIMPLE_BORDER)
         #   else:    
        self.mc = wx.media.MediaCtrl(self, style=wx.SIMPLE_BORDER)#, szBackend = wx.media.QUICKTIME )
        #except:
        #    self.mc = None

            

        self.folderPath = wx.TextCtrl(self, -1)

        browseButton = wx.Button(self, -1, 'Browse', size=(60, -1))
        
        hymnButton = wx.Button(self, -1, 'H', size=(30, -1))
        sermonButton = wx.Button(self, -1, 'S', size=(30, -1))

        hymnButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0))
        hymnButton.SetForegroundColour(wx.Colour(128, 0, 0))
        #sermonButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0))
        sermonButton.SetForegroundColour(wx.Colour(128, 0, 0))
        
        browseButton.SetToolTipString(' Browse for Audio Folder')

        hymnButton.SetToolTipString(' Load Hymn Folder')
        sermonButton.SetToolTipString(' Load Sermon Folder')
        
        self.audLB = wx.ListBox(self, -1, (80, 50), wx.DefaultSize, '', style=wx.LB_EXTENDED )
        

        self.timeLabel = wx.StaticText(self, -1, "")

        #self.volSlider = wx.Slider(self, -1, 8, 0, 10, size=(100, 20), style=wx.SL_AUTOTICKS)
        
        self.posSlider = wx.Slider(self, -1, 0, 0, 0, size=(150, 20))
        self.Bind(wx.EVT_SLIDER, self.OnSeek, self.posSlider)


        
        playButton = wx.Button(self, -1, 'Play', size=(50, 22))

        self.pauseButton = wx.ToggleButton(self, -1, '||', size=(22, 22))

        stopButton = wx.Button(self, -1, 'Stop', size=(50, 22))

        

        self.playAll = wx.CheckBox(self, -1, 'Play All From First Selected')

        

        self.playAll.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.timeLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        playButton.SetForegroundColour(wx.Colour(35, 35, 142))

        stopButton.SetForegroundColour(wx.Colour(35, 35, 142))
        
        self.Bind(wx.EVT_BUTTON, self.onPlay, playButton)

        self.Bind(wx.EVT_BUTTON, self.onStop, stopButton)

        self.Bind(wx.EVT_BUTTON, self.OnBrowse, browseButton)

        self.Bind(wx.EVT_BUTTON, self.OnHymnFolder, hymnButton)
        self.Bind(wx.EVT_BUTTON, self.OnSermonFolder, sermonButton)

        self.Bind(wx.EVT_TOGGLEBUTTON, self.onPause, self.pauseButton)
        self.Bind(wx.media.EVT_MEDIA_LOADED, self.Play)
        self.Bind(wx.media.EVT_MEDIA_FINISHED, self.onFinished)

        #self.Bind(wx.EVT_COMMAND_SCROLL, self.setVolume, self.volSlider)
        self.Bind(wx.EVT_LISTBOX, self.OnLBClick, self.audLB)
                
        self.timer = wx.Timer(self)
        self.Bind(wx.EVT_TIMER, self.OnTimer)
        self.timer.Start(100)
        
        self.hymnSizer = wx.BoxSizer(wx.VERTICAL)

        self.browseSizer = wx.BoxSizer(wx.HORIZONTAL)

        self.buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        title = controlMini.FMTitlePanel(self, "Midi/Mp3 Audio Player")
        self.hymnSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)

        self.browseSizer.Add(self.folderPath, 1, wx.EXPAND)

        self.browseSizer.Add(browseButton, 0, wx.LEFT, 5)

        self.browseSizer.Add(hymnButton, 0, wx.LEFT, 5)
        self.browseSizer.Add(sermonButton, 0, wx.LEFT, 5)

        self.hymnSizer.Add(self.browseSizer, 0, wx.ALIGN_CENTER|wx.EXPAND|wx.ALL, 5)
        self.hymnSizer.Add(self.audLB, 1, wx.EXPAND|wx.LEFT|wx.RIGHT, 5)

        self.hymnSizer.Add(self.playAll, 0, wx.ALIGN_CENTER|wx.TOP, 3)        

        #self.hymnSizer.Add(self.volLabel, 0, wx.ALIGN_CENTER|wx.TOP, 5)

        #self.hymnSizer.Add(self.volSlider, 0, wx.ALIGN_CENTER|wx.TOP, 2)

        

        self.buttonSizer.Add(playButton, 0, wx.RIGHT, 6)

        self.buttonSizer.Add(self.pauseButton, 0, wx.RIGHT, 6)

        self.buttonSizer.Add(stopButton, 0, wx.ALIGN_CENTER, 0)

        self.hymnSizer.Add(self.buttonSizer, 0, wx.ALIGN_CENTER|wx.TOP, 10)
        
        self.hymnSizer.Add(self.timeLabel, 0, wx.ALIGN_CENTER|wx.TOP, 10)
        self.hymnSizer.Add(self.posSlider, 0, wx.ALIGN_CENTER|wx.TOP, 2)

        
        self.SetSizer(self.hymnSizer)
        self.Layout()

        
        self.LoadTitles(self.mainApp.audioPath)

        self.folderPath.SetValue(self.mainApp.audioPath)


    

    def OnHymnFolder(self, event):

        if self.mc.GetState() == 2:
            dlg = wx.MessageDialog(self.mainApp, 'You must stop playing the current selection to change folders.',
                'Bible Analyzer Audio Player Notice', wx.OK | wx.ICON_INFORMATION ) 
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        self.LoadTitles(self.hymnPath)
        self.mainApp.audioPath = self.hymnPath


    def OnSermonFolder(self, event):
        if self.mc.GetState() == 2:
            dlg = wx.MessageDialog(self.mainApp, 'You must stop playing the current selection to change folders.',
                'Bible Analyzer Audio Player Notice', wx.OK | wx.ICON_INFORMATION ) 
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        self.LoadTitles(self.hymnPath + r'/sermon')
        self.mainApp.audioPath = self.hymnPath + r'/sermon'



    def OnBrowse(self, event):

        path = self.mainApp.audioPath
        if self.folderPath.GetValue():
            print self.folderPath.GetValue(), 'folderPath'
            path = self.folderPath.GetValue()

        dialog = wx.DirDialog(self,

        message = 'Select a folder to play audio files.',
        defaultPath = path,
        style = wx.DD_DIR_MUST_EXIST)

        if dialog.ShowModal() == wx.ID_OK:

            self.folderPath.SetValue(dialog.GetPath())

            self.LoadTitles(dialog.GetPath())
            self.mainApp.audioPath = dialog.GetPath()

        dialog.Destroy()



    

    def LoadTitles(self, path):
        if not os.access(path, 1):
            print 'not'
            path = self.mainApp.allUsersDir + r'/modules/audio/'
        

        self.audioFileList = []

        self.audioTitleList = []

        self.audLB.Clear()

        for fn in os.listdir(path):

            if fn.endswith('mid') or fn.endswith('mp3') or fn.endswith('wav'):

                self.audioFileList.append(path + r'/' + fn)

                title = os.path.basename(fn)

                self.audLB.Append(title[:-4])

                self.audioTitleList.append(title[:-4])

    
    

    def OnLBClick(self, event):
        self.title = event.GetString()
        

    def OnSeek(self, evt):
        if not self.mc:
            return

        offset = self.posSlider.GetValue()
        self.mc.Seek(offset)

    def OnTimer(self, evt):
        if not self.mc:
            return

        offset = self.mc.Tell()
        self.posSlider.SetValue(offset)
        self.timeLabel.SetLabel('%d of %d sec.' % (offset/1000, self.mc.Length()/1000))
        self.GetSizer().Layout()
        
        if self.mc.GetState() == 2: 
            #try:
            self.statText = 'Playing: %s - %d of %d sec.' % (self.audioTitleList[self.selected[self.cycle]], offset/1000, self.mc.Length()/1000)
            self.mainApp.statusbar.SetStatusText(self.statText, 0)
            #except:
            #    print 'audio timer error, #175'
            #    pass


    def setVolume(self, event):

        vol = float(self.volSlider.GetValue()) /10
        self.mc.SetVolume(vol)
        
    

    def onPlay(self, event):
        if not self.mc:
            self.mediaError()
            return
        
        self.cycle = 0
        selected = self.audLB.GetSelections()

        self.selected = list(selected)
        self.selected.sort()

        if not self.selected:

            dlg = wx.MessageDialog(self, 'You need to select at least one audio file. \n',

'No File(s) Selected', wx.OK | wx.ICON_INFORMATION	)

            dlg.ShowModal()
            dlg.Destroy()

            return

        

        if self.playAll.GetValue() == True:

            sel = self.selected[0]
            self.selected = []
            count = self.audLB.GetCount()
            for num in range(sel, count):

                self.selected.append(num)

        

        self.title = self.audioTitleList[self.selected[self.cycle]]
        fn = self.audioFileList[self.selected[self.cycle]]
        self.pauseButton.SetValue(False)

        

        print fn
        
        self.mc.Load(fn)
        
        self.posSlider.SetRange(0, self.mc.Length())
        
    

    def playNext(self):
        if self.cycle > len(self.selected) -1:
            self.mainApp.statusbar.SetStatusText("Sanctify them through thy truth...", 0)
            return
        
        fn = self.audioFileList[self.selected[self.cycle]]
        self.mc.Load(fn)
        
        if self.playAll.GetValue() == True:        
            self.title = self.audioTitleList[self.selected[self.cycle]]
            self.audLB.Deselect(self.selected[self.cycle -1])
            self.audLB.SetStringSelection(self.title)
            self.audLB.ScrollLines(1)
            
            
    def Play(self, evt):
        lth = str(self.mc.Length() /1000) + ' sec.'
        self.mc.Play()
        
        self.posSlider.SetRange(0, self.mc.Length())


    def onFinished(self, event):
        self.cycle += 1
        self.playNext()
        
    def onStop(self, event):
        if not self.mc:
            return


        self.mc.Stop()

        self.mainApp.statusbar.SetStatusText("Sanctify them through thy truth...", 0)



    def onPause(self, event):
        if not self.mc:
            return

        if self.pauseButton.GetValue() == True and self.mc.GetState() == 2:

            self.mc.Pause()

            self.mainApp.statusbar.SetStatusText("Paused: %s" % self.audioTitleList[self.selected[self.cycle]], 0)

        elif self.mc.GetState() == 1:

            if not self.selected == ():

                self.mainApp.statusbar.SetStatusText(self.statText, 0)

                self.mc.Play()

        
        print self.mc.Tell()


    def mediaError(self):
        dlg = wx.MessageDialog(self.mainApp, 'This systen does not appear to have an audio engine installed.\n\
The Bible Analyzer Audio Player will not be able to play audio.',
    'Bible Analyzer Audio Player Error', wx.OK | wx.ICON_INFORMATION    )
        dlg.ShowModal()
        dlg.Destroy()
