import wx, wx.html, re, os
import advSearch, fixRef, utility
import errdlg
#import flatMenu as FM
from urllib import urlopen, urlencode


class NoUnderLineTag(wx.html.HtmlWinTagHandler):
    def __init__(self):
        wx.html.HtmlWinTagHandler.__init__(self)
 
    def GetSupportedTags(self):  
        return "NU"

    def HandleTag(self, tag):
        underlined = self.GetParser().GetFontUnderlined()
        self.GetParser().SetFontUnderlined(False)
        self.GetParser().GetContainer().InsertCell(wx.html.HtmlFontCell(self.GetParser().CreateCurrentFont()))
        
        self.ParseInner(tag)

        self.GetParser().SetFontUnderlined(underlined);
        self.GetParser().GetContainer().InsertCell(wx.html.HtmlFontCell(self.GetParser().CreateCurrentFont()));

        return True

wx.html.HtmlWinParser_AddTagHandler(NoUnderLineTag)

class NewH2Tag(wx.html.HtmlWinTagHandler):
    def __init__(self):
        wx.html.HtmlWinTagHandler.__init__(self)
        
        #print dir(self.GetParser())
 
    def GetSupportedTags(self):  
        return "H2"

    def HandleTag(self, tag):
        bold = self.GetParser().GetFontBold()
        size = self.GetParser().GetFontSize()
        self.GetParser().SetFontBold(False)
        self.GetParser().SetFontSize(5)
        self.GetParser().GetContainer().InsertCell(wx.html.HtmlFontCell(self.GetParser().CreateCurrentFont()))
        self.GetParser().GetContainer().SetAlignHor(1)
        
        self.ParseInner(tag)

        self.GetParser().SetFontBold(bold)
        self.GetParser().SetFontSize(size)
        self.GetParser().GetContainer().InsertCell(wx.html.HtmlFontCell(self.GetParser().CreateCurrentFont()));

        return True

wx.html.HtmlWinParser_AddTagHandler(NewH2Tag)



class IndentLineTag(wx.html.HtmlWinTagHandler):
    def __init__(self):
        wx.html.HtmlWinTagHandler.__init__(self)
 
    def GetSupportedTags(self):  
        return "IND"

    def HandleTag(self, tag):
        parser = self.GetParser()
        #parser.CloseContainer()
        parser.OpenContainer()
        parser.GetContainer().SetIndent(3 * parser.GetCharWidth(), wx.html.HTML_INDENT_LEFT )
        parser.OpenContainer()
        self.ParseInner(tag)
        parser.CloseContainer()
        parser.CloseContainer()
        #parser.OpenContainer()
        
        return True

wx.html.HtmlWinParser_AddTagHandler(IndentLineTag)



class HtmlWindow(wx.html.HtmlWindow):
    def __init__(self, parent, id, style):
        wx.html.HtmlWindow.__init__(self, parent, id, style=style)
                
        self.mainApp = wx.GetApp().GetTopWindow()
               
        self.advSearch = advSearch.primSearch(self)

    def OnLinkClicked(self, link):
        
        mButton = link.GetEvent().GetButton()
        if mButton == 3:
            return
  
        lnk = link.GetHref()       
        print lnk.encode('utf-8'), 'in base'
        
        if 'bibleFN/' in lnk:
            return
        
        elif 'http://' in lnk:
            wx.LaunchDefaultBrowser(lnk)
            
        elif 'dialog://' in lnk:
            type = lnk[9:]
            dlg = utility.ParaBibListDlg(self.mainApp)
            dlg.Show()
            
            
        
        elif 'search://' in lnk:
            # 0-word, 1-fName, 2-abbr, 3-full, 4-opt, 5-case, 6-fface, 7-showRed, 8-redSearch, 9-idxList, 10-exclude,
            # 11-rangeStr, 12-refOnly, 13-resWdList, 14-doRoot, 15-fixedRef
            
            parStr = re.search(r'\[(.*)\]', lnk).group(1)
            parList = parStr.split('; ')
            
            if not parList[0]:
                return
            
            #print parList[0], parList[1], parList[2], eval(parList[3]), eval(parList[4]), eval(parList[5]), parList[6],\
            #eval(parList[7]), eval(parList[8]), eval(parList[9]), parList[10], parList[11], eval(parList[12]),\
            #eval(parList[13]), eval(parList[14]), parList[15]
            
            result, verseList, title, count, findStr, totalHits, exclude, rngRefList = self.advSearch.StdSearch\
            (parList[0], parList[1], parList[2], eval(parList[3]), eval(parList[4]), eval(parList[5]), parList[6],\
            eval(parList[7]), eval(parList[8]), eval(parList[9]), parList[10], parList[11], eval(parList[12]),\
            eval(parList[13]), eval(parList[14]), parList[15], 0)
            
            # Add data to search query list
            temp = [parList[0], parList[1], parList[2], eval(parList[3]), eval(parList[4]), eval(parList[5]), eval(parList[7]),\
            eval(parList[8]), count, findStr, totalHits, exclude, parList[15], rngRefList, eval(parList[9])]
            self.mainApp.searchQList.append(temp)
            
            if self.mainApp.fontSize > 0:
                result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
                
            try:
                title = unicode(title, "utf-8")
            except:
                title = ''
            
            self.mainApp.AddResult(parList[0], title, result)
            self.mainApp.Showing = result
            
            if self.mainApp.getMaximized():
                self.mainApp.mainMgr.RestoreMaximizedPane()
                self.mainApp.mainMgr.MaximizePane(self.mainApp.getResPane())
                self.mainApp.mainMgr.Update()
        

        

        elif 'searchRng://' in lnk:

            # searchRng://AV/1ch/david

            if self.mainApp.toolwin:

                self.mainApp.toolwin.Destroy()

            

            self.mainApp.SearchRngLnk(lnk)

            

       

        elif 'bible://' in lnk: 
            ref = lnk[8:]
            ref = re.sub(r'([a-z])[.](\d+)[.:]?', r'\1_\2:', ref, re.I)
            
            # Need code to check if ref is valid.
            self.mainApp.ShowRefContext(ref)

        elif 'book://' in lnk: 
            #print lnk
            #<a href="book://title/chapter">%s</a>
            parse = re.search(r'book://(.+)', lnk, re.I)
            
            if not parse:
                print 'Bad book link'
                return
            
            if parse.group(1) == 'goNext':
                self.mainApp.cpMini.BookViewer.OnNextChap(None)
                return
            if parse.group(1) == 'goPrev':
                self.mainApp.cpMini.BookViewer.OnPrevChap(None)
                return

            if parse.group(1) == 'goCont':
                #print 'go'
                self.mainApp.cpMini.BookViewer.OnContents()
                return

            bkGroup = parse.group(1)
            bkGroup = re.sub(r'</?b>', '', bkGroup)
            #print bkGroup
            #print bkGroup, 'in base book'
            #print self.mainApp.cpMini.BookViewer.titles
            try:
                self.mainApp.cpMini.BookViewer.Tree.SelectItem(self.mainApp.cpMini.BookViewer.titles[bkGroup])
            except:
                print 'Book title key error, baseClass'


        elif 'dict/' in lnk: 
            #<a href="dict/ABBR://%s">%s</a>
            parse = re.search(r'dict/(.+?)://(.+)', lnk, re.I)
            dctTabName = parse.group(1)
            dctTopic = parse.group(2)#.title()
            
            #print dctTopic, dctTabName

            try:
                tab = self.mainApp.dAbbrList.index(dctTabName)
                if self.mainApp.dctNB.GetSelection() != tab:
                    self.mainApp.dctNB.SetSelection(tab)
                self.mainApp.dctEntry.SetValue(dctTopic)
                if self.mainApp.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
                    if tab != self.mainApp.wordListTab:
                        self.mainApp.GetWordList(tab)
                        
                    self.mainApp.dctListbox.SetItemCount(len(self.mainApp.currentWL))
                    item = self.mainApp.FindDctEntry(self.mainApp.dctEntry.GetValue())
                    if item:
                        self.mainApp.dctListbox.EnsureVisible(item)
                        self.mainApp.dctListbox.Select(item)
                
                self.mainApp.OnDctViewEntry()
                
                if self.mainApp.useMini == False and self.mainApp.getMaximized() and self.mainApp.jumpState == True: 
                    self.mainApp.mainMgr.RestoreMaximizedPane()
                    #self.mainApp.mainMgr.MaximizePane(self.mainApp.getDctPane())
                    self.mainApp.Freeze()
                    self.mainApp.mainMgr.Update()
                    self.mainApp.Thaw()
                
            except:
                dlg = wx.MessageDialog(self.mainApp, 'The %s Dictionary or %s Topic was not found.\n\
The %s Dictionary must be loaded and the %s Topic available for this link to work.' % (dctTabName, dctTopic, dctTabName, dctTopic),
                '%s Module Not Found' % dctTabName, wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()

        elif 'comm/' in lnk: 
            #<a href="comm/ABBR://%s">%s</a>
            parse = re.search(r'comm/(.+?)://(.+)', lnk, re.I)
            cmtTabName = parse.group(1)
            cmtTopic = parse.group(2)
            
            try:
                tab = self.mainApp.cAbbrList.index(cmtTabName)
                if tab in self.mainApp.hitList:
                    cmtTopic = self.mainApp.hitList[tab]

                if self.mainApp.cmtNB.GetSelection() != tab +1:
                    self.mainApp.cmtNB.SetSelection(tab +1)
                    self.mainApp.cmtTabIdx = self.mainApp.cmtNB.GetSelection()

                self.mainApp.cmtEntry.SetValue(cmtTopic)
                if self.mainApp.cmtNB.cmtPanel.miniTB.GetToolToggled(707) == True:
                    if tab != self.mainApp.wordListTab:
                        self.mainApp.GetVerseList(tab)
                        
                    self.mainApp.cmtListbox.SetItemCount(len(self.mainApp.currentVL))
                    item = self.mainApp.FindCmtEntry(self.mainApp.cmtEntry.GetValue())
                    if item:
                        self.mainApp.cmtListbox.EnsureVisible(item)
                        self.mainApp.cmtListbox.Select(item)
                
                self.mainApp.OnCmtViewEntry()
            except:
                dlg = wx.MessageDialog(self.mainApp, 'The %s Commentary or %s Comments was not found.\n\
The %s Commentary must be loaded and the %s Comments available for this link to work.' % (cmtTabName, cmtTopic, cmtTabName, cmtTopic),
                '%s Module Not Found' % cmtTabName, wx.OK | wx.ICON_INFORMATION )
                dlg.ShowModal()
                dlg.Destroy()
        
        elif 'commFN/' in lnk: 
            parse = re.search(r'commFN/(.+?)/(.+?)://(.+)', lnk, re.I)
            abbr = parse.group(1)
            ref = self.mainApp.GetVsInCmtRange(abbr, parse.group(2), 1)

            #print abbr, ref, 'abbr base'
            
            try:
                tab = self.mainApp.cAbbrList.index(abbr) +1
            except ValueError:
                #print 'Valuerror base'
                try:
                    tab = self.mainApp.cAbbrList.index('NET-') +1
                except ValueError:
                    print '%s Cmt not found' % abbr
                    return

            self.mainApp.cmtTab = tab
            self.mainApp.cmtNB.SetSelection(tab)
            self.mainApp.OnCmtNBChanged(None)
            self.mainApp.cmtEntry.SetValue(ref)
            self.mainApp.OnCmtViewEntry(True)
            
        elif 'embNote/' in lnk:
            #parse = re.search(r'embNote/(.+)', lnk, re.I)
            return

        else:
            super(HtmlWindow, self).OnLinkClicked(link)



class VirtDctList(wx.ListCtrl):
    def __init__(self, parent):
        wx.ListCtrl.__init__(self, parent, -1, style=wx.LC_REPORT|wx.LC_VIRTUAL|wx.LC_NO_HEADER|wx.LC_SINGLE_SEL|wx.BORDER_THEME) # |wx.LC_HRULES)
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.attr = wx.ListItemAttr()
        self.attr.SetBackgroundColour(wx.Colour(255,235,235))

    def OnGetItemText(self, item, col):
        return self.mainApp.currentWL[item]

    
    def OnGetItemAttr(self, item):
        if item % 2 == 1:
            return self.attr
        else:
            return None



class VirtCmtList(wx.ListCtrl):
    def __init__(self, parent):
        wx.ListCtrl.__init__(self, parent, -1, style=wx.LC_REPORT|wx.LC_VIRTUAL|wx.LC_NO_HEADER|wx.LC_SINGLE_SEL|wx.BORDER_THEME  ) #|wx.LC_HRULES|wx.LC_VRULES
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.attr = wx.ListItemAttr()
        self.attr.SetBackgroundColour(wx.Colour(255,230,230))

    def OnGetItemText(self, item, col):
        return self.mainApp.currentVL[item]


    def OnGetItemAttr(self, item):
        if item % 2 == 1:
            return self.attr
        else:
            return None



#class CustomTreeCtrl(CusTree.CustomTreeCtrl):
class CustomTreeCtrl(wx.TreeCtrl):

    def __init__(self, parent, id=wx.ID_ANY, pos=wx.DefaultPosition, size=wx.DefaultSize, 
    style=wx.TR_HAS_BUTTONS|wx.TR_LINES_AT_ROOT|wx.TR_HIDE_ROOT|wx.TR_DEFAULT_STYLE|wx.BORDER_THEME):
        wx.TreeCtrl.__init__(self, parent, id, pos, size, style)
    
    #style=CusTree.TR_HAS_BUTTONS|CusTree.TR_HIDE_ROOT|CusTree.TR_DEFAULT_STYLE|wx.BORDER_THEME):
        #CusTree.CustomTreeCtrl.__init__(self, parent, id, pos, size, style)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        
        #Create Bible tree
        self.books = {
            'Gen':'51', 'Exo':'41', 'Lev':'28', 'Num':'37', 'Deu':'35', 'Jos':'25', 'Jdg':'22', 'Rth':'5', '1Sa':'32',
            '2Sa':'25', '1Ki':'23', '2Ki':'26', '1Ch':'30', '2Ch':'37', 'Ezr':'11', 'Neh':'14', 'Est':'11', 'Job':'43',
            'Psa':'151', 'Pro':'32', 'Ecc':'13', 'Son':'9', 'Isa':'67', 'Jer':'53', 'Lam':'6', 'Eze':'49', 'Dan':'13',
            'Hos':'15', 'Joe':'4', 'Amo':'10', 'Oba':'2', 'Jon':'5', 'Mic':'8', 'Nah':'4', 'Hab':'4', 'Zep':'4',
            'Hag':'3', 'Zec':'15', 'Mal':'5', 'Mat':'29', 'Mar':'17', 'Luk':'25', 'Joh':'22', 'Act':'29', 'Rom':'17',
            '1Co':'17', '2Co':'14', 'Gal':'7', 'Eph':'7', 'Phi':'5', 'Col':'5', '1Th':'6', '2Th':'4', '1Ti':'7',
            '2Ti':'5', 'Tit':'4', 'Phm':'2', 'Heb':'14', 'Jam':'6', '1Pe':'6', '2Pe':'4', '1Jo':'6', '2Jo':'2',
            '3Jo':'2', 'Jud':'2', 'Rev':'23',}
        self.order = [
            'Gen', 'Exo', 'Lev', 'Num', 'Deu', 'Jos', 'Jdg', 'Rth', '1Sa', '2Sa', '1Ki', '2Ki', '1Ch', '2Ch',
            'Ezr', 'Neh', 'Est', 'Job', 'Psa', 'Pro', 'Ecc', 'Son', 'Isa', 'Jer', 'Lam', 'Eze', 'Dan', 'Hos',
            'Joe', 'Amo', 'Oba', 'Jon', 'Mic', 'Nah', 'Hab', 'Zep', 'Hag', 'Zec', 'Mal', 'Mat', 'Mar', 'Luk',
            'Joh', 'Act', 'Rom', '1Co', '2Co', 'Gal', 'Eph', 'Phi', 'Col', '1Th', '2Th', '1Ti', '2Ti', 'Tit',
            'Phm', 'Heb', 'Jam', '1Pe', '2Pe', '1Jo', '2Jo', '3Jo', 'Jud', 'Rev']
        
        self.apocBooks = {
            '1Es':'10', '2Es':'17', 'Tob':'15', 'Jth':'17', 'RoE':'7', 'Wis':'20', 'Ecs':'52', 'Bar':'7',
            'SoC':'2', 'Sus':'2', 'Bel':'2', 'PoM':'2', '1Ma':'17', '2Ma':'16'}

        self.apocOrder = [
            '1Es', '2Es', 'Tob', 'Jth', 'RoE', 'Wis', 'Ecs', 'Bar', 'SoC', 'Sus', 'Bel', 'PoM', '1Ma', '2Ma']

        self.apocOrder.reverse()
        self.apocBkList = []

        self.chapId = {}
        self.bookId = {}
        self.item = None
        self.menu = None
       
        self.root = self.AddRoot('Top')
        #self.EnableSelectionVista(True)
        
        try:
            if parent == self.mainApp:
                self.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)
                self.Bind(wx.EVT_RIGHT_DOWN, self.OnRightDown)
        except:
            pass
        
        for book in self.order:
            child = self.AppendItem(self.root, book)
            if book == 'Mat':
                ntId = child
            self.bookId[book] = child
            self.SetItemBold(child, True)
           
            num = 1
            value = int(self.books[book])
            for z in range(1, value):
                item = self.AppendItem(child, "%d" % z)
                self.chapId[book+str(num)] = item
                num = num + 1

    def addApoc(self):
        for book in self.apocOrder:
            child = self.InsertItemBefore(self.root, 39, book)
            self.bookId[book] = child
            self.SetItemBold(child, True)
            self.SetItemTextColour(child, wx.NamedColour('Brown'))
            self.apocBkList.append(child)
           
            num = 1
            value = int(self.apocBooks[book])
            for z in range(1, value):
                item = self.AppendItem(child, "%d" % z)
                self.chapId[book+str(num)] = item
                num = num + 1

    def delApoc(self):
        for child in self.apocBkList:
            self.DeleteChildren(child)
            self.Delete(child)
            
            self.apocBkList = []

    
    def OnRightDown(self, event):
        #So click won't make selection
        pass


    def OnRightUp(self, event):
        pt = event.GetPosition()
        item, flags = self.HitTest(pt)
        
        if not item:
            event.Skip()
            return

        parent = self.GetItemParent(item)
        
        if parent == self.GetRootItem():
            self.label = self.GetItemText(item)
            
            try:
                chaps = int(self.books[self.label]) -1
            except:
                chaps = int(self.apocBooks[self.label]) -1
        else:
            return
               
        self.menu = wx.Menu()
        idx = 0
        for num in range(1, chaps +1):
            if idx % 15 == 0:
                self.menu.Break()

            id = wx.NewId()
            self.menu.Append(id, str(num), "", wx.ITEM_NORMAL)
            self.mainApp.Bind(wx.EVT_MENU, self.OnChapter, id=id)
            idx += 1
               
        self.mainApp.PopupMenu(self.menu)
        self.menu.Destroy()        
    
    def OnChapter(self, event):
        id = event.GetId()
        chap = self.menu.FindItemById(id).GetLabel()
        ref = '%s %s:' % (self.label, chap)
        
        self.mainApp.currentRef = ref
        self.mainApp.currentChap = ref[:3]
        
        self.mainApp.OnChapDisplay(ref)
        
        #if self.mainApp.para.GetValue() == False:
        self.mainApp.ClearCmtTabs()
        self.mainApp.FlagCmtTabs(ref)

        if self.mainApp.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            self.mainApp.OnCmtNBChanged(None)
        
        self.mainApp.noTreeProcess = 1
        self.mainApp.Tree.SelectItem(self.mainApp.Tree.bookId[self.label])
        self.mainApp.noTreeProcess = 0

        

        self.mainApp.cmtNB.cmtPanel.miniTB.ToggleTool(711, False)

        self.mainApp.cmtNB.cmtPanel.miniTB.ToggleTool(715, False)

        self.mainApp.cmtNB.cmtPanel.miniTB.ToggleTool(713, True)
        
        self.mainApp.SetBibFocus(None)
        



## Error Reporter Dialog
class ErrorDialog(errdlg.ErrorDialog):
    def __init__(self, msg):
        errdlg.ErrorDialog.__init__(self, None, title=("Bible Analyzer Error Report"), message=msg)
        self.SetDescriptionLabel(("An Error Has Occured - Please Report It.."))
        self.gui = wx.GetTopLevelWindows()[0]

    def Abort(self):
        pass
        #self.gui.util.prompt_for_save(self.gui.Destroy)

    def GetProgramName(self):
        return "Bible Analyzer " + wx.GetTopLevelWindows()[0].version

    def Send(self):
        """Send the error report. PHP script calls isset($_POST['submitted'])"""
        params = urlencode({'subject': "Bible Analyzer Crash Report " + wx.GetTopLevelWindows()[0].version,
                            'message': self._panel.err_msg,
                            'desc': self._panel.action.GetValue(),
                            'email': self._panel.email.GetValue()})
        f = urlopen("http://www.bibleanalyzer.com/bug_report.php", params)


def ExceptionHook(exctype, value, trace):
    print 'excepthook'
    print
    
    ftrace = ErrorDialog.FormatTrace(exctype, value, trace)
    print ftrace  # show in console

    if ErrorDialog.ABORT:
        os._exit(1)
    if not ErrorDialog.REPORTER_ACTIVE and not ErrorDialog.ABORT:
        dlg = ErrorDialog(ftrace)
        dlg.ShowModal()
        dlg.Destroy()


