# -*- coding: utf-8 -*-

import difflib, re, wx, zlib
import spelling, fixRef, utility
import sqlite3 as sqlite


def wordDiff(idxList, fName1, fName2, punct, case, spell, compound, fface, rangeStr, fromLength = 0):
    mainApp = wx.GetApp().GetTopWindow()
    
    def findVerses(ref, line1, line2):
        if '<a href' in line1:
            line1 = re.sub(r'<a href="embNote.+?</a>', r'', line1)

        line1 = re.sub(r'¶|<fnc?>.+?</fnc?>|<.*?>', r'', line1)
        if punct == 1:
            line1 = re.sub(r'[¶().,:;?!"-\'\[\]]', '', line1)
        if case == 1:
            line1 = line1.lower()
        mod1.extend(line1.split(None))
        
        if '<a href' in line2:
            line2 = re.sub(r'<a href="embNote.+?</a>', r'', line2)
        line2 = re.sub(r'¶|<fnc?>.+?</fnc?>|<.*?>', r'', line2)
        
        if punct == 1:
            line2 = re.sub(r'[¶().,:;?!"-\'\[\]]', '', line2)
        if case == 1:
            line2 = line2.lower()
        if spell == 1:
            line2 = re.sub(ur'ſ', ur's', line2) #Convert long s 'ſ' to 's'
            line2 = re.sub(r'v([^aeio])', r'u\1', line2) #Convert 'v' before non-vowel to 'u'
            line2 = re.sub(r'\bi([aeou])', r' j\1', line2) #Convert 'i' at beg. to 'j'
            line2 = re.sub(r'\bI([aeou])', r' J\1', line2) #Convert 'I' at beg. to 'J'
            line2 = re.sub(r'\bu([aeio])', r' v\1', line2) #Convert 'u' at beg. to 'v'
            line2 = re.sub(r'(\w\w)ie\b', r'\1y', line2) #Convert 'ie at end to 'y'
            line2 = re.sub(r'([aeio])u([aeio])', r'\1v\2', line2) #Convert 'u' between vowels
            line2 = ' ' + line2 + ' '
            line2 = spelling.Spelling(line2)
        if compound == 1:
            line2 = spelling.Compound(line2)
        mod2.extend(line2.split(None))

        l1 = []
        diffList = list(difflib.ndiff(mod1, mod2))
        for item in diffList:
            if item[0] == ' ':
                l1.extend(item[2:] + ' ')
            if item[0] == '-':
                l1.extend('<font color="#000066">-' + item[2:] + '</font> ')
            if item[0] == '+':
                l1.extend('<font color="#660000">+' + item[2:] + '</font> ')
            full = '<td valign="top" bgcolor="#EFEFEF"><font color="#336666">%s,<br></font><font color="#000000">%s</font></td>' % (ref, ''.join(l1))
        
        return full
    
    con1 = sqlite.connect(fName1)
    con1.text_factory = str
    cur1 = con1.cursor() 
    
    con2 = sqlite.connect(fName2)
    con2.text_factory = str
    cur2 = con2.cursor() 
    
    
    encrypt1 = utility.CheckEncrypt(cur1)
    encrypt2 = utility.CheckEncrypt(cur2)

    apocrypha1 = utility.CheckApocrypha(cur1)
    apocrypha2 = utility.CheckApocrypha(cur2)
    
    cur1.execute('SELECT * FROM title',)
    titleRow1 = cur1.fetchone()
    cur2.execute('SELECT * FROM title',)
    titleRow2 = cur2.fetchone()
    
    name1 = utility.CheckEncoding(titleRow1[0])
    name2 = utility.CheckEncoding(titleRow2[0])

    if apocrypha1:
        cur1 = utility.RemoveApocrypha(cur1)
    if apocrypha2:
        cur2 = utility.RemoveApocrypha(cur2)
    
    selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
    if len(idxList) > 1:
        for rng in idxList[1:]:
            selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])

    if encrypt1 == 1:
        hitRows1 = utility.UnEncryptRows(cur1, [], idxList)
    else:
        cur1.execute(selectStr)
        hitRows1 = cur1.fetchall()

    if encrypt2 == 1:
        hitRows2 = utility.UnEncryptRows(cur2, [], idxList)
    else:
        cur2.execute(selectStr)
        hitRows2 = cur2.fetchall()

    
    txt1 = []
    txt2 = []
    out = []
        
    for idx, row1 in enumerate(hitRows1):
        row1 = utility.CheckEncryptByHeader(row1)
        #idx = rows1.index(row)
        row2 = hitRows2[idx]
        row2 = utility.CheckEncryptByHeader(row2)
        
        ref = row1[1]
        
        ln1 = '<tr><td valign="top">%s<br>%s</td>' % (row1[1], row1[2])
        ln2 = '<td valign="top">%s<br>%s</td></tr>' % (row2[1], row2[2])
        
        if '<a href' in ln1:
            ln1 = re.sub(r'<a href="embNote.+?</a>', r'', ln1) 
        ln1 = re.sub(r'¶|<fnc?>.+?</fnc?>|\[.*?\]', '', ln1)
            
        if '<a href' in ln2:
            ln2 = re.sub(r'<a href="embNote.+?</a>', r'', ln2) 
        ln2 = re.sub(r'¶|<fnc?>.+?</fnc?>|\[.*?\]', '', ln2)
        
        
        
        mod1 = []
        mod2 = []
        difs = findVerses(ref, row1[2], row2[2])

        if '>-' in difs or '>+' in difs:
            out.append(ln1)
            out.append(difs)
            out.append(ln2)

    addcount = 0
    minuscount = 0
    
    #txt1 = '<br><br>'.join(txt1)
    #txt2 = '<br><br>'.join(txt2)
    out = ''.join(out)
    
    #txt1 = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', txt1)
    #txt2 = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', txt2)
    out = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', out)
    
    if fromLength == 1:
        return out
    
    final = '''<table border="0" cellpadding="8" cellspacing="0"><tbody><tr>
    <td width="%s"><center><b>%s<br></b></center></td>
    <td width="%s"><center><b>Differences<br></b></center></td>
    <td width="%s"><center><b>%s<br></b></center>%s</td></tr></tbody></table>'''\
    % ('33%', name1, '34%', '33%', name2, out)
    
    
    addcount += out.count('+')
    minuscount += out.count('-')
    count = addcount + minuscount
    
    stats = Count(hitRows1, hitRows2, name1, name2, fface)
    
    #abbr = origRef[:3]
    #fRef = fixRef.fullTitle(abbr)
    #fRef = fRef + origRef[3:]

    filt = ''
    if punct == 1: filt = filt + 'Punctuation Filtered, '
    if case == 1: filt = filt + 'Case Filtered, '
    if spell == 1: filt = filt + 'Spelling Filtered, '
    if compound == 1: filt = filt + 'Compound Words Filtered, '
    if filt == '': filt = 'Not Filtered'
                            
    
    answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
    <tr><td bgcolor="%s"><font face="%s"><b>Word Differences in <font color="#660000">%s</font><br>%s / %s,</b>
    %s Differences (%s additions, %s subtractions), <i>(%s)</i></font></td></tr></table><br><br><font face="%s">%s<hr>%s</font>'''
    
    return answer % (mainApp.resColor, mainApp.resHeadColor, fface, rangeStr, name1, name2, count, addcount, minuscount, filt, fface, stats, final)


def searchDiff(word, fName1, fName2, punct, case, spell, compound, fface):
    mainApp = wx.GetApp().GetTopWindow()

    def findVerses(line, line2):
        global ref
        tabIdx = line.find('\t')
        line1 = line[tabIdx:]
        
        ref = line[:tabIdx]
        ref2 = ref.replace(' ', '_')
        ref2 = '<u>%s</u>' % ref2
               
        if punct == 1:
            line1 = re.sub(r'[¶:;,."\'!-?()\[\]]', '', line1)
            line2 = re.sub(r'[¶:;,."\'!-?()\[\]]', '', line2)
        if case == 1:
            line1 = line1.lower()
            line2 = line2.lower()
        
        mod1.extend(line1.split(None))
        
        tabIdx = line2.find('\t')
        line2 = line2[tabIdx:]
            
        if spell == 1:
            line2 = re.sub(r'v([^aeio])', r'u\1', line2) #Convert 'v' before non-vowel to 'u'
            line2 = re.sub(r'\bi([aeou])', r' j\1', line2) #Convert 'i' at beg. to 'j'
            line2 = re.sub(r'\bI([aeou])', r' J\1', line2) #Convert 'I' at beg. to 'J'
            line2 = re.sub(r'\bu([aeio])', r' v\1', line2) #Convert 'u' at beg. to 'v'
            line2 = re.sub(r'(\w\w)ie\b', r'\1y', line2) #Convert 'ie at end to 'y'
            line2 = re.sub(r'([aeio])u([aeio])', r'\1v\2', line2) #Convert 'u' between vowels
            line2 = ' ' + line2 + ' '
            line2 = spelling.Spelling(line2)
        if compound == 1:
            line2 = spelling.Compound(line2)
        
        mod2.extend(line2.split(None))
        
        l1 = []
        diffList = list(difflib.ndiff(mod1, mod2))
        lword = word.lower()
        
        for item in diffList:
            if item[2:] == word:
                if item[0] == ' ':
                    l1.append(item[2:] + ' ')
                if item[0] == '-':
                    l1.append('<font color="#000066"><b>-' + item[2:] + '</b></font> ')
            elif item[2:] == lword:
                if item[0] == ' ':
                    l1.append(item[2:] + ' ')
                if item[0] == '-':
                    l1.append('<font color="#000066"><b>-' + item[2:] + '</b></font> ')
            else:
                if item[0] == ' ':
                    l1.append(item[2:] + ' ')
                elif item[0] == '-':
                    l1.append(item[2:] + ' ')
            full = '<font color="#336666">%s,<br></font><font color="#000000">%s</font><br><br>' % (ref2, ''.join(l1))
        if '-' in full:
            out.append(full)

    dbWord = '%' + word + '%'
    
    con1 = sqlite.connect(fName1)
    con1.text_factory = str
    cur1 = con1.cursor() 
    
    con2 = sqlite.connect(fName2)
    con2.text_factory = str
    cur2 = con2.cursor() 

    encrypt1 = utility.CheckEncrypt(cur1)
    encrypt2 = utility.CheckEncrypt(cur2)

    cur1.execute('SELECT * FROM title',)
    titleRow1 = cur1.fetchone()
    cur2.execute('SELECT * FROM title',)
    titleRow2 = cur2.fetchone()

    if encrypt1 == 1:
        hitRows1 = utility.UnEncryptRows(cur1, [dbWord], [[1, 31102]])
    else:
        cur1.execute('SELECT * FROM bible WHERE verse LIKE ?', (dbWord,))
        hitRows1 = cur1.fetchall()

    name1 = utility.CheckEncoding(titleRow1[0])
    name2 = utility.CheckEncoding(titleRow2[0])

    apocrypha1 = utility.CheckApocrypha(cur1)
    apocrypha2 = utility.CheckApocrypha(cur2)

    if apocrypha1:
        cur1 = utility.RemoveApocrypha(cur1)
    if apocrypha2:
        cur2 = utility.RemoveApocrypha(cur2)


    def getVerse(cur, id, enc):
        cur.execute('SELECT * FROM bible WHERE id = ?', (id,))
        row = cur.fetchone()
        row = utility.CheckEncryptByHeader(row)
        if not row:
            print '%s doesn\'t exist' % id
            return 'NoVerse\tNo Verse'
        
        vsTxt = re.sub(r'<fnc?>.+?</fnc?>|<.+?>', r'', row[2])
        
        #if '<a href' in vsTxt:
        #    vsTxt = re.sub(r'<a href="embNote.+?</a>', r'', vsTxt)

        return  '%s\t%s' % (row[1], vsTxt)

    #text1 = file(fName1).readlines()
    #text2 = file(fName2).readlines()
    
    out = []
    id1 = []
    
    if case == 1:
        word = word.lower()
    
    for row in hitRows1:
        row = utility.CheckEncryptByHeader(row)
        line = re.sub(r'<fnc?>.+?</fnc?>|<.+?>', r'', row[2])
        #if '<a href' in line:
        #    line = re.sub(r'<a href="embNote.+?</a>', r'', line)
                
        find = re.search(r'\b%s\b' % word, line, re.I)
        if find:
            lineIndex = row[0]
            id1.append(lineIndex)
        
    for id in id1:
        print id
        hit1 = getVerse(cur1, id, encrypt1)
        hit2 = getVerse(cur2, id, encrypt2) 
        
        #print hit1.encode('utf-8')
        #print hit2.encode('utf-8')
        
        #if '<a href' in hit1:
        #    hit1 = re.sub(r'<a href="embNote.+?</a>', r'', hit1)
        #if '<a href' in hit2:
        #    hit2 = re.sub(r'<a href="embNote.+?</a>', r'', hit2)

        #hit1 = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', r'', hit1)
        #hit2 = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', r'', hit2)
        
        hit2b = hit2
        if case == 1:
            hit2b = hit2b.lower()
        
        find = re.search(r'\b%s\b' % word, hit2b)
        if not find:
            mod1 = []
            mod2 = []
            findVerses(hit1, hit2)
        

    vCount = len(out)
    count = 0
    out = ''.join(out)
    #out = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', out)

    count += out.count('-')

    filt = ''
    if punct == 1: filt = filt + 'Punctuation Filtered, '
    if case == 1: filt = filt + 'Case Filtered, '
    if spell == 1: filt = filt + 'Spelling Filtered, '
    if compound == 1: filt = filt + 'Compound Words Filtered, '
    if filt == '': filt = 'Not Filtered'
                            
    answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s"><b>Omissions of <font color="#660000">%s, %s</b></font> compared to <font color="#660000"><b>%s</b></font>
        <br><b>%s</b> omissions in <b>%s</b> verses, <i>(%s)</i></font></td></tr></table><br><br><font face="%s">%s</font>'''
    
    return answer % (mainApp.resColor, mainApp.resHeadColor, fface, word, name2, name1, count, vCount, filt, fface, out)
    

def vLength(range, fName1, fName2, comp, fface):
    mainApp = wx.GetApp().GetTopWindow()
    
    def findVerses(line1, line2):
        mod1 = []
        mod2 = []

        tabIdx = line1.find('\t')
        ref = line1[:tabIdx]
        ref = ref.replace(' ', '_')
        ref = '<u>' + ref + '</u>'
        line1 = line1[tabIdx:]

        line1 = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', r'', line1)
        #line1 = re.sub(r'[().,:;?!"-\'\[\]]|<.*?>', '', line1)
        mod1.extend(line1.split(None))
        
        line2 = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', r'', line2)
        #line2 = re.sub(r'[().,:;?!"-\'\[\]]|<.*?>', '', line2)
        tabIdx = line2.find('\t')
        line2 = line2[tabIdx:]

        mod2.extend(line2.split(None))

        l1 = []
        diffList = list(difflib.ndiff(mod1, mod2))
        for item in diffList:
            if item[0] == ' ':
                l1.extend(item[2:] + ' ')
            if item[0] == '-':
                l1.extend('<font color="#000066"><b>-' + item[2:] + '</b></font> ')
            if item[0] == '+':
                l1.extend('<font color="#660000"><b>+' + item[2:] + '</b></font> ')
            full = '<font color="#336666">%s,<br></font><font color="#000000">%s</font><br><br>' % (ref, ''.join(l1))
        
        return full
    
    
    con1 = sqlite.connect(fName1)
    con1.text_factory = str
    cur1 = con1.cursor() 
    
    con2 = sqlite.connect(fName2)
    con2.text_factory = str
    cur2 = con2.cursor() 
    
    cur1.execute('SELECT * FROM title',)
    titleRow1 = cur1.fetchone()
    cur2.execute('SELECT * FROM title',)
    titleRow2 = cur2.fetchone()

    encrypt1 = utility.CheckEncrypt(cur1)
    encrypt2 = utility.CheckEncrypt(cur2)

    title1 = utility.CheckEncoding(titleRow1[0])
    title2 = utility.CheckEncoding(titleRow2[0])

    apocrypha1 = utility.CheckApocrypha(cur1)
    apocrypha2 = utility.CheckApocrypha(cur2)

    if apocrypha1:
        cur1 = utility.RemoveApocrypha(cur1)
    if apocrypha2:
        cur2 = utility.RemoveApocrypha(cur2)


    cur1.execute('SELECT * FROM bible')
    hitRows1 = cur1.fetchall()

    cur2.execute('SELECT * FROM bible')
    hitRows2 = cur2.fetchall()

    num = 1
    final = []
    vs = 0
    for row1 in hitRows1:
        row1 = utility.CheckEncryptByHeader(row1)
        
        vsTxt = row1[2]
        if '<a href' in vsTxt:
            vsTxt = re.sub(r'<a href="embNote.+?</a>', r'', vsTxt)
        
        vsTxt = re.sub(r'[().,:;?!"-\'¶]|<fnc?>.+?</fnc?>|<.*?>|\[.*?\]', '', vsTxt)
        row1 = (row1[0], row1[1], vsTxt)
        
        vs1 = row1[2]
        diff = 0
        
        vs1 = vs1.replace('-', ' ')
        
        hit2 = hitRows2[vs]
        hit2 = utility.CheckEncryptByHeader(hit2)
        vs2 = hit2[2]
        
        vs2 = vs2.replace('-', ' ')
        
        if title2 == 'AV-1611':
            if comp == 1:
                line2 = spelling.preCompound(line2)
                line2 = spelling.Compound(line2)
        
        if '<a href' in vs2:
            vs2 = re.sub(r'<a href="embNote.+?</a>', r'', vs2)
        vs2 = re.sub(r'[().,:;?!"-\'¶]|<fnc?>.+?</fnc?>|<.*?>|\[.*?\]', '', vs2)
        
        len1 = vs1.count(' ')
        len2 = vs2.count(' ')

        line1 = '%s\t%s' % (row1[1], row1[2])
        line2 = '%s\t%s' % (hitRows2[vs][1], vs2)
        
        
        if len2 > len1 + range -1:
            wDiff = findVerses(line1, line2)
            diff = len2 - len1 
            
            answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s" color="#660000"><b>%s</b></font> has <font color="#000066"><b>%s more</b></font>
            words than <font face="%s" color="#660000"><b>%s,</b></font></td></tr></table><br><br>%s<br>'''\
            % (mainApp.resColor, mainApp.resHeadColor, fface, title2, diff, fface, title1, wDiff)
            final.append(answer)
        
        elif len2 < len1 - range +1:
            wDiff = findVerses(line1, line2)
            diff = len1 - len2 
            
            answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
        <tr><td bgcolor="%s"><font face="%s" color="#660000"><b>%s</b></font> has <b>%s less</b>
            words than <font face="%s" color="#660000"><b>%s,</b></font></td></tr></table><br><br>%s<br>''' \
            % (mainApp.resColor, mainApp.resHeadColor, fface, title2, diff, fface, title1, wDiff)
            final.append(answer)
        
        num += 1
        
        vs +=1
    count = len(final)
    
    
    last = '''<font face="%s"><b>Verses with a Wordcount Difference of <font color="#660000">%s</font> or more</b><br>
    <font color="#660000"><b>%s</b></font> compared to <font color="#660000"><b>%s, </b></font><b>%s</b> verses found<hr>
    
    %s</font></font>''' % (fface, range, title2, title1, count, ''.join(final))
    
    return last
    

def Count(rows1, rows2, name1, name2, fface):
    words1, verses1, letters1, italics1 = 0,0,-3,0
    words2, verses2, letters2, italics2 = 0,0,-3,0
        
    for row in rows1:
        line = '%s\t%s' % (row[1], row[2])
        italics1 += line.count('<i>')
        line = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', '', line)
        verses1 += 1
        tempwords = line.split(None)
        words1 += len(tempwords[1:-1])
        letters1 += len( [c for c in line if re.match('[A-Za-z]', c)])
            
    for row in rows2:
        line = '%s\t%s' % (row[1], row[2])
        italics2 += line.count('<i>')
        line = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', '', line)
        verses2 += 1
        tempwords = line.split(None)
        words2 += len(tempwords[1:-1])
        letters2 += len( [c for c in line if re.match('[A-Za-z]', c)])
                           
    match ='''<font face="%s"><br><table border="0" width="200"><tbody>
                <tr><td></td><td><b>%s</b></td><td><b>%s</b></td>
                <tr><td><b>Verses:</b></td><td>%d</td><td>%d</td>
                <tr><td><b>Words:</b></td><td>%d</td><td>%d</td>
                <tr><td><b>Letters:</b></td><td>%d</td><td>%d</td>
                <tr><td><b>Italics:</b></td><td>%d</td><td>%d</td>
                </tbody></table></font>'''

    return match % (fface, name1, name2, verses1, verses2,
                        words1, words2,
                        letters1, letters2,
                        italics1, italics2)
                        
