# -*- coding: utf-8 -*-

import wx, re, os, cStringIO
import toolImg, fixRef, infoWin, PyRTFParser, utility
import normSearch, controlMini, stats
import wx.richtext as rt
#import flatMenu as FM
import sqlite3 as sqlite
import time
tmpDir = os.getcwd()
class ContextMenu:
    def __init__(self, parent):
        self.mainApp = wx.GetApp().GetTopWindow()
        self.parent = parent
        self.CheckWinState = utility.CheckWinState()

    
    def MakeShortMenu(self, popWord):
        try: self.mainApp.toolwin.Destroy()
        except: pass
            
        #self.parent.SetFocus()
        menu = wx.Menu()
        
        self.popTab = self.mainApp.bibNB.GetSelection()
        self.page = self.mainApp.FindFocus()
                
        if '_' in popWord:
            self.popWord = 'Word'
            self.popVerse = popWord.replace('_', ' ')
        else:
            self.popWord = re.sub(ur'[\(\)\.,\';:"?! ]', '', popWord)
            self.mainApp.FlagTabs(self.popWord)
            self.mainApp.dctEntry.SetValue(self.popWord)
            self.popVerse = 'Verse'
            self.popChap = 'Verse'
        
        menu.Append(501, "Select All", "")
        menu.Append(502, "Copy selection", "")
        menu.Append(503, "Export selection to S-Pad/Notes", "")
        #menu.Append(5001, "Copy Verse, " + self.popVerse, "")
        menu.Append(504, "Export " + self.popVerse + " to S-Pad", "")
        #menu.Append(504, "Related Search on " + self.popVerse, "")
        
        menu.Append(505, "Search for " + self.popWord + " in Bible", '')
        menu.Append(506, "Search for " + self.popWord + " in Libraries", "")
        
        
        menu.AppendSeparator()
        #menu.Append(508, "Print this Page", "")
        #menu.AppendSeparator()
        #menu.Append(5014, "Module Information", "")
    
        #self.mainApp.Bind(wx.EVT_MENU, self.PopupCopyVerse, id=5001)
        #self.mainApp.Bind(wx.EVT_MENU, self.PopupPrint, id=508)
        self.mainApp.Bind(wx.EVT_MENU, self.ExportEditor, id=504)
        self.mainApp.Bind(wx.EVT_MENU, self.ExportSelectionShort, id=503)
        self.mainApp.Bind(wx.EVT_MENU, self.mainApp.OnSelectAll, id=501)
        
        self.mainApp.Bind(wx.EVT_MENU, self.OnShortCopy, id=502)
        #self.mainApp.Bind(wx.EVT_MENU, self.OnInfo, id=5014)
        
        self.mainApp.Bind(wx.EVT_MENU, self.PopupSearchWord, id=505)
        self.mainApp.Bind(wx.EVT_MENU, self.PopupSearchLib, id=506)

        if '_' in popWord:
            menu.FindItemById(505).Enable(False)
            menu.FindItemById(506).Enable(False)
        else:
            menu.FindItemById(504).Enable(False)
        
        self.mainApp.PopupMenu(menu)
        menu.Destroy()        
    
        self.popMenu = menu
    
    
    def MakeMenu(self, popWord, ref, bk, lnk = None):
        self.mainApp.popupCheck()
        
        self.popWordDisplay = ''
        if popWord:
            popWord = popWord.strip(' ')
            self.popWordDisplay = re.sub(ur'[“”`().,\';:"?!*+<>\[\]]', '', popWord)
        
        self.popTab = self.mainApp.bibNB.GetSelection()
        self.page = self.mainApp.FindFocus()
                
        # Change popWord if selection
        self.mainApp.OnCopy(None)
        
        if self.mainApp.isSelection == 1:
            sel = wx.TextDataObject()
            if wx.TheClipboard.Open():
                wx.TheClipboard.GetData(sel)
                wx.TheClipboard.Close()
            
            txt = sel.GetText()
            self.selText = txt
            if txt:
                popWord = txt.strip()
                #self.popWordDisplay = re.sub(r'[().,';:"?!]', '', popWord)
                self.popWordDisplay = popWord
                if len(txt) > 15:
                    #txt = re.sub(r'[\(\)\.,\';:"?!]', '', txt)
                    self.popWordDisplay = txt[:12] + '...'
            
        title = self.page.GetName()
        
        if popWord:
            self.topicWord = re.sub(ur'[“”`().,\';:"?!\[\]]', '', popWord).capitalize()
            #self.popWordDisplay = self.popWordDisplay.capitalize()\
            
            if len(self.topicWord) > 12:
                self.topicWordDisplay = self.topicWord[:12] + '...'
            else:
                self.topicWordDisplay = self.topicWord

        
        #self.popWordDisplay = ''
        if ref != None:
            self.popVerse = ref
            if '-' in self.popVerse:
                idx = self.popVerse.find('-')
                self.popVerse = self.popVerse[:idx]
            idx = ref.find(':')
            self.popChap = self.popVerse[:idx] + ':'
            first = self.popVerse[idx+1:]
            
            tabLabel = self.mainApp.bibNB.GetPageText(self.popTab)
            if tabLabel == 'Parallel':
                self.popTab = self.mainApp.bAbbrList.index(self.mainApp.parallelBibClick)
            
            last = normSearch.getVerseRange(ref, self.mainApp.bibFileList[self.popTab])
        else:
            self.popVerse = '...'
            self.popChap = '...'
            
        if popWord == None:
            self.popWordDisplay = '...'
            
        else:
            self.popWord = re.sub(ur'[“”`().,;:"?!\']', '', popWord)
            #self.popWord = popWord
        
        if popWord:
            self.mainApp.FlagTabs(self.topicWord)
            #self.mainApp.dctEntry.SetValue(self.topicWord)
        if ref and not popWord:
            self.mainApp.ClearCmtTabs()            
            self.mainApp.FlagCmtTabs(self.popVerse)
        
        
        menu = wx.Menu()
        sm = wx.Menu()
        smStat = wx.Menu()
        smWList = wx.Menu()
        smWCloud = wx.Menu()
        smDctTitle = wx.Menu()
        smCmtTitle = wx.Menu()
        
        menu.Append(5020, "Select All", "")
        menu.Append(5002, "Copy Selection", "")
        menu.Append(5012, "Export Selection to S-Pad/Notes", "")
        #menu.Append(5001, "Copy Verse, " + self.popVerse, "")
        
        try:
            idx = 0
            for num in range(int(first)+1, int(last)+1):
                if idx % 15 == 0:
                    sm.Break()

                id = wx.NewId()
                sm.Append(id, str(num), "")
                self.mainApp.Bind(wx.EVT_MENU, self.ExportEditor, id=id)
                idx += 1
        except:
            pass
        
        menu.Append(5010, "Export '" + self.popVerse + "' to S-Pad/Notes", "")
        menu.AppendMenu(5011, "Export from " + self.popVerse + " to " + self.popChap, sm)
        menu.Append(5015, "Related Verse Search: " + self.popVerse, "")
        
        menu.AppendSeparator()

        menu.Append(5003, "Search for " + self.popWordDisplay + " in Bible", 'Search for selected word in Current Bible')
        
        if lnk and 'dict/ExLBP://' in lnk:
            self.peoID = re.search(r'//(\d+)', lnk).group(1)
            menu.Append(5025, "Search for %s by ID #%s" %(self.popWordDisplay, self.peoID), 'Search for Person by ID')
        
        menu.Append(5004, "Search for " + self.popVerse + " in Libraries", "Search for selected reference in Dictionary texts")
        menu.Append(5005, "Search for " + self.popWordDisplay + " in Libraries", "")
        
        if popWord and not re.search(r'\d', popWord):
            menu.Append(5085, "AV-Strong Index for " + self.popWordDisplay, "")
        
        menu.AppendSeparator()
        
        smWList.Append(5033, self.popVerse[:3] + " Word List", "")
        smWList.Append(5032, self.popChap + " Word List", "")
        smWList.Append(5031, self.popVerse + " Word List", "")
        
        menu.AppendMenu(5063, "Word List in MultiWindow", smWList)              

        smWCloud.Append(5043, self.popVerse[:3] + " Word Cloud", "")
        smWCloud.Append(5042, self.popChap + " Word Cloud", "")
        #smWCloud.Append(5031, self.popVerse + " Word List", "")
        
        menu.AppendMenu(5073, "Word Cloud in MultiWindow", smWCloud)              

        smStat.Append(5023, "Analyze " + self.popVerse[:3] + " Statistics", "")
        smStat.Append(5022, "Analyze " + self.popChap + " Statistics", "")
        smStat.Append(5021, "Analyze " + self.popVerse + " Statistics", "")
        
        menu.AppendMenu(5053, "Statistics in MultiWindow", smStat)   
        
        menu.Append(5075, "First Mention of %s Words" % self.popVerse, "")
        menu.AppendSeparator()

        menu.Append(5006, "View Refs in MultiWindow", "")
        menu.Append(5013, "View " + self.popVerse + " Context in MW", "")
        
        if popWord:
            self.GetMenuTab = []
            for item in self.mainApp.dctFlagList:
                topic = wx.MenuItem(menu, -1, "Go to " + self.topicWordDisplay + " in " + self.mainApp.dAbbrList[item], "")
                topic.SetBitmap(toolImg.getBlueBookBitmap())
                smDctTitle.AppendItem(topic)
                self.GetMenuTab.append(topic.GetId())
                self.mainApp.Bind(wx.EVT_MENU, self.PopupTitle, topic)
            
            if len(self.GetMenuTab) == 0:
                topic = wx.MenuItem(menu, -1, self.topicWordDisplay + " - Not Found", "")
                smDctTitle.AppendItem(topic)

            menu.AppendMenu(5055, "Dictionary Topics: " + self.popWordDisplay , smDctTitle)

        if ref:
            self.GetCmtMenuTab = []
            for item in self.mainApp.cmtFlagList:
                verse = wx.MenuItem(menu, -1, "Go to " + self.popVerse + " in " + self.mainApp.cAbbrList[item -1], "")
                verse.SetBitmap(toolImg.getGreenBookBitmap())
                smCmtTitle.AppendItem(verse)
                self.GetCmtMenuTab.append(verse.GetId())
                self.mainApp.Bind(wx.EVT_MENU, self.PopupVerse, verse)
            
            if len(self.GetCmtMenuTab) == 0:
                topic = wx.MenuItem(menu, -1, self.popVerse + " - Not Found", "")
                smCmtTitle.AppendItem(topic)

            menu.AppendMenu(5065, "Commentary Entries: " + self.popVerse , smCmtTitle)

        menu.AppendSeparator()
        menu.Append(5009, "Find in Page", "")
        #menu.Append(5008, "Print this Page", "")
        menu.Append(5007, "Print Preview this Page", "")
        
        
        if not title in ['parGen', 'htmlWindow']:
            #print title, 'title'
            #title = '...'
            menu.AppendSeparator()
            menu.Append(5014, title + " Module Info", "")

        #if self.mainApp.currentBible in self.mainApp.interList or self.mainApp.currentBible in self.mainApp.strongsList:
        #    menu.FindItem(5010).Enable(False)
        #    menu.FindItem(5011).Enable(False)
        
        
        if popWord == None:
            menu.FindItemById(5003).Enable(False)
            menu.FindItemById(5005).Enable(False)
            try:
                menu.FindItemById(5085).Enable(False)
            except:
                pass
            #menu.FindItemById(5055).Enable(False)
        
        if ref == None:
            menu.FindItemById(5004).Enable(False)
            menu.FindItemById(5010).Enable(False)
            menu.FindItemById(5015).Enable(False)
            menu.FindItemById(5011).Enable(False)
            menu.FindItemById(5013).Enable(False)
            menu.FindItemById(5053).Enable(False)
            menu.FindItemById(5063).Enable(False)
            menu.FindItemById(5073).Enable(False)
            menu.FindItemById(5075).Enable(False)
        
        #if bk == 1:
        #    menu.FindItem(5014).Enable(False)
            
        if self.mainApp.isSelection == 0:
            menu.FindItemById(5002).Enable(False)
            menu.FindItemById(5012).Enable(False)
        
        nb = self.page.GetGrandParent()
        
        if nb == self.mainApp.bibNB or nb == self.mainApp.resNB:
            menu.FindItemById(5006).Enable(False)
        
        if nb == self.mainApp.resNB:
            menu.FindItemById(5014).Enable(False)
                
        #self.mainApp.Bind(wx.EVT_MENU, self.PopupCopyVerse, id=5001)
        self.mainApp.Bind(wx.EVT_MENU, self.mainApp.OnCopy, id=5002)
        self.mainApp.Bind(wx.EVT_MENU, self.PopupSearchWord, id=5003)
        
        self.mainApp.Bind(wx.EVT_MENU, self.SearchByID, id=5025)
        
        self.mainApp.Bind(wx.EVT_MENU, self.PopupSearchVerse, id=5004)
        self.mainApp.Bind(wx.EVT_MENU, self.PopupSearchLib, id=5005)
        self.mainApp.Bind(wx.EVT_MENU, self.PopupViewRef, id=5006)
        self.mainApp.Bind(wx.EVT_MENU, self.PopupPrintPre, id=5007)
        #self.mainApp.Bind(wx.EVT_MENU, self.PopupPrint, id=5008)
        self.mainApp.Bind(wx.EVT_MENU, self.PageSearch, id=5009)
        self.mainApp.Bind(wx.EVT_MENU, self.ExportEditor, id=5010)
        self.mainApp.Bind(wx.EVT_MENU, self.ExportEditor, id=5011)
        self.mainApp.Bind(wx.EVT_MENU, self.ExportSelection, id=5012)
        self.mainApp.Bind(wx.EVT_MENU, self.ContextMini, id=5013)
        self.mainApp.Bind(wx.EVT_MENU, self.OnInfo, id=5014)
        self.mainApp.Bind(wx.EVT_MENU, self.mainApp.OnSelectAll, id=5020)
        
        self.mainApp.Bind(wx.EVT_MENU, self.OnVerseDetails, id=5021)
        self.mainApp.Bind(wx.EVT_MENU, self.OnRefDetails, id=5022)
        self.mainApp.Bind(wx.EVT_MENU, self.OnBookDetails, id=5023)
        self.mainApp.Bind(wx.EVT_MENU, self.OnRelated, id=5015)

        self.mainApp.Bind(wx.EVT_MENU, self.OnVerseList, id=5031)
        self.mainApp.Bind(wx.EVT_MENU, self.OnRefList, id=5032)
        self.mainApp.Bind(wx.EVT_MENU, self.OnBookList, id=5033)

        self.mainApp.Bind(wx.EVT_MENU, self.OnChapCloud, id=5042)
        self.mainApp.Bind(wx.EVT_MENU, self.OnBookCloud, id=5043)

        self.mainApp.Bind(wx.EVT_MENU, self.OnFirstMention, id=5075)
        self.mainApp.Bind(wx.EVT_MENU, self.OnStrongIndex, id=5085)

        self.mainApp.PopupMenu(menu)
        #menu.Destroy()        
        
        #pos = wx.GetMousePosition()

        #menu.Popup(wx.Point(pos[0], pos[1]+10), self.mainApp)
        self.popMenu = menu
 
 
    def OnStrongIndex(self, event):
        normSearch.strongIndex(self.popWord)


    def OnFirstMention(self, event):
        wx.BusyCursor
        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        try:
            idx, fixedRef = fixRef.parseRng(self.popVerse)
        except:
            self.mainApp.OnRefError()
            return
        wList = stats.wList(idx[0], text, 1, 0, self.mainApp.font, fixedRef, abbr, 2)
        result = normSearch.firstMention(wList, text, fixedRef, self.mainApp.font, abbr)
        
        self.mainApp.OnDictMini(result, 'First Mention', None)
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
        wx.EndBusyCursor
    
    
    def OnVerseList(self, event):
        self.ShowWordList(self.popVerse)
    
    def OnBookList(self, event):
        self.ShowWordList(self.popVerse[:3])

    def OnRefList(self, event):
        self.ShowWordList(self.popChap)

    def ShowWordList(self, ref):
        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        
        try:
            idx, fixedRef = fixRef.parseRng(ref)
        except:
            self.mainApp.OnRefError()
            return
        result = stats.wList(idx[0], text, 1, 0, self.mainApp.font, fixedRef, abbr, 1)
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)

        self.mainApp.OnDictMini(result, '%s Word List' % fixedRef, None, 1)
        
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
        

    def OnBookCloud(self, event):
        self.ShowWordCloud(self.popVerse[:3])

    def OnChapCloud(self, event):
        self.ShowWordCloud(self.popChap)

    def ShowWordCloud(self, ref):
        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        
        try:
            idx, fixedRef = fixRef.parseRng(ref)
        except:
            self.mainApp.OnRefError()
            return
        
        result = stats.wCloud(idx[0], text, 1, 0, self.mainApp.font, fixedRef, abbr)
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
            

        self.mainApp.OnDictMini(result, '%s Word Cloud' % fixedRef, None, 1)
        


    def OnRelated(self, event):
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)        
        self.mainApp.cpMini.LBook.SetSelection(2)
        
        self.mainApp.cpMini.FromPopupRelated(self.popVerse)
        self.mainApp.cpMini.Show()
    
    
    def OnVerseDetails(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]

        try:
            result = stats.sGetVerseDetails(self.popVerse, text, self.mainApp.font, abbr)
            self.mainApp.OnDictMini(result, 'Verse Details', None)
        except:
            print 'Exception: GetVerseDetails'
            return
        
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
        
        
    def OnRefDetails(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        
        idxList = []
        idxGroup, fixedRef = fixRef.parseRng(self.popChap)
        idxList.append(idxGroup)

        try:
            result = stats.sGetRefDetails(idxList[0], text, fixedRef, self.mainApp.font, abbr)
            self.mainApp.OnDictMini(result, '%s Statistics' % self.popChap, None)
        except:
            print 'Exception: GetRefDetails'
            return

        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
        
        
    def OnBookDetails(self, event):
        wx.BeginBusyCursor()

        tab = self.mainApp.bibNB.GetSelection()
        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        
        idxList = []
        idxGroup, fixedRef = fixRef.parseRng(self.popChap[:3])
        idxList.append(idxGroup)

        result = stats.sGetRefDetails(idxList[0], text, fixedRef, self.mainApp.font, abbr)
        self.mainApp.OnDictMini(result, '%s Statistics' % self.popVerse[:3], None)
        wx.EndBusyCursor()
        
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
        
    
    def OnInfo(self, event):
        try:
            nb = self.page.GetGrandParent().GetParent()
            tab = nb.GetSelection()
            self.mainApp.OnInfo(nb, tab)
        except:
            return
        
            
    
    def ContextMini(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        fName = self.mainApp.bibFileList[tab]
        
        try:
            self.chapRef = re.match('(.*:)', self.popVerse) .group(1)
            self.verseRef = re.match('.*:(\d+)', self.popVerse) .group(1)
            popVerse = self.popVerse.replace(' ', '&nbsp;')
        except:
            return
        
        answer = normSearch.nView(self.chapRef, self.verseRef, fName, self.mainApp.font, self.mainApp.showRed, self.mainApp.showText, self.mainApp.showStrongs, self.mainApp.paragraph, 0)
        answer = answer.replace(popVerse + '</u>', '<a name="line"></a><font color="#660000"><b>%s</b></font>' % popVerse + '</u>')
        modAnswer = re.sub(r'&nbsp;(\d)', r'_\1', answer)

        title = "Verse Context Quick Viewer"
        self.mainApp.OnDictMini(modAnswer, title, None, 0, 1)
        
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()
    
    
    def OnShortCopy(self, event):
        try:
            page = self.parent.FindFocus()
            self.do = wx.TextDataObject()
            self.do.SetText(page.SelectionToText())
        except:
            wx.MessageBox("Nothing selected to copy!", "Notice!")
            return
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(self.do)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")

    
    def ExportSelectionShort(self, event):
        if wx.GetKeyState(wx.WXK_SHIFT):
            editor = self.mainApp.notes
            base = self.mainApp.noteEdit
        else:
            editor = self.mainApp.editor
            base = self.mainApp.edit
            editor.MarkDirty()
            self.mainApp.resNB.SetPageImage(0, 0)
            self.CheckWinState.CheckState()
        self.OnShortCopy(None)
        sel = wx.TextDataObject()
        if wx.TheClipboard.Open():
            wx.TheClipboard.GetData(sel)
            wx.TheClipboard.Close()
            txt = sel.GetText().replace('_', ' ')
            #editor.WriteText(txt)
            base.OnEditorPaste(txt)

    
    def ExportSelection(self, event):
        if wx.GetKeyState(wx.WXK_SHIFT):
            editor = self.mainApp.notes
            base = self.mainApp.noteEdit
        else:
            editor = self.mainApp.editor
            base = self.mainApp.edit
            editor.MarkDirty()
            self.mainApp.resNB.SetPageImage(0, 0)
            self.CheckWinState.CheckState()

        base.OnEditorPaste(self.selText)



    def ExportEditor(self, event):
        menu = event.GetEventObject()
        if not isinstance(menu, wx.Menu):
            print 'not menu item'
            return
        
        fn = self.mainApp.bibFileList[self.popTab]
        
        format = self.mainApp.copyFormat        
        id = event.GetId()
        
        if wx.GetKeyState(wx.WXK_SHIFT):
            editor = self.mainApp.notes
        else:
            editor = self.mainApp.editor
        
        idx = self.popVerse.find(':')
        chap = self.popVerse[:idx +1]
        
        last = menu.FindItemById(id).GetLabel()
        if not last.isdigit():
            idx = self.popVerse.find(':')
            last = self.popVerse[idx +1:]
        
            
        start = fixRef.findIdx(self.popVerse, fn)[0]
        end = fixRef.findIdx(chap + last, fn)[1]
        
        idxList = [start, end]
        
        #print idxList
        
        settings = self.mainApp.copySettings
        
        try:
            txt, ref, abbr = normSearch.formatRangeCopy(self.popVerse, last, self.mainApp.bibFileList[self.popTab], settings, idxList)
        except:
            print 'Can\'t export'
            return
        
        print txt.encode('utf-8')
        
        #txt = re.sub(r'</?[^i]+>', '', txt)
        txt = re.sub(r'[\^~]|<sup>.+?</sup>|<fnc?>.+?</fnc?>|<a href.+?">|</a>', '', txt)
        if self.mainApp.bibNB.bibPanel.miniTB.GetToolToggled(510) == False:
            txt = re.sub(r'\[[GH]\w+\]', '', txt)
        else:
            txt = re.sub(r'\[([GH]\w+)\]', r' \1', txt)

        print txt.encode('utf-8')
        
        editor.SetBasicStyle(editor.GetBasicStyle())
        
        if settings[3]:
            str = '%s '
            if settings[4]:
                str = '%s\n'
            editor.WriteText(str % ref)
            clipTxt = str % ref + txt + '\n\n'

        editor.WriteText(txt)
        
        if not settings[3]:
            str = ' %s'
            if settings[4]:
                str = '\n%s'
            editor.WriteText(str % ref)
            clipTxt = txt + str % ref + '\n\n'
        
        editor.SetBasicStyle(editor.GetBasicStyle())
        editor.Newline()
        
        if not '{' in txt:
            editor.Newline()
        
        rtfFromXML = self.EditorFormat(self.mainApp.copyRefColor, editor)
        editor.MarkDirty()
        
        clipTxt = re.sub(r'[{}]|<b>|</b>', '', clipTxt)        
        self.ToClipboard(clipTxt, rtfFromXML)
        
        if editor == self.mainApp.editor:
            self.mainApp.resNB.SetPageImage(0, 0)
            if self.mainApp.getMaximized() and self.mainApp.jumpState == True: 
                self.mainApp.OnMakeResultsFull(None)  
                self.mainApp.resNB.SetSelection(0)
            else:
                self.CheckWinState.CheckState()



    def EditorFormat(self, color, editor):
        buffer = editor.GetBuffer()
        xmlHandler = rt.RichTextXMLHandler()
        stream = cStringIO.StringIO()
        if xmlHandler.SaveStream(buffer, stream):
            contents = stream.getvalue()
            #print contents
            fixed = re.sub(r'{(.+?)}', r'</text><text textcolor="%s">\1</text><text>' % color, contents) # Ref Color
            fixed = re.sub(r'&lt;r&gt;(.+?)&lt;/r&gt;', r'</text><text textcolor="#FF0000">\1 </text><text>', fixed) # Red Letter
            fixed = re.sub(r'&lt;/?r&gt;', '', fixed)
            fixed = re.sub(r'\[(.+?)\]', r'</text><text fontstyle="93">\1</text><text>', fixed) # Italics
            fixed = re.sub(r'<b>(.+?)</b>', r'</text><text fontstyle="91">\1</text><text>', fixed) # Bold

            # Convert XML to RTF
            handler = PyRTFParser.PyRichTextRTFHandler()
            rtfFromXML = handler.SaveFile(None, None, fixed)

            output = cStringIO.StringIO(fixed)
            xmlHandler.LoadStream(buffer, output)
            #self.mainApp.edit.OnMakePageLinks(None)
            editor.Refresh()
            return rtfFromXML


    def PageSearch(self, event, name = ''):
        if not name:
            name = self.page.GetName()
        
        if name.startswith('Bib'):
            nb = self.mainApp.bibNB
        elif name.startswith('Dct'):
            nb = self.mainApp.dctNB
        if name.startswith('Cmt'):
            nb = self.mainApp.cmtNB
        if name.startswith('Res'):
            nb = self.mainApp.resNB

        dlg = controlMini.searchWin(self.mainApp)

        if dlg.ShowModal() == wx.ID_OK:
            query = dlg.entry.GetValue()
            full = dlg.whole.GetValue()
            self.DoPageSearch(query, full, nb)
        
        dlg.Destroy()
        
    
    def DoPageSearch(self, query, full, nb):

        tab = nb.GetSelection()
        if full == 1:
            hit = re.compile(r'\b%s\b' % query)
        else:
            hit = re.compile(r'\b%s' % query)

        if nb == self.mainApp.bibNB:
            txt = self.mainApp.bibCurrent
            page = self.mainApp.bibDisplay[tab]
        elif nb == self.mainApp.dctNB:
            txt = self.mainApp.dctCurrent
            page = self.mainApp.dctDisplay[tab]
        elif nb == self.mainApp.resNB:
            txt = self.mainApp.resultCurrent[tab -1]
            page = self.mainApp.resDisplay[tab -1]
        else:
            txt = self.mainApp.cmtCurrent
            page = self.mainApp.cmtDisplay[tab -1]
            
        #print page.GetName()
        
        #txt = unicode(txt, 'utf-8')
        answer = hit.sub(r'<a name="line"></a><font color="Blue"><b>%s</b></font>' % query, txt)
        page.SetPage(answer)
        self.mainApp.old = ''
        
        if '<a name="line">' in answer:
                page.ScrollToAnchor('line')
                page.ScrollLines(-2)
        else:
            dlg = wx.MessageDialog(self.mainApp, '"%s" is not found in this page' % query, 'Not Found', wx.OK)
            dlg.ShowModal()
            dlg.Destroy()
        
    
    def PopupPrintPre(self, event):
        self.mainApp.OnPrintPre(None)


    def PopupPrint(self, event):
        self.mainApp.OnPrint(None)

    
    def PopupViewRef(self, event):
        txt = self.page.ToText()
        idx = txt.find('\n')
        heading = txt[:idx]
        
        gp = self.page.GetGrandParent().GetParent()
        
        if heading == '' or gp == self.mainApp.dctNB or gp == self.mainApp.cmtNB:
            if gp == self.mainApp.dctNB:
                item = self.mainApp.dctListbox.GetFirstSelected()
                heading = self.mainApp.dctListbox.GetItemText(item)
                txt = self.mainApp.dctCurrent
            if gp == self.mainApp.cmtNB:
                item = self.mainApp.cmtListbox.GetFirstSelected()
                heading = self.mainApp.cmtListbox.GetItemText(item)
                txt = self.mainApp.cmtCurrent

        label = self.page.GetName()

        refs = re.findall(r'<a href="bible://(.+?)">|\w\w\w.\d+:\d+(?:-\d+)?', txt)
        
        wx.BeginBusyCursor()
        verses = []
        for ref in refs:
            ref = ref.replace('_', ' ')
            try:
                verse = normSearch.findRefs(ref, self.mainApp.bibFileList[self.popTab])
                if verse:
                    verses.append(verse)
            except:
                continue
            
        title = " Verses from References"
        answer = '''<font face="%s"><br><b>%s<hr>%s</b><br>(%s Verses)<br><br>%s 
        </font></body>''' % (self.mainApp.font, label, heading, len(verses), ''.join(verses))
        
        self.mainApp.OnDictMini(answer, title, None)
        
        wx.EndBusyCursor()
        
    
    def PopupTitle(self, event):
        menuTab = self.GetMenuTab.index(event.GetId())
        tab = self.mainApp.dctFlagList[menuTab]
        title = self.mainApp.dDescList[tab]
        self.mainApp.currentWord = self.topicWord.capitalize()
        
        #statText = 'Current Word: %s' % self.mainApp.currentWord
        #self.mainApp.statusbar.SetStatusText(statText, 2)
        
        if self.mainApp.useMini == True:
            answer, fNames = normSearch.showLibTopic(self.topicWord.capitalize(), self.mainApp.dctFileList[tab], self.mainApp.font, self.mainApp.dctColor, title, 0)
            if self.mainApp.fontSize > 0:
                answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)
            self.mainApp.OnDictMini(answer, title, None)
            self.mainApp.miniWin.type = 1

            default = ''
            self.mainApp.miniWin.hitList.Clear()
            for item in self.mainApp.dctFlagList:
                dct = self.mainApp.dAbbrList[item]
                if item == tab:                    
                    default = dct
                self.mainApp.miniWin.hitList.Append(dct)
                
            self.mainApp.miniWin.hitList.SetStringSelection(default)

            self.mainApp.miniWin.sizer2.Show(0, True)
            self.mainApp.miniWin.sizer2.Layout()
        else:
            
            self.mainApp.dctNB.SetSelection(self.mainApp.dctFlagList[menuTab])
            #self.mainApp.dctEntry.SetValue(self.topicWord.capitalize())
            self.mainApp.dctListIdx = tab
            #self.mainApp.currentWord = self.topicWord.capitalize()
            
            self.mainApp.OnDctNBChanged(None)
            self.mainApp.OnDctViewEntry()

    
    def PopupVerse(self, event):
        tab = self.GetCmtMenuTab.index(event.GetId()) 
        
        self.mainApp.cmtNB.SetSelection(self.mainApp.cmtFlagList[tab])
        self.mainApp.cmtEntry.SetValue(self.popVerse)
        self.mainApp.cmtListIdx = tab
        self.mainApp.currentRef = self.popVerse
        
        self.mainApp.OnCmtViewEntry()
        self.mainApp.OnCmtNBChanged(None)

    
    def PopupCopyVerse(self, event):
        verse = normSearch.getVerse(self.popVerse, self.mainApp.bibFileList[self.popTab], self.mainApp.copyFormat)
        #self.ToClipboard(verse)
        pass
            
    def PopupCopyRange(self, event):
        menu = event.GetEventObject()
        id = event.GetId()
        last = menu.FindItemById(id).GetLabel()
        txt = normSearch.formatRangeCopy(self.popVerse, last, self.bibFileList[self.popTab], self.mainApp.copySettings)
        #self.ToClipboard(txt)
    
    def ToClipboard(self, txt, rtf = None):
        
        compositeDataObject = wx.DataObjectComposite()
        
        if rtf:
            rtfFormat = wx.CustomDataFormat('Rich Text Format')
            rtfDataObject = wx.CustomDataObject(rtfFormat)
            rtfDataObject.SetData(rtf)
            compositeDataObject.Add(rtfDataObject)
        
        txtDataObject = wx.TextDataObject()
        txtDataObject.SetText(txt)
        compositeDataObject.Add(txtDataObject)
        
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(compositeDataObject)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")


    def SearchByID(self, event):
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)        
        self.mainApp.cpMini.LBook.SetSelection(0)
        id = '%s[%s]' % (self.peoID, self.popWord)
        self.mainApp.cpMini.FromPopupIDSearch(id)

    
    def PopupSearchWord(self, event):
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)        
        self.mainApp.cpMini.LBook.SetSelection(0)
        self.mainApp.cpMini.FromPopupBibSearch(self.popWord)
       
                
    def PopupSearchVerse(self, event):
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)
        self.mainApp.cpMini.LBook.SetSelection(3)
        
        self.mainApp.cpMini.FromPopupLib(self.popVerse)
        self.mainApp.cpMini.Show()
             
    
    def PopupSearchLib(self, event):
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)        
        self.mainApp.cpMini.LBook.SetSelection(3)
        
        self.mainApp.cpMini.FromPopupLib(self.popWord)
        self.mainApp.cpMini.Show()
        
    
    def singular(self, word):
        exclude = {'Gentiles':'Gentile'}
        if word in exclude.keys():
            return exclude[word]
        
        sing_rules = [lambda w: w[-3:] == 'ies' and w[:-3] + 'y',
                      lambda w: w[-4:] == 'ives' and w[:-4] + 'ife',
                      lambda w: w[-3:] == 'ves' and w[:-3] + 'f',
                      lambda w: w[-2:] == 'es' and w[:-2],
                      lambda w: w[-1:] == 's' and w[:-1],
                      lambda w: w,
                      ]
        word = word.strip()
        singleword = [f(word) for f in sing_rules if f(word) is not False][0]
        return singleword
    
    
    def DctCmtLookup(self, word):
        start = time.time()
        
        if wx.GetKeyState(wx.WXK_ALT):
            tab = self.mainApp.dctNB.GetSelection()
        elif self.mainApp.dctNB.dctPanel.miniTB.GetToolToggled(613) == True:
            tab = self.mainApp.defaultDctIdx
        else:           
            tab = self.mainApp.dctNB.GetSelection()
            
        #print tab, 'tab'
        
        try:
            title = self.mainApp.dDescList[tab]
        except:
            print 'no tab'
            return
        focus = self.mainApp.FindFocus()
        
        if re.search(r'[a-z]', word[0]):
            word = word.capitalize()
            self.mainApp.currentWord = word.capitalize()
            statText = 'Current Word: %s' % word.capitalize()
        else:
            self.mainApp.currentWord = word
            statText = 'Current Word: %s' % word
        
        self.mainApp.statusbar.SetStatusText(statText, 2)
        
        #p = inflect.engine()
        #word = p.singular_noun(word)
            
        if self.mainApp.dctNB.dctPanel.miniTB.GetToolToggled(605) == True:
            self.mainApp.FlagTabs(word)
        
        self.mainApp.dctEntry.SetValue(word)
        
        imgNames = []
        self.mainApp.dctEntry.Enable(True)
        
        answer, imgNames = normSearch.showLibTopic(word, self.mainApp.dctFileList[tab], self.mainApp.font, self.mainApp.dctColor, title, 0)
        
        if '</font> not found in,<br>' in answer:
            word = self.singular(word)
            answer, imgNames = normSearch.showLibTopic(word, self.mainApp.dctFileList[tab], self.mainApp.font, self.mainApp.dctColor, title, 0)
        
        #print answer.encode('utf-8')
        
        if self.mainApp.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)

        if self.mainApp.useMini == True or \
        self.mainApp.bibExpandMW == 1 and focus.GetName() == 'Parallel' or \
        self.mainApp.bibExpandMW == 1 and focus.GetName() == 'Dual':
            self.mainApp.OnDictMini(answer, title, imgNames)
            self.mainApp.miniWin.type = 1
            
            default = ''
            self.mainApp.miniWin.hitList.Clear()
            for item in self.mainApp.dctFlagList:
                dct = self.mainApp.dAbbrList[item]
                if item == tab:                    
                    default = dct
                self.mainApp.miniWin.hitList.Append(dct)
                
            self.mainApp.miniWin.hitList.SetStringSelection(default)

            #self.mainApp.miniWin.sizer2.Show(0, True)
            #self.mainApp.miniWin.sizer2.Layout()
            
            return
        
        self.mainApp.dctNB.SetSelection(tab)
        self.mainApp.dctListbox.Enable(True)
        
        if self.mainApp.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
            if tab != self.mainApp.wordListTab:
                self.mainApp.GetWordList(tab)
                
            self.mainApp.dctListbox.SetItemCount(len(self.mainApp.currentWL))
            item = self.mainApp.FindDctEntry(self.mainApp.dctEntry.GetValue())
            if item:
                self.mainApp.dctListbox.EnsureVisible(item)
                self.mainApp.dctListbox.Select(item)

        if self.mainApp.useMini == False and self.mainApp.getMaximized() and self.mainApp.jumpState == True: 

            win = self.mainApp.getMaximized()
            
            #In mainApp bibClicked the bibRef is run first setting focus to the CMT win. This switches to DCT win.
            if win.IsNotebookControl():
                nb = win.window
                for idx in range(nb.GetPageCount()):
                    if nb.GetPageText(idx) == 'Dictionaries':
                        nb.SetSelection(idx)
            else:          
                self.mainApp.mainMgr.RestoreMaximizedPane()
                #self.mainApp.mainMgr.MaximizePane(self.mainApp.getDctPane())

            
            self.mainApp.Freeze()
            self.mainApp.dctDisplay[tab].SetPage(answer)
            self.mainApp.mainMgr.Update()
            self.mainApp.Thaw()
        
        #elif self.mainApp.jumpState == True:
        else:    
            dctPane = self.mainApp.getDctPane()
            if dctPane.IsNotebookPage():
                nb = dctPane.window.GetParent()
                nb.SetSelectionToWindow(dctPane.window)
            #print '2' 
            self.mainApp.dctDisplay[tab].SetPage(answer)
            
        
        title = 'Dictionary - %s' % self.mainApp.dDescList[tab]
        pane = self.mainApp.mainMgr.GetPane("Dictionaries")
        
        if pane.IsNotebookPage():
            self.mainApp.doNotebookTitle(title)
        if pane.IsFloating():
            frameMgr = pane.frame.GetMgr()
            p = frameMgr.GetPane('Dictionaries')
            p.Caption(title)
            frameMgr.Update()
        else:
            pane.Caption(title)
        
        
        #self.mainApp.Thaw()
        
        if imgNames:
            self.mainApp.RemoveImages(imgNames)
        
        if self.mainApp.dctNB.dctPanel.fromDctBack:         
            self.mainApp.dctNB.dctPanel.fromDctBack = None
        else:
            tab = self.mainApp.dctNB.GetSelection()            
            self.mainApp.dctHistory.append((tab, word))
            self.mainApp.dctNB.dctHistoryIdx = -1
        
        self.mainApp.dctOld = self.mainApp.dctCurrent
        self.mainApp.dctCurrent = answer
        
        print time.time() - start, ' Search word Time'
