import wx, re, wx.html, time, utility, popup
import normSearch, stats, compareDiff, fixRef, advSearch, contextMenu, kjd, games, library, audioPlayer, related, baseClass, dialogs, mainMenu

from artManager import ArtManager, DCSaver


import flatNotebook as fnb
import sqlite3 as sqlite

from resources import *
import labelBook



books = [
    "Genesis", "Exodus", "Leviticus", "Numbers", "Deuteron.", "Joshua",
    "Judges", "Ruth", "1Samuel", "2Samuel", "1Kings", "2Kings",
    "1Chron.", "2Chron.", "Ezra", "Nehemiah", "Esther", "Job",
    "Psalms", "Proverbs", "Eccless.", "Song", "Isaiah", "Jeremiah",
    "Lamentat.", "Ezekiel", "Daniel", "Hosea", "Joel", "Amos",
    "Obadiah", "Jonah", "Micah", "Nahum", "Habbukkuk", "Zephaniah",
    "Haggai", "Zechariah", "Malachi", "Matthew", "Mark", "Luke",
    "John", "Acts", "Romans", "1Corinth.", "2Corinth.", "Galations",
    "Ephesians", "Phillipians", "Colossians", "1Thess.", "2Thess.", "1Timothy", 
    "2Timothy", "Titus", "Philemon", "Hebrews", "James", "1Peter",
    "2Peter", "1John", "2John", "3John", "Jude", "Revelation",
    ]

books2 = [
    'Gen', 'Exo', 'Lev', 'Num', 'Deu', 'Jos', 'Jdg', 'Rth', '1Sa', '2Sa', '1Ki', '2Ki', '1Ch', '2Ch',
    'Ezr', 'Neh', 'Est', 'Job', 'Psa', 'Pro', 'Ecc', 'Son', 'Isa', 'Jer', 'Lam', 'Eze', 'Dan', 'Hos',
    'Joe', 'Amo', 'Oba', 'Jon', 'Mic', 'Nah', 'Hab', 'Zep', 'Hag', 'Zec', 'Mal', 'Mat', 'Mar', 'Luk',
    'Joh', 'Act', 'Rom', '1Co', '2Co', 'Gal', 'Eph', 'Phi', 'Col', '1Th', '2Th', '1Ti', '2Ti', 'Tit',
    'Phm', 'Heb', 'Jam', '1Pe', '2Pe', '1Jo', '2Jo', '3Jo', 'Jud', 'Rev']



class FMTitlePanel(wx.Panel):
    def __init__(self, parent, title):

        wx.Panel.__init__(self, parent)
        self._title = title

        # Set the panel size
        dc = wx.MemoryDC()
        dc.SelectObject(wx.EmptyBitmap(1, 1))
        #dc.SetFont(wx.SystemSettings_GetFont( wx.SYS_DEFAULT_GUI_FONT ))
        dc.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0))
        
        ww, hh = dc.GetTextExtent("Tp")
        dc.SelectObject(wx.NullBitmap)

        self.SetSize(wx.Size(ww, hh + 12))

        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_ERASE_BACKGROUND, self.OnEraseBackground)

    def OnEraseBackground(self, event):
        pass

    def OnPaint(self, event):
        dc = wx.BufferedPaintDC(self)

        # Draw the background
        colour1 = wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE)
        colour2 = labelBook.ArtManager.Get().LightColour(colour1, 90)
        labelBook.ArtManager.Get().PaintStraightGradientBox(dc, self.GetClientRect(), colour1, colour2, False)

        # Draw the text
        #font = wx.SystemSettings_GetFont(wx.SYS_DEFAULT_GUI_FONT)
        font = wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0)
        #font.SetWeight(wx.BOLD)
        dc.SetFont(font)
        dc.SetTextForeground(wx.BLACK)
        dc.DrawText(self._title, 5, 5)


## Master Control Mini and Functions

class ControlMini(wx.MiniFrame):
    def __init__(self, parent):
        wx.MiniFrame.__init__(self, parent, -1, " Master Control Panel", style = wx.DEFAULT_FRAME_STYLE|wx.FRAME_FLOAT_ON_PARENT)
        
        self.mainApp = parent
        self.CheckWinState = utility.CheckWinState()
        
        self.LBook = None
        
        self.panel = wx.Panel(self)
        
        self.HideButton = wx.Button(self.panel, -1, "Hide")#, size=(40, 23))
        #self.HelpButton = wx.Button(self.panel, -1, '?', size=(22, 23)) #, style=wx.BORDER_NONE)
        
        #self.HelpButton.SetToolTip(wx.ToolTip('Help for the Selected Tab'))
        #self.HelpButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Verdana"))
        #self.HelpButton.SetForegroundColour(wx.Colour(128, 0, 0))

        # Create the main book and add some pages into it
        self.LBook = labelBook.LabelBook(self.panel, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize,\
                     style = INB_NO_RESIZE | INB_LEFT | INB_DRAW_SHADOW | INB_BORDER | INB_USE_PIN_BUTTON)

        self.LBook.SetColour(INB_TAB_AREA_BACKGROUND_COLOR, labelBook.ArtManager.Get().GetMenuFaceColour())

        colour = wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE)
        self.LBook.SetColour(INB_ACTIVE_TAB_COLOR, colour)

        self.Initialise()
        
        sz = wx.BoxSizer(wx.VERTICAL)
        self.panel.SetSizer(sz)
        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        
        sz.Add(self.LBook, 1, wx.EXPAND)
        hsizer.Add((-1, -1), 1, 0, 0)
        hsizer.Add(self.HideButton, 0, wx.ALIGN_CENTER | wx.TOP | wx.BOTTOM, 3)
        hsizer.Add((-1, -1), 1, 0, 0)
        #hsizer.Add(self.HelpButton, 0, wx.ALIGN_RIGHT|wx.RIGHT|wx.TOP, 3)
        sz.Add(wx.StaticLine(self.panel), 0, wx.EXPAND | wx.TOP, 3)
        sz.Add(hsizer, 0, wx.EXPAND | wx.ALL, 2)

        sz.Layout()
        
        self.Centre()
        self.SetMinSize((400, 700))
        
        self.Bind(labelBook.EVT_IMAGENOTEBOOK_PAGE_CHANGED, self.OnDual)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)
        self.Bind(wx.EVT_BUTTON, self.OnCloseWindow, self.HideButton)
        #self.Bind(wx.EVT_BUTTON, self.OnHelp, self.HelpButton)
        
        sessId = wx.NewId()
        self.Bind(wx.EVT_MENU, self.OnSessMan, id=sessId )
        accel_tbl = wx.AcceleratorTable([(wx.ACCEL_CTRL,  ord('M'), sessId )])
        self.SetAcceleratorTable(accel_tbl)
        
        id = wx.NewId()
        self.Bind(wx.EVT_MENU, self.OnToggle, id=id )
        accel_tbl = wx.AcceleratorTable([(wx.ACCEL_NORMAL, wx.WXK_F2, id )])
        self.SetAcceleratorTable(accel_tbl)
        

    def OnSessMan(self, event):
        self.mainApp.OnSessMan(None)

    def OnToggle(self, event):
        self.mainApp.OnMasterControlMini(None)


    def OnHelp(self, event):
        tab = self.LBook.GetSelection()
        if tab == 0:
            context = 90 
        elif tab == 1:
            context = 31 
        elif tab == 2:
            context = 371 
        elif tab == 3:
            context = 51 
        elif tab == 4:
            context = 321 
        elif tab == 5:
            context = 71 
        elif tab == 6:
            context = 81 
        elif tab == 7:
            context = 91 
        elif tab == 8:
            context = 381 
        else:
            return
        
        self.mainApp.OnContextHelp(context)


    def Initialise(self):
        self.BibSearch = BibSearchMini(self)
        self.ProxSearch = ProxSearchMini(self)
        self.WordList = WordListMini(self)

        self.Stat = StatMini(self)
        self.Compare = CompareMini(self)
        self.LibSearch = LibSearchMini(self)
        self.BookViewer = library.BookViewer(self)
        self.relatedVerse = related.RelatedSearch(self)
        self.Dual = DualBible(self)
        
        self.LBook.DeleteAllPages()
        self.LBook.AddPage(self.BibSearch, "Advanced Search", True)
        self.LBook.AddPage(self.ProxSearch, "Proximity Search", False)
        self.LBook.AddPage(self.relatedVerse, "Related Search", False)
        self.LBook.AddPage(self.LibSearch, "Libraries Search", False)
        self.LBook.AddPage(self.WordList, "Bible Word Lists", False)

        self.LBook.AddPage(self.Stat, "Bible Statistics", False)
        self.LBook.AddPage(self.Compare, "Bible Compare", False)
        self.LBook.AddPage(self.Dual, "Dual Bible View", False)
        self.LBook.AddPage(self.BookViewer, "Books & Articles", False)
        
        self.lastTab = 0
    

    

    def FromPopupRelated(self, ref):

        self.relatedVerse.verseBox.SetValue(ref)

        self.relatedVerse.OnRef(None)


    def FromPeopleButton(self, name):
        cur = self.BibSearch.SearchEntryBox.GetValue()
        name = re.sub(r'^<b>(.+?)</b>-(\d+)', r'\2[\1]', name)
        if cur:
            name = cur + ' ' + name
        self.BibSearch.SearchEntryBox.SetValue(name)


    def FromWLButton(self, word):

        cur = self.BibSearch.SearchEntryBox.GetValue()
        if cur:
            word = ' ' + word
        self.BibSearch.SearchEntryBox.AppendText(word)


    def FromPopupIDSearch(self, id):
        self.BibSearch.SearchOptions.SetSelection(3)
        
        self.BibSearch.SearchEntryBox.SetValue(id)
        self.BibSearch.OnOptSel(None)
        self.BibSearch.OnSearch(None)



    def FromPopupBibSearch(self, word):
        self.BibSearch.SearchOptions.SetSelection(0)
                
        self.BibSearch.SearchEntryBox.SetValue(word)
        self.BibSearch.OnOptSel(None)
        self.BibSearch.OnSearch(None)

    def FromQuickSearch(self, word):
        if '"' in word and word.count('"') == 1:
            word = word.replace('"', '')
            self.BibSearch.SearchOptions.SetSelection(0)
            #print 'Phrase'
        else:
            self.BibSearch.SearchOptions.SetSelection(1)
            #print 'Every word'
            
        self.BibSearch.SearchEntryBox.SetValue(word)
        self.BibSearch.OnOptSel(None)
        self.BibSearch.OnSearch(None)

    def FromRelatedLink(self, word):
        self.BibSearch.SearchOptions.SetSelection(0)
        self.BibSearch.SearchEntryBox.SetValue(word)
        self.BibSearch.OnSearch(None, 1, 1)

    
    def FromPopupLib(self, word):
        self.LibSearch.SearchEntryBox.ChangeValue(word)
        
    def FromPopupBookStats(self, ref):
        self.Stat.StatEntry.ChangeValue(ref)

    def FromPopupChapStats(self, ref):
        self.Stat.StatEntry.ChangeValue(ref)

    def FromPopupVerseStats(self, ref):
        self.Stat.StatEntry.ChangeValue(ref)

    def OnDual(self, event):
        self.mainApp.Freeze()
        if self.LBook.GetSelection() == 7:
            if self.mainApp.bibNB.bibPanel.miniTB.GetToolToggled(513) == False:
                self.mainApp.bibNB.bibPanel.miniTB.ToggleTool(513, True)
                self.mainApp.bibNB.bibPanel.OnDual(None)
                self.mainApp.Thaw()
                return
            else:
                self.mainApp.Thaw()
                return
        
        elif self.LBook.GetSelection() == 8:
            if self.mainApp.showBkWin == 0:
                self.mainApp.bookTitlesLoaded = True
                self.mainApp.resNB.SetSelection(1)
                self.mainApp.OnResNBChanged(None)
                if len(self.mainApp.bookDisplay.ToText()) == 0: # Empty
                    self.mainApp.cpMini.BookViewer.ShowRootItems()
            else:                
                output = '''<font face="Verdana"><center><i>Book and Articles are being displayed in the stand-alone window.<br>
                To display them here, change setting in Preferences.</i></center></font>'''
                
                self.mainApp.bookDisplay.SetPage(output)
        
        elif self.LBook.GetSelection() == 2:
            self.relatedVerse.GetWords(self.mainApp.currentRef)
        
        self.mainApp.SetCMiniFocus()
        #self.CheckWinState.CheckState()
        
        if self.mainApp.bibNB.bibPanel.miniTB.GetToolToggled(513) == True:
            self.mainApp.bibNB.bibPanel.miniTB.ToggleTool(513, False)
            self.mainApp.bibNB.bibPanel.OnDual(None)
        
        self.mainApp.Thaw()
    
    
    def OnCloseWindow(self, event):
        self.Hide()
        self.mainApp.Raise()



    

## Bible Search Mini and Functions

class BibSearchMini(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()

        self.advSearch = advSearch.primSearch(self)
        
        self.RangeBox = wx.StaticBox(self, -1, "Search Range")
        
        self.RadioE = wx.RadioButton(self, -1, 'Entire Bible', style = wx.RB_GROUP)
        self.RadioOT = wx.RadioButton(self, -1, 'Old Test.')
        self.RadioNT = wx.RadioButton(self, -1, 'New Test.')
        self.RadioRL = wx.RadioButton(self, -1, 'Red Letter')
        
        self.SearchEntryLabel = wx.StaticText(self, -1, "Enter Word or Phrase")
        self.SearchEntryBox = wx.ComboBox(self, -1, "", style=wx.TE_PROCESS_ENTER)

        self.ExcludeLabel = wx.StaticText(self, -1, "Exclude")

        self.ExcludeEntryBox = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER)

        ranges = ['Gen - Deu', 'Luk, Acts', 'Joh, 1Joh - 3Joh, Rev', 'Rom - Phm']
        self.rangeEntry = wx.ComboBox(self, -1, 'Genesis - Revelation', choices = ranges, size=(170, -1))
        
        self.SearchOptions = wx.RadioBox(self, -1, "Search Methods", choices=["Single Word / Phrase / Strong's #", "Every Word / Multi-Single Word", "Any Word or Phrase", "Specific Individuals (AVp)", "Character String", "Regular Expression"], majorDimension=1, style=wx.RA_SPECIFY_COLS)
        self.searchMulti = wx.CheckBox(self, -1, "Search Multiple Bibles")

        self.doRoot = wx.CheckBox(self, -1, "Root Words (Stemming)")
        self.refOnly = wx.CheckBox(self, -1, "References Only")

        self.WholeWord = wx.CheckBox(self, -1, "Whole Word")
        self.Case = wx.CheckBox(self, -1, "Case Sensitive")
        self.SearchButton = wx.Button(self, -1, "Search")

        self.WLButton = wx.Button(self, -1, "Words", size=(60, 25))
        self.multiButton = wx.Button(self, -1, "Texts", size=(60, 25))
        self.peopleButton = wx.Button(self, -1, "People", size=(60, 25))

        

        self.__set_properties()
        self.__do_layout()
        
    def __set_properties(self):
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.SearchEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.ExcludeLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.SearchOptions.SetSelection(0)
        self.SearchButton.SetForegroundColour(wx.Colour(142, 35, 35))
        #self.SearchButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.WholeWord.SetValue(True)
        
        self.SearchOptions.SetItemToolTip(0, 'Search for a single word or a phrase. i.e. [born] or [born again].\nAlso, Strong\'s Numbers can be entered, i.e. [G25]')
        self.SearchOptions.SetItemToolTip(1, 'Search for EVERY entered word or phrase in a verse. Phrase must be in quotes.\nEntering ["born again" life] will return verses with the phrase AND word')
        self.SearchOptions.SetItemToolTip(2, 'Search for ANY entered word or phrase in a verse. Phrase must be in quotes.\nEntering ["born again" life] will return verses with the phrase OR word')
        self.SearchOptions.SetItemToolTip(3, 'Search for persons by ID. IDs can be found with the "People Button."\nMultiple IDs can be entered as well as plain words for an EVERY type search.')
        self.SearchOptions.SetItemToolTip(4, 'Search for an exact string, including punctuation, spaces, etc."\ni.e [soul,] will only find "soul" followed by a comma.')
        self.SearchOptions.SetItemToolTip(5, 'Regular Expressions are advanced string matching patterns.\nSee the User Manual for more details')


    def __do_layout(self):
        MainSize = wx.BoxSizer(wx.VERTICAL)
        RangeStaticBox = wx.StaticBoxSizer(self.RangeBox, wx.VERTICAL)
        WLSizerSub = wx.BoxSizer(wx.VERTICAL)

        buttonSizer = wx.BoxSizer(wx.VERTICAL)

        WLSizer = wx.BoxSizer(wx.HORIZONTAL)

        ExSizer = wx.BoxSizer(wx.HORIZONTAL)
        
        title = FMTitlePanel(self, "Advanced Bible Search")
        MainSize.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        gs = wx.FlexGridSizer(2, 3, 4, 4)  # rows, cols, vgap, hgap
        gs.AddMany([ (self.RadioE,  0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioOT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     (self.RadioNT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioRL, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ])
        
        gs.AddGrowableCol(1)
        gs.AddGrowableCol(3)

        RangeStaticBox.Add(gs, 0, wx.TOP|wx.EXPAND, 6)
        RangeStaticBox.Add(self.rangeEntry, 0, wx.TOP|wx.EXPAND, 6)

        MainSize.Add(RangeStaticBox, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        MainSize.Add((-1, 5))
        MainSize.Add(self.SearchOptions, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        MainSize.Add((-1, 5))

        MainSize.Add(self.SearchEntryLabel, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        MainSize.Add((-1, 3))

        MainSize.Add(self.SearchEntryBox, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        MainSize.Add((-1, 5))

        

        ExSizer.Add(self.ExcludeLabel, 0, wx.ALIGN_CENTER|wx.RIGHT, 8)

        ExSizer.Add(self.ExcludeEntryBox, 1, wx.EXPAND, 0)

        MainSize.Add(ExSizer, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        MainSize.Add((-1, 10))

        

        WLSizerSub.Add((-1, 5))

        WLSizerSub.Add(self.searchMulti, 0, wx.LEFT, 0)

        WLSizerSub.Add((-1, 5))

        WLSizerSub.Add(self.Case, 0, wx.LEFT, 0)
        WLSizerSub.Add((-1, 5))

        WLSizerSub.Add(self.WholeWord, 0, wx.LEFT, 0)
        WLSizerSub.Add((-1, 5))

        WLSizerSub.Add(self.refOnly, 0, wx.LEFT, 0)
        WLSizerSub.Add((-1, 5))
        WLSizerSub.Add(self.doRoot, 0, wx.LEFT, 0)
        
        WLSizer.Add(WLSizerSub, 1, wx.TOP, 0)

        

        buttonSizer.Add(self.multiButton, 0, wx.ALIGN_RIGHT, 0)

        buttonSizer.Add((-1, 10))

        buttonSizer.Add(self.WLButton, 0, wx.ALIGN_RIGHT, 0)

        buttonSizer.Add((-1, 10))
        buttonSizer.Add(self.peopleButton, 0, wx.ALIGN_RIGHT, 0)
        WLSizer.Add(buttonSizer, 0, wx.ALIGN_RIGHT, 0)

        

        MainSize.Add(WLSizer, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)


        MainSize.Add(self.SearchButton, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 12)
        #MainSize.Add(self.WildLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)
        #self.SetAutoLayout(True)
        self.SetSizer(MainSize)
        #self.Layout()
        
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioE, self.RadioE)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioOT, self.RadioOT)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioNT, self.RadioNT)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioRL, self.RadioRL)

        self.Bind(wx.EVT_COMBOBOX, self.GetHistory, self.SearchEntryBox)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.SearchEntryBox)

        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.ExcludeEntryBox)

        
        self.Bind(wx.EVT_BUTTON, self.OnSearch, self.SearchButton)

        self.Bind(wx.EVT_BUTTON, self.OnWordList, self.WLButton)

        self.Bind(wx.EVT_BUTTON, self.OnBibMultiTexts, self.multiButton)
        self.Bind(wx.EVT_BUTTON, self.OnPeopleList, self.peopleButton)
        self.Bind(wx.EVT_RADIOBOX, self.OnOptSel, self.SearchOptions)

        #self.Bind(wx.EVT_RADIOBOX, self.OnMethod, self.SearchMethods)

        self.Bind(wx.EVT_TEXT, self.OnRangeChange, self.rangeEntry)

        self.searchHistory = []
        self.fixedRef = ''
        
        self.RadioE.SetValue(True)
        self.OnRadioE(None)
        
        self.OnOptSel(None)

    def OnPeopleList(self, event):
        peoTxtDlg = PeopleListDlg(self)
        peoTxtDlg.ShowModal()



    def OnBibMultiTexts(self, event):

        bibTxtDlg = BibListDlg(self)

        bibTxtDlg.ShowModal()

        


    def OnWordList(self, event):

        try: 
            findMini = FindWordMini(self)

            findMini.ShowModal()
        except:
            print 'Search word list Exception, #497'
            return

    
    def OnRadioE(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Revelation')

    def OnRadioOT(self, event):

        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Malachi')

    def OnRadioNT(self, event):

        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Matthew - Revelation')
        
    def OnRadioRL(self, event):
        self.rangeEntry.SetValue('Matthew - Revelation')
        self.rangeEntry.Enable(False)
        
    def OnRangeChange(self, event):
        self.RadioE.SetValue(False)
        self.RadioOT.SetValue(False)
        self.RadioNT.SetValue(False)
        self.RadioRL.SetValue(False)
        
    def OnMethod(self, event):

        if self.SearchMethods.GetSelection() == 1:

            self.SearchOptions.Enable(False)

            self.Case.Enable(False)

            self.WholeWord.Enable(False)            

        else:

            self.SearchOptions.Enable(True)

            self.Case.Enable(True)

            self.WholeWord.Enable(True)



    def OnOptSel(self, event):
        if self.SearchOptions.GetSelection() == 3:
            self.searchMulti.Enable(False)
            self.peopleButton.Enable(True)
            self.multiButton.Enable(False)
            self.Case.Enable(True)
            self.doRoot.Enable(True)
            self.WholeWord.Enable(True)
            self.ExcludeEntryBox.Enable(True)
            self.SearchEntryLabel.SetLabel("Select Person From \"People\" Button")
        elif self.SearchOptions.GetSelection() == 4:
            self.searchMulti.Enable(True)
            self.peopleButton.Enable(False)
            self.multiButton.Enable(True)
            self.Case.Enable(False)
            self.doRoot.Enable(False)
            self.WholeWord.Enable(False)
            self.ExcludeEntryBox.Enable(True)
            self.SearchEntryLabel.SetLabel("Enter String")
        elif self.SearchOptions.GetSelection() == 5:
            self.searchMulti.Enable(True)
            self.peopleButton.Enable(False)
            self.multiButton.Enable(True)
            self.Case.Enable(True)
            self.doRoot.Enable(False)
            self.WholeWord.Enable(False)
            self.ExcludeEntryBox.Enable(False)
            self.SearchEntryLabel.SetLabel('Enter Expression')
        elif self.SearchOptions.GetSelection() == 0:
            self.searchMulti.Enable(True)
            self.peopleButton.Enable(False)
            self.multiButton.Enable(True)
            self.Case.Enable(True)
            self.doRoot.Enable(True)
            self.WholeWord.Enable(True)
            self.ExcludeEntryBox.Enable(True)
            self.SearchEntryLabel.SetLabel('Enter Word/Phrase/Strong\'s #')
        else:
            self.searchMulti.Enable(True)
            self.peopleButton.Enable(False)
            self.multiButton.Enable(True)
            self.Case.Enable(True)
            self.doRoot.Enable(True)
            self.WholeWord.Enable(True)
            self.ExcludeEntryBox.Enable(True)
            self.SearchEntryLabel.SetLabel("Enter Word or Phrase")
            
        self.Layout()
        
    
    def GetHistory(self, event):
        sel = self.SearchEntryBox.GetSelection()
        entry = self.SearchEntryBox.GetStringSelection()
        
        #self.SearchMethods.SetSelection(self.searchHistory[sel][0])
        idxList = self.searchHistory[sel][0]
        #endIdx = self.searchHistory[sel][2]
        
        full = self.searchHistory[sel][1]
        self.WholeWord.SetValue(self.searchHistory[sel][1])
        
        case = self.searchHistory[sel][2]
        self.Case.SetValue(self.searchHistory[sel][2])
        
        redSearch = self.searchHistory[sel][3]
        
        opt = self.searchHistory[sel][4]
        self.SearchOptions.SetSelection(self.searchHistory[sel][4])
        
        exBox = self.searchHistory[sel][5]
        
        rng = self.searchHistory[sel][6]
        self.rangeEntry.SetValue(rng)
        
        self.fixedRef = self.searchHistory[sel][7]

        
        if exBox != None:
            self.ExcludeEntryBox.SetValue(exBox)
        else:
            self.ExcludeEntryBox.Clear()
        
        self.OnRangeChange(None)
        
        #self.DisplaySearch(entry, full, case, opt, redSearch, idxList)
        
    
    
    def OnSearch(self, event, relatedRefOnly = 0, relatedFull = 0):
        opt = self.SearchOptions.GetSelection()
        tab = self.mainApp.bibNB.GetSelection()
        
        tabLabel = self.mainApp.bibNB.GetPageText(tab)
        if tabLabel == 'Parallel' and self.mainApp.parallelBibClick:
            tab = self.mainApp.bAbbrList.index(self.mainApp.parallelBibClick)
        
        if opt == 3 and not 'AVp' in self.mainApp.bAbbrList:
            dlg = dialogs.HTMLDialog(self)
            dlg.SetTitle('AV People Edition Bible (AVp) Not Selected/Available')
            #dlg.SetSize((550, 500))
            
            txt = '''<p align="center"><font color="brown"><b>The <i>AV People Edition Bible Bundle</i> (AVp)
            is not loaded or available.<br>This bundle is required for Specific Individual searches.</b></font></p>
            <p><ul><li>Would you like to search for only ONE of the six <i>Marys</i> in the Bible?</li>
            <li>How about ONE or MORE of the 28 <i>Zechariahs</i> excluding all others?</li>
            <li>Would you like to find verses with combinations of individuals, such as <i>Mary</i> the mother of Jesus AND <i>Mary Magdalene,</i> excluding the other Marys?</li>
            <li>Would you like to find <i>Jesus</i> in verses where He is not mentioned by name, like John 3:16 or 5:24?</li>
            <li>How about searching for the Lord by pronouns (<i>he, my, him, I, thou, etc.</i>) or alternate designations (<i>Holy One, etc.</i>)?</li>
            <li>Would you like to quickly view who the pronouns refer to in chapters like Psalms 22 and Isaiah 53?</li>
            <li>Would you like to view comprehensive details about each individual such as <i>Vital Statistics, Biographical Data, Near Relation, Paternal Ancestory, and AV Ocurrences</i>? </li></ul></p>
            <p>Then you need Bible Analyzer's <i>AVp Bundle</i>. The bundle contains the <i>AV "People Edition" Bible</i> and <i>The Exhaustive Library of Bible People</i> dictionary.
            Combined with Bible Analyzer 4.7+, they bring original and unique search and study capabilities not available
            with any other Bible software. This is Bible searching on a whole new level.</p>
            <p>For more information, see our <a href="http://www.bibleanalyzer.com/people.htm">AVp&nbsp;Page</a>,
            For a demo, watch this <a href="http://www.youtube.com/watch?v=9oLXWIKstRc">Youtube&nbsp;Video</a>.'''
            
            dlg.dlgWin.SetPage(txt)
            dlg.CenterOnScreen()
            dlg.Show()
            
            return
        
        elif opt == 3 and not self.mainApp.bibFileList[tab].endswith('AVp.bib'):
            dialogs.peoModNotSelected(self.mainApp)
            return

        self.relatedRefOnly = relatedRefOnly
        
        if self.SearchEntryBox.GetValue() == '':
            return

        entry = self.SearchEntryBox.GetValue()
        if entry.strip() == '?' or entry.strip() == '*':
            return
                    
        rng = self.rangeEntry.GetValue()
        self.mainApp.multiRngLen = 0

        if tab == len(self.mainApp.bibFileList): # and self.searchMulti.GetValue() == 0:
            dialogs.noAdvSearchParallel(self.mainApp)
            return
        
        if opt != 3 and self.mainApp.bibFileList[tab].endswith('AVp.bib') and re.search(r'\b\d+\b', entry):
            dlg = wx.MessageDialog(self.mainApp, 'There appears to be a person ID entered in the Search Entry Box.\n\n\
To search for individuals the "Specific Individuals" search method must be selected. Please check that method and search again.',
            'Select "Specific Individuals" Search Method', wx.OK | wx.ICON_INFORMATION    )
            dlg.ShowModal()
            dlg.Destroy()
            return


        idxList, self.fixedRef = fixRef.parseRng(rng, self.mainApp.bibFileList[tab])
        if not idxList or 'rngError' in idxList:
            #dialogs.rangeError(self)
            return
        
        doRoot = 0
        full = 0
        case = 0
        redSearch = 0
        
        #self.select = self.SearchMethods.GetSelection()

        #self.select = 0
 

        if self.searchMulti.IsChecked():

            bibMulti = 1

        if self.WholeWord.IsChecked() and relatedFull == 0:
            full = 1
        if self.Case.IsChecked():
            case = 1
        if self.doRoot.IsChecked() and self.doRoot.IsEnabled():
            doRoot = 1

        if self.RadioRL.GetValue() == True:
            redSearch = 1
        
        # Get items for search history
        if self.ExcludeEntryBox.GetValue() == '' or self.ExcludeEntryBox.GetValue() == ' ':
            exBox = None
        else:
            exBox = self.ExcludeEntryBox.GetValue()
                    
        self.DisplaySearch(event, entry, full, case, opt, redSearch, idxList, doRoot, tab)
        
        #if self.rangeEntry.FindString(rng) == -1:
        self.rangeEntry.Append(rng)           
                
        temp = []
        #temp.append(self.select)
        temp.append(idxList)
        temp.append(full)
        temp.append(case)
        temp.append(redSearch)
        temp.append(opt)
        temp.append(exBox)
        temp.append(rng)
        temp.append(self.fixedRef)
        
        self.searchHistory.append(temp)
        
        if self.SearchEntryBox.FindString(entry) == -1:
            self.SearchEntryBox.Append(entry)
        
        
    def DisplaySearch(self, event, entry, full, case, opt, redSearch, idxList, doRoot, tab):   

        
        tabLabel = self.mainApp.bibNB.GetPageText(tab)
        
        if event and tabLabel == 'Parallel':
            tab = self.mainApp.avIndex
            self.mainApp.bibNB.SetSelection(tab)
        elif tabLabel == 'Parallel':
            tab = self.mainApp.bAbbrList.index(self.mainApp.parallelBibClick)
        
        if self.mainApp.fromDual:
            tab = self.mainApp.dualBibIdx
            self.mainApp.fromDual = False

        abbr = self.mainApp.bAbbrList[tab]
        
        if self.ExcludeEntryBox.GetValue() == '' or self.ExcludeEntryBox.GetValue() == ' ':
            exBox = None
        else:
            exBox = self.ExcludeEntryBox.GetValue()
                        
        exclude = None
        self.entry = entry
        self.sWord = self.entry
        
        #print entry.encode('utf-8')


        wx.BeginBusyCursor()
        

        # Multi-Bible Search

        if self.searchMulti.GetValue() == 1:

            result, verseList, title, count, findStr, totalHits, exclude, rngRefList = self.advSearch.MultiSearch\
            (entry, self.mainApp.bibFileList[tab], abbr, full, opt, case, self.mainApp.font, self.mainApp.showRed, redSearch, idxList, exBox, self.fixedRef, 0, 0, doRoot, self.fixedRef, self.relatedRefOnly)

        else:
            start = time.time()
            try:
                result, verseList, title, count, findStr, totalHits, exclude, rngRefList = self.advSearch.StdSearch\
                (entry, self.mainApp.bibFileList[tab], abbr, full, opt, case, self.mainApp.font, self.mainApp.showRed, redSearch, idxList, exBox, self.fixedRef, self.refOnly.GetValue(), 0, doRoot, self.fixedRef, self.relatedRefOnly)
            except:
                print 'Search Exception, controlMini #751'

                wx.EndBusyCursor()
                return

        
        # Add data to search query list
        temp = [entry, self.mainApp.bibFileList[tab], abbr, full, opt, case, self.mainApp.showRed, redSearch, count, findStr, totalHits, exclude, self.fixedRef, rngRefList, idxList, 0] # Last (0) is fromSchRngLnk

        self.mainApp.searchQList.append(temp)
        
        #print time.time() - start, 'cm 723'
        
        tabLabel = entry
        if self.searchMulti.GetValue() == 1:
            tabLabel = entry + '-m'

        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        
        
        self.mainApp.Freeze()
        self.mainApp.AddResult(tabLabel, title, result, 'search')
        
        self.mainApp.Showing = result
        
        #print time.time() - start
        self.CheckWinState.CheckState()
        self.mainApp.Thaw()
        
        wx.EndBusyCursor()
        
        
    
## Proximity Search Mini and Functions
class ProxSearchMini(wx.Panel):
    def __init__(self, *args, **kwds):
        wx.Panel.__init__(self, *args, **kwds)

        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()

        self.advSearch = advSearch.primSearch(self)

        self.RangeBox = wx.StaticBox(self, -1, "Search Range")  
        self.RadioE = wx.RadioButton(self, -1, 'Entire Bible', style = wx.RB_GROUP)
        self.RadioOT = wx.RadioButton(self, -1, 'Old Test.')
        self.RadioNT = wx.RadioButton(self, -1, 'New Test.')
        self.RadioRL = wx.RadioButton(self, -1, 'Red Letter')
        
        ranges = ['Gen - Deu', 'Luk, Acts', 'Joh, 1Joh - 3Joh, Rev', 'Rom - Phm']
        self.rangeEntry = wx.ComboBox(self, -1, 'Genesis - Revelation', choices = ranges, size=(170, -1))

        self.SearchEntryLabel = wx.StaticText(self, -1, "Primary word")
        self.SearchEntryBox = wx.TextCtrl(self, -1, "", size=(100, -1), style=wx.TE_PROCESS_ENTER)
        self.SecondaryEntryLabel = wx.StaticText(self, -1, "Secondary word(s)")
        self.SecondaryEntryBox = wx.TextCtrl(self, -1, "", size=(128, -1), style=wx.TE_PROCESS_ENTER)
        self.RangeEntryBox = wx.TextCtrl(self, -1, "3", size=(20, -1))
        self.VerseRangeLabel = wx.StaticText(self, -1, "Vs. Range")
        self.WholeWord = wx.CheckBox(self, -1, "Whole")
        self.SearchButton = wx.Button(self, -1, "Search")
        #self.DispLabel = wx.StaticText(self, -1, "Proximity Statistics Display")
        self.Stats = baseClass.HtmlWindow(self, -1, style=wx.BORDER_THEME )
        self.PreviousButton = wx.Button(self, -1, "<<", size=(40, 25))
        self.NextButton = wx.Button(self, -1, ">>", size=(40, 25))

        self.__set_properties()
        self.__do_layout()
        
        self.Stats.SetPage('<font face="Verdana"><center>Proximity Statistics</center></font>')

    def __set_properties(self):
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.SearchEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.SearchEntryBox.SetMinSize((100, -1))
        self.SecondaryEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.SecondaryEntryBox.SetMinSize((128, -1))
        self.VerseRangeLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.RangeEntryBox.SetMinSize((20, -1))
        self.SearchButton.SetForegroundColour(wx.Colour(142, 35, 35))
        #self.SearchButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        #self.DispLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.WholeWord.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        
        #self.Stats.SetMinSize((180, 170))
        #self.PreviousButton.SetMinSize((30, -1))
        #self.NextButton.SetMinSize((30, -1))

    def __do_layout(self):
        MainSize = wx.BoxSizer(wx.VERTICAL)
        RangeStaticBox = wx.StaticBoxSizer(self.RangeBox, wx.VERTICAL)

        MatchSizer = wx.BoxSizer(wx.HORIZONTAL)
        entrySizer1 = wx.BoxSizer(wx.HORIZONTAL)
        entrySizer2 = wx.BoxSizer(wx.HORIZONTAL)
        ProximitySizer = wx.BoxSizer(wx.HORIZONTAL)
        
        title = FMTitlePanel(self, "Bible Proximity Search")
        MainSize.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        gs = wx.FlexGridSizer(2, 3, 4, 4)  # rows, cols, vgap, hgap
        gs.AddMany([ (self.RadioE,  0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioOT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     (self.RadioNT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioRL, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ])
        
        gs.AddGrowableCol(1)
        gs.AddGrowableCol(3)

        RangeStaticBox.Add(gs, 0, wx.TOP|wx.EXPAND, 6)
        RangeStaticBox.Add(self.rangeEntry, 0, wx.TOP|wx.EXPAND, 6)
        
        MainSize.Add(RangeStaticBox, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        
        MainSize.Add((0, 3))
        MainSize.Add(self.SearchEntryLabel, 0, wx.LEFT, 29)
        entrySizer1.Add(self.SearchEntryBox, 1, wx.EXPAND, 0)
        
        ProximitySizer.Add(self.RangeEntryBox, 0, wx.LEFT, 5)
        ProximitySizer.Add(self.VerseRangeLabel, 0, wx.LEFT|wx.ALIGN_CENTER, 3)
        
        entrySizer1.Add(ProximitySizer, 0, 0, 8)

        MainSize.Add(entrySizer1, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        
        MainSize.Add((0, 2))
        MainSize.Add(self.SecondaryEntryLabel, 0, wx.LEFT, 29)
        entrySizer2.Add(self.SecondaryEntryBox, 1, wx.EXPAND, 0)
        entrySizer2.Add(self.WholeWord, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 8)
        MainSize.Add(entrySizer2, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        
        MainSize.Add(self.SearchButton, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 12)
        
        MainSize.Add((0, 8))
        MainSize.Add(self.Stats, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        
        MatchSizer.Add(self.PreviousButton, 0, wx.RIGHT, 3)
        MatchSizer.Add(self.NextButton, 0, wx.LEFT, 3)
        MainSize.Add(MatchSizer, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 5)
        
        self.SetAutoLayout(True)
        self.SetSizer(MainSize)
        self.Layout()
        
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioE, self.RadioE)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioOT, self.RadioOT)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioNT, self.RadioNT)
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.SearchEntryBox)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.SecondaryEntryBox)
        self.Bind(wx.EVT_BUTTON, self.OnSearch, self.SearchButton)
        
        self.Bind(wx.EVT_BUTTON, self.OnPrevious, self.PreviousButton)
        self.Bind(wx.EVT_BUTTON, self.OnNext, self.NextButton)
        
        self.Bind(wx.EVT_TEXT, self.OnRangeChange, self.rangeEntry)
        
        self.RadioRL.Enable(False)
        self.PreviousButton.Enable(False)
        self.NextButton.Enable(False)
        self.WholeWord.SetValue(True)
    
    def OnRadioE(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Revelation')

    def OnRadioOT(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Malachi')
        
    def OnRadioNT(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Matthew - Revelation')
        
    def OnRadioRL(self, event):
        self.rangeEntry.SetValue('Matthew - Revelation')
        self.rangeEntry.Enable(False)
        
    def OnRangeChange(self, event):
        self.RadioE.SetValue(False)
        self.RadioOT.SetValue(False)
        self.RadioNT.SetValue(False)
    
    def OnPrevious(self, event):
        self.OnPrevProx(None)
        
    def OnNext(self, event):
        self.OnNextProx(None)
    
        
    def OnSearch(self, event):
        if self.SearchEntryBox.GetValue() == '':
            return
 
        entry = self.SearchEntryBox.GetValue()
        sec = self.SecondaryEntryBox.GetValue()
        vsRng = self.RangeEntryBox.GetValue()
        secWL = sec.split()
        
        rng = self.rangeEntry.GetValue()
        self.mainApp.multiRngLen = 0
        
        self.PreviousButton.Enable(False)


        idxList, self.fixedRef = fixRef.parseRng(rng)        
        if not idxList or 'rngError' in idxList:
            #dialogs.rangeError(self)
            return
        
        
        full = 0
        if self.WholeWord.IsChecked():
            full = 1
        
        self.NextButton.Enable(True)
        
        redSearch = 0
        if self.RadioRL.GetValue() == True:
            redSearch = 1
                
        self.DisplaySearch(entry, secWL, 2, vsRng, full, redSearch, idxList)
        
        self.rangeEntry.Append(rng)           


    def DisplaySearch(self, entry, secWL, select, vsRng, full, redSearch, idxList):
        tab = self.mainApp.bibNB.GetSelection()
        if tab == len(self.mainApp.bibFileList):
            dialogs.noAdvSearchParallel(self.mainApp)
            return
        
        self.BibleDisplay = self.mainApp.bibDisplay[tab]
        
        self.fName = self.mainApp.bibFileList[tab]
        
        dist = []
        self.entry = entry
        

        secWords = ', '.join(secWL)
        
        self.secWL = secWL
        self.vsRng = vsRng
        self.sWord = self.entry
        self.next = 0
        self.count = 1
        
        wx.BeginBusyCursor()
        
        result, self.matches, distList, ref = self.advSearch.Proximity(self.entry, self.secWL, self.fName,\
        self.mainApp.bAbbrList[tab], int(vsRng), full, self.mainApp.font, self.mainApp.showRed, redSearch, idxList, self.fixedRef)
        
        if ref != 'Not Found':
            abbr = ref[:3]
            fRef = fixRef.fullTitle(abbr)
            fRef = fRef + ref[3:]
            
            for num in range(len(secWL)):
                dist.append('<font color="#660000"><b>%s</b></font> - %s words' % (secWL[num], distList[num]))     
            
            avg = sum(distList)/len(distList)
            
        else:
            self.NextButton.Enable(False)
            fRef = ref
            avg = 0
        

        answer = '''<center>Distance from <font color="#660000"><b>%s</b></font> in <b>%s</b>:</center><br><br>
        %s<br><br>Average - %s words<br><br><center><b>Match <font color="#660000">1</font> of %s</b></center></font>'''


        self.Stats.SetPage(answer % (self.entry, fRef, '<br>'.join(dist), avg, self.matches))


        self.mainApp.Showing = result
        tabLabel = 'Prox'
        title = 'Proximity Search Results'

        if self.matches == 1:
            self.NextButton.Enable(False)
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        
        page = self.mainApp.FindWindowByName('Res/Prox')
        if page:

            page.SetPage(result)

            wx.EndBusyCursor()

            return

        
        self.CheckWinState.CheckState()
        

        wx.EndBusyCursor()
        self.mainApp.searchQList.append('')
        
        self.mainApp.AddResult(tabLabel, title, result)

        advSearch.masterVerseString.append('')
        advSearch.masterVerseIdx.append('')
    
        
    
    def OnNextProx(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        self.next += 1
        self.count += 1
        self.PreviousButton.Enable(True)
        
        if self.count == self.matches:
            self.NextButton.Enable(False)
        else:
            #self.PreviousButton.Enable(True)
            self.NextButton.Enable(True)
        result, distList, ref = self.advSearch.proxNext(self.next, self.entry, self.secWL, int(self.vsRng), self.mainApp.font, self.mainApp.bAbbrList[tab], self.fixedRef, self.fName)
        

        #try:

        page = self.mainApp.FindWindowByName('Res/Prox')
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        

        page.SetPage(result)
        page.SetFocus()

        #except:
        #    print 'Exception'

        #    pass

        
        dist = []
        
        abbr = ref[:3]
        fRef = fixRef.fullTitle(abbr)
        fRef = fRef + ref[3:]
        
        for num in range(len(self.secWL)):
            dist.append('<font color="#660000"><b>%s</b></font> - %s words' % (self.secWL[num], distList[num]))
        
        avg = sum(distList)/len(distList)
        
        answer = '''<center>Distance from <font color="#660000"><b>%s</b></font> in <b>%s</b>:</center><br><br>
        %s<br><br>Average - %s words<br><br><center><b>Match <font color="#660000">%s</font> of %s</b></center></font>'''
        
        self.Stats.SetPage(answer % (self.entry, fRef, '<br>'.join(dist), avg, self.count, self.matches))
        
        self.CheckWinState.CheckState()


    def OnPrevProx(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        self.next -= 1
        self.count = self.count - 1
        self.NextButton.Enable(True)
        
        if self.count == 1:
            self.PreviousButton.Enable(False)
        else:
            self.PreviousButton.Enable(True)
            
        result, distList, ref = self.advSearch.proxNext(self.next, self.entry, self.secWL, int(self.vsRng), self.mainApp.font, self.mainApp.bAbbrList[tab], self.fixedRef, self.fName)
        
        try:

            page = self.mainApp.FindWindowByName('Res/Prox')
            
            if self.mainApp.fontSize > 0:
                result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        

            page.SetPage(result)
            page.SetFocus()            

        except:
            print 'Exception'

            pass

        
        dist = []
        abbr = ref[:3]
        fRef = fixRef.fullTitle(abbr)
        fRef = fRef + ref[3:]
        
        for num in range(len(self.secWL)):
            dist.append('<font color="#660000"><b>%s</b></font> - %s words' % (self.secWL[num], distList[num]))
        
        avg = sum(distList)/len(distList)
        
        answer = '''<center>Distance from <font color="#660000"><b>%s</b></font> in <b>%s</b>:</center><br><br>
        %s<br><br>Average - %s words<br><br><center><b>Match <font color="#660000">%s</font> of %s</b></center></font>'''
        
        self.Stats.SetPage(answer % (self.entry, fRef, '<br>'.join(dist), avg, self.count, self.matches))
        
        self.CheckWinState.CheckState()



        
## WordList Mini and Functions

class WordListMini(wx.Panel):
    def __init__(self, *args, **kwds):
        wx.Panel.__init__(self, *args, **kwds)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()
        
        self.RangeBox = wx.StaticBox(self, -1, "Search Range")
        self.RadioE = wx.RadioButton(self, -1, 'Entire Bible', style = wx.RB_GROUP)
        self.RadioOT = wx.RadioButton(self, -1, 'Old Test.')
        self.RadioNT = wx.RadioButton(self, -1, 'New Test.')
        self.RadioRL = wx.RadioButton(self, -1, 'Red Letter')
        
        ranges = ['Gen - Deu', 'Luk, Acts', 'Joh, 1Joh - 3Joh, Rev', 'Rom - Phm']
        self.rangeEntry = wx.ComboBox(self, -1, 'Genesis - Revelation', choices = ranges, size=(170, -1))
        
        self.WordListEntryLabel = wx.StaticText(self, -1, "Enter Reference")
        self.WordListEntry = wx.TextCtrl(self, -1, "", size=(95, -1), style=wx.TE_PROCESS_ENTER)
        self.WordListMethod = wx.RadioBox(self, -1, "Select Method", size=(185, -1), choices=["Word List of Range", "Word Occurrences by Book", "Word Form From String", "List of Capital Letters", "Verses with Same Reference"], majorDimension=1, style=wx.RA_SPECIFY_COLS)
        self.WordListButton = wx.Button(self, -1, "Analyze")
        self.WordListOptions = wx.RadioBox(self, -1, "Word List Sort Options", size=(180, -1), choices=["By Word       ", "By Freq."], majorDimension=1, style=wx.RA_SPECIFY_ROWS)
        self.WordFormOptions = wx.RadioBox(self, -1, "Word Form Options", size=(180, -1), choices=["Word Beg.", "Within Word", "Word End", "Find All"], majorDimension=2, style=wx.RA_SPECIFY_COLS)

        self.__set_properties()
        self.__do_layout()


    def __set_properties(self):
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.WordListEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.WordListEntry.SetMinSize((85, -1))
        #self.WordListMethod.SetMinSize((180, -1))
        self.WordListMethod.SetSelection(0)
        self.WordListButton.SetForegroundColour(wx.Colour(142, 35, 35))
        #self.WordListButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        #self.WordListOptions.SetMinSize((180, -1))
        self.WordListOptions.SetSelection(0)
        #self.WordFormOptions.SetMinSize((180, -1))
        self.WordFormOptions.SetSelection(0)

    def __do_layout(self):
        WordListSizer = wx.BoxSizer(wx.VERTICAL)

        RefEntrySizer = wx.BoxSizer(wx.HORIZONTAL)


        RangeStaticBox = wx.StaticBoxSizer(self.RangeBox, wx.VERTICAL)
        
        gs = wx.FlexGridSizer(2, 3, 4, 4)  # rows, cols, vgap, hgap
        gs.AddMany([ (self.RadioE,  0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioOT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     (self.RadioNT, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ((-1, -1)),
                     (self.RadioRL, 0, wx.ALIGN_LEFT|wx.EXPAND),
                     ])
        
        gs.AddGrowableCol(1)
        gs.AddGrowableCol(3)

        RangeStaticBox.Add(gs, 0, wx.TOP|wx.EXPAND, 6)
        RangeStaticBox.Add(self.rangeEntry, 0, wx.TOP|wx.EXPAND, 6)
        
        title = FMTitlePanel(self, "Bible Word List Search")
        WordListSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        WordListSizer.Add(RangeStaticBox, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        WordListSizer.Add((-1, 5))


        RefEntrySizer.Add(self.WordListEntry, 1, wx.ALL|wx.EXPAND, 3)

        RefEntrySizer.Add(self.WordListEntryLabel, 0, wx.ALL|wx.ALIGN_CENTER, 3)

        

        

        WordListSizer.Add(self.WordListMethod, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        

        WordListSizer.Add(RefEntrySizer, 0, wx.LEFT|wx.RIGHT|wx.TOP|wx.EXPAND, 5)



        WordListSizer.Add(self.WordListButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL, 10)

        WordListSizer.Add(self.WordListOptions, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        WordListSizer.Add((-1, 5))

        WordListSizer.Add(self.WordFormOptions, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        self.SetAutoLayout(True)

        self.SetSizer(WordListSizer)

        self.Layout()

        
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioE, self.RadioE)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioOT, self.RadioOT)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioNT, self.RadioNT)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioRL, self.RadioRL)
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnAnalyze, self.WordListEntry)

        self.Bind(wx.EVT_BUTTON, self.OnAnalyze, self.WordListButton)

        self.Bind(wx.EVT_RADIOBOX, self.OnSel, self.WordListMethod)
        
        self.Bind(wx.EVT_TEXT, self.OnRangeChange, self.rangeEntry)


        

        self.OnSel(None)

        
    def OnRadioE(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Revelation')

    def OnRadioOT(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Genesis - Malachi')

    def OnRadioNT(self, event):
        self.rangeEntry.Enable(True)     
        self.rangeEntry.SetValue('Matthew - Revelation')
        
    def OnRadioRL(self, event):
        self.rangeEntry.SetValue('Matthew - Revelation')
        self.rangeEntry.Enable(False)
        
    def OnRangeChange(self, event):
        self.RadioE.SetValue(False)
        self.RadioOT.SetValue(False)
        self.RadioNT.SetValue(False)
        self.RadioRL.SetValue(False)
    

    def OnSel(self, event):
        if self.WordListMethod.GetSelection() != 0:
            self.WordListOptions.Enable(False)
        else:
            self.WordListOptions.Enable(True)
        
        if self.WordListMethod.GetSelection() != 2:
            self.WordFormOptions.Enable(False)
        else:
            self.WordFormOptions.Enable(True)
        
        if self.WordListMethod.GetSelection() == 0 or self.WordListMethod.GetSelection() == 3:
            self.WordListEntry.Enable(False)
            self.rangeEntry.Enable(True)
            self.RadioE.Enable(True)
            self.RadioOT.Enable(True)
            self.RadioNT.Enable(True)
            self.RadioRL.Enable(True)
        
        elif self.WordListMethod.GetSelection() == 1:
            self.WordListEntry.Enable(True)
            self.rangeEntry.Enable(False)
            self.RadioE.Enable(False)
            self.RadioOT.Enable(False)
            self.RadioNT.Enable(False)
            self.RadioRL.Enable(False)          
            self.WordListEntryLabel.SetLabel('Enter Word')
        
        elif self.WordListMethod.GetSelection() == 2:
            self.rangeEntry.Enable(False)
            self.RadioE.Enable(False)
            self.RadioOT.Enable(False)
            self.RadioNT.Enable(False)
            self.RadioRL.Enable(False)
            self.WordListEntry.Enable(True)            
            self.WordListEntryLabel.SetLabel('Enter String')
        
        elif self.WordListMethod.GetSelection() == 4:
            self.rangeEntry.Enable(False)
            self.RadioE.Enable(False)
            self.RadioOT.Enable(False)
            self.RadioNT.Enable(False)
            self.RadioRL.Enable(False)
            self.WordListEntry.Enable(True)            
            self.WordListEntryLabel.SetLabel('Enter Ref. (3:16)')
    
    def OnAnalyze(self, event):
        tab = self.mainApp.bibNB.GetSelection()
        if tab == len(self.mainApp.bibFileList):
            dialogs.noWListStatParallel(self.mainApp)
            return

        rng = self.rangeEntry.GetValue()
        self.mainApp.multiRngLen = 0
        fn = self.mainApp.bibFileList[self.mainApp.bibNB.GetSelection()]

        

        ctrl = 0

        if wx.GetKeyState(wx.WXK_CONTROL):

            ctrl = 1


        idxList, self.fixedRef = fixRef.parseRng(rng, fn)
        if not idxList or 'rngError' in idxList:
            #dialogs.rangeError(self)
            return

        #self.WordListEntry.SetValue(entry)
        select = self.WordListMethod.GetSelection()
        sort = self.WordListOptions.GetSelection()
        kind = self.WordFormOptions.GetSelection()

        abbr = self.mainApp.bAbbrList[tab]
        text = self.mainApp.bibFileList[tab]
        display = self.mainApp.resNB.GetCurrentPage()

        dispWidth = display.GetClientSize()
        
        redSearch = 0
        if self.RadioRL.GetValue() == True:
            redSearch = 1
        
        self.mainApp.Freeze()
        wx.BeginBusyCursor()
        
        entry = self.WordListEntry.GetValue()
        if select == 0:
            result = stats.wList(idxList, text, sort, redSearch, self.mainApp.font, self.fixedRef, abbr)

            tabLabel = 'List-1'
            entry = self.fixedRef


        if select == 1:
            result = stats.wFreq(entry, text, sort, self.mainApp.font, dispWidth[0])

            tabLabel = 'List-2'

            
        if select == 2:
            result = stats.wForm(entry, text, entry, kind, self.mainApp.font, dispWidth[0])

            tabLabel = 'List-3'



        if select == 3:

            entry = 'Caps'

            result = stats.getCaps(idxList, text, redSearch, self.mainApp.font, self.fixedRef, ctrl)

            tabLabel = 'List-4'

        
        if select == 4:
            entry = re.sub(r'[\. ]', ':', entry)
            result = stats.getSameRef(entry, text, self.mainApp.font)
            tabLabel = 'List-5'

        #tabLabel = 'List - ' + entry
        title = 'Word List, ' + entry
        
        self.mainApp.searchQList.append('')
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        

        self.mainApp.AddResult(tabLabel, title, result)
        
        advSearch.masterVerseString.append('')
        advSearch.masterVerseIdx.append('')
        
        
        self.CheckWinState.CheckState()
        
        self.mainApp.Showing = result
        wx.EndBusyCursor()
        self.mainApp.Thaw()
    
    
    def refError(self):
            dlg = wx.MessageDialog(self, 'Bible Analyzer cannot understand your entry.\nSee Quick Help in Master Control Panel for hints.',
                                         'Entry Error', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()
            return





## Statistics Mini and Functions



class StatMini(wx.Panel):

    def __init__(self, *args, **kwds):

        wx.Panel.__init__(self, *args, **kwds)

        

        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()


        self.StatRefEntryLabel = wx.StaticText(self, -1, "Start Verse")

        self.StatEntryLabel = wx.StaticText(self, -1, "Sequence Interval")

        self.StatEntryLabel2 = wx.StaticText(self, -1, "Sequence Cycles")

        self.StatEntryLabel3 = wx.StaticText(self, -1, "Number of Vowels")
        
        self.StatRefEntry = wx.TextCtrl(self, -1, "Gen 1:1", size=(85, -1), style=wx.TE_PROCESS_ENTER)
        

        self.StatEntry = wx.TextCtrl(self, -1, "", size=(30, -1), style=wx.TE_PROCESS_ENTER)

        self.StatEntry2 = wx.TextCtrl(self, -1, "", size=(30, -1), style=wx.TE_PROCESS_ENTER)

        self.StatEntry3 = wx.TextCtrl(self, -1, "", size=(30, -1), style=wx.TE_PROCESS_ENTER)

        self.StatMethod = wx.RadioBox(self, -1, "Select Method", size=(180, -1), choices=["Data by Sequence", "Verses by Numerical Sum", "Verses by Count(s)", "Various Stats of Verse/Range", "Curious Stats of Book/Range", "Various Stats of all Bibles (slow)"], majorDimension=1, style=wx.RA_SPECIFY_COLS)

        self.StatButton = wx.Button(self, -1, "Analyze")

        self.SequenceOptions = wx.RadioBox(self, -1, "Sequences Options", size=(180, -1), choices=["Verses", "Words", "Letters"], majorDimension=1, style=wx.RA_SPECIFY_COLS)



        self.__set_properties()

        self.__do_layout()





    def __set_properties(self):

        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.StatRefEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.StatEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.StatEntryLabel2.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.StatEntryLabel3.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        #self.StatRefEntry.SetMinSize((85, -1))
        #self.StatEntry.SetMinSize((25, -1))

        #self.StatEntry2.SetMinSize((25, -1))

        #self.StatEntry3.SetMinSize((25, -1))

        #self.StatMethod.SetMinSize((180, -1))

        self.StatMethod.SetSelection(0)

        self.StatButton.SetForegroundColour(wx.Colour(142, 35, 35))

        #self.StatButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))

        #self.SequenceOptions.SetMinSize((180, -1))

        self.SequenceOptions.SetSelection(0)



    def __do_layout(self):

        StatSizer = wx.BoxSizer(wx.VERTICAL)
        RefEntrySizer = wx.BoxSizer(wx.HORIZONTAL)

        EntrySizer1 = wx.BoxSizer(wx.HORIZONTAL)

        EntrySizer2 = wx.BoxSizer(wx.HORIZONTAL)

        EntrySizer3 = wx.BoxSizer(wx.HORIZONTAL)

        

        title = FMTitlePanel(self, "Bible Statistics Search")

        StatSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        StatSizer.Add(self.StatMethod, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        
        RefEntrySizer.Add(self.StatRefEntry, 1, wx.ALL|wx.EXPAND, 3)
        RefEntrySizer.Add(self.StatRefEntryLabel, 0, wx.ALL|wx.ALIGN_CENTER|wx.EXPAND, 3)
        
        EntrySizer1.Add(self.StatEntry, 0, wx.ALL, 3)

        EntrySizer1.Add(self.StatEntryLabel, 0, wx.ALL|wx.ALIGN_CENTER, 3)

        EntrySizer2.Add(self.StatEntry2, 0, wx.ALL, 3)

        EntrySizer2.Add(self.StatEntryLabel2, 0, wx.ALL|wx.ALIGN_CENTER, 3)

        EntrySizer3.Add(self.StatEntry3, 0, wx.ALL, 3)

        EntrySizer3.Add(self.StatEntryLabel3, 0, wx.ALL|wx.ALIGN_CENTER, 3)


        StatSizer.Add(RefEntrySizer, 0, wx.LEFT|wx.TOP|wx.EXPAND, 5)

        StatSizer.Add(EntrySizer1, 0, wx.LEFT, 5)

        StatSizer.Add(EntrySizer2, 0, wx.LEFT, 5)

        StatSizer.Add(EntrySizer3, 0, wx.LEFT, 5)

        

        

        StatSizer.Add(self.StatButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL, 10)

        StatSizer.Add(self.SequenceOptions, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)

        self.SetAutoLayout(True)

        self.SetSizer(StatSizer)

        self.Layout()

        

        self.Bind(wx.EVT_TEXT_ENTER, self.OnDisplayStat, self.StatEntry)

        self.Bind(wx.EVT_TEXT_ENTER, self.OnDisplayStat, self.StatRefEntry)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnDisplayStat, self.StatEntry2)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnDisplayStat, self.StatEntry3)


        self.Bind(wx.EVT_BUTTON, self.OnDisplayStat, self.StatButton)

        self.Bind(wx.EVT_RADIOBOX, self.OnSel, self.StatMethod)

        

        self.OnSel(None)

        self.StatEntryLabel3.Enable(False)

        



    def OnSel(self, event):
        sel = self.StatMethod.GetSelection()

        if sel != 0:

            self.SequenceOptions.Enable(False)

        else:

            self.SequenceOptions.Enable(True)

            

        if sel == 0:
            self.StatRefEntryLabel.SetLabel('Start Verse')

            self.StatEntryLabel.SetLabel('Sequence Interval')

            self.StatEntryLabel2.SetLabel('Sequence Cycles')
            self.StatRefEntryLabel.Enable(True)
            self.StatRefEntry.Enable(True)           
            self.StatEntryLabel.Enable(True)
            self.StatEntry.Enable(True)
            self.StatEntryLabel2.Enable(True)
            self.StatEntry2.Enable(True)
            self.StatEntryLabel3.Enable(False)
            self.StatEntry3.Enable(False)

        
        elif sel == 3 or sel == 4 or sel == 5:
            self.StatRefEntryLabel.SetLabel('Verse or Range')
            self.StatRefEntryLabel.Enable(True)
            self.StatRefEntry.Enable(True)
            self.StatEntryLabel.Enable(False)
            self.StatEntry.Enable(False)
            self.StatEntryLabel2.Enable(False)
            self.StatEntry2.Enable(False)
            self.StatEntryLabel3.Enable(False)
            self.StatEntry3.Enable(False)
            
        elif sel == 1:
            self.StatEntryLabel.SetLabel('Number to Match')
            self.StatRefEntryLabel.Enable(False)
            self.StatRefEntry.Enable(False)
            self.StatEntryLabel.Enable(True)
            self.StatEntry.Enable(True)
            self.StatEntryLabel2.Enable(False)
            self.StatEntry2.Enable(False)
            self.StatEntryLabel3.Enable(False)
            self.StatEntry3.Enable(False)        
                
        elif sel == 2:

            self.StatEntryLabel.SetLabel('Number of Words')

            self.StatEntryLabel2.SetLabel('Number of Letters')
            self.StatRefEntryLabel.Enable(False)
            self.StatRefEntry.Enable(False)
            self.StatEntryLabel.Enable(True)
            self.StatEntry.Enable(True)
            self.StatEntryLabel2.Enable(True)
            self.StatEntry2.Enable(True)
            self.StatEntryLabel3.Enable(True)
            self.StatEntry3.Enable(True)
            

    
    def OnDisplayStat(self, event):
        if self.StatRefEntry.GetValue() == '':
            return
        
        tab = self.mainApp.bibNB.GetSelection()
        if tab == len(self.mainApp.bibFileList):
            dialogs.noWListStatParallel(self.mainApp)
            return
        
        ref = self.StatRefEntry.GetValue()
        select = self.StatMethod.GetSelection()
        
        if select == 3 or select == 4 or select == 5:
            rng = ref
                        

            idxList, self.fixedRef = fixRef.parseRng(rng)
            if not idxList or 'rngError' in idxList:
                #dialogs.rangeError(self)
                return


        
        if select == 4:
            if ',' in ref:
                dlg = wx.MessageDialog(self, 'You must enter a chapter or greater reference,\n(i.e. \'Rom 4:\', \'Rom 4-6\', \'Rom - Gal\')\nAlso, any range must be contiguous.',
                                             'Entry Error', wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()
                return
            
            
        entry1 = self.StatEntry.GetValue()
        entry2 = self.StatEntry2.GetValue()
        entry3 = self.StatEntry3.GetValue()
        seOpt = self.SequenceOptions.GetSelection()
        

        text = self.mainApp.bibFileList[tab]
        abbr = self.mainApp.bAbbrList[tab]

        

        wx.BeginBusyCursor()

        fullStats = stats.fullStats()
        

        if select == 0:
            try:

                num = int(entry1)

                cyc = int(entry2)
                
                idxList, fixedRef = fixRef.parseRng(ref)
                
                result = stats.Sequence(fixedRef, num, cyc, text, self.mainApp.font, seOpt)

             
            except:
                print 'Exception: Sequence'
                dlg = wx.MessageDialog(self, 'You must enter a complete start verse (i.e. Gen 1:1)\nin the first box, and a number in the other two boxes.\nSee User Manual for details.',
                                             'Entry Error', wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()
                wx.EndBusyCursor()
                return
           
            tabLabel = 'Stat-1'
            title = 'Sequence'
        
        if select == 3:
            try:
                if not idxList:
                    result = stats.sGetVerseDetails(ref, text, self.mainApp.font, abbr)
                else:
                    result = stats.sGetRefDetails(idxList, text, self.fixedRef, self.mainApp.font, abbr)
            except:
                dlg = wx.MessageDialog(self, 'You must enter a book (Gen), chapter (Gen 1:), or verse (Gen 1:1)\nor a range (Gen - Lev) for this selection.',
                                             'Entry Error', wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()
                wx.EndBusyCursor()
                return
            
            tabLabel = 'Stat-4'
            title = 'Various Statistics, %s' % ref
        
        if select == 1:
            if entry1.isdigit():
                result = stats.sGetVerseNumerical(entry1, text, self.mainApp.font)
            else:
                dlg = wx.MessageDialog(self, 'You must enter a number for this selection.',
                                             'Entry Error', wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()
                wx.EndBusyCursor()
                return
                
            tabLabel = 'Stat-2' 
            title = 'Verses by Numerical, %s' % entry1
        
        if select == 2:
            try:

                result = stats.sVerseByCount(entry1, entry2, entry3, text, self.mainApp.font)

            except:
                dlg = wx.MessageDialog(self, 'You must enter a number in at least one box for this selection.',
                                             'Entry Error', wx.OK | wx.ICON_INFORMATION	)
                dlg.ShowModal()
                dlg.Destroy()
                wx.EndBusyCursor()
                return
            
            tabLabel = 'Stat-3'
            title = 'Verses by Count'
        
        if select == 4:
            check = re.search(r':\d+', ref)
            

            result = stats.sStats(idxList, text, self.fixedRef, self.mainApp.font)
            tabLabel = 'Stat-5'
            title = 'Book/Chapter Details, %s' % ref
        
        if select == 5:
            result = fullStats.DoStats(idxList, self.mainApp.bibFileList, self.fixedRef, self.mainApp.font)
            tabLabel = 'Stat-6'
            title = 'Table of all Bibles, %s' % ref
        
        self.mainApp.searchQList.append('')

        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
        
        self.mainApp.AddResult(tabLabel, title, result)

        
        advSearch.masterVerseString.append('')

        advSearch.masterVerseIdx.append('')

        
        
        self.CheckWinState.CheckState()
        
        self.mainApp.Showing = result

        wx.EndBusyCursor()

    






## Compare Mini and Functions

class CompareMini(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()

        self.CompSizer3_staticbox = wx.StaticBox(self, -1, "Options")
        self.SelectTextsLabel = wx.StaticText(self, -1, "Select a Text from Each Box")
        self.LeftTextBox = wx.Choice(self, -1, size=(75, 25), choices=self.mainApp.compareList)
        self.RightTextBox = wx.Choice(self, -1, size=(75, 25), choices=self.mainApp.compareList)
        self.EnterRefLabel = wx.StaticText(self, -1, "Enter Book, Chapter, or Verse")
        self.CompareEntry = wx.TextCtrl(self, -1, "", size=(155, -1), style=wx.TE_PROCESS_ENTER)
        self.WordRangeEntry = wx.TextCtrl(self, -1, "10", size=(25, -1))
        self.WordRangeLabel = wx.StaticText(self, -1, "Verse Length Range")
        self.CompareMethod = wx.RadioBox(self, -1, "Compare Method", size=(180, -1), choices=["Word Level", "Keyword Only", "Verse Length Difference"], majorDimension=1, style=wx.RA_SPECIFY_COLS)
        self.RemovePunct = wx.CheckBox(self, -1, "Remove Punctuation")
        self.RemoveCase = wx.CheckBox(self, -1, "Remove Word Case")
        self.AVLabel = wx.StaticText(self, -1, "(AV-1611 only)")
        self.IgnoreSpelling = wx.CheckBox(self, -1, "Ignore Spelling Differences ")
        self.IgnoreCompWords = wx.CheckBox(self, -1, "Ignore Compound Words          ")
        self.CompareButton = wx.Button(self, -1, "Compare")

        self.__set_properties()
        self.__do_layout()


    def __set_properties(self):
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.SelectTextsLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.LeftTextBox.SetMinSize((75, 21))
        #self.RightTextBox.SetMinSize((75, 21))
        self.EnterRefLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.CompareEntry.SetMinSize((155, 21))
        self.CompareEntry.SetFocus()
        #self.WordRangeEntry.SetMinSize((20, -1))
        self.WordRangeLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.CompareMethod.SetMinSize((180, -1))
        self.CompareMethod.SetSelection(0)
        self.AVLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.CompareButton.SetForegroundColour(wx.Colour(142, 35, 35))
        #self.CompareButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))

    def __do_layout(self):
        CompSizer4 = wx.BoxSizer(wx.VERTICAL)
        
        title = FMTitlePanel(self, "Bible Text Comparison")
        CompSizer4.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        CompSizer3 = wx.StaticBoxSizer(self.CompSizer3_staticbox, wx.VERTICAL)
        CompSizer2 = wx.BoxSizer(wx.HORIZONTAL)
        CompSizer1 = wx.BoxSizer(wx.HORIZONTAL)
        CompSizer4.Add(self.SelectTextsLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 5)
        CompSizer1.Add(self.LeftTextBox, 0, wx.RIGHT, 3)
        CompSizer1.Add(self.RightTextBox, 0, wx.LEFT, 3)
        CompSizer4.Add(CompSizer1, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 3)
        CompSizer4.Add(self.EnterRefLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)
        CompSizer4.Add(self.CompareEntry, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.EXPAND, 5)
        CompSizer2.Add(self.WordRangeEntry, 0, wx.RIGHT, 3)
        CompSizer2.Add(self.WordRangeLabel, 0, wx.LEFT|wx.TOP, 3)

        
        CompSizer4.Add(CompSizer2, 0, wx.LEFT, 23)

        CompSizer4.Add((-1, 5))
        CompSizer4.Add(self.CompareMethod, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        CompSizer3.Add(self.RemovePunct, 0, wx.ADJUST_MINSIZE, 0)
        CompSizer3.Add(self.RemoveCase, 0, wx.TOP, 8)
        CompSizer3.Add(self.AVLabel, 0, wx.TOP, 8)
        CompSizer3.Add(self.IgnoreSpelling, 0, wx.TOP|wx.BOTTOM, 3)
        CompSizer3.Add(self.IgnoreCompWords, 0, wx.TOP|wx.BOTTOM, 5)

        CompSizer4.Add((-1, 5))
        CompSizer4.Add(CompSizer3, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        CompSizer4.Add(self.CompareButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL, 15)
        self.SetAutoLayout(True)
        self.SetSizer(CompSizer4)
        self.Layout()
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnCompare, self.CompareEntry)
        self.Bind(wx.EVT_BUTTON, self.OnCompare, self.CompareButton)
        self.Bind(wx.EVT_RADIOBOX, self.Settings, self.CompareMethod)
        
        self.LeftTextBox.SetSelection(0)
        self.RightTextBox.SetSelection(0)
        self.Settings(None)
        
    
    def OnCompare(self, event):
        punct, case, spell, compWords = 0, 0, 0, 0
        if self.RemovePunct.IsChecked(): punct = 1
        if self.RemoveCase.IsChecked(): case = 1
        if self.IgnoreSpelling.IsChecked(): spell = 1
        if self.IgnoreCompWords.IsChecked(): compWords = 1
        text1 = self.LeftTextBox.GetSelection()
        text2 = self.RightTextBox.GetSelection()
        range = self.WordRangeEntry.GetValue()
        entry = self.CompareEntry.GetValue()
        select = self.CompareMethod.GetSelection()
        self.DisplayCompare(entry, select, text1, text2, range, punct, case, spell, compWords)
    
    def Settings(self, event):
        def Clear():
            self.RemovePunct.Enable(True)
            self.RemoveCase.Enable(True)
            self.IgnoreSpelling.Enable(True)
            self.EnterRefLabel.Enable(True)
            self.CompareEntry.Enable(True)
            self.WordRangeEntry.Enable(False)
            self.WordRangeLabel.Enable(False)
            
            self.RemovePunct.SetValue(False)
            self.RemoveCase.SetValue(False)
            self.IgnoreSpelling.SetValue(False)
            
        if self.CompareMethod.GetSelection() == 0:
            self.EnterRefLabel.SetLabel("Enter Reference or Range")
            Clear()
        if self.CompareMethod.GetSelection() == 1:
            self.EnterRefLabel.SetLabel("Enter Keyword or Key-Phrase")
            Clear()
            self.RemovePunct.SetValue(True)
            self.RemoveCase.SetValue(True)
        if self.CompareMethod.GetSelection() == 2:
            self.EnterRefLabel.Enable(False)
            self.CompareEntry.Enable(False)
            self.WordRangeEntry.Enable(True)
            self.WordRangeLabel.Enable(True)
            self.RemovePunct.Enable(False)
            self.RemoveCase.Enable(False)
            self.IgnoreSpelling.Enable(False)
            
            self.RemovePunct.SetValue(True)
            self.RemoveCase.SetValue(True)
            self.IgnoreSpelling.SetValue(True)
    
    
    def DisplayCompare(self, entry, select, text1idx, text2idx, range, punct, case, spell, compWords):
        wx.BeginBusyCursor()

        text1 = self.mainApp.compareFileList[text1idx]
        text2 = self.mainApp.compareFileList[text2idx]
        
        try:
            range = int(range)
        except:
            wx.EndBusyCursor()
            print 'Exception 1702'
            pass
        
        if select == 0:
            if entry == '':
                wx.EndBusyCursor()
                return
            
            idxList, fixedRef = fixRef.parseRng(entry)
            
            if not idxList:
                wx.EndBusyCursor()
                return
            

            try:
                result = compareDiff.wordDiff(idxList, text1, text2, punct, case, spell, compWords, self.mainApp.font, fixedRef)

            except:
                print 'Compare error, 1729'
                wx.EndBusyCursor()
                return
        
        if select == 1:
            if entry == '':
                return

            try:
                result = compareDiff.searchDiff(entry, text1, text2, punct, case, spell, compWords, self.mainApp.font)
            except:
                wx.EndBusyCursor()
                print 'Compare error, 1833'
                return            
            
            fixedRef = entry
            
        if select == 2:
            try:
                result = compareDiff.vLength(range, text1, text2, compWords, self.mainApp.font)
            except:
                wx.EndBusyCursor()
                print 'Compare error, 1751'
                return
            
            fixedRef = ''
        
        tabLabel = 'Comp - ' + fixedRef
        title = 'Comparison Results, ' + fixedRef

        
        self.mainApp.searchQList.append('')
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
             
        self.mainApp.AddResult(tabLabel, title, result)

        advSearch.masterVerseString.append('')
        advSearch.masterVerseIdx.append('')
        
        
        self.CheckWinState.CheckState()
        
        self.mainApp.Showing = result
        wx.EndBusyCursor()
    
    
    
## Library Search Mini and Functions
class LibSearchMini(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()


        self.dctFileList = self.mainApp.dctFileList
        self.cmtFileList = self.mainApp.cmtFileList



        self.dAbbrList = self.mainApp.dAbbrList
        self.cAbbrList = self.mainApp.cAbbrList
        self.cDescList = self.mainApp.cDescList
        self.dDescList = self.mainApp.dDescList
        

        self.Select = wx.RadioBox(self, -1, "Select Group", size=(120, -1), choices=["Dictionary", "Commentary", "Book/Article"], majorDimension=1, style=wx.RA_SPECIFY_COLS)
        self.Single = wx.RadioBox(self, -1, "Select Resource", size=(120, -1), choices=["Single Title", "All Titles" ], majorDimension=1, style=wx.RA_SPECIFY_COLS)
        self.txtChoice = wx.Choice(self, -1, size=(185, 25), choices = [])
        self.SearchEntryLabel = wx.StaticText(self, -1, "Enter Word, Phrase or Ref.")
        self.SearchEntryBox = wx.TextCtrl(self, -1, "", size=(132, -1), style=wx.TE_PROCESS_ENTER)
        self.WholeWord = wx.CheckBox(self, -1, "Whole")
        self.SearchButton = wx.Button(self, -1, "Search")
        self.Totals = wx.StaticText(self, -1, "Search Results Titles")
        self.Tree = wx.TreeCtrl(self, -1, style=wx.TR_HAS_BUTTONS|wx.TR_LINES_AT_ROOT|wx.TR_HIDE_ROOT|wx.BORDER_THEME)
                
        self.__set_properties()
        self.__do_layout()
        
        self.root = self.Tree.AddRoot('Search Results')
        self.Tree.SetItemBold(self.root, True)
        #self.Tree.EnableSelectionVista(True)
        
        
    def __set_properties(self):
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.SearchEntryLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.SearchButton.SetForegroundColour(wx.Colour(142, 35, 35))
        #self.SearchButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))

    def __do_layout(self):
        MainSize = wx.BoxSizer(wx.VERTICAL)
        radioSize = wx.BoxSizer(wx.HORIZONTAL)
        entrySize = wx.BoxSizer(wx.HORIZONTAL)
        
        title = FMTitlePanel(self, "Library Search")
        MainSize.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        

        radioSize.Add(self.Select, 0, wx.RIGHT|wx.EXPAND, 3)
        radioSize.Add((-1, -1), 1, 0)

        radioSize.Add(self.Single, 0, wx.LEFT|wx.EXPAND, 3)
        MainSize.Add(radioSize, 0, wx.RIGHT|wx.LEFT|wx.EXPAND, 8)
        MainSize.Add((0, 5))

        MainSize.Add(self.txtChoice, 0, wx.RIGHT|wx.LEFT|wx.EXPAND, 8)
        
        MainSize.Add(self.SearchEntryLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 5)
        entrySize.Add(self.SearchEntryBox, 1, wx.LEFT|wx.EXPAND, 7)
        entrySize.Add(self.WholeWord, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 5)
        MainSize.Add(entrySize, 0, wx.TOP|wx.EXPAND, 3)

        MainSize.Add(self.SearchButton, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        MainSize.Add(self.Totals, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 5)
        MainSize.Add(self.Tree, 1, wx.EXPAND|wx.LEFT|wx.RIGHT, 5)
        self.SetSizer(MainSize)
        self.Layout()
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.SearchEntryBox)
        self.Bind(wx.EVT_BUTTON, self.OnSearch, self.SearchButton)
        self.Bind(wx.EVT_RADIOBOX, self.OnSingle, self.Single)
        self.Bind(wx.EVT_RADIOBOX, self.OnLibSelect, self.Select)
        
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnSelChanged)
        
        self.WholeWord.SetValue(True)
        self.OnSingle(None)
        self.OnLibSelect(None)

    def OnSingle(self, event):
        if self.Single.GetSelection() == 1:
            self.txtChoice.Enable(False)
        else:
            self.txtChoice.Enable(True)
        
    def OnLibSelect(self, event):
        self.txtChoice.Clear()
        if self.Select.GetSelection() == 2:
            for item in self.mainApp.bkData:
                self.txtChoice.Append(item[1])
        elif self.Select.GetSelection() == 1:
            for item in self.cDescList:
                self.txtChoice.Append(item)
        else: 
            for item in self.dDescList:
                self.txtChoice.Append(item)
        self.txtChoice.SetSelection(0)
    
    
    def BuildTree(self, txtList, result, totals):
        self.Freeze()
        self.Tree.DeleteChildren(self.root)
        idx = 0
        while idx < len(result):
            cnt = len(result[idx])
            if cnt < 1:
                idx += 1
                continue
            self.title = txtList[idx] + ', (%s entries)' % cnt
            child = self.Tree.AppendItem(self.root, self.title)
            self.Tree.SetItemBold(child, True)
            self.Tree.SetPyData(child, idx)
                
            cyc = 0
            while cyc < len(result[idx]):
                entry = '%s' % unicode(result[idx][cyc][0], 'utf-8')
                self.Tree.AppendItem(child, entry)
                cyc += 1
            idx += 1
            
        self.Totals.SetLabel(totals)
        self.Layout()
        self.Thaw()

 
    def OnSearch(self, event):
        if self.SearchEntryBox.IsEmpty():
            return

        

        full = 0

        self.entry = self.SearchEntryBox.GetValue()

        

        self.refEntry = 0        

        if ':' in self.entry:

            self.refEntry = 1
            self.entry = fixRef.prelimFix(self.entry)
            self.entry = re.sub(r' (\d)', r'_\1', self.entry)
            
            self.entry = fixRef.refMatch(self.entry)            

        
        if self.WholeWord.IsChecked(): full = 1
        
        if self.Single.GetSelection() == 0:
            wx.BeginBusyCursor()
            txtList = []
            txtAbbr = []
            self.txtIdx = self.txtChoice.GetSelection()
            if self.Select.GetSelection() == 2:
                txt = self.mainApp.bkData[self.txtIdx][2]
                txtAb = self.mainApp.bkData[self.txtIdx][1]
                type = 2
            elif self.Select.GetSelection() == 0:
                txt = self.dctFileList[self.txtIdx]
                txtAb = self.dAbbrList[self.txtIdx]

                type = 0
            else:
                txt = self.cmtFileList[self.txtIdx]
                txtAb = self.cAbbrList[self.txtIdx]

                type = 1
            
            txtList.append(txt)
            txtAbbr.append(txtAb)
            

            try:

                result, totals = normSearch.libSearch(self.entry, txtList, full, type, self.refEntry)

            except:

                print 'Exception: SingleSearch'
                wx.EndBusyCursor()

                return

            

            self.BuildTree(txtAbbr, result, totals)
            
            item = self.Tree.GetFirstVisibleItem()
            try:
                child = self.Tree.GetFirstChild(item)
                self.Tree.SelectItem(child[0])
            except:
                print 'Exception: GetFirstChild'
                pass
            
            wx.EndBusyCursor()
                
        else:
            wx.BeginBusyCursor()

            
            if self.Select.GetSelection() == 0:
                type = 0
                fList = self.dctFileList
                abbrList = self.dAbbrList
            elif self.Select.GetSelection() == 1:
                type = 1
                fList = self.cmtFileList
                abbrList = self.cAbbrList
            else:
                type = 2
                fList = []
                abbrList = []
                for set in self.mainApp.bkData:
                    abbrList.append(set[1])
                    fList.append(set[2])
            try:

                result, totals = normSearch.libSearch(self.entry, fList, full, type, self.refEntry)
            except:
                print 'Multi-book search exception'
                wx.EndBusyCursor()
                return
            
            self.BuildTree(abbrList, result, totals)
            wx.EndBusyCursor()
            



    def OnSelChanged(self, event):
        try:
            item = event.GetItem()
            parent = self.Tree.GetItemParent(item)
            parentTitle = re.sub(r', \(\d+\)$', '', self.Tree.GetItemText(parent))

            if parent == self.Tree.GetRootItem():
                return
            
            if self.Single.GetSelection() == 0:
                idx = self.txtIdx
            else:
                idx = self.Tree.GetPyData(parent)
            
            title = self.Tree.GetItemText(item)
        except:
            print 'Exception: GetItemParent (no hits)'
            return
                
        if self.Select.GetSelection() == 0 and idx != None:
            #self.mainApp.Freeze()
            #self.mainApp.dctEntry.SetValue(title)
            #if self.mainApp.dctNB.GetSelection() != idx:
            #    self.mainApp.dctNB.SetSelection(idx)

            #    self.mainApp.OnDctNBChanged(None)

            #if self.mainApp.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
                #if self.mainApp.dctNB.GetSelection() != idx:
                #    self.mainApp.GetWordList(idx)
                
                #self.mainApp.dctListbox.SetItemCount(len(self.mainApp.currentWL))
                #item = self.mainApp.FindDctEntry(self.mainApp.dctEntry.GetValue())
                #if item:
                #    self.mainApp.dctListbox.EnsureVisible(item)
                #    self.mainApp.dctListbox.Select(item)
            
            display = self.mainApp.dctDisplay[idx]
            file = self.dctFileList[idx]
            

            try:
                answer = normSearch.LibHitSearch(self.entry, file, title, parentTitle)
            except:
                print 'Exception: LibHitSearch #2083'

                return


            #if self.mainApp.fontSize > 0:
            #    answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)
            
            #display.SetPage(answer)
            #if '<a name="line">' in answer:
            #    display.ScrollToAnchor('line')
            #    display.ScrollLines(-2)
            
            #self.mainApp.RemoveImages(fNames)
            
            #self.mainApp.dctCurrent = answer
            #self.mainApp.Thaw()
            
        elif self.Select.GetSelection() == 1 and idx != None:
            #self.mainApp.Freeze()
            #self.mainApp.cmtEntry.SetValue(title)
            #if self.mainApp.cmtNB.GetSelection() != idx+1:
            #    self.mainApp.cmtNB.SetSelection(idx+1)
            #    self.mainApp.OnCmtNBChanged(None)
                
            #if self.mainApp.cmtNB.cmtPanel.miniTB.GetToolToggled(707) == True:
            #    if self.mainApp.cmtNB.GetSelection() != idx+1:
            #        self.mainApp.GetVerseList(idx)
                    
            #    self.mainApp.cmtListbox.SetItemCount(len(self.mainApp.currentWL))
            #    item = self.mainApp.FindCmtEntry(self.mainApp.cmtEntry.GetValue())
            #    if item:
            #        self.mainApp.cmtListbox.EnsureVisible(item)
            #        self.mainApp.cmtListbox.Select(item)
            

            file = self.cmtFileList[idx]

            display = self.mainApp.cmtDisplay[idx]

            
            answer = normSearch.LibHitSearch(self.entry, file, title, parentTitle)
            
            #if self.mainApp.fontSize > 0:
            #    answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)
            
            #display.SetPage(answer)
            #if '<a name="line">' in answer:
            #    display.ScrollToAnchor('line')
            #    display.ScrollLines(-2)
            
            #self.mainApp.RemoveImages(fNames)
            
            #self.mainApp.cmtCurrent = answer
            #self.mainApp.Thaw()
        
        elif idx != None:
            #self.mainApp.Freeze()

            file = self.mainApp.bkData[idx][2]
            
            #if self.mainApp.showBkWin == 0:
            #    if self.mainApp.resNB.GetSelection() != 1:
            #        self.mainApp.resNB.SetSelection(1)
            #        self.mainApp.OnResNBChanged(None)
                
            #    display = self.mainApp.bookDisplay
            #else:
            #    display = self.mainApp.bkWinDisplay                                
            #    self.mainApp.bkWin.Show()
                
            #print self.entry, title, file, self.mainApp.txtColor, self.mainApp.font, self.Select.GetSelection(), self.refEntry, self.WholeWord.GetValue()
            
            answer = normSearch.LibHitSearch(self.entry, file, title, parentTitle)

            #if self.mainApp.fontSize > 0:
            #    answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)
            
            #display.SetPage(answer)
            #if '<a name="line">' in answer:
            #    display.ScrollToAnchor('line')
            #    display.ScrollLines(-2)

            
            self.CheckWinState.CheckState()
            
            #self.mainApp.RemoveImages(fNames)
            
            self.mainApp.resultCurrent[0] = answer
            self.mainApp.prePage = answer
            #self.mainApp.Thaw()



## Dual Bible
class DualBible(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = utility.CheckWinState()

        
        self.fList = self.mainApp.bibFileList
        textList = self.mainApp.bAbbrList
        
        self.Tree1 = baseClass.CustomTreeCtrl(self)
        self.Tree2 = baseClass.CustomTreeCtrl(self)
        self.choice1 = wx.Choice(self, -1, choices=textList)
        self.choice2 = wx.Choice(self, -1, choices=textList)
        self.syncLabel = wx.StaticText(self, -1, 'Sync Chapters')
        self.syncButton = wx.Button(self, -1, "Sync")
        

        self.syncButton.SetForegroundColour(wx.Colour(142, 35, 35))

        #self.syncButton.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))

        

        self.Tree1.SetMinSize((90, 340))
        self.Tree2.SetMinSize((90, 340))

        self.syncLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        mainSizer = wx.BoxSizer(wx.VERTICAL)
        
        title = FMTitlePanel(self, "Dual Bible Viewer")
        mainSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        treeSizer = wx.BoxSizer(wx.HORIZONTAL)
        choiceSizer = wx.BoxSizer(wx.HORIZONTAL)
        
        treeSizer.Add(self.Tree1, 1, wx.ALIGN_CENTER|wx.LEFT|wx.RIGHT|wx.EXPAND, 5)
        treeSizer.Add(self.Tree2, 1, wx.ALIGN_CENTER|wx.RIGHT|wx.LEFT|wx.EXPAND, 5)
        mainSizer.Add(treeSizer, 1, wx.ALIGN_CENTER|wx.EXPAND, 0)
        
        choiceSizer.Add(self.choice1, 0, wx.RIGHT, 12)
        choiceSizer.Add(self.choice2, 0, wx.LEFT, 12)
        mainSizer.Add(choiceSizer, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 5)
        
        mainSizer.Add(self.syncLabel, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.TOP, 10)
        mainSizer.Add(self.syncButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.TOP|wx.BOTTOM, 3)
        #self.SetAutoLayout(True)
        self.SetSizer(mainSizer)
        
        sel = self.mainApp.bibNB.GetSelection()
        
        self.choice1.SetSelection(sel)
        self.choice2.SetSelection(0)
        
        self.bib1 = self.choice1.GetStringSelection()
        self.bib2 = self.choice2.GetStringSelection()
        
        self.Bind(wx.EVT_CHOICE, self.OnChoice1, self.choice1)
        self.Bind(wx.EVT_CHOICE, self.OnTree2Sel, self.choice2)
        
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnTree2Sel, self.Tree2)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnTree1Sel, self.Tree1)
        self.Bind(wx.EVT_BUTTON, self.syncTexts, self.syncButton)


    
    def OnChoice1(self, event):
        idx = self.choice1.GetSelection()
        self.mainApp.bibNB.SetSelection(idx)
        self.bib1 = self.choice1.GetStringSelection()
        self.mainApp.OnSelChanged(None)
        self.mainApp.Freeze()
        self.mainApp.dualLabelPanel.SetLabel('%s - Dual Bible - %s' % (self.bib1, self.bib2))
        self.mainApp.Thaw()
        
    
    #Just sends reference to the main tree
    def OnTree1Sel(self, event):
        self.TreeSel = self.Tree1.GetSelection()
        if self.Tree1.GetItemParent(self.TreeSel) == self.Tree1.root:
            return
        
        #self.mainApp.Freeze()
        parent = self.Tree1.GetItemParent(self.TreeSel)
        label = self.Tree1.GetItemText(parent)
        tRef1 = '%s %s:' % (label, self.Tree1.GetItemText(self.TreeSel))
        
        self.mainApp.OnChapDisplay(tRef1)
        self.mainApp.currentRef = tRef1
        self.mainApp.StatusUpdate()
        self.mainApp.noTreeProcess = 1
        
        try:
            self.mainApp.Tree.SelectItem(self.mainApp.Tree.bookId[label])
            self.mainApp.noTreeProcess = 0
        except:
            print 'Dual Exception'
            self.mainApp.noTreeProcess = 0
            return
        
        #if self.mainApp.cmtNB.cmtPanel.cmtSync.GetValue() == True:
        #    self.mainApp.OnNB4Changed(None)
        
        #self.mainApp.Thaw()
        
    
    def OnTree2Sel(self, event):
        self.TreeSel = self.Tree2.GetSelection()
        if self.Tree2.GetItemParent(self.TreeSel) == self.Tree2.root:
            return
        
        #self.mainApp.Freeze()
        parent = self.Tree2.GetItemParent(self.TreeSel)
        label = self.Tree2.GetItemText(parent)
        
        tRef2 = label + ' ' + self.Tree2.GetItemText(self.TreeSel) + ':'
        idx = self.choice2.GetSelection()
        self.bib2 = self.choice2.GetStringSelection()
        text2 = self.fList[idx]
        

        title = 'Dual Bible Viewer'

        tabLabel = 'Dual'

        
        answer = normSearch.nView(tRef2, '', text2, self.mainApp.font, self.mainApp.showRed, self.mainApp.showText, self.mainApp.showStrongs, self.mainApp.paragraph, 1)
        
        if self.mainApp.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)
        

        page = self.mainApp.FindWindowByName('Dual')
        if page:

            page.SetPage(answer)

        
        self.mainApp.dualLabelPanel.SetLabel('%s - Dual Bible - %s' % (self.bib1, self.bib2))

        #self.mainApp.Thaw()
    
        
    
    def MatchMainTree(self):
        #self.mainApp.Freeze()
        
        ref = self.mainApp.currentRef
        if ':' in ref:
            idx = ref.find(':')
            chap = ref[:idx]
        else:
            chap = ref + '1'
        chap = chap.replace(' ', '')
        
        text = self.mainApp.bibNB.GetSelection()
        self.choice1.SetSelection(text)
        
        self.Tree1.SelectItem(self.Tree1.chapId[chap])
        #self.mainApp.Thaw()
               
    
    def syncTexts(self, event):
        #self.mainApp.Freeze()

        self.MatchMainTree()
        sel = self.Tree1.GetSelection()
        parent = self.Tree1.GetItemParent(sel)
        label = self.Tree1.GetItemText(parent)
        tRef = label + self.Tree1.GetItemText(sel)
        
        self.mainApp.dualLabelPanel.SetLabel('%s - Dual Bible - %s' % (self.bib1, self.bib2))
                
        self.Tree2.SelectItem(self.Tree2.chapId[tRef])
        #self.mainApp.Thaw()
        


## Popup Search Window
class searchWin(wx.Dialog):
    def __init__(self, *args, **kwds):
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)

        
        label = wx.StaticText(self, -1, "Enter Search Word or Phrase\n          (Case Sensitive)")
        self.entry = wx.TextCtrl(self, -1, "")
        sButton = wx.Button(self, wx.ID_OK, "Search", size=(50, 22))
        self.whole = wx.CheckBox(self, -1, "Whole Words Only")

        self.SetTitle("Search Current Page")
        self.SetSize((245, 125))
        self.entry.SetMinSize((150, -1))

        mainSizer = wx.BoxSizer(wx.VERTICAL)
        entrySizer = wx.BoxSizer(wx.HORIZONTAL)
        mainSizer.Add(label, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 8)
        entrySizer.Add(self.entry, 0, wx.LEFT|wx.RIGHT, 10)
        
        entrySizer.Add(sButton, 0, wx.LEFT|wx.RIGHT, 0)
        
        mainSizer.Add(entrySizer, 0, wx.BOTTOM, 5)
        mainSizer.Add(self.whole, 0, wx.LEFT, 10)
        sButton.SetDefault()
        
        self.SetSizer(mainSizer)
        self.Layout()



class PeopleListDlg(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX )
        self.mainApp = wx.GetApp().GetTopWindow()
        
        listPanel = wx.Panel(self, -1)
        txtPanel = wx.Panel(self, -1)
        
        hit = 0
        for fn in self.mainApp.dctFileList:
            if fn.endswith('ExLBP.dct'):
                con = sqlite.connect(fn)
                cur = con.cursor()
                hit = 1
                break
                
        if not hit:
            dlg = wx.MessageDialog(self.mainApp, \
'The Exhaustive Library of Bible People dictionary module (part of the AVp Bundle) is not loaded. \
It is required to generate the Bible Individuals list.\n\
If you have the module, go to Session Manager and be sure it is selected to load. If you don\'t have it, \
go to www.BibleAnalyzer.com for more information.',
                'People Database Not Available', wx.OK | wx.ICON_INFORMATION    )
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        cur.execute('SELECT name FROM names')
        plist = cur.fetchall()
        
        self.peoList = []
        for n in plist:
            self.peoList.append(re.sub(r'^(.+?)(-\d+)', r'<b>\1</b>\2', n[0][:-1]))
        
        #self.peoList = [wd[0][:-1] for wd in plist]

        self.Entry = wx.TextCtrl(listPanel, -1, size=(180, -1), style=wx.TE_PROCESS_ENTER)
        self.WList = wx.SimpleHtmlListBox(listPanel, -1, choices=self.peoList, size=(180, -1))
        
        #self.WList = MyHtmlListBox(listPanel, -1, size=(180, -1))
        #self.WList.SetItemCount(3000)
        #self.WList.SetSelection(0)
        
        txt = wx.StaticText(txtPanel, -1, 'Begin typing to find an individual. Place cursor over name for a preview.\n\n\
Hit "Enter" or click name to select.\n\n\
Search will find all instances of individual.\n\nMore than one name can be entered.')
        txt.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        txt.Wrap(100)

        num = len(self.peoList)

        head = wx.StaticText(txtPanel, -1, 'Exhaustive\nList Of\nBible People') 
        head.SetForegroundColour(wx.Colour(100, 0, 0))
        head.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0))

        total = wx.StaticText(txtPanel, -1, '3084 Individuals\n%s Names' % num) 
        total.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
               
        self.SetTitle('Bible Individuals List')
        self.SetSize((300, 450))
        
        WLSizer = wx.BoxSizer(wx.HORIZONTAL)
        txtSizer = wx.BoxSizer(wx.VERTICAL)
        listSizer = wx.BoxSizer(wx.VERTICAL)
        
        #txtSizer.Add((-1, 10))
        txtSizer.Add(head, 0, wx.ALL|wx.ALIGN_CENTER, 5)
        txtSizer.Add((-1, 10))
        txtSizer.Add(txt, 0, wx.ALL|wx.ALIGN_CENTER, 5)
        txtSizer.Add((-1, 10))
        txtSizer.Add(total, 0, wx.ALL|wx.ALIGN_CENTER, 5)
        
        listSizer.Add((-1, 5))
        listSizer.Add(self.Entry, 0, 0, 0)
        listSizer.Add((-1, 5))
        listSizer.Add(self.WList, 1, wx.EXPAND, 0)
        
        #sizer2.Add(close, 0, wx.ALIGN_RIGHT|wx.BOTTOM|wx.RIGHT, 5)
        listPanel.SetSizer(listSizer)
        txtPanel.SetSizer(txtSizer)
        WLSizer.Add(txtPanel, 1, wx.ALIGN_CENTER, 0)
        WLSizer.Add(listPanel, 0, wx.EXPAND|wx.RIGHT|wx.BOTTOM, 5)
        self.SetSizer(WLSizer)
        self.Layout()
        
        self.Bind(wx.EVT_TEXT, self.OnEntry, self.Entry)
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnEnter, self.Entry)
        self.Bind(wx.EVT_LISTBOX, self.OnEnter, self.WList)
        
        self.WList.Bind(wx.EVT_MOTION, self.OnMotion)
        self.WList.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        
        self.oldIdx = None


    def OnMotion(self, event):
        pos = event.GetPosition()
        idx = self.WList.HitTest(pos)
        if idx == self.oldIdx:
            return
        
        self.oldIdx = idx
        str = self.WList.GetString(idx)
        id = re.search(r'-(\d+)', str).group(1)
        try:
            modIdx = self.mainApp.dAbbrList.index('ExLBP')
            pth = self.mainApp.dctFileList[modIdx]
        except:
            print 'People Dict. missing'
            return

        line = normSearch.showLibTopic(id, pth, self.mainApp.font, self.mainApp.dctColor, self.mainApp.dDescList[modIdx], 0, 1)
        if not line:
            return
        
        if '<sm>' in line:
            line = re.search(r'<sm>(.+)</sm>', line).group(1)
               
        line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
        
        fTxt = '''<body background="memory:bg.png"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Dct)</font><br><font size="%s">&nbsp;Topic on  
        <font color="brown"><b>%s</b></font></font></td></tr></table>
        <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 

        fTxt = fTxt % (self.mainApp.popHeadColor, self.mainApp.popFontSize +2, self.mainApp.dDescList[modIdx], self.mainApp.popFontSize +2, str, self.mainApp.popFontSize +2, line)
        if not fTxt or fTxt == self.mainApp.popRef:
            return
        
        else:
            fTxt = fTxt.replace('Click for more details', 'Click to select individual for search')
            x, y = wx.GetMousePosition()
            self.mainApp.popupCheck()
            self.mainApp.popRef = fTxt

            self.mainApp.toolwin = popup.HtmlPopup(self, fTxt, self.mainApp.popColorIdx, self.mainApp.popFontSize, 0)
            time.sleep(.2)
            self.mainApp.ShowPopup(x, y)
            return            

    
    def leaveWindow(self, event):
        self.mainApp.popupCheck()
        self.oldIdx = None
        

    def FindEntry(self, entry):
        lenth = len(entry)
        data = self.peoList
        for word in data:
            if word[:lenth +3] == '<b>' + entry:
                return data.index(word)

    def OnEntry(self, event):
        entry = self.Entry.GetValue()
        item = self.FindEntry(entry.capitalize())
        if item: 
            self.WList.SetSelection(item)


    def OnEnter(self, event):
        name = self.WList.GetStringSelection()
        self.mainApp.cpMini.FromPeopleButton(name)
        self.Destroy()




class BibListDlg(wx.Dialog):

    def __init__(self, parent):

        wx.Dialog.__init__(self, parent, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX )

        self.mainApp = wx.GetApp().GetTopWindow()



        self.wordListLabel = wx.StaticText(self, -1, "Multi-Bible Search Texts")

        self.wordList = wx.CheckListBox(self, -1, wx.DefaultPosition, wx.DefaultSize, [])

        self.doneButton = wx.Button(self, -1, "Done", size=(40, 25))

                
        self.Bind(wx.EVT_BUTTON, self.OnDone, self.doneButton)
        
        self.SetTitle('Bible Module List')

        self.SetSize((200, 300))

        sizer = wx.BoxSizer(wx.VERTICAL)

        sizer.Add(self.wordListLabel, 0, wx.ALIGN_CENTER|wx.TOP, 7)

        sizer.Add(self.wordList, 1, wx.EXPAND|wx.RIGHT|wx.LEFT, 8)

        sizer.Add((-1, 3))

        sizer.Add(self.doneButton, 0, wx.ALIGN_RIGHT|wx.RIGHT, 8)

        sizer.Add((-1, 3))



        self.SetSizer(sizer)

        self.Layout()



        for num, abbr in enumerate(self.mainApp.bAbbrList):

            self.wordList.Append(abbr)
            if abbr in self.mainApp.bibMultiList:
                self.wordList.Check(num)
                
        #for num in range(self.wordList.GetCount()):
        #    if abbr in self.mainApp.bibMultiList:
        #        self.wordList.Check(num)



    def OnDone(self, event):

        self.mainApp.bibMultiList = []

        cnt = self.wordList.GetCount()        

        for num in range(cnt):

            if self.wordList.IsChecked(num):

                self.mainApp.bibMultiList.append(self.mainApp.bAbbrList[num])

                

        self.Destroy()

        

        



class FindWordMini(wx.Dialog):

    def __init__(self, parent):

        wx.Dialog.__init__(self, parent, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX )

        

        self.mainApp = wx.GetApp().GetTopWindow()

        tab = self.mainApp.bibNB.GetSelection()

        #self.txtList = file('av1769r.wl').readlines()

        

        con = sqlite.connect(self.mainApp.bibFileList[tab])

        #con.text_factory = str

        cur = con.cursor()

        

        cur.execute('SELECT * FROM wordlist')

        wlist = cur.fetchall()
        
        self.txtList = [wd[0] for wd in wlist]

        
        '''

        self.txtList = []

        for wd in wlist:
            try:
                wd = unicode(wd[0], "utf-8")
            except:
                wd = unicode(wd[0], "latin1")
            

            self.txtList.append(wd)

        '''

        

        listPanel = wx.Panel(self, -1)

        txtPanel = wx.Panel(self, -1)

        

        self.Entry = wx.ComboBox(listPanel, -1, choices=[], size=(125, -1), style=wx.CB_DROPDOWN|wx.TE_PROCESS_ENTER)

        self.WList = wx.ListBox(listPanel, -1, choices=self.txtList, size=(125, 183))

        

        txt = wx.StaticText(txtPanel, -1, 'Begin Typing\nto Find Word\n\nHit Enter or\nClick Word\nto Select\
        \n\nWord will be\nAppended to\nSearch Entry')

        txt.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))



        num = len(self.txtList)

        

        total = wx.StaticText(txtPanel, -1, '%s Words' % num) 

        total.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        

        abbr = self.mainApp.bAbbrList[tab]

        

        self.SetTitle('%s - Word List' % abbr)

        self.SetSize((225, 250))

        

        WLSizer = wx.BoxSizer(wx.HORIZONTAL)

        txtSizer = wx.BoxSizer(wx.VERTICAL)

        listSizer = wx.BoxSizer(wx.VERTICAL)

        

        txtSizer.Add((-1, 25))

        txtSizer.Add(txt, 0, wx.ALL|wx.ALIGN_CENTER, 5)

        txtSizer.Add((-1, 25))

        txtSizer.Add(total, 0, wx.ALL|wx.ALIGN_CENTER, 5)

        

        listSizer.Add((-1, 5))

        listSizer.Add(self.Entry, 0, 0, 0)

        listSizer.Add((-1, 5))

        listSizer.Add(self.WList, 1, 0, 0)

        

        #sizer2.Add(close, 0, wx.ALIGN_RIGHT|wx.BOTTOM|wx.RIGHT, 5)

        listPanel.SetSizer(listSizer)

        txtPanel.SetSizer(txtSizer)

        WLSizer.Add(txtPanel, 1, wx.ALIGN_CENTER, 0)

        WLSizer.Add(listPanel, 0, wx.RIGHT|wx.BOTTOM, 5)

        self.SetSizer(WLSizer)

        self.Layout()

        

        #self.Bind(wx.EVT_COMBOBOX, self.OnEntry, self.Entry)

        self.Bind(wx.EVT_TEXT, self.OnEntry, self.Entry)

        

        self.Bind(wx.EVT_TEXT_ENTER, self.OnEnter, self.Entry)

        self.Bind(wx.EVT_LISTBOX, self.OnEnter, self.WList)





    def FindEntry(self, entry):

        lenth = len(entry)

        data = self.txtList

        for word in data:

            if word[:lenth] == entry:

                return data.index(word)



    def OnEntry(self, event):

        entry = self.Entry.GetValue()

        item = self.FindEntry(entry)

        try: 

            self.WList.SetSelection(item)

        except:
            print 'Exception'
            pass



    def OnEnter(self, event):

        word = self.WList.GetStringSelection()

        self.Entry.SetValue(word)
        if wx.GetKeyState(wx.WXK_CONTROL):      
            self.mainApp.cpMini.FromWLButton(word)
        else:
            self.mainApp.cpMini.FromPopupBibSearch(word)

        self.Destroy()





