import wx, os, re, cStringIO 
import sqlite3 as sqlite
import tools.bookConvert
import fixRef, baseClass
import normSearch
import wx.richtext as rt



def noWListStatParallel(app):
    dlg = wx.MessageDialog(app, 'It is not possible to build word lists or statistics for a Bible text while in Parallel View.\n\n\
Click a Tab for a single Bible text in the Bible Panel to make it active then run this utility again.',
    'Parallel Search Notice', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def noAdvSearchParallel(app):
    dlg = wx.MessageDialog(app, 'It is not possible to search a Bible text from Advanced Search or Proximity Search while in Parallel View.\n\n\
To search a single text, click the Tab for that text in the Bible Panel to make it active then search again.\n\n\
If you want to search multiple texts at once, check the option in Advanced Search (A single Bible Tab must still be selected).\n\n\
You can search a word or selection in Parallel View when right-clicking on a word or selection.',
    'Parallel Search Notice', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def noRelatedParallel(app):
    dlg = wx.MessageDialog(app, 'Related Verse Search cannot update while in Parallel Mode.\n\n\
Select a single Bible text tab to use Related Verse Search.',
    'Select Single Bible', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def noTTSParallel(app):
    dlg = wx.MessageDialog(app, 'Text-To-Speech or Audio Verse is not available while in Parallel Mode.\n\n\
Select a single Bible text tab to use Text-To-Speech or Audio Verse Reading.',
    'TTS or Audio Verse Not Available in Parallel Mode', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def noWriteIdx(app):
    dlg = wx.MessageDialog(app, 'Due to the system user priviliges setting, the database index cannot be created.\n\
Often the reason for this is the current user does not have administrative priviliges to allow writing to a file. If Bible Analyzer\
is run once with Adminstrator priviliges, the index files should be created. After that normal user settings would be sufficient.\n\n\
Without the index, the generation of the Library Index will be slower, if possible at all.',
    'Database Index Cannot Be Created', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def noParallelAV(app):
    dlg = wx.MessageDialog(app, 'At least one Authorized Version Bible must be checked.\n\n\
One or more of the "AV," "AVs," "AVp" or "AV-1611" must be checked for proper Parallel Table display.' ,
    'An AV Bible Must Be Selected', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def peoModNotAvailable(app):
    dlg = wx.MessageDialog(app, 'The AV People Edition Bible (AVp) is not loaded or available. This module is required for individual specific searches.\n\n\
See www.BibleAnayzer.com on how to obtain the module along with the Exhaustive Dictionary of Bible People.',
    'AV People Editiom Bible (AVp) Not Selected/Available ', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def peoModNotSelected(app):
    dlg = wx.MessageDialog(app, 'The AV People Edition Bible (AVp) is not the current Bible. It must be selected for individual specific searches. \
Select the "AVp" tab in the Bible Panel and try the search again.',
    'AV People Editiom Bible (AVp) Not Selected', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def vsIndexTTSError(app):
    dlg = wx.MessageDialog(app, 'There was an error reading the text of this chapter.\n\
Contact morton@bibleanalyzer.com for more information.',
    'TTS Reading Error', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def rangeError(app):
    dlg = wx.MessageDialog(app, 'The range specified for this search is not valid for the current Bible.\n\
For instance, specifing an OT book in a NT only Bible\n\n\
Select or enter a range within the range of the current Bible.',
    'Range Error For Current Bible', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def mediaError(app):
    dlg = wx.MessageDialog(app, 'This systen does not appear to have an audio engine installed.\n\
The Bible Analyzer Audio Player will not be able to play audio.',
    'Bible Analyzer Audio Player Error', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def mediaPathError(app):
    dlg = wx.MessageDialog(app, 'The audio file for this chapter cannot be found.\n\
If it exists and has been moved, go to Preferences/Audio Settings and select the current audio folder.\n\
If it does not exist, change the setting in Preferences/Audio Settings to cause the Text-To-Speech voice to read this chapter.',
    'Audio File Not Found', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def ttsError(app):
    dlg = wx.MessageDialog(app, '\
The SAPI Text-To-Speech Engine does not appear to be installed on this system.\n\n\
Without it Bible Analyzer\'s Text-To-Speech feature can not function. Playing Audio Files should still function\n\n\
Bible Analyzer will not attempt to load the TTS engine on next start\n\n',
                           'Text-To-Speech Engine Missing',
                           wx.OK | wx.CANCEL | wx.ICON_INFORMATION
                           )
    if dlg.ShowModal() == wx.ID_OK:
        dlg.Destroy()
                    

def ttsPlayError(app):
    dlg = wx.MessageDialog(app, '\
The SAPI Text-To-Speech Engine does not appear to be installed or properly configured on this system.\n\n\
Without it Bible Analyzer\'s Text-To-Speech feature can not function. Playing Audio Files should still function.',
                           'Text-To-Speech Engine Missing',
                           wx.OK | wx.CANCEL | wx.ICON_INFORMATION
                           )
    if dlg.ShowModal() == wx.ID_OK:
        dlg.Destroy()



def configError(app):
    dlg = wx.MessageDialog(app, 'Your configuration file is corrupted.\n\n\
Restart Bible Analyzer and a new config.ini\nfile will be created with default settings.',
'Bible Analyzer Configuation Error', wx.OK | wx.ICON_INFORMATION	)
    dlg.ShowModal()
    dlg.Destroy()


def speakError(app):
    txt = 'Only Bible, Dictionary, Commentary, Book/Article, ScripturePad,\n\
User Notes and Search Results pages can be spoken. Other pages cannot be spoken.\n\n\
Click in one of these Windows to select and click the Speech Icon again. '
    dlg = wx.MessageDialog(app, txt, 'Non-Speakable Page', wx.OK | wx.ICON_INFORMATION	)
    
    #app.tts.speakTxt(txt, app.ttsVolume, app.ttsRate, app.ttsVoice, 0)
    dlg.ShowModal()
    #app.tts.Stop()
    dlg.Destroy()



def helpError(app, appPath):
    dlg = wx.MessageDialog(app, 
'''Bible Analyzer cannot find the User Manual (help.chm).\n\nIt expected to find it in this folder:\n%s\n
Try reinstalling Bible Analyzer.''' % appPath, 'User Manual Not Found', wx.OK | wx.ICON_INFORMATION	)
    dlg.ShowModal()
    dlg.Destroy()


def bookConvert(app, path):
    dlg = wx.MessageDialog(app, 'This utility will attempt to convert version 3.7 and earlier\n\
Texts/Books with the .htm extension to the new .bk format.\n\n\
Some single chapter texts may not convert properly. Those included\n\
with Bible Analyzer can be downloaded in the new format from the\n\
www.bibleanalyzer.com Downloads page. See User Manual for details \n\
on how to format raw texts.\n\n\
Click OK to convert all .htm files in the Modules/Text folder.\n\
Restart Bible Analyzer to view the converted texts.\n\n',
                       'Text File Converter',
                       wx.OK | wx.CANCEL | wx.ICON_INFORMATION
                       )
    if dlg.ShowModal() == wx.ID_OK:
        count = tools.bookConvert.Convert(path)
    dlg.Destroy()


def parseError(app, origRef):
    dlg = wx.MessageDialog(app, '"%s" is not a valid reference.\n\n\
You must enter a single reference (Gen 3:15, Joh 3:16, etc.).\n\
Partial references (Gen, re, etc.) will go to the first chapter.\n\
Most abbreviations are accepted (Ge, mat, mt, ro 4:5, Rev., etc.)\n\
A period or space may be used in place of a colon (Ro 4.5, ro 4 5).\n\n\
See User Manual for more tips.' % origRef,
    'Reference Error', wx.OK | wx.ICON_INFORMATION	)
    dlg.ShowModal()
    dlg.Destroy()


def refError(app):
    dlg = wx.MessageDialog(app, 'You can enter a single reference (Gen, Gen 3, Gen 3:15, etc.),\n\
or a range (Gen-Deu, Gen 1-3, Gen 3:15-Deu 4:10, etc.)\n\
Most abbreviations are accepted (Ge, mt 5-7, ro 4:5, Rev., etc.)\n\n\
See User Manual for more tips.',
    'Reference Error', wx.OK | wx.ICON_INFORMATION	)
    dlg.ShowModal()
    dlg.Destroy()


def rngError(app):
    dlg = wx.MessageDialog(app, 'The range specified is not valid for the current Bible. \
Check the entry and ensure it is a valid range for the selected Bible\n\n\
Common issues,\nSpecifing an OT book in a NT only Bible\nEntering reference for non-existing passage (like 2 Cor 15:4 instead of 1 Cor 15:4).',
    'Range Error For Current Bible', wx.OK | wx.ICON_INFORMATION    )
    dlg.ShowModal()
    dlg.Destroy()


def exportNotesInfo(app):
    dlg = wx.MessageDialog(app, 
'All notes entered in the Notes Editor will be exported to "user-notes.txt" \n\
in the "Bible Analyzer User Modules" folder (under the "Documents" folder). \n\n\
Each set of notes will be placed on a single line with the reference first, \n\
a tab, then the notes. The notes will have HTML tags to retain formatting. \n\n\
(The exported file can be made into a commentary module using Module Creator.)',
    'Export Notes Info', wx.OK | wx.ICON_INFORMATION	)
    dlg.ShowModal()
    dlg.Destroy()



def ExportNotes(mainApp):
        
    exportNotesInfo(mainApp)
    
    con = sqlite.connect(mainApp.userDir +'/notes.usr')
    con.text_factory = str
    cur = con.cursor()
    cur.execute('SELECT * FROM commentary')
    
    rows = cur.fetchall()
    
    tmpEdit = rt.RichTextCtrl(mainApp, style=wx.WANTS_CHARS)
    xmlHand = rt.RichTextXMLHandler()
    htmlHand = rt.RichTextHTMLHandler()
    
    con = sqlite.connect(mainApp.bibFileList[mainApp.avIndex])
    cur = con.cursor()
    cur.execute('SELECT ref FROM bible')
    rRows = cur.fetchall()
    
    refRows = [r[0] for r in rRows]
    #chaps = [r[0] for r in fixRef.chapIdx.chapIdx[:-1]]
    chaps = fixRef.chapIdx.keys()
    
    refList = mainApp.Tree.order
    chaps.extend(refRows)
    refList.extend(chaps)
    
    for row in rows:
        stream = cStringIO.StringIO(row[1])
        xmlHand.LoadStream(tmpEdit.GetBuffer(), stream)
        stream = cStringIO.StringIO()
        htmlHand.SaveStream(tmpEdit.GetBuffer(), stream)
        line = stream.getvalue()
        
        emptyLine = re.sub(r'<.+?>', '', line)
        if not re.search(r'\w', emptyLine):
            continue
            
        line = re.sub(r'\r|\n', '', line)
        line = re.sub(r'<html><head></head><body>|</body></html>|<font face="MS Shell Dlg 2" size="1" color="#000000" >', '', line)
        
        #print row[0]
        #print line
        line = '%s\t%s' % (row[0], line)
        idx = refList.index(row[0])
        refList[idx] = line
        
        tmpEdit.Clear()
    
    del tmpEdit
    
    fList = [r for r in refList if '\t' in r] 

    txtout = file(mainApp.userDir + ur"/user-notes.txt", 'w')
    txtout.write('\n'.join(fList))
    txtout.close()
        



class HTMLDialog(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, style = wx.FRAME_NO_TASKBAR | wx.STAY_ON_TOP)
        panel = wx.Panel(self, -1)

        self.dlgWin = baseClass.HtmlWindow(panel, -1, style = wx.BORDER_THEME)
        close = wx.Button(panel, -1, 'OK')
        
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        self.Bind(wx.EVT_BUTTON, self.OnClose, close)
        
        self.SetSize((560, 500))
    
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.dlgWin, 1, wx.EXPAND, 0)
        sizer.Add(close, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER, 10)
        panel.SetSizer(sizer)
        #sizer.Fit(self)
        self.Layout()
        
    def OnClose(self, event):
        self.Destroy()






txt = '''There is generated data in the Parallel Generator History.
          To append an existing .pll file click Append.'''
                
txt2 ='''                 To save the data to a new file,
enter the module title in the box below and click New.'''


class SaveParallel(wx.Dialog):
    def __init__(self, parent):
        
        self.mainApp = wx.GetApp().GetTopWindow()

        wx.Dialog.__init__(self, parent, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX)
        panel = wx.Panel(self, -1)
        
                
        rngLabel = wx.StaticText(panel, -1, txt)
        rngLabel2 = wx.StaticText(panel, -1, txt2)
        self.rngEnter = wx.TextCtrl(panel, -1, size=(250, -1))

        appendButt = wx.Button(panel, -1, "Append", size=(60, -1))
        newButt = wx.Button(panel, -1, "New", size=(60, -1))
        cancelButt = wx.Button(panel, -1, "Cancel", size=(60, -1))

        rngLabel.SetPosition((40, 10))
        self.rngEnter.SetPosition((55, 82))
        rngLabel2.SetPosition((53, 40))

        appendButt.SetPosition((55, 120))
        newButt.SetPosition((150, 120))
        cancelButt.SetPosition((245, 120))


        self.SetSize((370, 190))
        self.SetTitle('Save Parallel Data to File?')

        self.Bind(wx.EVT_BUTTON, self.OnFile, newButt)
        self.Bind(wx.EVT_BUTTON, self.OnAppend, appendButt)
        self.Bind(wx.EVT_BUTTON, self.OnClose, cancelButt)
        
        self.Bind(wx.EVT_CLOSE, self.OnClose)


    def OnAppend(self, event):
        tmp = []
        
        for idx, refs in enumerate(self.mainApp.parallelWin.parHistory):
            title = self.mainApp.parallelWin.parHistoryTitle[idx]
            ln = '%s\t%s' % (title, refs)
            tmp.append(ln)
            
        
        dlg = wx.FileDialog(
            self, message="Save file as ...", defaultDir = self.mainApp.allUsersDir + '/Modules',
            defaultFile="", wildcard='PLL files (*.pll)|*.pll', style=wx.SAVE)

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            
            txt = '\n%s' % '\n'.join(tmp)
            
            fp = file(path, 'a') 
            fp.write(txt)
            fp.close()

        dlg.Destroy()
        self.OnClose(None)



    def OnFile(self, event):
        if self.rngEnter.GetValue:
            modTitle = self.rngEnter.GetValue()
        else:
            dlg = wx.MessageDialog(app, 'You must enter a Module title in the Entry Box before you can save a new file.',
            'Module Title', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        tmp = []
        
        for idx, refs in enumerate(self.mainApp.parallelWin.parHistory):
            title = self.mainApp.parallelWin.parHistoryTitle[idx]
            ln = '%s\t%s' % (title, refs)
            tmp.append(ln)
            
        
        dlg = wx.FileDialog(
            self, message="Save file as ...", defaultDir = self.mainApp.allUsersDir + '/Modules',
            defaultFile="%s" % modTitle, wildcard='.pll', style=wx.SAVE)

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            
            txt = '%s\n%s' % (modTitle, '\n'.join(tmp))
            
            fp = file(path, 'w') 
            fp.write(txt)
            fp.close()

        dlg.Destroy()
        self.OnClose(None)


    def OnClose(self, event):
        self.Destroy()







class ExportBib(wx.Dialog):
    def __init__(self, parent, ID, title):
        
        self.mainApp = wx.GetApp().GetTopWindow()

        wx.Dialog.__init__(self, parent, ID, title, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX)
        panel = wx.Panel(self, -1)
                
        rngLabel = wx.StaticText(panel, -1, 'Enter verse(s) or range')
        self.rngEnter = wx.TextCtrl(panel, -1, size=(250, -1))

        bibLabel = wx.StaticText(panel, -1, 'Select Bible')
        self.bibEnter = wx.Choice(panel, -1, choices = self.mainApp.bAbbrList, size=(60, -1))

        layoutButt = wx.Button(panel, -1, "Set Format")

        exFileButt = wx.Button(panel, -1, "Export to File", size=(100, -1))
        exSPButt = wx.Button(panel, -1, "Export to S-Pad", size=(100, -1))
        copyButt = wx.Button(panel, -1, "Copy to Clipboard", size=(100, -1))
        #helpButton = wx.Button(panel, -1, '?', size=(22, 23))

        #helpButton.SetToolTip(wx.ToolTip('Help for the Selected Tab'))
        #helpButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Verdana"))
        #helpButton.SetForegroundColour(wx.Colour(128, 0, 0))

        helpLabel = wx.StaticText(panel, -1, 'Verse: Joh 3:16\nRange: Joh 3:16-18\nMultiple Verses: Joh 3:16, Joh 3:18\nChapter: Joh 3:')
        helpLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        rngLabel.SetPosition((90, 5))
        self.rngEnter.SetPosition((15, 20))

        bibLabel.SetPosition((273, 5))
        self.bibEnter.SetPosition((270, 20))
        
        helpLabel.SetPosition((15, 55))
        #helpButton.SetPosition((215, 70))
        
        layoutButt.SetPosition((255, 70))

        exFileButt.SetPosition((15, 120))
        exSPButt.SetPosition((123, 120))
        copyButt.SetPosition((231, 120))
        
        self.SetSize((350, 185))
        self.Centre()
        
        self.rngEnter.SetValue(self.mainApp.currentRef)
        self.bibEnter.SetSelection(self.mainApp.bibNB.GetSelection())
        
        self.Bind(wx.EVT_BUTTON, self.OnFormat, layoutButt)
        self.Bind(wx.EVT_BUTTON, self.OnExportFile, exFileButt)
        self.Bind(wx.EVT_BUTTON, self.OnExportSpad, exSPButt)
        self.Bind(wx.EVT_BUTTON, self.OnCopy, copyButt)
        
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)


    def OnCloseWindow(self, event):
        self.Destroy()

    def OnFormat(self, event):
        self.mainApp.OnOptionsDlg(None)
        self.mainApp.optionsDlg._book.SetSelection(2)
    
    
    def OnCopy(self, event):
        txt = self.getText()
        if not txt:
            return
        
        txtData = wx.TextDataObject()
        txtData.SetText(txt)
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(txtData)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")


    def OnExportSpad(self, event):
        txt = self.getText(True)
        if not txt:
            return
        #print txt
        self.mainApp.editor.WriteText(txt)
        #return
        
        buffer = self.mainApp.editor.GetBuffer()
        xmlHandler = rt.RichTextXMLHandler()
        stream = cStringIO.StringIO()
        if xmlHandler.SaveStream(buffer, stream):
            contents = stream.getvalue() 

            fixed = re.sub(r'{(.+?)}', r'</text><text textcolor="%s">\1</text><text>' % self.mainApp.copyRefColor, contents) # Ref Color
            fixed = re.sub(r'&lt;r&gt;(.+?)&lt;/r&gt;', r'</text><text textcolor="#FF0000">\1 </text><text>', fixed) # Red Letter
            fixed = re.sub(r'&lt;/?r&gt;', '', fixed)
            fixed = re.sub(r'\[(.+?)\]', r'</text><text fontstyle="93">\1</text><text>', fixed) # Italics
            fixed = re.sub(r'&lt;/?fn&gt;', r'', fixed)
            
            print fixed
            
            output = cStringIO.StringIO(fixed)
            xmlHandler.LoadStream(buffer, output)
            self.mainApp.editor.Refresh()
            self.mainApp.editor.MarkDirty()

    
    def OnExportFile(self, event):
        txt = self.getText()
        if not txt:
            return
        
        dlg = wx.FileDialog(
            self, message="Save file as ...", defaultDir=os.getcwd(), 
            defaultFile="", wildcard='.txt', style=wx.SAVE)

        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            
            fp = file(path, 'w') 
            fp.write(txt.encode('utf-8'))
            fp.close()

        dlg.Destroy()



    def getText(self, sPad = None):
        if self.rngEnter.GetValue() == '':
            return
        entry = self.rngEnter.GetValue()
        idxList, ref = fixRef.parseRng(entry)
        
        if idxList[0] == 'rngError':
            self.mainApp.OnRngError()
            return None
        
        settings = self.mainApp.copySettings
        ref = ref.replace(';', ',')
        refList = ref.split(',')
        
        final = []
        for cyc, idx in enumerate(idxList):
            r = refList[cyc]
        
            txt, ref, abbr = normSearch.formatRangeCopy(entry, None, self.mainApp.bibFileList[self.bibEnter.GetSelection()], settings, idx)            
            txt = self.doSettings(txt, r, abbr, settings, sPad)
            final.append(txt)
        
        return '\n'.join(final)
        

    def doSettings(self, txt, ref, abbr, settings, sPad):
        txt = re.sub(r'[\^~]|<b>|</b>|<sup>.+?</sup>', '', txt)
        
        ref = ref.strip()
        
        if not settings[2]:
            abbr = ''
                    
        if settings[1]:
            fullBk = fixRef.fullTitle(ref[:3])
            ref = fullBk + ref[3:]

        if settings[5]:
            ref = ('(%s%s)' % (ref, abbr))
        if not settings[5]:
            ref = ('%s%s' % (ref, abbr))
        if settings[6]:
            ref = '{%s}' % ref

        if settings[3]:
            str = '%s ' % ref
            if settings[4]:
                str = '%s\n' % ref
            txt = str + txt 
                
        if not settings[3]:
            str = ' %s' % ref
            if settings[4]:
                str = '\n%s' % ref
            txt = txt + str
        
        if sPad:
            return txt + '\n'
        else:
            txt = re.sub(r'[{}]', r'', txt) # Ref Color
            txt = re.sub(r'<r>|</r>', r'', txt) # Red Letter
            txt = re.sub(r'<i>', r'[', txt)             
            txt = re.sub(r'</i>', r']', txt) 
            txt = re.sub(r'<.+?>', r'', txt) 
        
        return txt + '\n'    
