import wx
import fixRef


class ExportBib(wx.Dialog):
    def __init__(self, parent, ID, title):
        
        #self.mainApp = wx.GetApp().GetTopWindow()

        wx.Dialog.__init__(self, parent, ID, title, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX)
        panel = wx.Panel(self, -1)
                
        rngLabel = wx.StaticText(panel, -1, 'Enter verse(s) or range')
        self.rngEnter = wx.TextCtrl(panel, -1, size=(250, -1))

        bibLabel = wx.StaticText(panel, -1, 'Select Bible')
        bibEnter = wx.Choice(panel, -1, size=(60, -1))

        layoutButt = wx.Button(panel, -1, "Set Format")

        exFileButt = wx.Button(panel, -1, "Export to File", size=(100, -1))
        exSPButt = wx.Button(panel, -1, "Export to S-Pad", size=(100, -1))
        copyButt = wx.Button(panel, -1, "Copy to Clipboard", size=(100, -1))
        helpButton = wx.Button(panel, -1, '?', size=(22, 23))

        helpButton.SetToolTip(wx.ToolTip('Help for the Selected Tab'))
        helpButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Verdana"))
        helpButton.SetForegroundColour(wx.Colour(128, 0, 0))

        helpLabel = wx.StaticText(panel, -1, 'Verse: Joh 3:16\nRange: Joh 3:16-18\nMultiple Verses: Joh 3:16, Joh 3:18\nChapter: Joh 3:')
        helpLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        rngLabel.SetPosition((90, 5))
        self.rngEnter.SetPosition((15, 20))

        bibLabel.SetPosition((273, 5))
        bibEnter.SetPosition((270, 20))
        
        helpLabel.SetPosition((15, 55))
        helpButton.SetPosition((215, 70))
        
        layoutButt.SetPosition((255, 70))

        exFileButt.SetPosition((15, 120))
        exSPButt.SetPosition((123, 120))
        copyButt.SetPosition((231, 120))
        
        self.SetSize((350, 185))
        self.Centre()
        
        self.Bind(wx.EVT_BUTTON, self.OnFormat, layoutButt)
        self.Bind(wx.EVT_BUTTON, self.OnExportFile, exFileButt)
        
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)


    def OnCloseWindow(self, event):
        self.Destroy()

    def OnFormat(self, event):
        self.mainApp.OnOptionsDlg(None)
        self.mainApp.optionsDlg._book.SetSelection(2)
        
    def OnExportFile(self, event):
        if self.rngEnter.GetValue() == '':
            return
        entry = self.rngEnter.GetValue()
        print entry
        
        idxList, ref = fixRef.parseRng(entry)
        print ref, idxList






class MyApp(wx.App):
    def OnInit(self):        
        export = ExportBib(None, -1, "Export Bible")
        export.Show()
        
        return True

if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()
