# -*- coding: utf-8 -*-

import wx, contextMenu, advSearch, stats
import genButton as buttons
import wx.lib.buttons as buttons
#import flatMenu as FM
import agw.aui as Aui
#import wx.lib.agw.aui as Aui
import toolImg



class ToolImg():
    def __init__(self):
        self.copyImg = toolImg.getCopyBitmap()
        self.printImg = toolImg.getPrinterBitmap()
        self.preImg = toolImg.getPreviewBitmap()
        self.findImg = toolImg.getFindBitmap()
        self.topicsImg = toolImg.getTopicsBitmap()

        self.backImg = toolImg.getBackArrowBitmap()
        self.forwImg = toolImg.getForwArrowBitmap()

        self.nextImg = toolImg.getNextArrowBitmap()
        self.prevImg = toolImg.getPrevArrowBitmap()

        self.syncImg = toolImg.getSyncBitmap()

        self.bkCmtImg = toolImg.getBookTBBitmap()
        self.chCmtImg = toolImg.getChapTBBitmap()
        self.vsCmtImg = toolImg.getVerseTBBitmap()

        self.defaultImg = toolImg.getDefaultBitmap()

        self.ExportMW = toolImg.getExportMWBitmap()
        self.chapTog = toolImg.getChapTogBitmap()
        self.spanImg = toolImg.getSpanBitmap()
        self.treeImg = toolImg.getTreeBitmap()
        self.dctImg = toolImg.getDctToolBitmap()
        self.cmtImg = toolImg.getCmtToolBitmap()
        self.bkImg = toolImg.getBkToolBitmap()


class BibToolPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        ti = ToolImg()

        self.NB = parent
        self.mainApp = wx.GetApp().GetTopWindow()
        self.bibHistoryIdx = 0
        
        self.panelState = None
        self.oldLayout = None

        nextBkImg = toolImg.getNbookBitmap()
        prevBkImg = toolImg.getPbookBitmap()
        nextChImg = toolImg.getNchapBitmap()
        prevChImg = toolImg.getPchapBitmap()
        numImg = toolImg.getNumBitmap()
        numImgDis = toolImg.getNum_Bitmap()
        interImg = toolImg.getInterBitmap()
        interImgDis = toolImg.getInter_Bitmap()
        dualImg = toolImg.getDualBitmap()
        fNoteImg = toolImg.getFNoteBitmap()

        self._mgr = Aui.AuiManager(self)

        prepend_items, append_items = [], []
        item = Aui.AuiToolBarItem()
        item.SetKind(wx.ITEM_SEPARATOR)
        append_items.append(item)

        self.miniTB = Aui.AuiToolBar(self, -1, wx.DefaultPosition, wx.DefaultSize, type = 1, agwStyle = Aui.AUI_TB_OVERFLOW|Aui.AUI_TB_PLAIN_BACKGROUND)
        self.refList = wx.Choice(self.miniTB, -1, choices = [], size = (105, -1))
        #self.refList.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0))
        self.refList.SetToolTip(wx.ToolTip('Reference History'))

        #self.miniTB.AddSimpleTool(500, "Copy", ti.copyImg, "Copy selected in Bible Window")
        #self.miniTB.AddSimpleTool(501, "Print", ti.preImg, "Print Preview Bible Window")
        #self.miniTB.AddSimpleTool(502, "Find", ti.findImg, "Find in page")
        
        self.miniTB.AddControl(self.refList)
        #self.miniTB.AddSimpleTool(515, "Back", ti.backImg, 'Cycle Last Seven Refs')
        #self.miniTB.AddSimpleTool(516, "Forw", ti.forwImg, 'Verse History Forward')
        self.miniTB.AddSpacer(5)

        self.miniTB.AddSimpleTool(513, "Dual", dualImg, 'Toggle Dual Viewer', Aui.ITEM_CHECK)
        #self.miniTB.AddSpacer(5)

        self.miniTB.AddSimpleTool(503, "PreBk", prevBkImg, 'Previous Book')
        self.miniTB.AddSimpleTool(504, "NextBk", nextBkImg, 'Next Book')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(505, "PreCh", prevChImg, 'Previous Chapter, F7')
        self.miniTB.AddSimpleTool(506, "NextCh", nextChImg, 'Next Chapter, F8')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(507, "PreVs", ti.prevImg, 'Previous Verse, F5')
        self.miniTB.AddSimpleTool(508, "NextVs", ti.nextImg, 'Next Verse, F6')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(512, "bibExport", ti.ExportMW, 'Export Page to MultiWin')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddTool(514, "Inter", fNoteImg, interImgDis, Aui.ITEM_CHECK, "Hide/Show Inline Footnotes", "", None)
        #self.miniTB.AddSpacer(5)
        self.miniTB.AddTool(509, "Inter", interImg, interImgDis, Aui.ITEM_CHECK, "Hide/Show Interlinear Text", "", None)
        self.miniTB.AddTool(510, "Strong", numImg, numImgDis, Aui.ITEM_CHECK, "Hide/Show Strong's Numbers", "", None)
        self.miniTB.AddStretchSpacer()

        self.miniTB.AddSimpleTool(511, "Topics", ti.topicsImg, 'Hide/Show Reference panel', Aui.ITEM_CHECK)
        self.miniTB.SetCustomOverflowItems(prepend_items, append_items)

        self.miniTB.Realize()

        info = Aui.AuiPaneInfo().Name("Bible TB").CaptionVisible(False).Top().DockFixed()
        self._mgr.AddPane(self.miniTB, info)

        self._mgr.GetArtProvider().SetMetric(Aui.AUI_DOCKART_PANE_BORDER_SIZE, 0)

        self._mgr.Update()

        #self.miniTB.EnableTool(5001, False)

        #self.Bind(wx.EVT_TOOL, self.OnBibleCopy, id=500)
        #self.Bind(wx.EVT_TOOL, self.OnBiblePreview, id=501)
        
        #self.Bind(wx.EVT_TOOL, self.OnBibBack, id=515)
        #self.Bind(wx.EVT_TOOL, self.OnBibForw, id=516)
        
        self.Bind(wx.EVT_CHOICE, self.OnRef, self.refList)
        self.Bind(wx.EVT_TOOL, self.OnDual, id=513)
        self.Bind(wx.EVT_TOOL, self.OnNextVerse, id=508)
        self.Bind(wx.EVT_TOOL, self.OnNextChap, id=506)
        self.Bind(wx.EVT_TOOL, self.OnPreVerse, id=507)
        self.Bind(wx.EVT_TOOL, self.OnPreChap, id=505)
        self.Bind(wx.EVT_TOOL, self.OnPreBook, id=503)
        self.Bind(wx.EVT_TOOL, self.OnNextBook, id=504)
        self.Bind(wx.EVT_TOOL, self.OnShowText, id=509)
        self.Bind(wx.EVT_TOOL, self.OnShowStrongs, id=510)
        self.Bind(wx.EVT_TOOL, self.OnShowBibRef, id=511)
        self.Bind(wx.EVT_TOOL, self.OnBibClone, id=512)
        self.Bind(wx.EVT_TOOL, self.OnFootnote, id=514)


    def InsertBibRef(self, ref):
        if self.refList.GetCount() > 14:
            self.refList.Delete(self.refList.GetCount() -1)
        
        if ref not in self.refList.GetStrings():
            self.refList.Insert(ref, 0)
            self.refList.Select(0)
        
        
    def OnRef(self, event):
        ref = self.refList.GetStringSelection()
        self.mainApp.ShowRefContext(ref)
        

    def OnBibBack(self, event):
        if not self.mainApp.verseHistory:
            return
        
        #print self.mainApp.verseHistory
        self.mainApp.OnSaveNotes()
        
        try:
            self.bibHistoryIdx -= 1
            self.mainApp.ShowRefContext(self.mainApp.verseHistory[self.bibHistoryIdx])
        except IndexError:
            self.bibHistoryIdx = len(self.mainApp.verseHistory) -1
            self.mainApp.ShowRefContext(self.mainApp.verseHistory[self.bibHistoryIdx])

    
    
    def OnBibForw(self, event):
        return



    
    def OnDual(self, event):
        self.mainApp.Freeze()
        bibPane = self.mainApp.getBibPane()
        if self.miniTB.GetToolToggled(513) == True:
            self.panelState = self.mainApp.bibNB.bibPanel.miniTB.GetToolToggled(511)
            self.mainApp.bibNB.bibPanel.miniTB.ToggleTool(511, False)

            self.oldLayout = self.mainApp.mainMgr.SavePerspective()
            self.mainApp.bibSplit.SplitVertically(self.mainApp.bibNB, self.mainApp.dualPanel)
            self.mainApp.OnMasterControlMini(None, 2)
            self.mainApp.cpMini.LBook.SetSelection(7)
            self.mainApp.cpMini.Dual.syncTexts(None)
              
            self.mainApp.mainMgr.MaximizePane(bibPane)
        else:
            self.mainApp.bibSplit.Unsplit(self.mainApp.dualPanel)
            self.mainApp.mainMgr.LoadPerspective(self.oldLayout)
            self.mainApp.mainMgr.LoadPerspective(self.oldLayout)
            if self.panelState:
                self.mainApp.bibNB.bibPanel.miniTB.ToggleTool(511, True)
            else:
                self.mainApp.bibNB.bibPanel.miniTB.ToggleTool(511, False)
        
        self.mainApp.mainMgr.Update()
        self.mainApp.bibNB.bibPanel.OnShowBibRef(None)
        self.mainApp.Thaw()
        
    
    
    def OnFootnote(self, event):
        if self.miniTB.GetToolToggled(514) == True:
            self.mainApp.OnShowFootnote(True)
        else:
            self.mainApp.OnShowFootnote(False)


    def OnBibClone(self, event):
        self.mainApp.OnMiniWinCopy('bib')

    def OnShowBibRef(self, event):
        bibPanel = self.mainApp.bibMgr.GetPane('Bible Win')
        if self.miniTB.GetToolToggled(511) == False:
            self.mainApp.bibMgr.RestoreMaximizedPane()
            self.mainApp.bibMgr.MaximizePane(bibPanel)
            self.mainApp.bibMgr.Update()
        else:
            self.mainApp.bibMgr.RestoreMaximizedPane()
            self.mainApp.bibMgr.Update()
            self.mainApp.checkRefNB()


        ## Scroll Bible
        tab = self.mainApp.bibNB.GetSelection()
        if '<a name="line"></a>' in self.mainApp.bibCurrent:
            self.mainApp.bibDisplay[tab].ScrollToAnchor('line')
            self.mainApp.bibDisplay[tab].ScrollLines(-2)



    def OnShowText(self, event):
        if self.miniTB.GetToolToggled(509) == True:
            self.mainApp.OnShowText(True)
        else:
            self.mainApp.OnShowText(False)

    def OnShowStrongs(self, event):
        if self.miniTB.GetToolToggled(510) == True:
            self.mainApp.OnShowStrongs(True)
        else:
            self.mainApp.OnShowStrongs(False)

    def OnBibExpand(self, event):
        self.mainApp.OnMakeBibleFull(None)

    def OnNextBook(self, event):
        self.mainApp.OnNextBook(None)

    def OnPreBook(self, event):
        self.mainApp.OnPreBook(None)

    def OnBibFind(self, event):
        self.mainApp.SetBibFocus(None)
        cm = contextMenu.ContextMenu(self)
        cm.PageSearch(None, 1)

    def OnBibleCopy(self, event):
        self.mainApp.SetBibFocus(None)
        self.mainApp.OnCopy(None)

    def OnBiblePrint(self, event):
        self.mainApp.OnBibPrint(None)

    def OnBiblePreview(self, event):
        self.mainApp.OnPrintBibPreview(None)

    def OnNextVerse(self, event):
        self.mainApp.OnNextVerse(None)

    def OnNextChap(self, event):
        self.mainApp.OnNextChap(None)

    def OnPreVerse(self, event):
        self.mainApp.OnPreVerse(None)

    def OnPreChap(self, event):
        self.mainApp.OnPreChap(None)



class DctToolPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        self.dctHistoryIdx = -1
        self.fromDctBack = None

        self.NB = parent
        self.mainApp = wx.GetApp().GetTopWindow()

        ti = ToolImg()

        self._mgr = Aui.AuiManager(self)

        prepend_items, append_items = [], []
        item = Aui.AuiToolBarItem()
        item.SetKind(wx.ITEM_SEPARATOR)
        append_items.append(item)

        self.miniTB = Aui.AuiToolBar(self, -1, wx.DefaultPosition, wx.DefaultSize, type = 1, agwStyle = Aui.AUI_TB_OVERFLOW|Aui.AUI_TB_PLAIN_BACKGROUND)

        self.miniTB.AddSimpleTool(606, "Back", ti.backImg, 'History Back')
        self.miniTB.AddSimpleTool(607, "Forw", ti.forwImg, 'History Forward')
        #self.miniTB.AddSpacer(5)

        #self.miniTB.AddSimpleTool(601, "Copy", ti.copyImg, "Copy selected in Dictionary Window")
        #self.miniTB.AddSimpleTool(602, "Print", ti.printImg, "Print Dictionary Window")
        self.miniTB.AddSimpleTool(603, "Print Preview", ti.preImg, "Print Preview Dictionary Window")
        #self.miniTB.AddSimpleTool(604, "Find", ti.findImg, "Find in page")
        self.miniTB.AddSimpleTool(605, "Sync", ti.syncImg, 'Sync dictionary to clicked word', Aui.ITEM_CHECK)
        #self.miniTB.AddSpacer(5)
        self.miniTB.AddSimpleTool(608, "PreDct", ti.prevImg, 'Previous Topic')
        self.miniTB.AddSimpleTool(609, "NextDct", ti.nextImg, 'Next Topic')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(612, "dctExport", ti.ExportMW, 'Export Page to MultiWin')
        #self.miniTB.AddSpacer(4)
        self.miniTB.AddSimpleTool(613, "default", ti.defaultImg, 'Use Default Dictionary', Aui.ITEM_CHECK)

        self.miniTB.AddStretchSpacer()
        self.miniTB.AddSimpleTool(610, "Topics", ti.topicsImg, 'Hide/Show Topics', Aui.ITEM_CHECK)
        self.miniTB.SetCustomOverflowItems(prepend_items, append_items)

        self.miniTB.Realize()

        self.miniTB.ToggleTool(613, True)

        info = Aui.AuiPaneInfo().Name("Bible TB").CaptionVisible(False).Top().DockFixed()
        self._mgr.AddPane(self.miniTB, info)

        self._mgr.GetArtProvider().SetMetric(Aui.AUI_DOCKART_PANE_BORDER_SIZE, 0)
        self._mgr.Update()

        #self.Bind(wx.EVT_TOOL, self.OnDctCopy, id=601)
        #self.Bind(wx.EVT_TOOL, self.OnDctPrint, id=602)
        self.Bind(wx.EVT_TOOL, self.OnDctPreview, id=603)
        self.Bind(wx.EVT_TOOL, self.OnDctNext, id=609)
        self.Bind(wx.EVT_TOOL, self.OnDctPrev, id=608)

        self.Bind(wx.EVT_TOOL, self.OnDctBack, id=606)
        self.Bind(wx.EVT_TOOL, self.OnDctForw, id=607)

        self.Bind(wx.EVT_TOOL, self.OnDctTopics, id=610)
        #self.Bind(wx.EVT_TOOL, self.OnDctFind, id=604)
        self.Bind(wx.EVT_TOOL, self.OnDctClone, id=612)


    def OnDctClone(self, event):
        self.mainApp.OnMiniWinCopy('dct')

    def OnDctCopy(self, event):
        self.mainApp.SetDctFocus(None)
        self.mainApp.OnCopy(None)

    def OnDctPrint(self, event):
        self.mainApp.OnDctPrint(None)

    def OnDctPreview(self, event):
        self.mainApp.OnPrintDctPreview(None)


    def OnDctBack(self, event):
        entries = len(self.mainApp.dctHistory)
        if self.dctHistoryIdx == entries - entries - entries:
            return

        self.dctHistoryIdx -= 1
        self.fromDctBack = True

        self.mainApp.dctEntry.SetValue(self.mainApp.dctHistory[self.dctHistoryIdx][1])
        self.mainApp.dctNB.SetSelection(self.mainApp.dctHistory[self.dctHistoryIdx][0])
        self.mainApp.OnDctViewEntry()

    def OnDctForw(self, event):
        if self.dctHistoryIdx == -1:
            return

        self.dctHistoryIdx += 1
        self.fromDctBack = True

        self.mainApp.dctEntry.SetValue(self.mainApp.dctHistory[self.dctHistoryIdx][1])
        self.mainApp.dctNB.SetSelection(self.mainApp.dctHistory[self.dctHistoryIdx][0])
        self.mainApp.OnDctViewEntry()

    def OnDctNext(self, event):
        self.mainApp.OnDctNext()

    def OnDctPrev(self, event):
        self.mainApp.OnDctPrev()

    def OnDctFind(self, event):
        self.mainApp.SetDctFocus(None)
        cm = contextMenu.ContextMenu(self)
        cm.PageSearch(None, 2)

    def OnDctExpand(self, event):
        self.mainApp.OnMakeDictionaryFull(None)

    def OnDctTopics(self, event):
        self.mainApp.Freeze()
        self.mainApp.SetDctFocus(None)
        wx.BeginBusyCursor()

        if self.miniTB.GetToolToggled(610) == True:
            tab = self.mainApp.dctNB.GetSelection()

            if tab != self.mainApp.wordListTab:
                self.mainApp.GetWordList(tab)

            self.mainApp.dctListbox.SetItemCount(len(self.mainApp.currentWL))
            item = self.mainApp.FindDctEntry(self.mainApp.dctEntry.GetValue())
            if item:
                self.mainApp.dctListbox.EnsureVisible(item)
                self.mainApp.dctListbox.Select(item)

            self.mainApp.dctSizer.Show(1, True)
            self.NB._pages.CheckIfVisible(tab +2)
        else:
            self.mainApp.dctSizer.Show(1, False)

        self.mainApp.dctSizer.Layout()
        self.mainApp.Thaw()
        wx.EndBusyCursor()



class CmtToolPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.cmtHistoryIdx = -1
        self.fromCmtBack = None

        self.NB = parent
        self.mainApp = wx.GetApp().GetTopWindow()

        ti = ToolImg()

        prepend_items, append_items = [], []
        item = Aui.AuiToolBarItem()
        item.SetKind(wx.ITEM_SEPARATOR)
        append_items.append(item)
        self._mgr = Aui.AuiManager(self)

        self.miniTB = Aui.AuiToolBar(self, -1, wx.DefaultPosition, wx.DefaultSize, type = 1, agwStyle = Aui.AUI_TB_OVERFLOW|Aui.AUI_TB_PLAIN_BACKGROUND)

        self.miniTB.AddSimpleTool(704, "Back", ti.backImg, 'History Back')
        self.miniTB.AddSimpleTool(705, "Forw", ti.forwImg, 'History Forward')
        #self.miniTB.AddSpacer(5)
        #self.miniTB.AddSimpleTool(701, "Copy", ti.copyImg, "Copy selected in Commentary Window")
        #self.miniTB.AddSimpleTool(702, "Print", ti.printImg, "Print Commentary Window")
        self.miniTB.AddSimpleTool(710, "Print Preview", ti.preImg, "Print Preview Commentary Window")
        #self.miniTB.AddSimpleTool(703, "Find", ti.findImg, "Find in page")
        #self.miniTB.AddSpacer(5)
        self.miniTB.AddSimpleTool(706, "Sync", ti.syncImg, 'Sync comments to current reference', Aui.ITEM_CHECK)
        self.miniTB.AddSpacer(5)
        self.miniTB.AddSimpleTool(711, "BookCmt", ti.bkCmtImg, 'Show Current Book Comments', Aui.ITEM_CHECK)
        self.miniTB.AddSimpleTool(713, "ChapCmt", ti.chCmtImg, 'Show Current Chapter Comments', Aui.ITEM_CHECK)
        self.miniTB.AddSimpleTool(715, "VerseCmt", ti.vsCmtImg, 'Show Current Verse Comments', Aui.ITEM_CHECK)
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(708, "PreDct", ti.prevImg, 'Previous Comment')
        self.miniTB.AddSimpleTool(709, "NextDct", ti.nextImg, 'Next Comment')
        #self.miniTB.AddSpacer(2)
        self.miniTB.AddSimpleTool(716, "chToggle", ti.chapTog, 'Show Comments For Whole Chapter', Aui.ITEM_CHECK)
        #self.miniTB.AddSpacer(4)
        self.miniTB.AddSimpleTool(712, "cmtExport", ti.ExportMW, 'Export Page to MultiWin')
        #self.miniTB.AddSpacer(2)

        self.miniTB.AddSimpleTool(714, "default", ti.defaultImg, 'Use Default Commentary', Aui.ITEM_CHECK)

        self.miniTB.AddStretchSpacer()
        #self.miniTB.AddStretchSpacer()
        self.miniTB.AddSimpleTool(707, "Topics", ti.topicsImg, 'Hide/Show Verses', Aui.ITEM_CHECK)
        self.miniTB.SetCustomOverflowItems(prepend_items, append_items)

        self.miniTB.Realize()

        self.miniTB.ToggleTool(714, True)

        info = Aui.AuiPaneInfo().Name("Bible TB").CaptionVisible(False).Top().DockFixed()
        self._mgr.AddPane(self.miniTB, info)

        self._mgr.GetArtProvider().SetMetric(Aui.AUI_DOCKART_PANE_BORDER_SIZE, 0)
        self._mgr.Update()

        self.Bind(wx.EVT_TOOL, self.OnCmtSync, id=706)
        #self.Bind(wx.EVT_TOOL, self.OnCmtCopy, id=701)
        #self.Bind(wx.EVT_TOOL, self.OnCmtPrint, id=702)
        self.Bind(wx.EVT_TOOL, self.OnCmtPreview, id=710)
        self.Bind(wx.EVT_TOOL, self.OnCmtNext, id=709)
        self.Bind(wx.EVT_TOOL, self.OnCmtPrev, id=708)

        self.Bind(wx.EVT_TOOL, self.OnBkCmt, id=711)
        self.Bind(wx.EVT_TOOL, self.OnChapCmt, id=713)
        self.Bind(wx.EVT_TOOL, self.OnVerseCmt, id=715)

        self.Bind(wx.EVT_TOOL, self.OnCmtBack, id=704)
        self.Bind(wx.EVT_TOOL, self.OnCmtForw, id=705)

        #self.Bind(wx.EVT_TOOL, self.OnCmtFind, id=703)
        self.Bind(wx.EVT_TOOL, self.OnCmtTopics, id=707)
        self.Bind(wx.EVT_TOOL, self.OnCmtClone, id=712)
        self.Bind(wx.EVT_TOOL, self.OnToggleCh, id=716)


    def OnToggleCh(self, event):
        if self.miniTB.GetToolToggled(716) == True:
            self.mainApp.OnToggleChap()
        else:
            self.mainApp.OnCmtNBChanged(None)


    def OnCmtClone(self, event):
        if wx.GetKeyState(wx.WXK_CONTROL):
            self.mainApp.OnExportCmtChap()
        else:
            self.mainApp.OnMiniWinCopy('cmt')


    def OnVerseCmt(self, event):
        self.miniTB.ToggleTool(711, False)
        self.miniTB.ToggleTool(713, False)

        ref = self.mainApp.currentRef
        if ref[-1] ==':':
            ref = ref +'1'
        elif not ref[-1].isdigit():
            ref = ref +' 1:1'
        self.mainApp.OnBkChapCmt(ref)


    def OnBkCmt(self, event):
        self.miniTB.ToggleTool(715, False)
        self.miniTB.ToggleTool(713, False)

        ref = self.mainApp.fromBibRef[:3]
        self.mainApp.OnBkChapCmt(ref)


    def OnChapCmt(self, event):
        self.miniTB.ToggleTool(715, False)
        self.miniTB.ToggleTool(711, False)

        if len(self.mainApp.fromBibRef) == 3:
            ref = self.mainApp.fromBibRef + ' 1:'
        else:
            idx = self.mainApp.fromBibRef.find(':')
            ref = self.mainApp.fromBibRef[:idx +1]
        self.mainApp.OnBkChapCmt(ref)


    def OnCmtExpand(self, event):
        self.mainApp.OnMakeCommentaryFull(None)

    def OnCmtFind(self, event):
        self.mainApp.SetCmtFocus(None)
        cm = contextMenu.ContextMenu(self)
        cm.PageSearch(None, 4)


    def OnCmtTopics(self, event):
        self.mainApp.Freeze()
        self.mainApp.SetCmtFocus(None)
        wx.BeginBusyCursor()

        if self.miniTB.GetToolToggled(707) == True:
            tab = self.mainApp.cmtNB.GetSelection() -1

            if tab != self.mainApp.verseListTab:
                self.mainApp.GetVerseList(tab)

            self.mainApp.cmtListbox.SetItemCount(len(self.mainApp.currentVL))
            item = self.mainApp.FindCmtEntry(self.mainApp.cmtEntry.GetValue())
            print item, 'cmtitem'
            if item:
                self.mainApp.cmtListbox.EnsureVisible(item)
                self.mainApp.cmtListbox.Select(item)

            #self.mainApp.cmtListbox.Set(self.mainApp.currentVL)
            #self.mainApp.cmtListbox.SetStringSelection(self.mainApp.CmtRef)
            self.mainApp.commentarySizer.Show(1, True)
            self.NB._pages.CheckIfVisible(tab +2)
        else:
            self.mainApp.commentarySizer.Show(1, False)

        self.mainApp.commentarySizer.Layout()
        self.mainApp.Thaw()
        wx.EndBusyCursor()


    def OnCmtBack(self, event):
        entries = len(self.mainApp.cmtHistory)
        if self.cmtHistoryIdx == entries - entries - entries:
            return

        self.cmtHistoryIdx -= 1
        self.fromCmtBack = True

        self.mainApp.cmtEntry.SetValue(self.mainApp.cmtHistory[self.cmtHistoryIdx][1])
        self.mainApp.cmtNB.SetSelection(self.mainApp.cmtHistory[self.cmtHistoryIdx][0])
        self.mainApp.Freeze()

        if self.mainApp.cmtHistory[self.cmtHistoryIdx][0] == 0:
            self.mainApp.cmtNB._mainSizer.Show(2, False)
            self.mainApp.commentarySizer.Show(1, False)
            self.mainApp.commentarySizer.Layout()
            self.mainApp.cmtNB.cmtTopics.SetValue(False)
        else:
            self.mainApp.cmtNB._mainSizer.Show(2, True)

        self.mainApp.cmtNB.Layout()
        self.mainApp.Thaw()
        self.mainApp.OnCmtViewEntry()

    def OnCmtForw(self, event):
        if self.cmtHistoryIdx == -1:
            return

        self.cmtHistoryIdx += 1
        self.fromCmtBack = True

        self.mainApp.cmtEntry.SetValue(self.mainApp.cmtHistory[self.cmtHistoryIdx][1])
        self.mainApp.cmtNB.SetSelection(self.mainApp.cmtHistory[self.cmtHistoryIdx][0])
        self.mainApp.OnCmtViewEntry()


    def OnCmtNext(self, event):
        self.mainApp.OnCmtNext()

    def OnCmtPrev(self, event):
        self.mainApp.OnCmtPrev()

    def OnCmtCopy(self, event):
        self.mainApp.SetCmtFocus(None)
        self.mainApp.OnCopy(None)

    def OnCmtPrint(self, event):
        self.mainApp.OnCmtPrint(None)

    def OnCmtPreview(self, event):
        self.mainApp.OnPrintCmtPreview(None)

    def OnCmtSync(self, event):
        if self.miniTB.GetToolToggled(706) == True:
            self.mainApp.ClearCmtTabs()
            self.mainApp.FlagCmtTabs(self.mainApp.currentRef)

            self.mainApp.OnCmtNBChanged(None)



class ResToolPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.mainApp = wx.GetApp().GetTopWindow()
        ti = ToolImg()

        self._mgr = Aui.AuiManager(self)

        prepend_items, append_items = [], []
        item = Aui.AuiToolBarItem()
        item.SetKind(wx.ITEM_SEPARATOR)
        append_items.append(item)

        self.miniTB = Aui.AuiToolBar(self, -1, wx.DefaultPosition, wx.DefaultSize, type = 1, agwStyle = Aui.AUI_TB_OVERFLOW|Aui.AUI_TB_PLAIN_BACKGROUND)

        self.miniTB.AddSimpleTool(806, "Back", ti.backImg, 'Back')
        #self.miniTB.AddSpacer(5)

        self.miniTB.AddSimpleTool(801, "Copy", ti.copyImg, "Copy selected in This Window")
        self.miniTB.AddSimpleTool(802, "Print", ti.printImg, "Print This Window")
        self.miniTB.AddSimpleTool(803, "Print Preview", ti.preImg, "Print Preview This Window")
        self.miniTB.AddSimpleTool(804, "Find", ti.findImg, "Find in page")
        self.miniTB.AddSimpleTool(812, "ResExport", ti.ExportMW, 'Export Page to MultiWin')
        #self.miniTB.AddSpacer(5)

        self.hitList = wx.Choice(self.miniTB, -1, choices = ['Verse Range'], size=(150, -1))
        self.miniTB.AddControl(self.hitList, "Hit List")
        self.miniTB.AddSpacer(5)
        self.wdList = wx.Button(self.miniTB, -1, 'WL', size=(40, -1))
        self.miniTB.AddControl(self.wdList, "Word List")
        self.miniTB.SetCustomOverflowItems(prepend_items, append_items)

        self.miniTB.Realize()

        info = Aui.AuiPaneInfo().Name("Results TB").CaptionVisible(False).Top().DockFixed()
        self._mgr.AddPane(self.miniTB, info)

        self._mgr.GetArtProvider().SetMetric(Aui.AUI_DOCKART_PANE_BORDER_SIZE, 0)
        self._mgr.Update()


        #self.hitList.SetToolTipString("Verse Range List")
        #self.wdList.SetToolTipString("Word List of Results")


        self.Bind(wx.EVT_TOOL, self.OnResCopy, id=801)
        self.Bind(wx.EVT_TOOL, self.OnResPrint, id=802)
        self.Bind(wx.EVT_TOOL, self.OnResPreview, id=803)
        self.Bind(wx.EVT_TOOL, self.OnResFind, id=804)
        self.Bind(wx.EVT_CHOICE, self.OnHitList, self.hitList)
        self.Bind(wx.EVT_TOOL, self.OnBack, id=806)
        self.Bind(wx.EVT_BUTTON, self.OnWdList, self.wdList)
        self.Bind(wx.EVT_TOOL, self.OnResClone, id=812)


    def OnResClone(self, event):
        self.mainApp.OnMiniWinCopy('res')


    def OnWdList(self, event):
        self.advSearch = advSearch.primSearch(self)
        tab = self.mainApp.resNB.GetSelection() -1
        sList = self.mainApp.searchQList[tab]

        refs = self.advSearch.StdSearch(sList[0], sList[1], sList[2], sList[3], sList[4], sList[5], self.mainApp.font,\
        sList[6], sList[7], sList[14], sList[11], sList[12], 1, 1, 0, 0, 0)

        result = stats.schWordList(sList[1], self.mainApp.font, refs, sList[0],)

        self.mainApp.OnDictMini(result, '"%s" Search Word List' % sList[0], None, 1)
        #self.mainApp.miniWin.sizer2.Show(0, False)
        #self.mainApp.miniWin.sizer2.Layout()


    def OnBack(self, event):
        if self.mainApp.resNB.GetSelection() != 1:
            tab = self.mainApp.resNB.GetSelection()
            self.mainApp.resDisplay[tab -1].SetPage(self.mainApp.resultCurrent[tab -1])
        elif self.mainApp.resNB.GetSelection() == 1:
            if len(self.mainApp.bookDisplay.ToText()) == 0: # Image
                self.mainApp.bookDisplay.SetPage(self.mainApp.prePage)
            else:
                self.mainApp.cpMini.BookViewer.OnContents()


    def OnHitList(self, event):
        self.mainApp.SetResFocus(None)
        self.advSearch = advSearch.primSearch(self)
        sel = event.GetSelection()
        tab = self.mainApp.resNB.GetSelection() -1

        # sList = 0-entry, 1-fileName, 2-abbr, 3-full, 4-opt, 5-case, 6-showRed, 7-redSearch, 8-count, 9-findStr, 10-totalHits, 11-exclude, 12-fixedRef, 13-rngRefList, 14-idxList
        sList = self.mainApp.searchQList[tab]
        #print sList

        display = self.mainApp.resDisplay[tab]
        answer = self.advSearch.PrevNextSearch(sList[0], sList[1], sList[2], sList[3], sList[4], sList[5], sList[6], sList[7], sList[8], sList[9], sList[10], sList[11], sList[12], sList[13], tab, sel)

        if self.mainApp.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)

        display.SetPage('<font face="%s">%s</font>' % (self.mainApp.font, answer))
        self.mainApp.resultCurrent[tab] = answer


    def OnResFind(self, event):
        self.mainApp.SetResFocus(None)
        cm = contextMenu.ContextMenu(self)
        cm.PageSearch(None, 'Res')

    def OnResCopy(self, event):
        self.mainApp.SetResFocus(None)
        self.mainApp.OnCopy(None)

    def OnResPrint(self, event):
        self.mainApp.OnResPrint(None)

    def OnResPreview(self, event):
        self.mainApp.OnPrintResPreview(None)


class RefToolPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.NB = parent
        self.mainApp = wx.GetApp().GetTopWindow()
        ti = ToolImg()
        
        self.dctRef = buttons.GenBitmapToggleButton(self, -1, ti.dctImg, size = (22, 18))
        self.cmtRef = buttons.GenBitmapToggleButton(self, -1, ti.cmtImg, size = (22, 18))
        self.bkRef = buttons.GenBitmapToggleButton(self, -1, ti.bkImg, size = (22, 18))
        self.spRef = buttons.GenBitmapToggleButton(self, -1, ti.spanImg, size = (18, 18))
        self.expRef = buttons.GenBitmapToggleButton(self, -1, ti.treeImg, size = (18, 18))

        self.dctRef.SetUseFocusIndicator(False)
        self.dctRef.SetBezelWidth(1)
        self.cmtRef.SetUseFocusIndicator(False)
        self.cmtRef.SetBezelWidth(1)
        self.bkRef.SetUseFocusIndicator(False)
        self.bkRef.SetBezelWidth(1)
        self.expRef.SetUseFocusIndicator(False)
        self.expRef.SetBezelWidth(1)
        self.spRef.SetUseFocusIndicator(False)
        self.spRef.SetBezelWidth(1)

        #self.dctRef.SetForegroundColour(wx.Colour(0, 0, 140))
        #self.cmtRef.SetForegroundColour(wx.Colour(0, 90, 0))
        #self.bkRef.SetForegroundColour(wx.Colour(100, 0, 0))
        
        self.dctRef.SetFont(wx.Font(8, wx.DEFAULT, wx.ITALIC, wx.BOLD, 0, ""))
        self.cmtRef.SetFont(wx.Font(8, wx.DEFAULT, wx.ITALIC, wx.BOLD, 0, ""))
        self.bkRef.SetFont(wx.Font(8, wx.DEFAULT, wx.ITALIC, wx.BOLD, 0, ""))
        self.expRef.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.spRef.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        
        self.dctRef.SetToolTipString('Toggle Dct Hits')
        self.cmtRef.SetToolTipString('Toggle Cmt Hits')
        self.bkRef.SetToolTipString('Toggle Book Hits')
        self.expRef.SetToolTipString('Expand Ref. Tree')
        self.spRef.SetToolTipString('Show refs with verse in span, i.e. vs. 5 within vs. 4-6')
        
        sz1 = wx.BoxSizer(wx.VERTICAL)
        sz2 = wx.BoxSizer(wx.HORIZONTAL)
        #sz2.Add((-1, -1), 1, 0, 0)
        sz2.Add(self.dctRef, 0, wx.LEFT|wx.EXPAND, 5)
        sz2.Add(self.cmtRef, 0, wx.LEFT|wx.EXPAND, 5)
        sz2.Add(self.bkRef, 0, wx.LEFT|wx.EXPAND, 5)
        sz2.Add((-1, -1), 1, 0, 0)
        sz2.Add(self.spRef, 0, wx.RIGHT|wx.EXPAND, 5)
        sz2.Add(self.expRef, 0, wx.RIGHT|wx.EXPAND, 5)
        sz1.Add(sz2, 0, wx.TOP|wx.BOTTOM|wx.EXPAND, 3)
                        
        self.SetSizer(sz1)
        
        self.Bind(wx.EVT_BUTTON, self.OnButton, self.dctRef)
        self.Bind(wx.EVT_BUTTON, self.OnButton, self.cmtRef)
        self.Bind(wx.EVT_BUTTON, self.OnButton, self.bkRef)
        self.Bind(wx.EVT_BUTTON, self.OnExpand, self.expRef)
        self.Bind(wx.EVT_BUTTON, self.OnSpan, self.spRef)

    def OnButton(self, event):
        #self.mainApp.Freeze()
        if event.GetEventObject() == self.dctRef:
            if self.dctRef.GetValue():
                self.mainApp.showRefHits[0] = True
            else:
                self.mainApp.showRefHits[0] = False
        if event.GetEventObject() == self.cmtRef:
            if self.cmtRef.GetValue():
                self.mainApp.showRefHits[1] = True
            else:
                self.mainApp.showRefHits[1] = False
        if event.GetEventObject() == self.bkRef:
            if self.bkRef.GetValue():
                self.mainApp.showRefHits[2] = True
            else:
                self.mainApp.showRefHits[2] = False
                
        self.mainApp.checkRefNB()
        #self.mainApp.Thaw()
        
    def OnExpand(self, event):
        if self.expRef.GetValue():
            self.mainApp.refTree.ExpandAll()
        else:
            try: self.mainApp.refTree.CollapseAll()
            except: pass

    def OnSpan(self, event):
        self.mainApp.checkRefNB()

