import wx, random, controlMini, kjd, utility
import sqlite3 as sqlite


rightList = [
'That is Correct!', 'Congratulations!', 'You are Right!', 'Affirmative!', 'Yes!', 'You Got It!',
'That\'s It!', 'Smarty Pants', 'You\'re on a Roll', 'Absolutly!', 'You\'re Amazing', 'Wow', 
'Awesome', 'Simply Marvelous', 'Genius', 'Masterful', 'Don\'t Stop Now!',
]

wrongList = [
'Sorry', 'Uh...What?', 'That is Plain Wrong!', 'Error, Error', 'Having Problems?', 'What Happened?',
'Are You Awake?', 'Click the Wrong Button?', 'Not Correct', 'Unfortunatly ...', 'Did You Guess?', 'That Will Cost You',
'Did You Mean That?', 'Well ... No', 'Not this Time', 'You\'re Being Silly', 'Are You Serious?', 'Need to Rest a While?',
'Negative', 
]


## Book Quest Game Mini and Functions
class BookQuest(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.path = self.mainApp.allUsersDir
        
        self.Select = wx.RadioBox(self, -1, "Select Testament",  choices=["Both ", " Old ", " New"], majorDimension=1, style=wx.RA_SPECIFY_ROWS)
        self.revLabel = wx.StaticText(self, -1, "Mystery Verse")
        self.choice = wx.Choice(self, -1, choices = controlMini.books)
        self.newButton = wx.Button(self, -1, "New")#, size=(40, 22))
        self.revLabel2 = wx.StaticText(self, -1, "Select Book")
        self.ansLabel = wx.StaticText(self, -1, "", style=wx.ALIGN_CENTER)
        self.ansLabel2 = wx.StaticText(self, -1, "", style=wx.ALIGN_CENTER)
        self.scoreLabel = wx.StaticText(self, -1, "Score = 0", style=wx.ALIGN_CENTER)
        
        self.display = wx.html.HtmlWindow(self, -1, size = (-1, 100), style=wx.BORDER_SIMPLE )

        self.__set_properties()
        self.__do_layout()
        
        self.Bind(wx.EVT_CHOICE, self.OnCheck, self.choice)
        self.Bind(wx.EVT_BUTTON, self.GetVerse, self.newButton)


    def __set_properties(self):
        self.revLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.revLabel2.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        self.scoreLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.scoreLabel.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.ansLabel.SetForegroundColour(wx.Colour(100, 0, 0))
        #self.ansLabel.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.ansLabel2.SetForegroundColour(wx.Colour(100, 0, 0))


    def __do_layout(self):
        self.revSizer = wx.BoxSizer(wx.VERTICAL)
        #radioSize = wx.BoxSizer(wx.HORIZONTAL)
        entrySize = wx.BoxSizer(wx.HORIZONTAL)
        
        title = controlMini.FMTitlePanel(self, "Verse Challenge Quiz")
        self.revSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        #radioSize.Add(self.Select, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.EXPAND, 3)
        #self.revSizer.Add(radioSize, 0, wx.RIGHT|wx.LEFT|wx.EXPAND, 8)
        self.revSizer.Add(self.Select, 0, wx.RIGHT|wx.LEFT|wx.ALIGN_CENTER, 5)
        self.revSizer.Add((0, 5))

        self.revSizer.Add(self.revLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 3)
        self.revSizer.Add(self.display, 1, wx.RIGHT|wx.LEFT|wx.TOP|wx.EXPAND, 5)
        
        self.revSizer.Add(self.newButton, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)

        self.revSizer.Add(self.revLabel2, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)               
        self.revSizer.Add(self.choice, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        self.revSizer.Add(self.ansLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)  
        self.revSizer.Add(self.ansLabel2, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 2)
        self.revSizer.Add(self.scoreLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 18)
        
        self.SetSizer(self.revSizer)
        self.Layout()
    
        self.choice.SetSelection(0)
        self.GetVerse(None)
        self.score = 0
        self.check = 0
        
        
    def GetVerse(self, event):
        self.ansLabel.SetLabel('')
        self.ansLabel2.SetLabel('')
        
        rng = self.Select.GetSelection()
        
        if rng == 0:
            num = random.randint(1, 31102)
        if rng == 1:
            num = random.randint(1, 23146)
            self.choice.Clear()
            for item in controlMini.books[:38]:
                self.choice.Append(item)
            self.choice.SetSelection(0)
        if rng == 2:
            num = random.randint(23146, 31102)
            self.choice.Clear()
            for item in controlMini.books[39:]:
                self.choice.Append(item)
            self.choice.SetSelection(0)
                
        con = sqlite.connect(self.mainApp.bibFileList[self.mainApp.avIndex])
        #con.text_factory = str
        cur = con.cursor() 
        cur.execute('SELECT * FROM bible WHERE id LIKE ?', (num,))
        row = cur.fetchone()
        
        self.ref = row[1]
        verse = row[2]
        
        print self.ref
        self.display.SetPage('%s' % verse)


    def OnCheck(self, event):
                
        self.check += 1
        entry = self.choice.GetSelection()
        
        rng = self.Select.GetSelection()
        if rng == 2:
            abbr = controlMini.books2[entry +39]
        else:
            abbr = controlMini.books2[entry]
            
        print abbr
        
        
        bk = self.ref[:3]
        if abbr == bk:
            cIdx = random.randint(1, len(rightList))
            
            self.ansLabel.SetLabel(rightList[cIdx -1])
            self.ansLabel2.SetLabel('The verse is %s' % self.ref)
            
            self.score = self.score +2
            #self.GetVerse(None)
        else:
            wIdx = random.randint(1, len(wrongList))
            
            self.ansLabel.SetLabel(wrongList[wIdx -1])
            self.ansLabel2.SetLabel('You can try again.')
            
            self.score = self.score -1
            self.check = 0
        
        self.scoreLabel.SetLabel('Score = %s' % self.score)
        self.revSizer.Layout()

        if self.check == 20:
            dlg = wx.MessageDialog(self, 'Outstanding Job!\nYou have gotten twenty correct answers in a row. \n',
            'Outstanding!', wx.OK | wx.ICON_INFORMATION	)
            
            dlg.ShowModal()
            dlg.Destroy()

        elif self.check == 10:
            dlg = wx.MessageDialog(self, 'Excellent Job!\nYou have gotten ten correct answers in a row. \n',
            'Excellent!', wx.OK | wx.ICON_INFORMATION	)
            
            dlg.ShowModal()
            dlg.Destroy()
                
        elif self.check == 5:
            dlg = wx.MessageDialog(self, 'Good Job!\nYou have gotten five correct answers in a row. \n',
            'Good!', wx.OK | wx.ICON_INFORMATION	)
            
            dlg.ShowModal()
            dlg.Destroy()

            

## Word Quest Game Mini and Functions
class WordQuest(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.wqLabel = wx.StaticText(self, -1, "Select the Correct Definition for", style=wx.ALIGN_CENTER)
        self.wordLabel = wx.StaticText(self, -1, "Word", style=wx.ALIGN_CENTER)
        
        self.RangeBox = wx.StaticBox(self, -1, "Choices")
        
        self.Radio0 = wx.RadioButton(self, -1, '0', style = wx.RB_GROUP)
        self.Radio1 = wx.RadioButton(self, -1, '1')
        self.Radio2 = wx.RadioButton(self, -1, '2')
        self.Radio3 = wx.RadioButton(self, -1, '3')
        self.Radio4 = wx.RadioButton(self, -1, '4')
        
        self.newButton = wx.Button(self, -1, "New")#, size=(40, 22))
        self.ansLabel = wx.StaticText(self, -1, "Correct!\nClick \'New\' for a new word.", style=wx.ALIGN_CENTER)
        self.scoreLabel = wx.StaticText(self, -1, "Score = 0", style=wx.ALIGN_CENTER)
        
        self.__set_properties()
        self.__do_layout()
        
        self.Bind(wx.EVT_BUTTON, self.OnNew, self.newButton)
        
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadio, self.Radio0)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadio, self.Radio1)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadio, self.Radio2)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadio, self.Radio3)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadio, self.Radio4)
        

    def __set_properties(self):
        self.wqLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        
        #self.wordLabel.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.wordLabel.SetForegroundColour(wx.Colour(100, 0, 0))
        
        self.scoreLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))
        #self.scoreLabel.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.ansLabel.SetForegroundColour(wx.Colour(100, 0, 0))
        #self.ansLabel.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))


    def __do_layout(self):
        RangeStaticBox = wx.StaticBoxSizer(self.RangeBox, wx.VERTICAL)
        
        self.wqSizer = wx.BoxSizer(wx.VERTICAL)
        radioSizer = wx.BoxSizer(wx.VERTICAL)
        entrySize = wx.BoxSizer(wx.HORIZONTAL)
        
        title = controlMini.FMTitlePanel(self, "Definition Quest Quiz")
        self.wqSizer.Add(title, 0, wx.EXPAND|wx.ALL, 5)
        
        self.wqSizer.Add((0, 5))
        
        radioSizer.Add(self.Radio0, 0, wx.TOP, 0)
        radioSizer.Add(self.Radio1, 0, wx.TOP, 5)
        radioSizer.Add(self.Radio2, 0, wx.TOP, 5)
        radioSizer.Add(self.Radio3, 0, wx.TOP, 5)
        radioSizer.Add(self.Radio4, 0, wx.TOP, 5)
        radioSizer.Add((0, 5))
        RangeStaticBox.Add(radioSizer, 0, wx.TOP, 6)

        self.wqSizer.Add(self.wqLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 3)
        self.wqSizer.Add(self.wordLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 15)
        self.wqSizer.Add((0, 10))
        self.wqSizer.Add(RangeStaticBox, 0, wx.ALL|wx.EXPAND, 7)
        
        self.wqSizer.Add(self.newButton, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 8)
        self.wqSizer.Add((0, 10))
        self.wqSizer.Add(self.ansLabel, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)  
        self.wqSizer.Add(self.scoreLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10) 
        
        self.SetSizer(self.wqSizer)
        self.Layout()
        
        self.wdList = kjd.kjd.keys()
        self.defList = kjd.kjd.values()
        self.btnList = [self.Radio0, self.Radio1, self.Radio2, self.Radio3, self.Radio4]
        
        self.OnNew(None)
        self.score = 0
        

    def OnRadio(self, event):
        for btn in self.btnList:
            if btn.GetValue() == True:
                df = btn.GetLabel()
                print df
        

        lth = len(df)

        print self.curDef[:lth -1]

        
        if df[:-1] == self.curDef[:lth -1]:
            self.ansLabel.SetLabel('Correct!\nClick \'New\' for a new word.')
            self.score += 2 
        else:
            self.ansLabel.SetLabel('Sorry,\nTry again.')
            self.score -= 1 
        
        self.scoreLabel.SetLabel('Score = %s' % self.score)
        self.wqSizer.Layout()
 

    def OnNew(self, event):
        self.ansLabel.SetLabel(' \n ')
        
        wdNum = random.randint(1, len(self.wdList)) -1
        
        defsNum = random.sample(xrange(len(self.wdList)), 4)
        curWord = self.wdList[wdNum]
        self.curDef = kjd.kjd[curWord]
        
        defListTmp = []
        for num in defsNum:
            df = self.defList[num]
            long = 0
            while self.Radio0.GetTextExtent(df)[0] > 180:
                long = 1
                df = df[:-1] 
            if long == 1:
                df = df[:-1] + '-'
            defListTmp.append(df)
        
        ans = self.defList[wdNum]
        long = 0
        while self.Radio0.GetTextExtent(ans)[0] > 160:
            long = 1
            ans = ans[:-1] 
        if long == 1:
            ans = ans[:-1] + '-'
        
        defListTmp.append(ans)
        
        self.wordLabel.SetLabel(curWord)
        
        random.shuffle(defListTmp)
        
        n = 0
        for df in defListTmp:
            self.btnList[n].SetLabel(df)
            n += 1
        
        for btn in self.btnList:
            btn.SetValue(False)

        self.wqSizer.Layout()
        
        #print curWord, self.curDef
        #print defListTmp


