
import os, re
import sqlite3 as sqlite

sets = {}


def getRefs(id, topic, ln):
    tmpKeys = []
    links = re.findall(r'<a href="bible://(.+?)">', ln) # True ref links
    if not links:
        links = re.findall(r'<u>(\w\w\w_\d+:\d+)</u>', ln) # Older ref tags
        links = [l.replace('_', ' ') for l in links]
    if links:
        for lnk in links:
            #lnk = re.sub(r'^(.+)(?:-\d+)?', r'\1', lnk)

            if lnk.endswith(':'):  # Skip chapters only
                continue
            if not lnk in sets:
                sets[lnk] = []
            dlst = sets.get(lnk)
            if not id in dlst:
                dlst.append(id)
            sets[lnk] = dlst
                    

def doIndex(fn, selStr):
    global sets
    print fn

    verses = []
    lines = []

    con = sqlite.connect(fn)
    con.text_factory = str
    cur = con.cursor()
    cur.execute(selStr)

    for id, row in enumerate(cur):
        getRefs(id, row[1], row[2])
    
    for k, v in sets.items():
        verses.append(k)
        lines.append(v)
        
    cur.execute("DROP TABLE IF EXISTS refindex")
    cur.execute("create table refindex(id INTEGER PRIMARY KEY, topic, line)")

    for id, ln in enumerate(verses):
        cur.execute('insert into refindex values (null, ?, ?)', (ln, repr(lines[id]),))

    con.commit()
    sets = {}






for root, dirs, files in os.walk('Modules'):
    for fn in files:
        if fn.endswith('.dct'):
            pth = ur'%s\%s' % (root, fn)
            if pth.endswith('nave.dct'):
                selStr = 'SELECT * FROM dictionary'
                doIndex(pth, selStr)
        '''        
        elif fn.endswith('.cmt'):
            pth = ur'%s\%s' % (root, fn)
            selStr = 'SELECT * FROM commentary'
            doIndex(pth, selStr)
        elif fn.endswith('.bk'):
            pth = ur'%s\%s' % (root, fn)
            selStr = 'SELECT * FROM book'
            doIndex(pth, selStr)

        '''
    




