import os, os.path, re, zipfile, wx, wx.html, StringIO, toolImg, baseClass, mainPopup, advSearch, fixRef, popup, time, copy
import wx.media
#import flatMenu as FM
import sqlite3 as sqlite
import tools.convertImg


import dragscroller


tmpDir = os.getcwd()
#print tmpDir


class ImageViewer(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, style = wx.DEFAULT_FRAME_STYLE|wx.CLIP_CHILDREN)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.advSearch = advSearch.primSearch(self)
                
        self.imgCheck()

        #Group File Details For Choice Display
        self.imgGroupTitle = []

        #Individual Image Titles, nested
        self.imgTitles = []

        #List of Images file names, nested
        self.imgFileList = []  
        self.imgFNList = []
             
        #self.GetImages()
        self.GetDBImages()
        
        self.Panel = wx.Panel(self, -1)

        self.viewerTree = wx.TreeCtrl(self.Panel, -1, style=wx.TR_HAS_BUTTONS|wx.TR_HIDE_ROOT|wx.TR_LINES_AT_ROOT|wx.BORDER_THEME)
        self.fitSideButton = wx.ToggleButton(self.Panel, -1, "Fit Side")
        self.fitAllButton = wx.ToggleButton(self.Panel, -1, "Fit All")
        self.Display = baseClass.HtmlWindow(self.Panel, -1, style=wx.BORDER_THEME)       
        
        self.SetTitle("Bible Analyzer Image Viewer")
        
        icon = toolImg.getScrollIcon()
        self.SetIcon(icon)
        
        self.Menu = self.CreateMenu()
        self.SetMenuBar(self.Menu)

        self.SetMinSize((800, 600))
        self.viewerTree.SetMinSize((200, -1))
        self.fitSideButton.SetMinSize((65, -1))
        self.fitAllButton.SetMinSize((65, -1))


        mainSizer = wx.BoxSizer(wx.VERTICAL)
        self.fullSizer = wx.BoxSizer(wx.HORIZONTAL)
        treeSizer = wx.BoxSizer(wx.VERTICAL)
        buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        
        buttonSizer.Add(self.fitSideButton, 0, wx.LEFT, 0)
        buttonSizer.Add(self.fitAllButton, 0, wx.LEFT, 5)
        
        treeSizer.Add(self.viewerTree, 1, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 0)
        treeSizer.Add(buttonSizer, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL, 10)
        
        self.fullSizer.Add(treeSizer, 0, wx.TOP|wx.EXPAND, 0)
        self.fullSizer.Add((3, 0))
        self.fullSizer.Add(self.Display, 1, wx.EXPAND, 0)
        
        mainSizer.Add(self.fullSizer, 1, wx.EXPAND, 0)
        self.Panel.SetSizer(mainSizer)
        mainSizer.Fit(self)
        
        #self.Layout()
        self.Center()

        self.mPop = mainPopup.MainPopup(self, self.Display)


        self.root = self.viewerTree.AddRoot('Top')
        
        self.Display.Bind(wx.EVT_MOTION, self.mPop.OnMotion)
        #self.Display.Bind(wx.html.EVT_HTML_CELL_HOVER, self.OnMotion)
        #self.Display.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnLeftDown)
        
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnSelChanged)
        self.Bind(wx.EVT_TOGGLEBUTTON, self.OnFitAll, self.fitAllButton)
        self.Bind(wx.EVT_TOGGLEBUTTON, self.OnFitSide, self.fitSideButton)
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        
        self.Bind(wx.EVT_MENU, self.OnExport, id=1001)
        self.Bind(wx.EVT_MENU, self.OnPrint, id=1002)
        self.Bind(wx.EVT_MENU, self.OnPrintPre, id=1003)
        self.Bind(wx.EVT_MENU, self.OnPrintSetup, id=1004)
        self.Bind(wx.EVT_MENU, self.OnHide, id=1005)
        
        self.Bind(wx.EVT_MENU, self.OnZoom50, id=1020)
        self.Bind(wx.EVT_MENU, self.OnZoom100, id=1021)
        self.Bind(wx.EVT_MENU, self.OnZoom125, id=1022)
        self.Bind(wx.EVT_MENU, self.OnZoom150, id=1023)
        self.Bind(wx.EVT_MENU, self.OnZoom200, id=1024)
        
        self.Bind(wx.EVT_MENU, self.OnClose, id=1010)
        
        self.Display.Bind(wx.EVT_LEAVE_WINDOW, self.mPop.leaveWindow)
        self.Display.Bind(wx.EVT_LEFT_DOWN, self.mPop.OnLeftDown)
        self.Display.Bind(wx.EVT_LEFT_UP, self.mPop.OnLeftUp)
        
        self.Display.Bind(wx.EVT_CHAR, self.mPop.OnCancel)
        
        self.scroller = dragscroller.DragScroller(self.Display)
        
        self.ePrint = wx.html.HtmlEasyPrinting()
        self.ePrint.SetParentWindow(self)
        
        data = self.ePrint.GetPageSetupData()
        data.SetMarginTopLeft((10,10))
        data.SetMarginBottomRight((10,10))
        data.SetPaperId(1)

        
        self.BuildTree()
        
        intro = '''<center><font face="Verdana" size="+2" color="#660000">Bible Analyzer Image Viewer</font><br><br><font face="Verdana">
        Select an image to view from the titles on the left.<br><br>You can add you own <i>.jpg</i> and <i>.gif</i> images by placing them 
        in the<br>%s folder.<br> They will be found under <i>User Images</i> upon the next start.</font></center>''' % self.mainApp.myDocsDir.replace("\\", "/")
        
        self.Display.SetPage(intro)
        
        self.Toggle = 0
        self.inMem = 0
        self.inMemPrint = 0
        self.imgMapData = None
        self.txtData = None
        self.lastWord = None
        self.toolwin = None
        self.mc = None
        self.audioTitle = None
        self.mp3Idx = 0
        self.mp3Path = None
        self.regions = None
        self.img = None
        
        self.memFs = wx.MemoryFSHandler()
        wx.FileSystem_AddHandler(self.memFs)
          



    ## Image functions

    def imgCheck(self):
        imgPath = self.mainApp.allUsersDir + '/modules/image/'
        cnt = 1
        hit = False
        for fname in os.listdir(imgPath):
            if fname.endswith('img'):
                base, ext = os.path.splitext(fname)
                if not os.access(imgPath + base + '.imd', 1):
                    hit = True
                    dlg = wx.ProgressDialog('Converting Image Files.', 'This is just to make the dialog bigger', maximum = 12, \
                    style = wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_REMAINING_TIME)
                    dlg.Update(cnt, 'Converting %s' % base)
                    tools.convertImg.convertImg(imgPath, base + '.img')
                    cnt += 1
                    dlg.Destroy()
        if hit:
            dlg = wx.MessageDialog(self.mainApp, 'The Image modules have been converted to an updated format.\nThey will appear in the Image Viewer when Bible Analyzer is restarted.',
            'Image File Conversion', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()
    

    def GetDBImages(self):
        for fname in self.mainApp.imdList:
            con = sqlite.connect(fname)
            cur = con.cursor()
            temp = []
            
            # Get main title
            cur.execute('SELECT * FROM title')
            row = cur.fetchone()
            self.imgGroupTitle.append(row[0])
            
            # Get image titles
            cur.execute('SELECT title FROM images')
            rows = cur.fetchall()
            temp = [(row[0]) for row in rows]
            self.imgTitles.append(temp)
            
            self.imgFNList.append(fname)
        
        self.GetUserImages()
        
    
    def GetUserImages(self):
        # User added images
        user = []
        userFn = []
        self.imgGroupTitle.append('User Images ')
        for fname in self.mainApp.userImgList:
            base = os.path.basename(fname)
            user.append(base[:-4].capitalize())
            userFn.append(fname)
        self.imgTitles.append(user)
        self.imgFileList.append(userFn)
        


    def BuildTree(self):
        idx = 0
        for group in self.imgGroupTitle:
            child = self.viewerTree.AppendItem(self.root, group[:-1])
            self.viewerTree.SetPyData(child, idx)
            self.viewerTree.SetItemBold(child, True)
            imgIdx = 0
            for img in self.imgTitles[idx]:
                subChild = self.viewerTree.AppendItem(child, img)
                self.viewerTree.SetPyData(subChild, imgIdx)
                imgIdx += 1
            
            idx += 1
    
        
    
    
    def OnHide(self, event):
        self.fullSizer.Hide(0, True)
        if self.Toggle == 0:
            self.fullSizer.Hide(0, True)
            self.Toggle = 1
        else:
            self.fullSizer.Show(0, True)
            self.Toggle = 0
        self.fullSizer.Layout()

    
    def OnExport(self, event):
        try:
            self.img
        except:
            dlg = wx.MessageDialog(self, 'You must select an image first.',
                                         'Select Image', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        dlg = wx.FileDialog(self, message="Export PNG Image", defaultDir=os.getcwd(), defaultFile = "",
                            wildcard = '.png', style=wx.SAVE)
            
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            self.origImg.SaveFile(path, wx.wx.BITMAP_TYPE_PNG)
        
        dlg.Destroy()
    
        
    def OnPrint(self, event):
        img = self.fixPrint()
        page = '<body><img src="memory:print.png"></body>'
        self.ePrint.PrintText(page)
    
    
    def OnPrintPre(self, event):
        img = self.fixPrint()
        page = '<body><img src="memory:print.png"></body>'
        self.ePrint.PreviewText(page)
    
    
    def fixPrint(self):
        if not self.origImg:
            return
        
        img = self.origImg
        
        imgWidth = img.GetWidth()
        imgHeight = img.GetHeight()
        
        #print imgWidth, imgHeight, 'img1'
        
        data = self.ePrint.GetPrintData()
        orient = data.GetOrientation()
        
        if orient == 1:
            paperWid = 710
            paperHgt = 910
        else:
            paperWid = 910
            paperHgt = 710
        
        if imgWidth > paperWid or imgHeight > paperHgt:
            if self.ratio > 1:
                imgWidth = paperWid
                imgHeight = imgWidth / self.ratio
                if imgHeight > paperHgt:
                    imgHeight = paperHgt
                    imgWidth = imgHeight * self.ratio               
            else:
                imgHeight = paperHgt
                imgWidth = imgHeight * self.ratio
                if imgWidth > paperWid:
                    imgWidth = paperWid
                    imgHeight = imgWidth / self.ratio
                    
            
            img.Rescale(imgWidth, imgHeight)

        if self.inMemPrint:
            self.memFs.RemoveFile('print.png')
            self.inMemPrint = 0
        
        self.memFs.AddFile('print.png', img, wx.wx.BITMAP_TYPE_PNG)
        self.inMemPrint = 1
        #return img
        
    
    
    def OnSelChanged(self, event):
        self.CheckForImg()            
        
        self.imgMapData = None
        self.txtData = None

        item = event.GetItem()
        self.itemParent = self.viewerTree.GetItemParent(item)
        
        if self.itemParent == self.root:
               return
            
        imgIdx = self.viewerTree.GetPyData(item)
         
        if self.viewerTree.GetItemText(self.itemParent) == 'User Images':
            fn = self.imgFileList[-1][imgIdx]
            self.img = wx.Image(fn)
            
            self.origImg = wx.Image(fn)
            self.userImg = 1
        
        else:
            idx = self.viewerTree.GetPyData(self.itemParent)
            
            con = sqlite.connect(self.imgFNList[idx])
            cur = con.cursor()
            cur.execute('SELECT * FROM images where id=?', (imgIdx +1,))
            row = cur.fetchone()
            
            if len(row) > 3:
                try:
                    self.imgMapData = eval(row[3])
                except:
                    self.imgMapData = None

            if len(row) > 4:
                self.txtData = row[4]

            self.imageData = row[2]
            
            self.origImg = wx.ImageFromStream(StringIO.StringIO(self.imageData))
            
            self.img = self.origImg.Copy()
            
            self.userImg = 0
                
        self.ratio = float(self.img.GetWidth())/float(self.img.GetHeight())
        
        self.winsize = self.Display.GetClientSize()
        self.width = self.winsize[0]
        self.height = self.winsize[1] 
        
        self.imgSize = (self.img.GetWidth(), self.img.GetHeight())
        
                
        if self.fitSideButton.GetValue() == True:
            self.OnFitSide(None)
        
        elif self.fitAllButton.GetValue() == True:
            self.OnFitAll(None)
        
        else:
            self.showImg(self.img)
        

    def showImg(self, img):
        wx.BeginBusyCursor()
        self.memFs.AddFile('img.png', img, wx.BITMAP_TYPE_PNG)
        self.inMem = 1
        self.Display.LoadPage('memory:img.png')
        if self.txtData:
            self.Display.AppendToPage(self.txtData)
        #self.memFs.RemoveFile('img.png')
        wx.EndBusyCursor()


    def resizeWarning(self):
        dlg = wx.MessageDialog(self, 'This is a linked image; resizing it will destroy the link coordinates.\n\
To maintain proper coordinates, the image must be viewed at full size.',
    'Linked Image Resize Warning', wx.OK | wx.ICON_WARNING)
        dlg.ShowModal()
        dlg.Destroy()



    def OnFitAll(self, event):
        
        if self.inMem:
            self.memFs.RemoveFile('img.png')
            self.inMem = 0
        
        try:
            if self.fitAllButton.GetValue() == True:
                if self.imgMapData:
                    self.resizeWarning()

                self.fitSideButton.SetValue(False)
                
                size = self.Display.GetSize()
                if self.userImg == 0:
                    img = wx.ImageFromStream(StringIO.StringIO(self.imageData))
                else:
                    img = self.img
                    
                imgWidth = self.img.GetWidth()
                imgHeight = self.img.GetHeight()
                
                print imgWidth, imgHeight
                
                if self.ratio > 1:
                    imgWidth = self.width -30
                    imgHeight = imgWidth / self.ratio
                else:
                    imgHeight = self.height -30
                    imgWidth = imgHeight * self.ratio
                    
                print imgWidth, imgHeight
                
                img.Rescale(imgWidth, imgHeight, wx.IMAGE_QUALITY_HIGH)
                self.showImg(img)
                
            else:
                self.showImg(self.origImg)
        except:
            return
    
    def OnFitSide(self, event):
        
        if self.inMem:
            self.memFs.RemoveFile('img.png')
            self.inMem = 0

        try:
            if self.fitSideButton.GetValue() == True:
                if self.imgMapData:
                    self.resizeWarning()
                
                self.fitAllButton.SetValue(False)
                
                imgWidth = self.img.GetWidth()
                imgHeight = self.img.GetHeight()
                
                if self.userImg == 0:
                    img = wx.ImageFromStream(StringIO.StringIO(self.imageData))
                else:
                    img = self.img
                
                if self.ratio > 1:
                    imgHeight = self.height
                    imgWidth = imgHeight * self.ratio
                else:
                    imgWidth = self.width 
                    imgHeight = imgWidth / self.ratio

                img.Rescale(imgWidth -35, imgHeight -40, wx.IMAGE_QUALITY_HIGH)
                self.showImg(img)                
                
            else:
                self.showImg(self.origImg)        
        except: 
            return
    
    def OnPrintSetup(self, event):
        
        self.ePrint.PageSetup()

    def CheckForImg(self):
        if self.inMem:
            self.memFs.RemoveFile('img.png')
            self.inMem = 0


    def OnZoom50(self, event):
        wx.BeginBusyCursor()
        self.CheckForImg()
        if self.img:
            img = self.img.Copy()
        else:
            return
        img.Rescale(self.imgSize[0] * .5, self.imgSize[1] * .5, wx.IMAGE_QUALITY_HIGH)
        self.showImg(img)
        wx.EndBusyCursor()

    def OnZoom100(self, event):
        self.CheckForImg()
        if self.img:
            self.showImg(self.origImg)
        else:
            return

        

    def OnZoom125(self, event):
        wx.BeginBusyCursor()
        self.CheckForImg()
        if self.img:
            img = self.img.Copy()
        else:
            return
        img.Rescale(self.imgSize[0] * 1.25, self.imgSize[1] * 1.25, wx.IMAGE_QUALITY_HIGH )
        self.showImg(img)
        wx.EndBusyCursor()

    def OnZoom150(self, event):
        wx.BeginBusyCursor()
        self.CheckForImg()
        if self.img:
            img = self.img.Copy()
        else:
            return
        img.Rescale(self.imgSize[0] * 1.5, self.imgSize[1] * 1.5, wx.IMAGE_QUALITY_HIGH)
        self.showImg(img)
        wx.EndBusyCursor()

    def OnZoom200(self, event):
        wx.BeginBusyCursor()
        self.CheckForImg()
        if self.img:
            img = self.img.Copy()
        else:
            return
        img.Rescale(self.imgSize[0] * 2, self.imgSize[1] * 2, wx.IMAGE_QUALITY_HIGH)
        self.showImg(img)
        wx.EndBusyCursor()


    
    def CreateMenu(self):
        viewMenu  = wx.Menu()
        fileMenu  = wx.Menu()
        zoomMenu = wx.Menu()
        printMenu  = wx.Menu()
        menu = wx.MenuBar()
        
        self.togHide = wx.MenuItem(viewMenu, 1005, "Hide/Show Image Tree\tCtrl+H", " Hide/Show Image Tree", wx.ITEM_NORMAL)
        viewMenu.AppendItem(self.togHide)

        self.close = wx.MenuItem(viewMenu, 1010, "Exit\tAlt+X", " Close Viewer", wx.ITEM_NORMAL)
        viewMenu.AppendItem(self.close)

        self.export = wx.MenuItem(fileMenu, 1001, "Export Current Image", " Export Current Image", wx.ITEM_NORMAL)
        fileMenu.AppendItem(self.export)

        self.zoomImg = wx.MenuItem(zoomMenu, 1020, "Resize to 50%", " Resize to 50%", wx.ITEM_NORMAL)
        zoomMenu.AppendItem(self.zoomImg)

        self.zoomImg = wx.MenuItem(zoomMenu, 1021, "Resize to 100%", " Resize to 50%", wx.ITEM_NORMAL)
        zoomMenu.AppendItem(self.zoomImg)

        self.zoomImg = wx.MenuItem(zoomMenu, 1022, "Resize to 125%", " Resize to 50%", wx.ITEM_NORMAL)
        zoomMenu.AppendItem(self.zoomImg)

        self.zoomImg = wx.MenuItem(zoomMenu, 1023, "Resize to 150%", " Resize to 50%", wx.ITEM_NORMAL)
        zoomMenu.AppendItem(self.zoomImg)

        self.zoomImg = wx.MenuItem(zoomMenu, 1024, "Resize to 200%", " Resize to 50%", wx.ITEM_NORMAL)
        zoomMenu.AppendItem(self.zoomImg)


        self.printSetup = wx.MenuItem(printMenu, 1004, "Printer Setup", " Printer Setup", wx.ITEM_NORMAL)
        printMenu.AppendItem(self.printSetup)

        self.printImg = wx.MenuItem(printMenu, 1002, "Print Current Image", " Print Image", wx.ITEM_NORMAL)
        printMenu.AppendItem(self.printImg)
        
        self.printImgPre = wx.MenuItem(printMenu, 1003, "Print Preview Current Image", " Print preview for Image", wx.ITEM_NORMAL, None)
        printMenu.AppendItem(self.printImgPre)

        menu.Append(viewMenu, "&View")
        menu.Append(fileMenu, "&Export")
        menu.Append(zoomMenu, "&Zoom")
        menu.Append(printMenu, "&Print")
        self.addToolText = False
        return menu


    def OnClose(self, event):
        self.Hide()
        self.mainApp.Raise()



class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        Viewer = ImageViewer(None, -1, "")
        #self.SetTopWindow(Viewer)
        Viewer.Show()
        return 1


if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()
