import wx, re, fixRef, contextMenu, baseClass
#from pysqlite2 import dbapi2 as sqlite
import sqlite3 as sqlite
import wx.lib.buttons as buttons
from artManager import ArtManager, DCSaver


class InfoWin(wx.MiniFrame):
    def __init__(self, parent):
        wx.MiniFrame.__init__(self, parent, style = wx.DEFAULT_FRAME_STYLE)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.panel = wx.Panel(self, -1)
        self.infoWindow = baseClass.HtmlWindow(self.panel, -1, style = wx.WANTS_CHARS|wx.BORDER_THEME)
        self.infoWindow.SetName('InfoWin')
        close = buttons.GenButton(self.panel, -1, 'Close', size=(35, 22))

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer2 = wx.BoxSizer(wx.VERTICAL)
        sizer2.Add(self.infoWindow, 1, wx.EXPAND|wx.ALL, 5)
        sizer2.Add(close, 0, wx.ALIGN_RIGHT|wx.BOTTOM|wx.RIGHT, 5)
        self.panel.SetSizer(sizer2)
        sizer.Add(self.panel, 1, wx.EXPAND, 0)
        self.SetSizer(sizer)
        self.Layout()
        
        self.infoWindow.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnClick)
        self.infoWindow.Bind(wx.html.EVT_HTML_CELL_HOVER, self.OnOver)
        self.infoWindow.Bind(wx.EVT_LEAVE_WINDOW, self.mainApp.leaveWindow)
        
        self.infoWindow.Bind(wx.EVT_KEY_DOWN, self.OnKeyDown)
        self.infoWindow.Bind(wx.EVT_CHAR, self.OnChar)        

        self.Bind(wx.EVT_BUTTON, self.OnCloseWindow, close)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)
        
        self.panel.Bind(wx.EVT_PAINT, self.OnPaint)
        self.panel.Bind(wx.EVT_ERASE_BACKGROUND, self.OnEraseBackground)
        
        
    
    def OnPaint(self, event):
        dc = wx.BufferedPaintDC(self.panel)
        clientRect = self.panel.GetClientRect()
        endColor = wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE)
        startColor = wx.Colour(255, 255, 255)
        ArtManager.Get().PaintStraightGradientBox(dc, clientRect, startColor, endColor, True)
    
    def OnEraseBackground(self, event):
        pass

    
    def OnClick(self, event):
        event.Skip()
        self.SetFocus()
        cell = event.GetCell()
        select = cell.ConvertToText(None)
        
        mouseButton = event.GetMouseEvent().GetButton()
        if mouseButton == 1:
            if '_' in select:
                self.mainApp.ShowRefContext(select)
            else:
                return
        if mouseButton == 3:
            self.infoWindow.SetFocus()
            conMenu = contextMenu.ContextMenu(self) 
            conMenu.MakeShortMenu(select)
            self.Refresh()
    
    def OnOver(self, event):
        event.Skip()
        cell = event.GetCell()
        x, y = wx.GetMousePosition()
        select = cell.ConvertToText(None)
        self.GetParent().GetPopup(x, y, select)

    def OnCloseWindow(self, event):
        self.Hide()

    def OnKeyDown(self, event):
        event.Skip()
        keycode = event.GetKeyCode()
    
    def OnChar(self, event):
        keycode = event.GetKeyCode()
        if keycode == 3:
            self.OnCopy(event)
        elif keycode == 1:
            self.OnSelectAll(event)
    
    def OnSelectAll(self, event):
        focus = self.FindFocus()
        focus.SelectAll()
    
    def OnCopy(self, event):
        event.Skip()
        try:
            page = self.FindFocus()
            self.do = wx.TextDataObject()
            self.do.SetText(page.SelectionToText())
        except:
            wx.MessageBox("Nothing selected to copy!", "Notice!")
            return
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(self.do)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")


