import wx, os, time, re, advSearch, fixRef, popup
import sqlite3 as sqlite

tmpDir = os.getcwd()

class MainPopup:
    def __init__(self, parent, display):
        
        self.parent = parent
        self.display = display
                
        self.mainApp = wx.GetApp().GetTopWindow()
        self.advSearch = advSearch.primSearch(self)
                
        self.mapData = None
        self.txtData = None
        self.lastWord = None
        self.toolwin = None
        self.mc = None
        self.audioTitle = None
        self.mp3Idx = 0
        self.mp3Path = None
        self.regions = None
        self.scroller = None
        
        

    def OnLeftDown(self, event):
        event.Skip()
        self.leaveWindow(None)
        #print 'down'
        self.mapData = self.parent.imgMapData
        
        if wx.GetKeyState(wx.WXK_CONTROL):
            if self.parent == self.mainApp.imgViewer:
                self.parent.scroller.Start(event.GetPosition())
        else:
            if self.mapData:
                if not self.regions:
                    return
                #    self.SetRegions()

                self.mainApp.Freeze()
                
                disp = self.display.CalcScrolledPosition(self.display.GetScreenPosition())
                pos = wx.GetMousePosition()
                adjPos0 = pos[0] - disp[0]
                adjPos1 = pos[1] - disp[1]
                
                for rg in self.regions:
                    if rg.Contains(adjPos0, adjPos1) == wx.InRegion:
                        
                            word = self.words[self.regions.index(rg)]
                            print word, 'click word'
                            
                            #try:
                            if '[[Note]]' in word:
                                note = word.replace('[[Note]] ', '')
                                self.mainApp.OnDictMini(note, 'Image Note', 0)
                                break
                            
                            elif '[[Audio]]' in word:
                                audioTitle = self.newWord.replace('[[Audio]] ', '')
                                self.playAudio(audioTitle)
                                break
                            
                            elif '[[TTS]]' in word:
                                ttsParse = re.search(r'\[\[popup\]\](.+)\[\[read\]\](.+)', word)
                                ttsRead = ttsParse.group(2)
                                self.mainApp.OnTTSReadImage(ttsRead)
                                break
                            
                            elif re.search(r' \d+:', word):
                                self.mainApp.ShowRefContext(word)
                                break
                            
                            elif 'Click to view chapter:' in word:
                                word = re.sub(r'.+:', '', word)
                                try:
                                    word = '%s/%s' % (self.parent.bookTitle, word.strip())
                                    self.mainApp.cpMini.BookViewer.Tree.SelectItem(self.mainApp.cpMini.BookViewer.titles[word])
                                except:
                                    print 'No chapter title'
                            #elif 'searchRng://' in word or 'imageSch/' in word:
                            #    word = re.sub(r'searchRng://|imageSch/', '', word)
                            #    self.OnWordSearch(word, self.rng[self.regions.index(rg)])
                            #    break
                            
                            else:
                                self.OnWordSearch(word, self.rng[self.regions.index(rg)])
                                break

                            #except:
                            #   print 'Image click error'
                            
                self.mainApp.Thaw()


    def OnLeftUp(self, event):
        event.Skip()
        try: 
            self.parent.scroller.Stop()
        except:
            pass
    
    
    def leaveWindow(self, event):
        try:
            self.toolwin.Destroy()
        except:
            pass

        try:
            self.mainApp.toolwin.Destroy()
        except:
            pass

    
    def OnWordSearch(self, word, rng, fromMotion = 0):
        # 0-word, 1-fName, 2-abbr, 3-full, 4-opt, 5-case, 6-fface, 7-showRed, 8-redSearch, 9-idxList, 10-exclude,
        # 11-rangeStr, 12-refOnly, 13-resWdList, 14-doRoot, 15-fixedRef
        
        rngIdx, rngLabel = fixRef.parseRng(rng)
        
        #print rngIdx, rngLabel, 'rngIdx'
        #print word, rng, fromMotion, 'wd'
        
        fPath = self.mainApp.bibFileList[self.mainApp.avIndex]
        
        popup = 0
        if fromMotion:
            popup = 1
        
        if word and rngIdx:
            result, verseList, title, count, findStr, totalHits, exclude, rngRefList = self.advSearch.StdSearch\
            (word, fPath, 'AV', 1, 0, 0, self.mainApp.font, 1, 0, rngIdx, None, rngLabel, 0, 0, 0, rngLabel, 0, 0, popup)
        else:
            return

        if fromMotion:
            return result, verseList, title, count, findStr, totalHits, exclude, rngRefList
        
        # Add data to search query list
        temp = [word, fPath, 'AV', 1, 0, 0, 1, 0, count, findStr, totalHits, exclude, rngLabel, rngRefList, rngIdx]
        self.mainApp.searchQList.append(temp)
        
        #print self.mainApp.searchQList
        
        if self.mainApp.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, result)
            
        try:
            title = utility.CheckEncoding(title)
            #title = unicode(title, "utf-8")
        except:
            title = ''
        
        #self.mainApp.Raise()
        #self.mainApp.Freeze()
        self.mainApp.AddResult(word, title, result)
        self.mainApp.Showing = result
        #self.mainApp.Thaw()
        
        if self.mainApp.getMaximized():
            self.mainApp.mainMgr.RestoreMaximizedPane()
            self.mainApp.mainMgr.MaximizePane(self.mainApp.getResPane())
            self.mainApp.mainMgr.Update()


    def SetRegions(self, offsets = (0,0)):
        self.regions = []
        self.words = []
        self.rng = []
        #print self.mapData
        for set in self.mapData:
            #print set
            c1 = int(set[0]) + offsets[0] -10
            c2 = int(set[1]) + offsets[1] -10
            c3 = int(set[2])
            c4 = int(set[3])
            self.regions.append(wx.Region(c1,c2,c3,c4))
            #appendSet = ['imageSch/%s' % wd for wd in set[4]]
            #self.words.append('imageSch/%s' % set[4])
            self.words.append(set[4])
            self.rng.append(set[5])

    
    def OnMotion(self, event):
        self.mapData = self.parent.imgMapData
        #print self.mapData
        #print 'in motion'
        
        event.Skip()
        if not self.mapData or wx.GetKeyState(wx.WXK_CONTROL):
            self.mainApp.OnMotion(event)
            #print 'not map'
            return
        
        pos = event.GetPosition()
        win = event.GetEventObject()
        sPos = win.CalcUnscrolledPosition(pos)
        
        containerCell = self.display.GetInternalRepresentation()
        cell = containerCell.FindCellByPos(sPos.x, sPos.y) 
        
        #print cell
        
        offset = 0
        if cell and not isinstance(cell, wx.html.HtmlWordCell):             # Image only cell
            #cellSize = (cell.GetWidth(), cell.GetHeight())
            offsets = cell.GetAbsPos()
            
            #print cell
            
            #print offsets, 'os'

            self.SetRegions(offsets)
            
            pos = wx.GetMousePosition()
            
            imgRegion = wx.Region(10 + offsets[0], 10 + offsets[1], cell.GetWidth(), cell.GetHeight())
            
            
            if imgRegion.Contains(sPos[0], sPos[1]) == wx.InRegion:
                #print imgRegion.GetBox()
                hit = 0
                for rg in self.regions:
                    if rg.Contains(sPos[0], sPos[1]) == wx.InRegion:
                        self.display.SetCursor(wx.StockCursor(wx.CURSOR_HAND))
                        
                        self.newWord = self.words[self.regions.index(rg)]
                        
                        if not self.newWord:
                            return
                        
                        if self.newWord == self.lastWord and self.toolwin:
                            return
                        
                        if self.toolwin:
                            self.toolwin.Destroy()
                        
                        self.lastWord = self.newWord
                        
                        time.sleep(.1)
                        hit = 1
                        
                        #print self.newWord, 'nw'
                        #return
                        
                        
                        if '[[Note]]' in self.newWord:
                            #print self.newWord, 'Note'
                            note = self.newWord.replace('[[Note]] ', '')
                            
                            noteTxt = '<b>Note:</b>'

                            if '[[title]]' in note:
                                ttsParse = re.search(r'\[\[title\]\](.+)\[\[body\]\](.+)', note)
                                title = ttsParse.group(1)
                                noteTxt = '<b>Note:</b> %s' % title
                                note = ttsParse.group(2)

                            if len(note) > 750:
                                note = note[:750] + '...<br>...<i>Click to continue.</i>'
                        
                            result = '''<body background="memory:bg.png"><font size="%s">
                            <font color="#660000">%s</font><br><br>%s<br><br><center><i>Click to view entire text in MultiWindow</i></center>
                            ''' % (self.mainApp.popFontSize +2, noteTxt, note)
                            
                            self.showPopup(pos[0], pos[1], result)
                            return
                        
                        elif '[[Audio]]' in self.newWord:
                            audioTitle = self.newWord.replace('[[Audio]] ', '')
                            
                            result = '''<body background="memory:bg.png"><font size="%s">
                            <font color="#660000"><b>Audio <i>%s</i> available</b>:</font><br><i>Click</i> to play; <i>Esc</i> to cancel.
                            ''' % (self.mainApp.popFontSize +2, audioTitle.capitalize())
                            
                            self.showPopup(pos[0], pos[1], result)
                            return
                        
                        elif '[[TTS]]' in self.newWord:
                            if not self.mainApp.tts:
                                return
                            ttsParse = re.search(r'\[\[popup\]\](.+)\[\[read\]\](.+)', self.newWord)
                            ttsPopup = ttsParse.group(1)
                            ttsRead = ttsParse.group(2)
                            
                            result = '''<body background="memory:bg.png"><font size="%s">
                            <font color="#660000"><b>Text-To-Speech Available:</font><br><br>%s</b><br><br><center><i>Click</i> to read; <i>Esc</i> to cancel.</center>
                            ''' % (self.mainApp.popFontSize +2, ttsPopup)
                            
                            self.showPopup(pos[0], pos[1], result)
                            return
                        
                        elif 'Click to view chapter:' in self.newWord:
                            result = '''<body background="memory:bg.png"><font size="%s">
                            %s</font>''' % (self.mainApp.popFontSize +3, self.newWord)
                            
                            self.showPopup(pos[0], pos[1], result)
                            return
                        
                        elif re.search(r' \d+:', self.newWord):
                            line = self.mainApp.GetPopupVerse(self.newWord)
                            if line:
                                self.showPopup(pos[0], pos[1], line)
                            return
                        
                        elif 'searchRng://' in self.newWord or 'imageSch/' in self.newWord:
                            self.newWord = re.sub(r'searchRng://|imageSch/', '', self.newWord)
                        
                        self.mainApp.noPopRefLnk = 1
                        result, verseList, title, count, findStr, totalHits, exclude, rngRefList = \
                        self.OnWordSearch(self.newWord, self.rng[self.regions.index(rg)], 1)
                        
                        #result = re.sub(r'<body.*|Verses.*|</?u>', '', result)
                        result = re.sub(r'^.*<hr>', '', result)
                        result = re.sub(r'_', ' ', result)
                        result = re.sub(r'<b>\d+</b>.*<hr>', '', result)
                        result = re.sub(r'<br><br>', '<br>', result)
                        result = result.strip()
                        resList = result.split('<br>')
                        
                        res = '<br>'.join(resList[:3])
                        if count > 3:
                            res = res + '<br>&nbsp;&nbsp;&nbsp;&nbsp;<font color="#336666"><i>...cont.</i> (click to view all)</font></font>'
                            #print '1', res
                        elif count < 3:
                            res = res[:-13] + '</font>'
                            #print '2', res

                        #result = '''<body background="memory:bg.png"><font size="%s">
                        #<center><font color="#660000"><b>%s</b> - %s (%s)</font><br>
                        #<font size="-1"> %s times in %s verses </font></center>
                        #<table  cellspacing="1" ><tbody><tr><td></td></tr></tbody></table>%s</font>
                        #''' % (self.mainApp.popFontSize +3, self.newWord.capitalize(), 'AV', self.rng[self.regions.index(rg)], totalHits, count, res)
                        
                        result = '''<body bgcolor="%s""><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                        <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> - %s (%s)</font><br><font size="-1">&nbsp;%s times in %s verses </font></td></tr></table>
                        <table cellpadding="2"><td><tr></tr></td></table><font size="%s">%s</font>''' \
                        % (self.mainApp.popColorMac, self.mainApp.popHeadColor, self.mainApp.popFontSize +3, self.newWord.capitalize(), 'AV', self.rng[self.regions.index(rg)], totalHits, count, self.mainApp.popFontSize +3, res)

                        self.showPopup(pos[0], pos[1], result)
                        break
                    else:
                        self.display.SetCursor(wx.NullCursor)
                
                if not hit and self.toolwin:
                    self.toolwin.Destroy()
            

        else:
            if self.toolwin:
                self.toolwin.Destroy()
            #print 'to main'
            self.mainApp.OnMotion(event)


    def showPopup(self, x, y, line):
        #print line, 'line'
        self.toolwin = popup.HtmlPopup(None, line, self.mainApp.popColorIdx, self.mainApp.popFontSize, 0)

        scnWidth = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_X)
        scnHeight = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_Y)
        w, h = self.toolwin.GetSizeTuple()
        if x +10 + w  > scnWidth:
            x = x - w -15
        if y +25 + h > scnHeight:
            y = y - h -25
        
        self.toolwin.SetPosition((x +5, y +15))
        self.toolwin.Show()


    def playAudio(self, audioTitle):
        if not self.mc:
            #try:
            if 'XP' in wx.GetOsDescription():
                self.ImgMC = wx.media.MediaCtrl(self.parent, style=wx.SIMPLE_BORDER)
            else:    
                self.ImgMC = wx.media.MediaCtrl(self.parent, style=wx.SIMPLE_BORDER, szBackend = wx.media.MEDIABACKEND_WMP10 )
            #except:
            #    return
                
            self.ImgMC.Bind(wx.media.EVT_MEDIA_LOADED, self.OnPlay)
            #self.ImgMC.Bind(wx.media.EVT_MEDIA_FINISHED, self.OnFinished)

        
        idx = self.parent.viewerTree.GetPyData(self.parent.itemParent)
        
        con = sqlite.connect(self.parent.imgFNList[idx])
        cur = con.cursor()
        cur.execute('SELECT audioData FROM audio where title=?', (audioTitle,))
        row = cur.fetchone()
        
        if self.mp3Path:
            os.remove(self.mp3Path)
        
        self.mp3Idx += 1
        self.mp3Path = '%s\\%s.mp3' % (tmpDir, self.mp3Idx)
       
        tmpout = open(self.mp3Path, 'wb')
        tmpout.write(row[0])
        tmpout.close()
            
        self.audioTitle = audioTitle    
        self.ImgMC.Load(self.mp3Path)
        


    def OnPlay(self, event):
        self.ImgMC.Play()

    def OnFinished(self, event):
        del self.ImgMC

    def OnCancel(self, event):
        keycode = event.GetKeyCode()
        if keycode == 27:
            if self.mc:
                self.mc.Stop()
            if self.mainApp.tts and self.mainApp.tts.tts.IsSpeaking():
                self.mainApp.tts.Stop()

