import wx, re, wx.html
import games, audioPlayer, labelBook
from artManager import ArtManager, DCSaver
from resources import *



class MediaMini(wx.MiniFrame):
    def __init__(self, parent):
        wx.MiniFrame.__init__(self, parent, -1, " Audio/Quiz Panel", style = wx.CAPTION|wx.CLOSE_BOX|wx.SYSTEM_MENU|wx.FRAME_FLOAT_ON_PARENT|wx.CLIP_CHILDREN)
        
        self.mainApp = parent
        self.LBook = None
        
        self.HideButton = wx.Button(self, -1, "Hide")
        self.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        
        self.CreateDialog()
        self.GetSizer().Fit(self)
        self.GetSizer().SetSizeHints(self)
        self.GetSizer().Layout()
        self.Centre()
        self.SetSize((350, 470))
        
        #self.Bind(labelBook.EVT_IMAGENOTEBOOK_PAGE_CHANGED, self.OnDual)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)
        self.Bind(wx.EVT_BUTTON, self.OnCloseWindow, self.HideButton)
        
        acclTable = self.mainApp.GetAcceleratorTable()
        self.SetAcceleratorTable(acclTable)

    
    

    def CreateDialog(self):

        sz = wx.BoxSizer(wx.VERTICAL)
        self.SetSizer(sz)

        # Create the main book and add some pages into it
        style = INB_NO_RESIZE | INB_LEFT | INB_DRAW_SHADOW | INB_BORDER | INB_USE_PIN_BUTTON
        self.LBook = labelBook.LabelBook(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, style)
        sz.Add(self.LBook, 1, wx.EXPAND)

        self.LBook.SetColour(INB_TAB_AREA_BACKGROUND_COLOR, labelBook.ArtManager.Get().GetMenuFaceColour())

        colour = wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE)
        self.LBook.SetColour(INB_ACTIVE_TAB_COLOR, colour)

        self.Initialise()
        hsizer = wx.BoxSizer(wx.HORIZONTAL)

        # add a separator between the book & the buttons area
        hsizer.Add(self.HideButton, 0, wx.TOP | wx.BOTTOM, 2)
        sz.Add(wx.StaticLine(self), 0, wx.EXPAND | wx.TOP, 3)
        sz.Add(hsizer, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALL, 2)


    def Initialise(self):
        self.BookQuest = games.BookQuest(self)
        self.WordQuest = games.WordQuest(self)
        self.AudioPanel = audioPlayer.HymnPanel(self)
        print self.AudioPanel
        
        self.LBook.DeleteAllPages()
        self.LBook.AddPage(self.AudioPanel, "Audio Player", False)
        self.LBook.AddPage(self.BookQuest, "Verse Challange", False) 
        self.LBook.AddPage(self.WordQuest, "Definition Quest", False)
        
    def OnCloseWindow(self, event):
        self.Hide()
        self.mainApp.Raise()
