import wx, wx.html, time, re
import normSearch, baseClass

import toolImg

#import flatMenu as FM
import genButton as buttons
from artManager import ArtManager



class MiniWin(wx.MiniFrame):
    def __init__(self, parent, type = 0):
        wx.MiniFrame.__init__(self, parent, style = wx.DEFAULT_FRAME_STYLE|wx.CLIP_CHILDREN)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        self.type = type
        
        nextImg = toolImg.getNextArrowBitmap()
        prevImg = toolImg.getPrevArrowBitmap()
        defaultImg = toolImg.getKeyBitmap()
        backImg = toolImg.getBackArrowBitmap()

        forwImg = toolImg.getForwArrowBitmap()

        

        self.panel = wx.Panel(self, -1)
        #self.next = buttons.GenBitmapButton(self.panel, -1, nextImg, size=(20, 22), style=wx.BORDER_NONE)
        #self.prev = buttons.GenBitmapButton(self.panel, -1, prevImg, size=(20, 22), style=wx.BORDER_NONE)
        self.list = buttons.GenButton(self.panel, -1, 'H', size=(22, 22))

        

        self.back = buttons.GenBitmapButton(self.panel, -1, backImg, size=(20, -1), style=wx.BORDER_NONE)

        self.forw = buttons.GenBitmapButton(self.panel, -1, forwImg, size=(20, -1), style=wx.BORDER_NONE)
        
        self.indexEnter = wx.TextCtrl(self.panel, -1, 'Enter Word for Strong\'s', size=(75, 22), style=wx.TE_PROCESS_ENTER)
        self.goIndex = wx.Button(self.panel, -1, 'Go', size=(40, 22))

        #self.HelpButton = wx.Button(self.panel, -1, '?', size=(22, 23)) #, style=wx.BORDER_NONE)

        

        self.hitList = wx.Choice(self.panel, -1, choices=[], size=(100, -1), style=wx.TE_PROCESS_ENTER)
        
        #self.default = buttons.GenBitmapButton(self.panel, -1, defaultImg, size=(22, 22), style=wx.BORDER_NONE)
        self.MiniWindow = baseClass.HtmlWindow(self.panel, -1, style = wx.WANTS_CHARS|wx.BORDER_THEME )
        self.MiniWindow.SetName('MultiWindow')
        close = wx.Button(self.panel, -1, 'Hide')#, size=(40, -1))
        self.related = wx.Button(self.panel, -1, 'Related')#, size=(50, -1))

        

        self.list.SetForegroundColour(wx.Colour(0, 0, 200))

        self.list.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))

        self.list.SetUseFocusIndicator(False)
               

        self.back.Enable(False)

        self.forw.Enable(False)

        self.list.Enable(False)

        

        self.SetTitle('MultiWindow Overview')
        self.SetMinSize((350, 450))
        
        #self.next.SetToolTipString('Next Resource')

        self.list.SetToolTipString('List of Resourses')
        #self.prev.SetToolTipString('Previous Resourse')
        #self.default.SetToolTipString('Default Resource')
        self.back.SetToolTipString('Cycle History Backward')

        self.forw.SetToolTipString('Cycle History Forward')



        #self.HelpButton.SetToolTip(wx.ToolTip('Help for Multi-Window'))

        #self.HelpButton.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Verdana"))

        #self.HelpButton.SetForegroundColour(wx.Colour(128, 0, 0))



        self.sizer = wx.BoxSizer(wx.VERTICAL)
        self.sizer2 = wx.BoxSizer(wx.VERTICAL)
        self.buttonSizer = wx.FlexGridSizer(1, 3, 3, 3)  # rows, cols, vgap, hgap

        self.buttonSizer.AddGrowableCol(1)
        
        #buttonSizer = wx.FlexGridSizer(1, 6, 3, 3)  # rows, cols, vgap, hgap
        buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        #buttonSizer.AddGrowableCol(4)

        buttonSizer.Add(self.back, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)

        buttonSizer.Add(self.list, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)

        buttonSizer.Add(self.forw, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)

        
        #buttonSizer.Add(self.prev, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        buttonSizer.Add(self.hitList, 0, wx.LEFT|wx.RIGHT, 5)
        #buttonSizer.Add(self.next, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        buttonSizer.Add(self.indexEnter, 1, wx.LEFT|wx.RIGHT, 5)
        buttonSizer.Add(self.goIndex, 0, wx.LEFT|wx.RIGHT, 5)
        #buttonSizer.Add(self.default, 0, wx.LEFT, 5)
        self.sizer2.Add(buttonSizer, 0, wx.EXPAND|wx.TOP, 5)
        
        self.sizer2.Add(self.MiniWindow, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 3)
        
        self.buttonSizer.Add(self.related, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)

        self.buttonSizer.Add(close, 0, wx.ALIGN_RIGHT|wx.RIGHT, 5)
        #self.buttonSizer.Add((-1, -1), 1, 0, 0)
        

        #self.buttonSizer.Add(self.HelpButton, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        self.sizer2.Add(self.buttonSizer, 0, wx.EXPAND|wx.ALL, 5)
        
        #self.panel.SetSizer(self.sizer2)
        
        self.sizer.Add(self.sizer2, 1, wx.EXPAND)
        self.panel.SetSizer(self.sizer)

        #self.Layout()
        
        self.MiniWindow.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnClick)
        self.MiniWindow.Bind(wx.EVT_MOTION, self.OnOver)
        self.MiniWindow.Bind(wx.EVT_LEAVE_WINDOW, self.mainApp.leaveWindow)


        self.Bind(wx.EVT_BUTTON, self.OnBack, self.back)

        self.Bind(wx.EVT_BUTTON, self.OnForw, self.forw)

        self.Bind(wx.EVT_BUTTON, self.OnList, self.list)


        self.Bind(wx.EVT_BUTTON, self.OnCloseWindow, close)
        #self.Bind(wx.EVT_BUTTON, self.OnPrev, self.prev)
        #self.Bind(wx.EVT_BUTTON, self.OnNext, self.next)
        #self.Bind(wx.EVT_BUTTON, self.OnDefault, self.default)

        self.Bind(wx.EVT_CHOICE, self.OnHitList, self.hitList)
        
        self.Bind(wx.EVT_BUTTON, self.OnRelated, self.related)
        
        self.Bind(wx.EVT_TEXT_ENTER, self.OnGoIndex, self.indexEnter)
        self.Bind(wx.EVT_BUTTON, self.OnGoIndex, self.goIndex)
        
        #self.Bind(wx.EVT_BUTTON, self.OnHelp, self.HelpButton)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)
        self.indexEnter.Bind(wx.EVT_LEFT_DOWN, self.OnIndexFocus)
        
        #self.MiniWindow.Bind(wx.EVT_KEY_DOWN, self.OnKeyDown)
        #self.MiniWindow.Bind(wx.EVT_CHAR, self.OnChar)
        
        self.MiniWindow.Bind(wx.EVT_ENTER_WINDOW, self.mainApp.enterWindow)
        self.MiniWindow.Bind(wx.EVT_MOUSEWHEEL, self.mainApp.OnWheelScroll)
        
        #self.panel.Bind(wx.EVT_PAINT, self.OnPaint)
        #self.panel.Bind(wx.EVT_ERASE_BACKGROUND, self.OnEraseBackground)
        
        self.related.SetToolTipString('Send List to Related Search')

        self.related.Enable(False)
        
        self.cmtHits = -1
        self.dctHits = -1
        

        

        self.intro = '''

            <center><font color="Navy" size="+1"><b>Bible Analyzer MultiWindow</b></font></center>
            <br><br>
            The MultiWindow is a multi-purpose window designed to display various
            forms of text and data. For instance, <br>
            <ul>
            <li>The MW can be an alternate viewer for <i>Dictionary</i> and <i>Commentary</i>
            pages (select in preferences).</li>
            <li>The MW will display a AV-Strongs Index for any AV word entered in the entry above
            or selected by Right-Click Context Menu</li>
            <li> The content of any <i>Bible, Commentary, Dictionary, Book</i>,
            and <i>Results</i> Page can be exported to the MW.</li>
            <li> All displayed content can be stored in memory and cycled with <i>Backward/Forward</i>
            buttons or selected from a drop-down list.</li>
            <li> Right-click context menu data such as <i>Word Lists</i> and <i>Statistics</i>
            is displayed in the MW.</li>
            <li> Word lists of search results can be displayed in the MW.</li>
            </ul>
            For more information on the use of the Multi-Window, consult the User Manual.
            <br>        '''


        self.MiniWindow.SetPage(self.intro)
    
    
    def OnIndexFocus(self, event):
        event.Skip()
        if self.indexEnter.GetValue() == 'Enter Word for Strong\'s':
            self.indexEnter.Clear()
        

    

    def OnHelp(self, event):

        self.mainApp.OnContextHelp(311)


    def OnGoIndex(self, event):
        wd = self.indexEnter.GetValue()
        if not wd or wd == 'Enter Word':
            return
        
        normSearch.strongIndex(wd)
        


    def OnListSel(self, event):

        idx = event.GetId() -300
        page = self.mainApp.miniHistory[idx]
        
        #if self.mainApp.fontSize > 0:
        #    page = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, page)
        

        self.MiniWindow.SetPage(page)

        self.SetTitle(self.mainApp.miniHistoryTitle[idx])



    

    def OnList(self, event):

        but = event.GetEventObject()

        self.multiMenu = wx.Menu()

        

        idx = 300

        for item in self.mainApp.miniHistoryTitle:

            self.multiMenu.Append(idx, item, "")

            idx += 1

        

        self.mainApp.Bind(wx.EVT_MENU_RANGE, self.OnListSel, id=300, id2=325)

        

        #rect = but.GetButtonRect()

        #pt = but.ClientToScreen(rect.GetBottomLeft())



        #self.multiMenu.Popup(pt, self.mainApp)
        self.PopupMenu(self.multiMenu)
        self.multiMenu.Destroy()

    
    

    def OnBack(self, event):

        entries = len(self.mainApp.miniHistory)

        posIdx = self.mainApp.miniHistoryIdx - self.mainApp.miniHistoryIdx - self.mainApp.miniHistoryIdx

        if entries < 2:

            return

        if posIdx == entries:

            self.mainApp.miniHistoryIdx = 0

        self.mainApp.miniHistoryIdx -= 1

        self.mainApp.miniWin.SetTitle(self.mainApp.miniHistoryTitle[self.mainApp.miniHistoryIdx])
        
        page = self.mainApp.miniHistory[self.mainApp.miniHistoryIdx]


        self.mainApp.miniWin.MiniWindow.SetPage(page)
        self.mainApp.miniCurrent = page



    def OnForw(self, event):

        entries = len(self.mainApp.miniHistory)

        if entries < 2:

            return

        if self.mainApp.miniHistoryIdx +1 == entries:

            self.mainApp.miniHistoryIdx = -1

        self.mainApp.miniHistoryIdx += 1

        self.mainApp.miniWin.SetTitle(self.mainApp.miniHistoryTitle[self.mainApp.miniHistoryIdx])
        page = self.mainApp.miniHistory[self.mainApp.miniHistoryIdx]
        

        self.mainApp.miniWin.MiniWindow.SetPage(page)
        self.mainApp.miniCurrent = page


    

    def OnRelated(self, event):
        txt = self.MiniWindow.ToText()
        txt = txt.split('\n')
        wList = txt[6:-1]
        
        if self.mainApp.cpMini == None:
            self.mainApp.OnMasterControlMini(None, 0)        
        self.mainApp.cpMini.LBook.SetSelection(2)
        
        self.mainApp.cpMini.relatedVerse.ImportWordList(wList)
        self.mainApp.cpMini.Show()
        
    
        
    def OnHitList(self, event):

        sel = self.hitList.GetSelection()
        if sel != -1:
            try:
                if self.type == 1:

                    word = self.mainApp.currentWord.capitalize()

                    sel = self.mainApp.dctFlagList[sel]

                    title = self.mainApp.dDescList[sel]

                    answer, fNames = normSearch.showLibTopic(word, self.mainApp.dctFileList[sel], self.mainApp.font, self.mainApp.dctColor, title, 0)

                else:

                    ref = self.mainApp.currentRef

                    sel = self.mainApp.cmtFlagList[sel] -1

                    title = self.mainApp.cDescList[sel]

                    

                    #print self.mainApp.hitList, sel

                    if sel in self.mainApp.hitList:

                        ref = self.mainApp.hitList[sel]

                    answer, fNames = normSearch.showLibTopic(ref, self.mainApp.cmtFileList[sel], self.mainApp.font, self.mainApp.cmtColor, title, 1)
            except:
                return
            

            self.SetTitle(title)
            
            if self.mainApp.fontSize > 0:
                answer = '<font size="+%s">%s</font>' % (self.mainApp.fontSize, answer)


            self.MiniWindow.SetPage(answer)

    

    

    
    def OnPrev(self, event):

        cur = self.hitList.GetSelection()

        if cur != 0:

            self.hitList.SetSelection(cur -1)

        else:

            cnt = self.hitList.GetCount()

            self.hitList.SetSelection(cnt -1)

        

        self.OnHitList(None)
        

    
    def OnNext(self, event):
        cur = self.hitList.GetSelection()

        cnt = self.hitList.GetCount()

        if cur != cnt -1:

            self.hitList.SetSelection(cur +1)

        else:

            self.hitList.SetSelection(0)

        

        self.OnHitList(None)



    def OnDefault(self, event):
        idx = self.mainApp.defaultDctIdx

        abbr = self.mainApp.dAbbrList[idx]
        if abbr in self.hitList.GetStrings():
            pass

        else:

            idx = self.mainApp.defaultCmtIdx

            abbr = self.mainApp.cAbbrList[idx]

        

        self.hitList.SetStringSelection(abbr)

        
        try:

            self.OnHitList(None)
        except:

            pass
    
    def OnPaint(self, event):
        dc = wx.BufferedPaintDC(self.panel)
        clientRect = self.panel.GetClientRect()
        endColor = wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE)
        startColor = wx.Colour(255, 255, 255)
        ArtManager.Get().PaintStraightGradientBox(dc, clientRect, startColor, endColor, True)

        
    
    def OnEraseBackground(self, event):
        pass
    
    
    def OnOver(self, event):
        #try:
        self.mainApp.OnMotion(event)
        #except:
        #    pass
        
        
    
    def OnClick(self, event):
        cell = event.GetCell()
        if cell.GetLink():
            event.Skip()
            return

        
        currentCell = event.GetCell()
        select = currentCell.ConvertToText(None)
        
        mButton = event.GetMouseEvent().GetButton()
        if mButton == 1: 
            if select:
                if select[0] == 'H' and select[1:].isdigit() or select[0] == 'G' and select[1:].isdigit():
                    self.mainApp.GoToStrongs(select)
                else:

                    old = self.mainApp.useMini

                    self.mainApp.useMini = True
                    self.mainApp.OnSelect(select)

                    self.mainApp.useMini = old
        if mButton == 3:
            if re.search(r'[_ ]\d+:\d', select):
                select = select.replace('_', ' ')
                self.mainApp.MakeContextMenu(None, select, None)
            else:
                self.mainApp.MakeContextMenu(select, None, None)
        


    def OnCloseWindow(self, event):
        self.Hide()
        self.mainApp.Raise()
    
    
    def OnKeyDown(self, event):
        event.Skip()
        keycode = event.GetKeyCode()
    
    def OnChar(self, event):
        keycode = event.GetKeyCode()
        if keycode == 3:
            self.OnCopy(event)
        elif keycode == 1:
            self.OnSelectAll(event)
    
    def OnSelectAll(self, event):
        focus = self.FindFocus()
        focus.SelectAll()
    
    def OnCopy(self, event):
        event.Skip()
        try:
            page = self.FindFocus()
            self.do = wx.TextDataObject()
            self.do.SetText(page.SelectionToText())
        except:
            wx.MessageBox("Nothing selected to copy!", "Notice!")
            return
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(self.do)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")

