 # -*- coding: utf-8 -*-

import re, wx, zlib, os
import fixRef, chapSum, utility
import sqlite3 as sqlite
import inflection
import time
        

bg = 'bgcolor="#ffffff"'



## Popup Menu Functions
def getVerse(ref, fName, format, full): 
    selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % ref
    con = sqlite.connect(fName)
    cur = con.cursor()
    
    mainApp = wx.GetApp().GetTopWindow()
    
    cur.execute('SELECT * FROM title')
    titleRow = cur.fetchone()
    abbr = ' %s' % titleRow[0]
    
    if mainApp.showBibleVer == 0:
        abbr = ''
    
    cur.execute(selStr)
    row = cur.fetchone()

    line = row[2]
    
    ref = row[1]
    if full == 1:
        fullBk = fixRef.fullTitle(ref[:3])
        ref = fullBk + ref[3:]
    
    ref = '%s%s' % (ref, abbr)
    
    line = re.sub(r'<i>', r'[', line)
    line = re.sub(r'</i>', r']', line)
        
    return line, ref


def getVerseRange(ref, fName):
    idx = ref.find(':')
    chap = ref[:idx+1]
    
    selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % chap
    con = sqlite.connect(fName)
    
    cur = con.cursor()
    cur.execute(selStr)
    
    rows = cur.fetchall()
    
    return len(rows)
        


def getVsRange(fName, idxList):
    final = []
    refList = []
        
    con = sqlite.connect(fName)
    #con.text_factory = str
    cur = con.cursor()
    cur.execute("SELECT * FROM bible WHERE id BETWEEN %d AND %d" % (idxList[0], idxList[1]))
    
    rows = cur.fetchall()
    for row in (rows):
        row = utility.CheckEncryptByHeader(row)
        line = '<a name="%s"></a>%s\t%s' % (row[1], row[1], row[2])
        refList.append(row[1])
        final.append(line)
        
    return refList, final



def formatRangeCopy(ref, last, fName, settings, idxList):
    final = []
    
    # Settings
    # 0-style, 1-fullBk, 2-showVer, 3-refPos, 4-refSep, 5-refParen, 6-refColor
    # Style
    # 0-breaks no verse refs, 1-paragraph-no verse refs, 2-paragraph-with refs, 3-breaks-with refs
    
    mainApp = wx.GetApp().GetTopWindow()
       
    con = sqlite.connect(fName)
    cur = con.cursor()

    try:
        cur.execute('SELECT * FROM title')
        titleRow = cur.fetchone()
        abbr = ' %s' % titleRow[0]
    except:
        print 'title error'
        return

    encrypt = 0
    cur.execute("SELECT name FROM sqlite_master WHERE name='option'")
    if cur.fetchone():
        cur.execute('SELECT * FROM option')
        row = cur.fetchone()
        if len(row) > 2 and row[2]:
            encrypt = 1
    
    if encrypt:
        if idxList[0] + 200 < idxList[1]:
            idxList[1] = idxList[0] + 200
    
    if not settings[2]:
        abbr = ''
    
    selStr = "SELECT * FROM bible WHERE id BETWEEN %d AND %d" % (idxList[0], idxList[1])
    cur.execute(selStr)
    rows = cur.fetchall()
    
    
    if settings[1]:
        fullBk = fixRef.fullTitle(ref[:3])
        ref = fullBk + ref[3:]
    
    for cyc, row in enumerate(rows):
        row = utility.CheckEncryptByHeader(row)
        
        idx = row[1].find(':')
        chap = row[1][:idx +1]
        vs = int(row[1][idx +1:])
        
        nline = row[2]
        
        if '<a hr' in nline:
            nline = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', nline)
            nline = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', nline)
        
        if cyc == 0:
            first = vs
        last = vs
        
        if settings[5]:
            vs = '(%s)' % vs
        
        if settings[6]:
            vs = '{%s}' % vs
        
        if settings[0] == 2 or settings[0] == 3:
            vs = '%s ' % vs
        else:
            vs = ''
        
        # Paragraph
        if settings[0] == 1 or settings[0] == 2:
            hit = '%s%s' % (vs, nline[:-1])
        # Line breaks
        if settings[0] == 0 or settings[0] == 3:
            hit = '%s%s' % (vs, nline)
        
        final.append('%s' % hit)
    
    if str(first) == str(last):
        last = ''
    else:
        last = '-%s' % last
    
    if settings[5]:
        ref = ('(%s%s%s)' % (ref, last, abbr))
    if not settings[5]:
        ref = ('%s%s%s' % (ref, last, abbr))
    if settings[6]:
        ref = '{%s}' % ref
    
    if settings[0] == 1 or settings[0] == 2:
        answer = ' '.join(final)
    if settings[0] == 0 or settings[0] == 3:
        answer = ''.join(final)[:-1]
    
    answer = answer.replace('<i>', '[')
    answer = answer.replace('</i>', ']')
    
    return answer, ref, abbr
    
    

## Tree Functions
def pView(ref, textsList, fface, showRed):
    index = []
    avFinal = []
    
    mainApp = wx.GetApp().GetTopWindow()
    
    if len(ref) == 3:
        ref = ref + ' 1:'
    
    print ref, 'parallel ref'

    def doText(ref, path, idx = 1):
        #print idx, 'idx'
        selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % ref
        
        con = sqlite.connect(path)
        con.text_factory = str
        cur = con.cursor()
        
        try:
            cur.execute('SELECT * FROM title')
            titleRow = cur.fetchone()
            abbr = titleRow[0]
        except:
            print path, 'Parallel, wrong title encoding'
            return 
        
        subFont = None
        if len(titleRow) > 3:
            subFont = titleRow[3]
            
        cur.execute(selStr)
        rows = cur.fetchall()

        if mainApp.showFootnote:
            cur.execute("SELECT name FROM sqlite_master WHERE type='table' AND name='footnote'")
            if cur.fetchone():
                fnSelStr = 'SELECT * FROM footnote WHERE ref LIKE \'%s%%\'' % ref
                cur.execute(fnSelStr)
                fnRows = cur.fetchall()
        
        temp = []
        found = 0
        
        if abbr in ['AV', 'AVs', 'AVp', 'AV-1611']:
            temp.append('<td valign="bottom" width="180"><center><font color="brown"><b>%s</b></font></center></td>' % abbr)
        else:    
            temp.append('<td valign="bottom" width="180"><center><b>%s</b></center></td>' % abbr)

        
        for id, row in enumerate(rows):
            row = utility.CheckEncryptByHeader(row)
            line = '%s\t%s' % (row[1], row[2])
                            
            if '<a hr' in line:
                line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
                line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)

            bgc = ''
            if id % 2 == 0:
                bgc = 'bgcolor="#EFEFEF"'

            #if abbr == 'AV':
            if idx == 0:
                if mainApp.fullBibRef == 0:
                    line = re.sub(r'\w.*\d+:(\d+)\t(.*)\n', r'<tr><td valign="top" width="180" %s><a name="%s"><font color="#660000"><b>\1,</b></font> \2<font size="-1"><i> (%s)</i></font></td>' % (bgc, row[1], abbr), line)
                else:
                    line = re.sub(r'(\w\w\w) (\d+:\d+)\t(.*)\n', r'<tr><td valign="top" width="180" %s><a name="%s"><font color="#336666">\1&nbsp;\2,</font> \3<font size="-1"><i> (%s)</i></font></td>' % (bgc, row[1], abbr), line)
            else:
                if mainApp.fullBibRef == 0:
                    line = re.sub(r'\w.*\d+:(\d+)\t(.*)\n', r'<td valign="top" width="180" %s><a name="%s"><font color="#660000"><b>\1,</b></font> \2<font size="-1"><i> (%s)</i></font></td>' % (bgc, row[1], abbr), line)
                else:
                    line = re.sub(r'(\w\w\w) (\d+:\d+)\t(.*)\n', r'<td valign="top" width="180" %s><a name="%s"><font color="#336666">\1&nbsp;\2,</font> \3<font size="-1"><i> (%s)</i></font></td>' % (bgc, row[1], abbr), line)

            if showRed == True:
                line = line.replace('<r>', '<font color="Red">')
                line = line.replace('</r>', '</font>')
            else:
                line = line.replace('<r>', '')
                line = line.replace('</r>', '')
            
            #Substitute embedded font
            if subFont:
                line = re.sub(r'<gu>', r'%s' % subFont, line)
                line = re.sub(r'</gu>', r'</font>', line)
                        
            found = 1
            
            if path in mainApp.interList:
                if mainApp.showText != True:
                    line = re.sub(r'{(.+?)}', r'', line)
                else:    
                    line = re.sub(r'{(.+?)}', r'<sup><font color="#777777" size="+1"> \1</font></sup>', line)
            
            if mainApp.showFootnote:
                # Database Footnotes
                if '<fn>' in line:
                    def getNote(mo):
                        hit = re.search(r'(<fn>%s.+?)</fn>' % mo.group(1), notes)
                        if hit:
                            note = hit.group(1)
                            note = utility.CheckEncoding(note)
                            nt = re.sub(r'<fn>(\w+)', r'(<b>\1</b>) ', note)
                            return ' <font color="brown" size="-1">%s</font> ' % nt
                                    
                    for fnRow in fnRows:
                        if fnRow[1] == row[1]:
                            notes = fnRow[2]#.split('</fn>')
                            line = re.sub(r'<fn>(\w+)</fn>', getNote, line)
                            break
                                   
                # Link Embedded Footnotes
                elif 'embNote' in line:
                    line = line.replace('<s h', '<a h')
                    line = line.replace('</s>', '</a>')
                    line = re.sub(ur'<a href="embNote/.+?/(.+?)">(\D+?)</a>', ur'<font color="brown" size="-1">\2 \1</font>', line)
                    
                    
                if abbr == 'NET':
                    if not 'NET' in mainApp.cAbbrList:
                        abbr = 'NET-'
                
            else:
                #line = re.sub(r'<fnc?>\d+?</fnc?>', '', line)
                #line = re.sub(r'<a href="embNote.+?</a>', '', line)
                if 'embNote' in line:
                    line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
                    line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
                    #print line.encode('utf-8')
                
            if '<fn>' in line:
                line = re.sub(r'<fn>(\w+?)</fn>', r'<a href="bibleFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, row[1]), line)
            
            if '<fnc>' in line:
                line = re.sub(r'<fnc>(\d+?)</fnc>', r'<a href="commFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, row[1]), line)
            
            if path in mainApp.strongsList:
                if mainApp.showStrongs != True:
                    line = re.sub(r' ?\[\(?[GH](.+?)\)?\]', r'', line)
                else:
                    line = re.sub(r'\[([GH].+?)\]', r'<sup><font color="#000066">\1</font></sup>', line)
            line = re.sub(r'\[\(([GH].+?)\)\]', r'<sup><font color="#660000">\1</font></sup>', line)
            
            #if path.endswith('av1611.bib'):
            #    line = re.sub(r'<sc>(.+?)</sc>', r'<font face="IM FELL English SC">\1</font>', line)
            #    line = re.sub(r'<tn>(.+?)</tn>', r'<font face="IM FELL English">\1</font>', line)
            #    if mainApp.useOldFont:
            #        line = '<font face="IM FELL English">%s</font>' % line
            
            #print line.encode('utf-8')

            temp.append(line)
               
        index.append(temp)

    mainApp = wx.GetApp().GetTopWindow()
    
    abbr = ref[:3]
    fRef = fixRef.fullTitle(abbr)
    fRef = fRef + ref[3:]
        
    #for idx, bibPath in enumerate(textsList):
    #    if bibPath.endswith('av1769.bib'):
    #        avPath = textsList.pop(idx)
    #        doText(ref, avPath)
    #        break

    #for idx, bibPath in enumerate(textsList):
    #    if bibPath.endswith('av1611.bib'):
    #        avPath = textsList.pop(idx)
    #        doText(ref, avPath)
    #        break


    for idx, bibPath in enumerate(textsList):
        doText(ref, bibPath, idx)
 
    
    final = []
    times = len(index[0])
    cycle = 0
    while times > 0:
        for num in range(len(index)):
            try:
                final.extend(''.join(index[num][cycle]))
            except:
                final.extend('<td valign="top" width="180"><center>Text Not Found</center></td>')
        times -= 1
        cycle += 1
        
  
    texts = '''<body link="#336666"><font face="%s" color="#660000"><font size='+2'><center>%s</font><center><br>\
    <center><a href="dialog://parList">Select Texts</a></center><br><br></font>\
    <font face="%s"><table border="0" cellpadding="10" cellspacing="0"><tbody>%s</tbody></table></font>'''\
    % (fface, fRef, fface, ''.join(final))

    return texts 
    
    

def nView(ref, verse, fName, fface, showRed, showText, showStrongs, paragraph, tree = 0, forPopup = 0):

    ref = ref.replace('_', ' ')
    abbr = ref[:3]
    origFace = fface
    
    mainApp = wx.GetApp().GetTopWindow()
    
    try:
        if fName.endswith('1611.bib'):
            fRef = fixRef.fullTitle1611(abbr)
        else:
            fRef = fixRef.fullTitle(abbr)
        fRef = fRef + ref[3:]
    except:
        fRef = ref
    
    cRef = ref + verse
    index = []
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor()
    
    try:
        cur.execute('SELECT * FROM wordlist')
        listrows = cur.fetchall()
        mainApp.txtWordList = [utility.CheckEncoding(row[0]) for row in listrows]
    except:
        mainApp.txtWordList = []
    
    #try:
    cur.execute('SELECT * FROM title')
    titleRow = cur.fetchone()
    abbr = utility.CheckEncoding(titleRow[0])
    
    headTxt = None
    cur.execute("SELECT name FROM sqlite_master WHERE type='table' AND name='heading'")
    if cur.fetchone():
        cur.execute('SELECT head FROM heading WHERE ref LIKE (?)', (ref,))
        headTxt = cur.fetchone()

    subFont = None
    if len(titleRow) > 3:
        subFont = titleRow[3]
        
    selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % ref
    
    cur.execute(selStr)
    rows = cur.fetchall()
    
    header = ''
    if headTxt:
        #headTxt = unicode(headTxt[0], "utf-8")
        headTxt = re.sub(ur'(\d+)(?= )', ur'<a href="bible://%s\1"><nu>\1</nu></a>' % ref, utility.CheckEncoding(headTxt[0]))
        header = '<table><tr><td>&nbsp;&nbsp;</td><td><font size="-1"color="navy">%s</font><br></td></tr></table>' % headTxt
        
    if mainApp.showFootnote:
        cur.execute("SELECT name FROM sqlite_master WHERE type='table' AND name='footnote'")
        if cur.fetchone():
            fnSelStr = 'SELECT * FROM footnote WHERE ref LIKE \'%s%%\'' % ref
            cur.execute(fnSelStr)
            fnRows = cur.fetchall()
    
    for vsNum, row in enumerate(rows):
        row = utility.CheckEncryptByHeader(row)
                
        line = u'%s\t%s' % (row[1], row[2])
        
        anchorRef = row[1]
        if tree != 1:
            line = re.sub(r'\n', '<br>', line)
            line = re.sub(r'(\w\w\w) (\d+):(\d+)\t', r'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<u>\1&nbsp;\2:\3</u>, </font>', line)
        
        else:
            line = re.sub(r'\n', '<br>', line)
            
            if mainApp.fullBibRef == 0:
                line = re.sub(r'.*:(\d+)\t', r'<a name="%s"></a><font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;\1, </font>' % anchorRef, line)
            else:
                line = re.sub(r'(\w\w\w) (\d+):(\d+)\t', r'<a name="%s"><font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;\1&nbsp;\2:\3, </font>' % anchorRef, line)
            
        if showRed == True:
            line = line.replace('<r>', '<font color="Red">')
            line = line.replace('</r>', '</font>')
        else:
            line = line.replace('<r>', '')
            line = line.replace('</r>', '')

        #Substitute embedded font
        if subFont:
            line = re.sub(r'<gu>', r'%s' %subFont, line)
            line = re.sub(r'</gu>', r'</font>', line)
               
        #Strongs numbers
        #print mainApp.strongsList
        if fName in mainApp.strongsList:
            if showStrongs != True:
                line = re.sub(r' ?\[\(?[GH](.+?)\)?\]', r'', line)
            else:
                line = re.sub(r'\[([GH].+?)\]', r'<sup><font color="#000066">\1</font></sup>', line)
                line = re.sub(r'\[\(([GH].+?)\)\]', r'<sup><font color="#660000">\1</font></sup>', line)
               
        #print line

        # Change color between brackets (Companion Bible)
        line = re.sub(r'\[(.+?)\]', r'<font color="#777777"> [\1]</font>', line)
        
        # Change color for idioms - LEB
        line = re.sub(ur'<idm>(.+?)</idm>', ur'<font color="red">‹</font>\1<font color="red">›</font>', line)
        
        # Change color for italic
        line = re.sub(r'(<i>.+?</i>)', r'<font color="#666666">\1</font>', line)
        
        #Interlinear text
        if fName in mainApp.interList:
            if showText != True:
                line = re.sub(r'{(.+?)}', r'', line)
            else:    
                line = re.sub(r'{(.+?)}', r'<sup><font color="#777777" size="+1"> \1</font></sup>', line)

        if mainApp.showFootnote:
            # Database Footnotes
            if '<fn>' in line:
                def getNote(mo):
                    hit = re.search(r'(<fn>%s.+?)</fn>' % mo.group(1), notes)
                    if hit:
                        note = hit.group(1)
                        note = utility.CheckEncoding(note)
                        nt = re.sub(r'<fn>(\w+)', r'(<b>\1</b>) ', note)
                        return ' <font color="brown" size="-1">%s</font> ' % nt
                                
                for fnRow in fnRows:
                    if fnRow[1] == row[1]:
                        notes = fnRow[2]#.split('</fn>')
                        line = re.sub(r'<fn>(\w+)</fn>', getNote, line)
                        break
                               
            # Link Embedded Footnotes
            elif 'embNote' in line:
                line = line.replace('<s h', '<a h')
                line = line.replace('</s>', '</a>')
                line = re.sub(ur'<a href="embNote/.+?/(.+?)">(\D+?)</a>', ur'<font color="brown" size="-1">\2 \1</font>', line)
                
                
            if abbr == 'NET':
                if not 'NET' in mainApp.cAbbrList:
                    abbr = 'NET-'
            
        else:
            #line = re.sub(r'<fnc?>\d+?</fnc?>', '', line)
            #line = re.sub(r'<a href="embNote.+?</a>', '', line)
            if 'embNote' in line:
                line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
                line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
                #print line.encode('utf-8')
                
            if '<fn>' in line:
                line = re.sub(r'<fn>(\w+?)</fn>', r'<a href="bibleFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, row[1]), line)
        
        if fName.endswith('av1611.bib'):
            line = re.sub(r'<sc>(.+?)</sc>', r'<font face="IM FELL English SC">\1</font>', line)
            line = re.sub(r'<tn>(.+?)</tn>', r'<font face="IM FELL English">\1</font>', line)
            if mainApp.useOldFont:
                fface = "IM FELL English"
            
        # Commentary footnotes (i.e. NET)
        if '<fnc>' in line:
            line = re.sub(r'<fnc>(\d+?)</fnc>', r'<a href="commFN/%s/%s://\1"><font color="brown"><sup><nu>\1</nu></sup></font></a> ' % (abbr, row[1]), line)
        
        #Hebrew font
        if fName == 'Modules/Bible/hebi.bib':
            line = re.sub(r', </font>', ', </font><font face="Times New Roman" size="+1">', line)
            #line = re.sub(r'<sup><font ', r'<sup><font size="-1" ', line)  
            line = line + '</font>'

        if fName.endswith('AVp.bib'):
            line = re.sub(r'(<a href="dict/ExLBP://.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
        
        #line = re.sub(r'<i>(.+?)</i>', r'<font color="#656565"><i>\1</i></font>', line)

        #print line.encode('utf-8')
        index.append(line)
        
    if forPopup:
        return ''.join(index)
    
    sum = ''
    if mainApp.showBibSum == 1:        
        for ln in chapSum.chapSum:
            if ln.startswith(ref):
                idx = ln.find('\t')
                sum = '<br><font size="-1"><i>%s</i></font>' % ln[idx:]
                
    title = '''<table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
    <tr><td bgcolor="#f8f8f8"><font face="%s"><font color="#660000"><b>%s</b></font>%s</font></td></tr></table>''' % (origFace, fRef, sum,)
    
    #print ''.join(index)
    
    if len(index) == 0:
        return '''<br><font face="%s"><font color="#660000"><center>
        Oops!<br>This Chapter Is Not Found.<br>Wrong Testament?</center></font></font>''' % fface
    else:
        return '''<body %s link="brown"><font face="%s">%s<br><br>
        %s<br>%s</font>''' % (bg, fface, title, header, ''.join(index))




## First Mention

def fmRegEx(expr, line):
    if isinstance(line, buffer):
        line = zlib.decompress('x\x01' + str(line))
        line = unicode(line, 'utf-8')
    
    if expr[2:-2].lower() in line.lower():
        r = re.compile(r'%s' % expr, re.I|re.U)
        find = r.search(line)
        if find:
            return 1   


def firstMention(wList, fName, vRef, fface, abbr):
    final = []
    
    con = sqlite.connect(fName)
    cur = con.cursor()
    con.create_function("regexp", 2, fmRegEx)

    for wd in wList:
        cur.execute("SELECT * FROM bible WHERE verse regexp '%s'" % (r'\b' + wd + r'\b',))
        row = cur.fetchone()
        row = utility.CheckEncryptByHeader(row)
        if row:
            ref = row[1].replace(' ', '_')
            ref = '<font color="#336666"><u>%s</u></font>' % ref
            final.extend('<tr><td>%s</td><td>%s</td></tr>' % (wd, ref))

    header = '<tr><td><b>Word</b></td><td><b>First Mention</b></td></tr>'

    answer = '''<font face="%s"><b>First Mention of Words in:<br>
    <font color="#660000">%s</font></b> (%s), <b>%s</b> words<br>
    (<i>Right-click on word to search</i>)<hr><table width="250">
    <tbody>%s%s</tbody></table><br></font>'''
    
    return answer % (fface, vRef, abbr, len(wList), header, ''.join(final))



def findRefs(ref, fName): 
    con = sqlite.connect(fName)
    #con.text_factory = str
    cur = con.cursor()
    cur.execute('SELECT * FROM bible WHERE ref =?', (ref,))
    
    hit = ''
    row = cur.fetchone()
    
    if row:
        row = utility.CheckEncryptByHeader(row)
    else:
        return
    
    if '<a hr' in row[2] or '<fn' in row[2]:
        #self.tagList = re.findall(r'<a href.+?</a>|<fnc?>\d+</fnc?>', row[2])
        noTag = re.sub(r'<a href.+?</a>|<fnc?>\d+</fnc?>', r'', row[2])
        row = (row[0], row[1], noTag)
    
    line = '%s\t%s' % (row[1], row[2])
    
    line = line.replace('\n', '<br>')
    line = re.sub(r'[\^~]', '', line)
    line = re.sub(r'(.*:\d+)\t', r'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;\1, </font>', line)
    hit = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', line)

    if hit == '':
        return '<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<b>%s</b></font> <i>Not Found</i><br>' % ref
    else:
        return hit


    
def sContext(ref, word, fName, verseRef, fface, showRed):
    selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % ref
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor()
    cur.execute(selStr)
    
    rows = cur.fetchall()

    ref = ref.replace('_', ' ')
    
    abbr = ref[:3]
    try:fRef = fixRef.fullTitle(abbr)
    except: fRef = abbr
    fRef = fRef + ref[3:]
    
    try: wlist = word.split()
    except: pass
    index = []
    final = []
    
    for row in rows:
        row = utility.CheckEncryptByHeader(row)
        line = '%s\t%s' % (row[1], row[2])
        
        #try:
        #    line = unicode(line, "utf-8")
        #except:
        #    line = unicode(line, "latin1")
        #    print fName, 'Latin1 Encoding'
            
        line = re.sub(r'\n', '<br>', line)
        line1 = re.sub(r'(.*:\d+)\t', r'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;\1, </font>', line)
        
        if showRed == True:
            line = line.replace('<r>', '<font color="Red">')
            line = line.replace('</r>', '</font>')
        else:
            line = line.replace('<r>', '')
            line = line.replace('</r>', '')
        
        line1 = re.sub(r'\[(.+?)\]', r'<font color="#660000"><small>\1</small></font>', line1)     #Strongs
        line1 = re.sub(r'(.\w\w) (\d+:\d+)', r'<u>\1_\2</u>', line1)
        index.append(line1)
    
    verseRef = verseRef + '</u>,'
    for line in index:
        find = re.search(verseRef, line)
        if find:
            try:
                for word in wlist:
                    line = re.sub(word, r'<font color="#660000"><b>'+ word +'</b></font>', line)
            except: pass
            line = re.sub(r'(.+:\d+)', r'<b>\1</b>', line)
            line = re.sub(r'336666', r'660000', line)
            line = re.sub(r'(.*)', r'<a name="line"></a><br>\1<br>', line)

        final.append(line)
    
    if len(final) == 0:
        return '''<br><a name="line"></a><font face="%s"><font color="#660000"><center>
        Oops!<br>This text must be New Testament only</center></font></font>''' % fface
    else:
        return '''<body %s><font face="%s"><font color="#660000">&nbsp;&nbsp;&nbsp;&nbsp;<b>%s</b></font>
        <hr><br><font color="#000000">%s</font></font>''' % (bg, fface, fRef, ''.join(final))



## Search Dictionaries and Commentaries

def libSearch(word, libFileList, full, type, refSch):
    start = time.time()
    
    mainApp = wx.GetApp().GetTopWindow()

    if refSch == 1:
        abbr = word[:3]
        fRef = fixRef.fullTitle(abbr)
        fRef = fRef + word[3:]
        fRef = fRef.replace('_', ' ')
        
        chapIdx = word.find(':')
        chapRef = word[:chapIdx]
        vs = word[chapIdx +1:]
        fWord = re.compile(r'\b%s\b' % word, re.I|re.U)

    else:
        if full == 1:
            fWord = re.compile(r'\b%s\b' % word, re.I|re.U)
        else:
            fWord = re.compile(r'\b%s' % word, re.I|re.U)
    
    final = []
    wdCount = 0
    orig = word
    
    countEntries = 0
    countAllInstances = 0
    countTitleSum = 0
    
    dlg = wx.ProgressDialog('Searching for %s' % word, 'This is just to make the dialog bigger bigger', maximum = len(libFileList), \
    style = wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_REMAINING_TIME)
    
    
    for idx, fName in enumerate(libFileList):
        #print fName
        libEntry = []
                
        countTitle = 0
        counted = 0
        encrypt = 0
        compress = 0
        
        con = sqlite.connect(fName)
        con.text_factory = str
        cur = con.cursor()

        if type != 2:
            cur.execute('SELECT * FROM title')
            titleRow = cur.fetchone()
            try:
                encrypt = titleRow[3]
                compress = titleRow[4]
            except:
                pass
        
        try:
            if type == 0:
                abbrIdx = mainApp.dctFileList.index(fName)
                cur.execute('SELECT * FROM dictionary')
                dlg.Update(idx, 'Searching %s' % mainApp.dAbbrList[abbrIdx])

            elif type == 1:
                abbrIdx = mainApp.cmtFileList.index(fName)
                cur.execute('SELECT * FROM commentary')
                dlg.Update(idx, 'Searching %s' % mainApp.cAbbrList[abbrIdx])
            else:
                cur.execute('SELECT * FROM book')
                dlg.Update(idx, 'Searching %s' % os.path.basename(fName))
        except:
            dlg.Destroy()
            return

        cyc = 1
        for row in cur:
            libText = []
            line = row[2]
            
            if encrypt == 1:
                line = decrypt(line, 'ThyWordIsTruth')
            if compress == 1:
                line = zlib.decompress(line)
                
            line = utility.CheckEncoding(line)

            if word.lower() in line.lower(): # or word.capitalize() in line or word.upper() in line:
                if fWord.search(line):
                    countInst = line.count(word)
                    countEntries += 1
                    countAllInstances += countInst
                    if counted == 0:
                        countTitle += 1
                        counted = 1
                        
                    libText.append(row[1])
                    libEntry.append(libText)    
                cyc += 1
            else:
                if refSch == 1:
                    find = re.search(chapRef + r':(\d+)(</u>)?-(\d+)', line, re.I)                
                    if find and int(vs) >= int(find.group(1)) and int(vs) <= int(find.group(3)):
                        dud, countInst = re.subn(chapRef + r':\d+(</u>)?-\d+', '', line, re.I)
                        countEntries += 1
                        countAllInstances += countInst
                        if counted == 0:
                            countTitle += 1
                            counted = 1
                        
                        libText.append(row[1])
                        libEntry.append(libText)
            
            
        #print cyc
        countTitleSum += countTitle
        final.append(libEntry)
    
    dlg.Destroy()
    
    print time.time() - start, 'Library Search Time'
    
    totals = '"%s" found %d times:\n %d entries in %d titles' % (orig, countAllInstances, countEntries, countTitleSum)
    
    return final, totals




def LibHitSearch(word, pth, topic, parentTitle):
    mainApp = wx.GetApp().GetTopWindow()
    if pth.endswith('.dct'):
        fList = mainApp.dctFileList
        idx = fList.index(pth)
        mainApp.dctNB.SetSelection(idx)
        oldCurrentWord = mainApp.currentWord
        mainApp.currentWord = topic
        mainApp.dctSearchTerm = word
        #mainApp.dctEntry.SetValue(topic)
        mainApp.OnDctNBChanged(None)
        mainApp.currentWord = oldCurrentWord
        
        if '<a name="line">' in mainApp.dctCurrent:
            mainApp.dctDisplay[idx].ScrollToAnchor('line')
            mainApp.dctDisplay[idx].ScrollLines(-2)
            
        mainApp.dctSearchTerm = None

    elif pth.endswith('.cmt'):
        fList = mainApp.cmtFileList
        idx = fList.index(pth)
        mainApp.cmtNB.SetSelection(idx +1)

        oldCurrentRef = mainApp.currentRef
        mainApp.currentRef = topic
        mainApp.cmtSearchTerm = word
        #mainApp.cmtEntry.SetValue(topic)
        mainApp.OnCmtNBChanged(None, 1)
        mainApp.currentRef = oldCurrentRef

        if '<a name="line">' in mainApp.cmtCurrent:
            mainApp.cmtDisplay[idx].ScrollToAnchor('line')
            mainApp.cmtDisplay[idx].ScrollLines(-2)

        mainApp.cmtSearchTerm = None
        
    elif pth.endswith('.bk'):
        parentTitle = re.sub(r', \(\d+ entries\)', '', parentTitle)
        titleStr = '%s/%s' % (parentTitle, topic.replace('"', '[q]'))
        
        print titleStr.encode('utf-8')
        
        mainApp.cpMini.BookViewer.Tree.SelectItem(mainApp.cpMini.BookViewer.titles[titleStr])
        
        cp = re.compile(r'\b(%s)\b' % word, re.I)
        new = cp.sub(r'<a name="line"><font color="#E44B00"><b>\1</b></font></a>', mainApp.prePage)
        
        if mainApp.showBkWin == 0:
            display = mainApp.bookDisplay
        else:
            mainApp.OnBkFrame()
            display = mainApp.bkWinDisplay
            
            useBkWinTxt = '<center><font color="navy"><b>Books are set in <i>Preferences</i> to display in a separate window.</b></font><br><br>\
            To view book contents again in this window (default),<br>\
            uncheck the <i>Show Books in Separate Window</i> option in Preferences.</center>'
            
            mainApp.bookDisplay.SetPage(useBkWinTxt)
            mainApp.bkWin.Show()
        
        display.SetPage(new)
        if '<a name="line">' in new:
            display.ScrollToAnchor('line')
            display.ScrollLines(-2)



## Display Library Topic (DCT/CMT) 
def showLibTopic(topic, fName, fface, bg, title, type, forPopup = 0):
    start = time.time()

    mainApp = wx.GetApp().GetTopWindow()    
    
    final = []
    fNames = []
    hitsList = []
    
    fRef = topic
    if type == 1:
        label1 = 'Comment'
        label2 = 'Verses'
        topic = topic.replace('_', ' ')
        abbr = topic[:3]
        
        if re.search(r'\d:', topic):
            fRef = fixRef.fullTitle(abbr)
            fRef = fRef + topic[3:]
            fRef = '<a href="bible://%s">%s</a>' % (topic, fRef)
        
        for idx in mainApp.cmtFlagList:
            abr = mainApp.cAbbrList[idx -1]
            desc = mainApp.cDescList[idx -1]
            hitsList.append('<a href="comm/%s://%s"><nu>%s</nu></a>' % (abr, topic, desc))
    else:
        label1 = 'Topic'
        label2 = 'Topics'
        for idx in mainApp.dctFlagList:
            abbr = mainApp.dAbbrList[idx]
            desc = mainApp.dDescList[idx]
            hitsList.append('<a href="dict/%s://%s"><nu>%s</nu></a>' % (abbr, topic, desc))
    
    for c in fRef:
        if ord(c) > 900 and ord(c) < 975 or  ord(c) > 7935 and ord(c) < 8191:   #Greek
            fRef = '<font face="GU Greek">%s</font>' % fRef
            break
        
        elif ord(c) > 1424 and ord(c) < 1524:                                  #Hebrew
            fRef = '<font face="GU Hebrew">%s</font>' % fRef
            break

    headBg = mainApp.dctHeadColor
    if type == 1:
        headBg = mainApp.cmtHeadColor
    
    lineIdx = 0
    
    header = '''<div align="center"><table align="center" bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
<tr><td bgcolor="%s"><font color="#676C8A"><i><b>%s</b></i><br><font color="#660000">%s</font> is not found.</font></td></tr></table></div>''' % (headBg, title, fRef)

    
    notFound = '<body bgcolor="%s" link="#336666"><font face="%s">%s\
    <font color="#666666"><br><br>Click "Next %s" button for closest entry or \
    "Hide/Show %s" button for a list of %ss.\
    <br><br><i>The following titles contain this topic (Click title to display):</i></font><br><br>%s</font>'\
    % (bg, fface, header, label1, label2, label1, '<br>'.join(hitsList))

    
    # Finds ref in .idx file and gets idx
    con = sqlite.connect(fName)
    cur = con.cursor()
    
    if type == 0:
        
        cur.execute('SELECT rowid FROM topics where topic=?', (topic,))
        idx = cur.fetchone()
        
        if not idx and topic.isdigit():
            cur.execute('SELECT rowid FROM topics where topic LIKE ?', (topic + '-%',))
            idx = cur.fetchone()
            if idx:
                fRef = topic
        
        elif not idx:
            topic = inflection.singularize(topic)
            cur.execute('SELECT rowid FROM topics where topic=?', (topic,))
            idx = cur.fetchone()
            if idx:
                fRef = topic
        
    else:
        cur.execute('SELECT rowid FROM reference where ref=?', (topic,))    
        idx = cur.fetchone()
    
    if idx:
        # Gets file by idx.
        con = sqlite.connect(fName)
        con.text_factory = str
        cur = con.cursor()
        
        if type == 0:
            cur.execute('SELECT * FROM dictionary where id=?', (idx[0],))
        else:
            cur.execute('SELECT * FROM commentary where id=?', (idx[0],))
        
        row = cur.fetchone()
        #print row
        
        cur.execute('SELECT * FROM title')
        titleRow = cur.fetchone()
        
        grkFont = '<font face="GU Greek" color="brown">'
        hebFont = '<font face="GU Hebrew" color="brown">'
        encrypt = 0
        compress = 0
        
        if len(titleRow) == 5:
            encrypt = titleRow[3]
            compress = titleRow[4]
        elif len(titleRow) == 7:
            if titleRow[5]:
                grkFont = titleRow[5]
            if titleRow[6]:
                hebFont = titleRow[6]

        try:
            lineIdx = row[0]
            line = row[2]
        except:
            return notFound, fNames
        
        if fName.endswith('s-strongEx.dct'):
            sumList = re.findall(r'\((\d+)\)', row[3])
            sumLst = [int(s) for s in sumList]
            total = sum(sumLst)
            wdCount = len(sumList)
            
            line = '%s<br><br><b><font color="#660000">AV Occurrences</font></b> (%s Instances, %s Words)<hr>%s' % (line, total, wdCount, row[3])
        
        if encrypt == 1:
            line = decrypt(line, 'ThyWordIsTruth')
        if compress == 1:
            line = zlib.decompress(line)
            
        line = utility.CheckEncoding(line)
        
        if forPopup:
            line = re.sub(r'<img src="memory:([^"]+)">', '', line)
            return line
        
        if '<img src="memory:' in line:

            fnTemp = re.findall(r'<img src="memory:([^"]+)">', line)
            for fn in fnTemp:
                try:    
                    fn = fn.lower()
                    cur.execute('SELECT * FROM images where fName=?', (fn,))
                    row = cur.fetchone()
                    imgData = row[1]
                    mainApp.memFs.AddFile(fn, str(imgData), wx.BITMAP_TYPE_ANY)
                    fNames.append(fn)
                except:
                    print 'Can\'t get/load images'

        
        if type == 1:
            topic = topic.replace(' ', '_')
            topic = '<font color="#336666" size="-1"><u>%s</u></font>' % topic
        
        line = re.sub(r'(<u>\w\w\w_\d+:\d+)</u>-(\d+(?!:))', r'\1-\2</u>', line)
        
        line = re.sub(r'<sm>.+</sm>', '', line)
        
        line = utility.checkLineTags(line, grkFont, hebFont)
        
        #print line.encode('utf-8')

        final.append(line)
        
        #print time.time() - start, fName, ' Cmt Seek Time'
        
        vsLnk = '- %s' % topic
        if type == 0:
            vsLnk = ''
            
        txt = ''.join(final)
        brk = '<br><br>'
        if txt.startswith('<p>'):
            brk = ''
        
        header = '''<table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
<tr><td bgcolor="%s"><i><font color="#676C8A"><b>%s</b></font></i> - <b>%s</b></td></tr></table>%s''' % (headBg, title, fRef, brk)

        #header = '''<i><font color="navy">%s</font></i> - %s<hr><br>''' % (title, fRef)

        return '''<body bgcolor="%s" link="#336666"><font face="%s"><font color="#660000">%s </font><br>%s</font>''' % (bg, fface, header, txt), fNames

    else:
        if forPopup:
            return
        else:
            return notFound, fNames



def doCmtChap(ref, path):
    selStr = 'SELECT * FROM commentary WHERE ref LIKE \'%s%%\'' % ref
    mainApp = wx.GetApp().GetTopWindow()

    tmp = []
    fNames = []
    
    con = sqlite.connect(path)
    con.text_factory = str
    cur = con.cursor()

    cur.execute('SELECT * FROM title')
    titleRow = cur.fetchone()
    
    grkFont = '<font face="Galaxie Unicode Greek" color="brown">'
    hebFont = '<font face="Galaxie Unicode Hebrew" color="brown">'
    encrypt = 0
    compress = 0
    
    if len(titleRow) == 5:
        encrypt = titleRow[3]
        compress = titleRow[4]
    elif len(titleRow) == 7:
        if titleRow[5]:
            grkFont = titleRow[5]
        if titleRow[6]:
            hebFont = titleRow[6]
            
    cur.execute(selStr)
    rows = cur.fetchall()
    
    for ln in rows:
        t = ln[2]
        if encrypt == 1:
            t = decrypt(t, 'ThyWordIsTruth')
        if compress == 1:
            t = zlib.decompress(t)
        
        t = utility.CheckEncoding(t)
        t = re.sub(r'(<br>)*$', '', t)

        if '<img src="memory:' in t:
            fnTemp = re.findall(r'<img src="memory:([^"]+)">', t)
            for fn in fnTemp:
                try:    
                    fn = fn.lower()
                    cur.execute('SELECT * FROM images where fName=?', (fn,))
                    row = cur.fetchone()
                    imgData = row[1]
                    mainApp.memFs.AddFile(fn, str(imgData), wx.BITMAP_TYPE_ANY)
                    fNames.append(fn)
                except:
                    print 'Can\'t get/load images'

        vRef = '<b><a name="%s" href="bible://%s">%s</a></b>' % (ln[1], ln[1], ln[1])
        t = utility.checkLineTags(t, grkFont, hebFont)
        tmp.append('%s<br><br>%s<hr><br>' % (vRef, t))

    return ''.join(tmp), fNames



def strongIndex(word):
    word = word.strip().replace('"', '')
    
    mainApp = wx.GetApp().GetTopWindow()
    
    if not mainApp.strongExIndex:
        result = '''<font face="Verdana"><center><font color="#660000"><b>AV-Strong Index Not Loaded</b></font></center>
<br><br>
The <b>Strong's Hebrew and Greek Dictionaries w/TVM &amp; AV
Usage</b> module (<i>StrongEx</i>) is not loaded. This module is
necessary to use the <b>AV-Strong Index</b> feature.
<br><br>
The <b>Bible Analyzer Word Study Bundle</b> which includes the <i>StrongEx</i> module and 7 other resources is available
by immediate download for currently $5 by clicking here, <a href="http://www.bibleanalyzer.com/orderStudy/ipn.php?buy">Word Study Bundle</a>.
<br><br>
This link will take you to Paypal, and once payment is confirmed you will be directed to a download page. You will also be sent an email
with the download page link.
<br><br>
If you would like to browse our other module bundles or our
online store, visit our <a href="http://www.BibleAnalyzer.com/modules.html">Modules Page</a>.
<br><br>
The Word Study Bundle Includes:
<ul><li><i>Authorized King James Version, w/Strong's + TVM</i></li>
<li><i>Strong\'s Hebrew and Greek Dictionaries w/TVM &amp; AV Usage</i></li>
<li><i>Greek/English Textus Receptus Interlinear, w/Strong's</i></li>
<li><i>Transliterated Pronounceable Bible, w/Strong's</i></li>
<li><i>Brown-Driver-Briggs Hebrew/Thayer Greek Dictionary</i></li>
<li><i>King James Concordance</i></li>
<li><i>Robertson's Word Pictures of the New Testament</i></li>
<li><i>Vincent's Word Studies,</i></li></ul>
<a href="http://www.bibleanalyzer.com/modules.html"></a></font>'''
        mainApp.OnDictMini(result, 'AV-Strong Index Not Loaded', None)
        return 
    
    
    commonList = ['the', 'and', 'for', 'if', 'with', 'as', 'so', 'it']
    
    if word in commonList:
        result = '''<center>The word "%s" will display thousands of hits and not produce a meaningful result.
        Please choose a less common word or phrase. <br>The word can be used in a phrase.</center>''' % word
        mainApp.OnDictMini(result, 'AV-Strong Index - %s' % word, None)
        return 
    
    if mainApp.dAbbrList.index('StrongEx'):
        con = sqlite.connect(mainApp.dctFileList[mainApp.dAbbrList.index('StrongEx')])
        cur = con.cursor()

        selStr = 'SELECT * FROM dictionary WHERE occr LIKE "%%%s%%"' % word
        cur.execute(selStr)
        rows = cur.fetchall()
        
        final = []
        for row in rows:
            tmp = []
            grps = row[3].split('<br><br>')
            for grp in grps:
                if re.search(r'\b%s\b' % word, grp):
                    grp = re.sub(r'\b(%s)\b' % word, r'<font color="#660000">\1</font>', grp)
                    tmp.append(grp)
            if tmp:
                ln = '<b><u>%s</u></b><br><br>%s<br>%s<hr>' % (row[1], row[2], '<br><br>'.join(tmp))
                ln = re.sub(r'([GH]\d+)', r'<u>\1</u>', ln)
                ln = re.sub(r'(<u>.*?</u>)', r'<font color="#336666">\1</font>', ln)
                ln = re.sub(r'<gu>(.*?)</gu>', r'<font face="GU Greek" color="brown">\1</font>', ln)
                ln = re.sub(r'<hu>(.*?)</hu>', r'<font face="GU Hebrew" color="brown">\1</font>', ln)
                final.append(ln)

        sumList = re.findall(r'\((\d+)\)', ''.join(final))
        sumLst = [int(s) for s in sumList]
        total = sum(sumLst)
        wdCount = len(final)
        
        if not final:
            final = ['<b>No matches found.</b>']

        result = '<font face="%s"><b>AV-Strong Index</b> for <font color="#660000"><b>%s</b></font><br><b>%s</b> Instance(s), <b>%s</b> Topic(s)<hr>%s</font>' % (mainApp.font, word, total, wdCount, ''.join(final))    
        mainApp.OnDictMini(result, 'AV-Strong Index - %s' % word, None)



def showTsk(ref, fName, fface, bg, title):
    
    final = []
    ref = ref.replace('_', ' ')
        
    lineIdx = 0
    notFound = '<body bgcolor="%s"><font face="Georgia"><center>Click in a verse to view references.</center></font>' % bg
    # Finds ref in .idx file and gets idx
    try:
        con = sqlite.connect(fName)
    except:
        notFound = '<body bgcolor="%s"><font face="Georgia"><center>Download Free TSK and Other Modules From,<br>\
        <a href="http://www.BibleAnalyzer.com/modules.htm">Bible Analyzer Modules Page</a></center></font>' % bg
    #con.text_factory = str
    cur = con.cursor()
    cur.execute('SELECT rowid FROM reference where ref=?', (ref,))
    
    idx = cur.fetchone()
    
    if idx:
        # Gets .cmt file by idx.
        con = sqlite.connect(fName)
        #con.text_factory = str
        cur = con.cursor()
        cur.execute('SELECT * FROM commentary where id=?', (idx[0],))
        
        row = cur.fetchone()
        
        try:
            lineIdx = row[0]
            line = row[2]
        except:
            return notFound
        
        #line = unicode(line, "utf-8")
        #line = re.sub(r'(<u>\w\w\w_\d+:\d+)</u>-(\d+(?!:))', r'\1-\2</u>', line)
        line = re.sub(r'(<u>.*?</u>)', r'<font color="#336666">\1</font>', line)
        
        line = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', line)

        
        line = re.sub(r'<gu>(.*?)</gu>', r'<font face="GU Greek" color="brown">\1</font>', line)
        line = re.sub(r'<hu>(.*?)</hu>', r'<font face="GU Hebrew" color="brown">\1</font>', line)
        
        line = re.sub(r' - ', r'<br>-&nbsp;', line)
        
        final.append(line)
        
        body = ''.join(final)
        rCnt = body.count('</a>')

        return u'''<body bgcolor="%s" link="#336666"><font face="%s"><p align="center"><font color="brown">\
        <i>Treasury of Scripture Knowledge, Enhanced</i></font><br><table><tr></tr></table>%s Cross-References<br><b>%s</b></p><hr>%s<hr><div align="center">© 2010, Timothy S. Morton</div></font>'''\
        % (bg, fface, rCnt, ref, body)
    
    else:
        return notFound


def decrypt(ciphertext, password):
    plain = []
    for i, c in enumerate(ciphertext):
        shift = password[i % len(password)]
        shift = ord(shift)
        plain.append((256 + ord(c) - shift) % 256)
    return ''.join([chr(n) for n in plain]) 


def doGradient(txt, page):
        import popup2
        bgImg = popup2.getyellowBackImage
        
        #page.SetPage(txt)
        #ir = page.GetInternalRepresentation()
        #page.SetSize( (ir.GetWidth(), ir.GetHeight()) )
        #self.SetClientSize(popWin.GetSize())
        
        #print ir.GetHeight()
        bgImg.Rescale(1, 500)
        
        memFs = wx.MemoryFSHandler()
        wx.FileSystem_AddHandler(memFs)
        
        memFs.AddFile('bg.png', bgImg, wx.BITMAP_TYPE_PNG)
        page.SetPage(txt)
        
        memFs.RemoveFile('bg.png')



