 # -*- coding: utf-8 -*-

import wx, wx.html, re, utility, fixRef
#import win32api, win32gui
from wx.lib.embeddedimage import PyEmbeddedImage
import sqlite3 as sqlite
import baseClass



class HtmlPopup(wx.MiniFrame):
    def __init__(self, parent, text, colorIdx, size, strong, wid = 0):
        wx.MiniFrame.__init__(self, parent, style = wx.BORDER_NONE|wx.STAY_ON_TOP|wx.FRAME_NO_TASKBAR )
        
        self.mainApp = wx.GetApp().GetTopWindow()

        popWin = baseClass.HtmlWindow(self, -1, style = wx.html.HW_SCROLLBAR_NEVER)
        popWin.Bind(wx.EVT_KEY_UP, self.mainApp.OnBibKeyUp)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(popWin, 1, wx.EXPAND, 0)
        self.SetSizer(sizer)
        self.Layout()
        
        text = re.sub(r'<fn>.+?</fn>', '', text)
        
        txt = text
        if '<br>' in text:
            txt.split('<br>')[1]
        
        strip = re.sub(r'\w\w\w \d+:\d+.+<br>|<.+?>|&nbsp;', '', txt)
        txtWid = popWin.GetTextExtent(strip)[0] +60
        
        #print text.encode('utf-8')
        #print strip.encode('utf-8')
        #print txtWid, size
        
        if size == 1:
            txtWid = txtWid * 1.15
        elif size == 2:
            txtWid = txtWid * 1.3
            
        width = 400
        if txtWid < width:
            width = txtWid
        elif wid == 1:
            width = 325
        
        #print width

        popWin.SetSize((width, -1))
                
        popWin.SetPage(text)

        ir = popWin.GetInternalRepresentation()
        popWin.SetSize( (ir.GetWidth(), ir.GetHeight()) )
        self.SetClientSize(popWin.GetSize())

        #if colorIdx == 1:
        #    bgImg = getRedBackImage()
        #elif colorIdx == 2:
        #    bgImg = getBlueBackImage()
        #elif colorIdx == 3:
        #    bgImg = getGreenBackImage()
        #else:
        #    bgImg = getYellowBackImage()
        
        #print bgImg
        #bgImg.Rescale(ir.GetWidth(), ir.GetHeight())
        
        #memFs = wx.MemoryFSHandler()
        #wx.FileSystem_AddHandler(memFs)
        
        #memFs.AddFile('bg.png', bgImg, wx.BITMAP_TYPE_PNG)
        popWin.SetPage(text)
        
        #memFs.RemoveFile('bg.png')


        #Add dropshadow
        #GCL_STYLE= -26
        #cstyle= win32gui.GetClassLong(self.GetHandle(), GCL_STYLE)
        #if cstyle & CS_DROPSHADOW == 0:
         #   win32api.SetClassLong(self.GetHandle(), GCL_STYLE, cstyle | CS_DROPSHADOW)
        


def popText(ref, startIdx, endIdx, fName, startVs, over):
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor()
    
    cur.execute('SELECT * FROM title')
    titleRow = cur.fetchone()
    title = utility.CheckEncoding(titleRow[1])
    
    selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (startIdx, endIdx)
    
    cur.execute(selectStr)
    rows = cur.fetchall()
    
    startVs = int(startVs)
    
    final = []
    for n, row in enumerate(rows):
        row = utility.CheckEncryptByHeader(row)

        vsRef = re.search(r':(\d+)', row[1]).group(1)
        if vsRef[-1] == ref[-1]:
            vsRef = '<b>%s</b>' % vsRef
        vs = row[2]
        if n > 0:
            vs = u'<br>&nbsp;&nbsp;<font color="Navy">%s</font> %s' % (vsRef, vs)
        else:
            vs = u'&nbsp;&nbsp;<font color="Navy">%s</font> %s' % (vsRef, vs)
            
        vs = vs.replace('<r>', '<font color="Red">')
        vs = vs.replace('</r>', '</font>')
        
        final.append(vs)
        startVs += 1
    
    txt = ''.join(final)
    
    #Remove links
    #print txt.encode('utf-8')
    txt = re.sub(r'<a href="bible[^>]+>.+?</a>', r'', txt)
    txt = re.sub(r'<a href="embNote[^>]+>.+?</a>', r'', txt)
    #print txt.encode('utf-8')
    
    fullBk = fixRef.fullTitle(ref[:3])
    ref = fullBk + ref[3:]
    
    
    if over == 1:
        txt = txt + '<br><font color="Navy">...<i>cont</i>.</font>'
    
    #print txt.encode('utf-8')
    return ref, txt, title
    


def popStrong(ref, fName):
    con = sqlite.connect(fName)
    cur = con.cursor()
    cur.execute('SELECT * FROM dictionary where topic=?', (ref,))
        
    row = cur.fetchone()
    
    try:
        ref = row[1]
        text = row[2]
    except:
        return
    
    #print text.encode('utf-8')

    text = re.sub(r'^(<b>.+?)<br>', r'\1<font size="+2">&nbsp;</font><br>', text)
    #text = re.sub(r'<br><br>', r'<br><font size="+2">&nbsp;</font>', text)
    text = re.sub(r'(</[hg]u>)', r'\1<font size="+2">&nbsp;</font>', text)
    
    text = re.sub(r'</p><p>', r'<table cellpadding="2" width="100%%"><tr><td></td></tr></table><br>', text)
    text = re.sub(r'<br><br>', r'<table cellpadding="2" width="100%%"><tr><td></td></tr></table><br>', text)
    text = re.sub(r'</?p>', r'', text)
    
    text = re.sub(r'<gu>(.+?)</gu>', r'<font face="Galaxie Unicode Greek" color="brown">\1</font>', text)
    text = re.sub(r'<hu>(.+?)</hu>', r'<font face="Galaxie Unicode Hebrew" color="brown">\1</font>', text)
    

    # For old way of tagging Heb/Greek
    if '~' in text:
        text = re.sub(r'\^\^', '<font face="Times New Roman" size="+1" color="brown">', text)
        text = re.sub(r'\^', '<font face="Palatino Linotype" color="brown">', text)
        text = re.sub(r'~', '</font>', text)

    text = re.sub(r'<br>\r\n', '', text)
    
    #print text.encode('utf-8')
    return ref, text


