import wx, re, fixRef, dialogs
from espeak import espeak

#from AppKit import NSSpeechSynthesizer
#import Sapi5


books = {
	'Gen':'Genesis', 'Exo':'Exodus', 'Lev':'Leviticus', 'Num':'Numbers', 'Deu':'Deuteronomy', 'Jos':'Joshua', 'Jdg':'Judges',
	'Rth':'Ruth', '1Sa':'1 Samuel', '2Sa':'2 Samuel', '1Ki':'1 Kings', '2Ki':'2 Kings', '1Ch':'1 Chronicles',
	'2Ch':'2 Chronicles', 'Ezr':'Ezra', 'Neh':'Nehemiah', 'Est':'Esther', 'Job':'Job', 'Psa':'Psalms', 'Pro':'Proverbs',
	'Ecc':'Ecclesiastes', 'Son':'Song Solomon', 'Isa':'Isaiah', 'Jer':'Jeremiah', 'Lam':'Lamentations', 'Eze':'Ezekiel',
	'Dan':'Daniel', 'Hos':'Hosea', 'Joe':'Joel', 'Amo':'Amos', 'Oba':'Obadiah', 'Jon':'Jonah', 'Mic':'Micah', 'Nah':'Nahum',
	'Hab':'Habbakkuk', 'Zep':'Zephaniah', 'Hag':'Haggai', 'Zec':'Zechariah', 'Mal':'Malachi', 'Mat':'Matthew', 'Mar':'Mark',
	'Luk':'Luke', 'Joh':'John', 'Act':'Acts', 'Rom':'Romans', '1Co':'1 Corinthians', '2Co':'2 Corinthians', 'Gal':'Galatians',
	'Eph':'Ephesians', 'Phi':'Philippians', 'Col':'Colossians', '1Th':'1 Thessalonians', '2Th':'2 Thessalonians ',
	'1Ti':'1 Timothy', '2Ti':'2 Timothy', 'Tit':'Titus', 'Phm':'Philemon', 'Heb':'Hebrews', 'Jam':'James', '1Pe':'1 Peter',
	'2Pe':'2 Peter', '1Jo':'1 John', '2Jo':'2 John', '3Jo':'3 John', 'Jud':'Jude', 'Rev':'Revelation',}



class Text2Speech:

	def __init__(self):

		self.ttsSynth = espeak
		
		if self.ttsSynth:	 
			self.voiceIDList = self.ttsSynth.list_voices()
			self.voices = [x.name for x in self.voiceIDList]
		else:
			return None
		
		#espeak.set_parameter(espeak.Parameter.Rate, <speed>)
		
	def abbr2Full(self, match):
		abbr = match.group(1)
		try:
			full = books[abbr]
		except:
			full = match.group(1)
		return full + ' ' + match.group(2)
		
		
	def speak(self, txt, skipRef, voice = None):
		if '<a hr' in txt:
			txt = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', txt)
			txt = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', txt)

		txt = re.sub(r'_|<br>|<hr>', ' ', txt)
		txt = re.sub(r'&nbsp;|&#\d+;|<fnc?>.+?</fnc?>|<.*?>', '', txt)
		txt = re.sub(r'\bNT\b', 'New Testament', txt)
		txt = re.sub(r'\bOT\b', 'Old Testament', txt)
		txt = re.sub(r'([?!])', r'\1 ', txt)
		
		if skipRef == 1:
			txt = re.sub(r'\w\w\w \d+:\d+', '', txt)
		else:
			txt = re.sub(r'(\w\w\w) (\d+:[^ ]+)', self.abbr2Full, txt)
			txt = re.sub(r'(\d+):(\d+)', r'\1 \2', txt)

					
		#self.setVolume(level)
		#self.setRate(rate)
			
		if voice:
			#print voice, 'in speech'
			self.ttsSynth.set_voice(voice)
		
		#try:
		#self.ttsSynth.startSpeakingString_(txt)
		#print txt
		self.ttsSynth.synth(txt.encode('utf-8'))
		#except:
		#	return
			#self.errorDialog()
	

	def setVolume(self, level):
		#set the speech volume percentage (0-100%)		
		self.ttsSynth.Volume(level)


	def getVolume(self):
		#set the speech volume percentage (0-100%) 
		return self.ttsSynth.Volume()


	def setRate(self, rate):
		#set the speech rate between -10 (slowest) and 10 (fastest), 0 is the default   
		self.ttsSynth.setRate_(rate)

	def getRate(self):
		#set the speech rate between -10 (slowest) and 10 (fastest), 0 is the default   
		return self.ttsSynth.Rate()
		
	def isSpeaking(self):
		return self.ttsSynth.is_playing()


	def stop(self):
		self.ttsSynth.cancel()

#speak = Text2Speech()
#speak.speak('this is a test of tts speaking', 1, 'english')	
