import re, string


spelling = {
' & ':' and ',
' abhominable  ':' abominable  ',
' abhorre ':' abhor ',
' aboundance ':' abundance ',
' aboundant ':' abundant ',
' aboundantly ':' abundantly ',
' abstaine ':' abstain ',
' absteine ':' abstain ',
' abundat ':' abundant ',
' accesse ':' access ',
' accompt ':' account ',
' accopanied ':' accompanied ',
' achas ':' achaz ',
' adde ':' add ',
' adiure ':' adjure ',
' administred ':' administered ',
' adoe ':' ado ',
' adorne ':' adorn ',
' aduantage ':' advantage ',
' aduantaged ':' advantaged ',
' aduantageth ':' advantageth ',
' aduenture ':' adventure ',
' aduersaries ':' adversaries ',
' aduersary ':' adversary ',
' aduersity ':' adversity ',
' aduice ':' advice ',
' aduised ':' advised ',
' adulteresse ':' adulteress ',
' aduocate ':' advocate ',
' afarre ':' afar ',
' affaires ':' affairs ',
' affirme ':' affirm ',
' afoote ':' afoot ',
' afraide ':' afraid ',
' afrighted ':' affrighted ',
' againe ':' again ',
' agoe ':' ago ',
' aire ':' air ',
' al ':' all ',
' alleadging ':' alleging ',
' allowe ':' allow ',
' almes ':' alms ',
' alowd ':' aloud ',
' alpheus ':' alphaeus ',
' alure ':' allure ',
' alwaies ':' always ',
' alwayes ':' always ',
' always ':' alway ',
' amased ':' amazed ',
' amisse ':' amiss ',
' amog ':' among ',
' amongst ':' among ',
' ancle ':' ankle ',
' ancres ':' anchors ',
' angell ':' angel ',
' anker ':' anchor ',
' ankers ':' anchors ',
' annise ':' anise ',
' anone ':' anon ',
' anoynted ':' anointed ',
' answere ':' answer ',
' answeres ':' answers ',
' apeece ':' apiece ',
' apollo ':' apollos ',
' apparell ':' apparel ',
' appeale ':' appeal ',
' appeare ':' appear ',
' appelles ':' apelles ',
' approch ':' approach ',
' approcheth ':' approacheth ',
' approching ':' approaching ',
' approoved ':' approved ',
' aray ':' array ',
' arayed ':' arrayed ',
' arimathea ':' arimathaea ',
' arke ':' ark ',
' arme ':' arm ',
' armes ':' arms ',
' arte ':' art ',
' aske ':' ask ',
' asleepe ':' asleep ',
' aspes ':' asps ',
' asse ':' ass ',
' athaia ':' achaia ',
' attaine ':' attain ',
' authour ':' author ',
' avoide ':' avoid ',
' avoyd ':' avoid ',
' avoyding ':' avoiding ',
' awaite ':' await ',
' ayre ':' air ',
' bablings ':' babblings ',
' backe ':' back ',
' backebitings ':' backbitings ',
' backeside ':' backside ',
' backeward ':' backward ',
' bagge ':' bag ',
' bagges ':' bags ',
' bancke ':' bank ',
' baptisme ':' baptism ',
' baptismes ':' baptisms ',
' bariesus ':' barjesus ',
' barne ':' barn ',
' barnes ':' barns ',
' bartimeus ':' bartimaeus ',
' battell ':' battle ',
' beame ':' beam ',
' beare ':' bear ',
' beastes ':' beasts ',
' beate ':' beat ',
' beautifull ':' beautiful ',
' beckened ':' beckoned ',
' beckening ':' beckoning ',
' beckning ':' beckoning ',
' becommeth ':' becometh ',
' bee ':' be ',
' beeing ':' being ',
' beene ':' been ',
' befor ':' before ',
' beganne ':' began ',
' begate ':' begat ',
' begge ':' beg ',
' begger ':' beggar ',
' beggerly ':' beggarly ',
' beginne ':' begin ',
' begunne ':' begun ',
' behalfe ':' behalf ',
' behelde ':' beheld ',
' behinde ':' behind ',
' beholde ':' behold ',
' behooved ':' behoved ',
' beleefe ':' belief ',
' beleeve ':' believe ',
' beleeved ':' believed ',
' beleevers ':' believers ',
' beleevest ':' believest ',
' beleeveth ':' believeth ',
' beleeving ':' believing ',
' belogeth ':' belong ',
' bene ':' been ',
' benefite ':' benefit ',
' beniamin ':' benjamin ',
' besides ':' beside ',
' bestowe ':' bestow ',
' betraied ':' betrayed ',
' betraieth ':' betrayeth ',
' betweene ':' between ',
' bewaile ':' bewail ',
' bin ':' been ',
' binde ':' bind ',
' birdes ':' birds ',
' bishopricke ':' bishoprick ',
' bitternes ':' bitterness ',
' bitternesse ':' bitterness ',
' bittes ':' bits ',
' blacke ':' black ',
' blacknesse ':' blackness ',
' blameles ':' blameless ',
' blamelesse ':' blameless ',
' blase ':' blaze ',
' blesse ':' bless ',
' blessednes ':' blessedness ',
' blessednesse ':' blessedness ',
' blinde ':' blind ',
' blindnesse ':' blindness ',
' blocke ':' block ',
' boate ':' boat ',
' bolde ':' bold ',
' boldnes ':' boldness ',
' boldnesse ':' boldness ',
' booke ':' book ',
' bookes ':' books ',
' boords ':' boards ',
' boos ':' booz ',
' borne ':' born ',
' bosome ':' bosom ',
' bottels ':' bottles ',
' bottome ':' bottom ',
' bottomelesse ':' bottomless ',
' bottomles ':' bottomless ',
' bottomlesse ':' bottomless ',
' bountifulnes ':' bountifulness ',
' bowe ':' bow ',
' bowles ':' bowels ',
' boxe ':' box ',
' boysterous ':' boisterous ',
' brasse ':' brass ',
' breake ':' break ',
' breehren ':' brethren ',
' brestplate ':' breastplate ',
' brestplates ':' breastplates ',
' brethen ':' brethren ',
' brethre ':' brethren ',
' bridegrome ':' bridegroom ',
' bridegromes ':' bridegrooms ',
' brightnes ':' brightness ',
' brightnesse ':' brightness ',
' brimme ':' brim ',
' brooke ':' brook ',
' broughe ':' brought ',
' broyled ':' broiled ',
' bruit ':' brute ',
' bulles ':' bulls ',
' bundels ':' bundles ',
' buriall ':' burial ',
' burne ':' burn ',
' burthen ':' burden ',
' burthened ':' burdened ',
' burthens ':' burdens ',
' burthensome ':' burdensome ',
' buryed ':' buried ',
' bushell ':' bushel ',
' busibodies ':' busybodies ',
' busibody ':' busybody ',
' busines ':' business ',
' businesse ':' business ',
' caiphas ':' caiaphas ',
' cal ':' call ',
' calfe ':' calf ',
' calme ':' calm ',
' caluary ':' calvary ',
' calues ':' calves ',
' campe ':' camp ',
' candlesticke ':' candlestick ',
' candlestickes ':' candlesticks ',
' captaine ':' captain ',
' captaines ':' captains ',
' carefull ':' careful ',
' carefulnesse ':' carefulness ',
' cariages ':' carriages ',
' caried ':' carried ',
' carieth ':' carrieth ',
' carkeise ':' carcase ',
' carnall ':' carnal ',
' cary ':' carry ',
' caryed ':' carried ',
' carying ':' carrying ',
' cattell ':' cattle ',
' ceassed ':' ceased ',
' celestiall ':' celestial ',
' censor ':' censer ',
' certaine ':' certain ',
' certainety ':' certainty ',
' certeine ':' certain ',
' cesar ':' caesar ',
' cesarea ':' caesarea ',
' cesars ':' caesars ',
' chaffe ':' chaff ',
' chaine ':' chain ',
' chaines ':' chains ',
' chaldeans ':' chaldaeans ',
' chamberlaine ':' chamberlain ',
' chambring ':' chambering ',
' charet ':' chariot ',
' charets ':' chariots ',
' chaunce ':' chance ',
' chaunged ':' changed ',
' cheare ':' cheer ',
' cheefe ':' chief ',
' cheeke ':' cheek ',
' cheere ':' cheer ',
' cheerefull ':' cheerful ',
' cheerefully ':' cheerfully ',
' cheerefulnesse ':' cheerfulness ',
' chiefe ':' chief ',
' childe ':' child ',
' childes ':' childs ',
' childlesse ':' childless ',
' choise ':' choice ',
' choos ':' coos ',
' christal ':' crystal ',
' christes ':' christs ',
' chrystall ':' crystal ',
' chuse ':' choose ',
' chusing ':' choosing ',
' circumcisio ':' circumcision ',
' cleane ':' clean ',
' cleare ':' clear ',
' clearely ':' clearly ',
' cleere ':' clear ',
' clensed ':' cleansed ',
' clenseth ':' cleanseth ',
' clensing ':' cleansing ',
' cleophas ':' cleopas ',
' climed ':' climbed ',
' climeth ':' climbeth ',
' cloake ':' cloke ',
' cloathing ':' clothing ',
' cloe ':' chloe ',
' cloude ':' cloud ',
' cloudes ':' clouds ',
' coales ':' coals ',
' coastes ':' coasts ',
' coate ':' coat ',
' coates ':' coats ',
' cocerning ':' concerning ',
' cocke ':' cock ',
' cofessing ':' confessing ',
' colde ':' cold ',
' comand ':' command ',
' comanded ':' commanded ',
' comelinesse ':' comeliness ',
' comfortlesse ':' comfortless ',
' commandement ':' commandment ',
' commandements ':' commandments ',
' commaund ':' command ',
' commaunded ':' commanded ',
' commaundement ':' commandment ',
' commaundements ':' commandments ',
' commaundeth ':' commandeth ',
' commaunding ':' commanding ',
' commers ':' comers ',
' commest ':' comest ',
' commeth ':' cometh ',
' comming ':' coming ',
' compasse ':' compass ',
' compell ':' compel ',
' comuned ':' communed ',
' concerne ':' concern ',
' condemne ':' condemn ',
' confesse ':' confess ',
' confirme ':' confirm ',
' conquere ':' conquer ',
' conquerours ':' conquerors ',
' consolatiou ':' consolation ',
' constraine ':' constrain ',
' constreineth ':' constraineth ',
' conteine ':' contain ',
' conteined ':' contained ',
' conteining ':' containing ',
' continuall ':' continual ',
' contrarywise ':' contrariwise ',
' conuenient ':' convenient ',
' conueniently ':' conveniently ',
' conuersation ':' conversation ',
' conuersion ':' conversion ',
' conuert ':' convert ',
' conuerted ':' converted ',
' conuerteth ':' converteth ',
' conueyed ':' conveyed ',
' conuicted ':' convicted ',
' conuince ':' convince ',
' conuinced ':' convinced ',
' conuinceth ':' convinceth ',
' coole ':' cool ',
' cordes ':' cords ',
' corne ':' corn ',
' costlinesse ':' costliness ',
' councill ':' council ',
' counsell ':' counsel ',
' counseller ':' counsellor ',
' countrey ':' country ',
' countreymen ':' countrymen ',
' countreys ':' countries ',
' covetousnes ':' covetousness ',
' covetousnesse ':' covetousness ',
' craftesmen ':' craftsmen ',
' craftines ':' craftiness ',
' craftinesse ':' craftiness ',
' creatour ':' creator ',
' creditour ':' creditor ',
' creeple ':' cripple ',
' creete ':' crete ',
' crosse ':' cross ',
' crowne ':' crown ',
' crownes ':' crowns ',
' cruell ':' cruel ',
' crummes ':' crumbs ',
' cryed ':' cried ',
' cryes ':' cries ',
' cryeth ':' crieth ',
' cubite ':' cubit ',
' cubites ':' cubits ',
' cumbred ':' cumbered ',
' cumbreth ':' cumbereth ',
' cummine ':' cummin ',
' custome ':' custom ',
' customes ':' customs ',
' cynamome ':' cinnamon ',
' daies ':' days ',
' damosell ':' damsel ',
' damsell ':' damsel ',
' darke ':' dark ',
' darkely ':' darkly ',
' darkenes ':' darkness ',
' darkenesse ':' darkness ',
' darkned ':' darkened ',
' darknes ':' darkness ',
' darknesse ':' darkness ',
' dartes ':' darts ',
' daunced ':' danced ',
' dauncing ':' dancing ',
' dawne ':' dawn ',
' dayes ':' days ',
' dayly ':' daily ',
' deadnes ':' deadness ',
' deafe ':' deaf ',
' deale ':' deal ',
' deare ':' dear ',
' dearely ':' dearly ',
' debter ':' debtor ',
' debters ':' debtors ',
' deceite ':' deceit ',
' deceitfull ':' deceitful ',
' deceitfulnesse ':' deceitfulness ',
' deceiveablenesse ':' deceivableness ',
' deede ':' deed ',
' deedes ':' deeds ',
' deepe ':' deep ',
' deepely ':' deeply ',
' deepenesse ':' deepness ',
' denne ':' den ',
' dennes ':' dens ',
' denyeth ':' denieth ',
' depthes ':' depths ',
' despaire ':' despair ',
' despitefull ':' despiteful ',
' destroied ':' destroyed ',
' destructio ':' destruction ',
' detters ':' debtors ',
' devill ':' devil ',
' devoure ':' devour ',
' digge ':' dig ',
' dipt ':' dipped ',
' disanul ':' disannul ',
' disanulleth ':' disannulleth ',
' disanulling ':' disannulling ',
' discerne ':' discern ',
' dispaired ':' despaired ',
' dissention ':' dissension ',
' dissolued ':' dissolved ',
' distresse ':' distress ',
' divels ':' devils ',
' doctour ':' doctor ',
' doctours ':' doctors ',
' doe ':' do ',
' dogges ':' dogs ',
' doore ':' door ',
' doores ':' doors ',
' double ':' doubletongued ',
' doubtfull ':' doubtful ',
' doubtlesse ':' doubtless ',
' doung ':' dung ',
' downe ':' down ',
' dranke ':' drank ',
' drawe ':' draw ',
' drawen ':' drawn ',
' dreame ':' dream ',
' dreames ':' dreams ',
' drewe ':' drew ',
' drinke ':' drink ',
' drinkes ':' drinks ',
' drowne ':' drown ',
' drunke ':' drunk ',
' drunkennesse ':' drunkenness ',
' duety ':' duty ',
' dumbe ':' dumb ',
' dwel ':' dwell ',
' dye ':' die ',
' dyed ':' died ',
' eare ':' ear ',
' earely ':' early ',
' eares ':' ears ',
' eate ':' eat ',
' effectuall ':' effectual ',
' egge ':' egg ',
' egle ':' eagle ',
' eie ':' eye ',
' eies ':' eyes ',
' eighteene ':' eighteen ',
' eli ':' esli ',
' elizabeth ':' elisabeth ',
' elizabeths ':' elisabeths ',
' elizeus ':' eliseus ',
' emaus ':' emmaus ',
' emeralde ':' emerald ',
' emor ':' emmor ',
' encountred ':' encountered ',
' encrease ':' increase ',
' encreased ':' increased ',
' ende ':' end ',
' endevored ':' endeavoured ',
' endevour ':' endeavour ',
' endevoured ':' endeavoured ',
' endevouring ':' endeavouring ',
' endles ':' endless ',
' endlesse ':' endless ',
' enformed ':' informed ',
' enioy ':' enjoy ',
' enioyne ':' enjoin ',
' enioyned ':' enjoined ',
' entertaine ':' entertain ',
' entertayned ':' entertained ',
' entier ':' entire ',
' entised ':' enticed ',
' entising ':' enticing ',
#' entreated ':' intreated ',
' entreaty ':' intreaty ',
' entred ':' entered ',
' entreth ':' entereth ',
' entring ':' entering ',
' entrrd ':' entered ',
' enuies ':' envies ',
' enuieth ':' envieth ',
' enuy ':' envy ',
' enuying ':' envying ',
' enuyings ':' envyings ',
' epenetus ':' epaenetus ',
' equall ':' equal ',
' erre ':' err ',
' errour ':' error ',
' esteeme ':' esteem ',
' eternall ':' eternal ',
' eunuches ':' eunuchs ',
' evill ':' evil ',
' evodias ':' euodias ',
' exceede ':' exceed ',
' excell ':' excel ',
' excesse ':' excess ',
' exorcistes ':' exorcists ',
' expresly ':' expressly ',
' expresse ':' express ',
' faile ':' fail ',
' faine ':' fain ',
' faine ':' feign ',
' fained ':' feigned ',
' faire ':' fair ',
' faithfull ':' faithful ',
' faithlesse ':' faithless ',
' falsly ':' falsely ',
' fanne ':' fan ',
' farewel ':' farewell ',
' farme ':' farm ',
' farre ':' far ',
' fasly ':' falsely ',
' fatherlesse ':' fatherless ',
' fatnesse ':' fatness ',
' faultles ':' faultless ',
' faultlesse ':' faultless ',
' fayth ':' faith ',
' feare ':' fear ',
' fearefull ':' fearful ',
' feares ':' fears ',
' fedde ':' fed ',
' feede ':' feed ',
' feele ':' feel ',
' feete ':' feet ',
' fel ':' fell ',
' fellowes ':' fellows ',
' felowship ':' fellowship ',
' feruent ':' fervent ',
' feruently ':' fervently ',
' fewe ':' few ',
' fieldes ':' fields ',
' fiercenesse ':' fierceness ',
' fift ':' fifth ',
' fifteeene ':' fifteen ',
' fifteene ':' fifteen ',
' figge ':' fig ',
' figges ':' figs ',
' fil ':' fill ',
' filthines ':' filthiness ',
' filthinesse ':' filthiness ',
' finde ':' find ',
' firme ':' firm ',
' flaxe ':' flax ',
' fledde ':' fled ',
' flocke ':' flock ',
' floore ':' floor ',
' floure ':' flour ',
' flowre ':' flower ',
' foale ':' foal ',
' folke ':' folk ',
' folkes ':' folks ',
' followe ':' follow ',
' folow ':' follow ',
' folowed ':' followed ',
' folowing ':' following ',
' fometh ':' foameth ',
' foming ':' foaming ',
' foode ':' food ',
' foole ':' fool ',
' fooles ':' fools ',
' foolishnesse ':' foolishness ',
' foorth ':' forth ',
' foorthwith ':' forthwith ',
' foote ':' foot ',
' footestoole ':' footstool ',
' footstoole ':' footstool ',
' forbade ':' forbad ',
' forbeare ':' forbear ',
' forbidde ':' forbid ',
' foreordeined ':' foreordained ',
' forewarne ':' forewarn ',
' forgetfull ':' forgetful ',
' forgivenesse ':' forgiveness ',
' forme ':' form ',
' fornace ':' furnace ',
' fornicatour ':' fornicator ',
' fornicatours ':' fornicators ',
' forreiners ':' foreigners ',
' forsooke ':' forsook ',
' forsweare ':' forswear ',
' forwardnesse ':' forwardness ',
' foule ':' foul ',
' foules ':' fowls ',
' fountaine ':' fountain ',
' fountaines ':' fountains ',
' foure ':' four ',
' fourescore ':' fourscore ',
' foureteene ':' fourteen ',
' fourme ':' form ',
' foursquare ':' foure ',
' fourteene ':' fourteen ',
' fourty ':' forty ',
' fowles ':' fowls ',
' foxe ':' fox ',
' freedome ':' freedom ',
' fruite ':' fruit ',
' fruites ':' fruits ',
' fruitfull ':' fruitful ',
' ful ':' full ',
' fulfill ':' fulfil ',
' fullfiled ':' fulfilled ',
' fulnes ':' fulness ',
' fulnesse ':' fulness ',
' gaine ':' gain ',
' gaines ':' gains ',
' gainesaying ':' gainsaying ',
' galile ':' galilee ',
' galilean ':' galilaean ',
' galileans ':' galilaeans ',
' galililee ':' galilee ',
' gardiner ':' gardener ',
' garison ':' garrison ',
' generall ':' general ',
' genesaret ':' gennesaret ',
' genesareth ':' gennesaret ',
' gentlenesse ':' gentleness ',
' gethsemani ':' gethsemane ',
' ghestchamber ':' guestchamber ',
' ghests ':' guests ',
' gideon ':' gedeon ',
' giftes ':' gifts ',
' girde ':' gird ',
' gladnes ':' gladness ',
' gladnesse ':' gladness ',
' glasse ':' glass ',
' goates ':' goats ',
' goddesse ':' goddess ',
' godlines ':' godliness ',
' godlinesse ':' godliness ',
' goe ':' go ',
' golde ':' gold ',
' goodnes ':' goodness ',
' goodnesse ':' goodness ',
' gopel ':' gospel ',
' gospell ':' gospel ',
' governour ':' governor ',
' governours ':' governors ',
' graffe ':' graff ',
' graine ':' grain ',
' grasse ':' grass ',
' graunt ':' grant ',
' greatnesse ':' greatness ',
' greedinesse ':' greediness ',
' greeke ':' greek ',
' greekes ':' greeks ',
' greene ':' green ',
' greete ':' greet ',
' grewe ':' grew ',
' griefe ':' grief ',
' grinde ':' grind ',
' groane ':' groan ',
' grone ':' groan ',
' groned ':' groaned ',
' groning ':' groaning ',
' grosse ':' gross ',
' growe ':' grow ',
' growen ':' grown ',
' guid ':' guide ',
' guiltlesse ':' guiltless ',
' gulfe ':' gulf ',
' haile ':' hail ',
' hailing ':' haling ',
' haire ':' hair ',
' haires ':' hairs ',
' halfe ':' half ',
' halowed ':' hallowed ',
' hande ':' hand ',
' handes ':' hands ',
' handmaide ':' handmaid ',
' happily ':' haply ',
' hardned ':' hardened ',
' hardnesse ':' hardness ',
' harme ':' harm ',
' harmelesse ':' harmless ',
' harpe ':' harp ',
' harpes ':' harps ',
' haruest ':' harvest ',
' hatefull ':' hateful ',
' havocke ':' havock ',
' hayle ':' hail ',
' heades ':' heads ',
' heale ':' heal ',
' heape ':' heap ',
' heare ':' hear ',
' heate ':' heat ',
' heauy ':' heavy ',
' heavinesse ':' heaviness ',
' hebrewe ':' hebrew ',
' hebrewes ':' hebrews ',
' hee ':' he ',
' heede ':' heed ',
' heele ':' heel ',
' heere ':' here ',
' heereafter ':' hereafter ',
' heereof ':' hereof ',
' heire ':' heir ',
' heires ':' heirs ',
' helde ':' held ',
' helme ':' helm ',
' helpe ':' help ',
' helpes ':' helps ',
' hemme ':' hem ',
' hencefoorth ':' henceforth ',
' henne ':' hen ',
' herbes ':' herbs ',
' heretike ':' heretick ',
' herode ':' herod ',
' herselfe ':' herself ',
' hewen ':' hewn ',
' heyres ':' heirs ',
' hidde ':' hid ',
' hie ':' high ',
' hiericho ':' jericho ',
' hierusalem ':' jerusalem ',
' hils ':' hills ',
' himselfe ':' himself ',
' hindred ':' hindered ',
' holde ':' hold ',
' holinesse ':' holiness ',
' honor ':' honour ',
' honorable ':' honourable ',
' honoreth ':' honoureth ',
' hony ':' honey ',
' hooke ':' hook ',
' horne ':' horn ',
' hornes ':' horns ',
' hoste ':' host ',
' hote ':' hot ',
' houre ':' hour ',
' houres ':' hours ',
' houshold ':' household ',
' housholder ':' householder ',
' howe ':' how ',
' howle ':' howl ',
' humblenesse ':' humbleness ',
' hurtfull ':' hurtful ',
' husbaud ':' husband ',
' huskes ':' husks ',
' hymeneus ':' hymenaeus ',
' hymne ':' hymn ',
' hymnes ':' hymns ',
' hysope ':' hyssop ',
' hyssope ':' hyssop ',
' idole ':' idol ',
' idoles ':' idols ',
' idumea ':' idumaea ',
' iland ':' island ',
' ile ':' isle ',
' imbraced ':' embraced ',
' immediatly ':' immediately ',
' immortall ':' immortal ',
' indeede ':' indeed ',
' indued ':' endued ',
' indure ':' endure ',
' indured ':' endured ',
' induring ':' enduring ',
' ingraven ':' engraven ',
' inherite ':' inherit ',
' iniured ':' injured ',
' iniurious ':' injurious ',
' inke ':' ink ',
' inlarged ':' enlarged ',
' inlightned ':' enlightened ',
' inne ':' inn ',
' inough ':' enough ',
' inquire ':' enquire ',
' inquired ':' enquired ',
' inquiry ':' enquiry ',
' instructour ':' instructor ',
' instrution ':' instruction ',
' intangle ':' entangle ',
' intangled ':' entangled ',
' intangleth ':' entangleth ',
' interpretatio ':' interpretation ',
' interprete ':' interpret ',
' intreate ':' intreat ',
' intreated ':' entreated ',
' inuenters ':' inventors ',
' inuisible ':' invisible ',
' isachar ':' issachar ',
' isahac ':' isaac ',
' itselfe ':' itself ',
' iturea ':' ituraea ',
' jacinct ':' jacinth ',
' jaylour ':' jailor ',
' jelousy ':' jealousy ',
' jephthah ':' jephthae ',
' jewe ':' jew ',
' jewes ':' jews ',
' jewesse ':' jewess ',
' jordane ':' jordan ',
' jote ':' jot ',
' journeying ':' journeyings ',
' journy ':' journey ',
' joyfull ':' joyful ',
' joyfulnesse ':' joyfulness ',
' joyne ':' join ',
' joyned ':' joined ',
' joynt ':' joint ',
' joynts ':' joints ',
' judea ':' judaea ',
' judgement ':' judgment ',
' judgements ':' judgments ',
' jury ':' jewry ',
' kain ':' cain ',
' keepe ':' keep ',
' keyes ':' keys ',
' kicke ':' kick ',
' kil ':' kill ',
' kinde ':' kind ',
' kindenesse ':' kindness ',
' kindes ':' kinds ',
' kindnesse ':' kindness ',
' kingdome ':' kingdom ',
' kingdomes ':' kingdoms ',
' kinne ':' kin ',
' kinred ':' kindred ',
' kinreds ':' kindreds ',
' kinsefolke ':' kinsfolk ',
' kinsefolkes ':' kinsfolks ',
' kinsemen ':' kinsmen ',
' kisse ':' kiss ',
' knewe ':' knew ',
' knocke ':' knock ',
' knowe ':' know ',
' knowen ':' known ',
' labor ':' labour ',
' labors ':' labours ',
' labourng ':' labouring ',
' lacke ':' lack ',
' laide ':' laid ',
' laied ':' laid ',
' laieth ':' layeth ',
' lambe ':' lamb ',
' lambes ':' lambs ',
' lampe ':' lamp ',
' lampes ':' lamps ',
' lanch ':' launch ',
' lanched ':' launched ',
' lande ':' land ',
' lanternes ':' lanterns ',
' lasciviousnes ':' lasciviousness ',
' lasciviousnesse ':' lasciviousness ',
' latine ':' latin ',
' lawe ':' law ',
' lawes ':' laws ',
' lawfull ':' lawful ',
' lawlesse ':' lawless ',
' layd ':' laid ',
' layde ':' laid ',
' layed ':' laid ',
' layen ':' lain ',
' laying ':' lying ',
' lead ':' led ',
' leade ':' lead ',
' leape ':' leap ',
' leapt ':' leaped ',
' learne ':' learn ',
' leatherne ':' leathern ',
' lebbeus ':' lebbaeus ',
' lesse ':' less ',
' leviticall ':' levitical ',
' lewdnesse ':' lewdness ',
' liberall ':' liberal ',
' lien ':' lain ',
' lier ':' liar ',
' lightening ':' lightning ',
' lightnesse ':' lightness ',
' likenesse ':' likeness ',
' lillies ':' lilies ',
' linage ':' lineage ',
' linnen ':' linen ',
' lippes ':' lips ',
' litle ':' little ',
' loafe ':' loaf ',
' loe ':' lo ',
' loines ':' loins ',
' longsuffring ':' longsuffering ',
' looke ':' look ',
' lorde ':' lord ',
' lordes ':' lords ',
' losse ':' loss ',
' loude ':' loud ',
' lowd ':' loud ',
' lowlinesse ':' lowliness ',
' loynes ':' loins ',
' lukewarme ':' lukewarm ',
' lumpe ':' lump ',
' lunaticke ':' lunatick ',
' lunatike ':' lunatick ',
' lustes ':' lusts ',
' lyar ':' liar ',
' lyars ':' liars ',
' lye ':' lie ',
' lyer ':' liar ',
' lyers ':' liars ',
' lyeth ':' lieth ',
' lyon ':' lion ',
' lysia ':' lycia ',
' madnesse ':' madness ',
' maide ':' maid ',
' maides ':' maids ',
' maiest ':' mayest ',
' maiesty ':' majesty ',
' maintaine ':' maintain ',
' maist ':' mayest ',
' maliciousnes ':' maliciousness ',
' maliciousnesse ':' maliciousness ',
' maner ':' manner ',
' maners ':' manners ',
' manifolde ':' manifold ',
' mankinde ':' mankind ',
' marchandise ':' merchandise ',
' marchant ':' merchant ',
' mariage ':' marriage ',
' maried ':' married ',
' marke ':' mark ',
' markes ':' marks ',
' marrowe ':' marrow ',
' mars ':' marshill ',
' maruailed ':' marvelled ',
' marueile ':' marvel ',
' marueiled ':' marvelled ',
' marueilous ':' marvellous ',
' maruelled ':' marvelled ',
' maruellous ':' marvellous ',
' matthathias ':' mattathias ',
' mayd ':' maid ',
' mayden ':' maiden ',
' meale ':' meal ',
' meane ':' mean ',
' meanes ':' means ',
' meate ':' meat ',
' meates ':' meats ',
' mediatour ':' mediator ',
' mee ':' me ',
' meeke ':' meek ',
' meekenes ':' meekness ',
' meekenesse ':' meekness ',
' meeknesse ':' meekness ',
' meete ':' meet ',
' membrs ':' members ',
' memoriall ':' memorial ',
' merchandize ':' merchandise ',
' mercifull ':' merciful ',
' mery ':' merry ',
' mids ':' midst ',
' middes ':' midst ',
' middest ':' midst ',
' milke ':' milk ',
' milstone ':' millstone ',
' minde ':' mind ',
' mindes ':' minds ',
' mindfull ':' mindful ',
' ministery ':' ministry ',
' ministred ':' ministered ',
' ministreth ':' ministereth ',
' ministring ':' ministering ',
' mischiefe ':' mischief ',
' mocke ':' mock ',
' momet ':' moment ',
' moneth ':' month ',
' monethes ':' months ',
' moneths ':' months ',
' moone ':' moon ',
' moove ':' move ',
' mooved ':' moved ',
' moover ':' mover ',
' moe ':' more ',
' morow ':' morrow ',
' morrowe ':' morrow ',
' morsell ':' morsel ',
' mortall ':' mortal ',
' mountaine ':' mountain ',
' mountaines ':' mountains ',
' mourne ':' mourn ',
' mousell ':' muzzle ',
' mouthes ':' mouths ',
' moyses ':' moses ',
' murmure ':' murmur ',
' murther ':' murder ',
' murtherer ':' murderer ',
' murtherers ':' murderers ',
' murthers ':' murders ',
' musicke ':' musick ',
' musitions ':' musicians ',
' muzzell ':' muzzle ',
' myrrhe ':' myrrh ',
' myselfe ':' myself ',
' nailes ':' nails ',
' naim ':' nain ',
' nakednes ':' nakedness ',
' nakednesse ':' nakedness ',
' nasson ':' naasson ',
' nathaneel ':' nathanael ',
' natio ':' nation ',
' naturall ':' natural ',
' naught ':' nought ',
' naughtinesse ':' naughtiness ',
' nayling ':' nailing ',
' necke ':' neck ',
' neckes ':' necks ',
' neede ':' need ',
' needefull ':' needful ',
' needes ':' needs ',
' needfull ':' needful ',
' neere ':' near ',
' neerer ':' nearer ',
' nephewes ':' nephews ',
' nephthali ':' nephthalim ',
' nepthali ':' nepthalim ',
' nevertheles ':' nevertheless ',
' neverthelesse ':' nevertheless ',
' newe ':' new ',
' newnesse ':' newness ',
' nineve ':' nineveh ',
' noone ':' noon ',
' nourture ':' nurture ',
' nowe ':' now ',
' noysed ':' noised ',
' noysome ':' noisome ',
' nuber ':' number ',
' numbred ':' numbered ',
' obeied ':' obeyed ',
' obiect ':' object ',
' obseruation ':' observation ',
' obserue ':' observe ',
' obserued ':' observed ',
' obtaine ':' obtain ',
' obteined ':' obtained ',
' obteining ':' obtaining ',
' offred ':' offered ',
' offrings ':' offerings ',
' oftner ':' oftener ',
' oile ':' oil ',
' olde ':' old ',
' oldnesse ':' oldness ',
' onely ':' only ',
' oppresse ':' oppress ',
' oratour ':' orator ',
' ordaine ':' ordain ',
' ordeine ':' ordain ',
' ordeined ':' ordained ',
' ordeyned ':' ordained ',
' orusilla ':' drusilla ',
' othe ':' oath ',
' othes ':' oaths ',
' overcommeth ':' overcometh ',
' overlayed ':' overlaid ',
' overthrowe ':' overthrow ',
' overthrowen ':' overthrown ',
' owne ':' own ',
' oxe ':' ox ',
' oyle ':' oil ',
' oyntment ':' ointment ',
' pacaciana ':' pacatiana ',
' paine ':' pain ',
' paines ':' pains ',
' painfulnesse ':' painfulness ',
' paire ':' pair ',
' pallace ':' palace ',
' palme ':' palm ',
' palmes ':' palms ',
' pappes ':' paps ',
' parcell ':' parcel ',
' partiall ':' partial ',
' passe ':' pass ',
' passeover ':' passover ',
' paterne ':' pattern ',
' patterne ':' pattern ',
' payd ':' paid ',
' pearce ':' pierce ',
' pearced ':' pierced ',
' pearcing ':' piercing ',
' pearle ':' pearl ',
' pearles ':' pearls ',
' penniworth ':' pennyworth ',
' peny ':' penny ',
' penyworth ':' pennyworth ',
' peraduenture ':' peradventure ',
' perfectnesse ':' perfectness ',
' performe ':' perform ',
' perill ':' peril ',
' perillous ':' perilous ',
' periured ':' perjured ',
' permenas ':' parmenas ',
' persecuter ':' persecutor ',
' perswade ':' persuade ',
' perswaded ':' persuaded ',
' perswadest ':' persuadest ',
' perswadeth ':' persuadeth ',
' perswading ':' persuading ',
' perswasion ':' persuasion ',
' pertaine ':' pertain ',
' pertayning ':' pertaining ',
' perteine ':' pertain ',
' perteineth ':' pertaineth ',
' perteining ':' pertaining ',
' peruerse ':' perverse ',
' peruert ':' pervert ',
' peruerteth ':' perverteth ',
' peruerting ':' perverting ',
' phaleg ':' phalec ',
' pharao ':' pharaoh ',
' pharise ':' pharisee ',
' pharises ':' pharisees ',
' phenicea ':' phenicia ',
' philippos ':' philippi ',
' phisitions ':' physicians ',
' physicion ':' physician ',
' physition ':' physician ',
' piersed ':' pierced ',
' pilgrimes ':' pilgrims ',
' pinacle ':' pinnacle ',
' pitifull ':' pitiful ',
' pitte ':' pit ',
' plaine ':' plain ',
' plainely ':' plainly ',
' plainnesse ':' plainness ',
' plucke ':' pluck ',
' pompe ':' pomp ',
' poole ':' pool ',
' poore ':' poor ',
' portius ':' porcius ',
' possesse ':' possess ',
' powerfull ':' powerful ',
' powre ':' pour ',
' powred ':' poured ',
' powreth ':' poureth ',
' powring ':' pouring ',
' poyson ':' poison ',
' practises ':' practices ',
' praied ':' prayed ',
' praiers ':' prayers ',
' prayse ':' praise ',
' prease ':' press ',
' preasse ':' press ',
' preassed ':' pressed ',
' preasseth ':' presseth ',
' pretious ':' precious ',
' preserue ':' preserve ',
' preserued ':' preserved ',
' presse ':' press ',
' pretorium ':' praetorium ',
' prevaile ':' prevail ',
' price ':' prize ',
' prickes ':' pricks ',
' priestes ':' priests ',
' principall ':' principal ',
' prist ':' priest ',
' priuy ':' privy ',
' proceede ':' proceed ',
' professe ':' profess ',
' profite ':' profit ',
' proofe ':' proof ',
' proofes ':' proofs ',
' proove ':' prove ',
' prooved ':' proved ',
' prooving ':' proving ',
' prophane ':' profane ',
' prophecied ':' prophesied ',
' prophecying ':' prophesying ',
' prophecyings ':' prophesyings ',
' prophesies ':' prophecies ',
' prophetesse ':' prophetess ',
' proselites ':' proselytes ',
' proude ':' proud ',
' proverbe ':' proverb ',
' proverbes ':' proverbs ',
' psalme ':' psalm ',
' psalmes ':' psalms ',
' publicane ':' publican ',
' publicanes ':' publicans ',
' publikely ':' publickly ',
' publique ':' publick ',
' puft ':' puffed ',
' pul ':' pull ',
' purenesse ':' pureness ',
' purloyning ':' purloining ',
' quarrell ':' quarrel ',
' queene ':' queen ',
' quicke ':' quick ',
' quickely ':' quickly ',
' quickesands ':' quicksands ',
' quickned ':' quickened ',
' quickneth ':' quickeneth ',
' quietnesse ':' quietness ',
' racha ':' raca ',
' raigne ':' reign ',
' raigned ':' reigned ',
' raine ':' rain ',
' rainebow ':' rainbow ',
' rankes ':' ranks ',
' ranne ':' ran ',
' ransome ':' ransom ',
' rayment ':' raiment ',
' raysed ':' raised ',
' reade ':' read ',
' readinesse ':' readiness ',
' reape ':' reap ',
' reare ':' rear ',
' receit ':' receipt ',
' receite ':' receipt ',
' receyueth ':' receiveth ',
' redeeme ':' redeem ',
' redeming ':' redeeming ',
' redemptiou ':' redemption ',
' reede ':' reed ',
' refraine ':' refrain ',
' reiect ':' reject ',
' reiected ':' rejected ',
' reiecteth ':' rejecteth ',
' reigne ':' reign ',
' reines ':' reins ',
' reioice ':' rejoice ',
' reioyce ':' rejoice ',
' reioyced ':' rejoiced ',
' reioyceth ':' rejoiceth ',
' reioycing ':' rejoicing ',
' releeved ':' relieved ',
' reliefe ':' relief ',
' remaine ':' remain ',
' remebred ':' remembered ',
' remembred ':' remembered ',
' remembrest ':' rememberest ',
' remembreth ':' remembereth ',
' remembring ':' remembering ',
' remissio ':' remission ',
' remoove ':' remove ',
' rendring ':' rendering ',
' renue ':' renew ',
' renued ':' renewed ',
' renuing ':' renewing ',
' reproch ':' reproach ',
' reproched ':' reproached ',
' reproches ':' reproaches ',
' reprochest ':' reproachest ',
' reprochfully ':' reproachfully ',
' reproofe ':' reproof ',
' reproove ':' reprove ',
' reprooved ':' reproved ',
' reserue ':' reserve ',
' reserued ':' reserved ',
' resolued ':' resolved ',
' retaine ':' retain ',
' reteined ':' retained ',
' returne ':' return ',
' reveale ':' reveal ',
' reveile ':' reveal ',
' reveiled ':' revealed ',
' revelatio ':' revelation ',
' reviued ':' revived ',
' riche ':' rich ',
' righteousnes ':' righteousness ',
' righteousnesse ':' righteousness ',
' rocke ':' rock ',
' rockes ':' rocks ',
' romane ':' roman ',
' romanes ':' romans ',
' roofe ':' roof ',
' roome ':' room ',
' roomes ':' rooms ',
' roote ':' root ',
' rootes ':' roots ',
' roume ':' room ',
' roumes ':' rooms ',
' royall ':' royal ',
' ruben ':' reuben ',
' ruine ':' ruin ',
' ruines ':' ruins ',
' rumors ':' rumours ',
' runne ':' run ',
' sabboth ':' sabbath ',
' sackecloth ':' sackcloth ',
' sacriledge ':' sacrilege ',
' sadduces ':' sadducees ',
' saide ':' said ',
' saidest ':' saidst ',
' saiest ':' sayest ',
' saieth ':' saith ',
' saile ':' sail ',
' sailers ':' sailors ',
' saincts ':' saints ',
' saltnesse ':' saltness ',
' saluatio ':' salvation ',
' salue ':' salve ',
' saluation ':' salvation ',
' samaritane ':' samaritan ',
' samaritanes ':' samaritans ',
' sampson ':' samson ',
' sandales ':' sandals ',
' saphir ':' sapphire ',
' saraes ':' saras ',
' sardonix ':' sardonyx ',
' sate ':' sat ',
' sathan ':' satan ',
' sawe ':' saw ',
' sawen ':' sawn ',
' sayd ':' said ',
' sayde ':' said ',
' saye ':' say ',
' sayeth ':' saith ',
' sayth ':' saith ',
' scarse ':' scarce ',
' scattred ':' scattered ',
' scepter ':' sceptre ',
' schisme ':' schism ',
' schoole ':' school ',
' schoolemaster ':' schoolmaster ',
' scorne ':' scorn ',
' scrippe ':' scrip ',
' scrowle ':' scroll ',
' seale ':' seal ',
' seales ':' seals ',
' seame ':' seam ',
' sease ':' seize ',
' seate ':' seat ',
' seates ':' seats ',
' seede ':' seed ',
' seedes ':' seeds ',
' seeke ':' seek ',
' seeme ':' seem ',
' seene ':' seen ',
' sel ':' sell ',
' selfe ':' self ',
' selfewilled ':' selfwilled ',
' selues ':' selves ',
' sensuall ':' sensual ',
' sergeants ':' serjeants ',
' seruant ':' servant ',
' seruants ':' servants ',
' serue ':' serve ',
' serued ':' served ',
' serueth ':' serveth ',
' seruice ':' service ',
' seruing ':' serving ',
' servant ':' selfe ',
' servants ':' selues ',
' serve ':' self ',
' setled ':' settled ',
' severall ':' several ',
' shal ':' shall ',
' sharpe ':' sharp ',
' sharpely ':' sharply ',
' sharpnesse ':' sharpness ',
' shedde ':' shed ',
' shee ':' she ',
' sheepe ':' sheep ',
' sheepefold ':' sheepfold ',
' sheepes ':' sheeps ',
' sheepskinnes ':' sheepskins ',
' sheete ':' sheet ',
' shepe ':' sheep ',
' shepheard ':' shepherd ',
' shepheards ':' shepherds ',
' shewe ':' shew ',
' shielde ':' shield ',
' shippe ':' ship ',
' shipwracke ':' shipwreck ',
' shooes ':' shoes ',
' shooke ':' shook ',
' shorne ':' shorn ',
' shortned ':' shortened ',
' showre ':' shower ',
' sichem ':' sychem ',
' sicke ':' sick ',
' sickenesse ':' sickness ',
' sickenesses ':' sicknesses ',
' sicknesse ':' sickness ',
' signe ':' sign ',
' signes ':' signs ',
' silke ':' silk ',
' siloe ':' siloam ',
' siluanus ':' silvanus ',
' siluer ':' silver ',
' sinfull ':' sinful ',
' singlenesse ':' singleness ',
' sinke ':' sink ',
' sinne ':' sin ',
' sinnefull ':' sinful ',
' sinnes ':' sins ',
' sirname ':' surname ',
' sirnamed ':' surnamed ',
' sixe ':' six ',
' sixt ':' sixth ',
' sixteene ':' sixteen ',
' slacke ':' slack ',
' slacknesse ':' slackness ',
' slaine ':' slain ',
' sleepe ':' sleep ',
' slewe ':' slew ',
' slothfull ':' slothful ',
' slouthfull ':' slothful ',
' slumbred ':' slumbered ',
' slumbreth ':' slumbereth ',
' smal ':' small ',
' snowe ':' snow ',
' sobernesse ':' soberness ',
' sodome ':' sodom ',
' soiourne ':' sojourn ',
' soiourned ':' sojourned ',
' soiourning ':' sojourning ',
' solde ':' sold ',
' sonne ':' son ',
' sonnes ':' sons ',
' soone ':' soon ',
' soppe ':' sop ',
' sorow ':' sorrow ',
' sorowful ':' sorrowful ',
' sorowfull ':' sorrowful ',
' sorrowes ':' sorrows ',
' sorrowfull ':' sorrowful ',
' sory ':' sorry ',
' souldier ':' soldier ',
' souldiour ':' soldier ',
' souldiers ':' soldiers ',
' soule ':' soul ',
' soules ':' souls ',
' soundnesse ':' soundness ',
' sowe ':' sow ',
' sowen ':' sown ',
' spaine ':' spain ',
' sparrowes ':' sparrows ',
' speach ':' speech ',
' speaches ':' speeches ',
' speake ':' speak ',
' speare ':' spear ',
' spearemen ':' spearmen ',
' speciall ':' special ',
' speechlesse ':' speechless ',
' spettle ':' spittle ',
' spew ':' spue ',
' spinne ':' spin ',
' spirituall ':' spiritual ',
' spoile ':' spoil ',
' spoiles ':' spoils ',
' spottes ':' spots ',
' spoyled ':' spoiled ',
' spoyling ':' spoiling ',
' spred ':' spread ',
' sprinckled ':' sprinkled ',
' sprinckling ':' sprinkling ',
' staffe ':' staff ',
' staires ':' stairs ',
' starre ':' star ',
' starres ':' stars ',
' steale ':' steal ',
' stedfastnesse ':' stedfastness ',
' steepe ':' steep ',
' steppes ':' steps ',
' sterne ':' stern ',
' steven ':' stephen ',
' stickes ':' sticks ',
' stifnecked ':' stiffnecked ',
' stirre ':' stir ',
' stocke ':' stock ',
' stockes ':' stocks ',
' stoikes ':' stoicks ',
' stomackes ':' stomachs ',
' stoode ':' stood ',
' storme ':' storm ',
' stoupe ':' stoop ',
' stouped ':' stooped ',
' stouping ':' stooping ',
' stowping ':' stooping ',
' straine ':' strain ',
' straitned ':' straitened ',
' streame ':' stream ',
' streete ':' street ',
' streetes ':' streets ',
' stricke ':' strike ',
' striken ':' stricken ',
' strog ':' strong ',
' stroke ':' struck ',
' stucke ':' stuck ',
' stuffe ':' stuff ',
' subiect ':' subject ',
' subiected ':' subjected ',
' subiection ':' subjection ',
' subuert ':' subvert ',
' subuerted ':' subverted ',
' subuerting ':' subverting ',
' sucke ':' suck ',
' suerty ':' surety ',
' suffred ':' suffered ',
' suffring ':' suffering ',
' suffrings ':' sufferings ',
' summe ':' sum ',
' sunke ':' sunk ',
' sunne ':' sun ',
' suppe ':' sup ',
' supplyeth ':' supplieth ',
' surfetting ':' surfeiting ',
' svelling ':' swelling ',
' swadling ':' swaddling ',
' swarued ':' swerved ',
' sweare ':' swear ',
' sweepe ':' sweep ',
' sweete ':' sweet ',
' swimme ':' swim ',
' sworne ':' sworn ',
' sydon ':' sidon ',
' syluanus ':' silvanus ',
' syncerely ':' sincerely ',
' syntiche ':' syntyche ',
' syr ':' sir ',
' syrname ':' surname ',
' taile ':' tail ',
' tailes ':' tails ',
' talke ':' talk ',
' taried ':' tarried ',
' tariest ':' tarriest ',
' tary ':' tarry ',
' tatlers ':' tattlers ',
' tavernes ':' taverns ',
' tayles ':' tails ',
' teares ':' tears ',
' tel ':' tell ',
' temporall ':' temporal ',
' tenne ':' ten ',
' terrestriall ':' terrestrial ',
' terrour ':' terror ',
' testatour ':' testator ',
' thaddeus ':' thaddaeus ',
' thanke ':' thank ',
' thankefull ':' thankful ',
' thankes ':' thanks ',
' thankesgiving ':' thanksgiving ',
' thankeworthy ':' thankworthy ',
' thankfulnesse ':' thankfulness ',
' theefe ':' thief ',
' theeves ':' thieves ',
' themselues ':' themselves ',
' thencefore ':' thenceforth ',
' therfore ':' therefore ',
' therin ':' therein ',
' therunto ':' thereunto ',
' thessalonias ':' thessalonians ',
' thicke ':' thick ',
' thiefe ':' thief ',
' thinke ':' think ',
' thirde ':' third ',
' thogh ':' though ',
' thorne ':' thorn ',
' thornes ':' thorns ',
' thorow ':' through ',
' thorowly ':' throughly ',
' thorowout ':' throughout ',
' threatned ':' threatened ',
' threatning ':' threatening ',
' threatnings ':' threatenings ',
' thrise ':' thrice ',
' throgh ':' through ',
' throte ':' throat ',
' throwen ':' thrown ',
' thundrings ':' thunderings ',
' thyine ':' thine ',
' til ':' till ',
' timeus ':' timaeus ',
' title ':' tittle ',
' toile ':' toil ',
' tolde ':' told ',
' tombe ':' tomb ',
' tombes ':' tombs ',
' tooke ':' took ',
' topas ':' topaz ',
' torne ':' torn ',
' towards ':' toward ',
' towell ':' towel ',
' towne ':' town ',
' townes ':' towns ',
' towre ':' tower ',
' traitour ':' traitor ',
' traitours ':' traitors ',
' transgresse ':' transgress ',
' transgressour ':' transgressor ',
' transgressours ':' transgressors ',
' traunce ':' trance ',
' travaile ':' travail ',
' traveilest ':' travailest ',
' trespasse ':' trespass ',
' triall ':' trial ',
' troden ':' trodden ',
' truely ':' truly ',
' trueth ':' truth ',
' trueths ':' truths ',
' trumpe ':' trump ',
' trumpetters ':' trumpeters ',
' tryed ':' tried ',
' turne ':' turn ',
' twaine ':' twain ',
' twelue ':' twelve ',
' twinckling ':' twinkling ',
' twise ':' twice ',
' tythe ':' tithe ',
' unbeleefe ':' unbelief ',
' unbeleevers ':' unbelievers ',
' unbeleeving ':' unbelieving ',
' unbeliefe ':' unbelief ',
' uncertaine ':' uncertain ',
' uncertainely ':' uncertainly ',
' uncleane ':' unclean ',
' uncleannesse ':' uncleanness ',
' uncorruptnesse ':' uncorruptness ',
' understading ':' understanding ',
' unfained ':' unfeigned ',
' unfruitfull ':' unfruitful ',
' ungodlinesse ':' ungodliness ',
' uniust ':' unjust ',
' unknowen ':' unknown ',
' unlawfull ':' unlawful ',
' unlesse ':' unless ',
' unlevened ':' unleavened ',
' unmaried ':' unmarried ',
' unmercifull ':' unmerciful ',
' unpossible ':' impossible ',
' unprofitablenesse ':' unprofitableness ',
' unquencheable ':' unquenchable ',
' unreprooveable ':' unreproveable ',
' unrighteousnes ':' unrighteousness ',
' unrighteousnesse ':' unrighteousness ',
' unseemely ':' unseemly ',
' unspeakeable ':' unspeakable ',
' unthankfull ':' unthankful ',
' untill ':' until ',
' uproare ':' uproar ',
' uprore ':' uproar ',
' usurpe ':' usurp ',
' vaile ':' vail ',
' vaile ':' veil ',
' vaine ':' vain ',
' vainely ':' vainly ',
' variablenesse ':' variableness ',
' verely ':' verily ',
' vertue ':' virtue ',
' vessell ':' vessel ',
' vexe ':' vex ',
' viall ':' vial ',
' vineger ':' vinegar ',
' virgine ':' virgin ',
' virgines ':' virgins ',
' visite ':' visit ',
' voide ':' void ',
' voyce ':' voice ',
' voyces ':' voices ',
' voyd ':' void ',
' waies ':' ways ',
' waight ':' weight ',
' waighty ':' weighty ',
' waile ':' wail ',
' waite ':' wait ',
' walke ':' walk ',
' walles ':' walls ',
' wandring ':' wandering ',
' wantonnes ':' wantonness ',
' wantonnesse ':' wantonness ',
' warne ':' warn ',
' warre ':' war ',
' warres ':' wars ',
' watchfull ':' watchful ',
' waxe ':' wax ',
' wayes ':' way ',
' wayes ':' ways ',
' wayling ':' wailing ',
' wayting ':' waiting ',
' weake ':' weak ',
' weakenesse ':' weakness ',
' weaknes ':' weakness ',
' weaknesse ':' weakness ',
' weare ':' wear ',
' wearinesse ':' weariness ',
' wee ':' we ',
' weeke ':' week ',
' weepe ':' weep ',
' wel ':' well ',
' welbeloved ':' wellbeloved ',
' welles ':' wells ',
' whe ':' when ',
' wheate ':' wheat ',
' wherby ':' whereby ',
' wherewithall ':' wherewithal ',
' wherfore ':' wherefore ',
' wherin ':' wherein ',
' wherof ':' whereof ',
' wherunto ':' whereunto ',
' wherupon ':' whereupon ',
' wherwith ':' wherewith ',
' whilest ':' while ',
' whilest ':' whilst ',
' whithersover ':' whithersoever ',
' wholy ':' wholly ',
' whome ':' whom ',
' whoseover ':' whosoever ',
' wickednes ':' wickedness ',
' wickednesse ':' wickedness ',
' widowe ':' widow ',
' widowes ':' widows ',
' wil ':' will ',
' wilde ':' wild ',
' wildernes ':' wilderness ',
' wildernesse ':' wilderness ',
' winde ':' wind ',
' windes ':' winds ',
' winepresse ':' winepress ',
' wisdome ':' wisdom ',
' wisedom ':' wisdom ',
' wisedome ':' wisdom ',
' withall ':' withal ',
' withdrawen ':' withdrawn ',
' witnes ':' witness ',
' witnesse ':' witness ',
' wo ':' woe ',
' wolues ':' wolves ',
' wombe ':' womb ',
' wonderfull ':' wonderful ',
' wondred ':' wondered ',
' wondring ':' wondering ',
' wonne ':' won ',
' woolfe ':' wolf ',
' wooll ':' wool ',
' woont ':' wont ',
' worde ':' word ',
' wordes ':' words ',
' worke ':' work ',
' workefellow ':' workfellow ',
' workeman ':' workman ',
' workemanship ':' workmanship ',
' workemen ':' workmen ',
' workes ':' works ',
' worlde ':' world ',
' worme ':' worm ',
' wormes ':' worms ',
' wormewood ':' wormwood ',
' worshippe ':' worship ',
' wote ':' wot ',
' wouldst ':' wouldest ',
' wrinckle ':' wrinkle ',
' yee ':' ye ',
' yeeld ':' yield ',
' yeelde ':' yield ',
' yeelded ':' yielded ',
' yeeldeth ':' yieldeth ',
' yeere ':' year ',
' yeeres ':' years ',
' yere ':' year ',
' yeres ':' years ',
' yland ':' island ',
' ynough ':' enough ',
' yong ':' young ',
' yonger ':' younger ',
' yourselues ':' yourselves ',
' yourselves ':' yield ',
' youthfull ':' youthful ',
' youwards ':' youward ',
' yron ':' iron ',
' yuory ':' ivory ',
' zacheus ':' zacchaeus ',
' zeale ':' zeal ',
' zelously ':' zealously ',
}

precompound = {
' folde ':' fold ',
' selfe ':' self ',
' selues ':' selves ',
' seruant ':' servant ',
' seruants ':' servants ',
' seuen ':' seven ',
}


compound = {
' alms deeds ':' almsdeeds ',
' an other ':' another ',
' assoone ':' as soon ',
' broken hearted ':' brokenhearted ',
' bond woman ':' bondwoman ',
' common wealth ':' commonwealth ',
' covenant breakers ':' covenantbreakers ',
' double tongued ':' doubletongued ',
' double tongued ':' doubletongued ',
' eye salve ':' eyesalve ',
' fellow citizens ':' fellowcitizens ',
' fellow disciples ':' fellowdisciples ',
' fellow heirs ':' fellowheirs ',
' fellow labourers ':' fellowlabourers ',
' fellow prisoner ':' fellowprisoner ',
' fellow prisoners ':' fellowprisoners ',
' fellow servant ':' fellowservant ',
' fellow servants ':' fellowservants ',
' fellow soldier ':' fellowsoldier ',
' fellow workers ':' fellowworkers ',
' figtree ':' fig tree ',
' first begotten ':' firstbegotten ',
' first begotten ':' firstbegotten ',
' first born ':' firstborn ',
' first borne ':' firstborn ',
' first fruit ':' firstfruit ',
' first fruits ':' firstfruits ',
' four footed ':' fourfooted ',
' four square ':' foursquare ',
' gazing stock ':' gazingstock ',
' guest chamber ':' guestchamber ',
' helfire ':' hell fire ',
' high minded ':' highminded ',
' high ways ':' highways ',
' him self ':' himself ',
' holy day ':' holyday ',
' honey combe ':' honeycomb ',
' hundred fold ':' hundredfold ',
' in as much ':' inasmuch ',
' in deed ':' indeed ',
' it self ':' itself ',
' in stead ':' instead ',
' joint heirs ':' jointheirs ',
' like minded ':' likeminded ',
' long suffering ':' longsuffering ',
' market place ':' marketplace ',
' man servant ':' manservant ',
' maid servant ':' maidservant ',
' maid servants ':' maidservants ',
' men pleasers ':' menpleasers ',
' men servants ':' menservants ',
' money changers ':' moneychangers ',
' my self ':' myself ',
' our selves ':' ourselves ', 
' seven fold ':' sevenfold ',
' shalbe ':' shall be ',
' shew bread ':' shewbread ',
' stumbling block ':' stumblingblock ',
' stumbling stone ':' stumblingstone ',
' sweet smelling ':' sweetsmelling ',
' tender hearted ':' tenderhearted ',
' thirty fold ':' thirtyfold ',
' thy self ':' thyself ',
' town clarke ':' townclerk ',
' turtle doves ':' turtledoves ',
' two edged ':' twoedged ',
' vain glory ':' vainglory ',
' verily verely ':' verily verily ',
' water pots ':' waterpots ',
' well pleasing ':' wellpleasing ',
' wild beasts ':' wildbeasts ',
' will worship ':' willworship ',
' your selves ':' yourselves ',
}


def preCompound(text):
    for pattern in precompound:
        match = precompound[pattern]
        text = string.replace(text, pattern, match)
    return text

def Compound(text):
    for pattern in compound:
        match = compound[pattern]
        text = string.replace(text, pattern, match)
    return text

def Spelling(text):
    for pattern in spelling:
        match = spelling[pattern]
        text = string.replace(text, pattern, match)
    return text
