# -*- coding: UTF-8 -*-

import wx, re, zlib
import fixRef, utility
import sqlite3 as sqlite


books = [   'Gen', 'Exo', 'Lev', 'Num', 'Deu', 'Jos', 'Jdg', 'Rth', '1Sa', '2Sa', '1Ki', '2Ki', '1Ch', '2Ch',
            'Ezr', 'Neh', 'Est', 'Job', 'Psa', 'Pro', 'Ecc', 'Son', 'Isa', 'Jer', 'Lam', 'Eze', 'Dan', 'Hos',
            'Joe', 'Amo', 'Oba', 'Jon', 'Mic', 'Nah', 'Hab', 'Zep', 'Hag', 'Zec', 'Mal', 'Mat', 'Mar', 'Luk',
            'Joh', 'Act', 'Rom', '1Co', '2Co', 'Gal', 'Eph', 'Phi', 'Col', '1Th', '2Th', '1Ti', '2Ti', 'Tit',
            'Phm', 'Heb', 'Jam', '1Pe', '2Pe', '1Jo', '2Jo', '3Jo', 'Jud', 'Rev']


lttr2num = {'a':1, 'b':2, 'c':3, 'd':4, 'e':5, 'f':6, 'g':7, 'h':8, 'i':9, 'j':10, 'k':11, 'l':12, 'm':13, 'n':14,
            'o':15, 'p':16, 'q':17, 'r':18, 's':19, 't':20, 'u':21, 'v':22, 'w':23, 'x':24, 'y':25, 'z':26}




def getSameRef(ref, fName, fface):
    ref = ' ' + ref
    index = []
    con = sqlite.connect(fName)
    cur = con.cursor() 

    cur.execute('SELECT * FROM bible WHERE ref LIKE \'%%%s\'' % ref)
    
    rows = cur.fetchall()
    #encrypt = utility.CheckEncrypt(cur)
    
    for row in rows:
        row = utility.CheckEncryptByHeader(row)
        
        #if encrypt == 1:
        #    vsTxt = zlib.decompress('x\x01' + str(row[2]))
        #    row = (row[0], row[1], unicode(vsTxt, 'utf-8'))

        line = '%s\t%s' % (row[1], row[2])
        line = re.sub(r'\n', '<br>', line)
        line = re.sub(r'(\w\w\w) (\d+):(\d+)\t', r'<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<u>\1_\2:\3</u>, </font>', line)

        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)

        index.append(line)
    
    hits = len(index)
        
    return '''<font face="%s"><b>Same Reference Search, <font color="#660000">%s</b></font><br>
    Found in %s Books 
    <hr><br></a>%s</font>''' % (fface, ref, hits, '<br>'.join(index))
        

def getCaps(idxList, fName, redSearch, fface, rangeStr, ctrl):
    mainApp = wx.GetApp().GetTopWindow()
    
    final = []
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    #con.text_factory = str
    cur = con.cursor() 
    
    encrypt = utility.CheckEncrypt(cur)
    
    if redSearch == 1:
        rangeStr = rangeStr + ' (Red-Letter)'
        cur.execute('SELECT * FROM bible WHERE id BETWEEN 23146 AND 31103')
        rows = cur.fetchall()
        for row in rows:
            
            if encrypt == 1:
                vsTxt = zlib.decompress('x\x01' + str(row[2]))
                row = (row[0], row[1], unicode(vsTxt, 'utf-8'))

            line = row[2]

            if '<r>' in line:
                rRange = re.findall(r'<r>.+?</r>', line)                                
                for rng in rRange:
                    line = re.sub(r'LORD', 'L', line)
                    line = re.sub(r'GOD', 'G', line)
                    
                    caps = re.findall(r'[A-Z]', rng)
                    if caps:
                        ref = row[1]
                        ref = ref.replace(' ', '_')
                        ref = '<font color="#336666"><u>%s</u></font>' % ref
                        final.append('<tr><td>')
                        for c in caps:
                            final.append('%s ' % c)
                        final.append('</td><td>%s</td></tr>' % ref)
    
    else:
        selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
        if len(idxList) > 1:
            for rng in idxList[1:]:
                selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])

        cur.execute(selectStr)
        rows = cur.fetchall()

        for row in rows:
            if encrypt == 1:
                vsTxt = zlib.decompress('x\x01' + str(row[2]))
                row = (row[0], row[1], unicode(vsTxt, 'utf-8'))
            
            line = re.sub(r'LORD', 'L', row[2])
            line = re.sub(r'GOD', 'G', line)
            
            if '<a href' in line:
                line = re.sub(r'<a href="embNote.+?</a>', r'', line)
            
            caps = re.findall(r'[A-Z]', line)
            if caps:
                
                if ctrl == 0:
                    ref = row[1]
                    ref = ref.replace(' ', '_')
                    ref = '<font color="#336666"><u>%s</u></font>' % ref
                    final.append('<tr><td>')
                    for c in caps:
                        final.append('%s ' % c)
                    final.append('</td><td>%s</td></tr>' % ref)
                else:
                    fface = 'Lucida Console'
                    for c in caps:
                        final.append('%s ' % c)

    if ctrl == 0:
        result = '''<font face="%s"><b>List of Capital Letters</b> (<font color="#660000">%s</font>): 
        <hr><table width="250">
        <tbody>%s</tbody></table><br></font>'''

        return result % (fface, rangeStr, ''.join(final))
    else:
        result = '''<font face="%s"><b>List of Capital Letters</b> (<font color="#660000">%s</font>): 
        <hr>%s<br><br>%s</font>'''
        
        rev = reversed(final)
        
        return result % (fface, rangeStr, ''.join(final), ''.join(rev))



def schWordList(fName, font, refList, entry, sort =1):
    wdList = []
    wCount = {}
    final = []
    valList = []
      
    con = sqlite.connect(fName)
    #con.text_factory = str
    cur = con.cursor() 
    
    encrypt = utility.CheckEncrypt(cur)
    
    # Select where ref is in a list, converted to string
    cur.execute('SELECT verse FROM bible WHERE ref IN (%s)' % "'%s'" % "', '".join(refList)) 
    
    for row in cur: 
        line = str(row[0])
        if encrypt == 1:
            #line = utility.CheckEncryptByHeader(row[0])
            line = zlib.decompress('x\x01' + line)
            line = unicode(line, 'utf-8')
        
        if '<a href' in line:
            line = re.sub(r'<a href="embNote.+?</a>', r'', line)
            line = re.sub(r'<a href.+?">|</a>', r'', line)
        
        line = re.sub(r'[().,:;?!"-\'¶]|<fnc?>.+?</fnc?>|<.*?>|\[.*?\]', '', line)
        
        for wd in line.split(None):
            wdList.append(wd)
    
    for word in wdList:
        word = word.lower()
        wCount[word] = wCount.get(word, 0) + 1
    keyList = wCount.keys()
    keyList.sort()
    
    if sort == 1:
        for key, value in wCount.items():
            valList.append((value, key))
            valList.sort()
            valList.reverse()
        for i in xrange(len(valList)):
            final.append('<tr><td>%s</td><td>%s</td></tr>' % (valList[i][0], valList[i][1]))
    else:
        for keyword in keyList:
            final.append('<tr><td>%s</td><td>%d</td></tr>' % (keyword, wCount[keyword]))

    uniq = len(keyList)
        
    total = sum(wCount.values())
   
    answer = '''<font face="%s"><b>Wordlist
    of:</b> "<font color="#660000"><b>%s</b></font>" <b>Search Results</b>,<br><b>%s</b> unique words - <b>%s</b> total words<br>
    (<i>Right-click on word to search</i>)<hr><center><table width="250">
    <tbody><tr><td><b>Instances</b></td><td><b>Word</b></td></tr>%s</tbody></table></center><br></font>'''

    return answer % (font, entry, uniq, total, ''.join(final))


def wCloud(idxList, fName, sort, redSearch, fface, rangeStr, abbr):
    mainApp = wx.GetApp().GetTopWindow()
    
    omitList = ['a','after','all','also','an','and','are','as','at','be','because','before','but','by','came','come','day','did','do',
    'down','even','every','for','from','go','had','hast','hath','have','he','her','him','his','i','if','in','into','is','it','let',
    'made','make','man','may','me','my','no','not','now','o','of','on','one','or','our','out','over','said','saith','say','saying',
    'shall','shalt','so','that','the','thee','their','them','then','there','therefore','these','they','things','this','thou','thy',
    'to','unto','up','upon','us','was','we','went','were','when','which','will','with','ye','you','your']
    
    wdList = wList(idxList, fName, sort, redSearch, fface, rangeStr, abbr, 2)
    
    wCount = {}
    for word in wdList:
        if not word.lower() in omitList:
            word = word.lower()
            wCount[word] = wCount.get(word, 0) + 1
    
    keyList = wCount.keys()
    keyList.sort()
    
    valList = []
    for key, value in wCount.items():
        valList.append((value, key))
        valList.sort()
        valList.reverse()
        if len(valList) > 100:
            valList = valList[:100]
    
    final = []
    for num, set in enumerate(valList):
        if num > -1 and num < 14:
            format = '[%s]<font color="brown" size="7">%s </font>' % (set[1], set[1])
        elif num > 13 and num < 28:
            format = '[%s]<font color="green" size="6">%s </font>' % (set[1], set[1])
        elif num > 27 and num < 42:
            format = '[%s]<font color="navy" size="5">%s </font>' % (set[1], set[1])
        elif num > 41 and num < 56:
            format = '[%s]<font color="red" size="4">%s </font>' % (set[1], set[1])
        elif num > 55 and num < 70:
            format = '[%s]<font color="teal" size="3">%s </font>' % (set[1], set[1])
        elif num > 69 and num < 84:
            format = '[%s]<font color="blue" size="2">%s </font>' % (set[1], set[1])
        elif num > 83:
            format = '[%s]<font color="black" size="1">%s </font>' % (set[1], set[1])
        
        final.append(format)
    
    final.sort()
    
    last = [re.sub(r'\[.+?\]', '', wd) for wd in final]

    answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
    <tr><td bgcolor="%s"><font face="%s"><b>Word Cloud of: <font color="#660000">%s</font></b> (%s),<br><b>100</b>\
    most used words of <b>%s</b> total words<br>\
    (<i>Right-click on word to search</i>)</td></tr></table><br><br><font face="%s">%s</font>'''

    return answer % (mainApp.resColor, mainApp.resHeadColor, fface, rangeStr, abbr, len(wdList), fface, ''.join(last))




def wList(idxList, fName, sort, redSearch, fface, rangeStr, abbr, popup = 0):
    mainApp = wx.GetApp().GetTopWindow()
    wdList = []
    wCount = {}
    
    def processLine(line):
        if '<a href' in line:
            line = re.sub(r'<a href="embNote.+?</a>', r'', line)
        line = re.sub(r'[().,:;?!"-\'¶]|<fnc?>.+?</fnc?>|<.*?>|\[.*?\]', '', line)

        line = line.split(None)
        wdList.extend(line)
        
    con = sqlite.connect(fName)
    #con.text_factory = str
    cur = con.cursor() 
    
    print idxList
    
    encrypt = utility.CheckEncrypt(cur)
    
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer

    if redSearch == 1:
        rangeStr = rangeStr + ' (Red-Letter)'
        cur.execute('SELECT * FROM bible WHERE id BETWEEN 23146 AND 31103')
        rows = cur.fetchall()
        
        for row in rows:
            if encrypt == 1:
                vsTxt = zlib.decompress('x\x01' + str(row[2]))
                row = (row[0], row[1], unicode(vsTxt, 'utf-8'))

            if '<r>' in row[2]:
                rRange = re.findall(r'<r>.+?</r>', row[2])                                
                for rng in rRange:
                    processLine(rng)
    else:
        if popup == 1 or popup == 2:
            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0], idxList[1])
        else:
            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])

        cur.execute(selectStr)
        rows = cur.fetchall()
                
        for row in rows:
            row = utility.CheckEncryptByHeader(row)
            processLine(row[2])
    
    if popup == 2:
        return wdList
    
    for word in wdList:
        word = word.lower()
        wCount[word] = wCount.get(word, 0) + 1
        
    keyList = wCount.keys()
    keyList.sort()
      
    final = []
    valList = []
    if sort == 1:
        from operator import itemgetter
        sortList = sorted(wCount.iteritems(), key=itemgetter(1), reverse=True)
        for tup in sortList:
            final.extend('<tr><td>%s</td><td>%s</td></tr>' % (tup[0], tup[1]))
        header = '<tr><td><b>Instances</b></td><td><b>Word</b></td></tr>'
            
    else:
        for keyword in keyList:
            final.extend('<tr><td>%s</td><td>%d</td></tr>' % (keyword, wCount[keyword]))
        header = '<tr><td><b>Word</b></td><td><b>Instances</b></td></tr>'

    uniq = len(keyList)
    
    total = sum(wCount.values())
   
    answer = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
    <tr><td bgcolor="%s"><font face="%s"><b>Wordlist
    of: <font color="#660000">%s</font></b> (%s),<br><b>%s</b> unique words - <b>%s</b> total words<br>
    (<i>Right-click on word to search</i>)</td></tr></table><br><br><table width="250">
    <tbody><font face="%s">%s%s</font></tbody></table><br></font>'''

    return answer % (mainApp.resColor, mainApp.resHeadColor, fface, rangeStr, abbr, uniq, total, fface, header, ''.join(final))


def wFreq(entry, fName, sort, fface, dispWidth):
    dbWord = '%' + entry + '%'
    
    if "'" in dbWord:
        dbWord = dbWord.replace("'", "''")
    
    mainApp = wx.GetApp().GetTopWindow()
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    encrypt = utility.CheckEncrypt(cur)

    if encrypt == 1:
        hitRows = utility.UnEncryptRows(cur, [dbWord], [[1, 31102]])
    else:
        cur.execute('SELECT * FROM bible WHERE verse LIKE ?', (dbWord,))
        hitRows = cur.fetchall()
      
    final = []
    hitList = []
    
    bkList = []
    refList = []
    
    for row in hitRows:
        row = utility.CheckEncryptByHeader(row)  
        vsTxt = row[2]
        if '<a href' in vsTxt:
            vsTxt = re.sub(r'<a href="embNote.+?</a>', r'', vsTxt)
        
        find = re.compile(r'\b%s\b' % entry, re.I)
        
        hit = find.findall(vsTxt)
        if hit:
            tmp = []
            bk = row[1][:3]
            ref = '<u>%s</u>' % row[1]
            ref = ref.replace(' ', '_')
            
            bk = fixRef.fullTitle(bk)
            if bk in bkList:
                idx = bkList.index(bk)
                refList[idx].append(ref)
            else:    
                bkList.append(bk)
                tmp.append(ref)
                refList.append(tmp)
                
            for num in range(len(hit)):
                hitList.append(bk)

    most = 0
    vsCnt = 0
    for set in refList:
        vsCnt += len(set)

    instances = 0
    for bk in bkList:
        cnt = hitList.count(bk)
        instances += cnt
        if cnt > most:
            most = cnt
    
    for bk in bkList:
        cnt = hitList.count(bk)
        if cnt != 0:
            if cnt == most:
                color = '#FF9696'
            else:            
                color = '#FFCCCC'
            
            width = float(cnt) / float(most) * float(dispWidth-155)
            
            result = '<table><tbody><tr><td width="100"><i>%s</i></td><td bgcolor="%s" width="%d">%s</td></tr></tbody></table>'\
            % (bk, color, width, cnt)
                
            final.append(result)
    
    booksCount = len(final)
    
    refFinal = []
    for bk in bkList:
        cnt = hitList.count(bk)
        idx = bkList.index(bk)
        refs = ', '.join(refList[idx])
        bk = '<font color="#660000">%s</font>' % bk
        refFinal.append('<br><br><b>%s, </b><i>%s times</i><br><font color="#336666">%s</font>' % (bk, cnt, refs))
    
    
    answer = '''<font face="%s"><b>Word Occurences by Book, <font color="#660000">%s,</b></font>
    <br><b>%s</b> Occurences in <b>%s</b> Verses in <b>%s</b> Books<hr><table>
    <tbody>%s</tbody></table><hr>%s</font>'''

    return answer % (fface, entry, instances, vsCnt, booksCount, ''.join(final), ''.join(refFinal))



def wForm(entry, fName, orig, kind, fface, dispWidth):
       
    dbWord = '%' + entry + '%'
    
    if "'" in dbWord:
        dbWord = dbWord.replace("'", "''")
    
    mainApp = wx.GetApp().GetTopWindow()
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    encrypt = utility.CheckEncrypt(cur)

    if encrypt == 1:
        #print dbWord
        hitRows = utility.UnEncryptRows(cur, [dbWord], [[1, 31102]])
    else:
        cur.execute('SELECT * FROM bible WHERE verse LIKE ?', (dbWord,))
        hitRows = cur.fetchall()

    if kind == 0: find = re.compile(r'(\b%s\w*)' % entry, re.I)
    if kind == 1: find = re.compile(r'(\w+%s\w+)' % entry, re.I)
    if kind == 2: find = re.compile(r'(\w*%s\b)' % entry, re.I)
    if kind == 3: find = re.compile(r'(\w*%s\w*)' % entry, re.I)
    
    wdList = []
    hitList = []
    refList = []
    chFinal = []
    
    for row in hitRows:
        #row = utility.CheckEncryptByHeader(row)            
        
        line = utility.CheckEncoding(row[2])
        if '<a href' in line:
            line = re.sub(r'<a href="embNote.+?</a>', r'', line)
        line = re.sub(r'[().,:;?!"-\'¶]|<fnc?>.+?</fnc?>|<.*?>|\[.*?\]', '', line)
        
        hits = find.findall(line)
        if hits:
            for wd in hits:
                tmp = []
                wd = wd.lower()
                
                ref = '<u>%s</u>' % row[1]
                ref = ref.replace(' ', '_')

                if wd in wdList:
                    idx = wdList.index(wd)
                    refList[idx].append(ref)
                else:    
                    wdList.append(wd)
                    tmp.append(ref)
                    refList.append(tmp)
                    
            for num in range(len(hits)):
                hitList.append(wd)

    most = 0
    for wd in wdList:
        cnt = hitList.count(wd)
        if cnt > most:
            most = cnt
    
    for wd in wdList:
        if cnt != 0:
            idx = wdList.index(wd)
            cnt = len(refList[idx])
            color = '#FFCCCC'
            width = float(cnt) / float(most) * float(dispWidth-155)
            wd = re.sub(entry, '<font color="#660000"><u>%s</u></font>' % entry, wd)

            result = '<table><tbody><tr><td width="100"><i>%s</i></td><td bgcolor="%s" width="%d">%s</td></tr></tbody></table>'\
            % (wd, color, width, cnt)
            
            chFinal.append(result)
    
    if kind == 0: sort = 'at beginning of word'
    if kind == 1: sort = 'within word'
    if kind == 2: sort = 'at end of word'
    if kind == 3: sort = 'anywhere in word'
        
    final = []

    wcount = len(wdList)
     
    icount = 0
    for wd in wdList:
        idx = wdList.index(wd)
        refs = ', '.join(refList[idx])
        wd = re.sub(entry, '<font color="#660000"><u>%s</u></font>' % entry, wd)
        cnt = len(refList[idx])
        icount += cnt
        final.append('<br><br><b>%s, </b>%s times<br><font color="#336666">%s</font>' % (wd, cnt, refs))
    
    answer = '''<font face="%s"><b>Forms
        of <font color="#660000">%s,</font></b> (%s):<br>%s instances, %s wordforms
        <hr>%s<table width="300"><tbody>%s</tbody></table><br></font>'''
    
    return answer % (fface, orig, sort, icount, wcount, ''.join(chFinal), ''.join(final))




def Sequence(ref, num, cyc, fName, fface, type):
    bk = ref[:3]
    fRef = fixRef.fullTitle(bk)
    fRef = fRef + ref[3:]
    
    mainApp = wx.GetApp().GetTopWindow()
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    cur.execute('SELECT * FROM title',)
    titleRow = cur.fetchone()
    title = utility.CheckEncoding(titleRow[0])
    
    cur.execute('SELECT * FROM bible WHERE ref = ?', (ref,))
    row = cur.fetchone()
    idx = row[0]
       
    cur.execute('SELECT * FROM bible WHERE id BETWEEN ? and ?', (idx, 31102))
    rows = cur.fetchall()

        
    index = []
    def vcycle(tm):
        count1 = 1
        while True:
            if count1 < num * tm:
                count1 += 1
            else:
                row = rows[count1 -1]
                row = utility.CheckEncryptByHeader(row)
                
                line = row[2]
                if '<a hr' in line:
                    line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
                    line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
                
                num1 = num * tm
                ref = row[1].replace(' ', '_')
                ref = '<font color="#336666"><u>' + ref + '</u></font>'
                line = '#' + str(num1) + '<br>' + ref + '<br>' + line + '<br><br>'
                index.append(line)
                break
    
    
    def wcycle(tm):
        words = []
        for row in rows:
            row = utility.CheckEncryptByHeader(row)    
            
            line = row[2]
            if '<a hr' in line:
                line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', line)
                line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', line)
                
            line = re.sub(r'[().,:;?!"-\' ¶]|<fnc?>.+?</fnc?>|<.*?>', '', line)

            temp = line.split(None)
            words.extend(temp)
            
            if line == '\n':
                break
            elif len(words) < num * tm:
                continue
            else:
                num1 = num * tm -1
                ref = row[1].replace(' ', '_')
                ref = '<font color="#336666"><u>' + ref + '</u></font>'
                word = '<tr><td># ' + str(num1 +1) + ':</td><td><b>' + words[num1] + '</b></td><td>' + ref + '</td></tr>'
                index.extend(word)
                break
    
    
    def lcycle(tm):
        letters = []
        for row in rows:
            row = utility.CheckEncryptByHeader(row)
            line = row[2]
            
            if '<a hr' in line:
                line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', line)
                line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', line)
                
            string = re.sub(r'[().,:;?!"-\' ¶]|<fnc?>.+?</fnc?>|<.*?>', '', line)
            temp = list(string)
            letters.extend(temp)
            
            if string == '\n':
                break
            elif len(letters) < num * tm:
                continue
            else:
                num1 = num * tm -1
                ref = row[1].replace(' ', '_')
                ref = '<font color="#336666"><u>' + ref + '</u></font>'
                final = '<tr><td># ' + str(num1 +1) + ':</td><td><b> ' + letters[num1] + ' </b></td><td>' + ref + '</td></tr>'
                index.extend(final)
                break
    
    if type == 0:
        
        count2 = 1
        while count2 <= cyc:
            vcycle(count2)
            count2 += 1
        
        answer = '''<font face="%s"><b>Verse Sequence (%s),</b> Beginning with %s<br>
        Verse Interval: <b>%s,</b> Cycles: <b>%s</b><hr>%s</font>'''

    if type == 1:

        count2 = 1
        while count2 <= cyc:
            wcycle(count2)
            count2 += 1
               
        answer = '''<font face="%s"><b>Word Sequence (%s),</b> Beginning with %s<br>
        Word Interval: <b>%s,</b> Cycles: <b>%s</b><hr><table width="300"><tbody>%s</tbody></table></font>'''

    if type == 2:
        count2 = 1
        while count2 <= cyc:
            lcycle(count2)
            count2 += 1
        
        answer = '''<font face="%s"><b>Letter Sequence (%s),</b> Beginning with %s<br>
        Letter Interval: <b>%s,</b> Cycles: <b>%s</b><hr><table width="250"><tbody>%s</tbody></table></font>'''
    
    #print index
    
    return answer % (fface, title, fRef, str(num), str(cyc), ''.join(index))


def sGetVerseNumerical(num, fName, font):
    mainApp = wx.GetApp().GetTopWindow()
    
    if fName in mainApp.interList or fName in mainApp.strongsList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    cur.execute('SELECT * FROM bible')
    rows = cur.fetchall()
        
    final = []
    for row in rows:
        row = utility.CheckEncryptByHeader(row)        
        line = '%s\t%s' % (row[1], row[2])
        
        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
        
        lineMod = re.sub(r"[\W]+|<fnc?>.+?</fnc?>|<.*?>|\n", '', line)
        
        try:
            lineSum = sum([lttr2num[c] for c in lineMod.lower() if c.isalpha()])
        except:
            return '<center>Only texts using the 26 letter alphabet (like the AV) are suitable for Numerical Sum.</center>'
        
        if lineSum == int(num):
            ref = row[1].replace(' ', '_')
            ref = '<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<u>%s</u></font>' % ref
            wholeline = '%s\t%s' % (ref, row[2])
            final.append(wholeline)
    
    if len(final) == 0:
        answer = '''<font face="%s"><center>No Matches of %s Found</center></font>''' % (font, num)
    else:
        answer = '''<font face="%s"><b>Numerical Value Verse Match,</b> <i>%s</i> Verses<br>Value, <b>%s</b>
        <hr>%s</font>''' % (font, len(final), num, '<br><br>'.join(final))
    
    return answer


def getSyllables(word):
    syl = 0
    subtract_syl = ['cial', 'tia', 'cius', 'cious', 'giu', 'ion', 'iou',
                    'sia$', '.ely$', 'ea.', 'oa.', 'enced$', 'es$', '[hr]ed$',
                    'ere', 'uai']
    add_syl = [ 'ia', 'riet', 'dien', 'iu', 'io', 'ii', '[aeiouym]bl$',
                '[aeiou]{3}', '^mc', 'ism$', '([^aeiouy])\1l$', 'eing$',
                '[^l]lien', '^coa[dglx].',  '[^gq]ua[^auieo]', 'dnt$']
    word = word.lower()
    word = word.replace("'", "") # fold contractions
    #word = word.replace('"', "") # remove quotes from around word
    word = re.sub("e$", "", word)
    if len(word) == 1:
        #print '1', word
        return 1
    spl = re.split("[^aeiouy]+", word)
    try:
        spl.remove("")
        spl.remove('') # why do this twice?  
    except ValueError:
        pass
    for rx in subtract_syl:
        if re.search(rx, word):
            syl -= 1
    for rx in add_syl:
        if re.search(rx, word):
            syl += 1
    if len(word) == 1: # 'x'
        syl += 1
    syl += len(spl)
    if syl == 0: 
        syl = 1
    #print syl, word
    return syl


def FleschKincaidGradeLevel(words, syllables, sentences):
    ASL = words/sentences
    ASW = syllables/words
    return 0.39*ASL + 11.8*ASW - 15.59


def sGetRefDetails(idxList, fName, rangeStr, font, abbr):
    mainApp = wx.GetApp().GetTopWindow()
        
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    words, complex, syll, letters, vowels, cons, phrases, sentences, italics, level = 0,0,0,0,0,0,0,0,0,0
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
        
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
    if len(idxList) > 1:
        for rng in idxList[1:]:
            selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
    
    cur.execute(selectStr)
    rows = cur.fetchall()
    
    if not rows:
        print 'no rows, stat 675'
        return
            
    for row in rows:
        row = utility.CheckEncryptByHeader(row)  
        vs = row[2]
        
        italics += vs.count('<i>')
        
        if '<a hr' in vs:
            vs = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', vs)
            vs = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', vs)
        
        vsMod = re.sub(r"[,.;:?'()!\-¶]|<fnc?>.+?</fnc?>|<.*?>|\n", '', vs)
        wordList = vsMod.split()
        words += len(wordList)
        
        for wd in wordList:
            syl = getSyllables(wd)
            syll += syl
            if syl >= 3:
                complex += 1
        
        vsMod = vsMod.replace(' ', '')
        letters += len(vsMod)
        vowels += len([c for c in vsMod if re.match('[aeiouAEIOU]', c)])
        
        questions = vs.count('?')
        s = vs.count('.') + vs.count('!') + questions
        sentences += s
        p = vs.count(',') + vs.count(';') + vs.count(':') + s
        phrases += p
    
    avg = float(letters)/float(words)
    avgL = round(avg, 2)
    cons += letters - vowels
    
    level = FleschKincaidGradeLevel(words, syll, sentences)    
    verses = len(rows)
    
    avg = float(words)/float(verses)
    avgV = round(avg, 2)

    #avg = float(words)/float(sentences)
    #avgS = round(avg, 2)

    answer = '''<font face="%s"><b>Various Statistics For:</b><br><font color="#660000"><b>%s</b></font> (%s)<hr>
    <table width="250" border="0" cellpadding="2" cellspacing="0">
    <tr><td>Verses</td><td>%s</td></tr>
    <tr><td>Words</td><td>%s</td></tr>
    <tr><td>Complex Words</td><td>%s</td></tr>
    <tr><td>Syllables</td><td>%s</td></tr>
    <tr><td>Letters</td><td>%s</td></tr>
    <tr><td>Vowels</td><td>%s</td></tr>
    <tr><td>Consonants</td><td>%s</td></tr>
    <tr><td>Phrases</td><td>%s</td></tr>
    <tr><td>Sentences</td><td>%s</td></tr>
    <tr><td>Italics</td><td>%s</td></tr>
    <tr><td>Avg. Word Length</td><td>%s</td></tr>
    <tr><td>Avg. Verse Length</td><td>%s</td></tr>
    <tr><td>Grade Level</td><td>%s</td></tr>
    </table></font><br>''' 
    
    return answer % (font, rangeStr, abbr, verses, words, complex, syll, letters, vowels, cons, phrases, sentences, \
    italics, avgL, avgV,level)


def sGetVerseDetails(ref, fName, font, abbr):
    mainApp = wx.GetApp().GetTopWindow()
    
    try:
        fRef = fixRef.fullTitle(ref)
        fRef = fRef + ref[3:]
    except:
        fRef = ref
    
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer
    
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    mainApp = wx.GetApp().GetTopWindow()
    if fName in mainApp.interList or fName in mainApp.strongsList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts or or texts with Strong's numbers.</center></font>'''        
        return answer
    
    cur.execute('SELECT * FROM bible WHERE ref = ?', (ref,))
    row = cur.fetchone()
    
    bk = ref[:3]
    
    if row:
        row = utility.CheckEncryptByHeader(row)        
        vsIdx = row[0]
    else:
        print 'no row, stat 766'
        return
    
    toLast = 31102 - int(vsIdx)
    
    italics = vs.count('<i>')
    
    line = row[2]
    if '<a hr' in line:
        line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', line)
        line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', line)
    
    vsMod = re.sub(r"[,.;:?'()!\-¶]|<fnc?>.+?</fnc?>|<.*?>|\n", '', line)
       
    wordList = vsMod.split()
    words = len(wordList)
    
    syll = 0
    complex = 0
    for wd in wordList:
        syl = getSyllables(wd)
        syll += syl
        if syl >= 3:
            complex += 1
    
    vsMod = vsMod.replace(' ', '')
    letters = len(vsMod)
    
    try:
        vsSum = sum([lttr2num[c] for c in vsMod.lower()])
    except:
        vsSum = 'Omitted'
    
    vowels = len([c for c in vsMod if re.match('[aeiouAEIOU]', c)])
    cons = letters - vowels
    
    avg = float(letters)/float(words)
    avg = round(avg, 2)
    
    questions = vs.count('?')
    sentences = vs.count('.') + vs.count('!') + questions
    phrases = vs.count(',') + vs.count(';') + vs.count(':') + sentences

    ref = row[1].replace(' ', '_')
    ref = '<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<u>%s</u></font>' % ref
    verse = '%s\t%s' % (ref, row[2])
    
    if sentences == 0:
        sent = 1
    else:
        sent = sentences

    level = FleschKincaidGradeLevel(words, syll, sent)
    
    answer = '''<font face="%s"><b>Various Statistics For:</b><br><font color="#660000"><b>%s</b></font> (%s)<hr>
    %s<br><br><table width="190" border="0" cellpadding="2" cellspacing="0">
    <tr><td>Words</td><td>%s</td></tr>
    <tr><td>Complex Words</td><td>%s</td></tr>
    <tr><td>Syllables</td><td>%s</td></tr>
    <tr><td>Letters</td><td>%s</td></tr>
    <tr><td>Vowels</td><td>%s</td></tr>
    <tr><td>Consonants</td><td>%s</td></tr>
    <tr><td>Phrases</td><td>%s</td></tr>
    <tr><td>Sentences</td><td>%s</td></tr>
    <tr><td>Italics</td><td>%s</td></tr>
    <tr><td>Avg. Word Length</td><td>%s</td></tr>
    <tr><td>Grade Level</td><td>%s</td></tr>
    <tr><td>Verse Index</td><td>%s</td></tr>
    <tr><td>Verses To End</td><td>%s</td></tr>
    <tr><td>Numerical Sum</td><td>%s</td></tr>
    </table><br></font>''' 
    
    return answer % (font, fRef, abbr, verse, words, complex, syll, letters, vowels, cons, phrases, sentences, italics, avg, level, vsIdx, toLast, vsSum)
  

def sVerseByCount(num1, num2, num3, fName, font):
    mainApp = wx.GetApp().GetTopWindow()
    
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer

    
    def AddVerse(row):
        ref = row[1].replace(' ', '_')
        ref = '<font color="#336666">&nbsp;&nbsp;&nbsp;&nbsp;<u>%s</u></font>' % ref
        line = row[2]
        
        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
        
        wholeline = '%s\t%s' % (ref, line)
        final.append(wholeline)
    
    num1txt = num1
    num2txt = num2
    num3txt = num3  
        
    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
        
    cur.execute('SELECT * FROM bible')
    rows = cur.fetchall()
    
    final = []
    for row in rows:
        row = utility.CheckEncryptByHeader(row)
        line = row[2]
        
        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'\1', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'\1<nu>\2</nu></a>', line)
        
        #line = re.sub(r'¶\s?', r'', line)
        #print line.encode('utf-8')
        
        spaces = len(line.split())
        if u'¶' in line:
            spaces -= 1

        lineMod = re.sub(r"[,.;:?'()!\- ]|<fnc?>.+?</fnc?>|<.*?>|\n", '', line)
                
        if num1 != '' and num2 != '' and num3 != '':
            if spaces == int(num1) and len(lineMod) == int(num2):
                v = len( [c for c in lineMod if re.match('[aeiouAEIOU]', c)])
                if v == int(num3):
                    con = int(num2) - v
                    AddVerse(row)                    
        
        elif num1 == '' and num2 != '' and num3 != '':
            if len(lineMod) == int(num2):
                v = len( [c for c in lineMod if re.match('[aeiouAEIOU]', c)])
                if v == int(num3):
                    con = int(num2) - v
                    AddVerse(row)
                num1txt = 'NA'
        
        elif num1 != '' and num2 == '' and num3 != '':
            if spaces == int(num1):
                v = len( [c for c in lineMod if re.match('[aeiouAEIOU]', c)])
                if v == int(num3):
                    con = len(lineMod) - v
                    AddVerse(row)
                num2txt = 'NA'
    
        elif num1 != '' and num2 != '' and num3 == '':
            if spaces == int(num1) and len(lineMod) == int(num2):
                AddVerse(row)
            num3txt = 'NA'
            con = 'NA'

        elif num1 != '' and num2 == '' and num3 == '':
            if spaces == int(num1):
                AddVerse(row)
            num3txt = 'NA'
            num2txt = 'NA'
            con = 'NA'

        elif num1 == '' and num2 != '' and num3 == '':
            if len(lineMod) == int(num2):
                AddVerse(row)
            num3txt = 'NA'
            num1txt = 'NA'
            con = 'NA'

        elif num1 == '' and num2 == '' and num3 != '':
            v = len( [c for c in lineMod if re.match('[aeiouAEIOU]', c)])
            if v == int(num3):
                con = len(lineMod) - v
                AddVerse(row)
            num1txt = 'NA'
            num2txt = 'NA'

    contxt = con

    answer = '''<font face="%s"><b>Verse Matches By Count(s),</b><br><b>%s</b> Verses Found<hr>
    <b>Search Criteria:</b><br><br>
    <table width="130" border="0" cellpadding="0" cellspacing="0">
    <tr><td>Words</td><td>%s</td></tr>
    <tr><td>Letters</td><td>%s</td></tr>
    <tr><td>Vowels</td><td>%s</td></tr>
    <tr><td>Consonants</td><td>%s</td></tr>
    </table><br><hr>%s</font>''' % (font, len(final), num1txt, num2txt, num3txt, contxt, '<br><br>'.join(final))
            
    return answer


def sStats(idxList, fName, rangeStr, fface):
    mainApp = wx.GetApp().GetTopWindow()
    
    if fName in mainApp.interList:
        answer = '''<font face="%s"><center>Statistics are not available for Hebrew and Greek Texts</center></font>'''        
        return answer

    con = sqlite.connect(fName)
    con.text_factory = str
    cur = con.cursor() 
    
    cur.execute('SELECT * FROM title',)
    titleRow = cur.fetchone()
    title = titleRow[0]
    
    orig = []
    v1 = []
    
    def processLine(line):
        line1 = re.sub(r'(\w.*)\t', r'<font color="#336666">\1,</font><br>', line)
        orig.append(line1)
        line2 = re.sub(r'\w.*\t(.*)\n', r'\1' , line)
        v1.append(line2)
    
    
    selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
    if len(idxList) > 1:
        for rng in idxList[1:]:
            selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
    
    
    cur.execute(selectStr)
    rows = cur.fetchall()
    for row in rows:
        row = utility.CheckEncryptByHeader(row)        
        
        line = '%s\t%s' % (row[1], row[2])
        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', line)
        
        processLine(line)    

    vM = []
    if len(v1) % 2 == 0:                #Find if count is odd or even
        vM.append(orig[len(v1)/2-1])    #If even find two middle verses
        vM.append(orig[len(v1)/2])
    else:
        vM.append(orig[len(v1)/2])      #If odd find middle verse

    w2 = ' '.join(v1).split()           #Convert to list of words
    w3 = len(w2)/2                      #Find middle word index
    wM = w2[w3-3:w3+2]                  #Find five word middle phrase
    
    wds = len(w2)                       #Count words
    
    SwM = ' '.join(wM)

    phM = ''
    for item in orig:           #Find verse with middle phrase
        if SwM in item:
            phM = re.sub(SwM, '<font color="#660000">[' + SwM + ']</font>', item)
    if phM == '': phM = '(This phrase spans two verses and is not formated for display.)'

    vlen = {}
    for item in orig:           #Find longest and shortest verses
        vlen[len(''.join(item))] = item
    keyList = vlen.keys()       #List of dictionary keys
    keyList.sort()
    
    sht = vlen[keyList[0]]      #Shortest
    lng = vlen[keyList[-1]]     #Longest
    shtlen = len(sht.split())-2 #Word length
    lnglen = len(lng.split())-2

        
    result = '''<font face="%s"><b>Curious Statistics for,<br><font color="#660000">%s</b></font> (%s)<hr>
    <b>Shortest Verse</b><br><font color="#660000">(%s words)</font><br><br>%s<br><br><br>
    <b>Longest Verse</b><br><font color="#660000">(%s words)</font><br><br>%s<br><br><br>
    <b>Middle Verse(s)</b><br><font color="#660000">(of %s verses)</font><br><br>%s<br><br><br>
    <b>Middle Five Words</b><br><font color="#660000">(of %s words)</font><br><br><font color="#660000">['%s']
    </font><br></center>%s<br><br></font>''' % (fface, rangeStr, title, shtlen, sht, lnglen, lng, len(v1), '<br>'.join(vM), wds, ' '.join(wM), phM)
    
    return result
    

class fullStats:
    def processLine(self, line, fn):
        tabIdx = line.find('\t')
        ref = line[:tabIdx]
        space = ref.find(' ')
        book = ref[:space]
        colon = ref.find(':')
        chap = ref[space:colon]
        try:
            if int(chap) != self.chapTemp or book != self.bookTemp:
                self.chapters += 1
                self.chapTemp = int(chap)
                self.bookTemp = book
        except:
            print line
        
        line = line[tabIdx+1:]
        self.italics += line.count('<i>')
        
        #if fn == 'Modules/Bible/av1769.bib':
        if '<r>' in line:
            rRange = re.findall(r'<r>.+?</r>', line)
            for rng in rRange:
                redWords = rng.split(None)
                self.redletter += len(redWords)
                
        if '<a hr' in line:
            line = re.sub(r'<s href="bible://[^>]+>(.+?)</s>', r'', line)
            line = re.sub(r'(<a href="embNote.+?">)(.+?)</a>', r'', line)
        
        line = re.sub(r'<fnc?>.+?</fnc?>|<.*?>', '', line)
        
        self.verses += 1
        lineQuestions = line.count('?')
        lineSentences = line.count('.') + line.count('!') + lineQuestions
        
        lineComma = line.count(',')
        self.comma += lineComma
        lineColon = line.count(':')
        self.colon += lineColon
        lineSemi = line.count(';')
        self.semi += lineSemi
        lineParenth = line.count('(') + line.count(')')
        self.parenth += lineParenth
        
        linePunct =  lineComma + lineColon + lineSemi + lineParenth + lineSentences
        self.questions += lineQuestions
        self.sentences += lineSentences
        self.punct += linePunct
        tempwords = line.split(None)
        self.words += len(tempwords)
        #letters += len( [c for c in line if re.match('[A-Za-z]', c)])
        
        line = line.replace(' ', '')
        line = line.replace('\n', '')
        self.letters += len(line) - linePunct - line.count('\'')
        
        
        
    def DoStats(self, idxList, fileList, rangeStr, fface):
        self.mainApp = wx.GetApp().GetTopWindow()
        
        total = len(fileList)
                
        final = []
                
        for fName in fileList:
            if fName in self.mainApp.strongsList:
                total -= 1
                continue
                        
            self.words, self.verses, self.sentences, self.letters, self.questions, self.punct, self.italics, self.redletter = 0, 0, 0, 0, 0, 0, 0, 0
            self.chapTemp, self.chapters, self.comma, self.colon, self.semi, self.parenth = 0, 0, 0, 0, 0, 0
            self.bookTemp = ''
            
            con = sqlite.connect(fName)
            con.text_factory = str
            cur = con.cursor() 
            
            cur.execute('SELECT * FROM title',)
            titleRow = cur.fetchone()
            title = titleRow[0]

            selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
            if len(idxList) > 1:
                for rng in idxList[1:]:
                    selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
            
            
            cur.execute(selectStr)
            rows = cur.fetchall()
                
            for row in rows:
                row = utility.CheckEncryptByHeader(row)        
                
                line = '%s\t%s' % (row[1], row[2])
                self.processLine(line, fName)    

            if self.chapters == 0:
                self.chapters = 1

            result = '''<tr><td><b>%s</b></td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></b></tr>'''
            final.append(result % (title, self.chapters, self.verses, self.sentences, self.words, self.letters, self.questions, self.comma, self.semi, self.colon, self.parenth, self.italics, self.redletter))
        
        
        if len(final) != 0:
            match ='''<font face="%s"><b>Statistical Results for,<br><font color="#660000">%s</b></font> (%s texts)<hr><br><br>
                    <table border="1" cellpadding="8" cellspacing="0" width="780"><tbody>
                    <tr><td></td><td><b>Chapters</b></td><td><b>Verses</b></td><td><b>Sentences</b></td><td><b>Words</b></td><td><b>Letters</b></td>
                    <td><b>Questions</b></td><td><b>Commas</b></td><td><b>Semi-Colons</b></td><td><b>Colons</b></td><td><b>Parenthesis</b></td>
                    <td><b>Italics</b></td><td><b>Red Words</b></td></tr>%s</tbody>
                    </table></font>'''
            
            return match % (fface, rangeStr, total, ''.join(final))
        
        else:
            return '<font face="Georgia" size="+1">Syntax Error!<br>\
            <font color="#000066">You must enter a book [Joh], chapter [Joh 3:], or verse [Joh 3:16].</font></font>'
        
    

