
# -*- coding: latin-1 -*-

# This imports the modules we need
import wx, wx.html, os, time
import sqlite3 as sqlite
import wx.media



#The main class is based on a Frame 
class Timing(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, style = wx.DEFAULT_FRAME_STYLE)
        
        #There is a panel on the frame to hold controls
        panel = wx.Panel(self, -1)
        
        self.times = []
        
        self.mc = wx.media.MediaCtrl(self, style=wx.SIMPLE_BORDER, szBackend = wx.media.MEDIABACKEND_WMP10 )
        self.Bind(wx.media.EVT_MEDIA_LOADED, self.doPlay)
        self.Bind(wx.media.EVT_MEDIA_FINISHED, self.Finished)
        
        #The html window and the button are children of the panel
        self.demoWindow = wx.html.HtmlWindow(panel, -1, style = wx.WANTS_CHARS)
        #self.demoWindow2 = wx.html.HtmlWindow(panel, -1, style = wx.WANTS_CHARS)
        
        file = wx.Button(panel, -1, 'File', size=(45, -1))
        start = wx.Button(panel, -1, 'Start', size=(45, -1))
        time = wx.Button(panel, -1, 'Time', size=(65, 30))
        
        self.SetTitle('Html Demo')

        #These sizers position the controls on the page
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        sizer2 = wx.BoxSizer(wx.VERTICAL)
        sizer2.Add(self.demoWindow, 1, wx.EXPAND|wx.ALL, 0)
        #sizer2.Add(self.demoWindow2, 0, wx.EXPAND|wx.ALL, 0)
        sizer2.Add(file, 0, wx.ALIGN_RIGHT|wx.TOP|wx.BOTTOM|wx.RIGHT, 5)
        sizer2.Add(start, 0, wx.ALIGN_RIGHT|wx.TOP|wx.BOTTOM|wx.RIGHT, 5)
        sizer2.Add(time, 0, wx.ALIGN_RIGHT|wx.TOP|wx.BOTTOM|wx.RIGHT, 5)
        panel.SetSizer(sizer2)
        sizer.Add(panel, 1, wx.EXPAND, 0)
        self.SetSizer(sizer)
        self.Layout()
        
        #This binds the event the button produces to the frame (self)
        self.Bind(wx.EVT_BUTTON, self.getFile, file)
        self.Bind(wx.EVT_BUTTON, self.Play, start)
        self.Bind(wx.EVT_BUTTON, self.OnGo, time)
        
        #This sets the initial text on the htmlWindow

    def getFile(self, event):
        self.times = []
        
        fName = "./Modules/Bible/av1769.bib"
        self.ref = '1Jo 3:'
        self.cyc = 1
        
        dlg = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=os.getcwd(), 
            defaultFile="",
            wildcard="",
            style=wx.OPEN | wx.CHANGE_DIR
            )

        # Show the dialog and retrieve the user response. If it is the OK response, 
        # process the data.
        if dlg.ShowModal() == wx.ID_OK:
            # This returns a Python list of files that were selected.
            self.path = dlg.GetPath()
        
        selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % self.ref
        con = sqlite.connect(fName)
        cur = con.cursor()
        cur.execute(selStr)
        
        tmp = []
        self.rows = cur.fetchall()
        for row in self.rows:
            line = row[2]
            tmp.append(line)
            
        self.demoWindow.SetPage('<br><br>'.join(tmp))
        
        print self.path
        
    def Play(self, event):
        print 'in load'
        self.mc.Load(self.path)
        #self.timer = wx.CallLater(self.fixedTimes[0], self.OnTimer)
        
    def doPlay(self, event):
        self.mc.Play()
        self.startTime = time.time()
        
    #The function called by the button event    
    def OnGo(self, event):
        clickTime = time.time() - self.startTime
        clickTime = int(clickTime *1000)
        self.times.append('%s%s\t%s' % (self.ref, self.cyc, str(clickTime)))
        
        print '%s%s\t%s' % (self.ref, self.cyc, str(clickTime))
        self.cyc += 1

    def Finished(self, event):
        out = file('1Jo 3.txt', 'w')
        out.write('\n'.join(self.times))
        out.close()

#The App class that calls and instance of the HtmlDemo class and actually shows it
class MyApp(wx.App):
    def OnInit(self):
        wx.InitAllImageHandlers()
        Demo = Timing(None)
        self.SetTopWindow(Demo)
        Demo.Show()
        return 1

# Loads the App class
if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()