# -*- coding: utf-8 -*-
import re


def r2h(txt, bib = 0):
    if bib:
        c2 = re.compile(r'{\\cf6 ([^}]+)}', re.I)
        c3 = re.compile(r'{\\cf11\\super [HG](\d+)}', re.I)
        c3b = re.compile(r'{\\cf11\\super [HG](\d+) \[[HG](\d+)\]}', re.I)
        
        txt = c3.sub(r'[\1]', txt) # Strongs' numbers
        txt = c3b.sub(r'[\1] [\2]', txt) # Strongs' numbers               
        txt = c2.sub(r'<r>\1</r>', txt) # Red letters

    b1 = re.compile(r'{\\b ?(.+)?}', re.I)    
    txt = b1.sub(r'<b>\1</b>', txt)

    i1 = re.compile(r'{\\i ?(.+)?}', re.I)    
    txt = i1.sub(r'<i>\1</i>', txt)
    
    #ref = re.compile(r'[{(]\\cf\d+\\ul (\w\w\w_.+?)[)}]', re.I)
    #txt = ref.sub(r'<u>\1</u>', txt)

    txt = re.sub(r'} *$', r'', txt)
    txt = re.sub(r'{.+?}}?', r'', txt)
    txt = re.sub(r'[{}]', r'', txt)
    
    c3 = re.compile(r'\\qc(.+?)\\pard', re.S|re.M)
    txt = c3.sub(r'<div align="center"><b>\1</b></div>', txt)
    
    txt = re.sub(r'\\fs4\d ?', r'</font><font size="+3">', txt)
    txt = re.sub(r'\\fs3\d ?', r'</font><font size="+2">', txt)
    txt = re.sub(r'\\fs2\d ?', r'</font>', txt)
    
    txt = re.sub(r"\\li7\d\d ?(.+?)\\pard ?", r"<ind>\1</ind>", txt)
    txt = re.sub(r"\\li10\d\d ?(.+?)\\pard ?", r"<ind><ind>\1</ind></ind>", txt)

    txt = re.sub(r'\\pard', r'', txt)
    txt = re.sub(r'\\par ?', r'</p><p>', txt)
    txt = re.sub(r'\\line ?', r'<br>', txt)
    #txt = re.sub(r'\\b1?([ \\].+?)(\\plain|\\b0) ?', r'<b>\1</b>', txt)
    #txt = re.sub(r'\\i1?([ \\].+?)(\\plain|\\i0) ?', r'<i>\1</i>', txt)
    
    # Convert refs
    txt = re.sub(r'(\w\w\w_\d+:\d+(?:-\d+)?)', r'<u>\1</u>', txt)
    
    txt = re.sub(ur'\\emdash ?', ur"—", txt)
    txt = re.sub(ur"\\'97", ur"—", txt)
    txt = re.sub(r"\\tab ?", r"&nbsp;", txt)
    
    txt = re.sub(r'\\[lr]dblquote ?', r'"', txt)
    txt = re.sub(r'\\rquote ?', r"'", txt)
    
    txt = re.sub(ur'\\[^\\ —<&]+ ?', r'', txt)
    
    txt = re.sub(r'  +', r' ', txt)

    return txt
