import os, wx, urllib2, stat
import version

# Version must be 0.0.0.0 format with no more than two digits for the "mini".

def CalcVer(ver_str="0.0.0.0"):
    verList = ver_str.split(u".")

    major = float(verList[0]) * 10000
    minor = float(verList[1]) * 1000
    micro = float(verList[2]) * 100

    if len(verList[3]) < 2:
        verList[3] += u'0'
    
    mini = float(verList[3])
    
    #print major,minor,micro,mini, 'raw version'
    #print major + minor + micro + mini, 'version'
    return major + minor + micro + mini


def GetPageText():
    version = u'dud '
    fName = ''
    try:
        verFile = urllib2.urlopen('http://www.bibleanalyzer.com/version.php')
        text = verFile.readlines()
        verFile.close()
        version = text[0]
        fName = text[1]
    finally:
        return version[:-1], fName


def UpdateCheck():
    mainApp = wx.GetApp().GetTopWindow()
    verTxt, verUrl = GetPageText()
    if verTxt == 'dud':
        txt = 'Unable to retrieve online version information.  '
        dlg = wx.MessageDialog(mainApp, txt, 'Update Check Error', wx.OK | wx.ICON_INFORMATION	)
        dlg.ShowModal()
        dlg.Destroy()       
        
    elif CalcVer(verTxt) > CalcVer(version.version):
        txt = 'Version %s update is available.\n' % verTxt
        txt = txt + 'Press "Yes" to download the update or "No" to cancel.  '
        dlg = wx.MessageDialog(mainApp, txt, '%s Update Available' % verTxt, wx.YES_NO | wx.ICON_QUESTION)
    
        if dlg.ShowModal() == wx.ID_YES:
            DoDownload(verUrl, verTxt)
        dlg.Destroy()       
     
    else:
        txt = 'You have the latest version, %s.  ' % verTxt
        dlg = wx.MessageDialog(mainApp, txt, 'No Update Available', wx.OK | wx.ICON_INFORMATION	)
        dlg.ShowModal()
        dlg.Destroy()       


def DoDownload(dlUrl, verTxt):
    mainApp = wx.GetApp().GetTopWindow()
    
    dlLocation = wx.GetHomeDir() + os.sep
    if os.path.exists(dlLocation + u"Desktop"):
        dlLocation = dlLocation + u"Desktop" + os.sep
    
    abort = False
    
    dlFile = dlUrl.split('/')[-1]
    dlLocation = dlLocation + dlFile
    blockSize = 4096
    read = 0
    try:
        webFile = urllib2.urlopen(dlUrl)
        fSize = int(webFile.info()['Content-Length'])
        localFile = open(dlLocation, 'wb')
        
        txt = '%s will be downloaded to your desktop.' % dlFile
        dlg = wx.ProgressDialog('Downloading Bible Analyzer %s Update' % verTxt, txt, maximum = fSize, \
        style = wx.PD_CAN_ABORT|wx.PD_REMAINING_TIME|wx.PD_AUTO_HIDE  )
        
        # Download the file in chunks so it can be aborted if need be between reads.
        while read < fSize and not abort:
            localFile.write(webFile.read(blockSize))
            read += blockSize
            if read > fSize:
                read = fSize
            if dlg.Update(read)[0] == False:
                abort = True

        localFile.close()
        webFile.close()
        dlg.Destroy()
    
    finally:
        if os.path.exists(dlLocation) and os.stat(dlLocation)[stat.ST_SIZE] == fSize:
            txt = 'Download was Sucessfull to your Desktop\nTo install, close Bible Analyzer and run the update.  '
            dlg = wx.MessageDialog(mainApp, txt, 'Download Sucessfull', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()       
        else:
            if os.path.exists(dlLocation):
                os.remove(dlLocation)
            txt = 'Download was cancelled or otherwise failed. Run "Check for Update" to try again.  '
            dlg = wx.MessageDialog(mainApp, txt, 'Download Failed', wx.OK | wx.ICON_INFORMATION	)
            dlg.ShowModal()
            dlg.Destroy()       

