 # -*- coding: utf-8 -*-

import wx, os, time, random, sys, re, zlib, time
from configobj import ConfigObj
import optionsDlg, mainImg, popup, fixRef
import wx.richtext as rt
import normSearch, dialogs
#import winpaths


import sqlite3 as sqlite


class CheckWinState():
    def __init__(self):
        self.mainApp = wx.GetApp().GetTopWindow()

    def CheckState(self):
        resPane = self.mainApp.getResPane()
        
        if resPane.IsClosed():
            resPane.Right().Layer(1).Show().NotClosed()

        if self.mainApp.getMaximized():# and self.mainApp.jumpState == True:
            #print 'is max'
            win = self.mainApp.getMaximized()
            if win.IsNotebookControl():
                if resPane.IsNotebookPage() and resPane.window.GetParent() == win.window:
                    win.window.SetSelectionToWindow(resPane.window)
                else:
                    #self.mainApp.mainMgr.RestoreMaximizedPane()
                    self.mainApp.mainMgr.MaximizePane(resPane)
                
            elif resPane.IsNotebookPage():
                nb = self.mainApp.mainMgr.GetNotebooks()[0]
                nbInfo = self.mainApp.mainMgr.GetPane(nb)
                self.mainApp.mainMgr.RestoreMaximizedPane()
                #self.mainApp.mainMgr.MaximizePane(nbInfo)
                for idx in range(nb.GetPageCount()):
                    if nb.GetPageText(idx) == 'Results':
                        nb.SetSelection(idx)
            else:    
                self.mainApp.mainMgr.RestoreMaximizedPane()
                #self.mainApp.mainMgr.MaximizePane(resPane)
        
        elif resPane.IsNotebookPage() and self.mainApp.mainMgr.GetPane('__notebook_0').IsClosed():
            self.mainApp.mainMgr.GetPaneByName('__notebook_0').NotClosed().Restore().Show()
        
        elif resPane.IsNotebookPage():
            #print 'is nb page'
            nb = resPane.window.GetParent()
            nb.SetSelectionToWindow(resPane.window)
        
        self.mainApp.Freeze()
        self.mainApp.mainMgr.Update()
        self.mainApp.Thaw()
        
            
    def CheckBiblePane(self):
        bibPane = self.mainApp.getBibPane()
        self.mainApp.mainMgr.MaximizePane(bibPane)
        self.mainApp.mainMgr.Update()


## Theme Index Functions

class ThemeIndex():
    def __init__(self):
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = CheckWinState()

    def GetThemes(self):
        themeList = []
        
        txt = '<p align="center"><i>Dictionary of Bible Themes</i></p>'
        
        if self.mainApp.themeIdx != None:
            pth = self.mainApp.dctFileList[self.mainApp.themeIdx]
        else:
            page = '<body bgcolor="%s"><font face="Verdana"><p>This feature requires the <i>Dictionary of Bible Themes</i> module.\
            With this premium module every Bible verse is linked to any relevent theme.</p>\
            <p>For more information click to visit the Bible Analyzer \
            <a href="http://www.BibleAnalyzer.com/themes.html">Dictionary of Bible Themes Page</a>\
            or view this <a href="http://www.youtube.com/watch?v=eCpiNwjx7Yw">Youtube video.</a></font></p>' % '#E6EEF0'
            self.mainApp.themeWin.SetPage(page)
            return
        
        con = sqlite.connect(pth)
        cur = con.cursor()
        
        selStr = 'SELECT * FROM themeindex WHERE ref LIKE ?'
        selRef = self.mainApp.currentChap +'%'
        
        isVs = True
        ref = self.mainApp.currentRef
        vsCk = re.search(r':(\d+)$', ref)
        if vsCk:
            currVs = vsCk.group(1)
        else:
            chCk = re.search(r':$', ref)
            if not chCk:
                page = '<body bgcolor="%s"><font face="Verdana"><center><p>Select a verse or chapter to display themes\
                (click on a verse in the Bible window).</p>\
                <p>If the current reference is an entire book (i.e. "Gen"), there are too many themes to display.</p>' % '#E6EEF0'
                self.mainApp.themeWin.SetPage(page)
                return
            else:
                isVs = False
            
        cur.execute(selStr, (selRef,))
        rows = cur.fetchall()

        cnt = 0
        for row in rows:
            if not isVs:
                ln = '<b>%s</b><br>%s' % (row[1], row[2])
                themeList.append(ln)
                cnt += 1
                
            elif re.search(r'%s$' % self.mainApp.currentRef, row[1]):
                ln = '<b>%s</b><br>%s' % (row[1], row[2])
                themeList.append(ln)
                cnt += 1
            
            elif '-' in row[1] and isVs:
                prs = re.search(r'(\d+)-(\d+)', row[1])
                if not prs:
                    continue
                prs = prs.groups()
                if int(prs[0]) <= int(currVs) <= int(prs[1]):
                    ln = '<b>%s</b><br>%s' % (row[1], row[2])
                    themeList.append(ln)
                    cnt += 1
                    
        themes = '<br><br>'.join(themeList)
        tCnt = themes.count('</a>')

        page = u'<body bgcolor="#E6EEF0" link="#336666"><font face="Verdana"><p align="center"><font color="brown">\
        <i>Dictionary of Bible Themes</i></font><br><table><tr></tr></table>%s Themes — %s Ranges<br><b>%s</b></p><hr>%s<hr><div align="center">© 2009, Martin Manser</div></font>'\
        % (tCnt, cnt, self.mainApp.currentRef, themes)
        
        if self.mainApp.fontSize > 0:
            page = '<font size="+%s">%s</font>' % (self.mainApp.fontSize -1, page)
        else:
            page = '<font size="-1">%s</font>' % page
        self.mainApp.themeWin.SetPage(page)


## Reference Index Functions

class RefIndex():
    def __init__(self):
        self.mainApp = wx.GetApp().GetTopWindow()
        self.CheckWinState = CheckWinState()
        self.sets = {}
        
                   

    def getRefs(self, id, topic, ln):
        tmpKeys = []
        links = re.findall(r'<a href="bible://(.+?)">', ln)
        if not links:
            links = re.findall(r'<u>(\w\w\w_\d+:\d+(?:-\d+)?)</u>', ln)
            links = [l.replace('_', ' ') for l in links]
        if links:
            for lnk in links:
                if lnk.endswith(':'):
                    continue
                if not lnk in self.sets:
                    self.sets[lnk] = []
                dlst = self.sets.get(lnk)
                if not id in dlst:
                    dlst.append(id)
                self.sets[lnk] = dlst
                        

    def doRefIndex(self, fn, selStr):
        print fn, 'Building Ref Index Table'

        verses = []
        lines = []

        con = sqlite.connect(fn)
        con.text_factory = str
        cur = con.cursor()
        cur.execute(selStr)

        for id, row in enumerate(cur):
            self.getRefs(id, row[1], row[2])
        
        for k, v in self.sets.items():
            verses.append(k)
            lines.append(v)
            
        cur.execute("DROP TABLE IF EXISTS refindex")
        cur.execute("create table refindex(id INTEGER PRIMARY KEY, topic, line)")

        for id, ln in enumerate(verses):
            try:
                cur.execute('insert into refindex values (null, ?, ?)', (ln, repr(lines[id]),))
            except OperationalError:
                dialogs.noWriteIdx(self.mainApp)
                return
        
        try:
            cur.execute("create INDEX refidx ON refindex (topic)")
        except OperationalError:
            dialogs.noWriteIdx(self.mainApp)
            return

        con.commit()
        self.sets = {}


    def GetModRefs(self):
        dlg = wx.ProgressDialog('Creating Library Reference Indexes', 'This is just to make the dialog bigger', maximum = len(self.mainApp.initMods.needRefIdx), \
        style = wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_REMAINING_TIME|wx.STAY_ON_TOP)
        cnt = 1
        for pth in self.mainApp.initMods.needRefIdx:
            head, tail = os.path.split(pth)
            base, ext = os.path.splitext(tail)
            dlg.Update(cnt, 'Creating %s reference index' % base)

            if pth.endswith('.dct'):
                selStr = 'SELECT * FROM dictionary'
                self.doRefIndex(pth, selStr)
            elif pth.endswith('.cmt'):
                selStr = 'SELECT * FROM commentary'
                self.doRefIndex(pth, selStr)
            elif pth.endswith('.bk'):
                selStr = 'SELECT * FROM book'
                self.doRefIndex(pth, selStr)
            cnt += 1
        dlg.Destroy()
        


    def GetVerseIndexes(self):
        start = time.time()
        
        titleLst = []
        topicLst = []
        
        #self.mainApp.bibMgr.GetPane('Ref Panel').Caption(' Library Index - %s' % self.mainApp.currentRef)
        #self.mainApp.refNB.refPanel.Show()
        #self.mainApp.refNB.Layout()
        #self.mainApp.bibMgr.Update()
        
        vsCk = re.search(r':(\d+)$', self.mainApp.currentRef)
        if not vsCk:
            self.mainApp.refTree.DeleteChildren(self.mainApp.refTreeRoot)
            self.mainApp.refTree.AppendItem(self.mainApp.refTreeRoot, 'No Hits')
            return
        
        selStr = 'SELECT * FROM refindex WHERE topic =?'
        selRef = self.mainApp.currentRef
        if self.mainApp.refNB.refPanel.spRef.GetValue() == True:
            selStr = 'SELECT * FROM refindex WHERE topic LIKE ?'
            selRef = self.mainApp.currentChap +'%'
        
        currVs = vsCk.group(1)
                
        if self.mainApp.showRefHits[0]:
            for id, pth in enumerate(self.mainApp.dctFileList):
                title = self.mainApp.dAbbrList[id]
                con = sqlite.connect(pth)
                #con.text_factory = str
                cur = con.cursor()
                
                cur.execute(selStr, (selRef,))
                #cur.execute('SELECT * FROM refindex WHERE topic LIKE ?', (self.mainApp.currentChap +'%',))
                
                rows = cur.fetchall()
                if rows:
                    tmpList = []
                    hit = 0
                    for row in rows:
                        topicList = eval(row[2])
                        if re.search(r'%s$' % self.mainApp.currentRef, row[1]):
                            if not hit:
                                titleLst.append((title, pth))
                                hit = 1
                            for idx in topicList:
                                cur.execute('SELECT topic FROM dictionary where id=?', (idx +1,))
                                tRow = cur.fetchone()
                                tmpList.append(tRow[0])
                        
                        elif '-' in row[1] and self.mainApp.refNB.refPanel.spRef.GetValue() == True:
                            prs = re.search(r'(\d+)-(\d+)', row[1])
                            if not prs:
                                continue
                            prs = prs.groups()
                            if int(prs[0]) <= int(currVs) <= int(prs[1]) and int(prs[1]) - int(prs[0]) <= 5:
                                if not hit:
                                    titleLst.append((title, pth))
                                    hit = 1
                                for idx in topicList:
                                    cur.execute('SELECT topic FROM dictionary where id=?', (idx +1,))
                                    tRow = cur.fetchone()
                                    tmpList.append(tRow[0])
                    if tmpList:
                        topicLst.append(tmpList)
                
                
        if self.mainApp.showRefHits[1]:
            for id, pth in enumerate(self.mainApp.cmtFileList):
                if pth.endswith('tske.cmt'):
                    continue

                title = self.mainApp.cAbbrList[id]
                con = sqlite.connect(pth)
                cur = con.cursor()
                
                cur.execute(selStr, (selRef,))                
                
                rows = cur.fetchall()
                if rows:
                    tmpList = []
                    hit = 0
                    for row in rows:
                        topicList = eval(row[2])
                        if re.search(r'%s$' % self.mainApp.currentRef, row[1]):
                            if not hit:
                                titleLst.append((title, pth))
                                hit = 1
                            for idx in topicList:
                                cur.execute('SELECT ref FROM commentary where id=?', (idx +1,))
                                tRow = cur.fetchone()
                                tmpList.append(tRow[0])
                        
                        elif '-' in row[1] and self.mainApp.refNB.refPanel.spRef.GetValue() == True:
                            prs = re.search(r'(\d+)-(\d+)', row[1])
                            if not prs:
                                continue
                            prs = prs.groups()
                            if int(prs[0]) <= int(currVs) <= int(prs[1]) and int(prs[1]) - int(prs[0]) <= 5:
                                if not hit:
                                    titleLst.append((title, pth))
                                    hit = 1
                                for idx in topicList:
                                    cur.execute('SELECT ref FROM commentary where id=?', (idx +1,))
                                    tRow = cur.fetchone()
                                    tmpList.append(tRow[0])
                    if tmpList:
                        topicLst.append(tmpList)
        
        if self.mainApp.showRefHits[2]:
            for grp in (self.mainApp.bkData):
                title = grp[1]
                pth = grp[2]
                con = sqlite.connect(pth)
                cur = con.cursor()
                
                cur.execute(selStr, (selRef,))                
                
                rows = cur.fetchall()
                if rows:
                    tmpList = []
                    hit = 0
                    for row in rows:
                        topicList = eval(row[2])
                        if re.search(r'%s$' % self.mainApp.currentRef, row[1]):
                            if not hit:
                                titleLst.append((title, pth))
                                hit = 1
                            for idx in topicList:
                                cur.execute('SELECT chapter FROM book where id=?', (idx +1,))
                                tRow = cur.fetchone()
                                tmpList.append(tRow[0])
                        
                        elif '-' in row[1] and self.mainApp.refNB.refPanel.spRef.GetValue() == True:
                            prs = re.search(r'(\d+)-(\d+)', row[1])
                            if not prs:
                                continue
                            prs = prs.groups()
                            if int(prs[0]) <= int(currVs) <= int(prs[1]) and int(prs[1]) - int(prs[0]) <= 5:
                                if not hit:
                                    titleLst.append((title, pth))
                                    hit = 1
                                for idx in topicList:
                                    cur.execute('SELECT chapter FROM book where id=?', (idx +1,))
                                    tRow = cur.fetchone()
                                    tmpList.append(tRow[0])
                    if tmpList:
                        topicLst.append(tmpList)
        
        print time.time() - start, 'Index Retrieval Time'
        self.buildIdxTree(titleLst, topicLst)



    def buildIdxTree(self, txtList, result):
        self.mainApp.refNB.Freeze()
        self.mainApp.refTree.DeleteChildren(self.mainApp.refTreeRoot)
        
        idx = 0
        while idx < len(result):
            cnt = len(result[idx])
            title = txtList[idx][0] + ', (%s)' % cnt
            pth = txtList[idx][1]
            child = self.mainApp.refTree.AppendItem(self.mainApp.refTreeRoot, title)
            
            if pth.endswith('.dct'):
                self.mainApp.refTree.SetItemTextColour(child, wx.Colour(0, 80, 0))
                self.mainApp.refTree.SetPyData(child, pth)
                
            elif pth.endswith('.cmt'):
                self.mainApp.refTree.SetItemTextColour(child, wx.Colour(0, 0, 130))
                self.mainApp.refTree.SetPyData(child, pth)
                
                #fIdx = self.mainApp.cmtFileList.index(pth) +1
                #if fIdx in self.mainApp.cmtFlagList:
                #    self.mainApp.refTree.SetItemBackgroundColour(child, wx.Colour(255, 255, 200))
            
            elif pth.endswith('.bk'):
                self.mainApp.refTree.SetItemTextColour(child, wx.Colour(80, 0, 0))
                self.mainApp.refTree.SetPyData(child, pth)
                
            if self.mainApp.fontSize == 1:
                font = wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD)
                self.mainApp.refTree.SetItemFont(child, font)
            elif self.mainApp.fontSize > 1:
                font = wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD)
                self.mainApp.refTree.SetItemFont(child, font)

            self.mainApp.refTree.SetItemBold(child, True)
            
                
            cyc = 0
            while cyc < len(result[idx]):
                entry = '%s' % result[idx][cyc]
                gdChild = self.mainApp.refTree.AppendItem(child, entry)
                self.mainApp.refTree.SetPyData(gdChild, pth)
                cyc += 1
            idx += 1
            
        self.mainApp.refNB.Thaw()


    def CallRefTreeMotion(self, event):
        event.Skip()
        #wx.CallLater(500, self.OnRefTreeMotion, event)
        #if not wx.GetKeyState(wx.WXK_CONTROL):
        #    return
        self.OnRefTreeMotion(event)


    def OnRefTreeMotion(self, event):
        event.Skip()
        
        fixBk = fixRef.fullTitle(self.mainApp.currentRef[:3])
        cRefFull = fixBk + self.mainApp.currentRef[3:]
        
        def replaceSpace(mo):
            return mo.group(1).replace(' ', '_')
        
        fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Cmt)</font><br>&nbsp;Comments on  
        <font color="brown"><b>%s</b></font></td></tr></table>
        <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 

        x, y = wx.GetMousePosition()
        
        item, flags = self.mainApp.refTree.HitTest(event.GetPosition())
        #print item, flags
        
        if flags & wx.TREE_HITTEST_ONITEMLABEL and self.mainApp.refTree.GetItemParent(item) == self.mainApp.refTreeRoot and self.mainApp.refTree.GetPyData(item):
            label = re.search(r'^(.+), \(\d+\)', self.mainApp.refTree.GetItemText(item)).group(1)
            pth = self.mainApp.refTree.GetPyData(item)
            
            if self.mainApp.refTree.IsExpanded(item):
                self.mainApp.popupCheck()
                return
            
            if pth.endswith('.cmt'):
                desc = self.mainApp.cDescList[self.mainApp.cmtFileList.index(pth)]
                
                '''
                if self.mainApp.refTree.GetItemBackgroundColour(item) == wx.Colour(255, 255, 200):
                    line = self.mainApp.GetVsInCmtRange(label, self.mainApp.currentRef)
                               
                    grkFont = '<font face="Galaxie Unicode Greek" color="brown">'
                    hebFont = '<font face="Galaxie Unicode Hebrew" color="brown">'
                    
                    line = checkLineTags(line, grkFont, hebFont)
                    line = re.sub(r'<br><br>\n', '', line)
                    line = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', line)
                    
                    line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
                    line = CheckEncoding(line)
                    
                    if len(line) > 800:
                        line = '%s <font color="navy">...<i>cont.</i></font><p><center><i><font color="navy">Click to view entire comment</font></i></center>' % line[:800]
                    
                    fTxt = fTxt % (self.mainApp.popHeadColor, self.mainApp.popFontSize +3, desc, cRefFull, self.mainApp.popFontSize +3, line)
                '''
                #else:
                    
                titleLst = []
                child, cookie = self.mainApp.refTree.GetFirstChild(item)
                while child:
                    titleLst.append(self.mainApp.refTree.GetItemText(child))
                    child, cookie = self.mainApp.refTree.GetNextChild(item, cookie)
                    
                txt = '</i></li><li><i>'.join(titleLst)
                
                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Cmt)<br>&nbsp;Comments with reference to <font color="brown"><b>%s</b></font></font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s"><ul><li><i>%s</i></li></ul>\
                <table cellpadding="1"><td><tr></tr></td></table>\
                <div align="center"><font color="navy"><i>Double-click to select topic</i></font></font></div>'''
                
                fTxt = fTxt % (self.mainApp.popColorMac, self.mainApp.popHeadColor, self.mainApp.popFontSize +2, desc, cRefFull, self.mainApp.popFontSize +2, txt)
            
            elif pth.endswith('.dct'):
                desc = self.mainApp.dDescList[self.mainApp.dctFileList.index(pth)]
                titleLst = []
                child, cookie = self.mainApp.refTree.GetFirstChild(item)
                while child:
                    titleLst.append(self.mainApp.refTree.GetItemText(child))
                    child, cookie = self.mainApp.refTree.GetNextChild(item, cookie)
                    
                txt = '</i></li><li><i>'.join(titleLst)

                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Dct)<br>&nbsp;Topics with reference to <font color="brown"><b>%s</b></font></font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s"><ul><li><i>%s</i></li></ul>\
                <table cellpadding="1"><td><tr></tr></td></table>\
                <div align="center"><font color="navy"><i>Double-click to select topic</i></font></font></div>'''
                
                fTxt = fTxt % (self.mainApp.popColorMac, self.mainApp.popHeadColor, self.mainApp.popFontSize +2, desc, cRefFull, self.mainApp.popFontSize +2, txt)

            elif pth.endswith('.bk'):
                titleLst = []
                child, cookie = self.mainApp.refTree.GetFirstChild(item)
                while child:
                    titleLst.append(self.mainApp.refTree.GetItemText(child))
                    child, cookie = self.mainApp.refTree.GetNextChild(item, cookie)
                    
                txt = '</i></li><li><i>'.join(titleLst)
                
                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Bk)<br>&nbsp;Chapters with reference to <font color="brown"><b>%s</b></font></font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s"><ul><li><i>%s</i></li></ul>\
                <table cellpadding="1"><td><tr></tr></td></table>\
                <div align="center"><font color="navy"><i>Double-click to select topic</i></font></font></div>'''
                               
                fTxt = fTxt % (self.mainApp.popColorMac, self.mainApp.popHeadColor, self.mainApp.popFontSize +2, label, cRefFull, self.mainApp.popFontSize +2, txt)


            if fTxt == self.mainApp.popRef:
                return
            else:
                self.mainApp.popupCheck()
                self.mainApp.popRef = fTxt

                self.mainApp.toolwin = popup.HtmlPopup(self.mainApp, fTxt, self.mainApp.popColorIdx, self.mainApp.popFontSize, 0, 1)
                time.sleep(.2)
                self.mainApp.ShowPopup(x, y)


        elif flags & wx.TREE_HITTEST_ONITEMLABEL and self.mainApp.refTree.GetPyData(item):
            label = self.mainApp.refTree.GetItemText(item)
            parentLabel = self.mainApp.refTree.GetItemText(self.mainApp.refTree.GetItemParent(item))
            parentLabel = re.search(r'^(.+), \(\d+\)', parentLabel).group(1)
            fullLabel = '%s / %s' % (parentLabel, label)

            pth = self.mainApp.refTree.GetPyData(item)
            
            con = sqlite.connect(pth)
            con.text_factory = str
            cur = con.cursor()
            
            if pth.endswith('.dct'):
                cur.execute('SELECT definition FROM dictionary where topic =?', (label,))
                typeTxt = 'Dct'
            elif pth.endswith('.cmt'):
                cur.execute('SELECT comment FROM commentary where ref =?', (label,))
                typeTxt = 'Cmt'
            elif pth.endswith('.bk'):
                cur.execute('SELECT text FROM book where chapter =?', (label,))
                typeTxt = 'Book'
            
            row = cur.fetchone()
            
            grkFont = '<font face="GU Greek" color="brown">'
            hebFont = '<font face="GU Hebrew" color="brown">'
            
            line = CheckEncoding(row[0])
            line = checkLineTags(line, grkFont, hebFont)
            
            line = re.sub(r'(<a href="bible://(%s(.*?))">)(.+?)</a>' % self.mainApp.currentChap, self.makeBold, line)
            
            line = re.sub(r'(\w) (\d+:\d+)', r'\1_\2', line)
            line = re.sub(r'(<.+?>)', replaceSpace, line)
            line = line.replace('<a', ' <a')
            line = re.sub(r'  +', ' ', line)
            
            #print line
            
            spl = line.split()
            
            if len(spl) > 35:
                for i, grp in enumerate(spl):
                    if grp.startswith('<a_name'):
                        if i < 16:
                            line = ' '.join(spl[:i+20])
                        else:
                            line = ' '.join(spl[i-15:i+20])
                        break

            pre = '... '
            #pre = ''
            if line.startswith('<p>'):
                line = line[3:]
                #line = re.sub(r'<p.+?>', '', line)

            if line.startswith('<p'):
                pre = ''

            line = re.sub(r'</p> *$|<br><br> *$|<br> *$', '', line)
            
            line = '%s%s <font color="navy">...<i>cont.</i></font>\
            <table cellpadding="1"><td><tr></tr></td></table>\
            <div align="center"><font color="navy"><i>Click to view entire text</i></font></div>' % (pre, line.replace('_',  ' '))
            
            line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
            #print line.encode('utf-8')

            fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
            <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (%s)<br>&nbsp;
            <font color="brown"><b>%s</b></font> (First Hit)</font></td></tr></table>
            <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 
            
            fTxt = fTxt % (self.mainApp.popColorMac, self.mainApp.popHeadColor, self.mainApp.popFontSize +2, fullLabel, typeTxt, cRefFull, self.mainApp.popFontSize +2, line)
            
            if fTxt == self.mainApp.popRef:
                return
            else:
                self.mainApp.popupCheck()
                self.mainApp.popRef = fTxt

                self.mainApp.toolwin = popup.HtmlPopup(self.mainApp, fTxt, self.mainApp.popColorIdx, self.mainApp.popFontSize, 0, 1)
                time.sleep(.2)
                self.mainApp.ShowPopup(x, y)
        
        else:
            #print 'in else'
            self.mainApp.popupCheck()


    def makeBold(self, mo):
        if mo.group(2) == self.mainApp.currentRef:
            return  '<a name="line">%s<font color="#E44B00"><b>%s</b></font></a>' % (mo.group(1), mo.group(4))
        elif '-' in mo.group(3):
            #print mo.group(3)
            currVs = re.search(r':(\d+)$', self.mainApp.currentRef).group(1)
            prs = re.search(r'(\d+) *- *(\d+)', mo.group(3)).groups()
            if int(prs[0]) <= int(currVs) <= int(prs[1]) and int(prs[1]) - int(prs[0]) <= 5:
                return '<a name="line">%s<font color="#E44B00"><b>%s</b></font></a>' % (mo.group(1), mo.group(4))
        else:
            return mo.group(0)


    def OnRefSelChanged(self, event):
        event.Skip()
        
        if self.mainApp.cmtNB.cmtPanel.miniTB.GetToolToggled(716) == True:
            self.mainApp.cmtNB.cmtPanel.miniTB.ToggleTool(716, False)
            
        item = event.GetItem()
        parent = self.mainApp.refTree.GetItemParent(item)
                
        pth = self.mainApp.refTree.GetPyData(item)
        if not pth:
            return
        
        if parent == self.mainApp.refTreeRoot and self.mainApp.refTree.GetItemBackgroundColour(item) != wx.Colour(255, 255, 200):
            return
        
        title = self.mainApp.refTree.GetItemText(item)
        self.mainApp.Freeze()
        
        if pth.endswith('.dct'):
            fList = self.mainApp.dctFileList
            idx = fList.index(pth)
            self.mainApp.dctNB.SetSelection(idx)
            oldCurrentWord = self.mainApp.currentWord
            self.mainApp.currentWord = title
            self.mainApp.OnDctNBChanged(None, True)
            self.mainApp.currentWord = oldCurrentWord
            
            new = re.sub(r'(<a href="bible://(%s(.*?))">)(.+?)</a>' % self.mainApp.currentChap, self.makeBold, self.mainApp.dctCurrent)
            
            self.mainApp.dctDisplay[idx].SetPage(new)
            if '<a name="line">' in new:
                self.mainApp.dctDisplay[idx].ScrollToAnchor('line')
                self.mainApp.dctDisplay[idx].ScrollLines(-2)
        
        elif pth.endswith('.cmt'):
            fList = self.mainApp.cmtFileList
            idx = fList.index(pth)
            self.mainApp.cmtNB.SetSelection(idx +1)
            if parent == self.mainApp.refTreeRoot:
                self.mainApp.OnCmtNBChanged(None, True) 
                self.mainApp.Thaw()
                return

            oldCurrentRef = self.mainApp.currentRef
            self.mainApp.bibWordClick = False
            self.mainApp.currentRef = title
            self.mainApp.OnCmtNBChanged(None, 1)           
            self.mainApp.currentRef = oldCurrentRef

            new = re.sub(r'(<a href="bible://(%s(.*?))">)(.+?)</a>' % self.mainApp.currentChap, self.makeBold, self.mainApp.cmtCurrent)
            
            self.mainApp.cmtDisplay[idx].SetPage(new)
            if '<a name="line">' in new:
                self.mainApp.cmtDisplay[idx].ScrollToAnchor('line')
                self.mainApp.cmtDisplay[idx].ScrollLines(-2)


        elif pth.endswith('.bk'):
            parentTitle = re.sub(r', \(\d+\)$', '', self.mainApp.refTree.GetItemText(parent))
            titleStr = '%s/%s' % (parentTitle, title.replace('"', '[q]'))
            
            if self.mainApp.cpMini == None:
                self.mainApp.OnMasterControlMini(None, 0)
            
            self.mainApp.cpMini.BookViewer.Tree.SelectItem(self.mainApp.cpMini.BookViewer.titles[titleStr])
            
            new = re.sub(r'(<a href="bible://(%s(.*?))">)(.+?)</a>' % self.mainApp.currentChap, self.makeBold, self.mainApp.prePage)
            
            if self.mainApp.showBkWin == 0:
                display = self.mainApp.bookDisplay

            else:
                self.mainApp.OnBkFrame()
                display = self.mainApp.bkWinDisplay
                
                useBkWinTxt = '<center><font color="navy"><b>Books are set in <i>Preferences</i> to display in a separate window.</b></font><br><br>\
                To view book contents again in this window (default),<br>\
                uncheck the <i>Show Books in Separate Window</i> option in Preferences.</center>'
                
                self.mainApp.bookDisplay.SetPage(useBkWinTxt)
                self.mainApp.bkWin.Show()
            
            display.SetPage(new)
            if '<a name="line">' in new:
                display.ScrollToAnchor('line')
                display.ScrollLines(-2)

            #self.CheckWinState.CheckState()
            
        self.mainApp.Thaw()



def checkLineTags(line, grkFont, hebFont):
    line = re.sub(r'<u>(\w\w\w)_([^<]+)</u>', r'<a href="bible://\1 \2">\1 \2</a>', line)
    line = re.sub(r'([GH]\d+)', r'<font color="navy"><u>\1</u></font>', line)
    
    # For old way of tagging Heb/Greek
    if '^^' in line:
        line = re.sub(r'\^\^', '<font face="Galaxie Unicode Hebrew" size="+1" color="brown">', line)
    if '^' in line:
        line = re.sub(r'\^', '<font face="Galaxie Unicode Greek" color="brown">', line)
    if '~' in line:
        line = re.sub(r'~', '</font>', line)
    
    # <cl> Color as a Link
    if 'cl' in line:
        line = re.sub(r'<cl>([^<]+)</cl>', r'<font color="#336666">\1</font>', line)
            
    # Greek/Hebrew font
    if '<g>' in line:
        line = re.sub(r'<g>(.*?)</g>', r'<font face="Greek" color="brown">\1</font>', line)
    if '<h>' in line:
        line = re.sub(r'<h>(.*?)</h>', r'<font face="Hebrew" color="brown">\1</font>', line)
    
    # NET Notes
    # <gu> Greek unicode characters
    # <hu> Hebrew unicode characters
    # <tg> Greek translit characters
    # <th> Hebrew translit characters
    # <gun> Greek Uncial characters
    
    #line = re.sub(r'<gf>(.*?)</gf>', r'<font face="Greek" color="brown">\1</font>', line)
    
    if '<gu>' in line:
        line = re.sub(r'<gu>(.*?)</gu>', r'%s\1</font>' % grkFont, line)
    if '<hu>' in line:
        line = re.sub(r'<hu>(.*?)</hu>', r'%s\1</font>' % hebFont, line)
    if '<th>' in line:
        line = re.sub(r'<th>(.*?)</th>', r'<font face="Scholar">\1</font>', line)
    if '<tg>' in line:
        line = re.sub(r'<tg>(.*?)</tg>', r'<font face="Greektl">\1</font>', line)
    if '<gun>' in line:
        line = re.sub(r'<gun>(.*?)</gun>', r'<font face="Greek Uncials" color="brown">\1</font>', line)
    
    if '<fn>' in line:
        line = re.sub(r'<fn>(\d+)</fn>', r'<font color="brown"><sup>\1</sup></font>', line)
    
    
    if '<tl>' in line:
        line = re.sub(r'<tl>(.*?)</tl>', r'<font color="blue">\1</font>', line) # Transliterated, foriegn, etc. text - Calvin
    if '<fr>' in line:
        line = re.sub(r'<fr>(.*?)</fr>', r'<font color="brown"><sup><b>\1</b></sup></font>', line) # Footnote ref in text - Calvin
    if '<fn>' in line:
        line = re.sub(r'<fn>(.*?)</fn>', r'<font color="brown"><b>(\1)</b></font>', line) # Footnote itself - Calvin

    return line




def CheckOldFont(fName, line, fface):
    mainApp = wx.GetApp().GetTopWindow()
    #print fName, 'fn'
    if fName.endswith('av1611.bib'):
        #print 'fn'
        if '<sc>' in line:
            line = re.sub(r'<sc>(.+?)</sc>', r'<font face="IM FELL English SC">\1</font>', line)
        if '<tn>' in line:
            line = re.sub(r'<tn>(.+?)</tn>', r'<font face="IM FELL English">\1</font>', line)
        if mainApp.useOldFont:
            #print 'fnt'
            fface = "IM FELL English"
    
    return line, fface



def CheckEncoding(txt):
    if isinstance(txt, unicode):
        return txt
    txt = str(txt)
    try:
        txt =  unicode(txt, "utf-8")
    except UnicodeError:
        try:
            txt = unicode(txt, "Latin1")
            #print 'Is Latin1 encoding'
        except UnicodeError:
            txt =  unicode(txt, 'utf-8', 'replace')
            #print 'utf-8 encoding, replace'
    return txt


def CheckApocrypha(cur):
    apocrypha = 0
    cur.execute("SELECT name FROM sqlite_master WHERE name='option'")
    if cur.fetchone():
        cur.execute('SELECT * FROM option')
        row = cur.fetchone()
        if len(row) > 3 and row[3] ==1:
            apocrypha = 1

    return apocrypha


def RemoveApocrypha(cur):
    con1m = sqlite.connect(":memory:")
    cur1m = con1m.cursor()
    cur1m.execute("create table bible(id INTEGER PRIMARY KEY, ref, verse)")
    cur.execute("SELECT * FROM bible WHERE id BETWEEN 0 AND 23145 OR id BETWEEN 28826 AND 36782")
    for row in cur:
        cur1m.execute('insert into bible values (null, ?, ?)', (row[1], row[2],))
    
    return cur1m



## Unencrypt (decompress)
def CheckEncrypt(cur):
    encrypt = 0
    cur.execute("SELECT name FROM sqlite_master WHERE name='option'")
    if cur.fetchone():
        cur.execute('SELECT * FROM option')
        row = cur.fetchone()
        if len(row) > 2 and row[2] ==1:
            encrypt = 1
    
    return encrypt

def CheckEncryptByHeader(row):
    if not row:
        return
    
    vsTxt = row[2]
    if isinstance(row[2], buffer):
        vsTxt = str(row[2])
    
        try:
            vsTxt = zlib.decompress('x\x01' + vsTxt)
        except:
            #print 'decompress error'
            return row
        row = (row[0], row[1], unicode(vsTxt, 'utf-8', 'replace'))
    elif isinstance(row[2], str):
        row = (row[0], unicode(row[1], 'utf-8', 'replace'), unicode(row[2], 'utf-8', 'replace'))
        
    return row


def UnEncryptRows(cur, wList, idxList, anyWord = False):
    
    selectStr = 'SELECT * FROM bible WHERE id BETWEEN %d AND %d' % (idxList[0][0], idxList[0][1])
    if len(idxList) > 1:
        for rng in idxList[1:]:
            selectStr += ' OR id BETWEEN %d AND %d' % (rng[0], rng[1])
           
    cur.execute(selectStr)
    
    wdList = []
    altList = []
    phraseList = []
    
    if wList:
        wdList = [wd.lower() for wd in wList]
        #print wdList, 'wd1'
    
    if wdList:
        for wd in wdList[:]:
            #wd = wd.lower()
            if '|' in wd:
                wdList.remove(wd)
                altGrp = wd.split('|')
                for gp in altGrp:
                    if ' ' in gp:
                        wds = gp.split()
                        altList.append(wds)
                    else:
                        altList.append([gp])
                
                    
            if ' ' in wd:
                if wd in wdList:
                    wdList.remove(wd)
                phraseList.append(wd.split())
                
        #print altList, 'alt'
        #print wdList, 'wd2'
        #print phraseList, 'pl'
    
    hitRows = []
    for row in cur:                  
        vsTxt = zlib.decompress('x\x01' + str(row[2]))
        vsTxt = unicode(vsTxt, 'utf-8', 'replace')
        
        if wdList or altList:
            vTxt = vsTxt.lower()
            if anyWord:
                if any(word in vTxt for word in wdList):
                    unenc = (row[0], CheckEncoding(row[1]), vsTxt)
                    hitRows.append(unenc)
                elif altList:
                    for grp in altList:
                        if any(word in vTxt for word in grp):
                            unenc = (row[0], CheckEncoding(row[1]), vsTxt)
                            hitRows.append(unenc)
                            break
            
            elif all(word in vTxt for word in wdList):
                if altList:
                    for grp in altList:
                        #wds = grp.split()
                        if all(word in vTxt for word in grp):
                            unenc = (row[0], CheckEncoding(row[1]), vsTxt)
                            hitRows.append(unenc)
                            break
                elif phraseList:
                    for grp in phraseList:
                        if all(word in vTxt for word in grp):
                            unenc = (row[0], CheckEncoding(row[1]), vsTxt)
                            hitRows.append(unenc)
                            break
                else:
                    unenc = (row[0], CheckEncoding(row[1]), vsTxt)
                    hitRows.append(unenc)
        
        else:
            unenc = (row[0], CheckEncoding(row[1]), vsTxt)
            hitRows.append(unenc)

    #print len(hitRows), 'hitRows'
    return hitRows
    



## S-Pad Quote and Image
def editorQuote():
    mainApp = wx.GetApp().GetTopWindow()   

        

    editor = mainApp.editor

    
    date = time.strftime("%A, %B %d, %Y")
    
    editor.BeginAlignment(rt.TEXT_ALIGNMENT_CENTRE)
    editor.BeginBold() 
    editor.BeginFontSize(11)
    editor.BeginTextColour((150, 0, 0))

    editor.WriteText("%s" % date)
    editor.EndFontSize()
    editor.EndTextColour()
    editor.EndBold()
    editor.Newline()
    
    editor.BeginTextColour((0, 0, 100))  
    editor.BeginItalic()
    editor.WriteText(quote)
    editor.EndItalic()   
    editor.EndTextColour()
    
    editor.WriteText('(%s)' % author)
    editor.Newline()
    
    editor.EndAlignment()




class ParaBibListDlg(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent, style = wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX )
        self.mainApp = wx.GetApp().GetTopWindow()

        self.wordListLabel = wx.StaticText(self, -1, "Select Parallel Bible Texts")
        self.wordList = wx.CheckListBox(self, -1, wx.DefaultPosition, wx.DefaultSize, [])
        self.doneButton = wx.Button(self, -1, "Done", size=(40, 25))
        
        self.Bind(wx.EVT_BUTTON, self.OnDone, self.doneButton)
        
        self.SetTitle('Parallel Bible Texts')
        self.SetSize((175, 300))
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.wordListLabel, 0, wx.ALIGN_CENTER|wx.TOP, 7)
        sizer.Add(self.wordList, 1, wx.EXPAND|wx.RIGHT|wx.LEFT, 8)
        sizer.Add((-1, 3))
        sizer.Add(self.doneButton, 0, wx.ALIGN_RIGHT|wx.RIGHT, 8)
        sizer.Add((-1, 3))

        self.SetSizer(sizer)
        self.Layout()
        self.Center()

        for num, abbr in enumerate(self.mainApp.bAbbrList):
            self.wordList.Append(abbr)
            if abbr in self.mainApp.paraTextList:
                self.wordList.Check(num)
                
    def OnDone(self, event):
        self.mainApp.paraTextList = []
        cnt = self.wordList.GetCount()
        avTrue = 0
        for num in range(cnt):
            if self.wordList.IsChecked(num):
                abbr = self.mainApp.bAbbrList[num]
                self.mainApp.paraTextList.append(abbr)
                if abbr.startswith('AV'):
                    avTrue = 1
        if not avTrue:
            dialogs.noParallelAV(self.mainApp)
            self.mainApp.paraTextList = self.mainApp.bAbbrList[:]
        
        self.mainApp.OnParallel()
        self.Destroy()
        



## Manage Modules in Options
class Modules(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1)
        
        self.mainApp = wx.GetApp().GetTopWindow()
        
        self.modPanel = wx.ScrolledWindow(self, -1, style=wx.TAB_TRAVERSAL)
        self.headLabel1 = wx.StaticText(self, -1, "The Library Manager has been replaced by\n\
the Session Manager.\n\n\
The Session Manager allows the user to\nconfigure up to five custom module sessions.\n\n\
        Click the button below to open.\n        (also Ctrl+M or Control Menu)")
        butt = wx.Button(self, -1, 'Session Manager')

        self.headLabel1.SetForegroundColour(wx.Colour(142, 35, 35))
        self.modPanel.SetScrollRate(10, 10)

        mainSizer = wx.BoxSizer(wx.VERTICAL)
        
        title = optionsDlg.FMTitlePanel(self, "New Session Manager")
        mainSizer.Add(title, 0, wx.EXPAND | wx.ALL, 2)
        
        self.checkSizer = wx.BoxSizer(wx.VERTICAL)
        mainSizer.Add(self.headLabel1, 0, wx.TOP|wx.ALIGN_CENTER, 5)
        mainSizer.Add(butt, 0, wx.TOP|wx.ALIGN_CENTER, 20)
        
        self.modPanel.SetSizer(self.checkSizer)
        mainSizer.Add(self.modPanel, 1, wx.EXPAND, 0)
        self.SetSizer(mainSizer)
        
        self.Bind(wx.EVT_BUTTON, self.mainApp.OnSessMan, butt)
        

