# -*- coding: utf-8 -*-

import wx, wx.html, baseClass, welcomeTxt

class WelcomeWin(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, size=(600, 450), style=wx.STAY_ON_TOP|wx.DEFAULT_FRAME_STYLE)
        
        self.welcomeWin = baseClass.HtmlWindow(self, -1, style = wx.BORDER_THEME)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.welcomeWin, 1, wx.EXPAND|wx.ALL, 0)
        self.SetSizer(sizer)
        self.SetTitle('Welcome to Bible Analyzer 4!')
        self.Layout()
        self.Centre()
        
        self.welcomeWin.Bind(wx.EVT_CHAR, self.OnClose)
        
        txt = welcomeTxt.txt
        self.welcomeWin.SetPage(txt)
        
        self.Show()
            
    def OnClose(self, event):
        self.Hide()
        self.Destroy()


class MyApp(wx.App):
    def OnInit(self):
        wx.InitAllImageHandlers()
        Demo = WelcomeWin(None)
        Demo.Show()
        return 1

# Loads the App class
if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()
