import time
start = time.time()

import wx, wx.html, re, os, sys, cStringIO, cPickle

import mainMenu
import utility
import baseClass
import version
import update
#import win32help
import dialogs

#print time.time() - start, 'before aui import'

import agw.aui as aui

import flatNotebook as fnb
import miniWin
import advSearch
import normSearch
import editor
import library
import optionsDlg
import popup
import fixRef
import devWin

#print time.time() - start, 'before sess import'

import sessionMan

#print time.time() - start, 'before speech import'

import speech
#import pythoncom
import thread

import imgViewer
import tools.modTools
import mediaMini
import wx.media
import tools.bookConvert
import welcome


import controlMini
import contextMenu
import wx.richtext as rt
import toolImg
import splashImg
from captionImages import *
import sqlite3 as sqlite
import aboutFrm
import parGen
import infoWin
import mainPopup

print time.time() - start, 'imports'


__author__ = "Timothy Morton <morton@bibleanalyzer.com>"
__version__ = version.version
__title__ = "Bible Analyzer"



class BibleAnalyzer(wx.Frame):
    def __init__(self, parent, title):
        wx.Frame.__init__(self, None)
        wx.GetApp().SetTopWindow(self)

        self.SetMinSize((750, 550))
        self.Center()

        self.version = __version__

        #self.config = utility.config
        self.config = sessionMan.config
        self.refIndex = utility.RefIndex()
        self.themeIndex = utility.ThemeIndex()

        self.checkState = utility.CheckWinState()

        self.LoadModules()
        #print time.time() - start, 'mods'

        # For embedded images
        self.memFs = wx.MemoryFSHandler()
        wx.FileSystem_AddHandler(self.memFs)

        # Printer class instance
        self.ePrint = wx.html.HtmlEasyPrinting()
        self.ePrint.SetParentWindow(self)

        # Error reporter
        sys.excepthook = baseClass.ExceptionHook

        # RichTxtCtrl handlers
        self.AddRTCHandlers()

        icon = toolImg.getScrollIcon()
        self.SetIcon(icon)

        #print time.time() - start, 'before edit'

        self.edit = editor.Editor(self, 1)
        #self.noteEdit = editor.Editor(self, 2)

        self.tts = None

        #if os.path.isfile(self.userDir + r"/config4.ini"):
        #    if self.config["settings"]["loadtts"] == True:
        #        self.doLoadTTS()
        #    else:
        #        self.loadTts = False
        #        self.voices = ['None']
        #else:
        self.doLoadTTS()

        #self.engine = pyttsx.init()

        # Instantiate the AUI manager
        self.mainMgr = aui.AuiManager()
        self.mainMgr.SetManagedWindow(self)
        self.mainMgr.SetDockSizeConstraint(0.5, 0.5)

        # Create Statusbar
        self.statusbar = self.CreateStatusBar()
        self.statusbar.SetFieldsCount(4)
        self.statusbar.SetStatusWidths([-2, -1, -1, -1])
        statusbar_fields = ["Sanctify them through thy truth...", "...thy word is truth ", " Study..."]
        for i in range(len(statusbar_fields)):
            self.statusbar.SetStatusText(statusbar_fields[i], i)

        # Place Menu
        #if os.path.isfile(ur"%s/config4.ini" % self.userDir):
            
        titlesList = ['Save Current Layout', 'Three Windows 1 - Bible on left, Results and Dct/Cmt on right (Default)', 'Four Windows - Bible/Results top, Cmt/Dct bottom (Old Default)',\
        'Three Windows 2 - Bible on top, Dct/Cmt and Results on bottom', 'Two Columns - Bible on left, Dct/Cmt/Results on right', 'Two Rows - Bible on top, Dct/Cmt/Results on bottom']

        try:
            self.layoutTitles = self.config['settings']['layouttitles']
            if not 'Three Windows 2 - Bible on top, Dct/Cmt and Results on bottom' in self.layoutTitles:
                self.layoutTitles = titlesList
                if os.path.isfile(ur'%s/mainLayout.dat' % self.userDir):
                    try:
                        os.remove(ur'%s/mainLayout.dat' % self.userDir)
                        os.remove(ur'%s/bibLayout.dat' % self.userDir)
                    except:
                        print 'Layout files not removed'
        except:
            self.layoutTitles = titlesList

        self.txtList = []
        self.Menu = mainMenu.MainMenu(self)
        #self.mainMgr.AddPane(self.Menu, aui.AuiPaneInfo().Name("menu").ToolbarPane().Gripper(False).Top().Row(0).Position(0).Fixed().BestSize(395, 24))
        self.SetMenuBar(self.Menu)

        #print time.time() - start, 'before toolbars'

        # Add Help Toolbar
        tb = self.Menu.helpToolbar()
        tb.Realize()
        self.mainMgr.AddPane(tb, aui.AuiPaneInfo().Name("helpTB").ToolbarPane().Top().Row(0).Position(1))

        # Add Viewer Toolbar
        tb = self.Menu.viewerToolbar()
        tb.Realize()
        self.mainMgr.AddPane(tb, aui.AuiPaneInfo().Name("viewerTB").ToolbarPane().Top().Row(0).Position(0))

        # Add Entry Toolbar
        tb = self.Menu.entryToolbar()
        tb.Realize()
        self.mainMgr.AddPane(tb, aui.AuiPaneInfo().Name("entryTB").ToolbarPane().Top().Row(0).Position(3))

        # Add Button Toolbar
        tb = self.Menu.buttonToolbar()
        tb.Realize()
        self.mainMgr.AddPane(tb, aui.AuiPaneInfo().Name("buttonTB").ToolbarPane().Top().Row(0).Position(2))

        # Add Button Toolbar
        self.toolTxt = '"The Words of the Lord are Pure Words..."'
        if os.path.isfile(ur"%s/config4.ini" % self.userDir):
            try:
                if self.config["settings"]["addtool"]:
                    self.toolTxt = self.config["settings"]["tooltxt"]
                else:
                    self.toolTxt = ''
            except:
                self.toolTxt = '"The Words of the Lord are Pure Words..."'
        messageTB = self.Menu.imageToolbar()
        messageTB.Realize()
        #messageTB.Bind(wx.EVT_MOTION, self.popupCheck)
        self.mainMgr.AddPane(messageTB, aui.AuiPaneInfo().Name("messageTB").ToolbarPane().Top().Row(0).Position(4))

        #print time.time() - start, 'toolbars'

        self.Tree = baseClass.CustomTreeCtrl(self)

        # Make Bible panel
        self.bibRefPanel = wx.Panel(self, -1)
        
        self.bibSplit = wx.SplitterWindow(self.bibRefPanel, -1)
        self.bibMgr = aui.AuiManager(self.bibRefPanel)
        
        self.bibNB = fnb.FlatNotebook(self.bibSplit, panel=1, style=fnb.FNB_FANCY_TABS|fnb.FNB_NODRAG|fnb.FNB_DROPDOWN_TABS_LIST|fnb.FNB_NO_X_BUTTON|fnb.FNB_NO_NAV_BUTTONS)
        self.bibNB.SetName('bibNB')
        
        self.dualPanel = wx.Panel(self.bibSplit, -1)
        
        self.dualLabelPanel = wx.StaticText(self.dualPanel, -1, "Dual Bible Panel", (12, 16), style = wx.ALIGN_CENTER)
        font = wx.Font(12, wx.SWISS, wx.NORMAL, wx.NORMAL)
        self.dualLabelPanel.SetForegroundColour("gray")
        self.dualLabelPanel.SetFont(font)

        self.dualWin = baseClass.HtmlWindow(self.dualPanel, -1, style=wx.BORDER_THEME)
        self.dualWin.SetName('Dual')
        dualSizer = wx.BoxSizer(wx.VERTICAL)
        dualSizer.Add(self.dualWin, 1, wx.EXPAND|wx.TOP, 52)
        self.dualPanel.SetSizer(dualSizer)

        self.dualWin.Bind(wx.EVT_SCROLLWIN, self.OnDualScroll)

        self.bibSplit.SplitVertically(self.bibNB, self.dualPanel)
        self.bibSplit.Unsplit(self.dualPanel)
        
        self.refNB = fnb.FlatNotebook(self.bibRefPanel, panel=5, style=fnb.FNB_FANCY_TABS|fnb.FNB_NODRAG|fnb.FNB_DROPDOWN_TABS_LIST|fnb.FNB_NO_X_BUTTON|fnb.FNB_NO_NAV_BUTTONS)
        
        self.refTree = wx.TreeCtrl(self.refNB, -1, style=wx.TR_HAS_BUTTONS|wx.TR_LINES_AT_ROOT|wx.TR_HIDE_ROOT|wx.BORDER_THEME)
        self.refTreeRoot = self.refTree.AddRoot('Library References')
        
        self.refTree.SetBackgroundColour(wx.Colour(230, 236, 240))
        
        self.bibRefWin = baseClass.HtmlWindow(self.refNB, -1, style=wx.BORDER_THEME)
        self.bibRefWin.SetName('refPanel')
        
        self.themeWin = baseClass.HtmlWindow(self.refNB, -1, style=wx.BORDER_THEME)
                
        self.refNB.AddPage(self.refTree, 'IDX')
        self.refNB.AddPage(self.themeWin, 'DBT')
        self.refNB.AddPage(self.bibRefWin, 'TSKe')
        
        self.refNB.SetSelection(0)
        
        info = (aui.AuiPaneInfo().CenterPane().Name("Bible Win").MinSize(250, -1))
        self.bibMgr.AddPane(self.bibSplit, info)
        
        info = (aui.AuiPaneInfo().Right().Name("Ref Panel").Caption("Verse Index - Rom 4:5").CloseButton(False).MinSize(160, -1))
        self.bibMgr.AddPane(self.refNB, info)

        #self.bibMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_SASH_SIZE, 2)
        #self.bibMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_CAPTION_SIZE, 22)

        self.bibRefWin.Bind(wx.EVT_LEFT_DOWN, self.SetBibFocus)
        self.bibRefWin.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnDictClicked)
        self.bibRefWin.Bind(wx.EVT_MOTION, self.OnMotion)
        self.bibRefWin.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        self.bibRefWin.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        self.bibRefWin.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)

        self.themeWin.Bind(wx.EVT_LEFT_DOWN, self.SetBibFocus)
        self.themeWin.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnDictClicked)
        self.themeWin.Bind(wx.EVT_MOTION, self.OnMotion)
        self.themeWin.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        self.themeWin.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        self.themeWin.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)

        self.bibMgr.Update()


        # Make Dictionary panel
        self.dctPanel = wx.Panel(self)
        self.dctNB = fnb.FlatNotebook(self.dctPanel, panel=2, style=fnb.FNB_FANCY_TABS|fnb.FNB_NODRAG|fnb.FNB_DROPDOWN_TABS_LIST|fnb.FNB_NO_NAV_BUTTONS|fnb.FNB_NO_X_BUTTON)
        self.dctTopicsLabel = wx.StaticText(self.dctPanel, -1, "Search Topics List")
        self.dctEntry = wx.ComboBox(self.dctPanel, -1, choices=[], size=(115, 25), style=wx.CB_DROPDOWN|wx.TE_PROCESS_ENTER)
        #self.dctListbox = wx.ListBox(self.dctPanel, -1, choices=[], size=(100, -1))
        self.dctListbox = baseClass.VirtDctList(self.dctPanel)
        self.dctListbox.InsertColumn(0, "")
        self.dctListbox.SetColumnWidth(0, 95)

        self.dctTopicsLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.dctSizer = wx.BoxSizer(wx.HORIZONTAL)
        listSizer = wx.BoxSizer(wx.VERTICAL)

        listSizer.Add(self.dctTopicsLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)
        listSizer.Add(self.dctEntry, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.RIGHT, 2)
        listSizer.Add(self.dctListbox, 1, wx.TOP|wx.RIGHT|wx.EXPAND, 2)

        self.dctSizer.Add(self.dctNB, 1, wx.EXPAND, 0)
        self.dctSizer.Add(listSizer, 0, wx.EXPAND, 0)
        self.dctPanel.SetSizer(self.dctSizer)

        # Make Commentary panel
        self.commentaryPanel = wx.Panel(self)
        self.cmtNB = fnb.FlatNotebook(self.commentaryPanel, panel=4, style=fnb.FNB_FANCY_TABS|fnb.FNB_NODRAG|fnb.FNB_DROPDOWN_TABS_LIST|fnb.FNB_NO_NAV_BUTTONS|fnb.FNB_NO_X_BUTTON)
        self.cmtLabel = wx.StaticText(self.commentaryPanel, -1, "Search Verse List")
        self.cmtEntry = wx.ComboBox(self.commentaryPanel, -1, choices=[], size=(115, 25), style=wx.CB_DROPDOWN|wx.TE_PROCESS_ENTER)
        #self.cmtListbox = wx.ListBox(self.commentaryPanel, -1, choices=[], size=(100, -1))
        self.cmtListbox = baseClass.VirtCmtList(self.commentaryPanel)
        self.cmtListbox.InsertColumn(0, "")
        self.cmtListbox.SetColumnWidth(0, 95)

        self.cmtLabel.SetForegroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DDKSHADOW))

        self.commentarySizer = wx.BoxSizer(wx.HORIZONTAL)
        cmtListSizer = wx.BoxSizer(wx.VERTICAL)
        cmtListSizer.Add(self.cmtLabel, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 10)
        cmtListSizer.Add(self.cmtEntry, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.RIGHT, 2)
        cmtListSizer.Add(self.cmtListbox, 1, wx.TOP|wx.RIGHT|wx.EXPAND, 2)

        self.commentarySizer.Add(self.cmtNB, 1, wx.EXPAND, 0)
        self.commentarySizer.Add(cmtListSizer, 0, wx.EXPAND, 0)
        self.commentaryPanel.SetSizer(self.commentarySizer)

        # Results Notebook
        self.resNB = fnb.FlatNotebook(self, panel=3, style=fnb.FNB_FANCY_TABS|fnb.FNB_NODRAG|fnb.FNB_DROPDOWN_TABS_LIST|fnb.FNB_NO_NAV_BUTTONS)

        #print time.time() - start, 'make panels'

        self.Settings()

        self.resultCurrent = []

        #print time.time() - start, 'settings'

        self.AddBibles()
        self.AddDictionaries()
        self.AddCommentaries()
        self.AddResults()

        #print time.time() - start, 'add books'
        self.BindEvents()

        sx, sy = self.GetSize()
        sx = sx - 100
        sy = sy - 100


        # Add Panes
        self.bibInfo = (aui.AuiPaneInfo().CenterPane().Name("Bible").Caption("Bible").CaptionVisible(True).MaximizeButton().MinSize(100, 100))
        self.mainMgr.AddPane(self.bibRefPanel, self.bibInfo)

        self.resInfo = (aui.AuiPaneInfo().Right().Name("Results").Caption("Results").CaptionVisible(True).MaximizeButton().BestSize(sx/2, sy/2).MinSize(100, 100))
        self.mainMgr.AddPane(self.resNB, self.resInfo)

        self.dctInfo = (aui.AuiPaneInfo().Bottom().Position(1).Name("Dictionaries").Caption("Dictionary").CaptionVisible(True).MaximizeButton().BestSize(sx/2, sy/2).MinSize(100, 100))
        self.mainMgr.AddPane(self.dctPanel, self.dctInfo)

        self.cmtInfo = (aui.AuiPaneInfo().Bottom().Position(0).Name("Commentaries").Caption("Commentary").CaptionVisible(True).MaximizeButton().BestSize(sx/2, sy/2).MinSize(100, 100))
        self.mainMgr.AddPane(self.commentaryPanel, self.cmtInfo)

        treeInfo = (aui.AuiPaneInfo().Left().Layer(1).Position(0).Name("Tree").Caption("Bible Tree").CaptionVisible(True).NotebookDockable(False).BestSize(90, 600))
        self.mainMgr.AddPane(self.Tree, treeInfo)

        #self.mainMgr.SetArtProvider(aui.ModernDockArt(self))

        for bmp, button, active, maximize in CUSTOM_PANE_BITMAPS:
            self.mainMgr.GetArtProvider().SetCustomPaneBitmap(bmp.GetBitmap(), button, active, maximize)

        self.mainMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_SASH_SIZE, 3)
        self.mainMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_CAPTION_SIZE, 17)
        #self.mainMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_PANE_BORDER_SIZE, 0)

        self.mainMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_COLOUR, wx.Colour(255, 255, 255))
        self.mainMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_GRADIENT_COLOUR, wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.mainMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_TEXT_COLOUR, wx.Colour(160, 80, 80))

        self.bibMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_SASH_SIZE, 3)
        self.bibMgr.GetArtProvider().SetMetric(aui.AUI_DOCKART_CAPTION_SIZE, 17)

        self.bibMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_COLOUR, wx.Colour(255, 255, 255))
        self.bibMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_GRADIENT_COLOUR, wx.SystemSettings_GetColour(wx.SYS_COLOUR_3DFACE))
        self.bibMgr.GetArtProvider().SetColour(aui.AUI_DOCKART_INACTIVE_CAPTION_TEXT_COLOUR, wx.Colour(160, 80, 80))


        flag = aui.AUI_MGR_ALLOW_ACTIVE_PANE # | aui.AUI_MGR_USE_NATIVE_MINIFRAMES
        self.mainMgr.SetAGWFlags(self.mainMgr.GetAGWFlags() ^ flag)

        #self.defaultPerspective = self.mainMgr.SavePerspective()
        #self.mainMgr.Update()

        #print time.time() - start, 'update'

        #Prepare Dict tabs to receive image
        il = wx.ImageList(16, 16)
        il.Add(toolImg.getGreenBookBitmap())

        self.dctNB.SetImageList(il)
        self.numList = len(self.dctData) + 1
        while self.numList > 0:
            self.dctNB.SetPageImage(self.numList, -1)
            self.numList = self.numList - 1

        #Prepare Cmt tabs to receive image
        il = wx.ImageList(16, 16)
        il.Add(toolImg.getBlueBookBitmap())

        self.cmtNB.SetImageList(il)
        self.numList = len(self.cmtData) + 1
        while self.numList > 0:
            self.cmtNB.SetPageImage(self.numList, -1)
            self.numList = self.numList - 1

        self.sEntry = None
        
        self.SetDefaults()

        # Add MiniWin and hide
        self.miniWin = miniWin.MiniWin(self)
        self.miniWin.SetPosition(self.miniWinPos)
        self.miniWin.SetSize(self.miniWinSize)
        self.miniHistory = []
        self.miniHistoryTitle = []
        self.miniHistoryIdx = -1
        
        if self.fontSize > 0:
            self.miniWin.intro = '<font size="+%s">%s</font>' % (self.fontSize, self.miniWin.intro)

        self.miniWin.MiniWindow.SetPage(self.miniWin.intro)
        self.miniCurrent = self.miniWin.intro


        self.currBibDisplay = self.bibDisplay[self.avIndex]
        self.bibNB.SetSelection(self.avIndex)

        #print time.time() - start, 'defaults'
        startDctIdx = 0

        for tab in range(self.bibNB.GetPageCount()):
            if self.bibNB.GetPageText(tab) == self.bibTab:
                self.bibNB.SetSelection(tab)
                self.currBibDisplay = self.bibDisplay[tab]
                break
            else:
                self.currBibDisplay = self.bibDisplay[self.avIndex]

        for tab in range(self.dctNB.GetPageCount()):
            if self.dctNB.GetPageText(tab) == self.dctTab:
                self.dctNB.SetSelection(tab)
                startDctIdx = tab
                break
            else:
                startDctIdx = 0

        self.GetWordList(startDctIdx)
        self.currentWord = self.savedDctTopic
        #self.currentDctWord = self.currentWord # For dctListBox selection when not strict word ('scriptires' for 'scripture)
        self.dctWord = self.currentWord # for next/prev buttons

        for tab in range(self.cmtNB.GetPageCount()):
            if self.cmtNB.GetPageText(tab) == self.cmtTab:
                self.cmtNB.SetSelection(tab)
                startCmtIdx = tab -1
                break
            else:
                startCmtIdx = 1

        self.GetVerseList(startCmtIdx)

        # Check valid ref
        if len(self.currentRef) < 3 or re.search('[a-z]\d', self.currentRef) or re.search('[a-z] ?\d+$', self.currentRef):
            print self.currentRef, 'Malformed ref'
            self.currentRef = 'Rom 4:5'
        
        if self.currentRef[:3] not in self.Tree.order:
            print self.currentRef, 'bad book ref'
            self.currentRef = 'Rom 4:5'
        
        self.currentBk = self.currentRef[:3]

        self.CmtRef = self.currentRef

        statText = 'Current Word: %s' % self.currentWord
        self.statusbar.SetStatusText(statText, 2)

        #print time.time() - start, 'FlagTabs'

        self.FlagTabs(self.currentWord)
        self.FlagCmtTabs(self.currentRef)


        if ':' in self.currentRef:
            idx = self.currentRef.find(':')
            self.currentChap = self.currentRef[:idx +1]
        else:
            self.currentChap = self.currentRef

        self.StatusUpdate()

        try:
            treeRef = self.Tree.bookId[self.currentChap[:3]]
        except KeyError:
            if self.currentBk in self.Tree.apocOrder:
                self.Tree.addApoc()
            try:
                treeRef = self.Tree.bookId[self.currentBk]
            except KeyError:
                treeRef = self.Tree.bookId['Rom']
        except:
            treeRef = self.Tree.bookId['Rom']

        self.noChangeRef = 1
        self.noTreeProcess = 1
        self.Tree.SelectItem(treeRef)
        self.noTreeProcess = 0
        
        self.noChangeRef = 0

        self.resNB._mainSizer.Show(2, False)
        self.resNB.Layout()

        self.contextMenu = contextMenu.ContextMenu(self)

        self.bibNB.bibPanel.miniTB.ToggleTool(509, True)
        
        if self.showStrongs:
            self.bibNB.bibPanel.miniTB.ToggleTool(510, True)

        if self.showFootnote:
            self.bibNB.bibPanel.miniTB.ToggleTool(514, True)

        # Set Listbox state
        self.dctNB.dctPanel.miniTB.ToggleTool(610, self.showDctWL)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(707, self.showCmtWL)
        
        self.dctNB.dctPanel.miniTB.ToggleTool(613, self.showDctDef)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(714, self.showCmtDef)
        
        self.dctNB.dctPanel.OnDctTopics(None)
        self.cmtNB.cmtPanel.OnCmtTopics(None)

        # Show verse button on
        #self.cmtNB.cmtPanel.miniTB.ToggleTool(715, True)

        if self.showQuote == 1:
            sessionMan.editorQuote()

        self.editor.DiscardEdits()

        self.resNB.SetSelection(0)

        self.SetBibFocus(None)

        #print time.time() - start, 'Load Pers.'

        # Load layout Perspective
        if os.path.isfile(ur'%s/mainLayout.dat' % self.userDir):
            pklFile = open(ur'%s/mainLayout.dat' % self.userDir, 'rb')
            self.layoutList = cPickle.load(pklFile)
            self.mainMgr.LoadPerspective(self.layoutList[-1], False)
            self.lastClosedLayout = self.layoutList[-1]
            del self.layoutList[-1]
            pklFile.close()
            #print len(self.layoutList), 'len layout open'
            
            pklFile = open(ur'%s/bibLayout.dat' % self.userDir, 'rb')
            self.bibLayout = cPickle.load(pklFile)
            self.bibMgr.LoadPerspective(self.bibLayout)
            pklFile.close()
        else:
            import layouts
            self.layoutList = []
            self.layoutList.append(layouts.threeWin1)
            self.layoutList.append(layouts.fourWin)
            self.layoutList.append(layouts.threeWin2)
            self.layoutList.append(layouts.twoColumns)
            self.layoutList.append(layouts.twoRows)
            self.lastClosedLayout = self.layoutList[-1]
            
            self.mainMgr.LoadPerspective(layouts.threeWin1, False)

        self.bibNB.bibPanel.miniTB.ToggleTool(511, True)
        
        self.checkRefNB()
        
        statText = 'Current Layout: %s' % 'Last Closed'
        self.statusbar.SetStatusText(statText, 3)

        if self.lastSaved != ' ' and self.loadFile == True:
            if self.lastSaved[-3:] == 'xml':
                self.editor.LoadFile(self.lastSaved, 2)
                self.UpdateSPadCaption(os.path.basename(self.lastSaved))
        else:
            self.UpdateSPadCaption()


        #print self.lastBookTitle, 'last title'
        if self.resTab == 1: # or self.showBkWin:
            self.OnMasterControlMini(None, False)
            self.resNB.SetSelection(1)

            if self.lastBookTitle:
                try:
                    self.cpMini.BookViewer.Tree.SelectItem(self.cpMini.BookViewer.titles[self.lastBookTitle])
                    self.bookTitlesLoaded = True
                except: pass

        if self.mcpShown:
            self.OnMasterControlMini(None)
            #self.cpMini.LBook.SetSelection(self.mcpTab)

        self.SetMenuTbItems()

        #print time.time() - start, 'Update Nbooks'

        self.OnResNBChanged(None)
        self.OnCmtNBChanged(None)
        self.OnDctNBChanged(None)
        self.OnBibNBChanged(None)
        
        #self.verseHistory.append(self.currentRef)
        
        self.bibNB.bibPanel.InsertBibRef(self.currentRef)
        
        #print self.maximized
        if self.maximized:
            #print 'maxed'
            self.mainMgr.MaximizePane(self.mainMgr.GetPane(self.maximized))

        self.mainMgr.Update()
        
        self.GetPopupHeaderColor()
        self.GetPopColor()

        #print time.time() - start, 'end init'
        #self.SetBibFocus(None)
        
        self.SetQSearchFocus(None)
                
        if self.ttsEng and self.ttsStartTxt and self.ttsStartIdx == 0:
            self.ttsEng.speak(self.ttsStartTxt, True)

    
    def checkRefNB(self):
        if not self.refNB.IsShown():
            self.bibNB.bibPanel.miniTB.ToggleTool(511, False)
        else:
            wx.BeginBusyCursor()
            self.OnBibCrossRef(self.currentRef)
            self.refIndex.GetVerseIndexes()
            self.themeIndex.GetThemes()
            if self.refNB.refPanel.expRef.GetValue():
                self.refTree.ExpandAll()
            wx.EndBusyCursor()

        
    def SetDefaults(self):
        
        # Set default Strong's resource
        self.strongIndex = None
        #self.strongExIndex = None
        self.strongPopIdx = None
        
        #print self.dAbbrList, 'self.dAbbrList'

        # Set default dictionary
        if self.defaultDctAbbr in self.dAbbrList:
            self.defaultDctIdx = self.dAbbrList.index(self.defaultDctAbbr)
        elif 'Web 1828a' in self.dAbbrList:
            self.defaultDctIdx = self.dAbbrList.index('Web 1828a')
        elif 'Web 1828' in self.dAbbrList:
            self.defaultDctIdx = self.dAbbrList.index('Web 1828')
        else:
            self.defaultDctIdx = 0

        # Set default strongs
        self.strongExIndex = False
        if 'StrongEx' in self.dAbbrList:
            self.strongExIndex = True        

        if self.defaultStrongsAbbr in self.dAbbrList:
            self.strongIndex = self.dAbbrList.index(self.defaultStrongsAbbr)
        elif 'StrongEx' in self.dAbbrList:
            self.strongIndex = self.dAbbrList.index('StrongEx')
        else:
            if self.dctStrongList:
                self.strongIndex = self.dDescList.index(self.dctStrongList[0])
            else:
                self.strongIndex = None

        # Set default strongs popup
        if self.defaultStrongsPopAbbr in self.dAbbrList:
            self.strongPopIndex = self.dAbbrList.index(self.defaultStrongsPopAbbr)
        elif 'StrongEx' in self.dAbbrList:
            self.strongPopIndex = self.dAbbrList.index('StrongEx')
        else:
            if self.dctStrongList:
                self.strongPopIndex = self.dDescList.index(self.dctStrongList[0])
            else:
                self.strongPopIndex = None
            

        # Set default Commentary
        if self.defaultCmtAbbr in self.cAbbrList:
            self.defaultCmtIdx = self.cAbbrList.index(self.defaultCmtAbbr)
        elif 'TSKe' in self.cAbbrList:
            self.defaultCmtIdx = self.cAbbrList.index('TSKe')
        else:
            self.defaultCmtIdx = 0
            

        # Set Theme Idx
        self.themeIdx = None
        if 'Themes' in self.dAbbrList:
            self.themeIdx = self.dAbbrList.index("Themes")


        # Set popup Bible
        try:
            self.popupIndex = self.bDescList.index(self.defaultPopupTxt)
        except:
            self.popupIndex = self.avIndex
            

    def UpdateSPadCaption(self, fn = 'New Document'):
        resPane = self.mainMgr.GetPane("Results")
        resPane.Caption('ScripturePad Editor - %s' % fn)
        self.rDescList[0] = 'ScripturePad Editor - %s' % fn
        
        self.mainMgr.Update()

    def doLoadTTS(self):
            
        self.ttsEng = speech.Text2Speech()
        if not self.ttsEng:
            print 'No TTS Engine'
            self.loadTts = False
            self.ttsEng = None
            self.voices = ['None']
            return
            
        self.voices = self.ttsEng.voices
        
        self.voiceIDList = self.ttsEng.voiceIDList
        self.loadTts = True
        print 'TTS is loaded'
            

    def LoadModules(self, reload = False):
        
        if not reload:
            self.userDir = sessionMan.userDir
            self.allUsersDir = sessionMan.allUsersDir
            self.appPath = sessionMan.appDir
            self.myDocsDir = sessionMan.myDocsDir
            
            self.resDisplay = []
                
            try:
                self.sessTab = self.config['settings']['sesstab']
                self.sessTabTitles = self.config['settings']['sesstabtitles']
                if len(self.sessTabTitles) < 7:
                    self.sessTabTitles = ["All Modules", "Group 1", "Group 2", "Group 3", "Group 4", "Group 5", "Group 6"]
            except:
                self.sessTab = 0
                self.sessTabTitles = ["All Modules", "Group 1", "Group 2", "Group 3", "Group 4", "Group 5", "Group 6"]

            #print time.time() - start, 'before mods files'

            self.initMods = sessionMan.InitModules()
            self.initMods.GetResources()
            self.initMods.GetBooks()
            
            if self.initMods.needRefIdx:
                #print self.initMods.needRefIdx
                self.refIndex.GetModRefs()
            
            #print time.time() - start, 'after mods files'
            
            self.sessMan = sessionMan.SessionManager(self)
            self.sessMan.OnToggleButtons(None)
            #self.sessMan.InitOLV()
        
            self.isPortable = sessionMan.portable

            self.initMods.GetAudio()
            self.audioList = self.initMods.audioList
            self.audioTitleList = self.initMods.audioTitleList

            self.imdList = self.initMods.imdList
            self.userImgList = self.initMods.userImgList
            
            self.modules = utility.Modules

            self.initMods.GetDevotions()
            self.devData = self.initMods.devData

            self.initMods.GetHarmonies()
            self.harmonyTitleList = self.initMods.harmonyTitleList
            self.harmonyFileList = self.initMods.harmonyFileList

        #print time.time() - start, 'before load mods'

        self.bibData = self.initMods.bibData[:]
        self.dctData = self.initMods.dctData[:]
        self.cmtData = self.initMods.cmtData[:]
        self.bkData = self.initMods.bkData[:]
        #print self.bibData
           
        self.bibDisplay = []
        self.dctDisplay = []
        self.cmtDisplay = []
        
        if not self.sessMan.sessList:
            self.NoBibLoad = []
            self.NoDctLoad = []
            self.NoCmtLoad = []
            self.NoBkLoad = []
        
        else:
            self.NoBibLoad = self.sessMan.sessList[self.sessTab -1][0]
            self.NoDctLoad = self.sessMan.sessList[self.sessTab -1][1]
            self.NoCmtLoad = self.sessMan.sessList[self.sessTab -1][2]
            self.NoBkLoad = self.sessMan.sessList[self.sessTab -1][3]
        
        #Remove unckecked modules from fileLists
        bibTemp = self.bibData[:]
        for mod in bibTemp:
            if mod[1] in self.NoBibLoad:
                self.bibData.remove(mod)

        dctTemp = self.dctData[:]
        for mod in dctTemp:
            if mod[1] in self.NoDctLoad:
                self.dctData.remove(mod)

        cmtTemp = self.cmtData[:]
        for mod in cmtTemp:
            if mod[1] in self.NoCmtLoad:
                self.cmtData.remove(mod)

        bkTemp = self.bkData[:]
        for mod in bkTemp:
            if mod[1] in self.NoBkLoad:
                self.bkData.remove(mod)
        
        self.bkData.sort(key=lambda fn: fn[1])
        
        #print time.time() - start, 'after load mods'



    def Settings(self):
        self.noDctUpdate = 0
        self.noCmtUpdate = 0
        self.noTreeProcess = 0
        self.treeSelect = None
        self.font = 'Georgia'
        self.fontSize = 0
        self.showRed = 1
        self.showText = 1
        self.showStrongs = 1
        #self.showFootnote = 1
        self.paragraph = 0
        self.showBibSum = 1
        self.fullBibRef = 0

        #self.defaultDctAbbr = ''
        #self.defaultCmtAbbr = ''
        #self.defaultStrongsAbbr = ''
        self.defaultStrongsPopAbbr = ''

        # For printing
        self.cmtCurrent = ''
        self.dctCurrent = ''
        self.bibCurrent = ''
        self.ResultsText = ''

        # For popup
        self.popRef = ''
        self.noPopRefLnk = 0

        self.sEntry = None
        self.dctNB.SetSelection(0)
        self.cmtNB.SetSelection(0)

        self.winColors = {0:'#FFFFFF', 1:'#E6E6FF', 2:'#E6FFE6', 3:'#FFFFE6', 4:'#E6FFFF', 5:'#FFE6E6', 6:'#FFE6FF', 7:'#E0E0E0'}
        self.winHeadColors = {0:'#F8F8F8', 1:'#DFDFFF', 2:'#DBFFDB', 3:'#FFFFDC', 4:'#D6FFFF', 5:'#FFDBDB', 6:'#FFDDFF', 7:'#D5D5D5'}

        self.toolwin = None
        self.currentCellTxt = None
        self.showTree = 1
        self.oldWin = None
        self.prePage = ''
        self.lastSaved = ''
        self.oldCell2 = None
        self.cpMini = None
        self.mediaMini = None
        self.infoWin = None
        self.devotionWin = None
        self.libViewer = None
        self.parallelWin = None
        self.bkWinDisplay = None
        self.verseInt = None
        self.bkWin = None
        self.wordListTab = None
        self.verseListTab = None
        self.imgViewer = None
        self.bookTitlesLoaded = None
        self.bookTitle = None

        self.ttsChapClick = False
        self.fromDual = False
        self.bkChapRef = None
        self.audioVsInt = None

        self.optionsDlg = None

        self.searchQList = []
        self.resultCurrent = []
        self.searchQList = []
        self.hitListIdx = []
        self.dctHistory = []
        self.cmtHistory = []

        self.imgMapData = []
        #self.verseHistory = []

        self.hitList = {}

        self.cmtListIdx = None
        self.dctListIdx = None

        self.multiRngLen = 0
        self.bibPlayer = None
        self.noChangeRef = 0
        
        self.noCmtChange = False
        self.noDctChange = False
        self.noBibChange = False

        #Get settings from config.ini
        self.GetSet()

        self.SetWinColors()
        self.SetVerseBackColor()

        self.closedNB = None
        self.dctSearchTerm = None
        self.cmtSearchTerm = None

        self.dctNB.dctPanel.miniTB.ToggleTool(605, True)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(706, True)
        
        self.lastDctFlagEntry = None
        self.bibWordClick = False
        self.currentCell = None
        self.popupWin = None
        self.parallelBibClick = None



    def BindEvents(self):
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnSelChanged, self.Tree)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.refIndex.OnRefSelChanged, self.refTree)
        
        self.refTree.Bind(wx.EVT_MOTION, self.refIndex.CallRefTreeMotion)
        self.refTree.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)
        self.refTree.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        self.refTree.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        
        self.refNB.Bind(fnb.EVT_FLATNOTEBOOK_PAGE_CHANGED, self.OnRefNBChanged)
        self.bibNB.Bind(fnb.EVT_FLATNOTEBOOK_PAGE_CHANGED, self.OnBibNBChanged)
        self.resNB.Bind(fnb.EVT_FLATNOTEBOOK_PAGE_CHANGED, self.OnResNBChanged)
        self.cmtNB.Bind(fnb.EVT_FLATNOTEBOOK_PAGE_CHANGED, self.OnCmtNBChanged)
        self.dctNB.Bind(fnb.EVT_FLATNOTEBOOK_PAGE_CHANGED, self.OnDctNBChanged)

        self.Bind(wx.EVT_TEXT_ENTER, self.OnSearch, self.Menu.QSentry)
        #self.Bind(wx.EVT_TEXT, self.OnQuickEntry, self.Menu.QSentry)
        #self.Bind(wx.EVT_COMBOBOX, self.OnQuickSort, self.Menu.QSentry)

        self.Bind(wx.EVT_TEXT, self.OnDctEntry, self.dctEntry)
        self.Bind(wx.EVT_COMBOBOX, self.OnDctEntrySel, self.dctEntry)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnDctEnter, self.dctEntry)
        #self.Bind(wx.EVT_LISTBOX, self.OnDctSelView, self.dctListbox)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnDctSelView, self.dctListbox)

        self.Bind(wx.EVT_TEXT, self.OnCmtEntry, self.cmtEntry)
        self.Bind(wx.EVT_COMBOBOX, self.OnCmtEntrySel, self.cmtEntry)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnCmtEnter, self.cmtEntry)
        #self.Bind(wx.EVT_LISTBOX, self.OnCmtSelView, self.cmtListbox)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnCmtSelView, self.cmtListbox)

        self.Tree.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        #self.Tree.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)

        self.Bind(wx.EVT_CLOSE, self.OnClose)
        self.Bind(wx.EVT_SIZE, self.OnSize)


    def OnSize(self, event):
        event.Skip()
        self.SetMinSize((750, 550))
        x, y = self.bibRefPanel.GetSize()
        if x < 125:
            self.SetMinSize(self.GetSize())



    ## Add pages
    def AddBibles(self):
        #Splits Bible info after unchecked texts are deleted from bibData list.
        self.bAbbrList = []
        self.bDescList = []
        self.bibFileList = []
        self.compareList = []
        self.strongsList = []
        self.interList = []
        self.compareFileList = []
        self.avIndex = None

        for set in self.bibData:
            self.bAbbrList.append(set[0])
            self.bDescList.append(set[1])
            fn = set[2]
            self.bibFileList.append(fn)
            
            if fn.endswith('av1769.bib'):
                self.avIndex = self.bibFileList.index(fn)
            
            if set[3] == 1 or set[0] == 'AVs' or set[0] == 'TRi' or set[0] == 'GTR' or set[0] == 'TPB' or set[0] == 'ABPi':
                self.strongsList.append(fn)
            if set[4] == 1 or set[0] == 'TRi' or set[0] == 'ABPi':
                self.interList.append(fn)

            if not fn in self.interList and not fn in self.strongsList:
                self.compareList.append(set[0])
                self.compareFileList.append(fn)
                
        
        if self.avIndex == None:
            wx.MessageBox('The "av1769.bib" Bible file (AV) must be in the /Modules/Bible folder for Bible Analyzer to run.',
            'AV-1769 Bible Missing')
            self.Destroy()
            sys.exit()
        
        
        #Dynamically add pages for Bibles found
        for abbr in self.bAbbrList:
            self.AddBible(abbr, self.bDescList[self.bAbbrList.index(abbr)], -1)

        #Add Parallel Tab
        self.AddBible('Parallel', 'Parallel Table', -1)

        if not self.bibMultiList:
            self.bibMultiList = self.bAbbrList[:]
            
        if not self.paraTextList:
            self.paraTextList = self.bAbbrList[:]


    def AddBible(self, tabLabel, title, id):
        self.bibNB.AddPage(self.CreateBiblePage(tabLabel, title, self.bibNB, id), tabLabel, True)

    def AddDictionaries(self):
        #Splits Dict. info after unchecked texts are deleted from dctData list.
        self.dAbbrList = []
        self.dDescList = []
        self.dctFileList = []
        #self.dctIdxFileList = []
        #self.strongsDctList = []
        #self.strongsDctDescList = []
        #self.strongsDctAbbrList = []

        for set in self.dctData:
            self.dAbbrList.append(set[0])
            self.dDescList.append(set[1])
            fn = set[2]
            self.dctFileList.append(fn)
            #if set[0] == 'Strong\'s+' or set[0] == 'KJC' or set[0] == 'BDB/Thayer' or set[0] == 'StrongEx':
                
                #self.strongsDctList.append(fn)
                #self.strongsDctDescList.append(set[1])
                #self.strongsDctAbbrList.append(set[0])

            #self.dctIdxFileList.append(fn[:-3] + 'idx')

        #Dynamically add pages for Dicts found
        for abbr in self.dAbbrList:
            self.AddDict(abbr, self.dDescList[self.dAbbrList.index(abbr)], -1)
        
        self.dctStrongList = []
        for dct in self.initMods.dctStrongList:
            if dct in self.dDescList:
                self.dctStrongList.append(dct)
                
    def AddDict(self, tabLabel, title, id):
        self.dctNB.AddPage(self.CreatePage(tabLabel, title, self.dctNB, id), tabLabel, True)


    def AddCommentaries(self):
        #Splits Cmt info after unchecked texts are deleted from cmtData list.
        self.cAbbrList = []
        self.cDescList = []
        self.cmtFileList = []
        #self.cmtIdxFileList = []

        for set in self.cmtData:
            self.cAbbrList.append(set[0])
            self.cDescList.append(set[1])
            fn = set[2]
            self.cmtFileList.append(fn)
            #self.cmtIdxFileList.append(fn[:-3] + 'idx')

        # Add Notes panel
        self.noteEdit = editor.Editor(self, 2)
        #self.noteEdit.SetToolTip(wx.ToolTip('User Notes Editor'))
        self.cmtNB.AddPage(self.noteEdit, 'Notes', True)
        self.notes = self.noteEdit.editor

        #self.notes.Clear()
        self.noteEdit.OnBasicStyle()

        self.notes.Bind(wx.EVT_LEFT_DOWN, self.SetCmtFocus)
        self.notes.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        self.notes.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)


        #Dynamically add pages for Commentaries found
        for abbr in self.cAbbrList:
            self.AddCmt(abbr, self.cDescList[self.cAbbrList.index(abbr)], -1)



    def AddCmt(self, tabLabel, title, id):
        self.cmtNB.AddPage(self.CreatePage(tabLabel, title, self.cmtNB, id), tabLabel, True)


    def AddResults(self):
        self.rDescList = []

        # Add ScripturePad panel
        #self.edit.SetToolTip(wx.ToolTip('ScripturePad Editor'))
        self.resNB.AddPage(self.edit, 'S-Pad', True)
        self.editor = self.edit.editor

        self.editor.Bind(wx.EVT_LEFT_DOWN, self.SetResFocus)
        self.editor.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        #self.editor.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)

        self.editor.Clear()
        self.edit.OnBasicStyle()

        #Prepare S-Pad tab to receive unsaved data image
        il = wx.ImageList(14, 14)
        il.Add(toolImg.getPencilBitmap())
        #self.resNB.SetImageList(il)
        self.resNB.SetPageImage(0, -1)


        # Add Books panel
        #intro = '<center><font color="#660000">Press <b>F3</b> to open Book/Article Titles.</font></center>'

        p = wx.Panel(self.resNB)
        p2 = wx.Panel(p)
        #p.SetToolTip(wx.ToolTip('Book/Article Viewer'))
        self.bookDisplay = baseClass.HtmlWindow(p2, -1, style=wx.BORDER_NONE)
        #box = wx.StaticBox(p, -1, 'Book/Article Viewer')
        self.bookDisplay.SetName('Books')

        s1 = wx.BoxSizer(wx.HORIZONTAL)
        s2 = wx.BoxSizer(wx.HORIZONTAL)
        s2.Add(self.bookDisplay, 1, wx.ALL|wx.EXPAND, 1)
        p2.SetSizer(s2)
        s1.Add(p2, 1, wx.EXPAND|wx.ALL, 0)
        p.SetSizer(s1)

        self.mainPop = mainPopup.MainPopup(self, self.bookDisplay)

        self.bookDisplay.Bind(wx.EVT_LEFT_DOWN, self.SetResFocus)

        #self.bookDisplay.Bind(wx.EVT_MOTION, self.OnMotion)
        self.bookDisplay.Bind(wx.EVT_MOTION, self.mainPop.OnMotion)
        self.bookDisplay.Bind(wx.EVT_LEFT_DOWN, self.mainPop.OnLeftDown)

        self.bookDisplay.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        self.bookDisplay.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)

        self.bookDisplay.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnDictClicked)
        #self.bookDisplay.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)
        
        self.bookDisplay.Bind(wx.EVT_KEY_DOWN, self.OnBibKey)
        self.bookDisplay.Bind(wx.EVT_KEY_UP, self.OnBibKeyUp)

        self.resultCurrent.append('')

        self.resDisplay.append(self.bookDisplay)
        self.resNB.AddPage(p, 'Books', True)
        
        self.searchQList.append('')
        self.resNB.SetSelection(0)

        #il = wx.ImageList(16, 12)
        il.Add(toolImg.getBookBitmap())
        self.resNB.SetImageList(il)
        self.resNB.SetPageImage(1, 1)


        self.rDescList.append('ScripturePad Editor')
        self.rDescList.append('Books/Articles Viewer')
        
        #self.rDescList.append('Fold Panel')



    def AddResult(self, tabLabel, title, answer, name = ''):
        self.rDescList.append(tabLabel)
        if len(tabLabel) > 15:
            tabLabel = tabLabel[:15] + '...'
        page = self.CreatePage(tabLabel, title, self.resNB, -1, answer, name)
        self.resNB.AddPage(page, tabLabel, True)
        self.resultCurrent.append(answer)
        self.popupCheck()
        #self.imgViewer.Iconize()




    ## Create Pages
    def CreateBiblePage(self, tabLabel, title, nb, id):
        p = wx.Panel(nb)
        p2 = wx.Panel(p)
        #p.SetToolTip(wx.ToolTip(title))
        display = baseClass.HtmlWindow(p2, id, style=wx.BORDER_NONE)

        display.SetName('Bib/'+tabLabel)
        self.bibDisplay.append(display)

        s1 = wx.BoxSizer(wx.HORIZONTAL)
        s2 = wx.BoxSizer(wx.HORIZONTAL)
        s2.Add(display, 1, wx.ALL|wx.EXPAND, 1)
        p2.SetSizer(s2)
        s1.Add(p2, 1, wx.EXPAND|wx.ALL, 0)
        p.SetSizer(s1)

        #if tabLabel != 'Parallel':
        #    tabIdx = self.bAbbrList.index(tabLabel)
        #    if self.bibFileList[tabIdx] in self.strongsList:

        #display.Bind(wx.html.EVT_HTML_CELL_HOVER, self.OnStrongsPopup)
        #display.Bind(wx.html.EVT_HTML_CELL_HOVER, self.OnPopup)
        display.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        display.Bind(wx.EVT_MOTION, self.OnMotion)
        
        display.Bind(wx.EVT_KEY_DOWN, self.OnBibKey)
        display.Bind(wx.EVT_KEY_UP, self.OnBibKeyUp)

        display.Bind(wx.EVT_LEFT_DOWN, self.SetBibFocus)
        display.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnBibClicked)
        display.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        #display.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)

        return p


    def CreatePage(self, tabLabel, title, nb, id, answer = '', name = ''):
        if len(title) > 55:
            title = title[:55] + '...'

        p = wx.Panel(nb)
        p2 = wx.Panel(p)

        #p.SetToolTip(wx.ToolTip(title))
        display = baseClass.HtmlWindow(p2, id, style=wx.BORDER_NONE)
        
        if name == 'search':
            display.SetName('search')
            
        if nb == self.dctNB:
            self.dctDisplay.append(display)
            display.Bind(wx.EVT_LEFT_DOWN, self.SetDctFocus)
            display.SetName('Dct/'+tabLabel)
        if nb == self.resNB:
            self.resDisplay.append(display)
            display.Bind(wx.EVT_LEFT_DOWN, self.SetResFocus)
            display.Bind(wx.html.EVT_HTML_LINK_CLICKED, self.OnLinkClick)
            display.SetName('Res/'+tabLabel)
        if nb == self.cmtNB:
            self.cmtDisplay.append(display)
            display.Bind(wx.EVT_LEFT_DOWN, self.SetCmtFocus)
            display.SetName('Cmt/'+tabLabel)
        
        display.Bind(wx.EVT_KEY_DOWN, self.OnBibKey)
        display.Bind(wx.EVT_KEY_UP, self.OnBibKeyUp)
        
        s1 = wx.BoxSizer(wx.HORIZONTAL)
        s2 = wx.BoxSizer(wx.HORIZONTAL)
        s2.Add(display, 1, wx.ALL|wx.EXPAND, 1)
        p2.SetSizer(s2)
        s1.Add(p2, 1, wx.EXPAND|wx.ALL, 0)
        p.SetSizer(s1)

        #else:
        display.Bind(wx.html.EVT_HTML_CELL_CLICKED, self.OnDictClicked)
        #display.Bind(wx.html.EVT_HTML_CELL_HOVER, self.OnPopup)
        #display.Bind(wx.EVT_MOUSEWHEEL, self.OnWheelScroll)
        display.Bind(wx.EVT_MOTION, self.OnMotion)

        display.Bind(wx.EVT_LEAVE_WINDOW, self.leaveWindow)
        display.Bind(wx.EVT_ENTER_WINDOW, self.enterWindow)
        display.SetPage(answer)
        
        return p


    def OnRefNBChanged(self, event):
        tab = self.refNB.GetSelection()
        if tab == 0:
            self.bibMgr.GetPane('Ref Panel').Caption(' Verse Index - %s' % self.currentRef)
            self.refNB.refPanel.Show()
        elif tab == 1:
            self.bibMgr.GetPane('Ref Panel').Caption(' Bible Themes - %s' % self.currentRef)
            self.refNB.refPanel.Hide()
        elif tab == 2:
            self.bibMgr.GetPane('Ref Panel').Caption(' TSKe Refs - %s' % self.currentRef)
            self.refNB.refPanel.Hide()
        
        self.refNB.Layout()
        self.bibMgr.Update()
        #print tab, 'tab'


    def OnBibNBChanged(self, event):
        if self.noBibChange == True:
            return

        #print 'bibChanged'
        tab = self.bibNB.GetSelection()
        tabLabel = self.bibNB.GetPageText(tab)

        if tabLabel == 'Parallel':
            self.OnParallel()
            return

        self.currentBible = self.bibFileList[tab]
        display = self.bibDisplay[tab]
        self.Freeze()

        if tabLabel == 'AV-1611':
            if not self.Tree.apocBkList:
                self.Tree.addApoc()
        else:
            if self.Tree.apocBkList:
                self.Tree.delApoc()

        if len(self.currentRef) == 3:
            currentRef = self.currentRef[:3] + ' 1:'
            chapRef = currentRef
        else:
            try:
                chapRef = re.match('(.+:)', self.currentRef).group(1)
            except:
                chapRef = 'Rom 4:'

        try:
            verseRef = re.match('.+:(\d+)', self.currentRef) .group(1)
            self.verseInt = int(verseRef)
        except:
            verseRef = '0'

        #currentRef = currentRef.replace(' ', '_')

        answer = normSearch.nView(chapRef, verseRef, self.bibFileList[tab], self.font,  self.showRed, self.showText, self.showStrongs, self.paragraph, 1)
        self.ttsTxt = answer

        if self.fontSize  > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.bibCurrent = answer

        display.SetPage(answer)

        if self.currentRef[-1].isdigit():
            sRef = self.currentRef
            if '-' in self.currentRef:
                sRef = re.match(r'(.*)-', self.currentRef).group(1)

            if '<a name=' in self.bibCurrent:
                display.ScrollToAnchor(sRef)
                display.ScrollLines(-2)

        title = 'Bible - %s' % self.bDescList[tab]
        pane = self.mainMgr.GetPane("Bible")

        if pane.IsNotebookPage():
            self.doNotebookTitle(pane, title)
        elif pane.IsFloating():
            frameMgr = pane.frame.GetMgr()
            p = frameMgr.GetPane('Bible')
            p.Caption(title)
            frameMgr.Update()
        else:
            pane.Caption(title)

        self.currBibDisplay = display

        if self.bibFileList[tab] in self.strongsList:
            self.bibNB.bibPanel.miniTB.EnableTool(510, True)
        else:
            self.bibNB.bibPanel.miniTB.EnableTool(510, False)

        if self.bibFileList[tab] in self.interList:
            self.bibNB.bibPanel.miniTB.EnableTool(509, True)
        else:
            self.bibNB.bibPanel.miniTB.EnableTool(509, False)


        self.makeConCellList()
        self.oldCell.SetBackgroundColour(wx.Colour(255, 255, 255))

        if verseRef != '0':
            try:
                add = 0
                #if self.showBibSum == 1:
                #    add = 1

                #new = self.contCellList[int(verseRef) -1 +add]
                new = self.contCellList[int(verseRef) -1 +add]

                new.SetBackgroundColour(self.backColor)
                self.oldCell = new
            except:
                print 'bibNB Exception'

        wdTemplate = '%s<font color="brown"><b><u>%s</u></b></font>%s'
        self.Menu.QSentry.completer = self.Menu.listCompleter(self.txtWordList, wdTemplate)

        self.bibNB.Refresh()
        self.SetBibFocus(None)
        self.Thaw()


    def OnDctNBChanged(self, event, fromLibRef = False):
        if self.noDctChange == True:
            return
        
        #print 'dctChanged'

        self.Freeze()
        wx.BeginBusyCursor()

        tab = self.dctNB.GetSelection()
        #self.GetWordList(tab)

        self.dctEntry.SetValue(self.currentWord)
        self.dctListIdx = tab

        if self.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
            if tab != self.wordListTab:
                self.GetWordList(tab)

            #print 'dct shown'
            self.dctListbox.SetItemCount(len(self.currentWL))
            item = self.FindDctEntry(self.dctEntry.GetValue())
            if item:
                self.dctListbox.EnsureVisible(item)
                #self.dctListbox.Select(item)
                #print 'dctlistbox, #1405'
            #self.dctListbox.SetStringSelection(self.currentWord)

        self.dctWord = self.currentWord
        self.OnDctViewEntry(0, fromLibRef)

        self.dctOld = ''
        self.SetDctFocus(None)

        # To make sure tab is visible
        self.dctNB.SetSelection(tab)

        title = 'Dictionary - %s' % self.dDescList[tab]
        pane = self.mainMgr.GetPane("Dictionaries")

        if pane.IsNotebookPage():
            self.doNotebookTitle(title)
        if pane.IsFloating():
            frameMgr = pane.frame.GetMgr()
            p = frameMgr.GetPane('Dictionaries')
            p.Caption(title)
            frameMgr.Update()
        else:
            pane.Caption(title)

        self.dctNB.Layout()
        wx.EndBusyCursor()
        self.Thaw()


    def OnCmtNBChanged(self, event, fromLibRef = 0):
        try:
            self.OnSaveNotes()
        except:
            pass
        
        if self.noCmtChange == True:
            return
        
        #print 'cmtChanged'
        
        wx.BeginBusyCursor()
        self.cmtTabIdx = self.cmtNB.GetSelection()

        #self.GetVerseList(self.cmtTabIdx -1)

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            ref = self.currentRef.replace('_', ' ')
        else:
            ref = self.fromBibRef

        self.fromBibRef = ref

        if self.bkChapRef:
            ref = self.bkChapRef
        
        if self.cmtTabIdx == 0:
            oldRef = self.currentRef
            self.currentRef = ref
            self.OnGetNotes()
            self.currentRef = oldRef
            ntTitle = ref

        self.CmtRef = ref
        
        if not fromLibRef and self.cmtTabIdx -1 in self.hitList:
            ref = self.hitList[self.cmtTabIdx -1]

        self.cmtEntry.SetValue(ref)
        
        self.Freeze()

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(707) == True:
            if self.cmtTabIdx -1 != self.verseListTab:
                self.GetVerseList(self.cmtTabIdx -1)
            self.cmtListbox.SetItemCount(len(self.currentVL))
            item = self.FindCmtEntry(self.cmtEntry.GetValue())
            if item:
                self.cmtListbox.EnsureVisible(item)
                #self.cmtListbox.Select(item)
        
        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(716) == True:
            self.OnToggleChap()
        else:
            self.OnCmtViewEntry(fromLibRef)
        
        self.nextCmt = 0

        if self.cmtTabIdx == 0:
            self.cmtNB._mainSizer.Show(1, False)
            self.commentarySizer.Show(1, False)
            self.commentarySizer.Layout()
            self.cmtNB.cmtPanel.miniTB.ToggleTool(707, False)
            title = 'Commentary - User Notes Editor - %s' % ntTitle
        else:
            self.cmtNB._mainSizer.Show(1, True)
            title = 'Commentary - %s - %s' % (self.cDescList[self.cmtTabIdx -1], ref)

        # Make sure tab is visible
        self.cmtNB.SetSelection(self.cmtTabIdx)

        pane = self.mainMgr.GetPane("Commentaries")

        #if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
        if pane.IsNotebookPage():
            self.doNotebookTitle(title)
        if pane.IsFloating():
            frameMgr = pane.frame.GetMgr()
            p = frameMgr.GetPane('Commentaries')
            p.Caption(title)
            frameMgr.Update()
        else:
            pane.Caption(title)

        self.cmtNB.Layout()
        
        self.DoCommentCheck(self.currentChap)
        
        wx.EndBusyCursor()
        self.Thaw()


    def OnResNBChanged(self, event):
        #self.Freeze()

        tab = self.resNB.GetSelection()
        self.resNB.resPanel.hitList.Show()
        self.resNB.resPanel.hitList.Enable(False)
        self.resNB.resPanel.wdList.Enable(False)

        if tab == 1 and not self.bookTitlesLoaded:
            #print 'res change tab 1'
            self.OnMasterControlMini(None, False)
            #try:
            self.cpMini.BookViewer.ShowRootItems()
            self.bookTitlesLoaded = True
            #except:
            #    pass


        elif tab > 1 and self.searchQList[tab -1] != '':
            self.resNB.resPanel.hitList.Enable(True)
            self.resNB.resPanel.wdList.Enable(True)
            self.resNB.resPanel.hitList.Clear()

            for vs in advSearch.masterVerseString[tab -2]:
                self.resNB.resPanel.hitList.Append(vs)
            self.resNB.resPanel.hitList.SetSelection(0)

        if tab == 0:
            self.resNB._mainSizer.Show(1, False)
        else:
            self.resNB._mainSizer.Show(1, True)

        title = '%s' % self.rDescList[tab]
        title = title.replace('|', ' or ')

        pane = self.mainMgr.GetPane("Results")

        if pane.IsNotebookPage():
            self.doNotebookTitle(title)
        if pane.IsFloating():
            frameMgr = pane.frame.GetMgr()
            p = frameMgr.GetPane('Results')
            p.Caption(title)
            frameMgr.Update()
        else:
            pane.Caption(title)

        self.resNB.Layout()
        self.SetResFocus(None)
        #self.Thaw()



    def doNotebookTitle(self, title):
        nb = self.mainMgr.GetNotebooks()[0]
        nbPane = self.mainMgr.GetPaneByWidget(nb)
        title = title.replace('|', ' or ')
        if nbPane.IsFloating():
            try:
                frameMgr = nbPane.frame.GetMgr()
            except:
                return
            p = frameMgr.GetPane(nbPane.name)
            p.Caption(title)
            frameMgr.Update()
        else:
            nbPane.Caption(title)


    def OnBkChapCmt(self, ref):
        #self.ClearCmtTabs()
        self.FlagCmtTabs(ref)

        self.bkChapRef = ref
        self.OnCmtNBChanged(None)




    ## Get word lists
    def GetWordList(self, tab):
        if tab == self.wordListTab:
            return
        
        self.wordListTab = tab
        self.currentWL = []
        fn = self.dctFileList[tab]
        
        con = sqlite.connect(fn)
        con.text_factory = str
        cur = con.cursor()

        cur.execute('SELECT topic FROM topics')

        start = time.time()
        for item in cur:

            try:
                item = unicode(item[0], "utf-8")
            except:
                item = unicode(item[0], "latin1")
                #print 'latin1 encoding'
            self.currentWL.append(item)



    def GetVerseList(self, tab):
        if tab == self.verseListTab:
            return
        self.verseListTab = tab

        self.currentVL = []
        try:
            fn = self.cmtFileList[tab]
        except:
            print 'GetVerseList error'
            self.verseListTab = 0
            fn = self.cmtFileList[0]

        con = sqlite.connect(fn)
        cur = con.cursor()
        cur.execute('SELECT ref FROM reference')

        for item in cur:
            self.currentVL.append(item[0])



    ## Get and save user notes
    def OnGetNotes(self):
        con = sqlite.connect(ur'%s/notes.usr' % self.userDir)
        con.text_factory = str
        cur = con.cursor()
        ref = self.currentRef.replace('_', ' ')
        cur.execute('SELECT comment FROM commentary WHERE ref = ?', (ref,))

        row = cur.fetchone()
        if row == None:
            self.notes.Clear()
            self.noteEdit.OnBasicStyle()
            return

        handler = rt.RichTextXMLHandler()
        stream = cStringIO.StringIO(row[0])

        #print stream.getvalue(), 'stream, open'
        handler.LoadStream(self.notes.GetBuffer(), stream)


    def OnSaveNotes(self):
        if self.notes.IsModified():

            con = sqlite.connect(ur'%s/notes.usr' % self.userDir)
            cur = con.cursor()

            handler = rt.RichTextXMLHandler()
            stream = cStringIO.StringIO()

            #print stream.getvalue(), 'stream, save'

            handler.SaveStream(self.notes.GetBuffer(), stream)
            ref = self.currentRef.replace('_', ' ')

            line = stream.getvalue()
            emptyLine = re.sub(r'<.+?>|"', '', line)
            if not re.search(r'\w', emptyLine):
                #print 'empty note'
                return

            cur.execute('SELECT ref FROM commentary WHERE ref = ?', (ref,))
            row = cur.fetchone()
            if row:
                cur.execute('UPDATE commentary SET comment = (?) WHERE ref = (?)', (line, ref))
                #print ref, 'appending note'
            else:
                cur.execute('INSERT into commentary VALUES (?, ?)', (ref, line))
                #print ref, 'adding note'
            con.commit()



    ## Make Container Cell List
    def makeConCellList(self):
        self.topCell = self.currBibDisplay.GetInternalRepresentation()
        contCell = self.topCell.GetFirstChild()

        temp = []
        while contCell:
            contCell = contCell.GetNext()
            if contCell != None:
                temp.append(contCell)

        self.contCellList = temp[2:-2]

        #print len(self.contCellList), 'contcell'

        self.oldCell = self.contCellList[0]

        if not self.verseInt:
            self.verseInt = 0



    def OnParallel(self):
        modFileList = []
        for abbr in self.paraTextList:
            try:
                idx = self.bAbbrList.index(abbr)
                pth = self.bibFileList[idx]
                modFileList.append(pth)
            except:
                continue
                
        wx.BeginBusyCursor()
        texts = normSearch.pView(self.currentChap, modFileList, self.font, self.showRed)

        title = 'Bible - Parallel View, %d Texts' % len(modFileList)

        page = self.FindWindowByName('Bib/Parallel')
        page.SetPage(texts)
        
        if '<a name="%s">' % self.currentRef in texts:
            page.ScrollToAnchor(self.currentRef)
            page.ScrollLines(-2)

        self.bibCurrent = texts

        pane = self.mainMgr.GetPane("Bible")
        pane.Caption(title)

        wx.EndBusyCursor()



    ## Tree Functions

    def OnSelChanged(self, event):
        if self.noTreeProcess == 1:
            #self.noTreeProcess = 0 This can't be here because event is called twice. 
            return
        
        #print 'onSelChanged'

        self.CheckTTSSpeak()
        self.bibAudioCheck()

        self.OnSaveNotes()

        select = self.Tree.GetSelection()
        self.treeSelect = select

        parent = self.Tree.GetItemParent(select)

        if parent == self.Tree.GetRootItem():
            currentChap = self.Tree.GetItemText(select)
            label = currentChap
            #selectRef = currentChap + ' 1:'
        else:
            label = self.Tree.GetItemText(parent)
            currentChap = label + ' ' + self.Tree.GetItemText(select) + ':'

        selectRef = currentChap

        #self.noTreeProcess = 0
        self.verseInt = 0

        if not self.noChangeRef:
            self.currentRef = selectRef
            self.currentChap = selectRef

        self.OnChapDisplay(selectRef)

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            #self.ClearCmtTabs()
            self.FlagCmtTabs(self.currentRef)

            self.OnCmtNBChanged(None)

            self.cmtNB.cmtPanel.miniTB.ToggleTool(715, False)
            #self.cmtNB.cmtPanel.miniTB.ToggleTool(711, False)
            #self.cmtNB.cmtPanel.miniTB.ToggleTool(713, False)
            
            self.DoCommentCheck(self.currentChap)

            if self.currentRef[-1] == ':':
                self.cmtNB.cmtPanel.miniTB.ToggleTool(713, True)
            else:
                self.cmtNB.cmtPanel.miniTB.ToggleTool(711, True)
                
        wx.CallAfter(self.SetBibFocus, None)
    

    def DoCommentCheck(self, ref):
        self.cmtNB.cmtPanel.miniTB.EnableTool(711, False)
        self.cmtNB.cmtPanel.miniTB.EnableTool(713, False)
        
        bk = ref[:3]
        chap = None
        if ':' in ref:
            idx = ref.find(':')
            chap = ref[:idx +1]
        
        if bk in self.currentVL:
            self.cmtNB.cmtPanel.miniTB.EnableTool(711, True)
        if chap and chap in self.currentVL:
            self.cmtNB.cmtPanel.miniTB.EnableTool(713, True)



    def OnChapDisplay(self, selectRef):

        origRef = selectRef

        if selectRef[-1] != ':':
            selectRef = '%s 1:' % selectRef

        tab = self.bibNB.GetSelection()
        tabLabel = self.bibNB.GetPageText(tab)

        if tabLabel == 'Parallel':
            self.StatusUpdate()
            self.OnParallel()
            return

        self.Freeze()

        self.paragraph = 0
        answer = normSearch.nView(selectRef, '1', self.bibFileList[tab], self.font, self.showRed, self.showText, self.showStrongs, self.paragraph, 1)
        #print answer.encode('utf-8')

        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        display = self.bibDisplay[tab]
        display.SetPage(answer)

        self.bibCurrent = answer

        self.makeConCellList()

        if not self.noChangeRef:
            self.currentChap = selectRef
            statText = 'Current Ref: %s' % origRef
            self.statusbar.SetStatusText(statText, 1)

        #if self.currentRef not in self.Menu.QSentry.GetStrings():
        #    self.Menu.QSentry.Append(self.currentRef)
        self.Menu.QSentry.ChangeValue(self.currentRef)
        
        self.bibNB.bibPanel.InsertBibRef(self.currentRef)
        
        #if self.currentRef not in self.verseHistory:
        #    if len(self.verseHistory) > 7:
        #        self.verseHistory = self.verseHistory[1:]
        #    self.verseHistory.append(self.currentRef)

        self.SetBibFocus(None)
        
        self.checkRefNB()
        
        self.bkChapRef = None

        self.OnGetNotes()
        self.Thaw()


    def treeCollapse(self, event):
        self.Freeze()
        def collTree(node):
            try:
                if self.Tree.IsExpanded(node):
                    self.Tree.Collapse(node)
                next = self.Tree.GetNextSibling(node)
                collTree(next)
            except:
                try:
                    self.Tree.SelectItem(self.treeSelect)
                except:
                    pass
                return
        root = self.Tree.GetRootItem()
        child, cookie = self.Tree.GetFirstChild(root)
        collTree(child)
        self.Thaw()


    ## Bible Window Functions

    def OnBibClicked(self, event):
        event.Skip()
        self.bibAudioCheck()
        self.CheckTTSSpeak()

        idLink = None
        currentCell = event.GetCell()
        if currentCell.GetLink():
            idLink = currentCell.GetLink().GetHref()

        containerCell = currentCell.GetParent()
        firstCell = containerCell.GetFirstChild()

        tab = self.bibNB.GetSelection()
        tabLabel = self.bibNB.GetPageText(tab)

        if tabLabel == 'Parallel':
            while firstCell:
                if firstCell.ConvertToText(None):
                    abbr = firstCell.ConvertToText(None)
                firstCell = firstCell.GetNext()

            self.parallelBibClick =  abbr[1:-1]

            self.OnDictClicked(event)
            return

        self.OnSaveNotes()
        
        firstCell = containerCell.GetFirstChild()
        while firstCell:
            if not isinstance(firstCell, wx.html.HtmlWordCell):
                firstCell = firstCell.GetNext()
            else:
                ref = firstCell.ConvertToText(None)
                ref = ref.strip()

                if self.fullBibRef == 1:
                    if not ':' in ref:
                        firstCell = firstCell.GetNext()
                    else:
                        idx = ref.find(':')
                        ref = ref[idx +1:]
                        #print ref, 'fc'
                        break
                else:
                    if ref == '' or not ref[0].isdigit():
                        firstCell = firstCell.GetNext()
                    else:
                        break

        if firstCell == None:
            #print 'firstcell none'
            return

        #first = firstCell.ConvertToText(None)
        #print first, 'first'

        # To not allow chap heading to be selected.
        if self.fullBibRef == 0:
            if not ',' in ref:
                return

        word = currentCell.ConvertToText(None)
        isRef = re.search(r'\d:\d', word)

        word = word.strip()
        ref = ref.strip(' ''\n')
        
        if word == '':
            return

        #if re.search(r'\w \w|\s\s+', word):
        #    return

        ref = ref.strip(',')
        self.origRef = ref

        if len(self.currentChap) == 3:
            self.currentChap = self.currentChap + ' 1:'

        ref = self.currentChap + ref
        self.bkChapRef = None

        # Make sure verse button is on
        self.DoCommentCheck(self.currentChap) 
        self.cmtNB.cmtPanel.miniTB.ToggleTool(715, True)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(711, False)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(713, False)

        mButton = event.GetMouseEvent().GetButton()
        if mButton == 1:

            if self.oldCell and tabLabel != 'Parallel':
                self.oldCell.SetBackgroundColour(wx.Colour(255, 255, 255))
                
            if tabLabel != 'Parallel':
                containerCell.SetBackgroundColour(self.backColor)
                #containerCell.SetBorder(wx.Colour(155, 100, 100), wx.Colour(155, 100, 100))

            self.Refresh()
            self.oldCell = containerCell

            try:
                self.verseInt = int(self.origRef)
            except:
                print 'Exception:, BibClicked 1777'
                return

            self.currentRef = ref
            self.StatusUpdate()

            #if ref not in self.Menu.QSentry.GetStrings():
            #    self.Menu.QSentry.Append(ref)
            
            self.Menu.QSentry.ChangeValue(ref)
            
            self.bibNB.bibPanel.InsertBibRef(self.currentRef)
            
            #if ref not in self.verseHistory:
            #    if len(self.verseHistory) > 7:
            #        self.verseHistory = self.verseHistory[1:]
            #    self.verseHistory.append(ref)
                
            self.bibWordClick = False

            dctDefaultState = True
            cmtDefaultState = True
            if wx.GetKeyState(wx.WXK_CONTROL):
                if self.dctNB.dctPanel.miniTB.GetToolToggled(613) == False:
                    self.dctNB.dctPanel.miniTB.ToggleTool(613, True)
                    dctDefaultState = False
                if self.cmtNB.cmtPanel.miniTB.GetToolToggled(714) == False:
                    self.cmtNB.cmtPanel.miniTB.ToggleTool(714, True)
                    cmtDefaultState = False
            
            if word[-1] == ',' and word[:-1].isdigit() or isRef: #or wx.GetKeyState(wx.WXK_CONTROL) 
                #print ref, 'bibref'
                self.OnBibRef(ref)
            elif self.useMini == True:
                #print 'bib2'
                self.OnBibWord(word)
            else:
                #print ref, 'bibword'
                self.bibWordClick = True
                self.OnBibRef(ref)
                self.OnBibWord(word)
                
            if dctDefaultState == False:
                self.dctNB.dctPanel.miniTB.ToggleTool(613, False)
            if cmtDefaultState == False:
                self.cmtNB.cmtPanel.miniTB.ToggleTool(714, False)
            
            self.checkRefNB()
            self.parallelBibClick = None

        if mButton == 3:
            if word[-1] == ',' and word[:-1].isdigit() or wx.GetKeyState(wx.WXK_CONTROL):
                self.MakeContextMenu(None, ref, None)
            else:
                self.MakeContextMenu(word, ref, None, idLink)
        

    def OnBibCrossRef(self, ref):
        if self.bibMgr.GetPane('Ref Panel').IsShown():

            if 'TSKe' in self.cAbbrList:
                answer = normSearch.showTsk(ref, self.cmtFileList[self.cAbbrList.index('TSKe')], self.font, '#E6EEF0', 'TSKe')
                label = 'TSKe - %s' % self.currentRef

            elif 'TSK' in self.cAbbrList:
                answer = normSearch.showTsk(ref, self.cmtFileList[self.cAbbrList.index('TSK')], self.font, '#E6EEF0', 'TSK')
                label = 'TSK - %s' % self.currentRef
            else:
                answer = '<body bgcolor="%s"><font face="Georgia"><center>Download Free TSKe and Other Modules From,<br>\
                <a href="http://www.BibleAnalyzer.com/modules.htm">Bible Analyzer Modules Page</a></center></font>' % '#E6EEF0'
                label = 'TSK - None'
            
            if self.fontSize > 0:
                answer = '<font size="+%s">%s</font>' % (self.fontSize -1, answer)
            else:
                answer = '<font size="-1">%s</font>' % answer
                
            self.bibRefWin.SetPage(answer)
            #self.bibMgr.GetPane('Ref Panel').Caption('Cross-References')
            #self.bibMgr.Update()


    def OnBibWord(self, word):
        word = re.sub(r'[\(\)\[\],.;:!\? ]+', '', word)
        if len(word) == 0:
            return

        #print word.encode('utf-8')

        #Selection is a word
        if re.search(r'^[GH]\d+', word):
            self.GoToStrongs(word)

        else:
            if self.dctNB.dctPanel.miniTB.GetToolToggled(605) == True:
                saveDictMini = self.useMini

                maxPane = self.getMaximized()
                bibPane = self.mainMgr.GetPaneByWidget(self.bibRefPanel)

                if self.bibExpandMW == True and maxPane == bibPane and not wx.GetKeyState(wx.WXK_CONTROL):
                    self.useMini = True
                    #self.mainMgr.Update()

                #if not wx.GetKeyState(wx.WXK_CONTROL):
                self.contextMenu.DctCmtLookup(word)

                self.useMini = saveDictMini
                #self.mainMgr.Update()

        self.SetBibFocus(None)
        #print 'set bib'
        #self.Refresh()


    def getMaximized(self):
        for p in self.mainMgr.GetAllPanes():
            if p.IsMaximized():
                return p
        return None

    def getBibPane(self):
        return self.mainMgr.GetPaneByWidget(self.bibRefPanel)

    def getDctPane(self):
        return self.mainMgr.GetPaneByWidget(self.dctPanel)

    def getResPane(self):
        return self.mainMgr.GetPaneByWidget(self.resNB)

    def getCmtPane(self):
        return self.mainMgr.GetPaneByWidget(self.commentaryPanel)



    def OnBibRef(self, ref):
        self.OnGetNotes()
        focus = self.FindFocus()
        
        #print focus.GetName()
        
        self.currentRef = ref

        saveTskMini = self.useMini

        if self.bibExpandMW == True and self.getMaximized():
           self.useMini = True

        #Check if should go to MiniFrame
        if self.useMini == True or \
        self.bibExpandMW == 1 and focus.GetName() == 'Parallel' or \
        self.bibExpandMW == 1 and focus.GetName() == 'Dual':

            #self.ClearCmtTabs()
            self.FlagCmtTabs(ref)

            self.displayMiniWin()
            self.OnCmtNBChanged(None)
            self.SetBibFocus(None)
            return

        if self.useMini == False:
            self.cmtEntry.SetValue(self.currentRef)

            if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
                #self.ClearCmtTabs()
                self.FlagCmtTabs(ref)

                if self.getMaximized() and self.jumpState == True:
                    #maxPane = self.getMaximized()
                    #if maxPane and maxPane == self.getBibPane() or maxPane == self.getResPane():
                        #self.mainMgr.RestoreMaximizedPane()
                        #if self.getCmtPane().IsNotebookPage():
                        #    nb = self.mainMgr.GetNotebooks()[0]
                        #    nbInfo = self.mainMgr.GetPane(nb)
                        #    self.mainMgr.MaximizePane(nbInfo)
                        #else:
                        #    self.mainMgr.MaximizePane(self.getCmtPane())
                    
                    self.mainMgr.RestoreMaximizedPane()
                    self.mainMgr.Update()

                if self.cmtNB.cmtPanel.miniTB.GetToolToggled(714) == True:
                    tab = self.defaultCmtIdx +1
                    self.cmtNB.SetSelection(tab)

                self.OnCmtNBChanged(None)
                self.SetBibFocus(None)

        statText = 'Current Ref: %s' % self.currentRef
        self.statusbar.SetStatusText(statText, 1)

        #if self.currentRef not in self.Menu.QSentry.GetStrings():
        #    self.Menu.QSentry.Append(self.currentRef)
        self.Menu.QSentry.ChangeValue(self.currentRef)

        self.useMini = saveTskMini



    ## Quick Search Functions
        
    def OnSearch(self, event):
        if not self.Menu.QSentry.GetValue():
            return

        entry = self.Menu.QSentry.GetValue().strip()
        #print entry, 'entry'
        ref = re.search(r'\d[:.]', entry)
        if ref or entry[-1].isdigit():
            #print 'is ref'
            self.ParseEntry(entry)
            return

        if self.cpMini == None:
            self.OnMasterControlMini(None, 0)
        self.cpMini.LBook.SetSelection(0)
        self.cpMini.FromQuickSearch(entry)


    def ParseEntry(self, origRef):
        try:
            fn = self.bibFileList[self.bibNB.GetSelection()]
        except:
            fn = self.bibFileList[self.avIndex]
        
        ref = re.sub(r'([a-z])-(\d)', r'\1 \2', origRef)
        
        if ref.isdigit():
            ref = '%s%s' % (self.currentChap, ref)
        elif ref[:-1].isdigit() and re.match(r'[:.]', ref[-1]):
            ref = ref.replace('.', ':')
            ref = '%s %s' % (self.currentChap[:3], ref)
        elif re.match(r'\d+[:.]\d+', ref):
            ref = '%s %s' % (self.currentChap[:3], ref)
            
        #print ref, 'ref'

        ref = fixRef.parseRef(ref, fn, 1)

        if not ':' in ref and ref[-1].isdigit():
            ref = ref + ':'
        if not ' ' in ref:
            ref = ref + ' 1:'
        if '-' in ref:
            idx = ref.find('-')
            ref = ref[:idx]

        self.ShowRefContext(ref)
        self.SetBibFocus(None)
        #print self.FindFocus(), 'qe'


    def OnQuickSort(self, event):
        item = self.Menu.QSentry.GetStringSelection()
        ref = re.search(r'\d[: .]', item)
        if ref:
            self.ShowRefContext(item)
        else:
            if self.cpMini == None:
                self.OnMasterControlMini(None, 0)
            self.cpMini.LBook.SetSelection(0)
            self.cpMini.FromQuickSearch(item)



    ## Focus and Border
    def SetBibFocus(self, event):
        if event:
            event.Skip()
        tab = self.bibNB.GetSelection()
        self.bibDisplay[tab].SetFocus()
        self.OnSetBorder(None)

    def SetDctFocus(self, event):
        if event:
            event.Skip()
        tab = self.dctNB.GetSelection()
        self.dctDisplay[tab].SetFocus()
        self.OnSetBorder(None)

    def SetResFocus(self, event):
        if event:
            event.Skip()
        tab = self.resNB.GetSelection() -1

        if tab > -1:
            self.resDisplay[tab].SetFocus()
        else:
            self.editor.SetFocus()

        self.OnSetBorder(None)

    def SetCmtFocus(self, event):
        if event:
            event.Skip()
        tab = self.cmtNB.GetSelection() -1
        if tab > -1:
            self.cmtDisplay[tab].SetFocus()
        else:
            self.notes.SetFocus()

        self.OnSetBorder(None)


    def OnSetBorder(self, event):
        #return
        focus = self.FindFocus()
        if focus:
            panel = focus.GetParent()
        else:
            return

        if self.oldWin:
            self.oldWin.SetBackgroundColour(wx.Colour(200, 200, 200))
        panel.SetBackgroundColour(wx.Colour(0, 0, 200))

        self.oldWin = panel
        self.Refresh()



    ## Dictionary Window Functions
    def OnDictClicked(self, event):
        bk = None
        focus = self.FindFocus()
        if focus == self.resDisplay[0] or focus == self.bkWinDisplay:
            bk = 1

        mButton = event.GetMouseEvent().GetButton()

        cell = event.GetCell()
        if cell.GetLink() and mButton != 3:
            event.Skip()
            print 'in ret'
            return

        idLink = None
        if cell.GetLink():
            lnk = cell.GetLink().GetHref()
            if 'bible://' in lnk:
                select = lnk[8:]
            elif 'dict/ExLBP://' in lnk:
                select = cell.ConvertToText(None)
                idLink = lnk 
            else:
                return
        else:
            select = cell.ConvertToText(None)

        #print select, 'dict clicked'

        if not select or select == ' ':
            return

        select = select.strip()

        #if len(select) > 1 and select[0] == 'H' and select[1:].isdigit() or len(select) > 1 and select[0] == 'G' and select[1:].isdigit():
        if re.search(r'^[GH]\d+', select):
            self.GoToStrongs(select)

        if focus.GetName() == 'Dual' or focus.GetName() == 'Parallel':
            containerCell = cell.GetParent()
            firstCell = containerCell.GetFirstChild()

            while firstCell:
                if not isinstance(firstCell, wx.html.HtmlWordCell):
                    firstCell = firstCell.GetNext()
                else:
                    vs = firstCell.ConvertToText(None)
                    vs = vs.strip()
                    if self.fullBibRef == 1:
                        if not ':' in vs:
                            firstCell = firstCell.GetNext()
                        else:
                            idx = vs.find(':')
                            vs = vs[idx +1:]
                            break
                    else:
                        if vs == '' or not vs[0].isdigit():
                            firstCell = firstCell.GetNext()
                        else:
                            break

            vs = vs.strip(',')

            if focus.GetName() == 'Dual':
                sel = self.cpMini.Dual.Tree2.GetSelection()
                parent = self.cpMini.Dual.Tree2.GetItemParent(sel)
                label = self.cpMini.Dual.Tree2.GetItemText(parent) + ' '
                chap = label + self.cpMini.Dual.Tree2.GetItemText(sel) + ':'
                self.dualBibIdx = self.cpMini.Dual.choice2.GetSelection()
                self.fromDual = True

            else:
                chap = self.currentChap

            ref = chap + vs

        if mButton == 1:
            if select and select[-1] == ',' and select[:-1].isdigit() or re.search(r'_\d+:', select):
                select = select.replace('_', ' ')
                self.ShowRefContext(select)
            else:
                if self.dctNB.dctPanel.miniTB.GetToolToggled(605) == True:
                    self.OnSelect(select)


        if mButton == 3:
            if re.search(r'[_ ]\d+:\d', select):
                select = select.replace('_', ' ')
                select = select.replace(',', '')  # For Harmony verse
                self.MakeContextMenu(None, select, None)
            else:
                if focus.GetName() == 'Dual' or focus.GetName() == 'Parallel':
                    self.MakeContextMenu(select, ref, bk)
                else:
                    self.MakeContextMenu(select, None, bk, idLink)


    def OnSelect(self, select):
        if '_' not in select:
            #select = select.capitalize()
            select = re.sub(r'[.,:;?!"-\(\)\[\] ]+', '', select)
            if len(select) == 0:
                return
            
            select = select.title()
            self.dctEntry.SetValue(select)

            self.contextMenu.DctCmtLookup(select)
            self.mainMgr.Update()
            return

        select = select.replace('_', ' ')
        select = select.title()
        self.ShowRefContext(select)


    def ShowRefContext(self, select, save = True):
        
        self.bibNB.bibPanel.InsertBibRef(self.currentRef)
        
        #if select not in self.verseHistory:
        #    if len(self.verseHistory) > 7:
        #        self.verseHistory = self.verseHistory[1:]
        #    self.verseHistory.append(select)
            
        self.CheckTTSSpeak()
        self.bibAudioCheck()

        # Make sure verse button is on
        self.DoCommentCheck(self.currentChap)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(715, True)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(711, False)
        self.cmtNB.cmtPanel.miniTB.ToggleTool(713, False)

        #print select, 'ShowRefContext'

        if save:
            self.OnSaveNotes()

        try:
            treeRef = self.Tree.bookId[select[:3]]
        except:
            print select, 'Exception, ShowRefContext, 2531'
            return

        self.noTreeProcess = 1
        self.Tree.SelectItem(treeRef)
        self.noTreeProcess = 0

        if '-' in select:
            select = re.match(r'(.+)-', select).group(1)


        if len(select) == 3:
            select = select + ' 1:'

        try:
            chapRef = re.match('(.*:)', select) .group(1)
        except:
            return

        self.currentChap = chapRef.replace(r'_', r' ')

        self.currentRef = select

        tab = self.bibNB.GetSelection()
        tabLabel = self.bibNB.GetPageText(tab)

        #if tabLabel == 'Parallel':
        #    self.OnParallel()
        #    return

        self.Freeze()

        self.OnChapDisplay(self.currentChap)
        self.StatusUpdate()


        if select[-1] == ':' or len(select) == 3:
            if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
                self.bkChapRef = None
                #self.ClearCmtTabs()
                self.FlagCmtTabs(self.currentRef)
                self.OnCmtNBChanged(None)

            if self.jumpState == True and self.getMaximized():
                self.mainMgr.RestoreMaximizedPane()
                self.mainMgr.MaximizePane(self.getBibPane())
                self.mainMgr.Update()

            self.Thaw()
            return

        try:
            verseRef = re.match('.*:(\d+)', select) .group(1)
        except:
            return

        display = self.bibDisplay[tab]

        currentRef = chapRef + verseRef
        self.currentRef = currentRef.replace(r'_', r' ')

        display.SetLabel('Context Results')

        if '<a name=' in self.bibCurrent:
            display.ScrollToAnchor(select)
            display.ScrollLines(-2)

        add = 0
        #if self.showBibSum == 1:
        #    add = 1

        self.makeConCellList()
        self.oldCell.SetBackgroundColour(wx.Colour(255, 255, 255))

        # Return if verse not found (wrong testament)
        try:
            new = self.contCellList[int(verseRef) -1 +add]
        except:
            self.Thaw()
            return

        new.SetBackgroundColour(self.backColor)
        self.oldCell = new

        self.verseInt = int(verseRef)

        #if self.currentRef not in self.Menu.QSentry.GetStrings():
        #    self.Menu.QSentry.Append(self.currentRef)
        self.Menu.QSentry.ChangeValue(self.currentRef)

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            self.bkChapRef = None
            #self.ClearCmtTabs()
            self.FlagCmtTabs(self.currentRef)

        #Check if should go to MiniFrame
        if self.useMini == True:
            tab = self.cmtNB.GetSelection() -1
            title = self.cDescList[tab]

            cmtAnswer, fNames = normSearch.showLibTopic(self.currentRef, self.cmtFileList[tab], self.font, self.cmtColor, title, 1)

            self.OnDictMini(cmtAnswer, title, fNames)
            self.miniWin.type = 0

            default = ''
            self.miniWin.hitList.Clear()
            for item in self.cmtFlagList:
                cmt = self.cAbbrList[item -1]
                if item == tab +1:
                    default = cmt
                self.miniWin.hitList.Append(cmt)

            self.miniWin.hitList.SetStringSelection(default)
            self.miniWin.sizer2.Show(0, True)
            self.miniWin.sizer2.Layout()

        #else:
        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            self.OnCmtNBChanged(None)

        if self.getMaximized() and self.jumpState == True:
            self.mainMgr.RestoreMaximizedPane()
            self.mainMgr.MaximizePane(self.getBibPane())
            self.mainMgr.Update()

        self.checkRefNB()
        

        self.SetBibFocus(None)

        self.OnGetNotes()

        self.Refresh()
        self.Thaw()


    def GoToStrongs(self, word):
        word = word.capitalize()

        if self.strongIndex == None:
            return

        tab = self.strongIndex
        title = self.dDescList[tab]
        self.dctEntry.SetValue(word)

        self.FlagTabs(word)
        self.currentWord = word

        saveDictMini = self.useMini

        bibPane = self.mainMgr.GetPaneByWidget(self.bibRefPanel)
        if self.bibExpandMW == True and bibPane == self.getMaximized() and not wx.GetKeyState(wx.WXK_CONTROL):
            self.useMini = True

        if self.useMini == True and not wx.GetKeyState(wx.WXK_CONTROL):
            dctAnswer, fNames = normSearch.showLibTopic(word, self.dctFileList[tab], self.font, self.dctColor, title, 0)
            title = self.dDescList[tab]
            self.OnDictMini(dctAnswer, title, fNames)
            self.miniWin.type = 1

            default = ''
            self.miniWin.hitList.Clear()
            for item in self.dctFlagList:
                dct = self.dAbbrList[item]
                if item == tab:
                    default = dct
                self.miniWin.hitList.Append(dct)

            self.miniWin.hitList.SetStringSelection(default)
            self.miniWin.sizer2.Show(0, True)
            self.miniWin.sizer2.Layout()
            self.useMini = saveDictMini
            return

        if self.getMaximized() and self.jumpState == True:
            self.mainMgr.RestoreMaximizedPane()
            #self.mainMgr.MaximizePane(self.getDctPane())
            self.mainMgr.Update()

        self.useMini = saveDictMini

        self.dctNB.SetSelection(tab)
        self.OnDctNBChanged(None)

        self.OnDctViewEntry()


    ## Flag Tabs Functions
    def ClearTabs(self):
        count = self.dctNB.GetPageCount()
        count = int(count)
        while count >= 0:
            self.dctNB.SetPageImage(count, -1)
            count = count - 1


    def FlagTabsThread(self, entry):
        thread.start_new_thread(self.DoFlagDctTabs, (entry,))


    
    def FlagTabs(self, entry):
        #entry = entry.capitalize()
        #if self.lastDctFlagEntry and entry == self.lastDctFlagEntry:
        #    return
        
        self.ClearTabs()
        
        idx = 0
        self.dctFlagList = []
        flagged = 0

        start = time.time()

        for dct in self.dctFileList:
            temp = []
            con = sqlite.connect(dct)
            cur = con.cursor()
            try:
                cur.execute('SELECT topic FROM topics WHERE topic=?', (entry,))
                row = cur.fetchone()
            except:
                print 'flag tab error'
                continue

            if row:
                self.dctNB.SetPageImage(idx, 0)
                self.dctFlagList.append(idx)
            idx += 1
        
        self.lastDctFlagEntry = entry
        print time.time() - start, 'flag dct time'


    def FlagNotes(self, ref):
        con = sqlite.connect(ur'%s/notes.usr' % self.userDir.encode('utf-8'))
        cur = con.cursor()
        cur.execute('SELECT comment FROM commentary WHERE ref = ?', (ref,))

        row = cur.fetchone()
        if row:
            #print 'notes hit'
            self.cmtNB.SetPageImage(0, 0)


    def ClearCmtTabs(self):
        count = self.cmtNB.GetPageCount()
        count = int(count)
        while count >= 0:
            self.cmtNB.SetPageImage(count, -1)
            count = count - 1

    
    def FlagCmtTabsThread(self, verse):
        thread.start_new_thread(self.DoFlagCmtTabs, (verse,))


    def FlagCmtTabs(self, verse):
        start = time.time()
        
        self.ClearCmtTabs()
        
        verse = verse.replace('_', ' ')
        self.FlagNotes(verse)
        self.hitList = {}

        def Flag(idx):
            idx = idx+1
            self.cmtNB.SetPageImage(idx, 0)
            self.cmtFlagList.append(idx)

        idx = 0
        self.cmtFlagList = []

        chapIdx = verse.find(':')

        for cmt in self.cmtFileList:
            temp = []
            con = sqlite.connect(cmt)
            cur = con.cursor()
            cur.execute('SELECT ref FROM reference WHERE ref =?', (verse,))

            row = cur.fetchone()
            if row:
                Flag(idx)
            else:
                cur.execute('SELECT ref FROM reference WHERE ref LIKE ?', (verse[:3]+'%',))

                for ref in cur:
                    ref = ref[0]
                    if ref == verse: # If ref is a chapter 'Rom 1:'
                        Flag(idx)
                        break
                    
                    # For refs that span chapters, 'Rom 2:1-3:23'
                    if '-' in ref and ref.count(':') > 1 and verse[-1].isdigit():  
                        range = re.search(r'\w\w\w (\d+:\d+)-(\d+:\d+)', ref)
                        
                        vsIdx = fixRef.flagIdx(verse)
                        
                        try:
                            firstIdx = fixRef.flagIdx(verse[:3] + ' ' + range.group(1))
                            lastIdx = fixRef.flagIdx(verse[:3] + ' ' + range.group(2))
                        except:
                            print 'flag cmt error'
                            continue
                        
                        if vsIdx >= firstIdx and vsIdx <= lastIdx:
                            Flag(idx)
                            self.hitList[idx] = ref
                            break
                        
                    range = re.search(r'\d+:(\d+)-(\d+)', ref)
                    vsParse = re.search(r'\w\w\w \d+:(\d+)', verse)
                    if range and vsParse and verse[:chapIdx+1] == ref[:chapIdx+1]:
                        vsIdx = ref.find('-')
                        if ref[:vsIdx] == verse:
                            Flag(idx)
                            self.hitList[idx] = ref
                            break
                        
                        vsNum = int(vsParse.group(1))
                        first = int(range.group(1))
                        last = int(range.group(2))

                        if first <= vsNum <= last:
                            Flag(idx)
                            self.hitList[idx] = ref
                            break

            idx += 1
        
        print time.time() - start, 'cmt flag time'



    ## Dictionary and Commentary listbox functions
    def FindDctEntry(self, entry, fromTyping = 0):
        data = self.currentWL
        for word in data:
            lowWord = word.lower()
            if lowWord.startswith(entry.lower()):
                return data.index(word)
        if fromTyping:
            for word in data:
                lowWord = word.lower()
                if entry.lower() in lowWord:
                    return data.index(word)

        return 0

    def FindCmtEntry(self, entry):
        lenth = len(entry)
        data = self.currentVL
        for word in data:
            if word.startswith(entry):
                return data.index(word)
        return 0



    # Text entered into LibEntry. Search for match in LibListBox
    def OnDctEntry(self, event):
        event.Skip()
        entry = self.dctEntry.GetValue()
        item = self.FindDctEntry(entry, 1)
        self.noDctUpdate = 1
        self.dctListbox.Select(item)
        self.dctListbox.EnsureVisible(item)


    def OnCmtEntry(self, event):
        entry = self.cmtEntry.GetValue()
        item = self.FindCmtEntry(entry)
        self.noCmtUpdate = 1
        self.cmtListbox.Select(item)
        self.cmtListbox.EnsureVisible(item)


    # When Enter is hit while typing in Entrybox
    def OnDctEnter(self, event):
        item = self.dctListbox.GetFirstSelected()
        word = self.dctListbox.GetItemText(item)
        self.noDctUpdate = 0

        self.currentWord = word
        self.dctEntry.SetValue(word)
        self.dctEntry.Append(word)
        self.OnDctViewEntry()

    def OnCmtEnter(self, event):
        item = self.cmtListbox.GetFirstSelected()
        ref = self.cmtListbox.GetItemText(item)
        self.noCmtUpdate = 0

        self.CmtRef = ref
        self.cmtEntry.SetValue(ref)
        self.OnCmtViewEntry()


    def RemoveImages(self, imList):
        for fn in imList:
            try:
                self.memFs.RemoveFile(fn)
                #print 'removed', fn
            except:
                print 'No image to remove!'

   
    # Displays the selection
    def OnDctViewEntry(self, noFlag = 0, fromLink = False):

        tab = self.dctNB.GetSelection()
        title = self.dDescList[tab]
        word = self.dctEntry.GetValue()

        if not self.dctNB.dctPanel.fromDctBack and noFlag == 0:
            self.FlagTabs(self.currentWord)

        statText = 'Current Word: %s' % self.currentWord
        self.statusbar.SetStatusText(statText, 2)
        
        #print word, 'word'

        answer, imgNames = normSearch.showLibTopic(word, self.dctFileList[tab], self.font, self.dctColor, title, 0)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)
            
        if self.dctSearchTerm:
            cp = re.compile(r'\b(%s)\b' % self.dctSearchTerm, re.I)
            answer = cp.sub(r'<a name="line"><font color="#E44B00"><b>\1</b></font></a>', answer)
                    
        self.dctDisplay[tab].SetPage(answer)

        dctPane = self.getDctPane()
        if dctPane.IsNotebookPage():
            nb = dctPane.window.GetParent()
            nb.SetSelectionToWindow(dctPane.window)
        
        if self.jumpState == True and self.getMaximized() and fromLink:
            #if dctPane.IsNotebookPage():
            #    self.Menu.doMax(dctPane, 'Dictionaries')
            #else:
            self.mainMgr.RestoreMaximizedPane()
            #    self.mainMgr.MaximizePane(dctPane)
            self.mainMgr.Update()
        
        if dctPane.IsClosed():
            dctPane.Show().NotClosed()
            self.mainMgr.Update()
        
        if imgNames:
            self.RemoveImages(imgNames)

        if self.dctNB.dctPanel.fromDctBack:
            self.dctNB.dctPanel.fromDctBack = None
        else:
            self.dctHistory.append((tab, word))
            self.dctNB.dctHistoryIdx = -1

        self.dctCurrent = answer
        self.dctWord = word


    def OnCmtViewEntry(self, fromLink = False):
        
        tab = self.cmtTabIdx -1
        ref = self.cmtEntry.GetValue()
        title = self.cDescList[tab]
        
        #print tab, title, ref, 'cmtview'
        
        self.CmtRef = ref
        answer, imgNames = normSearch.showLibTopic(ref, self.cmtFileList[tab], self.font, self.cmtColor, title, 1)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)
        
        if self.cmtSearchTerm:
            cp = re.compile(r'\b(%s)\b' % self.cmtSearchTerm, re.I)
            answer = cp.sub(r'<a name="line"><font color="#E44B00"><b>\1</b></font></a>', answer)
        
        self.cmtDisplay[tab].SetPage(answer)


        cmtPane = self.getCmtPane()
        #print cmtPane.IsShown(), 'cmt is shown'
        
        if self.bibWordClick == False and cmtPane.IsNotebookPage():
            nb = cmtPane.window.GetParent()
            nb.SetSelectionToWindow(cmtPane.window)
            self.bibWordClick = False
        
        if self.jumpState == True and self.getMaximized() and fromLink:
            #if cmtPane.IsNotebookPage():
            #    self.Menu.doMax(cmtPane, 'Commentaries')
            #else:
            self.mainMgr.RestoreMaximizedPane()
            #    self.mainMgr.MaximizePane(cmtPane)
            self.mainMgr.Update()
        
        if cmtPane.IsClosed():
            cmtPane.Show().NotClosed()
            self.mainMgr.Update()

        if imgNames:
            self.RemoveImages(imgNames)

        if self.cmtNB.cmtPanel.fromCmtBack:
            self.cmtNB.cmtPanel.fromCmtBack = None
        else:
            if tab +1 != 0:
                self.cmtHistory.append((tab +1, ref))
            self.cmtNB.cmtHistoryIdx = -1
            
        self.DoCommentCheck(ref)

        self.cmtCurrent = answer


    # Selection in Entry box
    def OnDctEntrySel(self, event):
        self.Freeze()
        self.OnDctViewEntry()
        self.Thaw()

    def OnCmtEntrySel(self, event):
        self.Freeze()
        self.OnCmtViewEntry()
        self.Thaw()


    # Selection clicked in LibListbox
    def OnDctSelView(self, event):
        #word = event.GetText()
        currentItem = event.m_itemIndex
        word = self.dctListbox.GetItemText(currentItem)
        self.currentWord = word
        
        #print word, 'word'
        
        if self.noDctUpdate:
            self.noDctUpdate = 0
            return
        
        self.Freeze()
        self.dctEntry.SetValue(word)
        self.OnDctViewEntry()
        self.dctEntry.Append(word)
        self.Thaw()

    def OnCmtSelView(self, event):
        #ref =  event.GetText()
        currentItem = event.m_itemIndex
        ref = self.cmtListbox.GetItemText(currentItem)
        
        if self.noCmtUpdate:
            self.noCntUpdate = 0
            return
        
        self.Freeze()
        self.cmtEntry.SetValue(ref)
        self.OnCmtViewEntry()
        self.cmtEntry.Append(ref)
        self.Thaw()


    def MakeContextMenu(self, popWord, ref, bk, lnk = None):
        cm = contextMenu.ContextMenu(self)
        cm.MakeMenu(popWord, ref, bk, lnk)


    ## MiniWindow
    def OnToggleMini(self, event):
        if self.miniWin.IsShown():
            self.miniWin.Hide()
        else:
            self.miniWin.Show()
        self.miniWin.SetFocus()

    def OnDictMini(self, answer, title, imgNames, fromWL =0, scroll =0):
        self.miniWin.SetTitle(title)
        
        if self.fontSize > 0 and not 'font size=' in answer:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.miniWin.MiniWindow.SetPage(answer)
        self.miniCurrent = answer
        self.miniWin.related.Enable(False)
        self.miniWin.Show()

        self.AddMiniHistory(answer, title)

        if imgNames:
            self.RemoveImages(imgNames)

        if scroll == 1 and '<a name=' in answer:
            self.miniWin.MiniWindow.ScrollToAnchor('line')
            self.miniWin.MiniWindow.ScrollLines(-2)

        self.miniWin.related.Enable(False)
        if fromWL == 1:
            self.miniWin.related.Enable(True)


    def OnMiniWinCopy(self, type):
        if type == 'bib':
            txt = self.bibCurrent
            try: title = '%s - %s' % (self.bAbbrList[self.bibNB.GetSelection()], self.currentChap)
            except: title = 'Parallel - %s' % self.currentChap
        if type == 'dct':
            txt = self.dctCurrent
            title = '%s - %s' % (self.dAbbrList[self.dctNB.GetSelection()], self.currentWord)
        if type == 'cmt':
            txt = self.cmtCurrent
            title = '%s - %s' % (self.cAbbrList[self.cmtNB.GetSelection() -1], self.currentRef)
        if type == 'res':
            txt = self.resultCurrent[self.resNB.GetSelection() -1]
            title = self.rDescList[self.resNB.GetSelection()]

        self.miniWin.MiniWindow.SetPage(txt)
        self.miniCurrent = txt
        self.miniWin.SetTitle(title)
        
        self.AddMiniHistory(txt, title)

        self.miniWin.related.Enable(False)
        self.miniWin.sizer2.Show(0, True)
        self.miniWin.sizer2.Layout()
        self.miniWin.Show()

    
    def AddMiniHistory(self, txt, title):
        if len(self.miniHistory) == 20:
            del self.miniHistory[-1]
            del self.miniHistoryTitle[-1]

        if self.saveAllMW == 1:
            self.miniHistory.insert(0, txt)
            self.miniHistoryTitle.insert(0, title)
            self.miniHistoryIdx = -1


        if len(self.miniHistory) > 0:
            self.miniWin.back.Enable(True)
            self.miniWin.forw.Enable(True)
            self.miniWin.list.Enable(True)
    


    def OnToggleChap(self):
        txt, fNames = normSearch.doCmtChap(self.currentChap, self.cmtFileList[self.cmtNB.GetSelection() -1])

        if self.fontSize > 0: # and not 'font size=' in txt:
            txt = '<font size="+%s">%s</font>' % (self.fontSize, txt)

        txt = '''<body bgcolor="%s" link="#336666"><font face="%s"><br>%s</font>''' % (self.cmtColor, self.font, txt)

        display = self.cmtDisplay[self.cmtNB.GetSelection() -1]
        display.SetPage(txt)
        self.cmtCurrent = txt
        
        self.RemoveImages(fNames)
        
        if 'name="%s"' % self.currentRef in txt:
            display.ScrollToAnchor(self.currentRef)
            display.ScrollLines(-2)



    def OnExportCmtChap(self):
        txt = normSearch.ExportCmtChap(self.currentChap, self.cmtFileList[self.cmtNB.GetSelection() -1])
        title = '%s - Combined Comments - %s' % (self.cAbbrList[self.cmtNB.GetSelection() -1], self.currentChap)
        preTitle = title
        
        if self.fontSize > 0: # and not 'font size=' in txt:
            txt = '<font size="+%s">%s</font>' % (self.fontSize, txt)
            title = '<font size="+%s">%s</font>' % (self.fontSize, title)
        
        header = '''<table bgcolor="#CDCFDC" cellpadding="7" width="100%%">\
<tr><td bgcolor="%s"><i><font color="#676C8A"><b>%s</b></font></i></td></tr></table><br><br>''' % (self.cmtHeadColor, title)


        txt = '''<body bgcolor="%s" link="#336666"><font face="%s"><font color="#660000">%s </font><br>%s</font>''' % (self.cmtColor, self.font, header, txt)
        
        self.miniWin.MiniWindow.SetPage(txt)
        self.miniCurrent = txt
        self.miniWin.SetTitle(preTitle)
        self.AddMiniHistory(txt, preTitle)
        
        self.miniWin.sizer2.Show(0, True)
        self.miniWin.sizer2.Layout()
        self.miniWin.Show()
        

    def OnBkFrame(self):
        #if self.cpMini == None:
        #    self.OnMasterControlMini(None, 0)
        if not self.bkWin:
            self.bkWin = library.TextReader(self)
            self.bkWinDisplay = self.bkWin.Display
            self.bkWin.SetSize(self.bkWinSize)
            self.bkWin.SetPosition(self.bkWinPos)


    ##Master Control MiniFrame Controls
    def OnMasterControlMini(self, event, show =1):
        if self.cpMini == None:
            self.cpMini = controlMini.ControlMini(self)
            self.bookPanel = self.cpMini.BookViewer
            self.cpMini.SetPosition(self.miniPos)
            self.cpMini.SetSize(self.miniSize)
            if show != 0:
                self.cpMini.Show()
                self.cpMini.Raise()
                #self.SetCMiniFocus()
            

        elif self.cpMini.IsShown() and show != 2:
            self.cpMini.Hide()
            self.SetFocus()

        else:
            if show != 0:
                self.cpMini.Show()
                self.cpMini.Raise()
                #self.SetCMiniFocus()

        #self.SetCMiniFocus()


    def displayMiniWin(self):
        tab = self.cmtNB.GetSelection() -1
        title = self.cDescList[tab]

        ref = self.currentRef
        if tab in self.hitList:
            ref = self.hitList[tab]

        cmtAnswer, imgNames = normSearch.showLibTopic(ref, self.cmtFileList[tab], self.font, self.cmtColor, title, 1)

        self.OnDictMini(cmtAnswer, title, imgNames)
        self.miniWin.type = 0

        default = ''
        self.miniWin.hitList.Clear()
        for item in self.cmtFlagList:
            cmt = self.cAbbrList[item -1]
            if item == tab +1:
                default = cmt
            self.miniWin.hitList.Append(cmt)

        self.miniWin.hitList.SetStringSelection(default)
        self.miniWin.sizer2.Show(0, True)
        self.miniWin.sizer2.Layout()


    def SetCMiniFocus(self):
        if self.cpMini.BibSearch.IsShown():
            self.cpMini.BibSearch.SearchEntryBox.SetFocus()
        elif self.cpMini.ProxSearch.IsShown():
            self.cpMini.ProxSearch.SearchEntryBox.SetFocus()
        elif self.cpMini.Compare.IsShown():
            self.cpMini.Compare.CompareEntry.SetFocus()
        elif self.cpMini.LibSearch.IsShown():
            self.cpMini.LibSearch.SearchEntryBox.SetFocus()



    def OnMediaMini(self, event):
        if self.mediaMini == None:
            self.mediaMini = mediaMini.MediaMini(self)
            self.mediaMini.AudioPanel.playAll.SetValue(self.audioPlayAll)
            if self.lastAudio != 'None':
                self.mediaMini.AudioPanel.audLB.SetStringSelection(self.lastAudio)
                self.mediaMini.AudioPanel.audLB.ScrollLines(1)
            self.mediaMini.Show()

        elif self.mediaMini.IsShown():
            self.mediaMini.Hide()
        else:
            self.mediaMini.Show()


    def OnInfo(self, nb, tab):

        if nb == self.bibNB:
            fName = self.bibFileList[tab]
        elif nb == self.dctNB:
            fName = self.dctFileList[tab]
        elif nb == self.cmtNB:
            fName = self.cmtFileList[tab -1]
        else:
            return

        con = sqlite.connect(fName)
        con.text_factory = str
        cur = con.cursor()
        cur.execute('SELECT * FROM title')
        row = cur.fetchone()
        title = '(%s) %s' % (row[0], row[1])

        try:
            info = unicode(row[2], "utf-8")
        except:
            info = unicode(row[2], "latin1")

        self.infoText = '<font face="%s">%s</font>' % (self.font, info)

        fNames = []
        if '<img src="memory:' in info:
            fnTemp = re.findall(r'<img src="memory:([^"]+)">', info)
            for fn in fnTemp:
                try:
                    cur.execute('SELECT * FROM images where fName=?', (fn,))
                    row = cur.fetchone()
                    imgData = row[1]
                    self.memFs.AddFile(fn, str(imgData), wx.BITMAP_TYPE_ANY)
                    fNames.append(fn)
                except:
                    print 'Can\'t get/load images'

        if not self.infoWin:
            self.infoWin = infoWin.InfoWin(self)

        self.infoWin.Centre()
        self.infoWin.SetSize((650, 500))

        self.infoWin.Show()

        self.infoWin.SetTitle(title)
        self.infoWin.infoWindow.SetPage(self.infoText)
        self.infoWin.infoWindow.SetFocus()

        self.RemoveImages(fNames)



    ## Popup Functions
    
    def OnBibKeyUp(self, event):
        event.Skip()
        if event.GetKeyCode() == 308:
            self.popupCheck()
            self.currentCell = None
    
    def OnBibKey(self, event):
        event.Skip()
        if wx.GetKeyState(wx.WXK_CONTROL):          
            self.OnCtrlPopup()


    def OnCtrlPopup(self):        
            win = self.popupWin
            if not win:
                return
            
            x, y = wx.GetMousePosition()
            if y < win.GetScreenRect()[1]:
                return
            
            pos = win.ScreenToClient((x, y))
            sPos = win.CalcUnscrolledPosition(pos)
            
            containerCell = win.GetInternalRepresentation()
            if containerCell:
                cell = containerCell.FindCellByPos(sPos.x, sPos.y)
                if not cell or not isinstance(cell, wx.html.HtmlWordCell) or cell.GetLink():
                    self.currentCell = None
                    return
                
                cellPos = cell.GetAbsPos()
                if cellPos == self.currentCell:
                    #print 'same'
                    return

                select = cell.ConvertToText(None)
                
                self.currentCell = cellPos
                
                grkFont = '<font face="GU Greek" color="brown">'
                hebFont = '<font face="GU Hebrew" color="brown">'
                
                if re.search(r'\d+,', select):
                    if re.search(r'\d+:\d+,', select):
                        select = select[:-2].strip()
                    else:
                        select = self.currentChap + select[:-2].strip()
                    
                    desc = self.cDescList[self.defaultCmtIdx]
                    pth = self.cmtFileList[self.defaultCmtIdx]
                
                    line = normSearch.showLibTopic(select, pth, self.font, self.dctColor, desc, 1, 1)
                    if not line:
                        line = "%s is not found in %s." % (select, desc)
                        
                    if len(line) > 600:
                        line = '%s <font color="navy">...<i>cont.</i></font>\
                        <table cellpadding="1"><td><tr></tr></td></table>\
                        <div align="center"><i><font color="navy">Click to view entire comment...</font></i></div>' % line[:600]
                    
                    line = utility.checkLineTags(line, grkFont, hebFont)
                    line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
                    line = utility.CheckEncoding(line)
                    line = re.sub(r'(<br>)+ *$|(<br>)+ *\n', '', line)
                    
                    if line.startswith('<p>'):
                        line = line[3:]
                    
                    fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                    <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Cmt)<br>&nbsp;Comment on  
                    <font color="brown"><b>%s</b></font></font></td></tr></table>
                    <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 
                
                else:
                    select = re.sub(r'[.,;:?!"\(\) ]+', '', select)
                    desc = self.dDescList[self.defaultDctIdx]
                    pth = self.dctFileList[self.defaultDctIdx]
                
                    line = normSearch.showLibTopic(select.title(), pth, self.font, self.dctColor, desc, 0, 1)
                    if not line:
                        line = "%s is not found in %s." % (select.title(), desc)
                        
                    if len(line) > 600:
                        line = '%s <font color="navy">...<i>cont.</i></font>\
                        <table cellpadding="1"><td><tr></tr></td></table>\
                        <div align="center"><i><font color="navy">Click to view entire topic...</font></i></div>' % line[:600]
                    
                    line = utility.checkLineTags(line, grkFont, hebFont)
                    line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
                    line = utility.CheckEncoding(line)
                    line = re.sub(r'(<br>)+ *$|(<br>)+ *\n', '', line)
                    
                    if line.startswith('<p>'):
                        line = line[3:]
                    
                    fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                    <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Dct)<br>&nbsp;Topic on  
                    <font color="brown"><b>%s</b></font></font></td></tr></table>
                    <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 

                fTxt = fTxt % (self.popColorMac, self.popHeadColor, self.popFontSize +2, desc, select, self.popFontSize +2, line)
                
                if not fTxt or fTxt == self.popRef:
                    return
                
                self.popupCheck()
                self.popRef = fTxt

                self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0, 1)
                #time.sleep(.1)
                self.ShowPopup(x, y)


    def popupCheck(self, event = None):
        if self.toolwin:
            self.toolwin.Destroy()
            self.popRef = ''


    def OnMotion(self, event, parent = None):
        event.Skip()
        pos = event.GetPosition()
        self.popupWin = event.GetEventObject()

        sPos = self.popupWin.CalcUnscrolledPosition(pos)

        containerCell = self.popupWin.GetInternalRepresentation()
        if containerCell:
            cell = containerCell.FindCellByPos(sPos.x, sPos.y)
            if cell:
                cellPos = cell.GetAbsPos()
                if cellPos == self.currentCell:
                    #print 'motion same'
                    return
                
                #self.currentCell = cellPos
                self.OnPopup(event, cell)
                #self.currentCellTxt = txt
            else:
                self.popupCheck()
                #self.currentCellTxt = None
        else:
            self.popupCheck()



    def OnPopup(self, event, cell):
        fromLink = 0

        x, y = wx.GetMousePosition()
        grkFont = '<font face="GU Greek" color="brown">'
        hebFont = '<font face="GU Hebrew" color="brown">'
        
        if cell.GetLink():
            lnk = cell.GetLink().GetHref()

            #print lnk, 'OnPopup Lnk'

            if 'bible://' in lnk:
                select = lnk[8:]
                select = re.sub(r'([a-z])[.](\d+)[.:]', r'\1_\2:', select, re.I)
                #print select

                if select[-1] == ':':
                    tab = self.bibNB.GetSelection()
                    try:
                        last = normSearch.getVerseRange(select, self.bibFileList[tab])
                    except:
                        last = normSearch.getVerseRange(select, self.bibFileList[self.avIndex])
                    select = '%s1-%s' % (select, last)
                fromLink = 1

            elif 'bibleFN/' in lnk:
                #print lnk
                parse = re.search(r'bibleFN/(.+?)/(.+?)://(.+)', lnk, re.I)
                abbr = parse.group(1)
                ref = parse.group(2)
                note = parse.group(3)
                self.GetEmbFootnotePopup(abbr, ref, note, x, y)
                return

            elif 'commFN/' in lnk:
                parse = re.search(r'commFN/(.+?)/(.+?)://(.+)', lnk, re.I)
                abbr = parse.group(1)
                ref = parse.group(2)
                note = parse.group(3)
                self.GetCmtFootnotePopup(abbr, ref, note, x, y)
                return

            elif 'searchRng://' in lnk:
                #print 'searchRng'
                try:
                    word, bib, rng, result, verseList, title, count, findStr, totalHits, exclude, rngRefList = self.SearchRngLnk(lnk, 1)
                    self.FormatSearchPopup(word, bib, rng, result, verseList, title, count, findStr, totalHits, exclude, rngRefList, x, y)
                except:
                    return
                return

            elif 'embNote/' in lnk:
                parse = re.search(r'embNote/(.+?)/(.+)', lnk, re.I)
                abbr = parse.group(1)
                note = parse.group(2)

                #fTxt = '''<body bgcolor="memory:bg.png"><font size="%s"><font color="Navy"><b>&nbsp;%s</b></font>\
                #- Note<br><table cellpadding="2"><tbody><td><tr></tr></td></tbody></table>&nbsp;%s</font>''' % (self.popFontSize +3, abbr, note)

                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s -</b> Note</font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font size="%s" face="Georgia">%s</font>''' \
                % (self.popColorMac, self.popHeadColor, self.popFontSize +2, abbr, self.popFontSize +2, note)

                if fTxt == self.popRef:
                    return
                else:
                    self.popupCheck()
                    self.popRef = fTxt

                    self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0)
                    self.ShowPopup(x, y)
                return
            
            elif 'dict/' in lnk:
                parse = re.search(r'dict/(.+?)://(.+)', lnk, re.I)
                abbr = parse.group(1)
                topic = parse.group(2)
                try:
                    idx = self.dAbbrList.index(abbr)
                except:
                    return
                pth = self.dctFileList[idx]
                #print topic.title()
                
                line = normSearch.showLibTopic(topic, pth, self.font, self.dctColor, self.dDescList[idx], 0, 1)
                if not line:
                    return
                
                if '<sm>' in line:
                    line = re.search(r'<sm>(.+)</sm>', line).group(1)
                
                elif len(line) > 800:
                    line = '%s <font color="navy">...<i>cont.</i></font>\
                    <table cellpadding="1"><td><tr></tr></td></table>\
                    <div align="center"><i><font color="navy" size="%s">Click to view entire topic...</font></i></div>' % (line[:800], self.popFontSize +2)
                
                line = utility.checkLineTags(line, grkFont, hebFont)
                line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
                line = utility.CheckEncoding(line)
                line = re.sub(r'(<br>)+ *$|(<br>)+ *\n', '', line)
                
                if line.startswith('<p>'):
                    line = line[3:]
                
                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Dct)</font><br><font size="%s">&nbsp;Topic on  
                <font color="brown"><b>%s</b></font></font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 

                fTxt = fTxt % (self.popColorMac, self.popHeadColor, self.popFontSize +2, self.dDescList[idx], self.popFontSize +2, topic, self.popFontSize +2, line)
                
                if not fTxt or fTxt == self.popRef:
                    return
                
                else:
                    self.popupCheck()
                    self.popRef = fTxt

                    self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0)
                    time.sleep(.2)
                    self.ShowPopup(x, y)
                    return            
        

            elif 'comm/' in lnk:
                parse = re.search(r'comm/(.+?)://(.+)', lnk, re.I)
                abbr = parse.group(1)
                topic = parse.group(2)
                try:
                    idx = self.cAbbrList.index(abbr)
                except:
                    return
                pth = self.cmtFileList[idx]
                #print topic.title()
                
                tab = self.cAbbrList.index(abbr)
                if tab in self.hitList:
                    topic = self.hitList[tab]

                line = normSearch.showLibTopic(topic, pth, self.font, self.cmtColor, self.cDescList[idx], 1, 1)
                if not line:
                    print 'no data'
                    return
                
                if '<sm>' in line:
                    line = re.search(r'<sm>(.+)</sm>', line).group(1)
                
                elif len(line) > 800:
                    line = '%s <font color="navy">...<i>cont.</i></font>\
                    <table cellpadding="1"><td><tr></tr></td></table>\
                    <div align="center"><i><font color="navy" size="%s">Click to view entire comment...</font></i></div>' % (line[:800], self.popFontSize +2)
                
                line = utility.checkLineTags(line, grkFont, hebFont)
                line = re.sub(r'<a href=.+?">(.+?)</a>', r'\1', line)
                line = utility.CheckEncoding(line)
                line = re.sub(r'(<br>)+ *$|(<br>)+ *\n', '', line)
                
                if line.startswith('<p>'):
                    line = line[3:]
                
                fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
                <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> (Cmt)</font><br><font size="%s">&nbsp;Topic on  
                <font color="brown"><b>%s</b></font></font></td></tr></table>
                <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' 

                fTxt = fTxt % (self.popColorMac, self.popHeadColor, self.popFontSize +2, self.cDescList[idx], self.popFontSize +2, topic, self.popFontSize +2, line)
                
                if not fTxt or fTxt == self.popRef:
                    return
                
                else:
                    self.popupCheck()
                    self.popRef = fTxt

                    self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0)
                    time.sleep(.2)
                    self.ShowPopup(x, y)
                    return            
        
            else:
                return

        elif wx.GetKeyState(wx.WXK_CONTROL) and isinstance(self.popupWin, wx.html.HtmlWindow):
            #self.OnCtrlPopup(self.popupWin)
            return
        
        else:
            select = cell.ConvertToText(None)
            if not select or select == ' ' or len(select) == 0:
                return

        #print select.encode('utf-8'), 'select'
        select = select.replace('.', ':')

        if re.search(r'^[GH]\d+', select):
            select = re.sub(r'[.,:;?!"-() ]+', '', select).strip()
            self.GetStrongsPopup(x, y, select)
        
        else:
            select = re.sub(r'[.,;?!"\(\)]+', '', select)
            #self.popupWin.SetCursor(wx.StockCursor(wx.CURSOR_HAND))
            self.GetPopup(x, y, select, fromLink)


    def FormatSearchPopup(self, word, bib, rng, result, verseList, title, count, findStr, totalHits, exclude, rngRefList, x, y):
        #result = re.sub(r'<body.*|Verses.*|</?u>|<b>\d+</b>.*<hr>', '', result)
        result = re.sub(r'^.*<hr>', '', result)
        result = re.sub(r'_', ' ', result)
        result = re.sub(r'<a href.+?</a>', '', result)
        result = re.sub(r'<br><br>', '<br>', result)
        result = result.strip()
        resList = result.split('<br>')

        res = '<br>'.join(resList[:3])

        if count > 3:
            res = res + '<br>&nbsp;&nbsp;&nbsp;&nbsp;<font color="#336666"><i>...cont.</i> (click to view all)</font></font>'
        elif count < 3:
            res = res[:-13] + '</font>'

        txt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b> - %s (%s)</font><br><font size="-1"> %s times in %s verses </font></td></tr></table>
        <table cellpadding="2"><td><tr></tr></td></table><font size="%s" face="Verdana">%s</font>''' \
        % (self.popColorMac, self.popHeadColor, self.popFontSize +2, word.capitalize(), bib, rng, totalHits, count, self.popFontSize +2, res)

        #print txt
        if txt == self.popRef:
            return
        else:
            self.popupCheck()
            self.popRef = txt

        self.toolwin = popup.HtmlPopup(None, txt, self.popColorIdx, self.popFontSize, 0)
        self.ShowPopup(x, y)



    def SearchRngLnk(self, lnk, popup = 0):
        parLnk = re.search(r'//(.+)/(.+)/(.+)', lnk)
        bib = parLnk.group(1)
        rng = parLnk.group(2)
        word = parLnk.group(3)
        
        word = word.replace('*', '')
        #print bib, rng, word

        rngIdx, rngLabel = fixRef.parseRng(rng)
        fPath = self.bibFileList[self.bAbbrList.index(bib)]

        fromSchRngLnk = 1
        
        self.noPopRefLnk = 1
        
        advs = advSearch.primSearch(self)
        result, verseList, title, count, findStr, totalHits, exclude, rngRefList = advs.StdSearch\
        (word, fPath, bib, 1, 0, 0, self.font, 1, 0, rngIdx, None, rngLabel, 0, 0, 0, rngLabel, 0, 0, popup, 1)
        # last parameter is to indicate from a schRngLnk
        
        if popup:
            return word, bib, rng, result, verseList, title, count, findStr, totalHits, exclude, rngRefList

        temp = [word, fPath, bib, 1, 0, 0, 1, 0, count, findStr, totalHits, exclude, rngLabel, rngRefList, rngIdx]
        self.searchQList.append(temp)

        if self.fontSize > 0:
            result = '<font size="+%s">%s</font>' % (self.fontSize, result)

        self.Freeze()
        self.AddResult(word, title, result)
        self.Showing = result
        self.Thaw()


    def GetPopup(self, x, y, select, fromLink = 0):
        if select == self.popRef:
            pass
        else:
            self.popupCheck()
            self.popRef = select

            if '_' in select or fromLink:
                select = select.replace('_', ' ')
                vsRef = select
                over = 0

                line = self.GetPopupVerse(select)
                if line:
                    self.toolwin = popup.HtmlPopup(None, line, self.popColorIdx, self.popFontSize, 0)
                    self.ShowPopup(x, y)
                else:
                    return


    def GetVsInCmtRange(self, abbr, ref, type = 0):
        
        #print abbr, ref, 'in main'
        try:
            fnIdx = self.cAbbrList.index(abbr)
        except ValueError:

            try:
                fnIdx = self.cAbbrList.index('NET-')
            except ValueError:
                print '%s Cmt not found' % abbr
                return
        
        if fnIdx in self.hitList:
            ref = self.hitList[fnIdx]
            
        fName = self.cmtFileList[fnIdx]

        con = sqlite.connect(fName)
        cur = con.cursor()
        cur.execute('SELECT * FROM commentary WHERE ref =?', (ref,))

        row = cur.fetchone()

        if row:
            line = row[2]
        else:
            parse = re.match(r'(.+:)(\d+)', ref)
            bkChap = parse.group(1)
            verse = int(parse.group(2))

            cur.execute('SELECT * FROM commentary WHERE ref LIKE ?', (bkChap +'%',))

            line = ''
            for row in cur:
                if '-' in row[1]:
                    parse = re.match(r'.+:(\d+)-(\d+)', row[1])
                    first = int(parse.group(1))
                    last = int(parse.group(2))
                    if first <= verse <= last:
                        line = row[2]
                        break

        if type == 0:
            return line
        else:
            return row[1]


    def GetCmtFootnotePopup(self, abbr, ref, note, x, y):
        line = self.GetVsInCmtRange(abbr, ref)

        if not line:
            return

        #print line.encode('utf-8')
        if '<fn>' in line:

            #print line.encode('utf-8'), '2'

            try:
                line = re.search(r'(<fn>%s</fn>.+?)(<fn>|$)' % note, line, re.U).group(1)
                line = re.sub(r'<fn>%s</fn>' % note, r'<font color="brown"><sup>%s</sup></font>' % note, line, re.U)
                line = line.replace('_', ' ')
                line = re.sub(r'(<u>.*?</u>)', r'<font color="#336666">\1</font>', line)
            except:
                return

            grkFont = '<font face="GU Greek" color="brown">'
            hebFont = '<font face="GU Hebrew" color="brown">'

            #print line.encode('utf-8')
            line = utility.checkLineTags(line, grkFont, hebFont)

            if len(line) > 1500:
                line = '%s<font color="navy">...<i>cont.</font></i><p><center><i><font color="navy">Click to view entire note in commentary</font></i></center>' % line[:1500]

            fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
            <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s -</b> %s Commentary</font></td></tr></table>
            <table cellpadding="2"><td><tr></tr></td></table><font size="%s" face="Verdana">%s</font>''' \
            % (self.popColorMac, self.popHeadColor, self.popFontSize +2, ref, abbr, self.popFontSize +2, line)


        else:
            if len(line) > 1500:
                line = '%s<font color="navy">...<i>cont.</font></i><p><center><i><font color="navy">Click to view entire note in commentary</font></i></center>' % line[:1500]

            fTxt = '''<body bgcolor="%s"><font size="%s">%s</font>''' \
            % (self.popColorMac, self.popFontSize +3, line)

        if fTxt == self.popRef:
            return
        else:
            self.popupCheck()
            self.popRef = fTxt

            self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0)
            self.ShowPopup(x, y)



    def GetEmbFootnotePopup(self, abbr, ref, note, x, y):
        ref = ref.replace('_', ' ')
        #print abbr, ref, note

        fnIdx = self.bAbbrList.index(abbr)
        fName = self.bibFileList[fnIdx]

        con = sqlite.connect(fName)
        cur = con.cursor()
        
        cur.execute("SELECT name FROM sqlite_master WHERE type='table' AND name='footnote'")
        if not cur.fetchone():
            return
        
        cur.execute('SELECT * FROM footnote WHERE ref =?', (ref,))
        row = cur.fetchone()
        if not row:
            return
        
        grkFont = '<font face="GU Greek" color="brown" size="+1">'
        line = row[2]
        if '<gu>' in row[2]:
            line = re.sub(r'<gu>(.*?)</gu>', r'%s\1</font>' % grkFont, line, re.U)

        txt = re.search(r'<fn>%s (.+?)</fn>' % note, line).group(1)
        txt = re.sub(r'<a href="bible.+?>(.+?)</a>', r'\1', txt)

        #print txt.encode('utf-8')

        fTxt = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="navy" >&nbsp;<b>%s -</b> %s</font></td></tr></table>
        <table cellpadding="2"><td><tr></tr></td></table><font face="Verdana" size="%s">%s</font>''' \
        % (self.popColorMac, self.popHeadColor, self.popFontSize +3, ref, abbr, self.popFontSize +3, txt)

        if fTxt == self.popRef:
            return
        else:
            self.popupCheck()
            self.popRef = fTxt

            self.toolwin = popup.HtmlPopup(self, fTxt, self.popColorIdx, self.popFontSize, 0)
            self.ShowPopup(x, y)



    def GetStrongsPopup(self, x, y, select, fromMW = 0):       
        if select == self.popRef:
            return
        else:
            self.popRef = select

            if self.toolwin:
                self.toolwin.Destroy()

            type = 1

            try:
                if self.strongPopIndex == None:
                    ref = select
                    text = '<table cellpadding="2"><td><tr></tr></td></table>\
                    <font color="brown">A Dictionary Keyed to Strong\'s Numbers is not Loaded.</font><br>\
                    <table cellpadding="2"><td><tr></tr></td></table>\
                    To obtain one see <i>BibleAnalyzer.com</i> or\
                    ensure the module is checked in <i>Session Manager</i> (Ctrl+M) if already obtained.'
                    title = "Strong's Based Text Not Available"
                else:
                    ref, text = popup.popStrong(select, self.dctFileList[self.strongPopIndex])
                    title = self.dDescList[self.strongPopIndex]
            except:
                ref = select
                text = "<br><br><i>This Strong's Number is not found in %s Dictionary</i>" % self.dAbbrList[self.strongPopIndex]
                title = "Strong's Number Not Found"
                #return
            
            line = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">
            <tr><td bgcolor="%s"><font size="%s" color="navy">&nbsp;<b>%s</b></font> - %s</td></tr></table>
            <font size="%s" face="Verdana">%s</font></body>''' % (self.popColorMac, self.popHeadColor, self.popFontSize +3, ref, title, self.popFontSize +3, text)

            self.toolwin = popup.HtmlPopup(self, line, self.popColorIdx, self.popFontSize, type)
            self.ShowPopup(x, y)


    def ShowPopup(self, x, y):
        #print x,y
        #print wx.GetMousePosition()
        
        #if (x, y) != wx.GetMousePosition():
        #    return
        
        self.toolwin.Hide()
        scnWidth = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_X)
        scnHeight = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_Y)
        w, h = self.toolwin.GetSizeTuple()

        if x +10 + w  > scnWidth:
            x = x - w -15
        if y +25 + h > scnHeight:
            y = y - h -25

        self.toolwin.SetPosition((x +5, abs(y) +15))

        self.toolwin.Show()


    def GetPopupVerse(self, select):
        vsRef = select
        over = 0
        fn = self.bibFileList[self.popupIndex]
        abbr = self.bAbbrList[self.popupIndex]
        desc = self.bDescList[self.popupIndex]



        error = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="#336666">&nbsp;<b>%s -</b> %s</font></td></tr></table>
        <table cellpadding="2"><tr><td></td></tr></table><font size="%s" color="brown" face="Verdana"><b><i>This reference is not found in this Bible</i></b></font>'''\
        % (self.popColorMac, self.popHeadColor, self.popFontSize +3, select, desc, self.popFontSize +3)

        try:
            parse = re.search(r'(\w\w\w \d+):(\d+)(-\d+)?', select)
            bookChap = parse.group(1)
            startVs = parse.group(2)

            chapIdx, end = fixRef.getIdx(bookChap +':', fn)
            lastVs = normSearch.getVerseRange(select, fn)

            lastVs = end - chapIdx

        except:
            print 'Ref not found in DB'
            return error

        #print lastVs, int(startVs)
        if lastVs +1 < int(startVs):
            print 'Verse doesn\'t exist'
            return error

        if wx.GetKeyState(wx.WXK_CONTROL):
            startIdx = chapIdx + int(startVs) -3
            endIdx = int(startIdx) + 4
            if parse.group(3):
                vsRef = '%s:%s' % (parse.group(1), parse.group(2))

        elif not '-' in select:
            startIdx = chapIdx + int(startVs) -1
            endIdx = startIdx

        else:
            popupRng = int(self.popRange) -1
            parse = re.search(r'(\w\w\w \d+):(\d+)-(\d+)', select)
            
            if not parse:
                return error
            
            bookChap = parse.group(1)
            startVs = parse.group(2)
            endVs = parse.group(3)
            if int(startVs) + popupRng < int(endVs):
                over = 1

            diff = int(endVs) - int(startVs)
            if diff < popupRng:
                popupRng = diff
            #try:
            #    chapIdx, end = fixRef.getIdx(bookChap, fn)
            #except:
            #    return

            startIdx = chapIdx + int(startVs) -1
            endIdx = int(startIdx) + popupRng

        ref, verse, title = popup.popText(vsRef, startIdx, endIdx, self.bibFileList[self.popupIndex], startVs, over)
        
        #if self.bibNB.bibPanel.miniTB.GetToolToggled(510) == True:
        #    verse = re.sub(r'\[([GH].+?)\]', r'<sup><font color="#000066">\1</font></sup>', verse)
        #    verse = re.sub(r'\[\(([GH].+?)\)\]', r'<sup><font color="#660000">\1</font></sup>', verse)
        #else:
        verse = re.sub(r'\[\(?[GH].+?\)?\]', r'', verse)

        #print title, verse

        line = '''<body bgcolor="%s"><table bgcolor="#CDCFDC" width="100%%" cellpadding="1">\
        <tr><td bgcolor="%s"><font size="%s" color="#336666">&nbsp;<b>%s -</b> %s</font></td></tr></table>
        <table cellpadding="2"><tr><td></td></tr></table><font size="%s" face="Verdana">%s</font>''' \
        % (self.popColorMac, self.popHeadColor, self.popFontSize +3, ref, title, self.popFontSize +3, verse)

        return line


    def GetPopColor(self):
        self.popColorMac = '#FFFFC7'
        if self.popColorIdx == 1:
            self.popColorMac = '#EFD6D6'
        elif self.popColorIdx == 2:
            self.popColorMac = '#D7D7F1'
        elif self.popColorIdx == 3:
            self.popColorMac = '#D3EFD3'    


    def GetPopupHeaderColor(self):
        self.popHeadColor = '#FFFFDE'
        if self.popColorIdx == 1:
            self.popHeadColor = '#F2DFDF'
        elif self.popColorIdx == 2:
            self.popHeadColor = '#E1E1F3'
        elif self.popColorIdx == 3:
            self.popHeadColor = '#DFF2DF'



    ## Printing Functions
    def OnPrintPre(self, event):
        focus = self.FindFocus()
        if focus.GetName() in ['frame', 'control', 'text']:
            dlg = wx.MessageDialog(self, 'Click in a page to select for printing.\n',
            'No Page Selected For Printing', wx.OK | wx.ICON_INFORMATION    )
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        #print focus.GetName(), 'focus'

        if focus.GetName() == 'InfoWin':
            self.ePrint.PreviewText(self.infoText)
            return

        if focus.GetName() == 'parGen':
            self.ePrint.PreviewText(self.currentParGen)
            return

        if focus.GetName() == 'textReader':
            self.ePrint.PreviewText(self.prePage)
            return

        if not focus.GetName() == 'MultiWindow':
            if focus.GetName() == 'richText':
                nb = focus.GetGrandParent()
            else:

                nb = focus.GetGrandParent().GetParent()

            if nb == self.bibNB:
                self.ePrint.PreviewText(self.bibCurrent)
            elif nb == self.dctNB:
                self.ePrint.PreviewText(self.dctCurrent)
            elif nb == self.resNB:
                resPage = nb.GetSelection()-1
                if self.resNB.GetSelection() == 0:
                    self.edit.OnEditorPrintPre(None)
                    return
                self.ePrint.PreviewText(self.resultCurrent[resPage])
            elif nb == self.cmtNB:
                if self.cmtNB.GetSelection() == 0:
                    self.noteEdit.OnEditorPrintPre(None)
                    return
                self.ePrint.PreviewText(self.cmtCurrent)
            elif nb == self.libViewer:
                self.ePrint.PreviewText(self.libViewer.text)
        else:
            self.ePrint.PreviewText(self.miniCurrent)


    def OnPrint(self, event):
        focus = self.FindFocus()
        if focus.GetName() in ['frame', 'control', 'text']:
            dlg = wx.MessageDialog(self, 'Click in a page to select for printing.\n',
            'No Page Selected For Printing', wx.OK | wx.ICON_INFORMATION    )
            dlg.ShowModal()
            dlg.Destroy()
            return
        
        #focus.GetName(), 'focus'

        if focus.GetName() == 'InfoWin':
            self.ePrint.PrintText(self.infoText)
            return

        if focus.GetName() == 'parGen':
            self.ePrint.PrintText(self.currentParGen)
            return

        if not focus.GetName() == 'MultiWindow':
            if focus.GetName() == 'richText':
                nb = focus.GetGrandParent()
            else:
                nb = focus.GetGrandParent().GetParent()
            #resPage = nb.GetSelection()-1

        resPage = nb.GetSelection()-1

        if nb == self.bibNB:
            self.ePrint.PrintText(self.bibCurrent)
        elif nb == self.dctNB:
            self.ePrint.PrintText(self.dctCurrent)
        elif nb == self.resNB:
            if self.resNB.GetSelection() == 0:
                self.edit.OnEditorPrintPre(None)
                return
            self.ePrint.PrintText(self.resultCurrent[resPage])
        elif nb == self.cmtNB:
            if self.cmtNB.GetSelection() == 0:
                self.noteEdit.OnEditorPrintPre(None)
                return
            self.ePrint.PrintText(self.cmtCurrent)
        elif nb == self.libViewer:
            self.ePrint.PrintText(self.libViewer.text)

    def OnDctPrint(self, event):
        self.SetDctFocus(None)
        self.ePrint.PrintText(self.dctCurrent)

    def OnPrintDctPreview(self, event):
        self.SetDctFocus(None)
        try: self.ePrint.PreviewText(self.dctCurrent)
        except: pass

    def OnBibPrint(self, event):
        self.SetBibFocus(None)
        self.ePrint.PrintText(self.bibCurrent)

    def OnPrintBibPreview(self, event):
        self.SetBibFocus(None)
        try: self.ePrint.PreviewText(self.bibCurrent)
        except: pass

    def OnCmtPrint(self, event):
        self.SetCmtFocus(None)
        self.ePrint.PrintText(self.cmtCurrent)

    def OnPrintCmtPreview(self, event):
        self.SetCmtFocus(None)
        try: self.ePrint.PreviewText(self.cmtCurrent)
        except: pass

    def OnResPrint(self, event):
        tab = self.resNB.GetSelection() -1
        self.resDisplay[tab].SetFocus()
        self.ePrint.PrintText(self.resultCurrent[tab])

    def OnPrintResPreview(self, event):
        tab = self.resNB.GetSelection() -1
        self.resDisplay[tab].SetFocus()
        try: self.ePrint.PreviewText(self.resultCurrent[tab])
        except: pass


    def OnMakeBibleFull(self, event):
        self.SetBibFocus(None)
        self.mainMgr.RestoreMaximizedPane()
        self.mainMgr.MaximizePane(self.getBibPane())
        self.mainMgr.Update()

    def OnMakeDictionaryFull(self, event):
        self.SetDctFocus(None)
        self.mainMgr.RestoreMaximizedPane()
        self.mainMgr.MaximizePane(self.getDctPane())
        self.mainMgr.Update()

    def OnMakeResultsFull(self, event):
        self.SetResFocus(None)
        self.mainMgr.RestoreMaximizedPane()
        self.mainMgr.MaximizePane(self.getResPane())
        self.mainMgr.Update()

    def OnMakeCommentaryFull(self, event):
        self.SetCmtFocus(None)
        self.mainMgr.RestoreMaximizedPane()
        self.mainMgr.MaximizePane(self.getCmtPane())
        self.mainMgr.Update()

    def OnHideTree(self, event):
        pane = self.mainMgr.GetPane('Tree')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()


    def OnHideEntryTB(self, event):
        pane = self.mainMgr.GetPane('entryTB')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()

    def OnHideHelpTB(self, event):
        pane = self.mainMgr.GetPane('helpTB')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()

    def OnHideMessageTB(self, event):
        pane = self.mainMgr.GetPane('messageTB')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()

    def OnHideViewerTB(self, event):
        pane = self.mainMgr.GetPane('viewerTB')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()

    def OnHideButtonTB(self, event):
        pane = self.mainMgr.GetPane('buttonTB')
        if pane.IsShown():
            pane.Hide()
        else:
            pane.Show()
        self.mainMgr.Update()


    ## History Functions
    def OnLeftButton(self, event):
        self.SetBibFocus(None)
        current = self.history.GetSelection()
        if current == 0:
            return
        self.history.SetSelection(current-1)
        self.OnHistory(None)

    def OnRightButton(self, event):
        self.SetBibFocus(None)
        current = self.history.GetSelection()
        self.history.SetSelection(current+1)
        self.OnHistory(None)


    def OnCmtNext(self):
        tab = self.cmtTabIdx -1
        title = self.cDescList[tab]

        self.SetCmtFocus(None)
        hit = None

        ref = self.CmtRef

        if self.nextCmt == 0:
            if tab in self.hitList:
                ref = self.hitList[tab]

        if tab != self.verseListTab:
            self.GetVerseList(tab)

        try:
            idx = self.currentVL.index(ref)
        except:
            for idx in range(len(ref)):
                #print ref[:idx]
                dIdx = self.FindCmtEntry(ref[:idx])
                if dIdx:
                    hit = dIdx
            idx = -1
            if hit:
                idx = hit -1

        try:
            next = self.currentVL[idx+1]
        except:
            next = self.currentVL[0]

        self.CmtRef = next

        answer, imgNames = normSearch.showLibTopic(next, self.cmtFileList[tab], self.font, self.cmtColor, title, 1)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.cmtDisplay[tab].SetPage(answer)
        self.cmtCurrent = answer
        self.ttsTxt = answer

        if imgNames:
            self.RemoveImages(imgNames)

        if tab +1 != 0:
            self.cmtHistory.append((tab +1, next))
            self.cmtNB.cmtHistoryIdx = -1

        self.nextCmt = 1

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(707) == True:
            self.cmtEntry.SetValue(next)
            item = self.FindCmtEntry(next.capitalize())
            if item:
                self.cmtListbox.EnsureVisible(item)
                self.cmtListbox.Select(item)


    def OnCmtPrev(self):
        self.SetCmtFocus(None)
        tab = self.cmtTabIdx -1
        title = self.cDescList[tab]
        hit = None

        ref = self.CmtRef

        if self.nextCmt == 0:
            if tab in self.hitList:
                ref = self.hitList[tab]

        if tab != self.verseListTab:
            self.GetVerseList(tab)

        try:
            idx = self.currentVL.index(ref)
        except:
            for idx in range(len(ref)):
                dIdx = self.FindCmtEntry(ref[:idx])
                if dIdx:
                    hit = dIdx
            idx = -1
            if hit:
                idx = hit -1

        try:
            next = self.currentVL[idx-1]
        except:
            next = self.currentVL[-1]

        self.CmtRef = next

        answer, imgNames = normSearch.showLibTopic(next, self.cmtFileList[tab], self.font, self.cmtColor, title, 1)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.cmtDisplay[tab].SetPage(answer)
        self.cmtCurrent = answer
        self.ttsTxt = answer

        if imgNames:
            self.RemoveImages(imgNames)

        if tab +1 != 0:
            self.cmtHistory.append((tab +1, next))
            self.cmtNB.cmtHistoryIdx = -1

        self.nextCmt = 1

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(707) == True:
            self.cmtEntry.SetValue(next)
            item = self.FindCmtEntry(next.capitalize())
            if item:
                self.cmtListbox.EnsureVisible(item)
                self.cmtListbox.Select(item)


    def OnDctNext(self):
        tab = self.dctNB.GetSelection()
        title = self.dDescList[tab]

        self.SetDctFocus(None)
        topic = self.dctWord
        hit = None

        if tab != self.wordListTab:
            self.GetWordList(tab)
        try:
            idx = self.currentWL.index(topic)
        except:
            for idx in range(len(topic)):
                dIdx = self.FindDctEntry(topic[:idx])
                if dIdx:
                    hit = dIdx
            idx = -1
            if hit:
                idx = hit -1

        try:
            next = self.currentWL[idx+1]
        except:
            next = self.currentWL[0]

        self.dctWord = next

        answer, imgNames = normSearch.showLibTopic(next, self.dctFileList[tab], self.font, self.dctColor, title, 0)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.dctDisplay[tab].SetPage(answer)
        self.dctCurrent = answer
        self.ttsTxt = answer

        if imgNames:
            self.RemoveImages(imgNames)

        self.dctHistory.append((tab, next))
        self.dctNB.dctHistoryIdx = -1


        #self.FlagTabs(next)

        if self.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
            self.dctEntry.SetValue(next)
            item = self.FindDctEntry(next.capitalize())
            if item:
                self.dctListbox.EnsureVisible(item)
                self.dctListbox.Select(item)


    def OnDctPrev(self):
        tab = self.dctNB.GetSelection()
        title = self.dDescList[tab]

        self.SetDctFocus(None)
        topic = self.dctWord
        hit = None

        if tab != self.wordListTab:
            self.GetWordList(tab)

        try:
            idx = self.currentWL.index(topic)
        except:
            for idx in range(len(topic)):
                dIdx = self.FindDctEntry(topic[:idx])
                if dIdx:
                    hit = dIdx
            idx = -1
            if hit:
                idx = hit -1

        try:
            next = self.currentWL[idx-1]
        except:
           next = self.currentWL[-1]

        self.dctWord = next

        answer, imgNames = normSearch.showLibTopic(next, self.dctFileList[tab], self.font, self.dctColor, title, 0)
        if self.fontSize > 0:
            answer = '<font size="+%s">%s</font>' % (self.fontSize, answer)

        self.dctDisplay[tab].SetPage(answer)
        self.dctCurrent = answer
        self.ttsTxt = answer

        if imgNames:
            self.RemoveImages(imgNames)

        self.dctHistory.append((tab, next))
        self.dctNB.dctHistoryIdx = -1


        #self.FlagTabs(next)

        if self.dctNB.dctPanel.miniTB.GetToolToggled(610) == True:
            self.dctEntry.SetValue(next)
            item = self.FindDctEntry(next.capitalize())
            if item:
                self.dctListbox.EnsureVisible(item)
                self.dctListbox.Select(item)


    def StatusUpdate(self):
        statText = 'Current Ref: %s' % self.currentRef
        self.statusbar.SetStatusText(statText, 1)

    def OnShowText(self, state):
        if state == True:
            self.showText = True
        else:
            self.showText = False
        self.OnBibNBChanged(None)

    def OnShowStrongs(self, state):
        if state == True:
            self.showStrongs = True
        else:
            self.showStrongs = False
        self.OnBibNBChanged(None)


    def OnShowFootnote(self, state):
        if state == True:
            self.showFootnote = True
        else:
            self.showFootnote = False
        self.OnBibNBChanged(None)



## Bible Reference Change Functions
    def OnNextVerse(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        add = 0
        #if self.showBibSum == 1:
        #    add = 1

        #print self.verseInt, 'vi'

        self.SetBibFocus(None)
        self.Freeze()

        if self.verseInt == len(self.contCellList) -add:
            if self.currentRef == 'Rev 22:20':
                self.Thaw()
                return
            else:
                self.OnNextChap(None)

            try:
                newCell = self.contCellList[self.verseInt +add]
                newCell.SetBackgroundColour(self.backColor)
            except:
                self.Thaw()
                return
        else:
            try:
                self.oldCell.SetBackgroundColour(wx.Colour(255, 255, 255))
                newCell = self.contCellList[self.verseInt +add]
                newCell.SetBackgroundColour(self.backColor)

                h = newCell.GetHeight()
                x, y = self.currBibDisplay.GetViewStart()
                self.currBibDisplay.Scroll(-1, y +h/16)
            except:
                self.Thaw()
                return

        self.verseInt += 1
        self.currentRef = self.currentChap + str(self.verseInt)

        
        self.StatusUpdate()

        #self.ClearCmtTabs()
        self.FlagCmtTabs(self.currentRef)
        self.checkRefNB()
        
        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            self.OnCmtNBChanged(None)

        self.oldCell = newCell
        self.currBibDisplay.Refresh()
        self.SetBibFocus(None)
        self.Thaw()

        bibPane = self.mainMgr.GetPaneByWidget(self.bibRefPanel)
        if self.useMini == 1 and bibPane == self.getMaximized() or self.bibExpandMW == 1 and bibPane == self.getMaximized():
            self.displayMiniWin()

    def OnPreVerse(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        self.Freeze()
        add = 0
        #if self.showBibSum == 1:
        #    add = 1

        if self.verseInt == 1:
            if self.currentRef == 'Gen 1:1':
                self.Thaw()
                return

            try:
                self.OnPreChap(None)
                self.verseInt = len(self.contCellList) -add
                newCell = self.contCellList[self.verseInt -1 +add]
                self.currBibDisplay.Scroll(-1, 500)
            except:
                self.Thaw()
                return

        else:
            try:
                self.oldCell.SetBackgroundColour(wx.Colour(255, 255, 255))
                newCell = self.contCellList[self.verseInt -2 +add]
                self.verseInt -= 1
                h = newCell.GetHeight()
                x, y = self.currBibDisplay.GetViewStart()
                self.currBibDisplay.Scroll(-1, y - h /16)
            except:
                self.Thaw()
                return

        newCell.SetBackgroundColour(self.backColor)
        self.oldCell = newCell

        self.currentRef = self.currentChap + str(self.verseInt)

        
        #self.ClearCmtTabs()
        self.FlagCmtTabs(self.currentRef)
        self.checkRefNB()
        
        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            self.OnCmtNBChanged(None)

        self.StatusUpdate()
        self.currBibDisplay.Refresh()
        self.SetBibFocus(None)
        self.Thaw()

        bibPane = self.mainMgr.GetPaneByWidget(self.bibRefPanel)
        if self.useMini == 1 and bibPane == self.getMaximized() or self.bibExpandMW == 1 and bibPane == self.getMaximized():
            self.displayMiniWin()


    def OnNextChap(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        ref = self.currentChap

        #print self.currentRef, ref

        prs = re.search(r'(\w\w\w) ?(\d+)?:?', ref)
        bk = prs.group(1)
        if prs.group(2):
            chap = prs.group(2)
        else:
            chap = 1

        if bk == 'Rev' and chap == '22':
            return

        try:
            chaps = int(self.Tree.books[bk]) -1
            order = self.Tree.order
        except:
            chaps = int(self.Tree.apocBooks[bk]) -1
            order = self.Tree.apocOrder

        if int(chap) == chaps:
            bkIdx = order.index(bk)
            bk = order[bkIdx +1]
            new = '%s 1:' % bk
            next = 1
        else:
            next = int(chap) +1
            new = '%s %s:' %(bk, next)

        self.currentRef = new
        self.currentChap = new
        self.OnChapDisplay(new)

        self.noTreeProcess = 1
        if self.Tree.IsExpanded(self.Tree.bookId[bk]):
            self.Tree.SelectItem(self.Tree.chapId[bk+str(next)])
        else:
            self.Tree.SelectItem(self.Tree.bookId[bk])
        self.noTreeProcess = 0

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            #self.ClearCmtTabs()
            self.FlagCmtTabs(self.currentRef)
            self.OnCmtNBChanged(None)

        self.SetBibFocus(None)
        self.verseInt = 0


    def OnPreChap(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        ref = self.currentChap
        prs = re.search(r'(\w\w\w) ?(\d+)?:?', ref)
        bk = prs.group(1)
        if prs.group(2):
            chap = prs.group(2)
        else:
            chap = 1

        if bk == 'Gen' and chap == '1':
            return

        try:
            chaps = int(self.Tree.books[bk]) -1
            order = self.Tree.order
            books = self.Tree.books
        except:
            chaps = int(self.Tree.apocBooks[bk]) -1
            order = self.Tree.apocOrder
            books = self.Tree.apocBooks

        if int(chap) == 1:
            bkIdx = order.index(bk)
            bk = order[bkIdx -1]
            new = '%s %s:' % (bk, int(books[bk]) -1)
            prev = int(books[bk]) -1
        else:
            prev = int(chap) -1
            new = '%s %s:' %(bk, prev)

        self.currentRef = new
        self.currentChap = new
        self.OnChapDisplay(new)

        self.noTreeProcess = 1
        if self.Tree.IsExpanded(self.Tree.bookId[bk]):
            self.Tree.SelectItem(self.Tree.chapId[bk+str(prev)])
        else:
            self.Tree.SelectItem(self.Tree.bookId[bk])
        self.noTreeProcess = 0

        if self.cmtNB.cmtPanel.miniTB.GetToolToggled(706) == True:
            #self.ClearCmtTabs()
            self.FlagCmtTabs(self.currentRef)
            self.OnCmtNBChanged(None)

        self.SetBibFocus(None)
        self.verseInt = 0



    def OnPreBook(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        current = self.Tree.GetSelection()
        if self.Tree.ItemHasChildren(current):
            current = self.Tree.GetFirstChild(current)
            current = current[0]
        book = self.Tree.GetItemParent(current)
        nextBook = self.Tree.GetPrevSibling(book)
        if nextBook.IsOk():
            self.Tree.SelectItem(nextBook)
        self.SetBibFocus(None)

    def OnNextBook(self, event):
        self.CheckTTSSpeak()
        self.bibAudioCheck()
        self.OnSaveNotes()

        current = self.Tree.GetSelection()
        if self.Tree.ItemHasChildren(current):
            current = self.Tree.GetFirstChild(current)
            current = current[0]
        book = self.Tree.GetItemParent(current)
        nextBook = self.Tree.GetNextSibling(book)
        if nextBook.IsOk():
            self.Tree.SelectItem(nextBook)
        self.SetBibFocus(None)


    # Book/Article Viewer
    def OnNextBookChap(self, event):
        if self.cpMini:
            try:
                self.cpMini.BookViewer.OnNextChap(None)
            except:
                return

    def OnPreBookChap(self, event):
        if self.cpMini:
            try:
                self.cpMini.BookViewer.OnPrevChap(None)
            except:
                return


    ## Viewers
    def OnDevotions(self, event):
        if self.devotionWin == None:
            self.devotionWin = devWin.DevotionWin(self)
            self.devotionWin.Centre()
            self.devotionWin.Show()
        else:
            if self.devotionWin.IsShown():
                self.devotionWin.Hide()
            else:
                self.devotionWin.Show()


    def OnLibViewer(self, event):
        self.OnMasterControlMini(None, 2)
        self.cpMini.LBook.SetSelection(8)
        self.SetResFocus(None)
        self.checkState.CheckState()



    def OnImageViewer(self, event):
        if not self.imgViewer:
            wx.BeginBusyCursor()
            self.imgViewer = imgViewer.ImageViewer(self)
            self.imgViewer.SetPosition(self.imgWinPos)
            self.imgViewer.SetSize(self.imgWinSize)
            wx.EndBusyCursor()

        if self.imgViewer.IsShown():
            #print 'raise'
            #self.imgViewer.Hide()
            self.imgViewer.Raise()
        else:
            #print 'show'
            self.imgViewer.Show()
            #self.Lower()
        #if self.imgViewer.IsIconized():
        #    self.imgViewer.Iconize()


    def OnParGen(self, event):
        if not self.parallelWin:
            self.parallelWin = parGen.ParGen(self)
        self.parallelWin.Show()

    
    def OnSessMan(self, event):
        #if not self.parallelWin:
        #    self.parallelWin = parGen.ParGen(self)
        self.sessMan.Show()
        if self.optionsDlg and self.optionsDlg.IsShown():
            self.optionsDlg.Hide()

    

    def ChangeTabTitle(self, nb, idx, title):
        offset = 0
        if nb == self.bibNB:
            fn = self.bibFileList[idx]
            data = self.bibData
        elif nb == self.dctNB:
            fn = self.dctFileList[idx]
            data = self.dctData
        elif nb == self.cmtNB:
            fn = self.cmtFileList[idx -1]
            data = self.cmtData
            offset = 1
            
        con = sqlite.connect(fn)
        cur = con.cursor()                 
                                
        cur.execute('UPDATE title SET abbr="%s"' % title)
        con.commit()
        
        data[idx -offset][0] = title       
        self.sessMan.OnLoad(None)
        


    def OnWheelScroll(self, event):
        #event.Skip()
        inc = -3
        if event.GetWheelRotation() < 0:
            inc = 3

        try:
            self.winCapture.ScrollLines(inc)
        except:
            print 'No WinCapture'
            return
        #self.winCapture.SetFocus()


    def OnDualScroll(self, event):
        page = event.GetEventObject()
        event.Skip()
        pos = page.GetViewStart()
        tab = self.bibNB.GetSelection()
        mainBib = self.bibDisplay[tab]
        mainBib.Scroll(pos[0], pos[1])


    def enterWindow(self, event):

        event.Skip()

        self.winCapture = event.GetEventObject()
        #self.winCapture.SetFocus()


    def leaveWindow(self, event):
        event.Skip()

        try:
            self.toolwin.Destroy()
        except:
            pass
        self.popRef = ''



    def OnTTSReadImage(self, text):
        if not self.tts:
            return

        if self.tts.tts.IsSpeaking():
            self.tts.Stop()
            return

        self.CheckTTSSpeak()
        self.tts.speakTxt(text, self.ttsSkipRef, self.ttsVoice)



    def bibAudioCheck(self):
        if self.bibPlayer and self.bibPlayer.GetState() == wx.media.MEDIASTATE_PLAYING:
            self.bibPlayer.Stop()

            if self.audioVsInt:
                self.currentRef = self.currentChap + str(self.audioVsInt)

            statText = 'Current Ref: %s' % self.currentRef
            self.statusbar.SetStatusText(statText, 1)

            return True
        else:
            return False

    
    def CheckTTSSpeak(self):
        #print 'in tts check'
        self.breakTTS = False
        if self.ttsEng and self.ttsEng.isSpeaking():
            self.breakTTS = True
            self.ttsEng.stop()
            print 'CheckTTSSpeak, was speaking, now stopped'
            return True
        else:
            return False


    def OnTTSSpeak(self, event):
        print 'in tts speak'
        
        if not self.ttsEng:
            dialogs.ttsPlayError(self)
            return
        
        if self.CheckTTSSpeak():
            print 'in check speak'
            return

        if self.bibAudioCheck():
            return

        focus = self.FindFocus()
        #print focus.GetName(), 'tts'

        if focus == self.editor:
            if self.editor.HasSelection():
                self.ttsTxt = self.editor.GetStringSelection()
            else:
                self.ttsTxt = self.editor.GetRange(0, 10000)

        elif focus == self.notes:
            if self.notes.HasSelection():
                self.ttsTxt = self.notes.GetStringSelection()
            else:
                self.ttsTxt = self.notes.GetRange(0, 10000)

        elif focus == self.Tree: # or focus == self.history:
            self.ReadVerses()
            return

        elif focus == self.bibRefWin:
            self.ReadVerses()
            return

        elif isinstance(focus, baseClass.HtmlWindow):
            sel = self.OnSelectionCheck(focus)
            if sel != '':
                self.ttsTxt = sel

            elif focus.GetName() == 'Books':
                #print 'is book'
                self.ttsTxt = self.resultCurrent[0]

            elif focus.GetName() == 'search':
                tab = self.resNB.GetSelection()
                res = self.resultCurrent[tab -1]
                parse = re.search(r'<a name="results"></a>(.+)', res, re.DOTALL)
                self.ttsTxt = parse.group(1)

                self.resDisplay[tab -1].ScrollToAnchor('results')
                self.resDisplay[tab -1].ScrollLines(-2)

            elif focus.GetGrandParent().GetParent() == self.bibNB:
                self.ReadVerses()
                return

            elif focus.GetGrandParent().GetParent() == self.dctNB:
                self.ttsTxt = self.dctCurrent

            elif focus.GetGrandParent().GetParent() == self.resNB:
                tab = self.resNB.GetSelection() -1
                #print tab , 'tab'
                if tab > 0:
                    self.OnSpeakError()
                    return
                else:
                    self.ttsTxt = self.resultCurrent[0]
            elif focus.GetGrandParent().GetParent() == self.cmtNB:
                self.ttsTxt = self.cmtCurrent
            else:
                self.OnSpeakError()
                return
        else:
            self.OnSpeakError()
            return
                
        self.ttsEng.speak(self.ttsTxt, True, self.ttsVoice)





    ## These three methods are for an approximated time based on the verse length

    def getVerseLen(self, audioLen):
        selStr = 'SELECT * FROM bible WHERE ref LIKE \'%s%%\'' % self.currentChap
        con = sqlite.connect(self.bibFileList[self.avIndex])
        cur = con.cursor()
        cur.execute(selStr)

        rows = cur.fetchall()

        #print audioLen, 'length'

        if self.IsScourbyAudio:
            timing = [2.5]
            add = 5
            if len(self.currentChap) == 6 and self.currentChap[-2] == '1':
                timing = [6.0]
        else:
            timing = [2.2]
            add = 5
            if len(self.currentChap) == 6 and self.currentChap[-2] == '1':
                timing = [4.0]

        total = 0
        vsLen = []

        for row in rows:
            line = row[2][:-1]
            line = re.sub(r'<[^>]+>|[()]', '', line)

            chars = len(line)

            vsLen.append(chars)
            total += chars

        for cnt in vsLen[:-1]:
            per = cnt /float(total)
            seq = per * (audioLen - add) # Compensate for silence at ends of file
            timing.append(seq)

        return timing



    def OnBibSpeechPlay(self, event):
        audioLen = self.bibPlayer.Length() /1000
        timingList = self.getVerseLen(audioLen)

        #print timingList
        vsInt = 1
        if self.currentRef[-1].isdigit():
            idx = self.currentRef.index(':')
            vsInt = int(self.currentRef[idx +1:])

            prevSum = sum(timingList[:vsInt ])
            timingList = timingList[vsInt:]

            self.bibPlayer.Seek(prevSum *1000)
            vsInt += 1

        self.bibPlayer.Play()
        thread.start_new_thread(self.verseScroll, (timingList, vsInt))


    def verseScroll(self, timing, vsInt):
        for t in timing:
            count = 0
            while self.bibPlayer.GetState() and count < t:
                time.sleep(.1)
                count += .1

            if self.bibPlayer.GetState():
                print 'in state'

                wx.CallAfter(self.oldCell.SetBackgroundColour, wx.Colour(255, 255, 255))
                
                newCell = None
                if vsInt -1 < len(self.contCellList):
                    newCell = self.contCellList[vsInt -1]

                if self.showHighlight == 1 and vsInt -1 < len(self.contCellList) :
                    wx.CallAfter(newCell.SetBackgroundColour, self.backColor)

                    self.oldCell = newCell
                    wx.CallAfter(self.bibNB.Refresh)

                scrollPos = self.currBibDisplay.GetViewStart()[1] * 16
                if newCell and newCell.GetPosY() + 112 - scrollPos > self.bibNB.GetClientSize()[1]:
                    ref = self.currentChap + str(vsInt)
                    wx.CallAfter(self.currBibDisplay.ScrollToAnchor, ref)
                    self.currBibDisplay.ScrollLines(-2)

                self.audioVsInt = vsInt
                vsInt += 1


    def OnBibSpeechFinished(self, event):
        if self.readChapCon == 1:
            self.OnNextChap(None)
            self.ReadVerses()



    def ReadVerses(self):
        tab = self.bibNB.GetSelection()
        if tab == len(self.bibFileList):
            dialogs.noTTSParallel(self)
            return
        
        if self.bibPlayer and self.bibPlayer.GetState() == wx.media.MEDIASTATE_PLAYING:
            self.bibPlayer.Stop()
            return

        if self.mediaMini:
            self.mediaMini.AudioPanel.mc.Stop()

        # Audio Bible Speech
        if self.readBibOpt == 1:
            if os.path.isfile(ur'%s/audioPaths.dat' % self.userDir):
                pklFile = open(ur'%s/audioPaths.dat' % self.userDir, 'rb')
            else:
                dialogs.bibAudioPathsError(self)

            speechPathsDict = cPickle.load(pklFile)
            
            try:
                path = speechPathsDict[self.currentChap[:-1]]
            except:
                dialogs.mediaPathError(self)
                return
                
            if not self.bibPlayer:
                try:
                    self.bibPlayer = wx.media.MediaCtrl(self, style=wx.SIMPLE_BORDER)
                except:
                    dialogs.mediaError(self)
                    return

                self.bibPlayer.Bind(wx.media.EVT_MEDIA_LOADED, self.OnBibSpeechPlay)
                self.bibPlayer.Bind(wx.media.EVT_MEDIA_FINISHED, self.OnBibSpeechFinished)

            self.IsScourbyAudio = False
            if 'Alexander Scourby' in path:
                self.IsScourbyAudio = True

            self.bibPlayer.Load(path)

            if not self.currentRef[-1].isdigit():
                self.currBibDisplay.ScrollPages(-20)
            return

        # TTS Bible Speech
        else:

            vs = self.currentRef
            if vs[-1] == ':':
                vs = vs + '1'
                self.ShowRefContext(vs)
            elif vs[-1].isalpha():
                vs = vs + ' 1:1'
                self.ShowRefContext(vs)


            fn = self.bibFileList[self.bibNB.GetSelection()]
            idx = vs.find(':')
            chap = vs[:idx +1]

            last = normSearch.getVerseRange(vs, fn)

            start = fixRef.findIdx(vs, fn)[0]
            end = fixRef.findIdx(chap + str(last), fn)[1]
            
            if not end:
                dialogs.vsIndexTTSError(self)
                return
            
            idxList = [start, end]

            refList, txtList = normSearch.getVsRange(fn, idxList)
            thread.start_new_thread(self.ttsThread, (txtList, refList))

			
    def ttsThread(self, txtList, refList):
        chapDone = 0

        for cyc, ln in enumerate(txtList):
            if self.breakTTS:
                if not self.ttsChapClick:
                    self.currentRef = refList[cyc -1]
                self.ttsChapClick = False
                self.verseInt -= 1
                break

            # To avoid crash when last vs in chap is reselected.
            if self.verseInt > len(self.contCellList):
                self.verseInt -= 1

            wx.CallAfter(self.oldCell.SetBackgroundColour, wx.Colour(255, 255, 255))
            newCell = None

            if self.showHighlight == 1:
                newCell = self.contCellList[self.verseInt -1]
                wx.CallAfter(newCell.SetBackgroundColour, self.backColor)
                self.oldCell = newCell
                wx.CallAfter(self.bibNB.Refresh)
                
            scrollPos = self.currBibDisplay.GetViewStart()[1] * 16
            if newCell and newCell.GetPosY() + 112 - scrollPos > self.bibNB.GetClientSize()[1]:
                wx.CallAfter(self.currBibDisplay.ScrollToAnchor, refList[cyc])
                self.currBibDisplay.ScrollLines(-2)

            self.ttsEng.speak(ln, self.ttsSkipRef, self.ttsVoice)
            while self.ttsEng.isSpeaking():
                pass

            time.sleep(.5)
            
            if cyc +1 == len(txtList):
                self.currentRef = refList[cyc]
                chapDone = 1
            self.verseInt += 1

        #statText = 'Current Ref: %s' % self.currentRef
        #self.statusbar.SetStatusText(statText, 1)
        wx.CallAfter(self.StatusUpdate)

        if chapDone == 1:
            wx.CallAfter(self.OnBibSpeechFinished, None)
            


    def OnTTSStop(self, event):
        self.tts.Stop()


    def OnSpeakError(self):
        dialogs.speakError(self)

    def OnRefError(self):
        dialogs.refError(self)
        return

    def OnRngError(self):
        dialogs.rngError(self)
        return


    def SetQSearchFocus(self, event):
        self.Menu.QSentry.SetFocus()
        wx.CallAfter(self.Menu.QSentry.SelectAll)


    def OnDragInit(self, event):
        event.Skip()
        if not wx.GetKeyState(wx.WXK_CONTROL):
            return

        page = self.FindFocus()
        txt = page.SelectionToText()
        txt = txt.replace('_', ' ')

        tdo = wx.PyTextDataObject(txt)

        tds = wx.DropSource(page)
        tds.SetData(tdo)
        tds.DoDragDrop(True)


    def OnRefPanel(self, event):
        bibPanel = self.bibMgr.GetPane('Ref Panel')
        if bibPanel.IsShown():
            bibPanel.Hide()
            self.bibNB.bibPanel.miniTB.ToggleTool(511, False)
        else:
            bibPanel.Show()
            self.bibNB.bibPanel.miniTB.ToggleTool(511, True)
        self.bibMgr.Update()


    def OnSelectAll(self, event):
        focus = self.FindFocus()
        try:
            focus.SelectAll()
        except:
            return

    def OnSelectionCheck(self, page):
        sel = page.SelectionToText()
        return sel


    def OnCopy(self, event):
        page = self.FindFocus()
        #print page
        if page == self.editor:
            #print 'is editor'
            self.edit.OnEditorCopy(event)
            return

        try:
            sel = page.SelectionToText()
            if sel == '':
                self.isSelection = 0
                return
            else:
                self.isSelection = 1
            self.do = wx.TextDataObject()
            self.do.SetText(sel)
        except:
            return

        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(self.do)
            wx.TheClipboard.Close()
        else:
            wx.MessageBox("Unable to open the clipboard", "Error")

    def OnTools(self, event):
        tool = tools.modTools.ModTools()
        tool.Show()


    #def OnConvert(self, event):
    #    dialogs.bookConvert(self, self.allUsersDir)
        
    def OnIndex(self, event):
        self.initMods.needRefIdx = self.dctFileList[:]
        self.refIndex.GetModRefs()
        self.initMods.needRefIdx = self.cmtFileList[:]
        self.refIndex.GetModRefs()
        bkPth = [grp[2] for grp in self.bkData]
        self.initMods.needRefIdx = bkPth[:]
        self.refIndex.GetModRefs()
        
        self.initMods.needRefIdx = []


    def OnModFolder(self, event):
        import subprocess
        subprocess.Popen(['xdg-open', self.allUsersDir])
        

    def OnUserFolder(self, event):
        import subprocess
        try:
            subprocess.Popen(['xdg-open', self.userDir])    
        except:
            return

    def OnConfigFolder(self, event):
        return
        #os.startfile("%s" % self.userDir, 'explore' )


    def OnNotesFocus(self, event):
        self.cmtNB.SetSelection(0)
        self.OnCmtNBChanged(None)
        if self.getMaximized():
            self.mainMgr.RestoreMaximizedPane()
            self.mainMgr.MaximizePane(self.getCmtPane())
            self.mainMgr.Update()


    def OnContextHelp(self, context):
        return
        #win32help.HtmlHelp(self.GetHandle(), self.appPath + '/manual.chm', win32help.HH_HELP_CONTEXT, context)


    def OnHelp(self, event):
        #print 'file:%s/manual/index.html' % self.allUsersDir
        wx.LaunchDefaultBrowser('file:%s/manual/index.html' % self.allUsersDir)


    def OnFontPlus(self, event):
        if self.fontSize < 3:
            self.fontSize += 1

        self.OnBibNBChanged(None)
        self.OnDctNBChanged(None)
        self.OnCmtNBChanged(None)
        #if self.cpMini:
        #    self.cpMini.BookViewer.OnSelChanged(None)

    def OnFontMinus(self, event):
        if self.fontSize > 0:
            self.fontSize -= 1

        self.OnBibNBChanged(None)
        self.OnDctNBChanged(None)
        self.OnCmtNBChanged(None)
        #if self.cpMini:
        #    self.cpMini.BookViewer.OnSelChanged(None)


    def SetWinColors(self):
        self.dctColor = self.winColors[self.dctColorIdx]
        self.cmtColor = self.winColors[self.cmtColorIdx]
        self.resColor = self.winColors[self.resColorIdx]
        self.refColor = self.winColors[self.refColorIdx]

        self.dctHeadColor = self.winHeadColors[self.dctColorIdx]
        self.cmtHeadColor = self.winHeadColors[self.cmtColorIdx]
        self.resHeadColor = self.winHeadColors[self.resColorIdx]
        self.refHeadColor = self.winHeadColors[self.refColorIdx]


    def SetVerseBackColor(self):
        if self.backColorIdx == 1:
            self.backColor = wx.Colour(250, 220, 220) #FADCDC
            self.backColorHash = '#FADCDC'
        elif self.backColorIdx == 2:
            self.backColor = wx.Colour(220, 220, 250) #DCDCFA
            self.backColorHash = '#DCDCFA'
        elif self.backColorIdx == 3:
            self.backColor = wx.Colour(220, 250, 220) #DCFADC
            self.backColorHash = '#DCFADC'
        else:
            self.backColor = wx.Colour(220, 220, 220) #DCDCDC
            self.backColorHash = '#DCDCDC'


    def OnPause(self, event):
        if self.mediaMini:
            if self.mediaMini.AudioPanel.pauseButton.GetValue() == True:
                self.mediaMini.AudioPanel.pauseButton.SetValue(False)
            else:
                self.mediaMini.AudioPanel.pauseButton.SetValue(True)
            self.mediaMini.AudioPanel.onPause(None)


    def OnBAsite(self, event):
        wx.LaunchDefaultBrowser('http://www.bibleanalyzer.com/download')

    def OnBAupdate(self, event):
        update.UpdateCheck()

    def OnBAforum(self, event):
        wx.LaunchDefaultBrowser('http://www.bibleanalyzer.com/forum')

    def OnModulesPage(self, event):
        wx.LaunchDefaultBrowser('http://www.bibleanalyzer.com/modules.html')


    def OnLinkClick(self, event):
        event.Skip()
        wx.CallAfter(self.MakeLinkScroll)

    def MakeLinkScroll(self):
        page = self.FindFocus()
        page.ScrollLines(-2)


    def OnAbout(self, event):
        aboutFrm.AboutFrame(self)

    def OnWelcome(self, event):
        self.welcome = welcome.WelcomeWin(self)
        self.welcome.welcomeWin.SetFocus()

    def ExportNotes(self, event):
        dialogs.ExportNotes(self)


    def OnClose(self, event):
        #if event:
        #    event.Skip()

        self.CheckTTSSpeak()
        if self.bibPlayer:
            self.bibAudioCheck()

        self.maximized = None
        max = self.getMaximized()

        if max:
            self.maximized = max.name
            self.mainMgr.RestorePane(max)
            self.mainMgr.Update()

        if self.editor.IsModified():
            self.edit.saveCheck()

        if self.parallelWin and self.parallelWin.parHistory:
            save = dialogs.SaveParallel(self)
            save.ShowModal()

        if self.bkWin:
            self.bkWin.Hide()

        self.mcpShown = False
        if self.cpMini and self.cpMini.IsShown():
            self.mcpShown = True
            tab = self.cpMini.LBook.GetSelection()
            self.mcpTab = tab

        self.lastBookTitle = None
        if self.cpMini and self.cpMini.BookViewer.Tree.GetSelection() and self.resNB.GetSelection() == 1:
            item = self.cpMini.BookViewer.Tree.GetSelection()
            itemTxt = self.cpMini.BookViewer.Tree.GetItemText(item).strip(' \n')
            parent = self.cpMini.BookViewer.Tree.GetItemParent(item)

            if parent and parent != self.cpMini.BookViewer.root:
                parentTxt = self.cpMini.BookViewer.Tree.GetItemText(parent)
                self.lastBookTitle = '%s/%s' % (parentTxt, itemTxt)
            else:
                self.lastBookTitle = '%s' % (itemTxt)

        if self.cpMini:
            self.cpMini.Hide()

        if self.miniWin:
            self.miniWin.Hide()

        if self.imgViewer:
            self.imgViewer.Hide()

        if self.mediaMini:
            self.audioPlayAll = self.mediaMini.AudioPanel.playAll.GetValue()
            self.lastAudio = self.mediaMini.AudioPanel.title
            self.mediaMini.Hide()

        if self.devotionWin:
            if self.devotionWin.prayerEdit.IsModified():
                self.devotionWin.prayerEdit.SaveFile(self.userDir + r'/prayer.xml', 2)
            self.devotionWin.Hide()

        self.layoutList.append(self.mainMgr.SavePerspective())
        #print len(self.layoutList), 'len layout close'

        try:
            # Save layouts list as pickled file
            pFile = file(self.userDir + r'/mainLayout.dat', 'wb')
            cPickle.dump(self.layoutList, pFile)
            pFile.close()

            bibLayout = self.bibMgr.SavePerspective()
            pFile = file(self.userDir + r'/bibLayout.dat', 'wb')
            cPickle.dump(bibLayout, pFile)
            pFile.close()
        except:
            print 'Layouts not saved'
            pass
        
        self.mainAppMax = self.IsMaximized()
                        
        self.OnSaveNotes()
        self.SaveSet()
        
        self.Hide()
        self.Destroy()

    
    def OnReload(self):
        self.Freeze()
        self.bibNB.DeleteAllPages()
        self.dctNB.DeleteAllPages()
        self.cmtNB.DeleteAllPages()
        
        self.noCmtChange = True
        self.noDctChange = True
        self.noBibChange = True
        
        self.LoadModules(True)
        self.AddBibles()
        self.AddDictionaries()
        self.AddCommentaries()
                
        self.noCmtChange = False
        self.noDctChange = False
        self.noBibChange = False

        self.SetDefaults()

        self.bibNB.SetSelection(self.avIndex)
        self.cmtNB.SetSelection(self.defaultCmtIdx +1)

        self.FlagTabs(self.currentWord)
        self.FlagCmtTabs(self.currentRef)

        self.OnBibNBChanged(None)
        self.OnDctNBChanged(None)
        self.OnCmtNBChanged(None)
                
        self.OnSelect(self.currentWord)
        self.ShowRefContext(self.currentRef)
        
        if self.cpMini:
            show = self.cpMini.IsShown()
            self.cpMini.Destroy()
            self.cpMini = None
            self.OnMasterControlMini(None, show)
            
        if self.optionsDlg:
            show = self.optionsDlg.IsShown()
            self.optionsDlg.Destroy()
            self.optionsDlg = None
            self.OnOptionsDlg(None, show)
                
        self.Thaw()

    
    
    ## Options Dialog Functions
    def OnOptionsDlg(self, event, show = True):
        if self.optionsDlg == None:
            self.optionsDlg = optionsDlg.Options(self)

        # Send Settings to Options Dialog
        self.optionsDlg.useOldFont.SetValue(self.useOldFont)

        self.optionsDlg.saveAllMW.SetValue(self.saveAllMW)

        self.optionsDlg.fontSizeRB.SetSelection(self.fontSize)
        self.optionsDlg.popFontSize.SetSelection(self.popFontSize)

        self.optionsDlg.showBibleVer.SetValue(self.showBibleVer)
        self.optionsDlg.OnStyle(None)

        self.optionsDlg.fullBibRef.SetValue(self.fullBibRef)

        #self.optionsDlg.bibRefPanel.SetValue(self.showBibRefPanel)
        self.optionsDlg.showBibSum.SetValue(self.showBibSum)

        self.optionsDlg.backColorIdx.SetSelection(self.backColorIdx)

        self.optionsDlg.fontFace.SetStringSelection(self.font)

        self.optionsDlg.versePopupRB.SetSelection(self.popColorIdx)

        self.optionsDlg.showQuote.SetValue(self.showQuote)

        self.optionsDlg.showBkWin.SetValue(self.showBkWin)

        self.optionsDlg.showRedLetterCk.SetValue(self.showRed)

        self.optionsDlg.popRange.SetSelection(self.popRange -1)

        self.optionsDlg.defaultDct.SetSelection(self.defaultDctIdx)
        self.optionsDlg.defaultCmt.SetSelection(self.defaultCmtIdx)

        self.optionsDlg.defaultPopupTxt.SetStringSelection(self.defaultPopupTxt)

        if self.strongIndex:
            strongDesc = self.dDescList[self.strongIndex]
            self.optionsDlg.defaultStrongs.SetStringSelection(strongDesc)
            
            strongPopDesc = self.dDescList[self.strongPopIndex]
            self.optionsDlg.defaultStrongsPop.SetStringSelection(strongPopDesc)

        self.optionsDlg.useMini.SetValue(self.useMini)
        self.optionsDlg.bibExpandMW.SetValue(self.bibExpandMW)
        self.optionsDlg.loadFile.SetValue(self.loadFile)

        #self.optionsDlg.showDctWL.SetValue(self.showDctWL)
        #self.optionsDlg.showCmtWL.SetValue(self.showCmtWL)

        self.optionsDlg.appendTitleCB.SetValue(self.appendTitle)
        self.optionsDlg.appendTitleTC.SetValue(self.titleText)
        self.optionsDlg.appendToolCB.SetValue(self.addToolText)
        self.optionsDlg.appendToolTC.SetValue(self.toolTxt)

        self.optionsDlg.dctColorIdx.SetSelection(self.dctColorIdx)
        self.optionsDlg.cmtColorIdx.SetSelection(self.cmtColorIdx)
        self.optionsDlg.resColorIdx.SetSelection(self.resColorIdx)
        self.optionsDlg.refColorIdx.SetSelection(self.refColorIdx)
        
        self.optionsDlg.volSlider.SetValue(self.ttsVolume *100)
        self.optionsDlg.rateSlider.SetValue(self.ttsRate)
        self.optionsDlg.startSelect.SetSelection(self.ttsStartIdx)
        self.optionsDlg.skipRef.SetValue(self.ttsSkipRef)

        # Copy Settings
        self.optionsDlg.formatStyle.SetSelection(self.copySettings[0])
        self.optionsDlg.formatFullBk.SetValue(self.copySettings[1])
        self.optionsDlg.showBibleVer.SetValue(self.copySettings[2])
        self.optionsDlg.refPos.SetValue(self.copySettings[3])
        self.optionsDlg.refSep.SetValue(self.copySettings[4])
        self.optionsDlg.refParen.SetValue(self.copySettings[5])
        self.optionsDlg.refColor.SetValue(self.copySettings[6])
        self.optionsDlg.OnStyle(None)

        #try:
        self.optionsDlg.voices.SetStringSelection(self.ttsVoice)
        #except:
        #    print self.voices, self.ttsVoice

        if self.ttsStartTxt:
            self.optionsDlg.ttsStart.SetValue(self.ttsStartTxt)
        self.optionsDlg.startSelect.SetSelection(self.ttsStartIdx)
        self.optionsDlg.skipRef.SetValue(self.ttsSkipRef)

        self.optionsDlg.readOpt.SetSelection(self.readBibOpt)
        self.optionsDlg.readChapCon.SetValue(self.readChapCon)
        self.optionsDlg.showHighlight.SetValue(self.showHighlight)

        if show:
            self.optionsDlg.Show()


    # Get Settings from Options Dialog
    def GetOptions(self):

        self.useOldFont = self.optionsDlg.useOldFont.GetValue()

        self.saveAllMW = self.optionsDlg.saveAllMW.GetValue()

        self.font = self.optionsDlg.fontFace.GetStringSelection()
        self.fontSize = self.optionsDlg.fontSizeRB.GetSelection()
        self.popFontSize = self.optionsDlg.popFontSize.GetSelection()

        self.fullBibRef = self.optionsDlg.fullBibRef.GetValue()
        self.showBibleVer = self.optionsDlg.showBibleVer.GetValue()

        #self.showBibRefPanel = self.optionsDlg.bibRefPanel.GetValue()
        self.showBibSum = self.optionsDlg.showBibSum.GetValue()

        self.backColorIdx = self.optionsDlg.backColorIdx.GetSelection()
        self.SetVerseBackColor()

        self.SPFace = self.optionsDlg.newFace
        self.SPSize = self.optionsDlg.newSize

        self.popColorIdx = self.optionsDlg.versePopupRB.GetSelection()
        self.GetPopupHeaderColor()


        # Misc Options
        self.defaultDctIdx = self.optionsDlg.defaultDct.GetSelection()
        self.defaultCmtIdx = self.optionsDlg.defaultCmt.GetSelection()
        strongsDesc = self.optionsDlg.defaultStrongs.GetStringSelection()
        strongsPopDesc = self.optionsDlg.defaultStrongsPop.GetStringSelection()
        
        self.defaultPopupTxt = self.optionsDlg.defaultPopupTxt.GetStringSelection()
        try:
            self.popupIndex = self.bDescList.index(self.defaultPopupTxt)
        except:
            self.popupIndex = self.avIndex

        self.strongIndex = None
        self.strongPopIndex = None
        if strongsDesc:
            self.strongIndex = self.dDescList.index(strongsDesc)
        if strongsPopDesc:
            self.strongPopIndex = self.dDescList.index(strongsPopDesc)
        

        self.showQuote = self.optionsDlg.showQuote.GetValue()

        self.showBkWin = self.optionsDlg.showBkWin.GetValue()
        self.bookTitlesLoaded = None

        self.dctColorIdx = self.optionsDlg.dctColorIdx.GetSelection()
        self.cmtColorIdx = self.optionsDlg.cmtColorIdx.GetSelection()
        self.resColorIdx = self.optionsDlg.resColorIdx.GetSelection()
        self.refColorIdx = self.optionsDlg.refColorIdx.GetSelection()
        self.SetWinColors()

        self.showRed = self.optionsDlg.showRedLetterCk.GetValue()
        self.useMini = self.optionsDlg.useMini.GetValue()
        self.bibExpandMW = self.optionsDlg.bibExpandMW.GetValue()
        self.loadFile = self.optionsDlg.loadFile.GetValue()

        #self.showDctWL = self.optionsDlg.showDctWL.GetValue()
        #self.showCmtWL = self.optionsDlg.showCmtWL.GetValue()
        self.popRange = self.optionsDlg.popRange.GetSelection() +1

        # Customize Options
        self.appendTitle = self.optionsDlg.appendTitleCB.GetValue()
        self.titleText = self.optionsDlg.appendTitleTC.GetValue()
        self.addToolText = self.optionsDlg.appendToolCB.GetValue()
        self.toolTxt = self.optionsDlg.appendToolTC.GetValue()

        # Copy Settings
        self.copySettings = []
        self.copySettings.append(self.optionsDlg.formatStyle.GetSelection())
        self.copySettings.append(self.optionsDlg.formatFullBk.GetValue())
        self.copySettings.append(self.optionsDlg.showBibleVer.GetValue())
        self.copySettings.append(self.optionsDlg.refPos.GetValue())
        self.copySettings.append(self.optionsDlg.refSep.GetValue())
        self.copySettings.append(self.optionsDlg.refParen.GetValue())
        self.copySettings.append(self.optionsDlg.refColor.GetValue())

        # TTS Settings
        self.ttsVoice = self.optionsDlg.voices.GetStringSelection()
        self.ttsStartTxt = self.optionsDlg.ttsStart.GetValue()
        self.ttsStartIdx = self.optionsDlg.startSelect.GetSelection()
        self.ttsSkipRef = self.optionsDlg.skipRef.GetValue()

        self.readBibOpt = self.optionsDlg.readOpt.GetSelection()
        self.readChapCon = self.optionsDlg.readChapCon.GetValue()
        self.showHighlight = self.optionsDlg.showHighlight.GetValue()

        self.mainMgr.Update()


    def SetMenuTbItems(self):
        tbId = [self.Menu.helpTbId, self.Menu.viewerTbId, self.Menu.messageTbId, self.Menu.buttonTbId, self.Menu.entryTbId, self.Menu.treeShowId]
        for idx, nm in enumerate(['helpTB', 'viewerTB', 'messageTB', 'buttonTB', 'entryTB', 'Tree']):
            tb = self.mainMgr.GetPane(nm)
            if tb.IsShown():
                item = self.Menu.viewMenu.FindItemById(tbId[idx])
                item.Check()


    ## Save and Get Settings
    def SaveSet(self):
        pos = self.GetPositionTuple()
        size = self.GetSizeTuple()

        self.showDctWL = self.dctNB.dctPanel.miniTB.GetToolToggled(610)
        self.showCmtWL = self.cmtNB.cmtPanel.miniTB.GetToolToggled(707)

        self.showDctDef = self.dctNB.dctPanel.miniTB.GetToolToggled(613)
        self.showCmtDef = self.cmtNB.cmtPanel.miniTB.GetToolToggled(714)

        self.saveRef = self.currentChap

        defaultDctAbbr = self.dAbbrList[self.defaultDctIdx]
        defaultCmtAbbr = self.cAbbrList[self.defaultCmtIdx]

        self.bookmarkList = [self.Menu.bmMenu.FindItemById(num).GetLabel()[7:] for num in range(10000, 10010)]

        defaultStrongsAbbr = None
        defaultStrongsPopAbbr = None
        if self.strongIndex:
            defaultStrongsAbbr = self.dAbbrList[self.strongIndex]
            defaultStrongsPopAbbr = self.dAbbrList[self.strongPopIndex]
        
        if self.cpMini:
            self.miniPos = self.cpMini.GetPositionTuple()
            self.miniSize = self.cpMini.GetSizeTuple()

        if self.miniWin:
            self.miniWinPos = self.miniWin.GetPositionTuple()
            self.miniWinSize = self.miniWin.GetSizeTuple()

        if self.bkWin:
            self.bkWinPos = self.bkWin.GetPositionTuple()
            self.bkWinSize = self.bkWin.GetSizeTuple()

        if self.parallelWin:
            self.parWinPos = self.parallelWin.GetPositionTuple()
            self.parWinSize = self.parallelWin.GetSizeTuple()

        if self.imgViewer:
            self.imgWinPos = self.imgViewer.GetPositionTuple()
            self.imgWinSize = self.imgViewer.GetSizeTuple()

        if self.ttsStartTxt == '':
            self.ttsStartTxt = None

        self.lastSaved = self.lastSaved.replace('\\', '/')

        self.config['settings'] = {}
        self.config['settings']["saveallmw"] = self.saveAllMW
        self.config['settings']["dcttopic"] = self.currentWord

        self.config['settings']["dcttab"] = self.dctNB.GetPageText(self.dctNB.GetSelection())
        self.config['settings']["cmttab"] = self.cmtNB.GetPageText(self.cmtNB.GetSelection())
        self.config['settings']["bibtab"] = self.bibNB.GetPageText(self.bibNB.GetSelection())
        self.config['settings']["restab"] = self.resNB.GetSelection()

        self.config['settings']["layouttitles"] = self.layoutTitles

        self.config['settings']["firstrun"] = self.firstRun

        self.config['settings']["jumpstate"] = self.Menu.jumpBut.GetValue()
        self.config['settings']["audioplayall"] = self.audioPlayAll
        self.config['settings']["lastaudio"] = self.lastAudio

        self.config['settings']["lastsaved"] = self.lastSaved
        self.config['settings']["loadfile"] = self.loadFile

        self.config['settings']["fullbibref"] = self.fullBibRef
        self.config['settings']["showbibrefpanel"] = self.showBibRefPanel
        self.config['settings']["showbibsum"] = self.showBibSum

        self.config['settings']["backcoloridx"] = self.backColorIdx
        self.config['settings']["showbiblever"] = self.showBibleVer

        self.config['settings']["ttsskipref"] = self.ttsSkipRef
        self.config['settings']["ttsstarttxt"] = self.ttsStartTxt
        self.config['settings']["ttsstartidx"] = self.ttsStartIdx
        self.config['settings']["ttsvoice"] = self.ttsVoice
        self.config['settings']["ttsrate"] = self.ttsRate
        self.config['settings']["ttsvolume"] = self.ttsVolume
        self.config['settings']["loadtts"] = self.loadTts

        self.config['settings']["position"] = pos
        self.config['settings']["minipos"] = self.miniPos
        self.config['settings']["minisize"] = self.miniSize
        self.config['settings']["dictminipos"] = self.miniWinPos
        self.config['settings']["dictminisize"] = self.miniWinSize

        self.config['settings']["bkwinpos"] = self.bkWinPos
        self.config['settings']["bkwinsize"] = self.bkWinSize

        self.config['settings']["parwinpos"] = self.parWinPos
        self.config['settings']["parwinsize"] = self.parWinSize

        self.config['settings']["imgwinpos"] = self.imgWinPos
        self.config['settings']["imgwinsize"] = self.imgWinSize

        self.config['settings']["defaultdctabbr"] = defaultDctAbbr
        self.config['settings']["defaultcmtabbr"] = defaultCmtAbbr
        self.config['settings']["defaultstrongsabbr"] = defaultStrongsAbbr
        self.config['settings']["defaultstrongspopabbr"] = defaultStrongsPopAbbr

        self.config['settings']["usedictmini"] = self.useMini
        self.config['settings']["bibexpandmw"] = self.bibExpandMW

        self.config['settings']["poprange"] = self.popRange

        self.config['settings']["appendtitle"] = self.appendTitle
        self.config['settings']["titletext"] = self.titleText
        self.config['settings']["addtool"] = self.addToolText
        self.config['settings']["tooltxt"] = self.toolTxt

        self.config['settings']["showdctwl"] = self.showDctWL
        self.config['settings']["showcmtwl"] = self.showCmtWL

        self.config['settings']["showdctdef"] = self.showDctDef
        self.config['settings']["showcmtdef"] = self.showCmtDef

        self.config['settings']["size"] = size
        self.config['settings']["font"] = self.font
        self.config['settings']["fntsize"] = self.fontSize

        self.config['settings']["popcoloridx"] = self.popColorIdx
        self.config['settings']["txtcolor"] = self.txtColor

        self.config['settings']["showquote"] = self.showQuote
        self.config['settings']["showimage"] = self.showImage
        self.config['settings']["showbkwin"] = self.showBkWin

        self.config['settings']["showred"] = self.showRed

        self.config['settings']["currentref"] = self.currentRef

        self.config['settings']["nobibload"] = self.NoBibLoad
        self.config['settings']["nodctload"] = self.NoDctLoad
        self.config['settings']["nocmtload"] = self.NoCmtLoad
        self.config['settings']["copyformat"] = self.copyFormat
        self.config['settings']["copyfull"] = self.copyFull
        self.config['settings']["spfont"] = self.SPFace
        self.config['settings']["spsize"] = self.SPSize
        self.config['settings']["popuptextpath"] = self.defaultPopupTxt
        self.config['settings']["popfontsize"] = self.popFontSize

        self.config['settings']["dctcoloridx"] = self.dctColorIdx
        self.config['settings']["cmtcoloridx"] = self.cmtColorIdx
        self.config['settings']["rescoloridx"] = self.resColorIdx
        self.config['settings']["refcoloridx"] = self.refColorIdx

        self.config['settings']["chartcolor1"] = self.chartColor1
        self.config['settings']["chartcolor2"] = self.chartColor2
        self.config['settings']["copyrefcolor"] = self.copyRefColor

        self.config['settings']["backColorIdx"] = self.backColorIdx

        self.config['settings']["copysettings"] = self.copySettings
        self.config['settings']["bibmultilist"] = self.bibMultiList
        self.config['settings']["bookmarklist"] = self.bookmarkList

        self.config['settings']["maximized"] = self.maximized

        self.config["settings"]["audiopath"] = self.audioPath
        self.config["settings"]["readbibopt"] = self.readBibOpt
        self.config["settings"]["readchapcon"] = self.readChapCon
        self.config["settings"]["showhighlight"] = self.showHighlight

        self.config["settings"]["mcpshown"] = self.mcpShown
        self.config["settings"]["mcptab"] = self.mcpTab
        self.config["settings"]["lastbooktitle"] = self.lastBookTitle
        self.config["settings"]["showfootnote"] = self.showFootnote

        self.config["settings"]["mainappmax"] = self.mainAppMax
        self.config["settings"]["useoldfont"] = self.useOldFont
        
        self.config["settings"]["sesstab"] = self.sessTab
        self.config["settings"]["sesstabtitles"] = self.sessTabTitles
        
        self.config["settings"]["refnbtab"] = self.refNB.GetSelection()
        self.config["settings"]["showrefhits"] = self.showRefHits
        
        self.config['settings']["paratextlist"] = self.paraTextList
        self.config['settings']["showstrongs"] = self.showStrongs
        
        
        self.config.write()

    def GetSet(self):
        if os.path.isfile(ur'%s/config4.ini' % self.userDir):           
            try:
                
                try:
                    self.showStrongs = self.config['settings']["showstrongs"]
                    self.defaultStrongsPopAbbr = self.config['settings']["defaultstrongspopabbr"]
                    self.paraTextList = self.config["settings"]["paratextlist"]
                except:
                    self.showStrongs = 1
                    self.defaultStrongsPopAbbr = 'StrongEx'
                    self.paraTextList = []

                try:
                    self.showRefHits = eval(str(self.config['settings']['showrefhits']))              
                    self.refNB.refPanel.dctRef.SetValue(self.showRefHits[0])
                    self.refNB.refPanel.cmtRef.SetValue(self.showRefHits[1])
                    self.refNB.refPanel.bkRef.SetValue(self.showRefHits[2])
                    
                    refNBTab = self.config['settings']['refnbtab']
                    self.refNB.SetSelection(refNBTab)
                    if refNBTab > 0:
                        self.refNB.refPanel.Hide()
                        self.refNB.Layout()
                    
                except:
                    self.refNB.SetSelection(0)
                    self.showRefHits = [True, True, True]
                
                #try:
                #    self.sessTab = self.config['settings']['sesstab']
                #    self.sessTabTitles = self.config['settings']['sesstabtitles']
                #    if len(self.sessTabTitles) < 7:
                #        self.sessTabTitles = ["All Modules", "Group 1", "Group 2", "Group 3", "Group 4", "Group 5", "Group 6"]
                #except:
                #    self.sessTab = 0
                #    self.sessTabTitles = ["All Modules", "Group 1", "Group 2", "Group 3", "Group 4", "Group 5", "Group 6"]

                try:
                    self.showDctDef = self.config['settings']['showdctdef']
                    self.showCmtDef = self.config['settings']['showcmtdef']
                except:
                    self.showDctDef = 1
                    self.showCmtDef = 1
                
                try:
                    self.useOldFont = self.config['settings']['useoldfont']
                    self.mainAppMax = self.config['settings']['mainappmax']
                    if self.mainAppMax:
                        self.Maximize()

                    self.showFootnote = self.config['settings']['showfootnote']
                    self.resTab = self.config['settings']['restab']
                    self.miniSize = self.config['settings']['minisize']
                    self.audioPath = self.config["settings"]["audiopath"]
                    self.readBibOpt = self.config["settings"]["readbibopt"]
                    self.readChapCon = self.config["settings"]["readchapcon"]
                    self.showHighlight = self.config["settings"]["showhighlight"]
                    self.mcpShown = self.config["settings"]["mcpshown"]
                    self.mcpTab = self.config["settings"]["mcptab"]
                    self.lastBookTitle = self.config["settings"]["lastbooktitle"]
                except:
                    self.useOldFont = 1
                    self.mainAppMax = 0
                    self.showFootnote = 0
                    self.resTab = 0
                    self.miniSize = (320, 520)
                    self.audioPath = self.allUsersDir + '/modules/audio/'
                    self.readBibOpt = 0
                    self.readChapCon = 0
                    self.showHighlight = 1
                    self.mcpShown = False
                    self.mcpTab = None
                    self.lastBookTitle = None


                self.imgWinPos = self.config['settings']['imgwinpos']
                self.imgWinSize = self.config['settings']['imgwinsize']

                self.parWinPos = self.config['settings']['parwinpos']
                self.parWinSize = self.config['settings']['parwinsize']

                self.bibMultiList = self.config["settings"]["bibmultilist"]

                self.maximized = self.config["settings"]["maximized"]

                self.copySettings = self.config["settings"]["copysettings"]

                self.toolTxt = self.config["settings"]["tooltxt"]
                self.addToolText = self.config['settings']['addtool']

                self.saveAllMW = self.config["settings"]["saveallmw"]
                self.savedDctTopic = self.config["settings"]["dcttopic"]

                self.currentRef = self.config['settings']['currentref']

                self.bibTab = self.config['settings']['bibtab']
                self.dctTab = self.config['settings']['dcttab']
                self.cmtTab = self.config['settings']['cmttab']

                #self.layoutTitles = self.config['settings']['layouttitles']

                self.popFontSize = self.config['settings']['popfontsize']
                self.fontSize = self.config['settings']['fntsize']
                self.showBibRefPanel = self.config['settings']['showbibrefpanel']
                self.backColorIdx = self.config['settings']['backcoloridx']
                self.showBibSum = self.config['settings']['showbibsum']
                self.refColorIdx = self.config['settings']['refcoloridx']

                self.jumpState = self.config['settings']['jumpstate']
                self.Menu.jumpBut.SetValue(self.jumpState)

                self.defaultStrongsAbbr = self.config['settings']['defaultstrongsabbr']
                self.fullBibRef = self.config['settings']['fullbibref']
                self.copyRefColor = self.config['settings']['copyrefcolor']

                self.showBibleVer = self.config['settings']['showbiblever']

                self.audioPlayAll = self.config['settings']['audioplayall']
                self.lastAudio = self.config['settings']['lastaudio']
                self.firstRun = self.config['settings']['firstrun']

                # Regular options

                self.system = wx.SystemSettings_GetMetric
                pos = self.config['settings']['position']
                if pos[0] < -1: pos = (0, pos[1])
                if pos[1] < -1: pos = (pos[0], 0)
                if pos[0] > self.system(wx.SYS_SCREEN_X):
                    pos = (self.system(wx.SYS_SCREEN_X), pos[1])
                if pos[1] > self.system(wx.SYS_SCREEN_Y):
                    pos = (pos[0], self.system(wx.SYS_SCREEN_Y))
                self.SetPosition(pos)

                size = self.config['settings']['size']
                if size[0] > self.system(wx.SYS_SCREEN_X):
                    size = (self.system(wx.SYS_SCREEN_X), size[1])
                if size[1] > self.system(wx.SYS_SCREEN_Y):
                    size = (size[0], self.system(wx.SYS_SCREEN_Y))
                self.SetSize(size)

                self.popColorIdx = int(self.config['settings']['popcoloridx'])
                #self.GetPopupHeaderColor()

                self.txtColor = self.config['settings']['txtcolor']

                self.copyFormat = self.config['settings']['copyformat']

                self.font = self.config['settings']['font']

                self.SPFace = self.config['settings']['spfont']
                self.SPSize = self.config['settings']['spsize']

                self.showRed = self.config['settings']['showred']
                self.miniPos = self.config['settings']['minipos']

                self.miniWinPos = self.config['settings']['dictminipos']

                self.miniWinSize = self.config['settings']['dictminisize']

                self.defaultDctAbbr = self.config['settings']['defaultdctabbr']
                self.defaultCmtAbbr = self.config['settings']['defaultcmtabbr']

                self.useMini = self.config['settings']['usedictmini']

                self.showDctWL = self.config['settings']['showdctwl']
                self.showCmtWL = self.config['settings']['showcmtwl']

                self.appendTitle = self.config['settings']['appendtitle']

                self.titleText = self.config['settings']['titletext']

                portableTxt = ''
                if sessionMan.portable:
                    portableTxt = ', Portable'
                self.title = '%s%s' % ('Bible Analyzer 4', portableTxt)

                if self.appendTitle:
                    self.title = '%s - %s' % (self.title, self.titleText)

                self.SetTitle(self.title)

                self.defaultPopupTxt = self.config['settings']['popuptextpath']

                self.bibExpandMW = self.config['settings']['bibexpandmw']
                self.popRange = self.config['settings']['poprange']
                self.chartColor1 = self.config['settings']['chartcolor1']
                self.chartColor2 = self.config['settings']['chartcolor2']
                self.showQuote = self.config['settings']['showquote']
                self.showImage = self.config['settings']['showimage']

                self.copyFull = self.config['settings']['copyfull']
                self.showBkWin = self.config['settings']['showbkwin']

                self.bkWinPos = self.config['settings']['bkwinpos']
                self.bkWinSize = self.config['settings']['bkwinsize']

                self.ttsVoice = self.config['settings']['ttsvoice']
                self.ttsStartTxt = self.config['settings']['ttsstarttxt']
                self.ttsRate = float(self.config['settings']['ttsrate'])
                self.ttsVolume = float(self.config['settings']['ttsvolume'])

                self.ttsStartIdx = self.config['settings']['ttsstartidx']
                if self.ttsStartIdx > 1:
                    self.ttsStartIdx = 1

                self.ttsSkipRef = self.config['settings']['ttsskipref']
                self.lastSaved = self.config['settings']['lastsaved']

                self.loadFile = self.config['settings']['loadfile']

                self.dctColorIdx = self.config['settings']['dctcoloridx']
                self.cmtColorIdx = self.config['settings']['cmtcoloridx']
                self.resColorIdx = self.config['settings']['rescoloridx']


            except:
                dialogs.configError(self)
                os.remove(self.userDir + r'\config4.ini')
                sys.exit()

        else:
            print 'config else'

            self.bibTab = 'AV'
            self.dctTab = 'Web-1828a'
            self.cmtTab = 'TSKe'

            self.savedDctTopic = 'A'

            self.SetSize((1024, 728))
            self.Center()

            self.currentRef = 'Rom 4:5'

            self.miniPos = (500, 100)
            self.miniSize = (400, 700)
            self.miniWinPos = (600,100)
            self.miniWinSize = (375,550)

            self.lastSaved = ' '
            self.loadFile = False

            self.bkWinSize = (640, 480)
            self.bkWinPos = (550, 150)

            self.useMini = False

            self.bibExpandMW = False
            self.showCmtWL = False
            self.showDctWL = False
            self.popRange = 3

            self.showTips = True

            self.showRed = True

            self.addToolText = True
            self.appendTitle = True

            portableTxt = ''
            if sessionMan.portable:
                portableTxt = ', Portable'

            self.titleText = 'Study to show thyself approved...'
            self.title = '%s%s' % ('Bible Analyzer 4', portableTxt)
            title = '%s - %s' % (self.title, self.titleText)
            self.SetTitle(title)

            self.toolTxt = '"The Words of the Lord are Pure Words..."'


            self.SPFace = u'DejaVu Sans'
            self.SPSize = 9

            self.sash = (334, 234)
            self.font = u'DejaVu Sans'

            self.defaultDctAbbr = 'Web-1828a'
            self.defaultCmtAbbr = 'TSKe'
            self.defaultStrongsAbbr = 'StrongEX'

            #self.fontLarge = False
            self.fontSize = 0
            self.popFontSize = 0

            self.txtColor = '#000000'
            self.popColorIdx = 0
            #self.popColor = '#FFFFE1'

            self.defaultPopupTxt = 'Authorized King James Version'

            self.copyFormat = 0
            self.copyFull = 0
            self.showSymbol = 0

            self.chartColor1 = '#FF9696'
            self.chartColor2 = '#FFCCCC'
            self.copyRefColor = '#800000'
            self.showBibleVer = 1

            self.showQuote = 1
            self.showImage = 1
            self.showBkWin = 0

            self.ttsVoice = 'english'
            self.ttsStartTxt = 'Welcome to Bible Analyzer 4'
            self.ttsVolume = 80
            self.ttsRate = 0
            self.ttsStartIdx = 0
            self.ttsSkipRef = 0
            self.loadTts = True

            self.dctColorIdx = 2
            self.cmtColorIdx = 1
            self.resColorIdx = 3
            self.refColorIdx = 1

            self.showBibRefPanel = 1
            self.fullBibRef = 0
            self.showBibSum = 1
            self.bibRefSashPos = -100
            self.backColorIdx = 0

            self.jumpState = True
            self.Menu.jumpBut.SetValue(True)

            self.firstRun = 0

            #self.layoutTitles = ['Save Current Layout', 'Three Windows 1 - Bible on left, Results and Dct/Cmt on right (Default)', 'Four Windows - Bible/Results top, Cmt/Dct bottom (Old Default)',\
            #'Three Windows 2 - Bible on top, Dct/Cmt and Results on bottom', 'Two Columns - Bible on left, Dct/Cmt/Results on right', 'Two Rows - Bible on top, Dct/Cmt/Results on bottom']
            self.saveAllMW = 1

            self.copySettings = [0,0,0,0,0,0,0]
            self.bibMultiList = []
            self.paraTextList = []

            self.parWinPos = (40, 40)
            self.parWinSize = (800, 600)

            self.imgWinPos = (80, 80)
            self.imgWinSize = (800, 600)

            self.maximized = None

            self.audioPlayAll = 0
            self.lastAudio = 'None'
            self.audioPath = self.allUsersDir + '/modules/audio/'

            self.readBibOpt = 0
            self.readChapCon = 0
            self.showHighlight = 1

            self.mcpShown = False
            self.mcpTab = None
            self.lastBookTitle = None
            self.resTab = 0

            self.showFootnote = 0
            self.mainAppMax = 0
            self.useOldFont = 1
            
            self.showStrongs = 1
            
            self.showDctDef = 1
            self.showCmtDef = 1
            
            self.sessTab = 0
            self.sessTabTitles = ["All Modules", "Group 1", "Group 2", "Group 3", "Group 4", "Group 5", "Group 6"]
            
            self.refNB.SetSelection(0)
            
            self.showRefHits = [True, True, True]
            self.refNB.refPanel.dctRef.SetValue(self.showRefHits[0])
            self.refNB.refPanel.cmtRef.SetValue(self.showRefHits[1])
            self.refNB.refPanel.bkRef.SetValue(self.showRefHits[2])
            
            return



    def AddRTCHandlers(self):
        if rt.RichTextBuffer.FindHandlerByType(rt.RICHTEXT_TYPE_HTML) is not None:
            return

        rt.RichTextBuffer.AddHandler(rt.RichTextHTMLHandler())
        rt.RichTextBuffer.AddHandler(rt.RichTextXMLHandler())

        wx.FileSystem.AddHandler(wx.MemoryFSHandler())


class SplashScreen(wx.SplashScreen):
    def __init__(self):
        img = splashImg.getSplashBitmap()
        #img = wx.Image(("splash.jpg")).ConvertToBitmap()
        wx.SplashScreen.__init__(self, img, wx.SPLASH_CENTRE_ON_SCREEN | wx.SPLASH_TIMEOUT, 3000, None, -1,\
        style = wx.SIMPLE_BORDER|wx.FRAME_NO_TASKBAR)
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        #self.fc = wx.FutureCall(100, self.ShowMain)

    def OnClose(self, evt):
        evt.Skip()
        self.Hide()
        self.Destroy()
        #if self.fc.IsRunning():
            #self.fc.Stop()
            #self.ShowMain()



class MyApp(wx.App):
    def OnInit(self, splash = True):
        wx.InitAllImageHandlers()
        
        if splash:
            MySplash = SplashScreen()

        BAnalyzer = BibleAnalyzer(None, "Bible Analyzer 4.0")
        BAnalyzer.Show()

        if BAnalyzer.firstRun == 0:
            BAnalyzer.OnWelcome(None)
            BAnalyzer.firstRun = 1

        print time.time() - start, 'Load time'
        return True
    
    def BringWindowToFront(self):
        try: # it's possible for this event to come when the frame is closed
            self.GetTopWindow().Raise()
        except:
            pass    
    
    def MacReopenApp(self):
        """Called when the doc icon is clicked, and ???"""
        self.BringWindowToFront()

    def MacNewFile(self):
        pass
    
    def MacPrintFile(self, file_path):
        pass


if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()


